/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/types","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/network","vs/base/common/cancellation","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/node/pfs","vs/platform/userDataProfile/common/userDataProfile","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/stream","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/request/common/request","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/iterator","vs/base/common/jsonFormatter","fs","child_process","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/ipc/electron-sandbox/services","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/storage/common/storageIpc","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],re=function(Q){for(var e=[],R=0,n=Q.length;R<n;R++)e[R]=ne[Q[R]];return e};define(ne[50],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function R(A){return A?A.replace(/\$\((.*?)\)/g,(I,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=R;class n{constructor(I,E,P){this.id=I,this.definition=E,this.description=P,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",n.circleFilled.definition),n.closeDirty=new n("close-dirty",n.circleFilled.definition),n.debugBreakpoint=new n("debug-breakpoint",n.circleFilled.definition),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",n.circleFilled.definition),n.debugHint=new n("debug-hint",n.circleFilled.definition),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circle=new n("circle",{fontCharacter:"\\eabc"}),n.circleOutline=new n("circle-outline",n.circle.definition),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",n.circle.definition),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.circleSmallFilled=new n("circle-small-filled",{fontCharacter:"\\eb8a"}),n.debugStackframeDot=new n("debug-stackframe-dot",n.circleSmallFilled.definition),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLarge=new n("circle-large",{fontCharacter:"\\ebb5"}),n.circleLargeOutline=new n("circle-large-outline",n.circleLarge.definition),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.layoutSidebarRightOff=new n("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),n.layoutPanelOff=new n("layout-panel-off",{fontCharacter:"\\ec01"}),n.layoutSidebarLeftOff=new n("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.heartFilled=new n("heart-filled",{fontCharacter:"\\ec04"}),n.map=new n("map",{fontCharacter:"\\ec05"}),n.mapFilled=new n("map-filled",{fontCharacter:"\\ec06"}),n.circleSmall=new n("circle-small",{fontCharacter:"\\ec07"}),n.bellSlash=new n("bell-slash",{fontCharacter:"\\ec08"}),n.bellSlashDot=new n("bell-slash-dot",{fontCharacter:"\\ec09"}),n.commentUnresolved=new n("comment-unresolved",{fontCharacter:"\\ec0a"}),n.gitPullRequestGoToChanges=new n("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),n.gitPullRequestNewChanges=new n("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),n.searchFuzzy=new n("search-fuzzy",{fontCharacter:"\\ec0d"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function k(A,I){const E=["codicon","codicon-"+A];return I&&E.push("codicon-modifier-"+I),E}e.getClassNamesArray=k;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(w){if(w instanceof n)return["codicon","codicon-"+w.id];const m=I.exec(w.id);if(!m)return E(n.error);const[,S,h]=m,y=["codicon","codicon-"+S];return h&&y.push("codicon-modifier-"+h.substr(1)),y}A.asClassNameArray=E;function P(w){return E(w).join(" ")}A.asClassName=P;function b(w){return"."+E(w).join(".")}A.asCSSSelector=b})(T=e.CSSIcon||(e.CSSIcon={}))}),define(ne[61],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function R(A){return(I,E,P)=>{let b=null,w=null;if(typeof P.value=="function"?(b="value",w=P.value):typeof P.get=="function"&&(b="get",w=P.get),!w)throw new Error("not supported");P[b]=A(w,E)}}e.createDecorator=R;function n(A,I,E){let P=null,b=null;if(typeof E.value=="function"?(P="value",b=E.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(P="get",b=E.get),!b)throw new Error("not supported");const w=`$memoize$${I}`;E[P]=function(...m){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,m)}),this[w]}}e.memoize=n;function k(A,I,E){return R((P,b)=>{const w=`$debounce$${b}`,m=`$debounce$result$${b}`;return function(...S){this[m]||(this[m]=E?E():void 0),clearTimeout(this[w]),I&&(this[m]=I(this[m],...S),S=[this[m]]),this[w]=setTimeout(()=>{P.apply(this,S),this[m]=E?E():void 0},A)}})}e.debounce=k;function T(A,I,E){return R((P,b)=>{const w=`$throttle$timer$${b}`,m=`$throttle$result$${b}`,S=`$throttle$lastRun$${b}`,h=`$throttle$pending$${b}`;return function(...y){if(this[m]||(this[m]=E?E():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...y)),this[h])return;const C=this[S]+A;C<=Date.now()?(this[S]=Date.now(),P.apply(this,[this[m]]),this[m]=E?E():void 0):(this[h]=!0,this[w]=setTimeout(()=>{this[h]=!1,this[S]=Date.now(),P.apply(this,[this[m]]),this[m]=E?E():void 0},C-Date.now()))}})}e.throttle=T}),define(ne[9],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?a.isErrorNoTelemetry(i)?new a(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(s=>{s(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=R,e.errorHandler=new R;function n(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=n;function k(c){E(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function T(c){E(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=T;function A(c){if(c instanceof Error){const{name:i,message:s}=c,t=c.stacktrace||c.stack;return{$isError:!0,name:i,message:s,stack:t,noTelemetry:a.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=A;const I="Canceled";function E(c){return c instanceof P?!0:c instanceof Error&&c.name===I&&c.message===I}e.isCancellationError=E;class P extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=P;function b(){const c=new Error(I);return c.name=c.message,c}e.canceled=b;function w(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=w;function m(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=m;function S(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function h(c){const i=new Error(`${c} has been disposed`);return i.name="DISPOSED",i}e.disposed=h;function y(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=y;class C extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=C;class p extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=p;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class a extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof a)return i;const s=new a;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=a;class f extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype);debugger}}e.BugIndicatingError=f}),define(ne[18],re([0,1,9]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function n(X,ie=0){return X[X.length-(1+ie)]}e.tail=n;function k(X){if(X.length===0)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]}e.tail2=k;function T(X,ie,se=(ue,he)=>ue===he){if(X===ie)return!0;if(!X||!ie||X.length!==ie.length)return!1;for(let ue=0,he=X.length;ue<he;ue++)if(!se(X[ue],ie[ue]))return!1;return!0}e.equals=T;function A(X,ie){const se=X.length-1;ie<se&&(X[ie]=X[se]),X.pop()}e.removeFastWithoutKeepingOrder=A;function I(X,ie,se){return E(X.length,ue=>se(X[ue],ie))}e.binarySearch=I;function E(X,ie){let se=0,ue=X-1;for(;se<=ue;){const he=(se+ue)/2|0,ve=ie(he);if(ve<0)se=he+1;else if(ve>0)ue=he-1;else return he}return-(se+1)}e.binarySearch2=E;function P(X,ie){let se=0,ue=X.length;if(ue===0)return 0;for(;se<ue;){const he=Math.floor((se+ue)/2);ie(X[he])?ue=he:se=he+1}return se}e.findFirstInSorted=P;function b(X,ie,se){if(X=X|0,X>=ie.length)throw new TypeError("invalid index");const ue=ie[Math.floor(ie.length*Math.random())],he=[],ve=[],we=[];for(const Ee of ie){const Pe=se(Ee,ue);Pe<0?he.push(Ee):Pe>0?ve.push(Ee):we.push(Ee)}return X<he.length?b(X,he,se):X<he.length+we.length?we[0]:b(X-(he.length+we.length),ve,se)}e.quickSelect=b;function w(X,ie){const se=[];let ue;for(const he of X.slice(0).sort(ie))!ue||ie(ue[0],he)!==0?(ue=[he],se.push(ue)):ue.push(he);return se}e.groupBy=w;function m(X,ie,se){const ue=[];function he(Ee,Pe,Ue){if(Pe===0&&Ue.length===0)return;const ze=ue[ue.length-1];ze&&ze.start+ze.deleteCount===Ee?(ze.deleteCount+=Pe,ze.toInsert.push(...Ue)):ue.push({start:Ee,deleteCount:Pe,toInsert:Ue})}let ve=0,we=0;for(;;){if(ve===X.length){he(ve,0,ie.slice(we));break}if(we===ie.length){he(ve,X.length-ve,[]);break}const Ee=X[ve],Pe=ie[we],Ue=se(Ee,Pe);Ue===0?(ve+=1,we+=1):Ue<0?(he(ve,1,[]),ve+=1):Ue>0&&(he(ve,0,[Pe]),we+=1)}return ue}e.sortedDiff=m;function S(X,ie,se){const ue=m(X,ie,se),he=[],ve=[];for(const we of ue)he.push(...X.slice(we.start,we.start+we.deleteCount)),ve.push(...we.toInsert);return{removed:he,added:ve}}e.delta=S;function h(X,ie,se){if(se===0)return[];const ue=X.slice(0,se).sort(ie);return C(X,ie,ue,se,X.length),ue}e.top=h;function y(X,ie,se,ue,he){return se===0?Promise.resolve([]):new Promise((ve,we)=>{(async()=>{const Ee=X.length,Pe=X.slice(0,se).sort(ie);for(let Ue=se,ze=Math.min(se+ue,Ee);Ue<Ee;Ue=ze,ze=Math.min(ze+ue,Ee)){if(Ue>se&&await new Promise(Ve=>setTimeout(Ve)),he&&he.isCancellationRequested)throw new R.CancellationError;C(X,ie,Pe,Ue,ze)}return Pe})().then(ve,we)})}e.topAsync=y;function C(X,ie,se,ue,he){for(const ve=se.length;ue<he;ue++){const we=X[ue];if(ie(we,se[ve-1])<0){se.pop();const Ee=P(se,Pe=>ie(we,Pe)<0);se.splice(Ee,0,we)}}}function p(X){return X.filter(ie=>!!ie)}e.coalesce=p;function g(X){let ie=0;for(let se=0;se<X.length;se++)X[se]&&(X[ie]=X[se],ie+=1);X.length=ie}e.coalesceInPlace=g;function a(X,ie,se){X.splice(se,0,X.splice(ie,1)[0])}e.move=a;function f(X){return!Array.isArray(X)||X.length===0}e.isFalsyOrEmpty=f;function c(X){return Array.isArray(X)&&X.length>0}e.isNonEmptyArray=c;function i(X,ie=se=>se){const se=new Set;return X.filter(ue=>{const he=ie(ue);return se.has(he)?!1:(se.add(he),!0)})}e.distinct=i;function s(X){const ie=new Set;return se=>{const ue=X(se);return ie.has(ue)?!1:(ie.add(ue),!0)}}e.uniqueFilter=s;function t(X,ie){const se=r(X,ie);if(se!==-1)return X[se]}e.findLast=t;function r(X,ie){for(let se=X.length-1;se>=0;se--){const ue=X[se];if(ie(ue))return se}return-1}e.lastIndex=r;function o(X,ie){return X.length>0?X[0]:ie}e.firstOrDefault=o;function l(X,ie){return X.length>0?X[X.length-1]:ie}e.lastOrDefault=l;function u(X,ie,se=(ue,he)=>ue===he){let ue=0;for(let he=0,ve=Math.min(X.length,ie.length);he<ve&&se(X[he],ie[he]);he++)ue++;return ue}e.commonPrefixLength=u;function d(X){return[].concat(...X)}e.flatten=d;function v(X,ie){let se=typeof ie=="number"?X:0;typeof ie=="number"?se=X:(se=0,ie=X);const ue=[];if(se<=ie)for(let he=se;he<ie;he++)ue.push(he);else for(let he=se;he>ie;he--)ue.push(he);return ue}e.range=v;function L(X,ie,se){return X.reduce((ue,he)=>(ue[ie(he)]=se?se(he):he,ue),Object.create(null))}e.index=L;function _(X,ie){return X.push(ie),()=>M(X,ie)}e.insert=_;function M(X,ie){const se=X.indexOf(ie);if(se>-1)return X.splice(se,1),ie}e.remove=M;function U(X,ie,se){const ue=X.slice(0,ie),he=X.slice(ie);return ue.concat(se,he)}e.arrayInsert=U;function D(X,ie){let se;if(typeof ie=="number"){let ue=ie;se=()=>{const he=Math.sin(ue++)*179426549;return he-Math.floor(he)}}else se=Math.random;for(let ue=X.length-1;ue>0;ue-=1){const he=Math.floor(se()*(ue+1)),ve=X[ue];X[ue]=X[he],X[he]=ve}}e.shuffle=D;function F(X,ie){const se=X.indexOf(ie);se>-1&&(X.splice(se,1),X.unshift(ie))}e.pushToStart=F;function $(X,ie){const se=X.indexOf(ie);se>-1&&(X.splice(se,1),X.push(ie))}e.pushToEnd=$;function j(X,ie){for(const se of ie)X.push(se)}e.pushMany=j;function J(X,ie){return Array.isArray(X)?X.map(ie):ie(X)}e.mapArrayOrNot=J;function H(X){return Array.isArray(X)?X:[X]}e.asArray=H;function K(X){return X[Math.floor(Math.random()*X.length)]}e.getRandomElement=K;function q(X,ie){for(const se of X){const ue=ie(se);if(ue!==void 0)return ue}}e.mapFind=q;function B(X,ie,se){const ue=te(X,ie),he=X.length,ve=se.length;X.length=he+ve;for(let we=he-1;we>=ue;we--)X[we+ve]=X[we];for(let we=0;we<ve;we++)X[we+ue]=se[we]}e.insertInto=B;function Y(X,ie,se,ue){const he=te(X,ie),ve=X.splice(he,se);return B(X,he,ue),ve}e.splice=Y;function te(X,ie){return ie<0?Math.max(ie+X.length,0):Math.min(ie,X.length)}var ce;(function(X){function ie(he){return he<0}X.isLessThan=ie;function se(he){return he>0}X.isGreaterThan=se;function ue(he){return he===0}X.isNeitherLessOrGreaterThan=ue,X.greaterThan=1,X.lessThan=-1,X.neitherLessOrGreaterThan=0})(ce=e.CompareResult||(e.CompareResult={}));function z(X,ie){return(se,ue)=>ie(X(se),X(ue))}e.compareBy=z;function V(...X){return(ie,se)=>{for(const ue of X){const he=ue(ie,se);if(!ce.isNeitherLessOrGreaterThan(he))return he}return ce.neitherLessOrGreaterThan}}e.tieBreakComparators=V;const O=(X,ie)=>X-ie;e.numberComparator=O;function N(X,ie){if(X.length===0)return;let se=X[0];for(let ue=1;ue<X.length;ue++){const he=X[ue];ie(he,se)>0&&(se=he)}return se}e.findMaxBy=N;function W(X,ie){if(X.length===0)return;let se=X[0];for(let ue=1;ue<X.length;ue++){const he=X[ue];ie(he,se)>=0&&(se=he)}return se}e.findLastMaxBy=W;function x(X,ie){return N(X,(se,ue)=>-ie(se,ue))}e.findMinBy=x;class Z{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let se=this.firstIdx;for(;se<this.items.length&&ie(this.items[se]);)se++;const ue=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,ue}takeFromEndWhile(ie){let se=this.lastIdx;for(;se>=0&&ie(this.items[se]);)se--;const ue=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,ue}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const se=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,se}}e.ArrayQueue=Z;class oe{constructor(ie){this.iterate=ie}forEach(ie){this.iterate(se=>(ie(se),!0))}toArray(){const ie=[];return this.iterate(se=>(ie.push(se),!0)),ie}filter(ie){return new oe(se=>this.iterate(ue=>ie(ue)?se(ue):!0))}map(ie){return new oe(se=>this.iterate(ue=>se(ie(ue))))}some(ie){let se=!1;return this.iterate(ue=>(se=ie(ue),!se)),se}findFirst(ie){let se;return this.iterate(ue=>ie(ue)?(se=ue,!1):!0),se}findLast(ie){let se;return this.iterate(ue=>(ie(ue)&&(se=ue),!0)),se}findLastMaxBy(ie){let se,ue=!0;return this.iterate(he=>((ue||ce.isGreaterThan(ie(he,se)))&&(ue=!1,se=he),!0)),se}}e.CallbackIterable=oe,oe.empty=new oe(X=>{})}),define(ne[113],re([0,1,9]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function n(E,P){if(!E)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=n;function k(E,P="Unreachable"){throw new Error(P)}e.assertNever=k;function T(E){if(!E)throw new R.BugIndicatingError("Assertion Failed")}e.assert=T;function A(E){if(!E()){debugger;E(),(0,R.onUnexpectedError)(new R.BugIndicatingError("Assertion Failed"))}}e.assertFn=A;function I(E,P){let b=0;for(;b<E.length-1;){const w=E[b],m=E[b+1];if(!P(w,m))return!1;b++}return!0}e.checkAdjacentItems=I}),define(ne[75],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(n){const k=this;let T=!1,A;return function(){return T||(T=!0,A=n.apply(k,arguments)),A}}e.once=R}),define(ne[51],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(n){function k(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}n.is=k;const T=Object.freeze([]);function A(){return T}n.empty=A;function*I(s){yield s}n.single=I;function E(s){return s||T}n.from=E;function P(s){return!s||s[Symbol.iterator]().next().done===!0}n.isEmpty=P;function b(s){return s[Symbol.iterator]().next().value}n.first=b;function w(s,t){for(const r of s)if(t(r))return!0;return!1}n.some=w;function m(s,t){for(const r of s)if(t(r))return r}n.find=m;function*S(s,t){for(const r of s)t(r)&&(yield r)}n.filter=S;function*h(s,t){let r=0;for(const o of s)yield t(o,r++)}n.map=h;function*y(...s){for(const t of s)for(const r of t)yield r}n.concat=y;function*C(s){for(const t of s)for(const r of t)yield r}n.concatNested=C;function p(s,t,r){let o=r;for(const l of s)o=t(o,l);return o}n.reduce=p;function g(s,t){let r=0;for(const o of s)t(o,r++)}n.forEach=g;function*a(s,t,r=s.length){for(t<0&&(t+=s.length),r<0?r+=s.length:r>s.length&&(r=s.length);t<r;t++)yield s[t]}n.slice=a;function f(s,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,s];const o=s[Symbol.iterator]();for(let l=0;l<t;l++){const u=o.next();if(u.done)return[r,n.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return o}}]}n.consume=f;function c(s){return f(s)[0]}n.collect=c;function i(s,t,r=(o,l)=>o===l){const o=s[Symbol.iterator](),l=t[Symbol.iterator]();for(;;){const u=o.next(),d=l.next();if(u.done!==d.done)return!1;if(u.done)return!0;if(!r(u.value,d.value))return!1}}n.equals=i})(R=e.Iterable||(e.Iterable={}))}),define(ne[35],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(R=e.ScanError||(e.ScanError={}));var n;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(i){i.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(i,s=!1){let t=0;const r=i.length;let o="",l=0,u=16,d=0;function v($){let j=0,J=0;for(;j<$;){const H=i.charCodeAt(t);if(H>=48&&H<=57)J=J*16+H-48;else if(H>=65&&H<=70)J=J*16+H-65+10;else if(H>=97&&H<=102)J=J*16+H-97+10;else break;t++,j++}return j<$&&(J=-1),J}function L($){t=$,o="",l=0,u=16,d=0}function _(){const $=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&P(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&P(i.charCodeAt(t)))for(t++;t<i.length&&P(i.charCodeAt(t));)t++;else return d=3,i.substring($,t);let j=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&P(i.charCodeAt(t))){for(t++;t<i.length&&P(i.charCodeAt(t));)t++;j=t}else d=3;return i.substring($,j)}function M(){let $="",j=t;for(;;){if(t>=r){$+=i.substring(j,t),d=2;break}const J=i.charCodeAt(t);if(J===34){$+=i.substring(j,t),t++;break}if(J===92){if($+=i.substring(j,t),t++,t>=r){d=2;break}switch(i.charCodeAt(t++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const K=v(4);K>=0?$+=String.fromCharCode(K):d=4;break}default:d=5}j=t;continue}if(J>=0&&J<=31)if(E(J)){$+=i.substring(j,t),d=2;break}else d=6;t++}return $}function U(){if(o="",d=0,l=t,t>=r)return l=r,u=17;let $=i.charCodeAt(t);if(I($)){do t++,o+=String.fromCharCode($),$=i.charCodeAt(t);while(I($));return u=15}if(E($))return t++,o+=String.fromCharCode($),$===13&&i.charCodeAt(t)===10&&(t++,o+=`
`),u=14;switch($){case 123:return t++,u=1;case 125:return t++,u=2;case 91:return t++,u=3;case 93:return t++,u=4;case 58:return t++,u=6;case 44:return t++,u=5;case 34:return t++,o=M(),u=10;case 47:{const j=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<r&&!E(i.charCodeAt(t));)t++;return o=i.substring(j,t),u=12}if(i.charCodeAt(t+1)===42){t+=2;const J=r-1;let H=!1;for(;t<J;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,H=!0;break}t++}return H||(t++,d=1),o=i.substring(j,t),u=13}return o+=String.fromCharCode($),t++,u=16}case 45:if(o+=String.fromCharCode($),t++,t===r||!P(i.charCodeAt(t)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),u=11;default:for(;t<r&&D($);)t++,$=i.charCodeAt(t);if(l!==t){switch(o=i.substring(l,t),o){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return o+=String.fromCharCode($),t++,u=16}}function D($){if(I($)||E($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let $;do $=U();while($>=12&&$<=15);return $}return{setPosition:L,getPosition:()=>t,scan:s?F:U,getToken:()=>u,getTokenValue:()=>o,getTokenOffset:()=>l,getTokenLength:()=>t-l,getTokenError:()=>d}}e.createScanner=A;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function E(i){return i===10||i===13||i===8232||i===8233}function P(i){return i>=48&&i<=57}var b;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(b||(b={}));function w(i,s){const t=[],r=new Object;let o;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function d(v,L,_,M){l.value=v,l.offset=L,l.length=_,l.type=M,l.colonOffset=void 0,o=l}try{a(i,{onObjectBegin:(v,L)=>{if(s<=v)throw r;o=void 0,u=s>v,t.push("")},onObjectProperty:(v,L,_)=>{if(s<L||(d(v,L,_,"property"),t[t.length-1]=v,s<=L+_))throw r},onObjectEnd:(v,L)=>{if(s<=v)throw r;o=void 0,t.pop()},onArrayBegin:(v,L)=>{if(s<=v)throw r;o=void 0,t.push(0)},onArrayEnd:(v,L)=>{if(s<=v)throw r;o=void 0,t.pop()},onLiteralValue:(v,L,_)=>{if(s<L||(d(v,L,_,c(v)),s<=L+_))throw r},onSeparator:(v,L,_)=>{if(s<=L)throw r;if(v===":"&&o&&o.type==="property")o.colonOffset=L,u=!1,o=void 0;else if(v===","){const M=t[t.length-1];typeof M=="number"?t[t.length-1]=M+1:(u=!0,t[t.length-1]=""),o=void 0}}})}catch(v){if(v!==r)throw v}return{path:t,previousNode:o,isAtPropertyKey:u,matches:v=>{let L=0;for(let _=0;L<v.length&&_<t.length;_++)if(v[L]===t[_]||v[L]==="*")L++;else if(v[L]!=="**")return!1;return L===v.length}}}e.getLocation=w;function m(i,s=[],t=T.DEFAULT){let r=null,o=[];const l=[];function u(v){Array.isArray(o)?o.push(v):r!==null&&(o[r]=v)}return a(i,{onObjectBegin:()=>{const v={};u(v),l.push(o),o=v,r=null},onObjectProperty:v=>{r=v},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const v=[];u(v),l.push(o),o=v,r=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:u,onError:(v,L,_)=>{s.push({error:v,offset:L,length:_})}},t),o[0]}e.parse=m;function S(i,s=[],t=T.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(v){r.type==="property"&&(r.length=v-r.offset,r=r.parent)}function l(v){return r.children.push(v),v}a(i,{onObjectBegin:v=>{r=l({type:"object",offset:v,length:-1,parent:r,children:[]})},onObjectProperty:(v,L,_)=>{r=l({type:"property",offset:L,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:v,offset:L,length:_,parent:r})},onObjectEnd:(v,L)=>{r.length=v+L-r.offset,r=r.parent,o(v+L)},onArrayBegin:(v,L)=>{r=l({type:"array",offset:v,length:-1,parent:r,children:[]})},onArrayEnd:(v,L)=>{r.length=v+L-r.offset,r=r.parent,o(v+L)},onLiteralValue:(v,L,_)=>{l({type:c(v),offset:L,length:_,parent:r,value:v}),o(L+_)},onSeparator:(v,L,_)=>{r.type==="property"&&(v===":"?r.colonOffset=L:v===","&&o(L))},onError:(v,L,_)=>{s.push({error:v,offset:L,length:_})}},t);const d=r.children[0];return d&&delete d.parent,d}e.parseTree=S;function h(i,s){if(!i)return;let t=i;for(const r of s)if(typeof r=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const l of t.children)if(Array.isArray(l.children)&&l.children[0].value===r){t=l.children[1],o=!0;break}if(!o)return}else{const o=r;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}e.findNodeAtLocation=h;function y(i){if(!i.parent||!i.parent.children)return[];const s=y(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;s.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&s.push(t)}return s}e.getNodePath=y;function C(i){switch(i.type){case"array":return i.children.map(C);case"object":{const s=Object.create(null);for(const t of i.children){const r=t.children[1];r&&(s[t.children[0].value]=C(r))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=C;function p(i,s,t=!1){return s>=i.offset&&s<i.offset+i.length||t&&s===i.offset+i.length}e.contains=p;function g(i,s,t=!1){if(p(i,s,t)){const r=i.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=s;o++){const l=g(r[o],s,t);if(l)return l}return i}}e.findNodeAtOffset=g;function a(i,s,t=T.DEFAULT){const r=A(i,!1);function o(z){return z?()=>z(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(z){return z?V=>z(V,r.getTokenOffset(),r.getTokenLength()):()=>!0}const u=o(s.onObjectBegin),d=l(s.onObjectProperty),v=o(s.onObjectEnd),L=o(s.onArrayBegin),_=o(s.onArrayEnd),M=l(s.onLiteralValue),U=l(s.onSeparator),D=o(s.onComment),F=l(s.onError),$=t&&t.disallowComments,j=t&&t.allowTrailingComma;function J(){for(;;){const z=r.scan();switch(r.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:$||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(z){case 12:case 13:$?H(10):D();break;case 16:H(1);break;case 15:case 14:break;default:return z}}}function H(z,V=[],O=[]){if(F(z),V.length+O.length>0){let N=r.getToken();for(;N!==17;){if(V.indexOf(N)!==-1){J();break}else if(O.indexOf(N)!==-1)break;N=J()}}}function K(z){const V=r.getTokenValue();return z?M(V):d(V),J(),!0}function q(){switch(r.getToken()){case 11:{let z=0;try{z=JSON.parse(r.getTokenValue()),typeof z!="number"&&(H(2),z=0)}catch{H(2)}M(z);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return J(),!0}function B(){return r.getToken()!==10?(H(3,[],[2,5]),!1):(K(!1),r.getToken()===6?(U(":"),J(),ce()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function Y(){u(),J();let z=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(z||H(4,[],[]),U(","),J(),r.getToken()===2&&j)break}else z&&H(6,[],[]);B()||H(4,[],[2,5]),z=!0}return v(),r.getToken()!==2?H(7,[2],[]):J(),!0}function te(){L(),J();let z=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(z||H(4,[],[]),U(","),J(),r.getToken()===4&&j)break}else z&&H(6,[],[]);ce()||H(4,[],[4,5]),z=!0}return _(),r.getToken()!==4?H(8,[4],[]):J(),!0}function ce(){switch(r.getToken()){case 3:return te();case 1:return Y();case 10:return K(!0);default:return q()}}return J(),r.getToken()===17?t.allowEmptyContent?!0:(H(4,[],[]),!1):ce()?(r.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=a;function f(i,s){const t=A(i),r=[];let o,l=0,u;do switch(u=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:l!==u&&r.push(i.substring(l,u)),s!==void 0&&r.push(t.getTokenValue().replace(/[^\r\n]/g,s)),l=t.getPosition();break}while(o!==17);return r.join("")}e.stripComments=f;function c(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(ne[52],re([0,1,35]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(P,b,w){let m,S,h,y,C;if(b){for(y=b.offset,C=y+b.length,h=y;h>0&&!E(P,h-1);)h--;let u=C;for(;u<P.length&&!E(P,u);)u++;S=P.substring(h,u),m=A(S,w)}else S=P,m=0,h=0,y=0,C=P.length;const p=I(w,P);let g=!1,a=0,f;w.insertSpaces?f=T(" ",w.tabSize||4):f="	";const c=(0,R.createScanner)(S,!1);let i=!1;function s(){return p+T(f,m+a)}function t(){let u=c.scan();for(g=!1;u===15||u===14;)g=g||u===14,u=c.scan();return i=u===16||c.getTokenError()!==0,u}const r=[];function o(u,d,v){!i&&d<C&&v>y&&P.substring(d,v)!==u&&r.push({offset:d,length:v-d,content:u})}let l=t();if(l!==17){const u=c.getTokenOffset()+h,d=T(f,m);o(d,h,u)}for(;l!==17;){let u=c.getTokenOffset()+c.getTokenLength()+h,d=t(),v="";for(;!g&&(d===12||d===13);){const _=c.getTokenOffset()+h;o(" ",u,_),u=c.getTokenOffset()+c.getTokenLength()+h,v=d===12?s():"",d=t()}if(d===2)l!==1&&(a--,v=s());else if(d===4)l!==3&&(a--,v=s());else{switch(l){case 3:case 1:a++,v=s();break;case 5:case 12:v=s();break;case 13:g?v=s():v=" ";break;case 6:v=" ";break;case 10:if(d===6){v="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?v=" ":d!==5&&d!==17&&(i=!0);break;case 16:i=!0;break}g&&(d===12||d===13)&&(v=s())}const L=c.getTokenOffset()+h;o(v,u,L),l=d}return r}e.format=n;function k(P,b){const w=JSON.stringify(P,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?w.replace(/\r\n|\r|\n/g,b.eol):w}e.toFormattedString=k;function T(P,b){let w="";for(let m=0;m<b;m++)w+=P;return w}function A(P,b){let w=0,m=0;const S=b.tabSize||4;for(;w<P.length;){const h=P.charAt(w);if(h===" ")m++;else if(h==="	")m+=S;else break;w++}return Math.floor(m/S)}function I(P,b){for(let w=0;w<b.length;w++){const m=b.charAt(w);if(m==="\r")return w+1<b.length&&b.charAt(w+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return P&&P.eol||`
`}e.getEOL=I;function E(P,b){return`\r
`.indexOf(P.charAt(b))!==-1}e.isEOL=E}),define(ne[76],re([0,1,35,52]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(P,b,w){return T(P,b,void 0,w)}e.removeProperty=k;function T(P,b,w,m,S){const h=b.slice(),y=[],C=(0,R.parseTree)(P,y);let p,g;for(;h.length>0&&(g=h.pop(),p=(0,R.findNodeAtLocation)(C,h),p===void 0&&w!==void 0);)typeof g=="string"?w={[g]:w}:w=[w];if(p)if(p.type==="object"&&typeof g=="string"&&Array.isArray(p.children)){const a=(0,R.findNodeAtLocation)(p,[g]);if(a!==void 0)if(w===void 0){if(!a.parent)throw new Error("Malformed AST");const f=p.children.indexOf(a.parent);let c,i=a.parent.offset+a.parent.length;if(f>0){const s=p.children[f-1];c=s.offset+s.length}else c=p.offset+1,p.children.length>1&&(i=p.children[1].offset);return A(P,{offset:c,length:i-c,content:""},m)}else return A(P,{offset:a.offset,length:a.length,content:JSON.stringify(w)},m);else{if(w===void 0)return[];const f=`${JSON.stringify(g)}: ${JSON.stringify(w)}`,c=S?S(p.children.map(s=>s.children[0].value)):p.children.length;let i;if(c>0){const s=p.children[c-1];i={offset:s.offset+s.length,length:0,content:","+f}}else p.children.length===0?i={offset:p.offset+1,length:0,content:f}:i={offset:p.offset+1,length:0,content:f+","};return A(P,i,m)}}else if(p.type==="array"&&typeof g=="number"&&Array.isArray(p.children))if(w!==void 0){const a=`${JSON.stringify(w)}`;let f;if(p.children.length===0||g===0)f={offset:p.offset+1,length:0,content:p.children.length===0?a:a+","};else{const c=g===-1||g>p.children.length?p.children.length:g,i=p.children[c-1];f={offset:i.offset+i.length,length:0,content:","+a}}return A(P,f,m)}else{const a=g,f=p.children[a];let c;if(p.children.length===1)c={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===a){const i=p.children[a-1],s=i.offset+i.length,t=p.offset+p.length;c={offset:s,length:t-2-s,content:""}}else c={offset:f.offset,length:p.children[a+1].offset-f.offset,content:""};return A(P,c,m)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${p.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return A(P,{offset:C?C.offset:0,length:C?C.length:0,content:JSON.stringify(w)},m)}}e.setProperty=T;function A(P,b,w){let m=I(P,b),S=b.offset,h=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;S>0&&!(0,n.isEOL)(m,S-1);)S--;for(;h<m.length&&!(0,n.isEOL)(m,h);)h++}const y=(0,n.format)(m,{offset:S,length:h-S},w);for(let p=y.length-1;p>=0;p--){const g=y[p];m=I(m,g),S=Math.min(S,g.offset),h=Math.max(h,g.offset+g.length),h+=g.content.length-g.length}const C=P.length-(m.length-h)-S;return[{offset:S,length:C,content:m.substring(S,h)}]}e.withFormatting=A;function I(P,b){return P.substring(0,b.offset)+b.content+P.substring(b.offset+b.length)}e.applyEdit=I;function E(P,b){const w=b.slice(0).sort((S,h)=>{const y=S.offset-h.offset;return y===0?S.length-h.length:y});let m=P.length;for(let S=w.length-1;S>=0;S--){const h=w[S];if(h.offset+h.length<=m)P=I(P,h);else throw new Error("Overlapping edit");m=h.offset}return P}e.applyEdits=E}),define(ne[114],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class R{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new R(()=>k(this.getValue()))}}e.Lazy=R}),define(ne[2],re([0,1,75,51]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let T=null;function A(o){T=o}if(e.setDisposableTracker=A,k){const o="__is_disposable_tracked__";A(new class{trackDisposable(l){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[o]||console.log(u)},3e3)}setParent(l,u){if(l&&l!==g.None)try{l[o]=!0}catch{}}markAsDisposed(l){if(l&&l!==g.None)try{l[o]=!0}catch{}}markAsSingleton(l){}})}function I(o){return T?.trackDisposable(o),o}function E(o){T?.markAsDisposed(o)}function P(o,l){T?.setParent(o,l)}function b(o,l){if(!!T)for(const u of o)T.setParent(u,l)}function w(o){return T?.markAsSingleton(o),o}e.markAsSingleton=w;function m(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=m;function S(o){if(n.Iterable.is(o)){const l=[];for(const u of o)if(u)try{u.dispose()}catch(d){l.push(d)}if(l.length===1)throw l[0];if(l.length>1)throw new AggregateError(l,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=S;function h(o){for(const l of o)m(l)&&l.dispose();return[]}e.disposeIfDisposable=h;function y(...o){const l=C(()=>S(o));return b(o,l),l}e.combinedDisposable=y;function C(o){const l=I({dispose:(0,R.once)(()=>{E(l),o()})});return l}e.toDisposable=C;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{S(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return P(l,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new p,I(this),P(this._store,this)}dispose(){E(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){this._isDisposed||l===this._value||(this._value?.dispose(),l&&P(l,this),this._value=l)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const l=this._value;return this._value=void 0,l&&P(l,null),l}}e.MutableDisposable=a;class f{constructor(l){this._disposable=l,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(l){let u=l;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,E(this))},this}}e.SafeDisposable=c;class i{constructor(){this.references=new Map}acquire(l,...u){let d=this.references.get(l);d||(d={counter:0,object:this.createReferencedObject(l,...u)},this.references.set(l,d));const{object:v}=d,L=(0,R.once)(()=>{--d.counter===0&&(this.destroyReferencedObject(l,d.object),this.references.delete(l))});return d.counter++,{object:v,dispose:L}}}e.ReferenceCollection=i;class s{constructor(l){this.referenceCollection=l}async acquire(l,...u){const d=this.referenceCollection.acquire(l,...u);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(v){throw d.dispose(),v}}}e.AsyncReferenceCollection=s;class t{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=t;function r(o){const l=new p;try{o(l)}finally{l.dispose()}}e.disposeOnReturn=r}),define(ne[115],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(T){this.element=T,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class n{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let T=this._first;for(;T!==R.Undefined;){const A=T.next;T.prev=R.Undefined,T.next=R.Undefined,T=A}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,A){const I=new R(T);if(this._first===R.Undefined)this._first=I,this._last=I;else if(A){const P=this._last;this._last=I,I.prev=P,P.next=I}else{const P=this._first;this._first=I,I.next=P,P.prev=I}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(I))}}shift(){if(this._first!==R.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==R.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==R.Undefined&&T.next!==R.Undefined){const A=T.prev;A.next=T.next,T.next.prev=A}else T.prev===R.Undefined&&T.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):T.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):T.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==R.Undefined;)yield T.element,T=T.next}}e.LinkedList=n}),function(){function Q(k){const T=[];typeof k=="number"&&T.push("code/timeOrigin",k);function A(E){T.push(E,Date.now())}function I(){const E=[];for(let P=0;P<T.length;P+=2)E.push({name:T[P],startTime:T[P+1]});return E}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(k+A.startTime)});return T}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function R(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=R(n))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var n in R)(typeof exports=="object"?exports:Q)[n]=R[n]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function R(n){if(e[n])return e[n].exports;var k=e[n]={i:n,l:!1,exports:{}};return Q[n].call(k.exports,k,k.exports,R),k.l=!0,k.exports}return R.m=Q,R.c=e,R.d=function(n,k,T){R.o(n,k)||Object.defineProperty(n,k,{enumerable:!0,get:T})},R.r=function(n){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},R.t=function(n,k){if(1&k&&(n=R(n)),8&k||4&k&&typeof n=="object"&&n&&n.__esModule)return n;var T=Object.create(null);if(R.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:n}),2&k&&typeof n!="string")for(var A in n)R.d(T,A,function(I){return n[I]}.bind(null,A));return T},R.n=function(n){var k=n&&n.__esModule?function(){return n.default}:function(){return n};return R.d(k,"a",k),k},R.o=function(n,k){return Object.prototype.hasOwnProperty.call(n,k)},R.p="",R(R.s=0)}([function(Q,e,R){(function(n){var k;e=Q.exports=O,k=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],E=e.src=[],P=0,b=P++;E[b]="0|[1-9]\\d*";var w=P++;E[w]="[0-9]+";var m=P++;E[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=P++;E[S]="("+E[b]+")\\.("+E[b]+")\\.("+E[b]+")";var h=P++;E[h]="("+E[w]+")\\.("+E[w]+")\\.("+E[w]+")";var y=P++;E[y]="(?:"+E[b]+"|"+E[m]+")";var C=P++;E[C]="(?:"+E[w]+"|"+E[m]+")";var p=P++;E[p]="(?:-("+E[y]+"(?:\\."+E[y]+")*))";var g=P++;E[g]="(?:-?("+E[C]+"(?:\\."+E[C]+")*))";var a=P++;E[a]="[0-9A-Za-z-]+";var f=P++;E[f]="(?:\\+("+E[a]+"(?:\\."+E[a]+")*))";var c=P++,i="v?"+E[S]+E[p]+"?"+E[f]+"?";E[c]="^"+i+"$";var s="[v=\\s]*"+E[h]+E[g]+"?"+E[f]+"?",t=P++;E[t]="^"+s+"$";var r=P++;E[r]="((?:<|>)?=?)";var o=P++;E[o]=E[w]+"|x|X|\\*";var l=P++;E[l]=E[b]+"|x|X|\\*";var u=P++;E[u]="[v=\\s]*("+E[l]+")(?:\\.("+E[l]+")(?:\\.("+E[l]+")(?:"+E[p]+")?"+E[f]+"?)?)?";var d=P++;E[d]="[v=\\s]*("+E[o]+")(?:\\.("+E[o]+")(?:\\.("+E[o]+")(?:"+E[g]+")?"+E[f]+"?)?)?";var v=P++;E[v]="^"+E[r]+"\\s*"+E[u]+"$";var L=P++;E[L]="^"+E[r]+"\\s*"+E[d]+"$";var _=P++;E[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=P++;E[M]="(?:~>?)";var U=P++;E[U]="(\\s*)"+E[M]+"\\s+",I[U]=new RegExp(E[U],"g");var D=P++;E[D]="^"+E[M]+E[u]+"$";var F=P++;E[F]="^"+E[M]+E[d]+"$";var $=P++;E[$]="(?:\\^)";var j=P++;E[j]="(\\s*)"+E[$]+"\\s+",I[j]=new RegExp(E[j],"g");var J=P++;E[J]="^"+E[$]+E[u]+"$";var H=P++;E[H]="^"+E[$]+E[d]+"$";var K=P++;E[K]="^"+E[r]+"\\s*("+s+")$|^$";var q=P++;E[q]="^"+E[r]+"\\s*("+i+")$|^$";var B=P++;E[B]="(\\s*)"+E[r]+"\\s*("+s+"|"+E[u]+")",I[B]=new RegExp(E[B],"g");var Y=P++;E[Y]="^\\s*("+E[u]+")\\s+-\\s+("+E[u]+")\\s*$";var te=P++;E[te]="^\\s*("+E[d]+")\\s+-\\s+("+E[d]+")\\s*$";var ce=P++;E[ce]="(<|>)?=?\\s*\\*";for(var z=0;z<35;z++)k(z,E[z]),I[z]||(I[z]=new RegExp(E[z]));function V(ae,de){if(ae instanceof O)return ae;if(typeof ae!="string"||ae.length>T||!(de?I[t]:I[c]).test(ae))return null;try{return new O(ae,de)}catch{return null}}function O(ae,de){if(ae instanceof O){if(ae.loose===de)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof O))return new O(ae,de);k("SemVer",ae,de),this.loose=de;var fe=ae.trim().match(de?I[t]:I[c]);if(!fe)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Ie=+Ce;if(Ie>=0&&Ie<A)return Ie}return Ce}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=V,e.valid=function(ae,de){var fe=V(ae,de);return fe?fe.version:null},e.clean=function(ae,de){var fe=V(ae.trim().replace(/^[=v]+/,""),de);return fe?fe.version:null},e.SemVer=O,O.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},O.prototype.toString=function(){return this.version},O.prototype.compare=function(ae){return k("SemVer.compare",this.version,this.loose,ae),ae instanceof O||(ae=new O(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},O.prototype.compareMain=function(ae){return ae instanceof O||(ae=new O(ae,this.loose)),W(this.major,ae.major)||W(this.minor,ae.minor)||W(this.patch,ae.patch)},O.prototype.comparePre=function(ae){if(ae instanceof O||(ae=new O(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var de=0;do{var fe=this.prerelease[de],Ce=ae.prerelease[de];if(k("prerelease compare",de,fe,Ce),fe===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(fe===void 0)return-1;if(fe!==Ce)return W(fe,Ce)}while(++de)},O.prototype.inc=function(ae,de){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,de,fe,Ce){typeof fe=="string"&&(Ce=fe,fe=void 0);try{return new O(ae,fe).inc(de,Ce).version}catch{return null}},e.diff=function(ae,de){if(X(ae,de))return null;var fe=V(ae),Ce=V(de);if(fe.prerelease.length||Ce.prerelease.length){for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==Ce[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==Ce[Ie])return Ie},e.compareIdentifiers=W;var N=/^[0-9]+$/;function W(ae,de){var fe=N.test(ae),Ce=N.test(de);return fe&&Ce&&(ae=+ae,de=+de),fe&&!Ce?-1:Ce&&!fe?1:ae<de?-1:ae>de?1:0}function x(ae,de,fe){return new O(ae,fe).compare(new O(de,fe))}function Z(ae,de,fe){return x(ae,de,fe)>0}function oe(ae,de,fe){return x(ae,de,fe)<0}function X(ae,de,fe){return x(ae,de,fe)===0}function ie(ae,de,fe){return x(ae,de,fe)!==0}function se(ae,de,fe){return x(ae,de,fe)>=0}function ue(ae,de,fe){return x(ae,de,fe)<=0}function he(ae,de,fe,Ce){var Ie;switch(de){case"===":typeof ae=="object"&&(ae=ae.version),typeof fe=="object"&&(fe=fe.version),Ie=ae===fe;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof fe=="object"&&(fe=fe.version),Ie=ae!==fe;break;case"":case"=":case"==":Ie=X(ae,fe,Ce);break;case"!=":Ie=ie(ae,fe,Ce);break;case">":Ie=Z(ae,fe,Ce);break;case">=":Ie=se(ae,fe,Ce);break;case"<":Ie=oe(ae,fe,Ce);break;case"<=":Ie=ue(ae,fe,Ce);break;default:throw new TypeError("Invalid operator: "+de)}return Ie}function ve(ae,de){if(ae instanceof ve){if(ae.loose===de)return ae;ae=ae.value}if(!(this instanceof ve))return new ve(ae,de);k("comparator",ae,de),this.loose=de,this.parse(ae),this.semver===we?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(ae,de){return W(de,ae)},e.major=function(ae,de){return new O(ae,de).major},e.minor=function(ae,de){return new O(ae,de).minor},e.patch=function(ae,de){return new O(ae,de).patch},e.compare=x,e.compareLoose=function(ae,de){return x(ae,de,!0)},e.rcompare=function(ae,de,fe){return x(de,ae,fe)},e.sort=function(ae,de){return ae.sort(function(fe,Ce){return e.compare(fe,Ce,de)})},e.rsort=function(ae,de){return ae.sort(function(fe,Ce){return e.rcompare(fe,Ce,de)})},e.gt=Z,e.lt=oe,e.eq=X,e.neq=ie,e.gte=se,e.lte=ue,e.cmp=he,e.Comparator=ve;var we={};function Ee(ae,de){if(ae instanceof Ee)return ae.loose===de?ae:new Ee(ae.raw,de);if(ae instanceof ve)return new Ee(ae.value,de);if(!(this instanceof Ee))return new Ee(ae,de);if(this.loose=de,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Pe(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function Ue(ae,de,fe,Ce,Ie,Me,De,$e,Ae,Fe,_e,ke,ee){return((de=Pe(fe)?"":Pe(Ce)?">="+fe+".0.0":Pe(Ie)?">="+fe+"."+Ce+".0":">="+de)+" "+($e=Pe(Ae)?"":Pe(Fe)?"<"+(+Ae+1)+".0.0":Pe(_e)?"<"+Ae+"."+(+Fe+1)+".0":ke?"<="+Ae+"."+Fe+"."+_e+"-"+ke:"<="+$e)).trim()}function ze(ae,de){for(var fe=0;fe<ae.length;fe++)if(!ae[fe].test(de))return!1;if(de.prerelease.length){for(fe=0;fe<ae.length;fe++)if(k(ae[fe].semver),ae[fe].semver!==we&&ae[fe].semver.prerelease.length>0){var Ce=ae[fe].semver;if(Ce.major===de.major&&Ce.minor===de.minor&&Ce.patch===de.patch)return!0}return!1}return!0}function Ve(ae,de,fe){try{de=new Ee(de,fe)}catch{return!1}return de.test(ae)}function We(ae,de,fe,Ce){var Ie,Me,De,$e,Ae;switch(ae=new O(ae,Ce),de=new Ee(de,Ce),fe){case">":Ie=Z,Me=ue,De=oe,$e=">",Ae=">=";break;case"<":Ie=oe,Me=se,De=Z,$e="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ve(ae,de,Ce))return!1;for(var Fe=0;Fe<de.set.length;++Fe){var _e=de.set[Fe],ke=null,ee=null;if(_e.forEach(function(le){le.semver===we&&(le=new ve(">=0.0.0")),ke=ke||le,ee=ee||le,Ie(le.semver,ke.semver,Ce)?ke=le:De(le.semver,ee.semver,Ce)&&(ee=le)}),ke.operator===$e||ke.operator===Ae||(!ee.operator||ee.operator===$e)&&Me(ae,ee.semver)||ee.operator===Ae&&De(ae,ee.semver))return!1}return!0}ve.prototype.parse=function(ae){var de=this.loose?I[K]:I[q],fe=ae.match(de);if(!fe)throw new TypeError("Invalid comparator: "+ae);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new O(fe[2],this.loose):this.semver=we},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(ae){return k("Comparator.test",ae,this.loose),this.semver===we||(typeof ae=="string"&&(ae=new O(ae,this.loose)),he(ae,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(ae,de){if(!(ae instanceof ve))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Ee(ae.value,de),Ve(this.value,fe,de);if(ae.operator==="")return fe=new Ee(this.value,de),Ve(ae.semver,fe,de);var Ce=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Me=this.semver.version===ae.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),$e=he(this.semver,"<",ae.semver,de)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Ae=he(this.semver,">",ae.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Ce||Ie||Me&&De||$e||Ae},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ae){var de=this.loose;ae=ae.trim(),k("range",ae,de);var fe=de?I[te]:I[Y];ae=ae.replace(fe,Ue),k("hyphen replace",ae),ae=ae.replace(I[B],"$1$2$3"),k("comparator trim",ae,I[B]),ae=(ae=(ae=ae.replace(I[U],"$1~")).replace(I[j],"$1^")).split(/\s+/).join(" ");var Ce=de?I[K]:I[q],Ie=ae.split(" ").map(function(Me){return function(De,$e){return k("comp",De),De=function(Ae,Fe){return Ae.trim().split(/\s+/).map(function(_e){return function(ke,ee){k("caret",ke,ee);var le=ee?I[H]:I[J];return ke.replace(le,function(me,ge,Se,be,Re){var Te;return k("caret",ke,me,ge,Se,be,Re),Pe(ge)?Te="":Pe(Se)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":Pe(be)?Te=ge==="0"?">="+ge+"."+Se+".0 <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+".0 <"+(+ge+1)+".0.0":Re?(k("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Te=ge==="0"?Se==="0"?">="+ge+"."+Se+"."+be+Re+" <"+ge+"."+Se+"."+(+be+1):">="+ge+"."+Se+"."+be+Re+" <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+"."+be+Re+" <"+(+ge+1)+".0.0"):(k("no pr"),Te=ge==="0"?Se==="0"?">="+ge+"."+Se+"."+be+" <"+ge+"."+Se+"."+(+be+1):">="+ge+"."+Se+"."+be+" <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+"."+be+" <"+(+ge+1)+".0.0"),k("caret return",Te),Te})}(_e,Fe)}).join(" ")}(De,$e),k("caret",De),De=function(Ae,Fe){return Ae.trim().split(/\s+/).map(function(_e){return function(ke,ee){var le=ee?I[F]:I[D];return ke.replace(le,function(me,ge,Se,be,Re){var Te;return k("tilde",ke,me,ge,Se,be,Re),Pe(ge)?Te="":Pe(Se)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":Pe(be)?Te=">="+ge+"."+Se+".0 <"+ge+"."+(+Se+1)+".0":Re?(k("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Te=">="+ge+"."+Se+"."+be+Re+" <"+ge+"."+(+Se+1)+".0"):Te=">="+ge+"."+Se+"."+be+" <"+ge+"."+(+Se+1)+".0",k("tilde return",Te),Te})}(_e,Fe)}).join(" ")}(De,$e),k("tildes",De),De=function(Ae,Fe){return k("replaceXRanges",Ae,Fe),Ae.split(/\s+/).map(function(_e){return function(ke,ee){ke=ke.trim();var le=ee?I[L]:I[v];return ke.replace(le,function(me,ge,Se,be,Re,Te){k("xRange",ke,me,ge,Se,be,Re,Te);var qe=Pe(Se),Le=qe||Pe(be),Ne=Le||Pe(Re);return ge==="="&&Ne&&(ge=""),qe?me=ge===">"||ge==="<"?"<0.0.0":"*":ge&&Ne?(Le&&(be=0),Ne&&(Re=0),ge===">"?(ge=">=",Le?(Se=+Se+1,be=0,Re=0):Ne&&(be=+be+1,Re=0)):ge==="<="&&(ge="<",Le?Se=+Se+1:be=+be+1),me=ge+Se+"."+be+"."+Re):Le?me=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ne&&(me=">="+Se+"."+be+".0 <"+Se+"."+(+be+1)+".0"),k("xRange return",me),me})}(_e,Fe)}).join(" ")}(De,$e),k("xrange",De),De=function(Ae,Fe){return k("replaceStars",Ae,Fe),Ae.trim().replace(I[ce],"")}(De,$e),k("stars",De),De}(Me,de)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Me){return!!Me.match(Ce)})),Ie=Ie.map(function(Me){return new ve(Me,de)})},Ee.prototype.intersects=function(ae,de){if(!(ae instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Ce){return ae.set.some(function(Ie){return Ie.every(function(Me){return Ce.intersects(Me,de)})})})})},e.toComparators=function(ae,de){return new Ee(ae,de).set.map(function(fe){return fe.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new O(ae,this.loose));for(var de=0;de<this.set.length;de++)if(ze(this.set[de],ae))return!0;return!1},e.satisfies=Ve,e.maxSatisfying=function(ae,de,fe){var Ce=null,Ie=null;try{var Me=new Ee(de,fe)}catch{return null}return ae.forEach(function(De){Me.test(De)&&(Ce&&Ie.compare(De)!==-1||(Ie=new O(Ce=De,fe)))}),Ce},e.minSatisfying=function(ae,de,fe){var Ce=null,Ie=null;try{var Me=new Ee(de,fe)}catch{return null}return ae.forEach(function(De){Me.test(De)&&(Ce&&Ie.compare(De)!==1||(Ie=new O(Ce=De,fe)))}),Ce},e.validRange=function(ae,de){try{return new Ee(ae,de).range||"*"}catch{return null}},e.ltr=function(ae,de,fe){return We(ae,de,"<",fe)},e.gtr=function(ae,de,fe){return We(ae,de,">",fe)},e.outside=We,e.prerelease=function(ae,de){var fe=V(ae,de);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(ae,de,fe){return ae=new Ee(ae,fe),de=new Ee(de,fe),ae.intersects(de)},e.coerce=function(ae){if(ae instanceof O)return ae;if(typeof ae!="string")return null;var de=ae.match(I[_]);return de==null?null:V((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,R(1))},function(Q,e){var R,n,k=Q.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function I(C){if(R===setTimeout)return setTimeout(C,0);if((R===T||!R)&&setTimeout)return R=setTimeout,setTimeout(C,0);try{return R(C,0)}catch{try{return R.call(null,C,0)}catch{return R.call(this,C,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:T}catch{R=T}try{n=typeof clearTimeout=="function"?clearTimeout:A}catch{n=A}})();var E,P=[],b=!1,w=-1;function m(){b&&E&&(b=!1,E.length?P=E.concat(P):w=-1,P.length&&S())}function S(){if(!b){var C=I(m);b=!0;for(var p=P.length;p;){for(E=P,P=[];++w<p;)E&&E[w].run();w=-1,p=P.length}E=null,b=!1,function(g){if(n===clearTimeout)return clearTimeout(g);if((n===A||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(g);try{n(g)}catch{try{return n.call(null,g)}catch{return n.call(this,g)}}}(C)}}function h(C,p){this.fun=C,this.array=p}function y(){}k.nextTick=function(C){var p=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)p[g-1]=arguments[g];P.push(new h(C,p)),P.length!==1||b||I(S)},h.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=y,k.addListener=y,k.once=y,k.off=y,k.removeListener=y,k.removeAllListeners=y,k.emit=y,k.prependListener=y,k.prependOnceListener=y,k.listeners=function(C){return[]},k.binding=function(C){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(C){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ne[116],re([0,1]),function(Q,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(I,E,P){this.level=I,this.key=E,this.value=P,this.forward=[]}}const k=void 0;class T{constructor(I,E=2**16){this.comparator=I,this[R]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(E)|0),this._header=new n(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,k,k)}has(I){return Boolean(T._search(this,I,this.comparator))}get(I){return T._search(this,I,this.comparator)?.value}set(I,E){return T._insert(this,I,E,this.comparator)&&(this._size+=1),this}delete(I){const E=T._delete(this,I,this.comparator);return E&&(this._size-=1),E}forEach(I,E){let P=this._header.forward[0];for(;P;)I.call(E,P.value,P.key,this),P=P.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",E=this._header.forward[0];for(;E;)I+=`node(${E.key}, ${E.value}, lvl:${E.level})`,E=E.forward[0];return I}static _search(I,E,P){let b=I._header;for(let w=I._level-1;w>=0;w--)for(;b.forward[w]&&P(b.forward[w].key,E)<0;)b=b.forward[w];if(b=b.forward[0],b&&P(b.key,E)===0)return b}static _insert(I,E,P,b){const w=[];let m=I._header;for(let S=I._level-1;S>=0;S--){for(;m.forward[S]&&b(m.forward[S].key,E)<0;)m=m.forward[S];w[S]=m}if(m=m.forward[0],m&&b(m.key,E)===0)return m.value=P,!1;{const S=T._randomLevel(I);if(S>I._level){for(let h=I._level;h<S;h++)w[h]=I._header;I._level=S}m=new n(S,E,P);for(let h=0;h<S;h++)m.forward[h]=w[h].forward[h],w[h].forward[h]=m;return!0}}static _randomLevel(I,E=.5){let P=1;for(;Math.random()<E&&P<I._maxLevel;)P+=1;return P}static _delete(I,E,P){const b=[];let w=I._header;for(let m=I._level-1;m>=0;m--){for(;w.forward[m]&&P(w.forward[m].key,E)<0;)w=w.forward[m];b[m]=w}if(w=w.forward[0],!w||P(w.key,E)!==0)return!1;for(let m=0;m<I._level&&b[m].forward[m]===w;m++)b[m].forward[m]=w.forward[m];for(;I._level>0&&I._header.forward[I._level-1]===k;)I._level-=1;return!0}}e.SkipList=T}),define(ne[41],re([0,1,9,2]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(f){const c=f;return c?typeof c.read=="function":!1}e.isReadable=k;function T(f){const c=f;return c?[c.on,c.pause,c.resume,c.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=T;function A(f){const c=f;return c?T(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=A;function I(f,c){return new E(f,c)}e.newWriteableStream=I;class E{constructor(c,i){this.reducer=c,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c<"u"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(i=>i(c))}emitError(c){this.listeners.error.length===0?(0,R.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(i=>i(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,i){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(c,i){if(this.state.destroyed)return;let s;switch(c){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const t=s.indexOf(i);t>=0&&s.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(f,c){const i=[];let s;for(;(s=f.read())!==null;)i.push(s);return c(i)}e.consumeReadable=P;function b(f,c,i){const s=[];let t;for(;(t=f.read())!==null&&s.length<i;)s.push(t);return t===null&&s.length>0?c(s):{read:()=>{if(s.length>0)return s.shift();if(typeof t<"u"){const r=t;return t=void 0,r}return f.read()}}}e.peekReadable=b;function w(f,c){return new Promise((i,s)=>{const t=[];m(f,{onData:r=>{c&&t.push(r)},onError:r=>{c?s(r):i(void 0)},onEnd:()=>{i(c?c(t):void 0)}})})}e.consumeStream=w;function m(f,c){let i=!1;return f.on("error",s=>{i||c.onError(s)}),f.on("end",()=>{i||c.onEnd()}),f.on("data",s=>{i||c.onData(s)}),(0,n.toDisposable)(()=>i=!0)}e.listenStream=m;function S(f,c){return new Promise((i,s)=>{const t=new n.DisposableStore,r=[],o=d=>{if(r.push(d),r.length>c)return t.dispose(),f.pause(),i({stream:f,buffer:r,ended:!1})},l=d=>s(d),u=()=>i({stream:f,buffer:r,ended:!0});t.add((0,n.toDisposable)(()=>f.removeListener("error",l))),f.on("error",l),t.add((0,n.toDisposable)(()=>f.removeListener("end",u))),f.on("end",u),t.add((0,n.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=S;function h(f,c){const i=I(c);return i.end(f),i}e.toStream=h;function y(){const f=I(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=y;function C(f){let c=!1;return{read:()=>c?null:(c=!0,f)}}e.toReadable=C;function p(f,c,i){const s=I(i);return m(f,{onData:t=>s.write(c.data(t)),onError:t=>s.error(c.error?c.error(t):t),onEnd:()=>s.end()}),s}e.transform=p;function g(f,c,i){let s=!1;return{read:()=>{const t=c.read();return s?t:(s=!0,t!==null?i([f,t]):f)}}}e.prefixedReadable=g;function a(f,c,i){let s=!1;const t=I(i);return m(c,{onData:r=>s?t.write(r):(s=!0,t.write(i([f,r]))),onError:r=>t.error(r),onEnd:()=>{s||(s=!0,t.write(f)),t.end()}}),t}e.prefixedStream=a}),define(ne[16],re([0,1,41]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer<"u";let k,T;class A{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return n?new A(Buffer.allocUnsafe(d)):new A(new Uint8Array(d))}static wrap(d){return n&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new A(d)}static fromString(d,v){return!(v?.dontUseNodeBuffer||!1)&&n?new A(Buffer.from(d)):(k||(k=new TextEncoder),new A(k.encode(d)))}static fromByteArray(d){const v=A.alloc(d.length);for(let L=0,_=d.length;L<_;L++)v.buffer[L]=d[L];return v}static concat(d,v){if(typeof v>"u"){v=0;for(let M=0,U=d.length;M<U;M++)v+=d[M].byteLength}const L=A.alloc(v);let _=0;for(let M=0,U=d.length;M<U;M++){const D=d[M];L.set(D,_),_+=D.byteLength}return L}clone(){const d=A.alloc(this.byteLength);return d.set(this),d}toString(){return n?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(d,v){return new A(this.buffer.subarray(d,v))}set(d,v){if(d instanceof A)this.buffer.set(d.buffer,v);else if(d instanceof Uint8Array)this.buffer.set(d,v);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),v);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return P(this.buffer,d)}writeUInt32BE(d,v){b(this.buffer,d,v)}readUInt32LE(d){return w(this.buffer,d)}writeUInt32LE(d,v){m(this.buffer,d,v)}readUInt8(d){return S(this.buffer,d)}writeUInt8(d,v){h(this.buffer,d,v)}}e.VSBuffer=A;function I(u,d){return u[d+0]<<0>>>0|u[d+1]<<8>>>0}e.readUInt16LE=I;function E(u,d,v){u[v+0]=d&255,d=d>>>8,u[v+1]=d&255}e.writeUInt16LE=E;function P(u,d){return u[d]*2**24+u[d+1]*2**16+u[d+2]*2**8+u[d+3]}e.readUInt32BE=P;function b(u,d,v){u[v+3]=d,d=d>>>8,u[v+2]=d,d=d>>>8,u[v+1]=d,d=d>>>8,u[v]=d}e.writeUInt32BE=b;function w(u,d){return u[d+0]<<0>>>0|u[d+1]<<8>>>0|u[d+2]<<16>>>0|u[d+3]<<24>>>0}e.readUInt32LE=w;function m(u,d,v){u[v+0]=d&255,d=d>>>8,u[v+1]=d&255,d=d>>>8,u[v+2]=d&255,d=d>>>8,u[v+3]=d&255}e.writeUInt32LE=m;function S(u,d){return u[d]}e.readUInt8=S;function h(u,d,v){u[v]=d}e.writeUInt8=h;function y(u){return R.consumeReadable(u,d=>A.concat(d))}e.readableToBuffer=y;function C(u){return R.toReadable(u)}e.bufferToReadable=C;function p(u){return R.consumeStream(u,d=>A.concat(d))}e.streamToBuffer=p;async function g(u){return u.ended?A.concat(u.buffer):A.concat([...u.buffer,await p(u.stream)])}e.bufferedStreamToBuffer=g;function a(u){return R.toStream(u,d=>A.concat(d))}e.bufferToStream=a;function f(u){return R.transform(u,{data:d=>typeof d=="string"?A.fromString(d):A.wrap(d)},d=>A.concat(d))}e.streamToBufferReadableStream=f;function c(u){return R.newWriteableStream(d=>A.concat(d),u)}e.newWriteableBufferStream=c;function i(u,d){return R.prefixedReadable(u,d,v=>A.concat(v))}e.prefixedBufferReadable=i;function s(u,d){return R.prefixedStream(u,d,v=>A.concat(v))}e.prefixedBufferStream=s;function t(u){let d=0,v=0,L=0;const _=new Uint8Array(Math.floor(u.length/4*3)),M=D=>{switch(v){case 3:_[L++]=d|D,v=0;break;case 2:_[L++]=d|D>>>2,d=D<<6,v=3;break;case 1:_[L++]=d|D>>>4,d=D<<4,v=2;break;default:d=D<<2,v=1}};for(let D=0;D<u.length;D++){const F=u.charCodeAt(D);if(F>=65&&F<=90)M(F-65);else if(F>=97&&F<=122)M(F-97+26);else if(F>=48&&F<=57)M(F-48+52);else if(F===43||F===45)M(62);else if(F===47||F===95)M(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${u[D]}`)}}const U=L;for(;v>0;)M(0);return A.wrap(_).slice(0,U)}e.decodeBase64=t;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:u},d=!0,v=!1){const L=v?o:r;let _="";const M=u.byteLength%3;let U=0;for(;U<u.byteLength-M;U+=3){const D=u[U+0],F=u[U+1],$=u[U+2];_+=L[D>>>2],_+=L[(D<<4|F>>>4)&63],_+=L[(F<<2|$>>>6)&63],_+=L[$&63]}if(M===1){const D=u[U+0];_+=L[D>>>2],_+=L[D<<4&63],d&&(_+="==")}else if(M===2){const D=u[U+0],F=u[U+1];_+=L[D>>>2],_+=L[(D<<4|F>>>4)&63],_+=L[F<<2&63],d&&(_+="=")}return _}e.encodeBase64=l}),define(ne[14],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function R(s){return typeof s=="string"}e.isString=R;function n(s){return Array.isArray(s)&&s.every(t=>R(t))}e.isStringArray=n;function k(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=k;function T(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}e.isTypedArray=T;function A(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=A;function I(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=I;function E(s){return s===!0||s===!1}e.isBoolean=E;function P(s){return typeof s>"u"}e.isUndefined=P;function b(s){return!w(s)}e.isDefined=b;function w(s){return P(s)||s===null}e.isUndefinedOrNull=w;function m(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=m;function S(s){if(w(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=S;function h(...s){const t=[];for(let r=0;r<s.length;r++){const o=s[r];if(w(o))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(o)}return t}e.assertAllDefined=h;const y=Object.prototype.hasOwnProperty;function C(s){if(!k(s))return!1;for(const t in s)if(y.call(s,t))return!1;return!0}e.isEmptyObject=C;function p(s){return typeof s=="function"}e.isFunction=p;function g(...s){return s.length>0&&s.every(p)}e.areFunctions=g;function a(s,t){const r=Math.min(s.length,t.length);for(let o=0;o<r;o++)f(s[o],t[o])}e.validateConstraints=a;function f(s,t){if(R(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(p(t)){try{if(s instanceof t)return}catch{}if(!w(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function c(s){return s===null?void 0:s}e.withNullAsUndefined=c;function i(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=i}),define(ne[31],re([0,1,14]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const g=Array.isArray(p)?[]:{};return Object.keys(p).forEach(a=>{p[a]&&typeof p[a]=="object"?g[a]=n(p[a]):g[a]=p[a]}),g}e.deepClone=n;function k(p){if(!p||typeof p!="object")return p;const g=[p];for(;g.length>0;){const a=g.shift();Object.freeze(a);for(const f in a)if(T.call(a,f)){const c=a[f];typeof c=="object"&&!Object.isFrozen(c)&&!(0,R.isTypedArray)(c)&&g.push(c)}}return p}e.deepFreeze=k;const T=Object.prototype.hasOwnProperty;function A(p,g){return I(p,g,new Set)}e.cloneAndChange=A;function I(p,g,a){if((0,R.isUndefinedOrNull)(p))return p;const f=g(p);if(typeof f<"u")return f;if(Array.isArray(p)){const c=[];for(const i of p)c.push(I(i,g,a));return c}if((0,R.isObject)(p)){if(a.has(p))throw new Error("Cannot clone recursive data-structure");a.add(p);const c={};for(const i in p)T.call(p,i)&&(c[i]=I(p[i],g,a));return a.delete(p),c}return p}function E(p,g,a=!0){return(0,R.isObject)(p)?((0,R.isObject)(g)&&Object.keys(g).forEach(f=>{f in p?a&&((0,R.isObject)(p[f])&&(0,R.isObject)(g[f])?E(p[f],g[f],a):p[f]=g[f]):p[f]=g[f]}),p):g}e.mixin=E;function P(p,g){if(p===g)return!0;if(p==null||g===null||g===void 0||typeof p!=typeof g||typeof p!="object"||Array.isArray(p)!==Array.isArray(g))return!1;let a,f;if(Array.isArray(p)){if(p.length!==g.length)return!1;for(a=0;a<p.length;a++)if(!P(p[a],g[a]))return!1}else{const c=[];for(f in p)c.push(f);c.sort();const i=[];for(f in g)i.push(f);if(i.sort(),!P(c,i))return!1;for(a=0;a<c.length;a++)if(!P(p[c[a]],g[c[a]]))return!1}return!0}e.equals=P;function b(p){const g=new Set;return JSON.stringify(p,(a,f)=>{if((0,R.isObject)(f)||Array.isArray(f)){if(g.has(f))return"[Circular]";g.add(f)}return f})}e.safeStringify=b;function w(p,g){const a=Object.create(null);return!p||!g||Object.keys(g).forEach(c=>{const i=p[c],s=g[c];P(i,s)||(a[c]=s)}),a}e.distinct=w;function m(p,g){const a=g.toLowerCase(),f=Object.keys(p).find(c=>c.toLowerCase()===a);return f?p[f]:p[g]}e.getCaseInsensitive=m;function S(p,g){const a=Object.create(null);for(const[f,c]of Object.entries(p))g(f,c)&&(a[f]=c);return a}e.filter=S;function h(p){let g=[],a=Object.getPrototypeOf(p);for(;Object.prototype!==a;)g=g.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return g}e.getAllPropertyNames=h;function y(p){const g=[];for(const a of h(p))typeof p[a]=="function"&&g.push(a);return g}e.getAllMethodNames=y;function C(p,g){const a=c=>function(){const i=Array.prototype.slice.call(arguments,0);return g(c,i)},f={};for(const c of p)f[c]=a(c);return f}e.createProxyObject=C}),define(ne[30],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(k){return R.test(k)}e.isUUID=n,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(I){for(let E=0;E<I.length;E++)I[E]=Math.floor(Math.random()*256);return I};const T=new Uint8Array(16),A=[];for(let I=0;I<256;I++)A.push(I.toString(16).padStart(2,"0"));return function(){k(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let E=0,P="";return P+=A[T[E++]],P+=A[T[E++]],P+=A[T[E++]],P+=A[T[E++]],P+="-",P+=A[T[E++]],P+=A[T[E++]],P+="-",P+=A[T[E++]],P+=A[T[E++]],P+="-",P+=A[T[E++]],P+=A[T[E++]],P+="-",P+=A[T[E++]],P+=A[T[E++]],P+=A[T[E++]],P+=A[T[E++]],P+=A[T[E++]],P+=A[T[E++]],P}}()}),define(ne[117],re([0,1,37]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(A){const I=A.replace(/\-/g,":").toLowerCase();return!n.has(I)}function T(){const A=(0,R.networkInterfaces)();for(const I in A){const E=A[I];if(E){for(const{mac:P}of E)if(k(P))return P}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(ne[118],re([0,1,77]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(I,E,P,b=1){let w=!1;return new Promise(m=>{const S=setTimeout(()=>{if(!w)return w=!0,m(0)},P);k(I,E,b,h=>{if(!w)return w=!0,clearTimeout(S),m(h)})})}e.findFreePort=n;function k(I,E,P,b){if(E===0)return b(0);const w=new R.Socket;w.once("connect",()=>(A(w),k(I+P,E-1,P,b))),w.once("data",()=>{}),w.once("error",m=>(A(w),m.code!=="ECONNREFUSED"?k(I+P,E-1,P,b):b(I))),w.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(I,E,P){let b=!1,w,m=1;const S=R.createServer({pauseOnConnect:!0});function h(y,C){b||(b=!0,S.removeAllListeners(),S.close(),w&&clearTimeout(w),C(y))}return new Promise(y=>{w=setTimeout(()=>{h(0,y)},P),S.on("listening",()=>{h(I,y)}),S.on("error",C=>{C&&(C.code==="EADDRINUSE"||C.code==="EACCES")&&m<E?(I++,m++,S.listen(I,"127.0.0.1")):h(0,y)}),S.on("close",()=>{h(0,y)}),S.listen(I,"127.0.0.1")})}e.findFreePortFaster=T;function A(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(E){console.error(E)}}}),define(ne[119],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const R="Offline";function n(T){return T instanceof k?!0:T instanceof Error&&T.name===R&&T.message===R}e.isOfflineError=n;class k extends Error{constructor(){super(R),this.name=this.message}}e.OfflineError=k}),define(ne[120],re([0,1,16,9,119]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function T(E,P){if(!navigator.onLine)throw new k.OfflineError;E.proxyAuthorization&&(E.headers={...E.headers||{},"Proxy-Authorization":E.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((w,m)=>{b.open(E.type||"GET",E.url||"",!0,E.user,E.password),A(b,E),b.responseType="arraybuffer",b.onerror=S=>m(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=S=>{w({res:{statusCode:b.status,headers:I(b)},stream:(0,R.bufferToStream)(R.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=S=>m(new Error(`XHR timeout: ${E.timeout}ms`)),E.timeout&&(b.timeout=E.timeout),b.send(E.data),P.onCancellationRequested(()=>{b.abort(),m((0,n.canceled)())})})}e.request=T;function A(E,P){if(P.headers){e:for(const b in P.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}E.setRequestHeader(b,P.headers[b])}}}function I(E){const P=Object.create(null);for(const b of E.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const w=b.indexOf(":");P[b.substr(0,w).trim().toLowerCase()]=b.substr(w+1).trim()}return P}}),define(ne[121],re([11,12]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ne[62],re([0,1,121]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,k=n*60,T=k*24,A=T*7,I=T*30,E=T*365;function P(w,m,S){typeof w!="number"&&(w=w.getTime());const h=Math.round((new Date().getTime()-w)/1e3);if(h<-30)return(0,R.localize)(0,null,P(new Date().getTime()+h*1e3,!1));if(h<30)return(0,R.localize)(1,null);let y;return h<n?(y=h,m?y===1?S?(0,R.localize)(2,null,y):(0,R.localize)(3,null,y):S?(0,R.localize)(4,null,y):(0,R.localize)(5,null,y):y===1?S?(0,R.localize)(6,null,y):(0,R.localize)(7,null,y):S?(0,R.localize)(8,null,y):(0,R.localize)(9,null,y)):h<k?(y=Math.floor(h/n),m?y===1?S?(0,R.localize)(10,null,y):(0,R.localize)(11,null,y):S?(0,R.localize)(12,null,y):(0,R.localize)(13,null,y):y===1?S?(0,R.localize)(14,null,y):(0,R.localize)(15,null,y):S?(0,R.localize)(16,null,y):(0,R.localize)(17,null,y)):h<T?(y=Math.floor(h/k),m?y===1?S?(0,R.localize)(18,null,y):(0,R.localize)(19,null,y):S?(0,R.localize)(20,null,y):(0,R.localize)(21,null,y):y===1?S?(0,R.localize)(22,null,y):(0,R.localize)(23,null,y):S?(0,R.localize)(24,null,y):(0,R.localize)(25,null,y)):h<A?(y=Math.floor(h/T),m?y===1?(0,R.localize)(26,null,y):(0,R.localize)(27,null,y):y===1?(0,R.localize)(28,null,y):(0,R.localize)(29,null,y)):h<I?(y=Math.floor(h/A),m?y===1?S?(0,R.localize)(30,null,y):(0,R.localize)(31,null,y):S?(0,R.localize)(32,null,y):(0,R.localize)(33,null,y):y===1?S?(0,R.localize)(34,null,y):(0,R.localize)(35,null,y):S?(0,R.localize)(36,null,y):(0,R.localize)(37,null,y)):h<E?(y=Math.floor(h/I),m?y===1?S?(0,R.localize)(38,null,y):(0,R.localize)(39,null,y):S?(0,R.localize)(40,null,y):(0,R.localize)(41,null,y):y===1?S?(0,R.localize)(42,null,y):(0,R.localize)(43,null,y):S?(0,R.localize)(44,null,y):(0,R.localize)(45,null,y)):(y=Math.floor(h/E),m?y===1?S?(0,R.localize)(46,null,y):(0,R.localize)(47,null,y):S?(0,R.localize)(48,null,y):(0,R.localize)(49,null,y):y===1?S?(0,R.localize)(50,null,y):(0,R.localize)(51,null,y):S?(0,R.localize)(52,null,y):(0,R.localize)(53,null,y))}e.fromNow=P;function b(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(ne[122],re([11,12]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ne[38],re([0,1,18,14,122]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(w,m){return m&&(w.stack||w.stacktrace)?k.localize(0,null,I(w),A(w.stack)||A(w.stacktrace)):I(w)}function A(w){return Array.isArray(w)?w.join(`
`):w}function I(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?k.localize(1,null,w.message):w.message||k.localize(2,null)}function E(w=null,m=!1){if(!w)return k.localize(3,null);if(Array.isArray(w)){const S=R.coalesce(w),h=E(S[0],m);return S.length>1?k.localize(4,null,h,S.length):h}if(n.isString(w))return w;if(w.detail){const S=w.detail;if(S.error)return T(S.error,m);if(S.exception)return T(S.exception,m)}return w.stack?T(w,m):w.message?w.message:k.localize(5,null)}e.toErrorMessage=E;function P(w){const m=w;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=P;function b(w,m){let S;return typeof w=="string"?S=new Error(w):S=w,S.actions=m,S}e.createErrorWithActions=b}),define(ne[123],re([11,12]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(ne[124],re([0,1,123]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function n(k){switch(k){case 1:return(0,R.localize)(0,null);case 2:return(0,R.localize)(1,null);case 3:return(0,R.localize)(2,null);case 4:return(0,R.localize)(3,null);case 5:return(0,R.localize)(4,null);case 6:return(0,R.localize)(5,null);case 7:return(0,R.localize)(6,null);case 8:return(0,R.localize)(7,null);case 9:return(0,R.localize)(8,null);default:return""}}e.getParseErrorMessage=n}),define(ne[125],re([11,12]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(ne[4],re([0,1,125]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const n="en";let k=!1,T=!1,A=!1,I=!1,E=!1,P=!1,b=!1,w=!1,m=!1,S,h=n,y,C;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?p=e.globals.vscode.process:typeof process<"u"&&(p=process);const g=typeof p?.versions?.electron=="string",a=g&&p?.type==="renderer";if(typeof navigator=="object"&&!a)C=navigator.userAgent,k=C.indexOf("Windows")>=0,T=C.indexOf("Macintosh")>=0,w=(C.indexOf("Macintosh")>=0||C.indexOf("iPad")>=0||C.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=C.indexOf("Linux")>=0,P=!0,S=R.getConfiguredDefaultLocale(R.localize(0,null))||n,h=S;else if(typeof p=="object"){k=p.platform==="win32",T=p.platform==="darwin",A=p.platform==="linux",I=A&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,b=g,m=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=n,h=n;const u=p.env.VSCODE_NLS_CONFIG;if(u)try{const d=JSON.parse(u),v=d.availableLanguages["*"];S=d.locale,h=v||n,y=d._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var f;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function c(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let i=0;T?i=1:k?i=3:A&&(i=2),e.isWindows=k,e.isMacintosh=T,e.isLinux=A,e.isLinuxSnap=I,e.isNative=E,e.isElectron=b,e.isWeb=P,e.isWebWorker=P&&typeof e.globals.importScripts=="function",e.isIOS=w,e.isCI=m,e.platform=i,e.userAgent=C,e.language=h;var s;(function(u){function d(){return e.language}u.value=d;function v(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=v;function L(){return e.language==="en"}u.isDefault=L})(s=e.Language||(e.Language={})),e.locale=S,e.translationsConfigFile=y,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const u=[];e.globals.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let L=0,_=u.length;L<_;L++){const M=u[L];if(M.id===v.data.vscodeScheduleAsyncWork){u.splice(L,1),M.callback();return}}});let d=0;return v=>{const L=++d;u.push({id:L,callback:v}),e.globals.postMessage({vscodeScheduleAsyncWork:L},"*")}}return u=>setTimeout(u)})();var t;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||w?2:k?1:3;let r=!0,o=!1;function l(){if(!o){o=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,r=new Uint16Array(u.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[36],re([0,1,4]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof R.globals.vscode<"u"&&typeof R.globals.vscode.process<"u"){const k=R.globals.vscode.process;n={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ne[10],re([0,1,36]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,k=97,T=90,A=122,I=46,E=47,P=92,b=58,w=63;class m extends Error{constructor(f,c,i){let s;typeof c=="string"&&c.indexOf("not ")===0?(s="must not be",c=c.replace(/^not /,"")):s="must be";const t=f.indexOf(".")!==-1?"property":"argument";let r=`The "${f}" ${t} ${s} of type ${c}`;r+=`. Received type ${typeof i}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function S(a,f){if(typeof a!="string")throw new m(f,"string",a)}function h(a){return a===E||a===P}function y(a){return a===E}function C(a){return a>=n&&a<=T||a>=k&&a<=A}function p(a,f,c,i){let s="",t=0,r=-1,o=0,l=0;for(let u=0;u<=a.length;++u){if(u<a.length)l=a.charCodeAt(u);else{if(i(l))break;l=E}if(i(l)){if(!(r===u-1||o===1))if(o===2){if(s.length<2||t!==2||s.charCodeAt(s.length-1)!==I||s.charCodeAt(s.length-2)!==I){if(s.length>2){const d=s.lastIndexOf(c);d===-1?(s="",t=0):(s=s.slice(0,d),t=s.length-1-s.lastIndexOf(c)),r=u,o=0;continue}else if(s.length!==0){s="",t=0,r=u,o=0;continue}}f&&(s+=s.length>0?`${c}..`:"..",t=2)}else s.length>0?s+=`${c}${a.slice(r+1,u)}`:s=a.slice(r+1,u),t=u-r-1;r=u,o=0}else l===I&&o!==-1?++o:o=-1}return s}function g(a,f){if(f===null||typeof f!="object")throw new m("pathObject","Object",f);const c=f.dir||f.root,i=f.base||`${f.name||""}${f.ext||""}`;return c?c===f.root?`${c}${i}`:`${c}${a}${i}`:i}e.win32={resolve(...a){let f="",c="",i=!1;for(let s=a.length-1;s>=-1;s--){let t;if(s>=0){if(t=a[s],S(t,"path"),t.length===0)continue}else f.length===0?t=R.cwd():(t=R.env[`=${f}`]||R.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==f.toLowerCase()&&t.charCodeAt(2)===P)&&(t=`${f}\\`));const r=t.length;let o=0,l="",u=!1;const d=t.charCodeAt(0);if(r===1)h(d)&&(o=1,u=!0);else if(h(d))if(u=!0,h(t.charCodeAt(1))){let v=2,L=v;for(;v<r&&!h(t.charCodeAt(v));)v++;if(v<r&&v!==L){const _=t.slice(L,v);for(L=v;v<r&&h(t.charCodeAt(v));)v++;if(v<r&&v!==L){for(L=v;v<r&&!h(t.charCodeAt(v));)v++;(v===r||v!==L)&&(l=`\\\\${_}\\${t.slice(L,v)}`,o=v)}}}else o=1;else C(d)&&t.charCodeAt(1)===b&&(l=t.slice(0,2),o=2,r>2&&h(t.charCodeAt(2))&&(u=!0,o=3));if(l.length>0)if(f.length>0){if(l.toLowerCase()!==f.toLowerCase())continue}else f=l;if(i){if(f.length>0)break}else if(c=`${t.slice(o)}\\${c}`,i=u,u&&f.length>0)break}return c=p(c,!i,"\\",h),i?`${f}\\${c}`:`${f}${c}`||"."},normalize(a){S(a,"path");const f=a.length;if(f===0)return".";let c=0,i,s=!1;const t=a.charCodeAt(0);if(f===1)return y(t)?"\\":a;if(h(t))if(s=!0,h(a.charCodeAt(1))){let o=2,l=o;for(;o<f&&!h(a.charCodeAt(o));)o++;if(o<f&&o!==l){const u=a.slice(l,o);for(l=o;o<f&&h(a.charCodeAt(o));)o++;if(o<f&&o!==l){for(l=o;o<f&&!h(a.charCodeAt(o));)o++;if(o===f)return`\\\\${u}\\${a.slice(l)}\\`;o!==l&&(i=`\\\\${u}\\${a.slice(l,o)}`,c=o)}}}else c=1;else C(t)&&a.charCodeAt(1)===b&&(i=a.slice(0,2),c=2,f>2&&h(a.charCodeAt(2))&&(s=!0,c=3));let r=c<f?p(a.slice(c),!s,"\\",h):"";return r.length===0&&!s&&(r="."),r.length>0&&h(a.charCodeAt(f-1))&&(r+="\\"),i===void 0?s?`\\${r}`:r:s?`${i}\\${r}`:`${i}${r}`},isAbsolute(a){S(a,"path");const f=a.length;if(f===0)return!1;const c=a.charCodeAt(0);return h(c)||f>2&&C(c)&&a.charCodeAt(1)===b&&h(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let f,c;for(let t=0;t<a.length;++t){const r=a[t];S(r,"path"),r.length>0&&(f===void 0?f=c=r:f+=`\\${r}`)}if(f===void 0)return".";let i=!0,s=0;if(typeof c=="string"&&h(c.charCodeAt(0))){++s;const t=c.length;t>1&&h(c.charCodeAt(1))&&(++s,t>2&&(h(c.charCodeAt(2))?++s:i=!1))}if(i){for(;s<f.length&&h(f.charCodeAt(s));)s++;s>=2&&(f=`\\${f.slice(s)}`)}return e.win32.normalize(f)},relative(a,f){if(S(a,"from"),S(f,"to"),a===f)return"";const c=e.win32.resolve(a),i=e.win32.resolve(f);if(c===i||(a=c.toLowerCase(),f=i.toLowerCase(),a===f))return"";let s=0;for(;s<a.length&&a.charCodeAt(s)===P;)s++;let t=a.length;for(;t-1>s&&a.charCodeAt(t-1)===P;)t--;const r=t-s;let o=0;for(;o<f.length&&f.charCodeAt(o)===P;)o++;let l=f.length;for(;l-1>o&&f.charCodeAt(l-1)===P;)l--;const u=l-o,d=r<u?r:u;let v=-1,L=0;for(;L<d;L++){const M=a.charCodeAt(s+L);if(M!==f.charCodeAt(o+L))break;M===P&&(v=L)}if(L!==d){if(v===-1)return i}else{if(u>d){if(f.charCodeAt(o+L)===P)return i.slice(o+L+1);if(L===2)return i.slice(o+L)}r>d&&(a.charCodeAt(s+L)===P?v=L:L===2&&(v=3)),v===-1&&(v=0)}let _="";for(L=s+v+1;L<=t;++L)(L===t||a.charCodeAt(L)===P)&&(_+=_.length===0?"..":"\\..");return o+=v,_.length>0?`${_}${i.slice(o,l)}`:(i.charCodeAt(o)===P&&++o,i.slice(o,l))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const f=e.win32.resolve(a);if(f.length<=2)return a;if(f.charCodeAt(0)===P){if(f.charCodeAt(1)===P){const c=f.charCodeAt(2);if(c!==w&&c!==I)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(C(f.charCodeAt(0))&&f.charCodeAt(1)===b&&f.charCodeAt(2)===P)return`\\\\?\\${f}`;return a},dirname(a){S(a,"path");const f=a.length;if(f===0)return".";let c=-1,i=0;const s=a.charCodeAt(0);if(f===1)return h(s)?a:".";if(h(s)){if(c=i=1,h(a.charCodeAt(1))){let o=2,l=o;for(;o<f&&!h(a.charCodeAt(o));)o++;if(o<f&&o!==l){for(l=o;o<f&&h(a.charCodeAt(o));)o++;if(o<f&&o!==l){for(l=o;o<f&&!h(a.charCodeAt(o));)o++;if(o===f)return a;o!==l&&(c=i=o+1)}}}}else C(s)&&a.charCodeAt(1)===b&&(c=f>2&&h(a.charCodeAt(2))?3:2,i=c);let t=-1,r=!0;for(let o=f-1;o>=i;--o)if(h(a.charCodeAt(o))){if(!r){t=o;break}}else r=!1;if(t===-1){if(c===-1)return".";t=c}return a.slice(0,t)},basename(a,f){f!==void 0&&S(f,"ext"),S(a,"path");let c=0,i=-1,s=!0,t;if(a.length>=2&&C(a.charCodeAt(0))&&a.charCodeAt(1)===b&&(c=2),f!==void 0&&f.length>0&&f.length<=a.length){if(f===a)return"";let r=f.length-1,o=-1;for(t=a.length-1;t>=c;--t){const l=a.charCodeAt(t);if(h(l)){if(!s){c=t+1;break}}else o===-1&&(s=!1,o=t+1),r>=0&&(l===f.charCodeAt(r)?--r===-1&&(i=t):(r=-1,i=o))}return c===i?i=o:i===-1&&(i=a.length),a.slice(c,i)}for(t=a.length-1;t>=c;--t)if(h(a.charCodeAt(t))){if(!s){c=t+1;break}}else i===-1&&(s=!1,i=t+1);return i===-1?"":a.slice(c,i)},extname(a){S(a,"path");let f=0,c=-1,i=0,s=-1,t=!0,r=0;a.length>=2&&a.charCodeAt(1)===b&&C(a.charCodeAt(0))&&(f=i=2);for(let o=a.length-1;o>=f;--o){const l=a.charCodeAt(o);if(h(l)){if(!t){i=o+1;break}continue}s===-1&&(t=!1,s=o+1),l===I?c===-1?c=o:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||s===-1||r===0||r===1&&c===s-1&&c===i+1?"":a.slice(c,s)},format:g.bind(null,"\\"),parse(a){S(a,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return f;const c=a.length;let i=0,s=a.charCodeAt(0);if(c===1)return h(s)?(f.root=f.dir=a,f):(f.base=f.name=a,f);if(h(s)){if(i=1,h(a.charCodeAt(1))){let v=2,L=v;for(;v<c&&!h(a.charCodeAt(v));)v++;if(v<c&&v!==L){for(L=v;v<c&&h(a.charCodeAt(v));)v++;if(v<c&&v!==L){for(L=v;v<c&&!h(a.charCodeAt(v));)v++;v===c?i=v:v!==L&&(i=v+1)}}}}else if(C(s)&&a.charCodeAt(1)===b){if(c<=2)return f.root=f.dir=a,f;if(i=2,h(a.charCodeAt(2))){if(c===3)return f.root=f.dir=a,f;i=3}}i>0&&(f.root=a.slice(0,i));let t=-1,r=i,o=-1,l=!0,u=a.length-1,d=0;for(;u>=i;--u){if(s=a.charCodeAt(u),h(s)){if(!l){r=u+1;break}continue}o===-1&&(l=!1,o=u+1),s===I?t===-1?t=u:d!==1&&(d=1):t!==-1&&(d=-1)}return o!==-1&&(t===-1||d===0||d===1&&t===o-1&&t===r+1?f.base=f.name=a.slice(r,o):(f.name=a.slice(r,t),f.base=a.slice(r,o),f.ext=a.slice(t,o))),r>0&&r!==i?f.dir=a.slice(0,r-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let f="",c=!1;for(let i=a.length-1;i>=-1&&!c;i--){const s=i>=0?a[i]:R.cwd();S(s,"path"),s.length!==0&&(f=`${s}/${f}`,c=s.charCodeAt(0)===E)}return f=p(f,!c,"/",y),c?`/${f}`:f.length>0?f:"."},normalize(a){if(S(a,"path"),a.length===0)return".";const f=a.charCodeAt(0)===E,c=a.charCodeAt(a.length-1)===E;return a=p(a,!f,"/",y),a.length===0?f?"/":c?"./":".":(c&&(a+="/"),f?`/${a}`:a)},isAbsolute(a){return S(a,"path"),a.length>0&&a.charCodeAt(0)===E},join(...a){if(a.length===0)return".";let f;for(let c=0;c<a.length;++c){const i=a[c];S(i,"path"),i.length>0&&(f===void 0?f=i:f+=`/${i}`)}return f===void 0?".":e.posix.normalize(f)},relative(a,f){if(S(a,"from"),S(f,"to"),a===f||(a=e.posix.resolve(a),f=e.posix.resolve(f),a===f))return"";const c=1,i=a.length,s=i-c,t=1,r=f.length-t,o=s<r?s:r;let l=-1,u=0;for(;u<o;u++){const v=a.charCodeAt(c+u);if(v!==f.charCodeAt(t+u))break;v===E&&(l=u)}if(u===o)if(r>o){if(f.charCodeAt(t+u)===E)return f.slice(t+u+1);if(u===0)return f.slice(t+u)}else s>o&&(a.charCodeAt(c+u)===E?l=u:u===0&&(l=0));let d="";for(u=c+l+1;u<=i;++u)(u===i||a.charCodeAt(u)===E)&&(d+=d.length===0?"..":"/..");return`${d}${f.slice(t+l)}`},toNamespacedPath(a){return a},dirname(a){if(S(a,"path"),a.length===0)return".";const f=a.charCodeAt(0)===E;let c=-1,i=!0;for(let s=a.length-1;s>=1;--s)if(a.charCodeAt(s)===E){if(!i){c=s;break}}else i=!1;return c===-1?f?"/":".":f&&c===1?"//":a.slice(0,c)},basename(a,f){f!==void 0&&S(f,"ext"),S(a,"path");let c=0,i=-1,s=!0,t;if(f!==void 0&&f.length>0&&f.length<=a.length){if(f===a)return"";let r=f.length-1,o=-1;for(t=a.length-1;t>=0;--t){const l=a.charCodeAt(t);if(l===E){if(!s){c=t+1;break}}else o===-1&&(s=!1,o=t+1),r>=0&&(l===f.charCodeAt(r)?--r===-1&&(i=t):(r=-1,i=o))}return c===i?i=o:i===-1&&(i=a.length),a.slice(c,i)}for(t=a.length-1;t>=0;--t)if(a.charCodeAt(t)===E){if(!s){c=t+1;break}}else i===-1&&(s=!1,i=t+1);return i===-1?"":a.slice(c,i)},extname(a){S(a,"path");let f=-1,c=0,i=-1,s=!0,t=0;for(let r=a.length-1;r>=0;--r){const o=a.charCodeAt(r);if(o===E){if(!s){c=r+1;break}continue}i===-1&&(s=!1,i=r+1),o===I?f===-1?f=r:t!==1&&(t=1):f!==-1&&(t=-1)}return f===-1||i===-1||t===0||t===1&&f===i-1&&f===c+1?"":a.slice(f,i)},format:g.bind(null,"/"),parse(a){S(a,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return f;const c=a.charCodeAt(0)===E;let i;c?(f.root="/",i=1):i=0;let s=-1,t=0,r=-1,o=!0,l=a.length-1,u=0;for(;l>=i;--l){const d=a.charCodeAt(l);if(d===E){if(!o){t=l+1;break}continue}r===-1&&(o=!1,r=l+1),d===I?s===-1?s=l:u!==1&&(u=1):s!==-1&&(u=-1)}if(r!==-1){const d=t===0&&c?1:t;s===-1||u===0||u===1&&s===r-1&&s===t+1?f.base=f.name=a.slice(d,r):(f.name=a.slice(d,s),f.base=a.slice(d,r),f.ext=a.slice(s,r))}return t>0?f.dir=a.slice(0,t-1):c&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=R.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=R.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=R.platform==="win32"?e.win32.join:e.posix.join,e.resolve=R.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=R.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=R.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=R.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=R.platform==="win32"?e.win32.extname:e.posix.extname,e.format=R.platform==="win32"?e.win32.format:e.posix.format,e.parse=R.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=R.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=R.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=R.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[126],re([0,1,10]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(b){const w=(0,R.extname)(b),m=n[w.toLowerCase()];return m!==void 0?m:A(b)}e.getMediaOrTextMime=T;function A(b){const w=(0,R.extname)(b);return k[w.toLowerCase()]}e.getMediaMime=A;function I(b){for(const w in k)if(k[w]===b)return w}e.getExtensionForMimeType=I;const E=/^(.+)\/(.+?)(;.+)?$/;function P(b,w){const m=E.exec(b);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:w?void 0:b}e.normalizeMimeType=P}),define(ne[78],re([0,1,4]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var n;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(n=e.Source||(e.Source={}));var k;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(I,...E){const P=E.reduce((m,S)=>(m[S]=!0,m),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(m=>!P[m]).forEach(m=>{for(let S=0;S<b.length;S++)if(m.search(b[S])!==-1){delete I[m];break}})}e.sanitizeProcessEnvironment=T;function A(I){!I||(delete I.DEBUG,R.isMacintosh&&delete I.DYLD_LIBRARY_PATH,R.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(ne[127],re([0,1,4]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=R.globals.performance&&typeof R.globals.performance.now=="function";class k{constructor(A){this._highResolution=n&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new k(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ne[3],re([0,1,9,75,2,115,127]),function(Q,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const I=!1,E=!1;var P;(function(l){l.None=()=>k.Disposable.None;function u(N){if(E){const{onListenerDidAdd:W}=N,x=h.create();let Z=0;N.onListenerDidAdd=()=>{++Z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),x.print()),W?.()}}}function d(N){return(W,x=null,Z)=>{let oe=!1,X;return X=N(ie=>{if(!oe)return X?X.dispose():oe=!0,W.call(x,ie)},null,Z),oe&&X.dispose(),X}}l.once=d;function v(N,W,x){return F((Z,oe=null,X)=>N(ie=>Z.call(oe,W(ie)),null,X),x)}l.map=v;function L(N,W,x){return F((Z,oe=null,X)=>N(ie=>{W(ie),Z.call(oe,ie)},null,X),x)}l.forEach=L;function _(N,W,x){return F((Z,oe=null,X)=>N(ie=>W(ie)&&Z.call(oe,ie),null,X),x)}l.filter=_;function M(N){return N}l.signal=M;function U(...N){return(W,x=null,Z)=>(0,k.combinedDisposable)(...N.map(oe=>oe(X=>W.call(x,X),null,Z)))}l.any=U;function D(N,W,x,Z){let oe=x;return v(N,X=>(oe=W(oe,X),oe),Z)}l.reduce=D;function F(N,W){let x;const Z={onFirstListenerAdd(){x=N(oe.fire,oe)},onLastListenerRemove(){x?.dispose()}};W||u(Z);const oe=new C(Z);return W?.add(oe),oe.event}function $(N,W,x=100,Z=!1,oe,X){let ie,se,ue,he=0;const ve={leakWarningThreshold:oe,onFirstListenerAdd(){ie=N(Ee=>{he++,se=W(se,Ee),Z&&!ue&&(we.fire(se),se=void 0),clearTimeout(ue),ue=setTimeout(()=>{const Pe=se;se=void 0,ue=void 0,(!Z||he>1)&&we.fire(Pe),he=0},x)})},onLastListenerRemove(){ie.dispose()}};X||u(ve);const we=new C(ve);return X?.add(we),we.event}l.debounce=$;function j(N,W=(Z,oe)=>Z===oe,x){let Z=!0,oe;return _(N,X=>{const ie=Z||!W(X,oe);return Z=!1,oe=X,ie},x)}l.latch=j;function J(N,W,x){return[l.filter(N,W,x),l.filter(N,Z=>!W(Z),x)]}l.split=J;function H(N,W=!1,x=[]){let Z=x.slice(),oe=N(se=>{Z?Z.push(se):ie.fire(se)});const X=()=>{Z?.forEach(se=>ie.fire(se)),Z=null},ie=new C({onFirstListenerAdd(){oe||(oe=N(se=>ie.fire(se)))},onFirstListenerDidAdd(){Z&&(W?setTimeout(X):X())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return ie.event}l.buffer=H;class K{constructor(W){this.event=W,this.disposables=new k.DisposableStore}map(W){return new K(v(this.event,W,this.disposables))}forEach(W){return new K(L(this.event,W,this.disposables))}filter(W){return new K(_(this.event,W,this.disposables))}reduce(W,x){return new K(D(this.event,W,x,this.disposables))}latch(){return new K(j(this.event,void 0,this.disposables))}debounce(W,x=100,Z=!1,oe){return new K($(this.event,W,x,Z,oe,this.disposables))}on(W,x,Z){return this.event(W,x,Z)}once(W,x,Z){return d(this.event)(W,x,Z)}dispose(){this.disposables.dispose()}}function q(N){return new K(N)}l.chain=q;function B(N,W,x=Z=>Z){const Z=(...se)=>ie.fire(x(...se)),oe=()=>N.on(W,Z),X=()=>N.removeListener(W,Z),ie=new C({onFirstListenerAdd:oe,onLastListenerRemove:X});return ie.event}l.fromNodeEventEmitter=B;function Y(N,W,x=Z=>Z){const Z=(...se)=>ie.fire(x(...se)),oe=()=>N.addEventListener(W,Z),X=()=>N.removeEventListener(W,Z),ie=new C({onFirstListenerAdd:oe,onLastListenerRemove:X});return ie.event}l.fromDOMEventEmitter=Y;function te(N){return new Promise(W=>d(N)(W))}l.toPromise=te;function ce(N,W){return W(void 0),N(x=>W(x))}l.runAndSubscribe=ce;function z(N,W){let x=null;function Z(X){x?.dispose(),x=new k.DisposableStore,W(X,x)}Z(void 0);const oe=N(X=>Z(X));return(0,k.toDisposable)(()=>{oe.dispose(),x?.dispose()})}l.runAndSubscribeWithStore=z;class V{constructor(W,x){this.obs=W,this._counter=0,this._hasChanged=!1;const Z={onFirstListenerAdd:()=>{W.addObserver(this)},onLastListenerRemove:()=>{W.removeObserver(this)}};x||u(Z),this.emitter=new C(Z),x&&x.add(this.emitter)}beginUpdate(W){this._counter++}handleChange(W,x){this._hasChanged=!0}endUpdate(W){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function O(N,W){return new V(N,W).emitter.event}l.fromObservable=O})(P=e.Event||(e.Event={}));class b{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${b._idPool++}`}start(u){this._stopWatch=new A.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}b._idPool=0;let w=-1;function m(l){const u=w;return w=l,{dispose(){w=u}}}e.setGlobalLeakWarningThreshold=m;class S{constructor(u,d=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u,d){let v=w;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),v<=0||d<v)return;this._stacks||(this._stacks=new Map);const L=this._stacks.get(u.value)||0;if(this._stacks.set(u.value,L+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let _,M=0;for(const[U,D]of this._stacks)(!_||M<D)&&(_=U,M=D);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${M}):`),console.warn(_)}return()=>{const _=this._stacks.get(u.value)||0;this._stacks.set(u.value,_-1)}}}class h{constructor(u){this.value=u}static create(){return new h(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class y{constructor(u,d,v){this.callback=u,this.callbackThis=d,this.stack=v,this.subscription=new k.SafeDisposable}invoke(u){this.callback.call(this.callbackThis,u)}}class C{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=w>0?new S(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new b(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(I){const u=Array.from(this._listeners);queueMicrotask(()=>{for(const d of u)d.subscription.isset()&&(d.subscription.unset(),d.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(u,d,v)=>{this._listeners||(this._listeners=new T.LinkedList);const L=this._listeners.isEmpty();L&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let _,M;this._leakageMon&&this._listeners.size>=30&&(M=h.create(),_=this._leakageMon.check(M,this._listeners.size+1)),I&&(M=M??h.create());const U=new y(u,d,M),D=this._listeners.push(U);L&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,d);const F=U.subscription.set(()=>{_?.(),this._disposed||(D(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return v instanceof k.DisposableStore?v.add(F):Array.isArray(v)&&v.push(F),F}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(const d of this._listeners)this._deliveryQueue.push(this,d,u);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=C;class p{constructor(){this._queue=new T.LinkedList}get size(){return this._queue.size}push(u,d,v){this._queue.push(new a(u,d,v))}clear(u){const d=new T.LinkedList;for(const v of this._queue)v.emitter!==u&&d.push(v);this._queue=d}deliver(){for(;this._queue.size>0;){const u=this._queue.shift();try{u.listener.invoke(u.event)}catch(d){(0,R.onUnexpectedError)(d)}}}}e.EventDeliveryQueue=p;class g extends p{clear(u){this._queue.clear()}}class a{constructor(u,d,v){this.emitter=u,this.listener=d,this.event=v}}class f extends C{async fireAsync(u,d,v){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const L of this._listeners)this._asyncDeliveryQueue.push([L,u]);for(;this._asyncDeliveryQueue.size>0&&!d.isCancellationRequested;){const[L,_]=this._asyncDeliveryQueue.shift(),M=[],U={..._,token:d,waitUntil:D=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");v&&(D=v(D,L.callback)),M.push(D)}};try{L.invoke(U)}catch(D){(0,R.onUnexpectedError)(D);continue}Object.freeze(M),await Promise.allSettled(M).then(D=>{for(const F of D)F.status==="rejected"&&(0,R.onUnexpectedError)(F.reason)})}}}}e.AsyncEmitter=f;class c extends C{constructor(u){super(u),this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=c;class i extends c{constructor(u){super(u),this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=i;class s extends C{constructor(u){super(u),this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){!this.hasListeners()||(this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(d=>super.fire(d)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=s;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new C({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const d={event:u,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const v=()=>{this.hasListeners&&this.unhook(d);const L=this.events.indexOf(d);this.events.splice(L,1)};return(0,k.toDisposable)((0,n.once)(v))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(d=>this.emitter.fire(d))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class r{constructor(){this.buffers=[]}wrapEvent(u){return(d,v,L)=>u(_=>{const M=this.buffers[this.buffers.length-1];M?M.push(()=>d.call(v,_)):d.call(v,_)},void 0,L)}bufferEvents(u){const d=[];this.buffers.push(d);const v=u();return this.buffers.pop(),d.forEach(L=>L()),v}}e.EventBufferer=r;class o{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=k.Disposable.None,this.emitter=new C({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(ne[21],re([0,1,3]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(I,E){const P=setTimeout(I.bind(E),0);return{dispose(){clearTimeout(P)}}});var k;(function(I){function E(P){return P===I.None||P===I.Cancelled||P instanceof T?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}I.isCancellationToken=E,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(k=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=k.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=A}),define(ne[128],re([0,1,21]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class n{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new R.CancellationTokenSource,E=this.task(I.token);return this.result={promise:E,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=n;class k{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const E=JSON.stringify(I);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=k;class T{constructor(I){this.fn=I,this._map=new Map}get cachedValues(){return this._map}get(I){if(this._map.has(I))return this._map.get(I);const E=this.fn(I);return this._map.set(I,E),E}}e.CachedFunction=T}),define(ne[79],re([0,1,3,2]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=A=>({onDidChange:R.Event.None,value:A});e.staticObservableValue=k;class T extends n.Disposable{constructor(I){super(),this._value=I,this.changeEmitter=this._register(new R.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(I){I!==this._value&&(this._value=I,this.changeEmitter.fire(I))}}e.MutableObservableValue=T}),define(ne[24],re([0,1,128,114]),function(Q,e,R,n){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(ee){return!ee||typeof ee!="string"?!0:ee.trim().length===0}e.isFalsyOrWhitespace=T;const A=/{(\d+)}/g;function I(ee,...le){return le.length===0?ee:ee.replace(A,function(me,ge){const Se=parseInt(ge,10);return isNaN(Se)||Se<0||Se>=le.length?me:le[Se]})}e.format=I;const E=/{([^}]+)}/g;function P(ee,le){return ee.replace(E,(me,ge)=>le[ge]??me)}e.format2=P;function b(ee){return ee.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=b;function w(ee){return ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function m(ee,le){let me=0;const ge=le.charCodeAt(0);for(let Se=ee.length-1;Se>=0;Se--)ee.charCodeAt(Se)===ge&&me++;return me}e.count=m;function S(ee,le,me="\u2026"){return ee.length<=le?ee:`${ee.substr(0,le)}${me}`}e.truncate=S;function h(ee,le=" "){const me=y(ee,le);return C(me,le)}e.trim=h;function y(ee,le){if(!ee||!le)return ee;const me=le.length;if(me===0||ee.length===0)return ee;let ge=0;for(;ee.indexOf(le,ge)===ge;)ge=ge+me;return ee.substring(ge)}e.ltrim=y;function C(ee,le){if(!ee||!le)return ee;const me=le.length,ge=ee.length;if(me===0||ge===0)return ee;let Se=ge,be=-1;for(;be=ee.lastIndexOf(le,Se-1),!(be===-1||be+me!==Se);){if(be===0)return"";Se=be}return ee.substring(0,Se)}e.rtrim=C;function p(ee){return ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function g(ee){return ee.replace(/\*/g,"")}e.stripWildcards=g;function a(ee,le,me={}){if(!ee)throw new Error("Cannot create regex from empty string");le||(ee=w(ee)),me.wholeWord&&(/\B/.test(ee.charAt(0))||(ee="\\b"+ee),/\B/.test(ee.charAt(ee.length-1))||(ee=ee+"\\b"));let ge="";return me.global&&(ge+="g"),me.matchCase||(ge+="i"),me.multiline&&(ge+="m"),me.unicode&&(ge+="u"),new RegExp(ee,ge)}e.createRegExp=a;function f(ee){return ee.source==="^"||ee.source==="^$"||ee.source==="$"||ee.source==="^\\s*$"?!1:!!(ee.exec("")&&ee.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function c(ee){return!!ee.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function i(ee){return(ee.global?"g":"")+(ee.ignoreCase?"i":"")+(ee.multiline?"m":"")+(ee.unicode?"u":"")}e.regExpFlags=i;function s(ee){return ee.split(/\r\n|\r|\n/)}e.splitLines=s;function t(ee){for(let le=0,me=ee.length;le<me;le++){const ge=ee.charCodeAt(le);if(ge!==32&&ge!==9)return le}return-1}e.firstNonWhitespaceIndex=t;function r(ee,le=0,me=ee.length){for(let ge=le;ge<me;ge++){const Se=ee.charCodeAt(ge);if(Se!==32&&Se!==9)return ee.substring(le,ge)}return ee.substring(le,me)}e.getLeadingWhitespace=r;function o(ee,le=ee.length-1){for(let me=le;me>=0;me--){const ge=ee.charCodeAt(me);if(ge!==32&&ge!==9)return me}return-1}e.lastNonWhitespaceIndex=o;function l(ee,le,me){const ge=[];let Se=0;for(const be of ee.matchAll(le)){if(ge.push(ee.slice(Se,be.index)),be.index===void 0)throw new Error("match.index should be defined");Se=be.index+be[0].length,ge.push(me(be[0],...be.slice(1),be.index,ee,be.groups))}return ge.push(ee.slice(Se)),Promise.all(ge).then(be=>be.join(""))}e.replaceAsync=l;function u(ee,le){return ee<le?-1:ee>le?1:0}e.compare=u;function d(ee,le,me=0,ge=ee.length,Se=0,be=le.length){for(;me<ge&&Se<be;me++,Se++){const qe=ee.charCodeAt(me),Le=le.charCodeAt(Se);if(qe<Le)return-1;if(qe>Le)return 1}const Re=ge-me,Te=be-Se;return Re<Te?-1:Re>Te?1:0}e.compareSubstring=d;function v(ee,le){return L(ee,le,0,ee.length,0,le.length)}e.compareIgnoreCase=v;function L(ee,le,me=0,ge=ee.length,Se=0,be=le.length){for(;me<ge&&Se<be;me++,Se++){let qe=ee.charCodeAt(me),Le=le.charCodeAt(Se);if(qe===Le)continue;if(qe>=128||Le>=128)return d(ee.toLowerCase(),le.toLowerCase(),me,ge,Se,be);M(qe)&&(qe-=32),M(Le)&&(Le-=32);const Ne=qe-Le;if(Ne!==0)return Ne}const Re=ge-me,Te=be-Se;return Re<Te?-1:Re>Te?1:0}e.compareSubstringIgnoreCase=L;function _(ee){return ee>=48&&ee<=57}e.isAsciiDigit=_;function M(ee){return ee>=97&&ee<=122}e.isLowerAsciiLetter=M;function U(ee){return ee>=65&&ee<=90}e.isUpperAsciiLetter=U;function D(ee,le){return ee.length===le.length&&L(ee,le)===0}e.equalsIgnoreCase=D;function F(ee,le){const me=le.length;return le.length>ee.length?!1:L(ee,le,0,me)===0}e.startsWithIgnoreCase=F;function $(ee,le){const me=Math.min(ee.length,le.length);let ge;for(ge=0;ge<me;ge++)if(ee.charCodeAt(ge)!==le.charCodeAt(ge))return ge;return me}e.commonPrefixLength=$;function j(ee,le){const me=Math.min(ee.length,le.length);let ge;const Se=ee.length-1,be=le.length-1;for(ge=0;ge<me;ge++)if(ee.charCodeAt(Se-ge)!==le.charCodeAt(be-ge))return ge;return me}e.commonSuffixLength=j;function J(ee){return 55296<=ee&&ee<=56319}e.isHighSurrogate=J;function H(ee){return 56320<=ee&&ee<=57343}e.isLowSurrogate=H;function K(ee,le){return(ee-55296<<10)+(le-56320)+65536}e.computeCodePoint=K;function q(ee,le,me){const ge=ee.charCodeAt(me);if(J(ge)&&me+1<le){const Se=ee.charCodeAt(me+1);if(H(Se))return K(ge,Se)}return ge}e.getNextCodePoint=q;function B(ee,le){const me=ee.charCodeAt(le-1);if(H(me)&&le>1){const ge=ee.charCodeAt(le-2);if(J(ge))return K(ge,me)}return me}class Y{constructor(le,me=0){this._str=le,this._len=le.length,this._offset=me}get offset(){return this._offset}setOffset(le){this._offset=le}prevCodePoint(){const le=B(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=q(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=Y;class te{constructor(le,me=0){this._iterator=new Y(le,me)}get offset(){return this._iterator.offset}nextGraphemeLength(){const le=Ie.getInstance(),me=this._iterator,ge=me.offset;let Se=le.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const be=me.offset,Re=le.getGraphemeBreakType(me.nextCodePoint());if(fe(Se,Re)){me.setOffset(be);break}Se=Re}return me.offset-ge}prevGraphemeLength(){const le=Ie.getInstance(),me=this._iterator,ge=me.offset;let Se=le.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const be=me.offset,Re=le.getGraphemeBreakType(me.prevCodePoint());if(fe(Re,Se)){me.setOffset(be);break}Se=Re}return ge-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=te;function ce(ee,le){return new te(ee,le).nextGraphemeLength()}e.nextCharLength=ce;function z(ee,le){return new te(ee,le).prevGraphemeLength()}e.prevCharLength=z;function V(ee,le){le>0&&H(ee.charCodeAt(le))&&le--;const me=le+ce(ee,le);return[me-z(ee,me),me]}e.getCharContainingOffset=V;let O;function N(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(ee){return O||(O=N()),O.test(ee)}e.containsRTL=W;const x=/^[\t\n\r\x20-\x7E]*$/;function Z(ee){return x.test(ee)}e.isBasicASCII=Z,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(ee){return e.UNUSUAL_LINE_TERMINATORS.test(ee)}e.containsUnusualLineTerminators=oe;function X(ee){return ee>=11904&&ee<=55215||ee>=63744&&ee<=64255||ee>=65281&&ee<=65374}e.isFullWidthCharacter=X;function ie(ee){return ee>=127462&&ee<=127487||ee===8986||ee===8987||ee===9200||ee===9203||ee>=9728&&ee<=10175||ee===11088||ee===11093||ee>=127744&&ee<=128591||ee>=128640&&ee<=128764||ee>=128992&&ee<=129008||ee>=129280&&ee<=129535||ee>=129648&&ee<=129782}e.isEmojiImprecise=ie;function se(ee,le){if(ee.length<le)return ee;const me=/\b/g;let ge=0;for(;me.test(ee)&&!(ee.length-me.lastIndex<le);)ge=me.lastIndex,me.lastIndex+=1;return ee.substring(ge).replace(/^\s/,"")}e.lcut=se;const ue=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,ve=/\x1b\[0?m/g;function we(ee){return ee&&(ee=ee.replace(ue,""),ee=ee.replace(he,""),ee=ee.replace(ve,"")),ee}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(ee){return!!(ee&&ee.length>0&&ee.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Pe(ee){return Ee(ee)?ee.substr(1):ee}e.stripUTF8BOM=Pe;function Ue(ee,le){if(!ee||!le||ee.length<le.length)return!1;const me=le.length,ge=ee.toLowerCase();let Se=0,be=-1;for(;Se<me;){const Re=ge.indexOf(le[Se],be+1);if(Re<0)return!1;be=Re,Se++}return!0}e.fuzzyContains=Ue;function ze(ee,le=!1){return ee?(le&&(ee=ee.replace(/\\./g,"")),ee.toLowerCase()!==ee):!1}e.containsUppercaseCharacter=ze;function Ve(ee){return ee.charAt(0).toUpperCase()+ee.slice(1)}e.uppercaseFirstLetter=Ve;function We(ee,le=1){if(le===0)return"";let me=-1;do me=ee.indexOf(`
`,me+1),le--;while(le>0&&me>=0);return me===-1?ee:(ee[me-1]==="\r"&&me--,ee.substr(0,me))}e.getNLines=We;function ae(ee){return ee=ee%(2*26),ee<26?String.fromCharCode(97+ee):String.fromCharCode(65+ee-26)}e.singleLetterHash=ae;function de(ee){return Ie.getInstance().getGraphemeBreakType(ee)}e.getGraphemeBreakType=de;function fe(ee,le){return ee===0?le!==5&&le!==7:ee===2&&le===3?!1:ee===4||ee===2||ee===3||le===4||le===2||le===3?!0:!(ee===8&&(le===8||le===9||le===11||le===12)||(ee===11||ee===9)&&(le===9||le===10)||(ee===12||ee===10)&&le===10||le===5||le===13||le===7||ee===1||ee===13&&le===14||ee===6&&le===6)}var Ce;(function(ee){ee[ee.Other=0]="Other",ee[ee.Prepend=1]="Prepend",ee[ee.CR=2]="CR",ee[ee.LF=3]="LF",ee[ee.Control=4]="Control",ee[ee.Extend=5]="Extend",ee[ee.Regional_Indicator=6]="Regional_Indicator",ee[ee.SpacingMark=7]="SpacingMark",ee[ee.L=8]="L",ee[ee.V=9]="V",ee[ee.T=10]="T",ee[ee.LV=11]="LV",ee[ee.LVT=12]="LVT",ee[ee.ZWJ=13]="ZWJ",ee[ee.Extended_Pictographic=14]="Extended_Pictographic"})(Ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{constructor(){this._data=Me()}static getInstance(){return Ie._INSTANCE||(Ie._INSTANCE=new Ie),Ie._INSTANCE}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const me=this._data,ge=me.length/3;let Se=1;for(;Se<=ge;)if(le<me[3*Se])Se=2*Se;else if(le>me[3*Se+1])Se=2*Se+1;else return me[3*Se+2];return 0}}Ie._INSTANCE=null;function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function De(ee,le){if(ee===0)return 0;const me=$e(ee,le);if(me!==void 0)return me;const ge=new Y(le,ee);return ge.prevCodePoint(),ge.offset}e.getLeftDeleteOffset=De;function $e(ee,le){const me=new Y(le,ee);let ge=me.prevCodePoint();for(;Ae(ge)||ge===65039||ge===8419;){if(me.offset===0)return;ge=me.prevCodePoint()}if(!ie(ge))return;let Se=me.offset;return Se>0&&me.prevCodePoint()===8205&&(Se=me.offset),Se}function Ae(ee){return 127995<=ee&&ee<=127999}var Fe;(function(ee){ee[ee.zwj=8205]="zwj",ee[ee.emojiVariantSelector=65039]="emojiVariantSelector",ee[ee.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.noBreakWhitespace="\xA0";class _e{constructor(le){this.confusableDictionary=le}static getInstance(le){return _e.cache.get(Array.from(le))}static getLocales(){return _e._locales.getValue()}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=_e,k=_e,_e.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),_e.cache=new R.LRUCachedFunction(ee=>{function le(Le){const Ne=new Map;for(let je=0;je<Le.length;je+=2)Ne.set(Le[je],Le[je+1]);return Ne}function me(Le,Ne){const je=new Map(Le);for(const[Xe,Ze]of Ne)je.set(Xe,Ze);return je}function ge(Le,Ne){if(!Le)return Ne;const je=new Map;for(const[Xe,Ze]of Le)Ne.has(Xe)&&je.set(Xe,Ze);return je}const Se=k.ambiguousCharacterData.getValue();let be=ee.filter(Le=>!Le.startsWith("_")&&Le in Se);be.length===0&&(be=["_default"]);let Re;for(const Le of be){const Ne=le(Se[Le]);Re=ge(Re,Ne)}const Te=le(Se._common),qe=me(Te,Re);return new _e(qe)}),_e._locales=new n.Lazy(()=>Object.keys(_e.ambiguousCharacterData.getValue()).filter(ee=>!ee.startsWith("_")));class ke{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ke.getRawData())),this._data}static isInvisibleCharacter(le){return ke.getData().has(le)}static get codePoints(){return ke.getData()}}e.InvisibleCharacters=ke,ke._data=void 0}),define(ne[46],re([0,1,10,4,24,14]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(o){return o===47||o===92}e.isPathSeparator=A;function I(o){return o.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=I;function E(o){return o.indexOf("/")===-1&&(o=I(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=E;function P(o,l=R.posix.sep){if(!o)return"";const u=o.length,d=o.charCodeAt(0);if(A(d)){if(A(o.charCodeAt(1))&&!A(o.charCodeAt(2))){let L=3;const _=L;for(;L<u&&!A(o.charCodeAt(L));L++);if(_!==L&&!A(o.charCodeAt(L+1))){for(L+=1;L<u;L++)if(A(o.charCodeAt(L)))return o.slice(0,L+1).replace(/[\\/]/g,l)}}return l}else if(p(d)&&o.charCodeAt(1)===58)return A(o.charCodeAt(2))?o.slice(0,2)+l:o.slice(0,2);let v=o.indexOf("://");if(v!==-1){for(v+=3;v<u;v++)if(A(o.charCodeAt(v)))return o.slice(0,v+1)}return""}e.getRoot=P;function b(o){if(!n.isWindows||!o||o.length<5)return!1;let l=o.charCodeAt(0);if(l!==92||(l=o.charCodeAt(1),l!==92))return!1;let u=2;const d=u;for(;u<o.length&&(l=o.charCodeAt(u),l!==92);u++);return!(d===u||(l=o.charCodeAt(u+1),isNaN(l)||l===92))}e.isUNC=b;const w=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(o,l=n.isWindows){const u=l?w:m;return!(!o||o.length===0||/^\s+$/.test(o)||(u.lastIndex=0,u.test(o))||l&&S.test(o)||o==="."||o===".."||l&&o[o.length-1]==="."||l&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=h;function y(o,l,u){const d=o===l;return!u||d?d:!o||!l?!1:(0,k.equalsIgnoreCase)(o,l)}e.isEqual=y;function C(o,l,u,d=R.sep){if(o===l)return!0;if(!o||!l||l.length>o.length)return!1;if(u){if(!(0,k.startsWithIgnoreCase)(o,l))return!1;if(l.length===o.length)return!0;let L=l.length;return l.charAt(l.length-1)===d&&L--,o.charAt(L)===d}return l.charAt(l.length-1)!==d&&(l+=d),o.indexOf(l)===0}e.isEqualOrParent=C;function p(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=p;function g(o,l){return n.isWindows&&o.endsWith(":")&&(o+=R.sep),(0,R.isAbsolute)(o)||(o=(0,R.join)(l,o)),o=(0,R.normalize)(o),n.isWindows?(o=(0,k.rtrim)(o,R.sep),o.endsWith(":")&&(o+=R.sep)):(o=(0,k.rtrim)(o,R.sep),o||(o=R.sep)),o}e.sanitizeFilePath=g;function a(o){const l=(0,R.normalize)(o);return n.isWindows?o.length>3?!1:f(l)&&(o.length===2||l.charCodeAt(2)===92):l===R.posix.sep}e.isRootOrDriveLetter=a;function f(o,l=n.isWindows){return l?p(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function c(o){return f(o)?o[0]:void 0}e.getDriveLetter=c;function i(o,l,u){return l.length>o.length?-1:o===l?0:(u&&(o=o.toLowerCase(),l=l.toLowerCase()),o.indexOf(l))}e.indexOfPath=i;function s(o){const l=o.split(":");let u,d,v;for(const L of l){const _=Number(L);(0,T.isNumber)(_)?d===void 0?d=_:v===void 0&&(v=_):u=u?[u,L].join(":"):L}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:d!==void 0?d:void 0,column:v!==void 0?v:d!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(o,l,u=8){let d="";for(let L=0;L<u;L++)d+=t.charAt(Math.floor(Math.random()*t.length));let v;return l?v=`${l}-${d}`:v=d,o?(0,R.join)(o,v):v}e.randomPath=r}),define(ne[63],re([0,1,24]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(p){return k(p,0)}e.hash=n;function k(p,g){switch(typeof p){case"object":return p===null?T(349,g):Array.isArray(p)?E(p,g):P(p,g);case"string":return I(p,g);case"boolean":return A(p,g);case"number":return T(p,g);case"undefined":return T(937,g);default:return T(617,g)}}e.doHash=k;function T(p,g){return(g<<5)-g+p|0}e.numberHash=T;function A(p,g){return T(p?433:863,g)}function I(p,g){g=T(149417,g);for(let a=0,f=p.length;a<f;a++)g=T(p.charCodeAt(a),g);return g}e.stringHash=I;function E(p,g){return g=T(104579,g),p.reduce((a,f)=>k(f,a),g)}function P(p,g){return g=T(181387,g),Object.keys(p).sort().reduce((a,f)=>(a=I(f,a),k(p[f],a)),g)}class b{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=k(g,this._value),this._value}}e.Hasher=b;var w;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function m(p,g,a=32){const f=a-g,c=~((1<<f)-1);return(p<<g|(c&p)>>>f)>>>0}function S(p,g=0,a=p.byteLength,f=0){for(let c=0;c<a;c++)p[g+c]=f}function h(p,g,a="0"){for(;p.length<g;)p=a+p;return p}function y(p,g=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(a=>a.toString(16).padStart(2,"0")).join(""):h((p>>>0).toString(16),g/4)}e.toHexString=y;class C{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const a=g.length;if(a===0)return;const f=this._buff;let c=this._buffLen,i=this._leftoverHighSurrogate,s,t;for(i!==0?(s=i,t=-1,i=0):(s=g.charCodeAt(0),t=0);;){let r=s;if(R.isHighSurrogate(s))if(t+1<a){const o=g.charCodeAt(t+1);R.isLowSurrogate(o)?(t++,r=R.computeCodePoint(s,o)):r=65533}else{i=s;break}else R.isLowSurrogate(s)&&(r=65533);if(c=this._push(f,c,r),t++,t<a)s=g.charCodeAt(t);else break}this._buffLen=c,this._leftoverHighSurrogate=i}_push(g,a,f){return f<128?g[a++]=f:f<2048?(g[a++]=192|(f&1984)>>>6,g[a++]=128|(f&63)>>>0):f<65536?(g[a++]=224|(f&61440)>>>12,g[a++]=128|(f&4032)>>>6,g[a++]=128|(f&63)>>>0):(g[a++]=240|(f&1835008)>>>18,g[a++]=128|(f&258048)>>>12,g[a++]=128|(f&4032)>>>6,g[a++]=128|(f&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=C._bigBlock32,a=this._buffDV;for(let u=0;u<64;u+=4)g.setUint32(u,a.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)g.setUint32(u,m(g.getUint32(u-12,!1)^g.getUint32(u-32,!1)^g.getUint32(u-56,!1)^g.getUint32(u-64,!1),1),!1);let f=this._h0,c=this._h1,i=this._h2,s=this._h3,t=this._h4,r,o,l;for(let u=0;u<80;u++)u<20?(r=c&i|~c&s,o=1518500249):u<40?(r=c^i^s,o=1859775393):u<60?(r=c&i|c&s|i&s,o=2400959708):(r=c^i^s,o=3395469782),l=m(f,5)+r+t+o+g.getUint32(u*4,!1)&4294967295,t=s,s=i,i=m(c,30),c=f,f=l;this._h0=this._h0+f&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=C,C._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ne[34],re([0,1,18,24]),function(Q,e,R,n){"use strict";var k,T,A;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(t,r,o){let l=t.get(r);return l===void 0&&(l=o,t.set(r,l)),l}e.getOrSet=I;function E(t){const r=[];return t.forEach((o,l)=>{r.push(`${l} => ${o}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=E;function P(t){const r=[];return t.forEach(o=>{r.push(o)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=P;class b{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const o=r.charCodeAt(0),l=this._value.charCodeAt(this._pos);return o-l}value(){return this._value[this._pos]}}e.StringIterator=b;class w{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,n.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=w;class m{constructor(r=!0,o=!0){this._splitOnBackslash=r,this._caseSensitive=o}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let o=r.length-1;o>=0;o--,this._valueLen--){const l=this._value.charCodeAt(o);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,n.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var S;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(S||(S={}));class h{constructor(r,o){this._ignorePathCasing=r,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,n.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(t){t[t.Left=-1]="Left",t[t.Mid=0]="Mid",t[t.Right=1]="Right"})(C||(C={}));class p{constructor(r){this._iter=r}static forUris(r=()=>!1,o=()=>!1){return new p(new h(r,o))}static forPaths(r=!1){return new p(new m(void 0,!r))}static forStrings(){return new p(new b)}static forConfigKeys(){return new p(new w)}clear(){this._root=void 0}fill(r,o){if(o){const l=o.slice(0);(0,R.shuffle)(l);for(const u of l)this.set(u,r)}else{const l=r.slice(0);(0,R.shuffle)(l);for(const u of l)this.set(u[0],u[1])}}set(r,o){const l=this._iter.reset(r);let u;this._root||(this._root=new y,this._root.segment=l.value());const d=[];for(u=this._root;;){const L=l.cmp(u.segment);if(L>0)u.left||(u.left=new y,u.left.segment=l.value()),d.push([-1,u]),u=u.left;else if(L<0)u.right||(u.right=new y,u.right.segment=l.value()),d.push([1,u]),u=u.right;else if(l.hasNext())l.next(),u.mid||(u.mid=new y,u.mid.segment=l.value()),d.push([0,u]),u=u.mid;else break}const v=u.value;u.value=o,u.key=r;for(let L=d.length-1;L>=0;L--){const _=d[L][1];_.updateHeight();const M=_.balanceFactor();if(M<-1||M>1){const U=d[L][0],D=d[L+1][0];if(U===1&&D===1)d[L][1]=_.rotateLeft();else if(U===-1&&D===-1)d[L][1]=_.rotateRight();else if(U===1&&D===-1)_.right=d[L+1][1]=d[L+1][1].rotateRight(),d[L][1]=_.rotateLeft();else if(U===-1&&D===1)_.left=d[L+1][1]=d[L+1][1].rotateLeft(),d[L][1]=_.rotateRight();else throw new Error;if(L>0)switch(d[L-1][0]){case-1:d[L-1][1].left=d[L][1];break;case 1:d[L-1][1].right=d[L][1];break;case 0:d[L-1][1].mid=d[L][1];break}else this._root=d[0][1]}}return v}get(r){return this._getNode(r)?.value}_getNode(r){const o=this._iter.reset(r);let l=this._root;for(;l;){const u=o.cmp(l.segment);if(u>0)l=l.left;else if(u<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else break}return l}has(r){const o=this._getNode(r);return!(o?.value===void 0&&o?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,o){const l=this._iter.reset(r),u=[];let d=this._root;for(;d;){const v=l.cmp(d.segment);if(v>0)u.push([-1,d]),d=d.left;else if(v<0)u.push([1,d]),d=d.right;else if(l.hasNext())l.next(),u.push([0,d]),d=d.mid;else break}if(!!d){if(o?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const v=this._min(d.right),{key:L,value:_,segment:M}=v;this._delete(v.key,!1),d.key=L,d.value=_,d.segment=M}else{const v=d.left??d.right;if(u.length>0){const[L,_]=u[u.length-1];switch(L){case-1:_.left=v;break;case 0:_.mid=v;break;case 1:_.right=v;break}}else this._root=v}for(let v=u.length-1;v>=0;v--){const L=u[v][1];L.updateHeight();const _=L.balanceFactor();if(_>1?(L.right.balanceFactor()>=0||(L.right=L.right.rotateRight()),u[v][1]=L.rotateLeft()):_<-1&&(L.left.balanceFactor()<=0||(L.left=L.left.rotateLeft()),u[v][1]=L.rotateRight()),v>0)switch(u[v-1][0]){case-1:u[v-1][1].left=u[v][1];break;case 1:u[v-1][1].right=u[v][1];break;case 0:u[v-1][1].mid=u[v][1];break}else this._root=u[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const o=this._iter.reset(r);let l=this._root,u;for(;l;){const d=o.cmp(l.segment);if(d>0)l=l.left;else if(d<0)l=l.right;else if(o.hasNext())o.next(),u=l.value||u,l=l.mid;else break}return l&&l.value||u}findSuperstr(r){const o=this._iter.reset(r);let l=this._root;for(;l;){const u=o.cmp(l.segment);if(u>0)l=l.left;else if(u<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(r){for(const[o,l]of this)r(l,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const o=[];return this._dfsEntries(r,o),o[Symbol.iterator]()}_dfsEntries(r,o){!r||(r.left&&this._dfsEntries(r.left,o),r.value&&o.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,o),r.right&&this._dfsEntries(r.right,o))}_isBalanced(){const r=o=>{if(!o)return!0;const l=o.balanceFactor();return l<-1||l>1?!1:r(o.left)&&r(o.right)};return r(this._root)}}e.TernarySearchTree=p;class g{constructor(r,o){this.uri=r,this.value=o}}class a{constructor(r,o){this[k]="ResourceMap",r instanceof a?(this.map=new Map(r.map),this.toKey=o??a.defaultToKey):(this.map=new Map,this.toKey=r??a.defaultToKey)}set(r,o){return this.map.set(this.toKey(r),new g(r,o)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,o){typeof o<"u"&&(r=r.bind(o));for(const[l,u]of this.map)r(u.value,u.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=a,a.defaultToKey=t=>t.toString();class f{constructor(r,o){this[T]="ResourceSet",!r||typeof r=="function"?this._map=new a(r):(this._map=new a(o),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,o){this._map.forEach((l,u)=>r.call(o,u,u,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=f;var c;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class i{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,o=0){const l=this._map.get(r);if(!!l)return o!==0&&this.touch(l,o),l.value}set(r,o,l=0){let u=this._map.get(r);if(u)u.value=o,l!==0&&this.touch(u,l);else{switch(u={key:r,value:o,next:void 0,previous:void 0},l){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const o=this._map.get(r);if(!!o)return this._map.delete(r),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,o){const l=this._state;let u=this._head;for(;u;){if(o?r.bind(o)(u.value,u.key,this):r(u.value,u.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,o=this._state;let l=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const d={value:l.key,done:!1};return l=l.next,d}else return{value:void 0,done:!0}}};return u}values(){const r=this,o=this._state;let l=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const d={value:l.value,done:!1};return l=l.next,d}else return{value:void 0,done:!0}}};return u}entries(){const r=this,o=this._state;let l=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const d={value:[l.key,l.value],done:!1};return l=l.next,d}else return{value:void 0,done:!0}}};return u}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let o=this._head,l=this.size;for(;o&&l>r;)this._map.delete(o.key),o=o.next,l--;this._head=o,this._size=l,o&&(o.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const o=r.next,l=r.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}r.next=void 0,r.previous=void 0,this._state++}touch(r,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(r===this._head)return;const l=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(l.previous=u,u.next=l),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(o===2){if(r===this._tail)return;const l=r.next,u=r.previous;r===this._head?(l.previous=void 0,this._head=l):(l.previous=u,u.next=l),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((o,l)=>{r.push([l,o])}),r}fromJSON(r){this.clear();for(const[o,l]of r)this.set(o,l)}}e.LinkedMap=i;class s extends i{constructor(r,o=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,o=2){return super.get(r,o)}peek(r){return super.get(r,0)}set(r,o){return super.set(r,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s}),define(ne[80],re([0,1,34]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new R.LRUCache(1e4);function k(P){return E(P,"NFC",n)}e.normalizeNFC=k;const T=new R.LRUCache(1e4);function A(P){return E(P,"NFD",T)}e.normalizeNFD=A;const I=/[^\u0000-\u0080]/;function E(P,b,w){if(!P)return P;const m=w.get(P);if(m)return m;let S;return I.test(P)?S=P.normalize(b):S=P,w.set(P,S),S}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(b){return A(b).replace(P,"")}}()}),define(ne[81],re([0,1,24]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(n||(n={})),function(k){const T="error",A="warning",I="warn",E="info",P="ignore";function b(m){return m?R.equalsIgnoreCase(T,m)?k.Error:R.equalsIgnoreCase(A,m)||R.equalsIgnoreCase(I,m)?k.Warning:R.equalsIgnoreCase(E,m)?k.Info:k.Ignore:k.Ignore}k.fromValue=b;function w(m){switch(m){case k.Error:return T;case k.Warning:return A;case k.Info:return E;default:return P}}k.toString=w}(n||(n={})),e.default=n}),define(ne[7],re([0,1,10,4]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,T=/^\//,A=/^\/\//;function I(t,r){if(!t.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!k.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!T.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(t,r){return!t&&!r?"file":t}function P(t,r){switch(t){case"https":case"http":case"file":r?r[0]!==w&&(r=w+r):r=w;break}return r}const b="",w="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{constructor(r,o,l,u,d,v=!1){typeof r=="object"?(this.scheme=r.scheme||b,this.authority=r.authority||b,this.path=r.path||b,this.query=r.query||b,this.fragment=r.fragment||b):(this.scheme=E(r,v),this.authority=o||b,this.path=P(this.scheme,l||b),this.query=u||b,this.fragment=d||b,I(this,v))}static isUri(r){return r instanceof S?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return a(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:l,path:u,query:d,fragment:v}=r;return o===void 0?o=this.scheme:o===null&&(o=b),l===void 0?l=this.authority:l===null&&(l=b),u===void 0?u=this.path:u===null&&(u=b),d===void 0?d=this.query:d===null&&(d=b),v===void 0?v=this.fragment:v===null&&(v=b),o===this.scheme&&l===this.authority&&u===this.path&&d===this.query&&v===this.fragment?this:new y(o,l,u,d,v)}static parse(r,o=!1){const l=m.exec(r);return l?new y(l[2]||b,s(l[4]||b),s(l[5]||b),s(l[7]||b),s(l[9]||b),o):new y(b,b,b,b,b)}static file(r){let o=b;if(n.isWindows&&(r=r.replace(/\\/g,w)),r[0]===w&&r[1]===w){const l=r.indexOf(w,2);l===-1?(o=r.substring(2),r=w):(o=r.substring(2,l),r=r.substring(l)||w)}return new y("file",o,r,b,b)}static from(r){const o=new y(r.scheme,r.authority,r.path,r.query,r.fragment);return I(o,!0),o}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return n.isWindows&&r.scheme==="file"?l=S.file(R.win32.join(a(r,!0),...o)).path:l=R.posix.join(r.path,...o),r.with({path:l})}toString(r=!1){return f(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof S)return r;{const o=new y(r);return o._formatted=r.external,o._fsPath=r._sep===h?r.fsPath:null,o}}else return r}}e.URI=S;const h=n.isWindows?1:void 0;class y extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(r=!1){return r?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=h),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(t,r){let o,l=-1;for(let u=0;u<t.length;u++){const d=t.charCodeAt(u);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||r&&d===47)l!==-1&&(o+=encodeURIComponent(t.substring(l,u)),l=-1),o!==void 0&&(o+=t.charAt(u));else{o===void 0&&(o=t.substr(0,u));const v=C[d];v!==void 0?(l!==-1&&(o+=encodeURIComponent(t.substring(l,u)),l=-1),o+=v):l===-1&&(l=u)}}return l!==-1&&(o+=encodeURIComponent(t.substring(l))),o!==void 0?o:t}function g(t){let r;for(let o=0;o<t.length;o++){const l=t.charCodeAt(o);l===35||l===63?(r===void 0&&(r=t.substr(0,o)),r+=C[l]):r!==void 0&&(r+=t[o])}return r!==void 0?r:t}function a(t,r){let o;return t.authority&&t.path.length>1&&t.scheme==="file"?o=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?r?o=t.path.substr(1):o=t.path[1].toLowerCase()+t.path.substr(2):o=t.path,n.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=a;function f(t,r){const o=r?g:p;let l="",{scheme:u,authority:d,path:v,query:L,fragment:_}=t;if(u&&(l+=u,l+=":"),(d||u==="file")&&(l+=w,l+=w),d){let M=d.indexOf("@");if(M!==-1){const U=d.substr(0,M);d=d.substr(M+1),M=U.indexOf(":"),M===-1?l+=o(U,!1):(l+=o(U.substr(0,M),!1),l+=":",l+=o(U.substr(M+1),!1)),l+="@"}d=d.toLowerCase(),M=d.indexOf(":"),M===-1?l+=o(d,!1):(l+=o(d.substr(0,M),!1),l+=d.substr(M))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const M=v.charCodeAt(1);M>=65&&M<=90&&(v=`/${String.fromCharCode(M+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const M=v.charCodeAt(0);M>=65&&M<=90&&(v=`${String.fromCharCode(M+32)}:${v.substr(2)}`)}l+=o(v,!0)}return L&&(l+="?",l+=o(L,!1)),_&&(l+="#",l+=r?_:p(_,!1)),l}function c(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+c(t.substr(3)):t}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(t){return t.match(i)?t.replace(i,r=>c(r)):t}}),define(ne[129],re([0,1,7]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(P){const b=P;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=n;function k(P){const b=[];let w;try{const m=JSON.parse(P.arguments),S=m[m.length-1];S&&S.__$stack&&(m.pop(),w=S.__$stack),b.push(...m)}catch{b.push("Unable to log remote console arguments",P.arguments)}return{args:b,stack:w}}e.parse=k;function T(P){if(typeof P!="string")return T(k(P).stack);const b=P;if(b){const w=A(b),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(m&&m.length===4)return{uri:R.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=T;function A(P){if(!P)return P;const b=P.indexOf(`
`);return b===-1?P:P.substring(0,b)}function I(P,b){const{args:w,stack:m}=k(P),S=typeof w[0]=="string"&&w.length===1;let h=A(m);h&&(h=`(${h.trim()})`);let y=[];if(typeof w[0]=="string"?h&&S?y=[`%c[${b}] %c${w[0]} %c${h}`,E("blue"),E(""),E("grey")]:y=[`%c[${b}] %c${w[0]}`,E("blue"),E(""),...w.slice(1)]:y=[`%c[${b}]%`,E("blue"),...w],h&&!S&&y.push(h),typeof console[P.severity]!="function")throw new Error("Unknown console method");console[P.severity].apply(console,y)}e.log=I;function E(P){return`color: ${P}`}}),define(ne[64],re([0,1,16,24,7]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(P){return JSON.stringify(P,I)}e.stringify=T;function A(P){let b=JSON.parse(P);return b=E(b),b}e.parse=A;function I(P,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,n.regExpFlags)(b)}:b}function E(P,b=0){if(!P||b>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return k.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof R.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let w=0;w<P.length;++w)P[w]=E(P[w],b+1);else for(const w in P)Object.hasOwnProperty.call(P,w)&&(P[w]=E(P[w],b+1))}return P}e.revive=E}),define(ne[20],re([0,1,4,7]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${k.vscodeRemoteResource}`}set(P,b,w){this._hosts[P]=b,this._ports[P]=w}setConnectionToken(P,b){this._connectionTokens[P]=b}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)return this._delegate(P);const b=P.authority;let w=this._hosts[b];w&&w.indexOf(":")!==-1&&(w=`[${w}]`);const m=this._ports[b],S=this._connectionTokens[b];let h=`path=${encodeURIComponent(P.path)}`;return typeof S=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(S)}`),n.URI.from({scheme:R.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${w}:${m}`,path:this._remoteResourcesPath,query:h})}}e.RemoteAuthorities=new T;class A{asBrowserUri(P,b){const w=this.toUri(P,b);return w.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(w):w.scheme===k.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${k.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?w.with({scheme:k.vscodeFileResource,authority:w.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):w}asFileUri(P,b){const w=this.toUri(P,b);return w.scheme===k.vscodeFileResource?w.with({scheme:k.file,authority:w.authority!==A.FALLBACK_AUTHORITY?w.authority:null,query:null,fragment:null}):w}toUri(P,b){return n.URI.isUri(P)?P:n.URI.parse(b.toUrl(P))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A;var I;(function(E){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(P.get("3"));const b="vscode-coi";function w(S){let h;typeof S=="string"?h=new URL(S).searchParams:S instanceof URL?h=S.searchParams:n.URI.isUri(S)&&(h=new URL(S.toString(!0)).searchParams);const y=h?.get(b);if(!!y)return P.get(y)}E.getHeadersFromQuery=w;function m(S,h,y){if(!globalThis.crossOriginIsolated)return;const C=h&&y?"3":y?"2":"1";S instanceof URLSearchParams?S.set(b,C):S[b]=C}E.addSearchParam=m})(I=e.COI||(e.COI={}))}),define(ne[17],re([0,1,46,20,10,4,24,7]),function(Q,e,R,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(S){return(0,I.uriToFsPath)(S,!0)}e.originalFSPath=E;class P{constructor(h){this._ignorePathCasing=h}compare(h,y,C=!1){return h===y?0:(0,A.compare)(this.getComparisonKey(h,C),this.getComparisonKey(y,C))}isEqual(h,y,C=!1){return h===y?!0:!h||!y?!1:this.getComparisonKey(h,C)===this.getComparisonKey(y,C)}getComparisonKey(h,y=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,y,C=!1){if(h.scheme===y.scheme){if(h.scheme===n.Schemas.file)return R.isEqualOrParent(E(h),E(y),this._ignorePathCasing(h))&&h.query===y.query&&(C||h.fragment===y.fragment);if((0,e.isEqualAuthority)(h.authority,y.authority))return R.isEqualOrParent(h.path,y.path,this._ignorePathCasing(h),"/")&&h.query===y.query&&(C||h.fragment===y.fragment)}return!1}joinPath(h,...y){return I.URI.joinPath(h,...y)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return k.posix.basename(h.path)}extname(h){return k.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let y;return h.scheme===n.Schemas.file?y=I.URI.file(k.dirname(E(h))).path:(y=k.posix.dirname(h.path),h.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),y="/")),h.with({path:y})}normalizePath(h){if(!h.path.length)return h;let y;return h.scheme===n.Schemas.file?y=I.URI.file(k.normalize(E(h))).path:y=k.posix.normalize(h.path),h.with({path:y})}relativePath(h,y){if(h.scheme!==y.scheme||!(0,e.isEqualAuthority)(h.authority,y.authority))return;if(h.scheme===n.Schemas.file){const g=k.relative(E(h),E(y));return T.isWindows?R.toSlashes(g):g}let C=h.path||"/";const p=y.path||"/";if(this._ignorePathCasing(h)){let g=0;for(const a=Math.min(C.length,p.length);g<a&&!(C.charCodeAt(g)!==p.charCodeAt(g)&&C.charAt(g).toLowerCase()!==p.charAt(g).toLowerCase());g++);C=p.substr(0,g)+C.substr(g)}return k.posix.relative(C,p)}resolvePath(h,y){if(h.scheme===n.Schemas.file){const C=I.URI.file(k.resolve(E(h),y));return h.with({authority:C.authority,path:C.path})}return y=R.toPosixPath(y),h.with({path:k.posix.resolve(h.path,y)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,y){return h===y||h!==void 0&&y!==void 0&&(0,A.equalsIgnoreCase)(h,y)}hasTrailingPathSeparator(h,y=k.sep){if(h.scheme===n.Schemas.file){const C=E(h);return C.length>R.getRoot(C).length&&C[C.length-1]===y}else{const C=h.path;return C.length>1&&C.charCodeAt(C.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,y=k.sep){return(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,y=k.sep){let C=!1;if(h.scheme===n.Schemas.file){const p=E(h);C=p!==void 0&&p.length===R.getRoot(p).length&&p[p.length-1]===y}else{y="/";const p=h.path;C=p.length===1&&p.charCodeAt(p.length-1)===47}return!C&&!(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path+"/"}):h}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(S=>S.scheme===n.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new P(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(S,h){const y=[];for(let C=0;C<S.length;C++){const p=h(S[C]);S.some((g,a)=>a===C?!1:(0,e.isEqualOrParent)(p,h(g)))||y.push(S[C])}return y}e.distinctParents=b;var w;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function h(y){const C=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(a=>{const[f,c]=a.split(":");f&&c&&C.set(f,c)});const g=y.path.substring(0,y.path.indexOf(";"));return g&&C.set(S.META_DATA_MIME,g),C}S.parseMetaData=h})(w=e.DataUri||(e.DataUri={}));function m(S,h,y){if(h){let C=S.path;return C&&C[0]!==k.posix.sep&&(C=k.posix.sep+C),S.with({scheme:y,authority:h,path:C})}return S.with({scheme:y})}e.toLocalResource=m}),define(ne[6],re([0,1,21,9,3,2,17,4]),function(Q,e,R,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(V){return!!V&&typeof V.then=="function"}e.isThenable=E;function P(V){const O=new R.CancellationTokenSource,N=V(O.token),W=new Promise((x,Z)=>{const oe=O.token.onCancellationRequested(()=>{oe.dispose(),O.dispose(),Z(new n.CancellationError)});Promise.resolve(N).then(X=>{oe.dispose(),O.dispose(),x(X)},X=>{oe.dispose(),O.dispose(),Z(X)})});return new class{cancel(){O.cancel()}then(x,Z){return W.then(x,Z)}catch(x){return this.then(void 0,x)}finally(x){return W.finally(x)}}}e.createCancelablePromise=P;function b(V,O,N){return new Promise((W,x)=>{const Z=O.onCancellationRequested(()=>{Z.dispose(),W(N)});V.then(W,x).finally(()=>Z.dispose())})}e.raceCancellation=b;function w(V,O){return new Promise((N,W)=>{const x=O.onCancellationRequested(()=>{x.dispose(),W(new n.CancellationError)});V.then(N,W).finally(()=>x.dispose())})}e.raceCancellationError=w;async function m(V){let O=-1;const N=V.map((x,Z)=>x.then(oe=>(O=Z,oe))),W=await Promise.race(N);return V.forEach((x,Z)=>{Z!==O&&x.cancel()}),W}e.raceCancellablePromises=m;function S(V,O,N){let W;const x=setTimeout(()=>{W?.(void 0),N?.()},O);return Promise.race([V.finally(()=>clearTimeout(x)),new Promise(Z=>W=Z)])}e.raceTimeout=S;function h(V){return new Promise((O,N)=>{const W=V();E(W)?W.then(O,N):O(W)})}e.asPromise=h;class y{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(O){if(this.activePromise){if(this.queuedPromiseFactory=O,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(N,N).then(W)})}return new Promise((N,W)=>{this.queuedPromise.then(N,W)})}return this.activePromise=O(),new Promise((N,W)=>{this.activePromise.then(x=>{this.activePromise=null,N(x)},x=>{this.activePromise=null,W(x)})})}}e.Throttler=y;class C{constructor(){this.current=Promise.resolve(null)}queue(O){return this.current=this.current.then(()=>O(),()=>O())}}e.Sequencer=C;class p{constructor(){this.promiseMap=new Map}queue(O,N){const x=(this.promiseMap.get(O)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(O)===x&&this.promiseMap.delete(O)});return this.promiseMap.set(O,x),x}}e.SequencerByKey=p;const g=(V,O)=>{let N=!0;const W=setTimeout(()=>{N=!1,O()},V);return{isTriggered:()=>N,dispose:()=>{clearTimeout(W),N=!1}}},a=V=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,V())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(O){this.defaultDelay=O,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(O,N=this.defaultDelay){this.task=O,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((x,Z)=>{this.doResolve=x,this.doReject=Z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const x=this.task;return this.task=null,x()}}));const W=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=N===e.MicrotaskDelay?a(W):g(N,W),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class c{constructor(O){this.delayer=new f(O),this.throttler=new y}trigger(O,N){return this.delayer.trigger(()=>this.throttler.queue(O),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class i{constructor(){this._isOpen=!1,this._promise=new Promise((O,N)=>{this._completePromise=O})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class s extends i{constructor(O){super(),this._timeout=setTimeout(()=>this.open(),O)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function t(V,O){return O?new Promise((N,W)=>{const x=setTimeout(()=>{Z.dispose(),N()},V),Z=O.onCancellationRequested(()=>{clearTimeout(x),Z.dispose(),W(new n.CancellationError)})}):P(N=>t(V,N))}e.timeout=t;function r(V,O=0){const N=setTimeout(V,O);return(0,T.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=r;function o(V){const O=[];let N=0;const W=V.length;function x(){return N<W?V[N++]():null}function Z(oe){oe!=null&&O.push(oe);const X=x();return X?X.then(Z):Promise.resolve(O)}return Promise.resolve(null).then(Z)}e.sequence=o;function l(V,O=W=>!!W,N=null){let W=0;const x=V.length,Z=()=>{if(W>=x)return Promise.resolve(N);const oe=V[W++];return Promise.resolve(oe()).then(ie=>O(ie)?Promise.resolve(ie):Z())};return Z()}e.first=l;function u(V,O=W=>!!W,N=null){if(V.length===0)return Promise.resolve(N);let W=V.length;const x=()=>{W=-1;for(const Z of V)Z.cancel?.()};return new Promise((Z,oe)=>{for(const X of V)X.then(ie=>{--W>=0&&O(ie)?(x(),Z(ie)):W===0&&Z(N)}).catch(ie=>{--W>=0&&(x(),oe(ie))})})}e.firstParallel=u;class d{constructor(O){this._size=0,this.maxDegreeOfParalellism=O,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(O){return this._size++,new Promise((N,W)=>{this.outstandingPromises.push({factory:O,c:N,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const O=this.outstandingPromises.shift();this.runningPromises++;const N=O.factory();N.then(O.c,O.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=d;class v extends d{constructor(){super(1)}}e.Queue=v;class L{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const O=new q;return this.drainers.add(O),O.p}isDrained(){for(const[,O]of this.queues)if(O.size>0)return!1;return!0}queueFor(O,N=A.extUri){const W=N.getComparisonKey(O);let x=this.queues.get(W);return x||(x=new v,k.Event.once(x.onDrained)(()=>{x?.dispose(),this.queues.delete(W),this.onDidQueueDrain()}),this.queues.set(W,x)),x}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const O of this.drainers)O.complete();this.drainers.clear()}dispose(){for(const[,O]of this.queues)O.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=L;class _{constructor(O,N){this._token=-1,typeof O=="function"&&typeof N=="number"&&this.setIfNotSet(O,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(O,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,O()},N)}setIfNotSet(O,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,O()},N))}}e.TimeoutTimer=_;class M{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(O,N){this.cancel(),this._token=setInterval(()=>{O()},N)}}e.IntervalTimer=M;class U{constructor(O,N){this.timeoutToken=-1,this.runner=O,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(O=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,O)}get delay(){return this.timeout}set delay(O){this.timeout=O}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=U;class D{constructor(O,N){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.runner=O,this.timeout=N,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(O=this.timeout){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(O/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=D;class F extends U{constructor(O,N){super(O,N),this.units=[]}work(O){this.units.push(O),this.isScheduled()||this.schedule()}doRun(){const O=this.units;this.units=[],this.runner?.(O)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class $ extends T.Disposable{constructor(O,N){super(),this.options=O,this.handler=N,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(O){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+O.length>this.options.maxBufferedWork)return!1}else if(this.pending+O.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...O),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=V=>{(0,I.setTimeout0)(()=>{if(O)return;const N=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let O=!1;return{dispose(){O||(O=!0)}}}:e.runWhenIdle=(V,O)=>{const N=requestIdleCallback(V,typeof O=="number"?{timeout:O}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(N))}}}}();class j{constructor(O){this._didRun=!1,this._executor=()=>{try{this._value=O()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=j;async function J(V,O,N){let W;for(let x=0;x<N;x++)try{return await V()}catch(Z){W=Z,await t(O)}throw W}e.retry=J;class H{hasPending(O){return this._pending?typeof O=="number"?this._pending.taskId===O:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(O,N,W){return this._pending={taskId:O,cancel:()=>W?.(),promise:N},N.then(()=>this.donePending(O),()=>this.donePending(O)),N}donePending(O){this._pending&&O===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const O=this._next;this._next=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this._next)this._next.run=O;else{let N,W;const x=new Promise((Z,oe)=>{N=Z,W=oe});this._next={run:O,promise:x,promiseResolve:N,promiseReject:W}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=H;class K{constructor(O,N=()=>Date.now()){this.interval=O,this.nowFn=N,this.lastIncrementTime=0,this.value=0}increment(){const O=this.nowFn();return O-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=O,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((O,N)=>{this.completeCallback=O,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(O){return new Promise(N=>{this.completeCallback(O),this.resolved=!0,N()})}error(O){return new Promise(N=>{this.errorCallback(O),this.rejected=!0,N()})}cancel(){new Promise(O=>{this.errorCallback(new n.CancellationError),this.rejected=!0,O()})}}e.DeferredPromise=q;var B;(function(V){async function O(W){let x;const Z=await Promise.all(W.map(oe=>oe.then(X=>X,X=>{x||(x=X)})));if(typeof x<"u")throw x;return Z}V.settled=O;function N(W){return new Promise(async(x,Z)=>{try{await W(x,Z)}catch(oe){Z(oe)}})}V.withAsyncBody=N})(B=e.Promises||(e.Promises={}));var Y;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(Y||(Y={}));class te{constructor(O){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const N={emitOne:W=>this.emitOne(W),emitMany:W=>this.emitMany(W),reject:W=>this.reject(W)};try{await Promise.resolve(O(N)),this.resolve()}catch(W){this.reject(W)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}static fromArray(O){return new te(N=>{N.emitMany(O)})}static fromPromise(O){return new te(async N=>{N.emitMany(await O)})}static fromPromises(O){return new te(async N=>{await Promise.all(O.map(async W=>N.emitOne(await W)))})}static merge(O){return new te(async N=>{await Promise.all(O.map(async W=>{for await(const x of W)N.emitOne(x)}))})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(O<this._results.length)return{done:!1,value:this._results[O++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(O,N){return new te(async W=>{for await(const x of O)W.emitOne(N(x))})}map(O){return te.map(this,O)}static filter(O,N){return new te(async W=>{for await(const x of O)N(x)&&W.emitOne(x)})}filter(O){return te.filter(this,O)}static coalesce(O){return te.filter(O,N=>!!N)}coalesce(){return te.coalesce(this)}static async toPromise(O){const N=[];for await(const W of O)N.push(W);return N}toPromise(){return te.toPromise(this)}emitOne(O){this._state===0&&(this._results.push(O),this._onStateChanged.fire())}emitMany(O){this._state===0&&(this._results=this._results.concat(O),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(O){this._state===0&&(this._state=2,this._error=O,this._onStateChanged.fire())}}e.AsyncIterableObject=te,te.EMPTY=te.fromArray([]);class ce extends te{constructor(O,N){super(N),this._source=O}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function z(V){const O=new R.CancellationTokenSource,N=V(O.token);return new ce(O,async W=>{const x=O.token.onCancellationRequested(()=>{x.dispose(),O.dispose(),W.reject(new n.CancellationError)});try{for await(const Z of N){if(O.token.isCancellationRequested)return;W.emitOne(Z)}x.dispose(),O.dispose()}catch(Z){x.dispose(),O.dispose(),W.reject(Z)}})}e.createCancelableAsyncIterable=z}),define(ne[82],re([0,1,18,6,46,34,10,4,24]),function(Q,e,R,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",w="[^/\\\\]",m=/\//g;function S(q,B){switch(q){case 0:return"";case 1:return`${w}*?`;default:return`(?:${b}|${w}+${b}${B?`|${b}${w}+`:""})*?`}}function h(q,B){if(!q)return[];const Y=[];let te=!1,ce=!1,z="";for(const V of q){switch(V){case B:if(!te&&!ce){Y.push(z),z="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}z+=V}return z&&Y.push(z),Y}e.splitGlobAware=h;function y(q){if(!q)return"";let B="";const Y=h(q,e.GLOB_SPLIT);if(Y.every(te=>te===e.GLOBSTAR))B=".*";else{let te=!1;Y.forEach((ce,z)=>{if(ce===e.GLOBSTAR){if(te)return;B+=S(2,z===Y.length-1)}else{let V=!1,O="",N=!1,W="";for(const x of ce){if(x!=="}"&&V){O+=x;continue}if(N&&(x!=="]"||!W)){let Z;x==="-"?Z=x:(x==="^"||x==="!")&&!W?Z="^":x===e.GLOB_SPLIT?Z="":Z=(0,E.escapeRegExpCharacters)(x),W+=Z;continue}switch(x){case"{":V=!0;continue;case"[":N=!0;continue;case"}":{B+=`(?:${h(O,",").map(X=>y(X)).join("|")})`,V=!1,O="";break}case"]":{B+="["+W+"]",N=!1,W="";break}case"?":B+=w;continue;case"*":B+=S(1);continue;default:B+=(0,E.escapeRegExpCharacters)(x)}}z<Y.length-1&&(Y[z+1]!==e.GLOBSTAR||z+2<Y.length)&&(B+=b)}te=ce===e.GLOBSTAR})}return B}const C=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new T.LRUCache(1e4),s=function(){return!1},t=function(){return null};function r(q,B){if(!q)return t;let Y;typeof q!="string"?Y=q.pattern:Y=q,Y=Y.trim();const te=`${Y}_${!!B.trimForExclusions}`;let ce=i.get(te);if(ce)return o(ce,q);let z;return C.test(Y)?ce=u(Y.substr(4),Y):(z=p.exec(l(Y,B)))?ce=d(z[1],Y):(B.trimForExclusions?a:g).test(Y)?ce=v(Y,B):(z=f.exec(l(Y,B)))?ce=L(z[1].substr(1),Y,!0):(z=c.exec(l(Y,B)))?ce=L(z[1],Y,!1):ce=_(Y),i.set(te,ce),o(ce,q)}function o(q,B){if(typeof B=="string")return q;const Y=function(te,ce){return(0,k.isEqualOrParent)(te,B.base,!I.isLinux)?q(te.substr(B.base.length+1),ce):null};return Y.allBasenames=q.allBasenames,Y.allPaths=q.allPaths,Y.basenames=q.basenames,Y.patterns=q.patterns,Y}function l(q,B){return B.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function u(q,B){return function(Y,te){return typeof Y=="string"&&Y.endsWith(q)?B:null}}function d(q,B){const Y=`/${q}`,te=`\\${q}`,ce=function(V,O){return typeof V!="string"?null:O?O===q?B:null:V===q||V.endsWith(Y)||V.endsWith(te)?B:null},z=[q];return ce.basenames=z,ce.patterns=[B],ce.allBasenames=z,ce}function v(q,B){const Y=H(q.slice(1,-1).split(",").map(O=>r(O,B)).filter(O=>O!==t),q),te=Y.length;if(!te)return t;if(te===1)return Y[0];const ce=function(O,N){for(let W=0,x=Y.length;W<x;W++)if(Y[W](O,N))return q;return null},z=Y.find(O=>!!O.allBasenames);z&&(ce.allBasenames=z.allBasenames);const V=Y.reduce((O,N)=>N.allPaths?O.concat(N.allPaths):O,[]);return V.length&&(ce.allPaths=V),ce}function L(q,B,Y){const te=A.sep===A.posix.sep,ce=te?q:q.replace(m,A.sep),z=A.sep+ce,V=A.posix.sep+q;let O;return Y?O=function(N,W){return typeof N=="string"&&(N===ce||N.endsWith(z)||!te&&(N===q||N.endsWith(V)))?B:null}:O=function(N,W){return typeof N=="string"&&(N===ce||!te&&N===q)?B:null},O.allPaths=[(Y?"*/":"./")+q],O}function _(q){try{const B=new RegExp(`^${y(q)}$`);return function(Y){return B.lastIndex=0,typeof Y=="string"&&B.test(Y)?q:null}}catch{return t}}function M(q,B,Y){return!q||typeof B!="string"?!1:U(q)(B,void 0,Y)}e.match=M;function U(q,B={}){if(!q)return s;if(typeof q=="string"||D(q)){const Y=r(q,B);if(Y===t)return s;const te=function(ce,z){return!!Y(ce,z)};return Y.allBasenames&&(te.allBasenames=Y.allBasenames),Y.allPaths&&(te.allPaths=Y.allPaths),te}return j(q,B)}e.parse=U;function D(q){const B=q;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=D;function F(q){return q.allBasenames||[]}e.getBasenameTerms=F;function $(q){return q.allPaths||[]}e.getPathTerms=$;function j(q,B){const Y=H(Object.getOwnPropertyNames(q).map(O=>J(O,q[O],B)).filter(O=>O!==t)),te=Y.length;if(!te)return t;if(!Y.some(O=>!!O.requiresSiblings)){if(te===1)return Y[0];const O=function(x,Z){let oe;for(let X=0,ie=Y.length;X<ie;X++){const se=Y[X](x,Z);if(typeof se=="string")return se;(0,n.isThenable)(se)&&(oe||(oe=[]),oe.push(se))}return oe?(async()=>{for(const X of oe){const ie=await X;if(typeof ie=="string")return ie}return null})():null},N=Y.find(x=>!!x.allBasenames);N&&(O.allBasenames=N.allBasenames);const W=Y.reduce((x,Z)=>Z.allPaths?x.concat(Z.allPaths):x,[]);return W.length&&(O.allPaths=W),O}const ce=function(O,N,W){let x,Z;for(let oe=0,X=Y.length;oe<X;oe++){const ie=Y[oe];ie.requiresSiblings&&W&&(N||(N=(0,A.basename)(O)),x||(x=N.substr(0,N.length-(0,A.extname)(O).length)));const se=ie(O,N,x,W);if(typeof se=="string")return se;(0,n.isThenable)(se)&&(Z||(Z=[]),Z.push(se))}return Z?(async()=>{for(const oe of Z){const X=await oe;if(typeof X=="string")return X}return null})():null},z=Y.find(O=>!!O.allBasenames);z&&(ce.allBasenames=z.allBasenames);const V=Y.reduce((O,N)=>N.allPaths?O.concat(N.allPaths):O,[]);return V.length&&(ce.allPaths=V),ce}function J(q,B,Y){if(B===!1)return t;const te=r(q,Y);if(te===t)return t;if(typeof B=="boolean")return te;if(B){const ce=B.when;if(typeof ce=="string"){const z=(V,O,N,W)=>{if(!W||!te(V,O))return null;const x=ce.replace("$(basename)",N),Z=W(x);return(0,n.isThenable)(Z)?Z.then(oe=>oe?q:null):Z?q:null};return z.requiresSiblings=!0,z}}return te}function H(q,B){const Y=q.filter(O=>!!O.basenames);if(Y.length<2)return q;const te=Y.reduce((O,N)=>{const W=N.basenames;return W?O.concat(W):O},[]);let ce;if(B){ce=[];for(let O=0,N=te.length;O<N;O++)ce.push(B)}else ce=Y.reduce((O,N)=>{const W=N.patterns;return W?O.concat(W):O},[]);const z=function(O,N){if(typeof O!="string")return null;if(!N){let x;for(x=O.length;x>0;x--){const Z=O.charCodeAt(x-1);if(Z===47||Z===92)break}N=O.substr(x)}const W=te.indexOf(N);return W!==-1?ce[W]:null};z.basenames=te,z.patterns=ce,z.allBasenames=te;const V=q.filter(O=>!O.basenames);return V.push(z),V}function K(q,B){return(0,R.equals)(q,B,(Y,te)=>typeof Y=="string"&&typeof te=="string"?Y===te:typeof Y!="string"&&typeof te!="string"?Y.base===te.base&&Y.pattern===te.pattern:!1)}e.patternsEquals=K}),define(ne[130],re([0,1,7]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(b){return b.toJSON()}class k{constructor(w){this._uriTransformer=w}transformIncoming(w){const m=this._uriTransformer.transformIncoming(w);return m===w?w:n(R.URI.from(m))}transformOutgoing(w){const m=this._uriTransformer.transformOutgoing(w);return m===w?w:n(R.URI.from(m))}transformOutgoingURI(w){const m=this._uriTransformer.transformOutgoing(w);return m===w?w:R.URI.from(m)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function T(b,w,m){if(!b||m>200)return null;if(typeof b=="object"){if(b instanceof R.URI)return w.transformOutgoing(b);for(const S in b)if(Object.hasOwnProperty.call(b,S)){const h=T(b[S],w,m+1);h!==null&&(b[S]=h)}}return null}function A(b,w){const m=T(b,w,0);return m===null?b:m}e.transformOutgoingURIs=A;function I(b,w,m,S){if(!b||S>200)return null;if(typeof b=="object"){if(b.$mid===1)return m?R.URI.revive(w.transformIncoming(b)):w.transformIncoming(b);for(const h in b)if(Object.hasOwnProperty.call(b,h)){const y=I(b[h],w,m,S+1);y!==null&&(b[h]=y)}}return null}function E(b,w){const m=I(b,w,!1,0);return m===null?b:m}e.transformIncomingURIs=E;function P(b,w){const m=I(b,w,!0,0);return m===null?b:m}e.transformAndReviveIncomingURIs=P}),define(ne[131],re([0,1,37,9,34,30,117]),function(Q,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(b){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(b)}value(){if(this._value===void 0){let b=0,w=0;const m=(0,R.networkInterfaces)();for(const S in m){const h=m[S];if(h)for(const{mac:y,internal:C}of h)C||(w+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(b+=1))}this._value=w>0?b/w:0}return this._value}};let I;async function E(){return I||(I=(async()=>await P()||T.generateUuid())()),I}e.getMachineId=E;async function P(){try{const b=await new Promise((m,S)=>{Q(["crypto"],m,S)}),w=(0,A.getMac)();return b.createHash("sha256").update(w,"utf8").digest("hex")}catch(b){n.onUnexpectedError(b);return}}}),define(ne[27],re([0,1,53,37,270,6,46,80,10,4,17,7]),function(Q,e,R,n,k,T,A,I,E,P,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(j){j[j.UNLINK=0]="UNLINK",j[j.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function S(j,J=m.UNLINK){if((0,A.isRootOrDriveLetter)(j))throw new Error("rimraf - will refuse to recursively delete root");return J===m.UNLINK?y(j):h(j)}async function h(j){try{const J=(0,A.randomPath)((0,n.tmpdir)());try{await R.promises.rename(j,J)}catch(H){return H.code==="ENOENT"?void 0:y(j)}y(J).catch(H=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function y(j){return(0,k.promisify)(R.rm)(j,{recursive:!0,force:!0,maxRetries:3})}function C(j){if((0,A.isRootOrDriveLetter)(j))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(j,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=C;async function p(j,J){return f(await(J?g(j):(0,k.promisify)(R.readdir)(j)))}async function g(j){try{return await(0,k.promisify)(R.readdir)(j,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const J=[],H=await p(j);for(const K of H){let q=!1,B=!1,Y=!1;try{const te=await e.Promises.lstat((0,E.join)(j,K));q=te.isFile(),B=te.isDirectory(),Y=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}J.push({name:K,isFile:()=>q,isDirectory:()=>B,isSymbolicLink:()=>Y})}return J}function a(j){return f(R.readdirSync(j))}e.readdirSync=a;function f(j){return j.map(J=>typeof J=="string"?P.isMacintosh?(0,I.normalizeNFC)(J):J:(J.name=P.isMacintosh?(0,I.normalizeNFC)(J.name):J.name,J))}async function c(j){const J=await p(j),H=[];for(const K of J)await s.existsDirectory((0,E.join)(j,K))&&H.push(K);return H}function i(j,J=1e3){return new Promise(H=>{let K=!1;const q=setInterval(()=>{K||(K=!0,R.access(j,B=>{K=!1,B&&(clearInterval(q),H(void 0))}))},J)})}e.whenDeleted=i;var s;(function(j){async function J(q){let B;try{if(B=await e.Promises.lstat(q),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(P.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw te}throw Y}}j.stat=J;async function H(q){try{const{stat:B,symbolicLink:Y}=await j.stat(q);return B.isFile()&&Y?.dangling!==!0}catch{}return!1}j.existsFile=H;async function K(q){try{const{stat:B,symbolicLink:Y}=await j.stat(q);return B.isDirectory()&&Y?.dangling!==!0}catch{}return!1}j.existsDirectory=K})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new T.ResourceQueue;function r(j,J,H){return t.queueFor(w.URI.file(j),b.extUriBiasedIgnorePathCase).queue(()=>{const K=v(H);return new Promise((q,B)=>u(j,J,K,Y=>Y?B(Y):q()))})}let o=!0;function l(j){o=j}e.configureFlushOnWrite=l;function u(j,J,H,K){if(!o)return R.writeFile(j,J,{mode:H.mode,flag:H.flag},K);R.open(j,H.flag,H.mode,(q,B)=>{if(q)return K(q);R.writeFile(B,J,Y=>{if(Y)return R.close(B,()=>K(Y));R.fdatasync(B,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),l(!1)),R.close(B,ce=>K(ce))))})})}function d(j,J,H){const K=v(H);if(!o)return R.writeFileSync(j,J,{mode:K.mode,flag:K.flag});const q=R.openSync(j,K.flag,K.mode);try{R.writeFileSync(q,J);try{R.fdatasyncSync(q)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),l(!1)}}finally{R.closeSync(q)}}e.writeFileSync=d;function v(j){return j?{mode:typeof j.mode=="number"?j.mode:438,flag:typeof j.flag=="string"?j.flag:"w"}:{mode:438,flag:"w"}}async function L(j,J){if(j!==J)try{await e.Promises.rename(j,J)}catch(H){if(j.toLowerCase()!==J.toLowerCase()&&H.code==="EXDEV"||j.endsWith("."))await _(j,J,{preserveSymlinks:!1}),await S(j,m.MOVE);else throw H}}async function _(j,J,H){return U(j,J,{root:{source:j,target:J},options:H,handledSourcePaths:new Set})}const M=511;async function U(j,J,H){if(H.handledSourcePaths.has(j))return;H.handledSourcePaths.add(j);const{stat:K,symbolicLink:q}=await s.stat(j);if(q){if(H.options.preserveSymlinks)try{return await $(j,J,H)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(q.dangling)return}return K.isDirectory()?D(j,J,K.mode&M,H):F(j,J,K.mode&M)}async function D(j,J,H,K){await e.Promises.mkdir(J,{recursive:!0,mode:H});const q=await p(j);for(const B of q)await U((0,E.join)(j,B),(0,E.join)(J,B),K)}async function F(j,J,H){await e.Promises.copyFile(j,J),await e.Promises.chmod(J,H)}async function $(j,J,H){let K=await e.Promises.readlink(j);(0,A.isEqualOrParent)(K,H.root.source,!P.isLinux)&&(K=(0,E.join)(H.root.target,K.substr(H.root.source.length+1))),await e.Promises.symlink(K,J)}e.Promises=new class{get access(){return(0,k.promisify)(R.access)}get stat(){return(0,k.promisify)(R.stat)}get lstat(){return(0,k.promisify)(R.lstat)}get utimes(){return(0,k.promisify)(R.utimes)}get read(){return(j,J,H,K,q)=>new Promise((B,Y)=>{R.read(j,J,H,K,q,(te,ce,z)=>te?Y(te):B({bytesRead:ce,buffer:z}))})}get readFile(){return(0,k.promisify)(R.readFile)}get write(){return(j,J,H,K,q)=>new Promise((B,Y)=>{R.write(j,J,H,K,q,(te,ce,z)=>te?Y(te):B({bytesWritten:ce,buffer:z}))})}get appendFile(){return(0,k.promisify)(R.appendFile)}get fdatasync(){return(0,k.promisify)(R.fdatasync)}get truncate(){return(0,k.promisify)(R.truncate)}get rename(){return(0,k.promisify)(R.rename)}get copyFile(){return(0,k.promisify)(R.copyFile)}get open(){return(0,k.promisify)(R.open)}get close(){return(0,k.promisify)(R.close)}get symlink(){return(0,k.promisify)(R.symlink)}get readlink(){return(0,k.promisify)(R.readlink)}get chmod(){return(0,k.promisify)(R.chmod)}get mkdir(){return(0,k.promisify)(R.mkdir)}get unlink(){return(0,k.promisify)(R.unlink)}get rmdir(){return(0,k.promisify)(R.rmdir)}get realpath(){return(0,k.promisify)(R.realpath)}async exists(j){try{return await e.Promises.access(j),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return c}get writeFile(){return r}get rm(){return S}get move(){return L}get copy(){return _}}}),define(ne[132],re([0,1,53,10,4,24,27]),function(Q,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(m){if(k.isLinux)return m;const S=(0,n.dirname)(m);if(m===S)return m;const h=((0,n.basename)(m)||m).toLowerCase();try{const C=(0,A.readdirSync)(S).filter(p=>p.toLowerCase()===h);if(C.length===1){const p=I(S);if(p)return(0,n.join)(p,C[0])}else if(C.length>1){const p=C.indexOf(h);if(p>=0){const g=I(S);if(g)return(0,n.join)(g,C[p])}}}catch{}return null}e.realcaseSync=I;async function E(m){if(k.isLinux)return m;const S=(0,n.dirname)(m);if(m===S)return m;const h=((0,n.basename)(m)||m).toLowerCase();try{const C=(await A.Promises.readdir(S)).filter(p=>p.toLowerCase()===h);if(C.length===1){const p=await E(S);if(p)return(0,n.join)(p,C[0])}else if(C.length>1){const p=C.indexOf(h);if(p>=0){const g=await E(S);if(g)return(0,n.join)(g,C[p])}}}catch{}return null}e.realcase=E;async function P(m){try{return await A.Promises.realpath(m)}catch{const h=w(m);return await A.Promises.access(h,R.constants.R_OK),h}}e.realpath=P;function b(m){try{return R.realpathSync(m)}catch{const h=w(m);return R.accessSync(h,R.constants.R_OK),h}}e.realpathSync=b;function w(m){return(0,T.rtrim)((0,n.normalize)(m),n.sep)}}),define(ne[83],re([0,1,37,10,27]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,A=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var E;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(E||(E={}));let P;switch(process.arch){case"ia32":case"x32":P=1;break;case"arm":case"arm64":P=2;break;default:P=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class w{constructor(c,i,s){this.exePath=c,this.displayName=i,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:f=!1}={}){return f?P===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:f=!1,findPreview:c=!1}={}){const i=m({useAlternateBitness:f});if(!i)return null;const s=n.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(s))return null;let t=-1,r=null;for(const u of await k.Promises.readdir(s)){let d=-1;if(c){const L=u.indexOf("-");if(L<0)continue;const _=u.substring(0,L);if(!T.test(_)||u.substring(L+1)!=="preview")continue;d=parseInt(_,10)}else{if(!T.test(u))continue;d=parseInt(u,10)}if(d<=t)continue;const v=n.join(s,u,"pwsh.exe");!await k.SymlinkSupport.existsFile(v)||(r=v,t=d)}if(!r)return null;const o=i.includes("x86")?" (x86)":"",l=c?" Preview":"";return new w(r,`PowerShell${l}${o}`,!0)}async function h({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const c=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:i,pwshMsixName:s}=f?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(c))if(i.test(t)){const r=n.join(c,t,"pwsh.exe");return new w(r,s)}return null}function y(){const f=n.join(R.homedir(),".dotnet","tools","pwsh.exe");return new w(f,".NET Core PowerShell Global Tool")}function C(){const f=n.join(process.env.windir,P===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(f,"Windows PowerShell",!0)}async function*p(){let f=await S();f&&(yield f),f=await S({useAlternateBitness:!0}),f&&(yield f),f=await h(),f&&(yield f),f=y(),f&&(yield f),f=await S({findPreview:!0}),f&&(yield f),f=await h({findPreview:!0}),f&&(yield f),f=await S({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=C(),f&&(yield f)}async function*g(){for await(const f of p())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=g;async function a(){for await(const f of g())return f;return null}e.getFirstAvailablePowerShellInstallation=a}),define(ne[84],re([0,1,10,4,36,78,14,27]),function(Q,e,R,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function E(w=k.env){return w.comspec||"cmd.exe"}e.getWindowsShell=E;function P(w){let m=[],S=!1;const h=function(y){if(S){m.push(y);return}(!w.send(y,p=>{if(p&&console.error(p),S=!1,m.length>0){const g=m.slice(0);m=[],g.forEach(a=>h(a))}})||n.isWindows)&&(S=!0)};return{send:h}}e.createQueuedSender=P;var b;(function(w){async function m(S,h,y){if(R.isAbsolute(S))return S;if(h===void 0&&(h=k.cwd()),R.dirname(S)!=="."||(y===void 0&&A.isString(k.env.PATH)&&(y=k.env.PATH.split(R.delimiter)),y===void 0||y.length===0))return R.join(h,S);async function p(g){if(await I.Promises.exists(g)){let a;try{a=await I.Promises.stat(g)}catch(f){f.message.startsWith("EACCES")&&(a=await I.Promises.lstat(g))}return a?!a.isDirectory():!1}return!1}for(const g of y){let a;if(R.isAbsolute(g)?a=R.join(g,S):a=R.join(h,g,S),await p(a))return a;let f=a+".com";if(await p(f)||(f=a+".exe",await p(f)))return f}return R.join(h,S)}w.findExecutable=m})(b=e.win32||(e.win32={}))}),define(ne[133],re([0,1,54,20]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(A){return new Promise((I,E)=>{let P;const b=new Map;function w(S,h,y,C,p){const g=b.get(h);if(S===A||g){const a={name:m(y),cmd:y,pid:S,ppid:h,load:C,mem:p};b.set(S,a),S===A&&(P=a),g&&(g.children||(g.children=[]),g.children.push(a),g.children.length>1&&(g.children=g.children.sort((f,c)=>f.pid-c.pid)))}}function m(S){const h=/--vscode-window-kind=shared-process/,y=/--vscode-window-kind=issue-reporter/,C=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,g=/--utility-sub-type=node.mojom.NodeService/,a=/--crashes-directory/,f=/\\pipe\\winpty-control/,c=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(a.exec(S))return"electron-crash-reporter";if(f.exec(S))return"winpty-process";if(c.exec(S))return"console-window-host (Windows internal process)";let s=i.exec(S);if(s&&s.length===2){if(s[1]==="renderer")return h.exec(S)?"shared-process":y.exec(S)?"issue-reporter":C.exec(S)?"process-explorer":"window";if(s[1]==="utility"){if(p.exec(S))return"utility-network-service";if(g.exec(S))return"extension-host"}return s[1]}const t=/[a-zA-Z-]+\.js/g;let r="";do s=t.exec(S),s&&(r+=s+" ");while(s);return r&&S.indexOf("node ")<0&&S.indexOf("node.exe")<0?`electron_node ${r}`:S}if(process.platform==="win32"){const S=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,y)=>{Q(["windows-process-tree"],h,y)}).then(h=>{h.getProcessList(A,y=>{if(!y){E(new Error(`Root process ${A} not found`));return}h.getProcessCpuUsage(y,C=>{const p=new Map;C.forEach(g=>{const a=S(g.commandLine||"");p.set(g.pid,{name:m(a),cmd:a,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),P=p.get(A),P?(p.forEach(g=>{const a=p.get(g.ppid);a&&(a.children||(a.children=[]),a.children.push(g))}),p.forEach(g=>{g.children&&(g.children=g.children.sort((a,f)=>a.pid-f.pid))}),I(P)):E(new Error(`Root process ${A} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let S=function(){let h=[P];const y=[];for(;h.length;){const p=h.shift();p&&(y.push(p.pid),p.children&&(h=h.concat(p.children)))}let C=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);C+=" "+y.join(" "),(0,R.exec)(C,{},(p,g,a)=>{if(p||a)E(p||new Error(a.toString()));else{const f=g.toString().split(`
`);for(let c=0;c<y.length;c++){const i=b.get(y[c]);i.load=parseFloat(f[c])}if(!P){E(new Error(`Root process ${A} not found`));return}I(P)}})};(0,R.exec)("which ps",{},(h,y,C)=>{if(h||C)if(process.platform!=="linux")E(h||new Error(C.toString()));else{const p=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);(0,R.exec)(p,{},(g,a,f)=>{g||f?E(g||new Error(f.toString())):(T(a,w),S())})}else{const p=y.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${p} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(a,f,c)=>{a||c&&!c.includes("screen size is bogus")?E(a||new Error(c.toString())):(T(f,w),process.platform==="linux"?S():P?I(P):E(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=k;function T(A,I){const E=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,P=A.toString().split(`
`);for(const b of P){const w=E.exec(b.trim());w&&w.length===6&&I(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(ne[134],re([0,1,37,4,83,84]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(S,h){return S===1?n.isWindows?w():T.getWindowsShell(h):P(S,h)}e.getSystemShell=A;function I(S,h){return S===1?n.isWindows?m(h):T.getWindowsShell(h):P(S,h)}e.getSystemShellSync=I;let E=null;function P(S,h){if(n.isLinux&&S===2||n.isMacintosh&&S===3)return"/bin/bash";if(!E){let y;if(n.isWindows)y="/bin/bash";else{if(y=h.SHELL,!y)try{y=(0,R.userInfo)().shell}catch{}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}E=y}return E}let b=null;async function w(){return b||(b=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),b}function m(S){if(b)return b;const h=n.isWindows&&parseFloat((0,R.release)())>=10,y=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),C=`${S.windir}\\${y?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?C:T.getWindowsShell(S)}});var pe=this&&this.__decorate||function(Q,e,R,n){var k=arguments.length,T=k<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,R):n,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Q,e,R,n);else for(var I=Q.length-1;I>=0;I--)(A=Q[I])&&(T=(k<3?A(T):k>3?A(e,R,T):A(e,R))||T);return k>3&&T&&Object.defineProperty(e,R,T),T};define(ne[39],re([0,1,18,6,16,21,61,9,3,2,64,24,14]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var S;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(S=e.RequestType||(e.RequestType={}));function h(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(y=e.ResponseType||(e.ResponseType={}));function C(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(p||(p={}));class g{constructor(B){this.buffer=B,this.pos=0}read(B){const Y=this.buffer.slice(this.pos,this.pos+B);return this.pos+=Y.byteLength,Y}}class a{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(B){this.buffers.push(B)}}var f;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(f||(f={}));function c(q){const B=k.VSBuffer.alloc(4);return B.writeUInt32BE(q,0),B}function i(q){return q.read(4).readUInt32BE(0)}function s(q){const B=k.VSBuffer.alloc(1);return B.writeUInt8(q,0),B}const t={Undefined:s(f.Undefined),String:s(f.String),Buffer:s(f.Buffer),VSBuffer:s(f.VSBuffer),Array:s(f.Array),Object:s(f.Object)},r=typeof Buffer<"u";function o(q,B){if(typeof B>"u")q.write(t.Undefined);else if(typeof B=="string"){const Y=k.VSBuffer.fromString(B);q.write(t.String),q.write(c(Y.byteLength)),q.write(Y)}else if(r&&Buffer.isBuffer(B)){const Y=k.VSBuffer.wrap(B);q.write(t.Buffer),q.write(c(Y.byteLength)),q.write(Y)}else if(B instanceof k.VSBuffer)q.write(t.VSBuffer),q.write(c(B.byteLength)),q.write(B);else if(Array.isArray(B)){q.write(t.Array),q.write(c(B.length));for(const Y of B)o(q,Y)}else{const Y=k.VSBuffer.fromString(JSON.stringify(B));q.write(t.Object),q.write(c(Y.byteLength)),q.write(Y)}}function l(q){switch(q.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return q.read(i(q)).toString();case f.Buffer:return q.read(i(q)).buffer;case f.VSBuffer:return q.read(i(q));case f.Array:{const Y=i(q),te=[];for(let ce=0;ce<Y;ce++)te.push(l(q));return te}case f.Object:return JSON.parse(q.read(i(q)).toString())}}class u{constructor(B,Y,te=null,ce=1e3){this.protocol=B,this.ctx=Y,this.logger=te,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(z=>this.onRawMessage(z)),this.sendResponse({type:200})}registerChannel(B,Y){this.channels.set(B,Y),setTimeout(()=>this.flushPendingRequests(B),0)}sendResponse(B){switch(B.type){case 200:{const Y=this.send([B.type]);this.logger?.logOutgoing(Y,0,1,C(B.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([B.type,B.id],B.data);this.logger?.logOutgoing(Y,B.id,1,C(B.type),B.data);return}}}send(B,Y=void 0){const te=new a;return o(te,B),o(te,Y),this.sendBuffer(te.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onRawMessage(B){const Y=new g(B),te=l(Y),ce=l(Y),z=te[0];switch(z){case 100:return this.logger?.logIncoming(B.byteLength,te[1],1,`${h(z)}: ${te[2]}.${te[3]}`,ce),this.onPromise({type:z,id:te[1],channelName:te[2],name:te[3],arg:ce});case 102:return this.logger?.logIncoming(B.byteLength,te[1],1,`${h(z)}: ${te[2]}.${te[3]}`,ce),this.onEventListen({type:z,id:te[1],channelName:te[2],name:te[3],arg:ce});case 101:return this.logger?.logIncoming(B.byteLength,te[1],1,`${h(z)}`),this.disposeActiveRequest({type:z,id:te[1]});case 103:return this.logger?.logIncoming(B.byteLength,te[1],1,`${h(z)}`),this.disposeActiveRequest({type:z,id:te[1]})}}onPromise(B){const Y=this.channels.get(B.channelName);if(!Y){this.collectPendingRequest(B);return}const te=new T.CancellationTokenSource;let ce;try{ce=Y.call(this.ctx,B.name,B.arg,te.token)}catch(O){ce=Promise.reject(O)}const z=B.id;ce.then(O=>{this.sendResponse({id:z,data:O,type:201}),this.activeRequests.delete(B.id)},O=>{O instanceof Error?this.sendResponse({id:z,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.sendResponse({id:z,data:O,type:203}),this.activeRequests.delete(B.id)});const V=(0,P.toDisposable)(()=>te.cancel());this.activeRequests.set(B.id,V)}onEventListen(B){const Y=this.channels.get(B.channelName);if(!Y){this.collectPendingRequest(B);return}const te=B.id,z=Y.listen(this.ctx,B.name,B.arg)(V=>this.sendResponse({id:te,data:V,type:204}));this.activeRequests.set(B.id,z)}disposeActiveRequest(B){const Y=this.activeRequests.get(B.id);Y&&(Y.dispose(),this.activeRequests.delete(B.id))}collectPendingRequest(B){let Y=this.pendingRequests.get(B.channelName);Y||(Y=[],this.pendingRequests.set(B.channelName,Y));const te=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.sendResponse({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:B,timeoutTimer:te})}flushPendingRequests(B){const Y=this.pendingRequests.get(B);if(Y){for(const te of Y)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.onPromise(te.request);break;case 102:this.onEventListen(te.request);break}this.pendingRequests.delete(B)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=u;var d;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor(B,Y=null){this.protocol=B,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(te=>this.onBuffer(te)),this.logger=Y}getChannel(B){const Y=this;return{call(te,ce,z){return Y.isDisposed?Promise.reject(new I.CancellationError):Y.requestPromise(B,te,ce,z)},listen(te,ce){return Y.isDisposed?E.Event.None:Y.requestEvent(B,te,ce)}}}requestPromise(B,Y,te,ce=T.CancellationToken.None){const z=this.lastRequestId++,O={id:z,type:100,channelName:B,name:Y,arg:te};if(ce.isCancellationRequested)return Promise.reject(new I.CancellationError);let N;return new Promise((x,Z)=>{if(ce.isCancellationRequested)return Z(new I.CancellationError);const oe=()=>{const ue=he=>{switch(he.type){case 201:this.handlers.delete(z),x(he.data);break;case 202:{this.handlers.delete(z);const ve=new Error(he.data.message);ve.stack=he.data.stack,ve.name=he.data.name,Z(ve);break}case 203:this.handlers.delete(z),Z(he.data);break}};this.handlers.set(z,ue),this.sendRequest(O)};let X=null;this.state===p.Idle?oe():(X=(0,n.createCancelablePromise)(ue=>this.whenInitialized()),X.then(()=>{X=null,oe()}));const ie=()=>{X?(X.cancel(),X=null):this.sendRequest({id:z,type:101}),Z(new I.CancellationError)},se=ce.onCancellationRequested(ie);N=(0,P.combinedDisposable)((0,P.toDisposable)(ie),se),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent(B,Y,te){const ce=this.lastRequestId++,V={id:ce,type:102,channelName:B,name:Y,arg:te};let O=null;const N=new E.Emitter({onFirstListenerAdd:()=>{O=(0,n.createCancelablePromise)(x=>this.whenInitialized()),O.then(()=>{O=null,this.activeRequests.add(N),this.sendRequest(V)})},onLastListenerRemove:()=>{O?(O.cancel(),O=null):(this.activeRequests.delete(N),this.sendRequest({id:ce,type:103}))}}),W=x=>N.fire(x.data);return this.handlers.set(ce,W),N.event}sendRequest(B){switch(B.type){case 100:case 102:{const Y=this.send([B.type,B.id,B.channelName,B.name],B.arg);this.logger?.logOutgoing(Y,B.id,0,`${h(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const Y=this.send([B.type,B.id]);this.logger?.logOutgoing(Y,B.id,0,h(B.type));return}}}send(B,Y=void 0){const te=new a;return o(te,B),o(te,Y),this.sendBuffer(te.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onBuffer(B){const Y=new g(B),te=l(Y),ce=l(Y),z=te[0];switch(z){case 200:return this.logger?.logIncoming(B.byteLength,0,0,C(z)),this.onResponse({type:te[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(B.byteLength,te[1],0,C(z),ce),this.onResponse({type:te[0],id:te[1],data:ce})}}onResponse(B){if(B.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(B.id)?.(B)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}pe([A.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class L{constructor(B){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,B(({protocol:Y,onDidClientDisconnect:te})=>{E.Event.once(Y.onMessage)(z=>{const V=new g(z),O=l(V),N=new u(Y,O),W=new v(Y);this.channels.forEach((Z,oe)=>N.registerChannel(oe,Z));const x={channelServer:N,channelClient:W,ctx:O};this._connections.add(x),this._onDidAddConnection.fire(x),te(()=>{N.dispose(),W.dispose(),this._connections.delete(x),this._onDidRemoveConnection.fire(x)})})})}get connections(){const B=[];return this._connections.forEach(Y=>B.push(Y)),B}getChannel(B,Y){const te=this;return{call(ce,z,V){let O;if((0,m.isFunction)(Y)){const W=(0,R.getRandomElement)(te.connections.filter(Y));O=W?Promise.resolve(W):E.Event.toPromise(E.Event.filter(te.onDidAddConnection,Y))}else O=Y.routeCall(te,ce,z);const N=O.then(W=>W.channelClient.getChannel(B));return M(N).call(ce,z,V)},listen(ce,z){if((0,m.isFunction)(Y))return te.getMulticastEvent(B,Y,ce,z);const V=Y.routeEvent(te,ce,z).then(O=>O.channelClient.getChannel(B));return M(V).listen(ce,z)}}}getMulticastEvent(B,Y,te,ce){const z=this;let V=new P.DisposableStore;const O=new E.Emitter({onFirstListenerAdd:()=>{V=new P.DisposableStore;const N=new E.EventMultiplexer,W=new Map,x=oe=>{const ie=oe.channelClient.getChannel(B).listen(te,ce),se=N.add(ie);W.set(oe,se)},Z=oe=>{const X=W.get(oe);!X||(X.dispose(),W.delete(oe))};z.connections.filter(Y).forEach(x),E.Event.filter(z.onDidAddConnection,Y)(x,void 0,V),z.onDidRemoveConnection(Z,void 0,V),N.event(O.fire,O,V),V.add(N)},onLastListenerRemove:()=>{V.dispose()}});return O.event}registerChannel(B,Y){this.channels.set(B,Y),this._connections.forEach(te=>{te.channelServer.registerChannel(B,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class _{constructor(B,Y,te=null){const ce=new a;o(ce,Y),B.send(ce.buffer),this.channelClient=new v(B,te),this.channelServer=new u(B,Y,te)}getChannel(B){return this.channelClient.getChannel(B)}registerChannel(B,Y){this.channelServer.registerChannel(B,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function M(q){return{call(B,Y,te){return q.then(ce=>ce.call(B,Y,te))},listen(B,Y){const te=new E.Relay;return q.then(ce=>te.input=ce.listen(B,Y)),te.event}}}e.getDelayedChannel=M;function U(q){let B=!1;return{call(Y,te,ce){return B?q.call(Y,te,ce):(0,n.timeout)(0).then(()=>B=!0).then(()=>q.call(Y,te,ce))},listen(Y,te){if(B)return q.listen(Y,te);const ce=new E.Relay;return(0,n.timeout)(0).then(()=>B=!0).then(()=>ce.input=q.listen(Y,te)),ce.event}}}e.getNextTickChannel=U;class D{constructor(B){this.fn=B}routeCall(B){return this.route(B)}routeEvent(B){return this.route(B)}async route(B){for(const Y of B.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await E.Event.toPromise(B.onDidAddConnection),await this.route(B)}}e.StaticRouter=D;var F;(function(q){function B(z,V){const O=z,N=V&&V.disableMarshalling,W=new Map;for(const x in O)te(x)&&W.set(x,E.Event.buffer(O[x],!0));return new class{listen(x,Z,oe){const X=W.get(Z);if(X)return X;if(ce(Z)){const ie=O[Z];if(typeof ie=="function")return ie.call(O,oe)}throw new Error(`Event not found: ${Z}`)}call(x,Z,oe){const X=O[Z];if(typeof X=="function"){if(!N&&Array.isArray(oe))for(let ie=0;ie<oe.length;ie++)oe[ie]=(0,b.revive)(oe[ie]);return X.apply(O,oe)}throw new Error(`Method not found: ${Z}`)}}}q.fromService=B;function Y(z,V){const O=V&&V.disableMarshalling;return new Proxy({},{get(N,W){if(typeof W=="string")return V?.properties?.has(W)?V.properties.get(W):ce(W)?function(x){return z.listen(W,x)}:te(W)?z.listen(W):async function(...x){let Z;V&&!(0,m.isUndefinedOrNull)(V.context)?Z=[V.context,...x]:Z=x;const oe=await z.call(W,Z);return O?oe:(0,b.revive)(oe)};throw new Error(`Property not found: ${String(W)}`)}})}q.toService=Y;function te(z){return z[0]==="o"&&z[1]==="n"&&w.isUpperAsciiLetter(z.charCodeAt(2))}function ce(z){return/^onDynamic/.test(z)&&w.isUpperAsciiLetter(z.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const B=q.toString();if(B!=="[object Object]")return B}return q}function J(q){return Array.isArray(q)?q.map(j):j(q)}function H(q,B,Y,te,ce,z,V){V=J(V);const O=$[ce],N=O[te%O.length];let W=[`%c[${q}]%c[${String(B).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${z}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(z)?(W=W.concat(V),W.push(")")):W.push(V),console.log.apply(console,W)}e.logWithColors=H;class K{constructor(B,Y){this._outgoingPrefix=B,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(B,Y,te,ce,z){this._totalOutgoing+=B,H(this._outgoingPrefix,this._totalOutgoing,B,Y,te,ce,z)}logIncoming(B,Y,te,ce,z){this._totalIncoming+=B,H(this._incomingPrefix,this._totalIncoming,B,Y,te,ce,z)}}e.IPCLogger=K}),define(ne[135],re([0,1,16,3,39]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(E){this.port=E,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",P=>R.VSBuffer.wrap(P.data)),E.start()}send(E){this.port.postMessage(E.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class A extends k.IPCClient{constructor(E,P){const b=new T(E);super(b,P),this.protocol=b}dispose(){this.protocol.disconnect()}}e.Client=A}),define(ne[85],re([0,1,16,3,2,39]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(r){r.enableDiagnostics=!1,r.records=[];const o=new WeakMap;let l=0;function u(v,L){if(!o.has(v)){const _=String(++l);o.set(v,_)}return o.get(v)}function d(v,L,_,M){if(!r.enableDiagnostics)return;const U=u(v,L);if(M instanceof R.VSBuffer||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const D=R.VSBuffer.alloc(M.byteLength);D.set(M),r.records.push({timestamp:Date.now(),id:U,label:L,type:_,buff:D})}else r.records.push({timestamp:Date.now(),id:U,label:L,type:_,data:M})}r.traceSocketEvent=d})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function b(){return P||(P=R.VSBuffer.alloc(0)),P}class w{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,l){if(o===0)return b();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const L=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=o),L}if(this._chunks[0].byteLength>o){const L=this._chunks[0].slice(0,o);return l&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),L}const u=R.VSBuffer.alloc(o);let d=0,v=0;for(;o>0;){const L=this._chunks[v];if(L.byteLength>o){const _=L.slice(0,o);u.set(_,d),d+=o,l&&(this._chunks[v]=L.slice(o),this._totalLength-=o),o-=o}else u.set(L,d),d+=L.byteLength,l?(this._chunks.shift(),this._totalLength-=L.byteLength):v++,o-=L.byteLength}return u}}e.ChunkStream=w;var m;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(m||(m={}));function S(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var h;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class y{constructor(o,l,u,d){this.type=o,this.id=l,this.ack=u,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class C extends k.Disposable{constructor(o){super(),this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new w,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const u=this._state.messageType,d=this._state.id,v=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",l),this._onMessage.fire(new y(u,d,v,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=R.VSBuffer.alloc(13);l.writeUInt8(o.type,0),l.writeUInt32BE(o.id,1),l.writeUInt32BE(o.ack,5),l.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(l,o.data)}_bufferAdd(o,l){const u=this._totalLength===0;return this._data.push(o,l),this._totalLength+=o.byteLength+l.byteLength,u}_bufferTake(){const o=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,l){this._bufferAdd(o,l)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class g extends k.Disposable{constructor(o){super(),this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new C(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new y(1,0,0,o))}}e.Protocol=g;class a extends T.IPCClient{constructor(o,l,u=null){super(o,l,u),this.protocol=o}static fromSocket(o,l){return new a(new g(o),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=a;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class c{constructor(o){this.data=o,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let o=0,l=this._first;for(;l;)l=l.next,o++;return o}peek(){return this._first?this._first.data:null}toArray(){const o=[];let l=0,u=this._first;for(;u;)o[l++]=u.data,u=u.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const l=new c(o);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class s{constructor(){this.lastRuns=[];const o=Date.now();for(let l=0;l<s._HISTORY_LENGTH;l++)this.lastRuns[l]=o-1e3*l;setInterval(()=>{for(let l=s._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const o=Date.now(),l=(1+s._HISTORY_LENGTH)*1e3;let u=0;for(let d=0;d<s._HISTORY_LENGTH;d++)o-this.lastRuns[d]<=l&&u++;return 1-u/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class t{constructor(o,l=null,u=s.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),l&&this._socketReader.acceptChunk(l),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new y(5,0,0,b());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new y(7,0,0,b());this._socketWriter.write(o)}sendResume(){const o=new y(8,0,0,b());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,l){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new y(3,0,this._incomingAckId,b());this._socketWriter.write(o);const l=this._outgoingUnackMsg.toArray();for(let u=0,d=l.length;u<d;u++)this._socketWriter.write(l[u]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new y(6,0,0,b())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const l=this._outgoingUnackMsg.toArray();for(let u=0,d=l.length;u<d;u++)this._socketWriter.write(l[u]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new y(1,l,this._incomingAckId,o);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(o){const l=new y(2,0,0,o);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),l=Date.now()-o.writtenTime,u=Date.now()-this._socketReader.lastReadTime,d=Date.now()-this._lastSocketTimeoutTime;if(l>=2e4&&u>=2e4&&d>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:u});return}const v=Math.max(2e4-l,2e4-u,2e4-d,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},v)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new y(3,0,this._incomingAckId,b());this._socketWriter.write(o)}_sendKeepAlive(){const o=new y(9,0,0,b());this._socketWriter.write(o)}}e.PersistentProtocol=t}),define(ne[136],re([0,1,86,3,39,135]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends k.IPCServer{static getOnDidClientConnect(){const E=n.Event.fromNodeEventEmitter(R.ipcRenderer,"vscode:createMessageChannel",(P,b)=>b);return n.Event.map(E,P=>{const{port1:b,port2:w}=new MessageChannel,S={protocol:new T.Protocol(b),onDidClientDisconnect:n.Event.fromDOMEventEmitter(b,"close")};return R.ipcRenderer.postMessage("vscode:createMessageChannelResult",P,[w]),S})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(ne[65],re([0,1,54,6,16,21,129,9,3,2,31,84,78,39]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends S.ChannelServer{constructor(p){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",g=>k.VSBuffer.wrap(Buffer.from(g,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.Server=h;class y{constructor(p,g){this.modulePath=p,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const a=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new n.Delayer(a),this.child=null,this._client=null}getChannel(p){const g=this;return{call(a,f,c){return g.requestPromise(p,a,f,c)},listen(a,f){return g.requestEvent(p,a,f)}}}requestPromise(p,g,a,f=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(p),i=(0,n.createCancelablePromise)(r=>c.call(g,a,r)),s=f.onCancellationRequested(()=>i.cancel()),t=(0,P.toDisposable)(()=>i.cancel());return this.activeRequests.add(t),i.finally(()=>{s.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(p,g,a){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let f;const c=new E.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(p).listen(g,a)(c.fire,c),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,m.removeDangerousEnvVariables)(g.env),this.child=(0,R.fork)(this.modulePath,p,g);const a=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,A.isRemoteConsoleLog)(o)){(0,A.log)(o,`IPC Library: ${this.options.serverName}`);return}a.fire(k.VSBuffer.wrap(Buffer.from(o,"base64")))});const c=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,i=o=>this.child&&this.child.connected&&c.send(o.buffer.toString("base64")),s=a.event,t={send:i,onMessage:s};this._client=new S.ChannelClient(t);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,l)=>{process.removeListener("exit",r),this.activeRequests.forEach(u=>(0,P.dispose)(u)),this.activeRequests.clear(),o!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+l),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:l})})}return this._client}getCachedChannel(p){let g=this.channels.get(p);return g||(g=this.client.getChannel(p),this.channels.set(p,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(ne[137],re([0,1,16,9,3,2,10,4,30,39,85]),function(Q,e,R,n,k,T,A,I,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function w(){return{crypto:Q.__$__nodeRequire("crypto"),zlib:Q.__$__nodeRequire("zlib"),net:Q.__$__nodeRequire("net"),os:Q.__$__nodeRequire("os")}}class m{constructor(u,d=""){this.debugLabel=d,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=v=>{if(this.traceSocketEvent("error",{code:v?.code,message:v?.message}),v){if(v.code==="EPIPE")return;(0,n.onUnexpectedError)(v)}},this.socket.on("error",this._errorListener)}traceSocketEvent(u,d){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,d)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const d=v=>{this.traceSocketEvent("read",v),u(R.VSBuffer.wrap(v))};return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(u){const d=v=>{this.traceSocketEvent("close",{hadError:v}),u({type:0,hadError:v,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(u){const d=()=>{this.traceSocketEvent("nodeEndReceived"),u()};return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(u){if(!this.socket.destroyed)try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,n.onUnexpectedError)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,n.onUnexpectedError)(d)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,d)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const v=()=>{this.socket.off("close",v),this.socket.off("end",v),this.socket.off("error",v),this.socket.off("timeout",v),this.socket.off("drain",v),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",v),this.socket.on("end",v),this.socket.on("error",v),this.socket.on("timeout",v),this.socket.on("drain",v)})}}e.NodeSocket=m;var S;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var h;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(h||(h={}));class y extends T.Disposable{constructor(u,d,v,L){super(),this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:d,inflateBytesLength:v?.byteLength||0,recordInflateBytes:L}),this._flowManager=this._register(new C(this,d,v,L,this._onData,(_,M)=>this._write(_,M))),this._register(this._flowManager.onError(_=>{console.error(_),(0,n.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(u,d){this.socket.traceSocketEvent(u,d)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._flowManager.writeMessage(u)}_write(u,d){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let v=2;u.byteLength<126?v+=0:u.byteLength<2**16?v+=2:v+=8;const L=R.VSBuffer.alloc(v);if(d?L.writeUInt8(194,0):L.writeUInt8(130,0),u.byteLength<126)L.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){L.writeUInt8(126,1);let _=1;L.writeUInt8(u.byteLength>>>8&255,++_),L.writeUInt8(u.byteLength>>>0&255,++_)}else{L.writeUInt8(127,1);let _=1;L.writeUInt8(0,++_),L.writeUInt8(0,++_),L.writeUInt8(0,++_),L.writeUInt8(0,++_),L.writeUInt8(u.byteLength>>>24&255,++_),L.writeUInt8(u.byteLength>>>16&255,++_),L.writeUInt8(u.byteLength>>>8&255,++_),L.writeUInt8(u.byteLength>>>0&255,++_)}this.socket.write(R.VSBuffer.concat([L,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const d=this._incomingData.peek(this._state.readLen),v=d.readUInt8(0),L=(v&128)>>>7,_=(v&64)>>>6,M=d.readUInt8(1),U=(M&128)>>>7,D=M&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(D===126?2:0)+(D===127?8:0),this._state.fin=L,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(_)),this._state.firstFrameOfMessage=Boolean(L),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const d=this._incomingData.read(this._state.readLen),v=d.readUInt8(1),L=(v&128)>>>7;let _=v&127,M=1;_===126?_=d.readUInt8(++M)*2**8+d.readUInt8(++M):_===127&&(_=d.readUInt8(++M)*0+d.readUInt8(++M)*0+d.readUInt8(++M)*0+d.readUInt8(++M)*0+d.readUInt8(++M)*2**24+d.readUInt8(++M)*2**16+d.readUInt8(++M)*2**8+d.readUInt8(++M));let U=0;L&&(U=d.readUInt8(++M)*2**24+d.readUInt8(++M)*2**16+d.readUInt8(++M)*2**8+d.readUInt8(++M)),this._state.state=3,this._state.readLen=_,this._state.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const d=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",d),a(d,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",d),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(d,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=y;class C extends T.Disposable{constructor(u,d,v,L,_,M){super(),this._tracer=u,this._onData=_,this._writeFn=M,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,d?(this._zlibInflateStream=this._register(new p(this._tracer,L,v,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:R.VSBuffer.alloc(0)}writeMessage(u){this._writeQueue.push(u),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const u=this._writeQueue.shift();if(this._zlibDeflateStream){const d=await this._deflateMessage(this._zlibDeflateStream,u);this._writeFn(d,!0)}else this._writeFn(u,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(u,d){return new Promise((v,L)=>{u.write(d),u.flush(_=>v(_))})}acceptFrame(u,d,v){this._readQueue.push({data:u,isCompressed:d,isLastFrameOfMessage:v}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const u=this._readQueue.shift();if(this._zlibInflateStream&&u.isCompressed){const d=await this._inflateFrame(this._zlibInflateStream,u.data,u.isLastFrameOfMessage);this._onData.fire(d)}else this._onData.fire(u.data)}this._isProcessingReadQueue=!1}}_inflateFrame(u,d,v){return new Promise((L,_)=>{u.write(d),v&&u.write(R.VSBuffer.fromByteArray([0,0,255,255])),u.flush(M=>L(M))})}}class p extends T.Disposable{constructor(u,d,v,L){super(),this._tracer=u,this._recordInflateBytes=d,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=w().zlib.createInflateRaw(L),this._zlibInflate.on("error",_=>{this._tracer.traceSocketEvent("zlibInflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibInflate.on("data",_=>{this._tracer.traceSocketEvent("zlibInflateData",_),this._pendingInflateData.push(R.VSBuffer.wrap(_))}),v&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",v.buffer),this._zlibInflate.write(v.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.concat(this._recordedInflateBytes):R.VSBuffer.alloc(0)}write(u){this._recordInflateBytes&&this._recordedInflateBytes.push(u.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",u),this._zlibInflate.write(u.buffer)}flush(u){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const d=R.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,u(d)})}}class g extends T.Disposable{constructor(u,d){super(),this._tracer=u,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=w().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",v=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:v?.message,code:v?.code}),this._onError.fire(v)}),this._zlibDeflate.on("data",v=>{this._tracer.traceSocketEvent("zlibDeflateData",v),this._pendingDeflateData.push(R.VSBuffer.wrap(v))})}write(u){this._tracer.traceSocketEvent("zlibDeflateWrite",u.buffer),this._zlibDeflate.write(u.buffer)}flush(u){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let d=R.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,d=d.slice(0,d.byteLength-4),u(d)})}}function a(l,u){if(u===0)return;const d=l.byteLength>>>2;for(let D=0;D<d;D++){const F=l.readUInt32BE(D*4);l.writeUInt32BE(F^u,D*4)}const v=d*4,L=l.byteLength-v,_=u>>>24&255,M=u>>>16&255,U=u>>>8&255;L>=1&&l.writeUInt8(l.readUInt8(v)^_,v),L>=2&&l.writeUInt8(l.readUInt8(v+1)^M,v+1),L>=3&&l.writeUInt8(l.readUInt8(v+2)^U,v+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const f={[2]:107,[1]:103};function c(){const l=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):u=(0,A.join)(w().os.tmpdir(),`vscode-ipc-${l}.sock`),s(u),u}e.createRandomIPCHandle=c;function i(l,u,d){const v=w().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${v}-${d}-${u}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${v.substr(0,8)}-${d}-${u}.sock`):L=(0,A.join)(l,`${d}-${u}.sock`),s(L),L}e.createStaticIPCHandle=i;function s(l){const u=f[I.platform];typeof u=="number"&&l.length>=u&&console.warn(`WARNING: IPC handle "${l}" is longer than ${u} chars, try a shorter --user-data-dir`)}class t extends P.IPCServer{constructor(u){super(t.toClientConnectionEvent(u)),this.server=u}static toClientConnectionEvent(u){const d=k.Event.fromNodeEventEmitter(u,"connection");return k.Event.map(d,v=>({protocol:new b.Protocol(new m(v,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(v,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function r(l){return new Promise((u,d)=>{const v=w().net.createServer();v.on("error",d),v.listen(l,()=>{v.removeListener("error",d),u(new t(v))})})}e.serve=r;function o(l,u){return new Promise((d,v)=>{const L=w().net.createConnection(l,()=>{L.removeListener("error",v),d(b.Client.fromSocket(new m(L,`ipc-client${u}`),u))});L.once("error",v)})}e.connect=o}),define(ne[87],re([0,1,6,3,2,14]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function I(w){const m=w;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var E;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(E=e.StorageState||(e.StorageState={}));class P extends k.Disposable{constructor(m,S=Object.create(null)){super(),this.database=m,this.options=S,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=E.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(P.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((S,h)=>this.accept(h,S)),m.deleted?.forEach(S=>this.accept(S,void 0))}accept(m,S){if(this.state===E.Closed)return;let h=!1;(0,T.isUndefinedOrNull)(S)?h=this.cache.delete(m):this.cache.get(m)!==S&&(this.cache.set(m,S),h=!0),h&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===E.None&&(this.state=E.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,S){const h=this.cache.get(m);return(0,T.isUndefinedOrNull)(h)?S:h}getBoolean(m,S){const h=this.get(m);return(0,T.isUndefinedOrNull)(h)?S:h==="true"}getNumber(m,S){const h=this.get(m);return(0,T.isUndefinedOrNull)(h)?S:parseInt(h,10)}async set(m,S){if(this.state===E.Closed)return;if((0,T.isUndefinedOrNull)(S))return this.delete(m);const h=String(S);if(this.cache.get(m)!==h)return this.cache.set(m,h),this.pendingInserts.set(m,h),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===E.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=E.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=P,P.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert?.forEach((S,h)=>this.items.set(h,S)),m.delete?.forEach(S=>this.items.delete(S))}async close(){}}e.InMemoryStorageDatabase=b}),define(ne[138],re([11,12]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(ne[139],re([11,12]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[140],re([11,12]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(ne[141],re([11,12]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(ne[142],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[143],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[144],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[145],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[146],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[147],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[148],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[149],re([11,12]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[150],re([11,12]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(ne[151],re([11,12]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ne[152],re([11,12]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(ne[153],re([11,12]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[154],re([11,12]),function(Q,e){return Q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[155],re([11,12]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(ne[156],re([11,12]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(ne[157],re([11,12]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[158],re([11,12]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[159],re([11,12]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ne[160],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[161],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[162],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[163],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[164],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[165],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[166],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[167],re([11,12]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(ne[88],re([0,1,62,61,20,10,36,17,7]),function(Q,e,R,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class P{constructor(y,C,p){this._args=y,this.paths=C,this.productService=p,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,T.dirname)(k.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return E.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return E.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return E.URI.file(this.paths.tmpDir)}get cacheHome(){return E.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const y=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",y)}return this.args.logsPath}get userDataSyncLogResource(){return E.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return E.URI.file((0,T.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(E.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=A.env.VSCODE_PORTABLE;return y?E.URI.file((0,T.join)(y,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return E.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,T.resolve)(y):(0,T.normalize)((0,T.join)(k.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const y=this.args["extensions-download-dir"];return y?(0,T.resolve)(y):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,T.resolve)(y);const C=A.env.VSCODE_EXTENSIONS;if(C)return C;const p=A.env.VSCODE_PORTABLE;return p?(0,T.join)(p,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(C=>/^[^:/?#]+?:\/\//.test(C)?E.URI.parse(C):E.URI.file((0,T.normalize)(C)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?E.URI.parse(y):E.URI.file((0,T.normalize)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(E.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return E.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return E.URI.file((0,T.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const y=A.env.VSCODE_PORTABLE;return y?E.URI.file((0,T.join)(y,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}pe([n.memoize],P.prototype,"appRoot",null),pe([n.memoize],P.prototype,"userHome",null),pe([n.memoize],P.prototype,"userDataPath",null),pe([n.memoize],P.prototype,"appSettingsHome",null),pe([n.memoize],P.prototype,"tmpDir",null),pe([n.memoize],P.prototype,"cacheHome",null),pe([n.memoize],P.prototype,"stateResource",null),pe([n.memoize],P.prototype,"userRoamingDataHome",null),pe([n.memoize],P.prototype,"userDataSyncHome",null),pe([n.memoize],P.prototype,"userDataSyncLogResource",null),pe([n.memoize],P.prototype,"editSessionsLogResource",null),pe([n.memoize],P.prototype,"sync",null),pe([n.memoize],P.prototype,"machineSettingsResource",null),pe([n.memoize],P.prototype,"workspaceStorageHome",null),pe([n.memoize],P.prototype,"localHistoryHome",null),pe([n.memoize],P.prototype,"keyboardLayoutResource",null),pe([n.memoize],P.prototype,"argvResource",null),pe([n.memoize],P.prototype,"isExtensionDevelopment",null),pe([n.memoize],P.prototype,"untitledWorkspacesHome",null),pe([n.memoize],P.prototype,"installSourcePath",null),pe([n.memoize],P.prototype,"builtinExtensionsPath",null),pe([n.memoize],P.prototype,"extensionsPath",null),pe([n.memoize],P.prototype,"extensionDevelopmentLocationURI",null),pe([n.memoize],P.prototype,"extensionDevelopmentKind",null),pe([n.memoize],P.prototype,"extensionTestsLocationURI",null),pe([n.memoize],P.prototype,"debugExtensionHost",null),pe([n.memoize],P.prototype,"serviceMachineIdResource",null),pe([n.memoize],P.prototype,"telemetryLogResource",null),pe([n.memoize],P.prototype,"disableWorkspaceTrust",null),pe([n.memoize],P.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=P;function b(h,y){return S(h["inspect-extensions"],h["inspect-brk-extensions"],5870,y,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=b;function w(h,y){return S(h["inspect-search"],h["inspect-brk-search"],5876,y,h.extensionEnvironment)}e.parseSearchPort=w;function m(h,y){return S(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,y,h.extensionEnvironment)}e.parsePtyHostPort=m;function S(h,y,C,p,g,a){const c=Number(y||h)||(p?null:C),i=c?Boolean(!!y):!1;let s;if(a)try{s=JSON.parse(a)}catch{}return{port:c,break:i,debugId:g,env:s}}}),define(ne[168],re([0,1,271,4,140]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},category:{type:"string",cat:"e",description:(0,k.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(h,y,C=A){const p={},g=["_"],a=[];for(const s in y){const t=y[s];t.alias&&(p[s]=t.alias),t.type==="string"||t.type==="string[]"?(g.push(s),t.deprecates&&g.push(...t.deprecates)):t.type==="boolean"&&(a.push(s),t.deprecates&&a.push(...t.deprecates))}const f=R(h,{string:g,boolean:a,alias:p}),c={},i=f;c._=f._.map(s=>String(s)).filter(s=>s.length>0),delete i._;for(const s in y){const t=y[s];t.alias&&delete i[t.alias];let r=i[s];if(t.deprecates)for(const o of t.deprecates)i.hasOwnProperty(o)&&(r||(r=i[o],r&&C.onDeprecatedOption(o,t.deprecationMessage||(0,k.localize)(35,null,s))),delete i[o]);if(typeof r<"u"){if(t.type==="string[]"){if(Array.isArray(r)||(r=[r]),!t.allowEmptyValue){const o=r.filter(l=>l.length>0);o.length!==r.length&&(C.onEmptyValue(s),r=o.length>0?o:void 0)}}else t.type==="string"&&(Array.isArray(r)?(r=r.pop(),C.onMultipleValues(s,r)):!r&&!t.allowEmptyValue&&(C.onEmptyValue(s),r=void 0));c[s]=r,t.deprecationMessage&&C.onDeprecatedOption(s,t.deprecationMessage)}delete i[s]}for(const s in i)C.onUnknownOption(s);return c}e.parseArgs=I;function E(h,y){let C="";return y.args&&(Array.isArray(y.args)?C=` <${y.args.join("> <")}>`:C=` <${y.args}>`),y.alias?`-${y.alias} --${h}${C}`:`--${h}${C}`}function P(h,y){let C=0;const p=[];for(const c in h){const i=h[c],s=E(c,i);C=Math.max(C,s.length),p.push([s,i.description])}const g=C+2+1;if(y-g<25)return p.reduce((c,i)=>c.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const a=y-g-1,f=[];for(const c of p){const i=c[0],s=w(c[1],a),t=b(g-i.length-2);f.push("  "+i+t+s[0]);for(let r=1;r<s.length;r++)f.push(b(g)+s[r])}return f}e.formatOptions=P;function b(h){return" ".repeat(h)}function w(h,y){const C=[];for(;h.length;){const p=h.length<y?h.length:h.lastIndexOf(" ",y),g=h.slice(0,p).trim();h=h.slice(p),C.push(g)}return C}function m(h,y,C,p,g){const a=process.stdout.isTTY&&process.stdout.columns||80,f=g?.noInputFiles!==!0?`[${(0,k.localize)(36,null)}...]`:"",c=[`${h} ${C}`];c.push(""),c.push(`${(0,k.localize)(37,null)}: ${y} [${(0,k.localize)(38,null)}]${f}`),c.push(""),g?.noPipe!==!0&&(n.isWindows?c.push((0,k.localize)(39,null,y)):c.push((0,k.localize)(40,null,y)),c.push(""));const i={};for(const s in p){const t=p[s];if(t.description&&t.cat){let r=i[t.cat];r||(i[t.cat]=r={}),r[s]=t}}for(const s in i){const t=s,r=i[t];r&&(c.push(T[t]),c.push(...P(r,a)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=m;function S(h,y){return`${h||(0,k.localize)(41,null)}
${y||(0,k.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=S}),define(ne[169],re([0,1,272,141,168]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const T=2048;function A(m,S){const h={onUnknownOption:C=>{console.warn((0,n.localize)(0,null,C))},onMultipleValues:(C,p)=>{console.warn((0,n.localize)(1,null,C,p))},onEmptyValue:C=>{console.warn((0,n.localize)(2,null,C))},onDeprecatedOption:(C,p)=>{console.warn((0,n.localize)(3,null,C,p))}},y=(0,k.parseArgs)(m,k.OPTIONS,S?h:void 0);return y.goto&&y._.forEach(C=>R(/^(\w:)?[^:]+(:\d*){0,2}$/.test(C),(0,n.localize)(4,null))),y["max-memory"]&&R(parseInt(y["max-memory"])>=T,`The max-memory argument cannot be specified lower than ${T} MB.`),y}function I(m){const S=m.findIndex(h=>!/^-/.test(h));if(S>-1)return[...m.slice(0,S),...m.slice(S+1)]}function E(m){let[,...S]=m;process.env.VSCODE_DEV&&(S=I(S)||[]);const h=!w(process.env);return A(S,h)}e.parseMainProcessArgv=E;function P(m){const[,,...S]=m;return A(S,!0)}e.parseCLIProcessArgv=P;function b(m,...S){const h=m.indexOf("--");return h===-1?m.push(...S):m.splice(h,0,...S),m}e.addArg=b;function w(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),function(){"use strict";function Q(e,R,n,k){function T(I){const E=A(I),P=[E];return e.isAbsolute(E)||P.unshift(k),e.resolve(...P)}function A(I){const E=process.env.VSCODE_PORTABLE;if(E)return e.join(E,"user-data");let P=process.env.VSCODE_APPDATA;if(P)return e.join(P,n);const b=I["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(P=process.env.APPDATA,!P){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");P=e.join(w,"AppData","Roaming")}break;case"darwin":P=e.join(R.homedir(),"Library","Application Support");break;case"linux":P=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(P,n)}return{getUserDataPath:T}}if(typeof define=="function")define(ne[170],re([0,273,37,20,17,36]),function(e,R,n,k,T,A){const I=T.dirname(k.FileAccess.asFileUri("",e)),E=e.__$__nodeRequire(T.joinPath(I,"package.json").fsPath);return Q(R,n,E.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),R=require("path"),n=require("os");module.exports=Q(R,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[171],re([0,1,37,88,170]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends n.AbstractNativeEnvironmentService{constructor(I,E){super(I,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,k.getUserDataPath)(I)},E)}}e.NativeEnvironmentService=T}),define(ne[172],re([0,1,7]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,k=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,I=/^\s*url\s*=\s*(.+\S)\s*$/mg,E=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function P(C){const p=C.match(A);return p?p[1]:null}function b(C){if(C.indexOf("://")===-1){const p=C.match(n);return p?P(p[2]):null}try{const p=R.URI.parse(C);if(p.authority)return P(p.authority)}catch{}return null}function w(C,p){const g=new Set;let a;for(;a=I.exec(C);){const c=b(a[1]);c&&g.add(c)}const f=new Set(p);return Array.from(g).map(c=>f.has(c)?c:c.replace(E,"a"))}e.getDomainsOfRemotes=w;function m(C){const p=C.match(T);return p?p[2]:null}function S(C,p,g){return C&&p?(g&&p.endsWith(".git")&&(p=p.substr(0,p.length-4)),p.indexOf("/")===0?`${C}${p}`:`${C}/${p}`):null}function h(C,p){if(C.indexOf("://")===-1){const g=C.match(k);if(g)return S(g[2],g[3],p)}try{const g=R.URI.parse(C);if(g.authority)return S(m(g.authority),g.path,p)}catch{}return null}function y(C,p=!1){const g=[];let a;for(;a=I.exec(C);){const f=h(a[1],p);f&&g.push(f)}return g}e.getRemotes=y}),define(ne[173],re([0,1,14,144]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(A,I,E){try{T(A,I,E)}catch{}return A}e.localizeManifest=k;function T(A,I,E){const P=(b,w,m)=>{const S=b[w];if((0,R.isString)(S)){const h=S,y=h.length;if(y>1&&h[0]==="%"&&h[y-1]==="%"){const C=h.substr(1,y-2);let p=I[C];p===void 0&&E&&(p=E[C]);const g=typeof p=="string"?p:p.message;if(g!==void 0){const a=E?.[C],f=typeof a=="string"?a:a?.message;if(m&&(w==="title"||w==="category")&&f&&f!==g){const c={value:g,original:f};b[w]=c}else b[w]=g}else console.warn(`[${A.name}]: ${(0,n.localize)(0,null,C)}`)}}else if((0,R.isObject)(S))for(const h in S)S.hasOwnProperty(h)&&(h==="commands"?P(S,h,!0):P(S,h,m));else if(Array.isArray(S))for(let h=0;h<S.length;h++)P(S,h,m)};for(const b in A)A.hasOwnProperty(b)&&P(A,b)}}),define(ne[174],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,A,I,E){return this.channel.call("promptImportantExtensionsInstallNotification",[T,A,I,E])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class n{constructor(T){this.service=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,I){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(I[0],I[1],I[2],I[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(ne[66],re([0,1,17,81,149,55]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function E(p){return p=p.trim(),p==="*"||A.test(p)}e.isValidVersionStr=E;function P(p){if(!E(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=p.match(A);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=P;function b(p){if(!p)return null;const g=p.majorBase,a=p.majorMustEqual,f=p.minorBase;let c=p.minorMustEqual;const i=p.patchBase;let s=p.patchMustEqual;p.hasCaret&&(g===0||(c=!1),s=!1);let t=0;if(p.preRelease){const r=I.exec(p.preRelease);if(r){const[,o,l,u]=r;t=Date.UTC(Number(o),Number(l)-1,Number(u))}}return{majorBase:g,majorMustEqual:a,minorBase:f,minorMustEqual:c,patchBase:i,patchMustEqual:s,isMinimum:p.hasGreaterEquals,notBefore:t}}e.normalizeVersion=b;function w(p,g,a){let f;typeof p=="string"?f=b(P(p)):f=p;let c;g instanceof Date?c=g.getTime():typeof g=="string"&&(c=new Date(g).getTime());let i;if(typeof a=="string"?i=b(P(a)):i=a,!f||!i)return!1;const s=f.majorBase,t=f.minorBase,r=f.patchBase;let o=i.majorBase,l=i.minorBase,u=i.patchBase;const d=i.notBefore;let v=i.majorMustEqual,L=i.minorMustEqual,_=i.patchMustEqual;return i.isMinimum?s>o?!0:s<o?!1:t>l?!0:t<l||c&&c<d?!1:r>=u:(s===1&&o===0&&(!v||!L||!_)&&(o=1,l=0,u=0,v=!0,L=!1,_=!1),s<o?!1:s>o?!v:t<l?!1:t>l?!L:r<u?!1:r>u?!_:!(c&&c<d))}e.isValidVersion=w;function m(p,g,a,f,c){const i=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return i.push([n.default.Error,k.localize(0,null)]),i;if(typeof f.name!="string")return i.push([n.default.Error,k.localize(1,null,"name")]),i;if(typeof f.version!="string")return i.push([n.default.Error,k.localize(2,null,"version")]),i;if(!f.engines)return i.push([n.default.Error,k.localize(3,null,"engines")]),i;if(typeof f.engines.vscode!="string")return i.push([n.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof f.extensionDependencies<"u"&&!C(f.extensionDependencies))return i.push([n.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof f.activationEvents<"u"){if(!C(f.activationEvents))return i.push([n.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof f.main>"u"&&typeof f.browser>"u")return i.push([n.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&i.push([n.default.Warning,k.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return i.push([n.default.Error,k.localize(9,null,"main")]),i;{const r=(0,R.joinPath)(a,f.main);(0,R.isEqualOrParent)(r,a)||i.push([n.default.Warning,k.localize(10,null,r.path,a.path)])}if(typeof f.activationEvents>"u")return i.push([n.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof f.browser<"u"){if(typeof f.browser!="string")return i.push([n.default.Error,k.localize(12,null,"browser")]),i;{const r=(0,R.joinPath)(a,f.browser);(0,R.isEqualOrParent)(r,a)||i.push([n.default.Warning,k.localize(13,null,r.path,a.path)])}if(typeof f.activationEvents>"u")return i.push([n.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!T.valid(f.version))return i.push([n.default.Error,k.localize(15,null)]),i;const s=[];if(!S(p,g,f,c,s))for(const r of s)i.push([n.default.Error,r]);return i}e.validateExtensionManifest=m;function S(p,g,a,f,c){return f||typeof a.main>"u"&&typeof a.browser>"u"?!0:y(p,g,a.engines.vscode,c)}e.isValidExtensionVersion=S;function h(p,g,a){return p==="*"||y(g,a,p)}e.isEngineValid=h;function y(p,g,a,f=[]){const c=b(P(a));if(!c)return f.push(k.localize(16,null,a)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return f.push(k.localize(17,null,a)),!1}else if(!c.majorMustEqual)return f.push(k.localize(18,null,a)),!1;return w(p,g,c)?!0:(f.push(k.localize(19,null,p,a)),!1)}function C(p){if(!Array.isArray(p))return!1;for(let g=0,a=p.length;g<a;g++)if(typeof p[g]!="string")return!1;return!0}}),define(ne[47],re([0,1,16,30]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(T,A,I){let E=I&&I.get("storage.serviceMachineId",-1)||null;if(E)return E;try{const b=(await A.readFile(T.serviceMachineIdResource)).value.toString();E=(0,n.isUUID)(b)?b:null}catch{E=null}if(!E){E=(0,n.generateUuid)();try{await A.writeFile(T.serviceMachineIdResource,R.VSBuffer.fromString(E))}catch{}}return I?.store("storage.serviceMachineId",E,-1,1),E}e.getServiceMachineId=k}),define(ne[56],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(k,T=[],A=!1){this.ctor=k,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=R}),define(ne[89],re([0,1,56]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const n=[];var k;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function T(I,E,P){E instanceof R.SyncDescriptor||(E=new R.SyncDescriptor(E,[],Boolean(P))),n.push([I,E])}e.registerSingleton=T;function A(){return n}e.getSingletonServiceDescriptors=A}),define(ne[175],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(T,A){this.key=T,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=R;class n{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(const A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const I=this.lookupOrInsertNode(T),E=this.lookupOrInsertNode(A);I.outgoing.set(E.key,E),E.incoming.set(I.key,I)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(const I of this._nodes.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let I=this._nodes.get(A);return I||(I=new R(A,T),this._nodes.set(A,I)),I}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){const T=[];for(const[A,I]of this._nodes)T.push(`${A}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,A]of this._nodes){const I=new Set([T]),E=this._findCycle(A,I);if(E)return E}}_findCycle(T,A){for(const[I,E]of T.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const P=this._findCycle(E,A);if(P)return P;A.delete(I)}}}e.Graph=n}),define(ne[5],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function I(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=I})(R=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function n(A,I,E){I[R.DI_TARGET]===I?I[R.DI_DEPENDENCIES].push({id:A,index:E}):(I[R.DI_DEPENDENCIES]=[{id:A,index:E}],I[R.DI_TARGET]=I)}function k(A){if(R.serviceIds.has(A))return R.serviceIds.get(A);const I=function(E,P,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(I,E,b)};return I.toString=()=>A,R.serviceIds.set(A,I),I}e.createDecorator=k;function T(A){return A}e.refineServiceDecorator=T}),define(ne[176],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(ne[19],re([0,1,14,7,5]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function T(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof n.URI)}e.isConfigurationOverrides=T;function A(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=A;var I;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(p){switch(p){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function P(p,g){const a=Object.create(null);for(const f in p)b(a,f,p[f],g);return a}e.toValuesTree=P;function b(p,g,a,f){const c=g.split("."),i=c.pop();let s=p;for(let t=0;t<c.length;t++){const r=c[t];let o=s[r];switch(typeof o){case"undefined":o=s[r]=Object.create(null);break;case"object":break;default:f(`Ignoring ${g} as ${c.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}s=o}if(typeof s=="object"&&s!==null)try{s[i]=a}catch{f(`Ignoring ${g} as ${c.join(".")} is ${JSON.stringify(s)}`)}else f(`Ignoring ${g} as ${c.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=b;function w(p,g){const a=g.split(".");m(p,a)}e.removeFromValueTree=w;function m(p,g){const a=g.shift();if(g.length===0){delete p[a];return}if(Object.keys(p).indexOf(a)!==-1){const f=p[a];typeof f=="object"&&!Array.isArray(f)&&(m(f,g),Object.keys(f).length===0&&delete p[a])}}function S(p,g,a){function f(s,t){let r=s;for(const o of t){if(typeof r!="object"||r===null)return;r=r[o]}return r}const c=g.split("."),i=f(p,c);return typeof i>"u"?a:i}e.getConfigurationValue=S;function h(p,g,a){Object.keys(g).forEach(f=>{f!=="__proto__"&&(f in p?R.isObject(p[f])&&R.isObject(g[f])?h(p[f],g[f],a):a&&(p[f]=g[f]):p[f]=g[f])})}e.merge=h;function y(p,g,a){const f=p.inspect(g),c=p.inspect(a);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:f.defaultValue}e.getMigratedSettingValue=y;function C(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=C}),define(ne[177],re([0,1,4,24,5]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",R.isMacintosh),T.set("isLinux",R.isLinux),T.set("isWindows",R.isWindows),T.set("isWeb",R.isWeb),T.set("isMacNative",R.isMacintosh&&!R.isWeb),T.set("isEdge",R.isEdge),T.set("isFirefox",R.isFirefox),T.set("isChrome",R.isChrome),T.set("isSafari",R.isSafari);const A=Object.prototype.hasOwnProperty;var I;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return w.INSTANCE}static true(){return m.INSTANCE}static has(D){return S.create(D)}static equals(D,F){return h.create(D,F)}static notEquals(D,F){return p.create(D,F)}static regex(D,F){return t.create(D,F)}static in(D,F){return y.create(D,F)}static notIn(D,F){return C.create(D,F)}static not(D){return g.create(D)}static and(...D){return l.create(D,null)}static or(...D){return u.create(D,null,!0)}static greater(D,F){return f.create(D,F)}static greaterEquals(D,F){return c.create(D,F)}static smaller(D,F){return i.create(D,F)}static smallerEquals(D,F){return s.create(D,F)}static deserialize(D,F=!1){if(!!D)return this._deserializeOrExpression(D,F)}static _deserializeOrExpression(D,F){const $=D.split("||");return u.create($.map(j=>this._deserializeAndExpression(j,F)),null,!0)}static _deserializeAndExpression(D,F){const $=D.split("&&");return l.create($.map(j=>this._deserializeOne(j,F)),null)}static _deserializeOne(D,F){if(D=D.trim(),D.indexOf("!=")>=0){const $=D.split("!=");return p.create($[0].trim(),this._deserializeValue($[1],F))}if(D.indexOf("==")>=0){const $=D.split("==");return h.create($[0].trim(),this._deserializeValue($[1],F))}if(D.indexOf("=~")>=0){const $=D.split("=~");return t.create($[0].trim(),this._deserializeRegexValue($[1],F))}if(D.indexOf(" not in ")>=0){const $=D.split(" not in ");return C.create($[0].trim(),$[1].trim())}if(D.indexOf(" in ")>=0){const $=D.split(" in ");return y.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const $=D.split(">=");return c.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const $=D.split(">");return f.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const $=D.split("<=");return s.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const $=D.split("<");return i.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(D)?g.create(D.substr(1).trim()):S.create(D)}static _deserializeValue(D,F){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;const $=/^'([^']*)'$/.exec(D);return $?$[1].trim():D}static _deserializeRegexValue(D,F){if((0,n.isFalsyOrWhitespace)(D)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=D.indexOf("/"),j=D.lastIndexOf("/");if($===j||$<0){if(F)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}const J=D.slice($+1,j),H=D[j+1]==="i"?"i":"";try{return new RegExp(J,H)}catch(K){if(F)throw new Error(`bad regexp-value '${D}', parse error: ${K}`);return console.warn(`bad regexp-value '${D}', parse error: ${K}`),null}}}e.ContextKeyExpr=E;function P(U,D){const F=U?U.substituteConstants():void 0,$=D?D.substituteConstants():void 0;return!F&&!$?!0:!F||!$?!1:F.equals($)}e.expressionsAreEqualWithConstantSubstitution=P;function b(U,D){return U.cmp(D)}class w{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class m{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class S{constructor(D,F){this.key=D,this.negated=F,this.type=2}static create(D,F=null){const $=T.get(D);return typeof $=="boolean"?$?m.INSTANCE:w.INSTANCE:new S(D,F)}cmp(D){return D.type!==this.type?this.type-D.type:v(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=T.get(this.key);return typeof D=="boolean"?D?m.INSTANCE:w.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=S;class h{constructor(D,F,$){this.key=D,this.value=F,this.negated=$,this.type=4}static create(D,F,$=null){if(typeof F=="boolean")return F?S.create(D,$):g.create(D,$);const j=T.get(D);return typeof j=="boolean"?F===(j?"true":"false")?m.INSTANCE:w.INSTANCE:new h(D,F,$)}cmp(D){return D.type!==this.type?this.type-D.type:L(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=T.get(this.key);if(typeof D=="boolean"){const F=D?"true":"false";return this.value===F?m.INSTANCE:w.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class y{constructor(D,F){this.key=D,this.valueKey=F,this.type=10,this.negated=null}static create(D,F){return new y(D,F)}cmp(D){return D.type!==this.type?this.type-D.type:L(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const F=D.getValue(this.valueKey),$=D.getValue(this.key);return Array.isArray(F)?F.includes($):typeof $=="string"&&typeof F=="object"&&F!==null?A.call(F,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=C.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=y;class C{constructor(D,F){this.key=D,this.valueKey=F,this.type=11,this._negated=y.create(D,F)}static create(D,F){return new C(D,F)}cmp(D){return D.type!==this.type?this.type-D.type:this._negated.cmp(D._negated)}equals(D){return D.type===this.type?this._negated.equals(D._negated):!1}substituteConstants(){return this}evaluate(D){return!this._negated.evaluate(D)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(D){return D.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=C;class p{constructor(D,F,$){this.key=D,this.value=F,this.negated=$,this.type=5}static create(D,F,$=null){if(typeof F=="boolean")return F?g.create(D,$):S.create(D,$);const j=T.get(D);return typeof j=="boolean"?F===(j?"true":"false")?w.INSTANCE:m.INSTANCE:new p(D,F,$)}cmp(D){return D.type!==this.type?this.type-D.type:L(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=T.get(this.key);if(typeof D=="boolean"){const F=D?"true":"false";return this.value===F?w.INSTANCE:m.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=p;class g{constructor(D,F){this.key=D,this.negated=F,this.type=3}static create(D,F=null){const $=T.get(D);return typeof $=="boolean"?$?w.INSTANCE:m.INSTANCE:new g(D,F)}cmp(D){return D.type!==this.type?this.type-D.type:v(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=T.get(this.key);return typeof D=="boolean"?D?w.INSTANCE:m.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function a(U,D){if(typeof U=="string"){const F=parseFloat(U);isNaN(F)||(U=F)}return typeof U=="string"||typeof U=="number"?D(U):w.INSTANCE}class f{constructor(D,F,$){this.key=D,this.value=F,this.negated=$,this.type=12}static create(D,F,$=null){return a(F,j=>new f(D,j,$))}cmp(D){return D.type!==this.type?this.type-D.type:L(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=f;class c{constructor(D,F,$){this.key=D,this.value=F,this.negated=$,this.type=13}static create(D,F,$=null){return a(F,j=>new c(D,j,$))}cmp(D){return D.type!==this.type?this.type-D.type:L(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class i{constructor(D,F,$){this.key=D,this.value=F,this.negated=$,this.type=14}static create(D,F,$=null){return a(F,j=>new i(D,j,$))}cmp(D){return D.type!==this.type?this.type-D.type:L(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class s{constructor(D,F,$){this.key=D,this.value=F,this.negated=$,this.type=15}static create(D,F,$=null){return a(F,j=>new s(D,j,$))}cmp(D){return D.type!==this.type?this.type-D.type:L(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=s;class t{constructor(D,F){this.key=D,this.regexp=F,this.type=7,this.negated=null}static create(D,F){return new t(D,F)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const F=this.regexp?this.regexp.source:"",$=D.regexp?D.regexp.source:"";return F<$?-1:F>$?1:0}equals(D){if(D.type===this.type){const F=this.regexp?this.regexp.source:"",$=D.regexp?D.regexp.source:"";return this.key===D.key&&F===$}return!1}substituteConstants(){return this}evaluate(D){const F=D.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class r{constructor(D){this._actual=D,this.type=8}static create(D){return new r(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new r(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;function o(U){let D=null;for(let F=0,$=U.length;F<$;F++){const j=U[F].substituteConstants();if(U[F]!==j&&D===null){D=[];for(let J=0;J<F;J++)D[J]=U[J]}D!==null&&(D[F]=j)}return D===null?U:D}class l{constructor(D,F){this.expr=D,this.negated=F,this.type=6}static create(D,F){return l._normalizeArr(D,F)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let F=0,$=this.expr.length;F<$;F++){const j=b(this.expr[F],D.expr[F]);if(j!==0)return j}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let F=0,$=this.expr.length;F<$;F++)if(!this.expr[F].equals(D.expr[F]))return!1;return!0}return!1}substituteConstants(){const D=o(this.expr);return D===this.expr?this:l.create(D,this.negated)}evaluate(D){for(let F=0,$=this.expr.length;F<$;F++)if(!this.expr[F].evaluate(D))return!1;return!0}static _normalizeArr(D,F){const $=[];let j=!1;for(const J of D)if(!!J){if(J.type===1){j=!0;continue}if(J.type===0)return w.INSTANCE;if(J.type===6){$.push(...J.expr);continue}$.push(J)}if($.length===0&&j)return m.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(b);for(let J=1;J<$.length;J++)$[J-1].equals($[J])&&($.splice(J,1),J--);if($.length===1)return $[0];for(;$.length>1;){const J=$[$.length-1];if(J.type!==9)break;$.pop();const H=$.pop(),K=$.length===0,q=u.create(J.expr.map(B=>l.create([B,H],null)),null,K);q&&($.push(q),$.sort(b))}return $.length===1?$[0]:new l($,F)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const F of this.expr)D.push(...F.keys());return D}map(D){return new l(this.expr.map(F=>F.map(D)),null)}negate(){if(!this.negated){const D=[];for(const F of this.expr)D.push(F.negate());this.negated=u.create(D,this,!0)}return this.negated}}class u{constructor(D,F){this.expr=D,this.negated=F,this.type=9}static create(D,F,$){return u._normalizeArr(D,F,$)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let F=0,$=this.expr.length;F<$;F++){const j=b(this.expr[F],D.expr[F]);if(j!==0)return j}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let F=0,$=this.expr.length;F<$;F++)if(!this.expr[F].equals(D.expr[F]))return!1;return!0}return!1}substituteConstants(){const D=o(this.expr);return D===this.expr?this:u.create(D,this.negated,!1)}evaluate(D){for(let F=0,$=this.expr.length;F<$;F++)if(this.expr[F].evaluate(D))return!0;return!1}static _normalizeArr(D,F,$){let j=[],J=!1;if(D){for(let H=0,K=D.length;H<K;H++){const q=D[H];if(!!q){if(q.type===0){J=!0;continue}if(q.type===1)return m.INSTANCE;if(q.type===9){j=j.concat(q.expr);continue}j.push(q)}}if(j.length===0&&J)return w.INSTANCE;j.sort(b)}if(j.length!==0){if(j.length===1)return j[0];for(let H=1;H<j.length;H++)j[H-1].equals(j[H])&&(j.splice(H,1),H--);if(j.length===1)return j[0];if($){for(let H=0;H<j.length;H++)for(let K=H+1;K<j.length;K++)_(j[H],j[K])&&(j.splice(K,1),K--);if(j.length===1)return j[0]}return new u(j,F)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const F of this.expr)D.push(...F.keys());return D}map(D){return new u(this.expr.map(F=>F.map(D)),null)}negate(){if(!this.negated){const D=[];for(const F of this.expr)D.push(F.negate());for(;D.length>1;){const F=D.shift(),$=D.shift(),j=[];for(const H of M(F))for(const K of M($))j.push(l.create([H,K],null));const J=D.length===0;D.unshift(u.create(j,null,J))}this.negated=D[0]}return this.negated}}class d extends S{constructor(D,F,$){super(D,null),this._defaultValue=F,typeof $=="object"?d._info.push({...$,key:D}):$!==!0&&d._info.push({key:D,description:$,type:F!=null?typeof F:void 0})}static all(){return d._info.values()}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return h.create(this.key,D)}notEqualsTo(D){return p.create(this.key,D)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(U,D){return U<D?-1:U>D?1:0}function L(U,D,F,$){return U<F?-1:U>F?1:D<$?-1:D>$?1:0}function _(U,D){if(D.type===6&&U.type!==9&&U.type!==6){for(const j of D.expr)if(U.equals(j))return!0}const F=U.negate(),$=M(F).concat(M(D));$.sort(b);for(let j=0;j<$.length;j++){const H=$[j].negate();for(let K=j+1;K<$.length;K++){const q=$[K];if(H.equals(q))return!0}}return!1}e.implies=_;function M(U){return U.type===9?U.expr:[U]}}),define(ne[90],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function n(T){return!!T.hostName&&!!T.errorMessage}e.isRemoteDiagnosticError=n;class k{async getPerformanceInfo(A,I){return{}}async getSystemInfo(A,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,I){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=k}),define(ne[91],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(ne[15],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[29],re([0,1,143,5]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function T(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function A(p,g){switch(p){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function I(p,g){return g==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function E(p,g,a){return I(g,a)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===a?!0:P(a).includes(p)}e.isTargetPlatformCompatible=E;function P(p){switch(p){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function b(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=b;var w;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var m;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var S;(function(p){p.Install="install",p.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var h;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,n.createDecorator)("extensionGalleryService");var y;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatiblePreRelease="IncompatiblePreRelease",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.Extract="Extract",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Internal="Internal"})(y=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class C extends Error{constructor(g,a){super(g),this.code=a,this.name=a}}e.ExtensionManagementError=C,e.IExtensionManagementService=(0,n.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,n.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,n.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,R.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,R.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ne[178],re([0,1,3,2,64,31,7,130,29]),function(Q,e,R,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(C,p){return A.URI.revive(p?p.transformIncoming(C):C)}function b(C,p){return p?p.transformOutgoingURI(C):C}function w(C,p){p=p||I.DefaultURITransformer;const g=C.manifest;return{...(0,I.transformAndReviveIncomingURIs)({...C,manifest:void 0},p),manifest:g}}function m(C,p){return p?(0,T.cloneAndChange)(C,g=>g instanceof A.URI?p.transformOutgoingURI(g):void 0):C}class S{constructor(p,g){this.service=p,this.getUriTransformer=g,this.onInstallExtension=R.Event.buffer(p.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(p.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(p.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(p.onDidUninstallExtension,!0)}listen(p,g){const a=this.getUriTransformer(p);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,f=>f.map(c=>({...c,local:c.local?m(c.local,a):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(p,g,a){const f=this.getUriTransformer(p);switch(g){case"zip":return this.service.zip(w(a[0],f)).then(c=>b(c,f));case"unzip":return this.service.unzip(P(a[0],f));case"install":return this.service.install(P(a[0],f),(0,k.revive)(a[1]));case"getManifest":return this.service.getManifest(P(a[0],f));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(a[0]);case"installFromGallery":return this.service.installFromGallery(a[0],(0,k.revive)(a[1]));case"uninstall":return this.service.uninstall(w(a[0],f),(0,k.revive)(a[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(w(a[0],f));case"getInstalled":return this.service.getInstalled(a[0],A.URI.revive(a[1])).then(c=>c.map(i=>m(i,f)));case"getMetadata":return this.service.getMetadata(w(a[0],f));case"updateMetadata":return this.service.updateMetadata(w(a[0],f),a[1]).then(c=>m(c,f));case"updateExtensionScope":return this.service.updateExtensionScope(w(a[0],f),a[1]).then(c=>m(c,f));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=S;class h extends n.Disposable{constructor(p){super(),this.channel=p,this._onInstallExtension=this._register(new R.Emitter),this._onDidInstallExtensions=this._register(new R.Emitter),this._onUninstallExtension=this._register(new R.Emitter),this._onDidUninstallExtension=this._register(new R.Emitter),this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?A.URI.revive(g.source):g.source,profileLocation:A.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(a=>({...a,local:a.local?w(a.local,null):a.local,source:this.isUriComponents(a.source)?A.URI.revive(a.source):a.source,profileLocation:A.URI.revive(a.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire({identifier:g.identifier,profileLocation:A.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire({...g,profileLocation:A.URI.revive(g.profileLocation)})))}get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}isUriComponents(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(p){const g=await this.getTargetPlatform();return p.allTargetPlatforms.some(a=>(0,E.isTargetPlatformCompatible)(a,p.allTargetPlatforms,g))}zip(p){return Promise.resolve(this.channel.call("zip",[p]).then(g=>A.URI.revive(g)))}unzip(p){return Promise.resolve(this.channel.call("unzip",[p]))}install(p,g){return Promise.resolve(this.channel.call("install",[p,g])).then(a=>w(a,null))}getManifest(p){return Promise.resolve(this.channel.call("getManifest",[p]))}installFromGallery(p,g){return Promise.resolve(this.channel.call("installFromGallery",[p,g])).then(a=>w(a,null))}uninstall(p,g){return Promise.resolve(this.channel.call("uninstall",[p,g]))}reinstallFromGallery(p){return Promise.resolve(this.channel.call("reinstallFromGallery",[p]))}getInstalled(p=null,g){return Promise.resolve(this.channel.call("getInstalled",[p,g])).then(a=>a.map(f=>w(f,null)))}getMetadata(p){return Promise.resolve(this.channel.call("getMetadata",[p]))}updateMetadata(p,g){return Promise.resolve(this.channel.call("updateMetadata",[p,g])).then(a=>w(a,null))}updateExtensionScope(p,g){return Promise.resolve(this.channel.call("updateExtensionScope",[p,g])).then(a=>w(a,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class y{constructor(p){this.service=p}listen(p,g){throw new Error("Invalid listen")}call(p,g,a){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(a[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=y}),define(ne[92],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function k(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=k;var T;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[13],re([0,1,34,10,24,14,7,151,5]),function(Q,e,R,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function P(H){return H.create===!0}e.isFileOpenForWriteOptions=P;var b;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var w;(function(H){H[H.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var m;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function S(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=S;function h(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=h;function y(H){return!!(H.capabilities&32768)}e.hasFileCloneCapability=y;function C(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function p(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=p;function g(H){return S(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var a;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(a=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(K,q){super(K),this.code=q}}e.FileSystemProviderError=f;function c(H,K){const q=new f(H.toString(),K);return s(q,K),q}e.createFileSystemProviderError=c;function i(H){return H||c((0,I.localize)(0,null),a.Unknown)}e.ensureFileSystemProviderError=i;function s(H,K){return H.name=K?`${K} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=s;function t(H){if(!H)return a.Unknown;if(H instanceof f)return H.code;const K=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!K)return a.Unknown;switch(K[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileExceedsMemoryLimit:return a.FileExceedsMemoryLimit;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.toFileSystemProviderErrorCode=t;function r(H){if(H instanceof L)return H.fileOperationResult;switch(t(H)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 10;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileExceedsMemoryLimit:return 9;case a.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var o;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class l{constructor(K,q,B){this.resource=K,this.operation=q,this.target=B}isOperation(K){return this.operation===K}}e.FileOperationEvent=l;var u;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class d{constructor(K,q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=K;const B=new Map;for(const Y of K){const te=B.get(Y.type);switch(te?te.push([Y.resource,Y]):B.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,te]of B)switch(Y){case 1:this.added=R.TernarySearchTree.forUris(()=>q),this.added.fill(te);break;case 0:this.updated=R.TernarySearchTree.forUris(()=>q),this.updated.fill(te);break;case 2:this.deleted=R.TernarySearchTree.forUris(()=>q),this.deleted.fill(te);break}}contains(K,...q){return this.doContains(K,{includeChildren:!1},...q)}affects(K,...q){return this.doContains(K,{includeChildren:!0},...q)}doContains(K,q,...B){if(!K)return!1;const Y=B.length>0;return!!((!Y||B.includes(1))&&(this.added?.get(K)||q.includeChildren&&this.added?.findSuperstr(K))||(!Y||B.includes(0))&&(this.updated?.get(K)||q.includeChildren&&this.updated?.findSuperstr(K))||(!Y||B.includes(2))&&(this.deleted?.findSubstr(K)||q.includeChildren&&this.deleted?.findSuperstr(K)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=d;function v(H,K,q){return!H||!K||H===K||K.length>H.length?!1:(K.charAt(K.length-1)!==n.sep&&(K+=n.sep),q?(0,k.startsWithIgnoreCase)(H,K):H.indexOf(K)===0)}e.isParent=v;class L extends Error{constructor(K,q,B){super(K),this.fileOperationResult=q,this.options=B}}e.FileOperationError=L;class _ extends L{constructor(K,q,B){super(K,2,B),this.stat=q}}e.NotModifiedSinceFileOperationError=_;var M;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function D(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=D;async function F(H,K){if(!K.hasProvider(A.URI.from({scheme:H.scheme})))return new Promise(q=>{const B=K.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===H.scheme&&Y.added&&(B.dispose(),q())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(K){return(0,T.isNumber)(K)||(K=0),K<$.KB?(0,I.localize)(1,null,K.toFixed(0)):K<$.MB?(0,I.localize)(2,null,(K/$.KB).toFixed(2)):K<$.GB?(0,I.localize)(3,null,(K/$.MB).toFixed(2)):K<$.TB?(0,I.localize)(4,null,(K/$.GB).toFixed(2)):(0,I.localize)(5,null,(K/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var j;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function J(H){return{maxFileSize:H===0?300*$.MB:16*$.GB,maxHeapSize:H===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=J});var G=this&&this.__param||function(Q,e){return function(R,n){e(R,n,Q)}};define(ne[179],re([0,1,93,41,13]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(I){this.fileService=I}async checksum(I){const E=(await this.fileService.readFileStream(I)).value;return new Promise((P,b)=>{const w=(0,R.createHash)("md5");(0,n.listenStream)(E,{onData:m=>w.update(m.buffer),onError:m=>b(m),onEnd:()=>P(w.digest("base64").replace(/=+$/,""))})})}};T=pe([G(0,k.IFileService)],T),e.ChecksumService=T}),define(ne[180],re([0,1,16,38,9,3,2,41,7,30,13]),function(Q,e,R,n,k,T,A,I,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class w extends A.Disposable{constructor(S,h){super(),this.channel=S,this.extraCapabilities=h,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,P.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(S){return this.channel.call("stat",[S])}readdir(S){return this.channel.call("readdir",[S])}async readFile(S,h){const{buffer:y}=await this.channel.call("readFile",[S,h]);return y}readFileStream(S,h,y){const C=(0,I.newWriteableStream)(g=>R.VSBuffer.concat(g.map(a=>R.VSBuffer.wrap(a))).buffer),p=this.channel.listen("readFileStream",[S,h])(g=>{if(g instanceof R.VSBuffer)C.write(g.buffer);else{if(g==="end")C.end();else{let a=g;a instanceof Error||(a=(0,b.createFileSystemProviderError)((0,n.toErrorMessage)(a),b.FileSystemProviderErrorCode.Unknown)),C.error(a),C.end()}p.dispose()}});return y.onCancellationRequested(()=>{C.error((0,k.canceled)()),C.end(),p.dispose()}),C}writeFile(S,h,y){return this.channel.call("writeFile",[S,R.VSBuffer.wrap(h),y])}open(S,h){return this.channel.call("open",[S,h])}close(S){return this.channel.call("close",[S])}async read(S,h,y,C,p){const[g,a]=await this.channel.call("read",[S,h,p]);return y.set(g.buffer.slice(0,a),C),a}write(S,h,y,C,p){return this.channel.call("write",[S,h,R.VSBuffer.wrap(y),C,p])}mkdir(S){return this.channel.call("mkdir",[S])}delete(S,h){return this.channel.call("delete",[S,h])}rename(S,h,y){return this.channel.call("rename",[S,h,y])}copy(S,h,y){return this.channel.call("copy",[S,h,y])}cloneFile(S,h){return this.channel.call("cloneFile",[S,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(S=>{if(Array.isArray(S)){const h=S;this._onDidChange.fire(h.map(y=>({resource:E.URI.revive(y.resource),type:y.type})))}else{const h=S;this._onDidWatchError.fire(h)}}))}watch(S,h){const y=(0,P.generateUuid)();return this.channel.call("watch",[this.sessionId,y,S,h]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,y]))}}e.DiskFileSystemProviderClient=w}),define(ne[94],re([0,1,16,9,152,13]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(b,w,m,S,h,y){let C;try{await I(b,w,m,S,h,y)}catch(p){C=p}finally{C&&h.errorTransformer&&(C=h.errorTransformer(C)),typeof C<"u"&&m.error(C),m.end()}}e.readFileIntoStream=A;async function I(b,w,m,S,h,y){E(y);const C=await b.open(w,{create:!1});try{E(y);let p=0,g=0,a=h&&typeof h.length=="number"?h.length:void 0,f=R.VSBuffer.alloc(Math.min(h.bufferSize,typeof a=="number"?a:h.bufferSize)),c=h&&typeof h.position=="number"?h.position:0,i=0;do g=await b.read(C,c,f.buffer,i,f.byteLength-i),c+=g,i+=g,p+=g,typeof a=="number"&&(a-=g),i===f.byteLength&&(await m.write(S(f)),f=R.VSBuffer.alloc(Math.min(h.bufferSize,typeof a=="number"?a:h.bufferSize)),i=0);while(g>0&&(typeof a!="number"||a>0)&&E(y)&&P(p,h));if(i>0){let s=i;typeof a=="number"&&(s=Math.min(i,a)),m.write(S(f.slice(0,s)))}}catch(p){throw(0,T.ensureFileSystemProviderError)(p)}finally{await b.close(C)}}function E(b){if(b.isCancellationRequested)throw(0,n.canceled)();return!0}function P(b,w){if(w?.limits){if(typeof w.limits.memory=="number"&&b>w.limits.memory)throw(0,T.createFileSystemProviderError)((0,k.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&b>w.limits.size)throw(0,T.createFileSystemProviderError)((0,k.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[57],re([0,1,82,2,10,4,7,13]),function(Q,e,R,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function E(p){return p.recursive===!0}e.isRecursiveWatchRequest=E;class P extends n.Disposable{constructor(g,a,f,c){super(),this.onFileChanges=g,this.onLogMessage=a,this.verboseLogging=f,this.options=c,this.watcherDisposables=this._register(new n.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new n.DisposableStore;this.watcherDisposables.value=g,this.watcher=this.createWatcher(g),this.watcher.setVerboseLogging(this.verboseLogging),g.add(this.watcher.onDidChangeFile(a=>this.onFileChanges(a))),g.add(this.watcher.onDidLogMessage(a=>this.onLogMessage(a))),g.add(this.watcher.onDidError(a=>this.onError(a)))}onError(g){this.options.restartOnError?this.restartCounter<P.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`):this.error(g)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.watcher?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.watcher?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${g}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=P,P.MAX_RESTARTS=5;class b extends P{constructor(g,a,f){super(g,a,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class w extends P{constructor(g,a,f){super(g,a,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=w;function m(p){return p.map(g=>({type:g.type,resource:A.URI.file(g.path)}))}e.toFileChanges=m;function S(p){const g=new C;for(const a of p)g.processEvent(a);return g.coalesce()}e.coalesceEvents=S;function h(p,g){return typeof g=="string"&&!g.startsWith(R.GLOBSTAR)&&!(0,k.isAbsolute)(g)?{base:p,pattern:g}:g}e.normalizeWatcherPattern=h;function y(p,g){const a=[];for(const f of g)a.push((0,R.parse)(h(p,f)));return a}e.parseWatcherPatterns=y;class C{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return T.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const a=this.mapPathToChange.get(this.toKey(g));let f=!1;if(a){const c=a.type,i=g.type;a.path!==g.path&&(g.type===2||g.type===1)?f=!0:c===1&&i===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(a)):c===2&&i===1?a.type=0:c===1&&i===0||(a.type=i)}else f=!0;f&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],a=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(g.push(f),!1):!0).sort((f,c)=>f.path.length-c.path.length).filter(f=>a.some(c=>(0,I.isParent)(f.path,c,!T.isLinux))?!1:(a.push(f.path),!0)).concat(g)}}}),define(ne[181],re([0,1,53,6,21,46,2,80,10,4,132,27,57]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class S extends A.Disposable{constructor(C,p,g,a){super(),this.request=C,this.onDidFilesChange=p,this.onLogMessage=g,this.verboseLogging=a,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.onDidFilesChange(f)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(S.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,m.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,m.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const C=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await w.Promises.stat(C);this._register(await this.doWatch(C,p.isDirectory()))}catch(C){C.code!=="ENOENT"?this.error(C):this.trace(C)}}async normalizePath(C){let p=C.path;try{p=await w.Promises.realpath(C.path),C.path===p&&(p=await(0,b.realcase)(C.path)??C.path),C.path!==p&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${C.path}, real: ${p})`)}catch{}return p}async doWatch(C,p){if(P.isMacintosh&&(0,T.isEqualOrParent)(C,"/Volumes/",!0))return this.error(`Refusing to watch ${C} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const g=new k.CancellationTokenSource(this.cts.token),a=new A.DisposableStore;try{const f=(0,E.basename)(C),c=(0,R.watch)(C);a.add((0,A.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${C}'`);const i=new Set;if(p)try{for(const t of await w.Promises.readdir(C))i.add(t)}catch(t){this.error(t)}const s=new Map;a.add((0,A.toDisposable)(()=>{for(const[,t]of s)t.dispose();s.clear()})),c.on("error",(t,r)=>{this.error(`Failed to watch ${C} for changes using fs.watch() (${t}, ${r})`),this.dispose()}),c.on("change",(t,r)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${r}`);let o="";if(r&&(o=r.toString(),P.isMacintosh&&(o=(0,I.normalizeNFC)(o))),!(!o||t!=="change"&&t!=="rename"))if(p)if(t==="rename"){s.get(o)?.dispose();const l=setTimeout(async()=>{if(s.delete(o),o===f&&!await w.Promises.exists(C)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.existsChildStrictCase((0,E.join)(C,o));if(g.token.isCancellationRequested)return;let d;u?i.has(o)?d=0:(d=1,i.add(o)):(i.delete(o),d=2),this.onFileChange({path:(0,E.join)(this.request.path,o),type:d})},S.FILE_DELETE_HANDLER_DELAY);s.set(o,(0,A.toDisposable)(()=>clearTimeout(l)))}else{let l;i.has(o)?l=0:(l=1,i.add(o)),this.onFileChange({path:(0,E.join)(this.request.path,o),type:l})}else if(t==="rename"||o!==f){const l=setTimeout(async()=>{const u=await w.Promises.exists(C);g.token.isCancellationRequested||(u?(this.onFileChange({path:this.request.path,type:0},!0),a.add(await this.doWatch(C,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},S.FILE_DELETE_HANDLER_DELAY);a.clear(),a.add((0,A.toDisposable)(()=>clearTimeout(l)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(f){await w.Promises.exists(C)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${C} for changes using fs.watch() (${f.toString()})`)}return(0,A.toDisposable)(()=>{g.dispose(!0),a.dispose()})}async onFileChange(C,p=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),!p&&this.excludes.some(g=>g(C.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${C.path}`):!p&&this.includes&&this.includes.length>0&&!this.includes.some(g=>g(C.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${C.path}`):this.fileChangesBuffer.push(C);try{await this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const a=(0,m.coalesceEvents)(g);if(a.length>0){if(this.verboseLogging)for(const c of a)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(a)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${a[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(C){if(P.isLinux)return w.Promises.exists(C);try{const p=(0,E.basename)(C);return(await w.Promises.readdir((0,E.dirname)(C))).some(a=>a===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(C){this.verboseLogging=C}error(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${C}`})}warn(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${C}`})}trace(C){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=S,S.FILE_DELETE_HANDLER_DELAY=100,S.FILE_CHANGES_HANDLER_DELAY=50;async function h(y,C,p,g,a=512){const f=await w.Promises.open(y,"r"),c=Buffer.allocUnsafe(a),i=new k.CancellationTokenSource(g);let s,t=!1;const r={path:y,excludes:[],recursive:!1},o=new S(r,l=>{(async()=>{for(const{type:u}of l)if(u===0){if(t)return;t=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:d}=await w.Promises.read(f,c,0,a,null);if(!d||i.token.isCancellationRequested)break;C(c.slice(0,d))}}catch(d){s=new Error(d),i.dispose(!0)}finally{t=!1}}})()});return await o.ready,p(),new Promise((l,u)=>{i.token.onCancellationRequested(async()=>{o.dispose();try{await w.Promises.close(f)}catch(d){s=new Error(d)}s?u(s):l()})})}e.watchFileContents=h}),define(ne[182],re([0,1,3,82,2,4,181]),function(Q,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=R.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(P){const b=this.normalizeRequests(P),w=b.filter(S=>{const h=this.watchers.get(S.path);return h?!(0,n.patternsEquals)(h.request.excludes,S.excludes)||!(0,n.patternsEquals)(h.request.includes,S.includes):!0}),m=Array.from(this.watchers.values()).filter(({request:S})=>!b.find(h=>h.path===S.path&&(0,n.patternsEquals)(h.excludes,S.excludes)&&(0,n.patternsEquals)(h.includes,S.includes))).map(({request:S})=>S.path);w.length&&this.trace(`Request to start watching: ${w.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"})`).join(",")}`),m.length&&this.trace(`Request to stop watching: ${m.join(",")}`);for(const S of m)this.stopWatching(S);for(const S of w)this.startWatching(S)}startWatching(P){const b=new A.NodeJSFileWatcherLibrary(P,m=>this._onDidChangeFile.fire(m),m=>this._onDidLogMessage.fire(m),this.verboseLogging),w={request:P,instance:b};this.watchers.set(P.path,w)}async stop(){for(const[P]of this.watchers)this.stopWatching(P);this.watchers.clear()}stopWatching(P){const b=this.watchers.get(P);b&&(this.watchers.delete(P),b.instance.dispose())}normalizeRequests(P){const b=new Map;for(const w of P){const m=T.isLinux?w.path:w.path.toLowerCase();b.set(m,w)}return Array.from(b.values())}async setVerboseLogging(P){this.verboseLogging=P;for(const[,b]of this.watchers)b.instance.setVerboseLogging(P)}trace(P){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(P)})}toMessage(P,b){return b?`[File Watcher (node.js)] ${P} (path: ${b.request.path})`:`[File Watcher (node.js)] ${P}`}}e.NodeJSWatcher=I}),define(ne[183],re([0,1,57,182]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends R.AbstractNonRecursiveWatcherClient{constructor(A,I,E){super(A,I,E),this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(ne[184],re([0,1,20,39,65,57]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends T.AbstractUniversalWatcherClient{constructor(E,P,b){super(E,P,b),this.init()}createWatcher(E){const P=E.add(new k.Client(R.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(P.onDidProcessExit(({code:b,signal:w})=>this.onError(`terminated by itself with code ${b}, signal: ${w}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(P.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ne[95],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...k){this._entries=new Map;for(const[T,A]of k)this.set(T,A)}set(k,T){const A=this._entries.get(k);return this._entries.set(k,T),A}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=R}),define(ne[185],re([0,1,6,9,56,175,5,95]),function(Q,e,R,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class P extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class b{constructor(h=new I.ServiceCollection,y=!1,C){this._activeInstantiations=new Set,this._services=h,this._strict=y,this._parent=C,this._services.set(A.IInstantiationService,this)}createChild(h){return new b(h,this._strict,this)}invokeFunction(h,...y){const C=m.traceInvocation(h);let p=!1;try{return h({get:a=>{if(p)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(a,C);if(!f)throw new Error(`[invokeFunction] unknown service '${a}'`);return f}},...y)}finally{p=!0,C.stop()}}createInstance(h,...y){let C,p;return h instanceof k.SyncDescriptor?(C=m.traceCreation(h.ctor),p=this._createInstance(h.ctor,h.staticArguments.concat(y),C)):(C=m.traceCreation(h),p=this._createInstance(h,y,C)),C.stop(),p}_createInstance(h,y=[],C){const p=A._util.getServiceDependencies(h).sort((f,c)=>f.index-c.index),g=[];for(const f of p){const c=this._getOrCreateServiceInstance(f.id,C);c||this._throwIfStrict(`[createInstance] ${h.name} depends on UNKNOWN service ${f.id}.`,!1),g.push(c)}const a=p.length>0?p[0].index:y.length;if(y.length!==a){console.trace(`[createInstance] First service dependency of ${h.name} at position ${a+1} conflicts with ${y.length} static arguments`);const f=a-y.length;f>0?y=y.concat(new Array(f)):y=y.slice(0,a)}return new h(...y,...g)}_setServiceInstance(h,y){if(this._services.get(h)instanceof k.SyncDescriptor)this._services.set(h,y);else if(this._parent)this._parent._setServiceInstance(h,y);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){const y=this._services.get(h);return!y&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):y}_getOrCreateServiceInstance(h,y){const C=this._getServiceInstanceOrDescriptor(h);return C instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,C,y.branch(h,!0)):(y.branch(h,!1),C)}_safeCreateAndCacheServiceInstance(h,y,C){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,y,C)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,y,C){const p=new T.Graph(f=>f.id.toString());let g=0;const a=[{id:h,desc:y,_trace:C}];for(;a.length;){const f=a.pop();if(p.lookupOrInsertNode(f),g++>1e3)throw new P(p);for(const c of A._util.getServiceDependencies(f.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(c.id);if(i||this._throwIfStrict(`[createInstance] ${h} depends on ${c.id} which is NOT registered.`,!0),i instanceof k.SyncDescriptor){const s={id:c.id,desc:i,_trace:f._trace.branch(c.id,!0)};p.insertEdge(f,s),a.push(s)}}}for(;;){const f=p.roots();if(f.length===0){if(!p.isEmpty())throw new P(p);break}for(const{data:c}of f){if(this._getServiceInstanceOrDescriptor(c.id)instanceof k.SyncDescriptor){const s=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,s)}p.removeNode(c)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,y,C=[],p,g){if(this._services.get(h)instanceof k.SyncDescriptor)return this._createServiceInstance(y,C,p,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,y,C,p,g);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}_createServiceInstance(h,y=[],C,p){if(C){const g=new R.IdleValue(()=>this._createInstance(h,y,p));return new Proxy(Object.create(null),{get(a,f){if(f in a)return a[f];const c=g.value;let i=c[f];return typeof i!="function"||(i=i.bind(c),a[f]=i),i},set(a,f,c){return g.value[f]=c,!0}})}else return this._createInstance(h,y,p)}_throwIfStrict(h,y){if(y&&console.warn(h),this._strict)throw new Error(h)}}e.InstantiationService=b;var w;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(w||(w={}));class m{constructor(h,y){this.type=h,this.name=y,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return E?new m(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(h){return E?new m(0,h.name):m._None}branch(h,y){const C=new m(2,h.toString());return this._dep.push([h,y,C]),C}stop(){const h=Date.now()-this._start;m._totals+=h;let y=!1;function C(g,a){const f=[],c=new Array(g+1).join("	");for(const[i,s,t]of a._dep)if(s&&t){y=!0,f.push(`${c}CREATES -> ${i}`);const r=C(g+1,t);r&&f.push(r)}else f.push(`${c}uses -> ${i}`);return f.join(`
`)}const p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${C(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(h>2||y)&&console.log(p.join(`
`))}}e.Trace=m,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(ne[186],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class R{constructor(k,T){this.server=k,this.router=T}getChannel(k){return this.server.getChannel(k,this.router)}registerChannel(k,T){this.server.registerChannel(k,T)}}e.MessagePortMainProcessService=R}),define(ne[67],re([0,1,39,56,89,5]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(S,h,y){const C=y.getChannel(S);return I(h)?new h.channelClientCtor(C):R.ProxyChannel.toService(C,h?.proxyOptions)}}function I(m){return!!m?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let E=class extends A{constructor(S,h,y){super(S,h,y)}};E=pe([G(2,e.IMainProcessService)],E);function P(m,S,h){(0,k.registerSingleton)(m,new n.SyncDescriptor(E,[S,h],!0))}e.registerMainProcessRemoteService=P,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let b=class extends A{constructor(S,h,y){super(S,h,y)}};b=pe([G(2,e.ISharedProcessService)],b);function w(m,S,h){(0,k.registerSingleton)(m,new n.SyncDescriptor(b,[S,h],!0))}e.registerSharedProcessRemoteService=w}),define(ne[68],re([0,1,21,2,4,154,29,5]),function(Q,e,R,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,I.createDecorator)("languagePackService");let E=class extends n.Disposable{constructor(b){super(),this.extensionGalleryService=b}async getAvailableLanguages(){const b=new R.CancellationTokenSource;setTimeout(()=>b.cancel(),1e3);let w;try{w=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const S=w.firstPage.filter(h=>h.properties.localizedLanguages?.length&&h.tags.some(y=>y.startsWith("lp-"))).map(h=>{const y=h.properties.localizedLanguages?.[0],C=this.getLocale(h);return{...this.createQuickPickItem(C,y,h),extensionId:h.identifier.id,galleryExtension:h}});return S.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),S}getLocale(b){return b.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(b,w,m){const S=w??b;let h;if(S!==b&&(h=`(${b})`),b.toLowerCase()===k.language.toLowerCase()&&(h??="",h+=(0,T.localize)(0,null)),m?.installCount){h??="";const y=m.installCount;let C;y>1e6?C=`${Math.floor(y/1e5)/10}M`:y>1e3?C=`${Math.floor(y/1e3)}K`:C=String(y),h+=` $(cloud-download) ${C}`}return{id:b,label:S,description:h}}};E=pe([G(0,A.IExtensionGalleryService)],E),e.LanguagePackBaseService=E}),define(ne[187],re([0,1,2,68]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let k=class extends R.Disposable{constructor(A){super(),this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};k=pe([G(0,n.ILanguagePackService)],k),e.LocalizationsUpdater=k}),define(ne[8],re([0,1,38,3,2,4,5]),function(Q,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function I(){return new Date().toISOString()}var E;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function P(s,t,r){switch(t){case E.Trace:s.trace(r);break;case E.Debug:s.debug(r);break;case E.Info:s.info(r);break;case E.Warning:s.warn(r);break;case E.Error:s.error(r);break;case E.Critical:s.critical(r);break;default:throw new Error("Invalid log level")}}e.log=P;function b(s){let t="";for(let r=0;r<s.length;r++){let o=s[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}t+=(r>0?" ":"")+o}return t}e.format=b;class w extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class m extends w{constructor(t){super(),this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(E.Trace)&&this.log(E.Trace,b([t,...r]))}debug(t,...r){this.checkLogLevel(E.Debug)&&this.log(E.Debug,b([t,...r]))}info(t,...r){this.checkLogLevel(E.Info)&&this.log(E.Info,b([t,...r]))}warn(t,...r){this.checkLogLevel(E.Warning)&&this.log(E.Warning,b([t,...r]))}error(t,...r){if(this.checkLogLevel(E.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(E.Error,b(o))}else this.log(E.Error,b([t,...r]))}critical(t,...r){this.checkLogLevel(E.Critical)&&this.log(E.Critical,b([t,...r]))}flush(){}}e.AbstractMessageLogger=m;class S extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.useColors=!T.isWindows}trace(t,...r){this.getLevel()<=E.Trace&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,t,...r):console.log(`[main ${I()}]`,t,...r))}debug(t,...r){this.getLevel()<=E.Debug&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,t,...r):console.log(`[main ${I()}]`,t,...r))}info(t,...r){this.getLevel()<=E.Info&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,t,...r):console.log(`[main ${I()}]`,t,...r))}warn(t,...r){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${I()}]\x1B[0m`,t,...r):console.warn(`[main ${I()}]`,t,...r))}error(t,...r){this.getLevel()<=E.Error&&(this.useColors?console.error(`\x1B[91m[main ${I()}]\x1B[0m`,t,...r):console.error(`[main ${I()}]`,t,...r))}critical(t,...r){this.getLevel()<=E.Critical&&(this.useColors?console.error(`\x1B[90m[main ${I()}]\x1B[0m`,t,...r):console.error(`[main ${I()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class h extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...r){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=h;class y extends w{constructor(t,r=e.DEFAULT_LOG_LEVEL){super(),this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,R.toErrorMessage)(t,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class C extends w{constructor(t){super(),this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const o of this.logServices)o.trace(t,...r)}debug(t,...r){for(const o of this.logServices)o.debug(t,...r)}info(t,...r){for(const o of this.logServices)o.info(t,...r)}warn(t,...r){for(const o of this.logServices)o.warn(t,...r)}error(t,...r){for(const o of this.logServices)o.error(t,...r)}critical(t,...r){for(const o of this.logServices)o.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=C;class p extends k.Disposable{constructor(t){super(),this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=p;class g extends k.Disposable{constructor(t,r){super(),this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(l=>l.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,r?.always?E.Trace:this.logLevel,r),this.loggers.set(t.toString(),o),r?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class a{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(t){}getLevel(){return E.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=a;function f(s){if(s.verbose)return E.Trace;if(typeof s.logLevel=="string"){const t=c(s.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function c(s){switch(s){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=c;function i(s){switch(s){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=i}),define(ne[188],re([0,1,6,9,2,10,27,15,8]),function(Q,e,R,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let P=class extends k.Disposable{constructor(w,m){super(),this.environmentService=w,this.logService=m,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const w=(0,T.basename)(this.environmentService.logsPath),m=(0,T.dirname)(this.environmentService.logsPath),y=(await A.Promises.readdir(m)).filter(p=>/^\d{8}T\d{6}$/.test(p)).sort().filter(p=>p!==w),C=y.slice(0,Math.max(0,y.length-9));C.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${C.join(", ")}'`),await Promise.all(C.map(p=>A.Promises.rm((0,T.join)(m,p)))))}catch(w){(0,n.onUnexpectedError)(w)}}};P=pe([G(0,I.IEnvironmentService),G(1,E.ILogService)],P),e.LogsDataCleaner=P}),define(ne[189],re([0,1,18,6,9,3,2,10,57,8]),function(Q,e,R,n,k,T,A,I,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends A.Disposable{constructor(m,S){super(),this.logService=m,this.options=S,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(m,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,S):this.watchNonRecursive(m,S)}watchUniversal(m,S){const h={path:this.toFilePath(m),excludes:S.excludes,includes:S.includes,recursive:S.recursive},y=(0,R.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{y(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,k.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,E.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const S of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const S of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(S)&&m.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(m,S){const h={path:this.toFilePath(m),excludes:S.excludes,includes:S.includes,recursive:!1},y=(0,R.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{y(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,k.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,E.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,I.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(ne[190],re([0,1,18,6,16,21,3,63,51,2,34,20,191,17,41,150,13,94,8]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let a=class extends P.Disposable{constructor(c){super(),this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(c,i){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${c}`);const s=new P.DisposableStore;return this.provider.set(c,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:i}),s.add(i.onDidChangeFile(t=>this._onDidFilesChange.fire(new C.FileChangesEvent(t,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&s.add(i.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),s.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:c}))),(0,P.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:i}),this.provider.delete(c),(0,P.dispose)(s)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(s){i.push(s)}}),!this.provider.has(c)&&await n.Promises.settled(i)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,i){const s=this.provider.get(c.scheme);return!!(s&&s.capabilities&i)}listCapabilities(){return E.Iterable.map(this.provider,([c,i])=>({scheme:c,capabilities:i.capabilities}))}async withProvider(c){if(!(0,S.isAbsolutePath)(c))throw new C.FileOperationError((0,y.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const i=this.provider.get(c.scheme);if(!i){const s=new Error;throw s.name="ENOPRO",s.message=(0,y.localize)(1,null,c.toString()),s}return i}async withReadProvider(c){const i=await this.withProvider(c);if((0,C.hasOpenReadWriteCloseCapability)(i)||(0,C.hasReadWriteCapability)(i)||(0,C.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const i=await this.withProvider(c);if((0,C.hasOpenReadWriteCloseCapability)(i)||(0,C.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,i){try{return await this.doResolveFile(c,i)}catch(s){throw(0,C.toFileSystemProviderErrorCode)(s)===C.FileSystemProviderErrorCode.FileNotFound?new C.FileOperationError((0,y.localize)(2,null,this.resourceForError(c)),1):(0,C.ensureFileSystemProviderError)(s)}}async doResolveFile(c,i){const s=await this.withProvider(c),t=this.isPathCaseSensitive(s),r=i?.resolveTo,o=i?.resolveSingleChildDescendants,l=i?.resolveMetadata,u=await s.stat(c);let d;return this.toFileStat(s,c,u,void 0,!!l,(v,L)=>(d||(d=b.TernarySearchTree.forUris(()=>!t),d.set(c,!0),r&&d.fill(!0,r)),d.get(v.resource)||d.findSuperstr(v.resource.with({query:null,fragment:null}))?!0:v.isDirectory&&o?L===1:!1))}async toFileStat(c,i,s,t,r,o){const{providerExtUri:l}=this.getExtUri(c),u={resource:i,name:l.basename(i),isFile:(s.type&C.FileType.File)!==0,isDirectory:(s.type&C.FileType.Directory)!==0,isSymbolicLink:(s.type&C.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&C.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,C.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(u.isDirectory&&o(u,t)){try{const d=await c.readdir(i),v=await n.Promises.settled(d.map(async([L,_])=>{try{const M=l.joinPath(i,L),U=r?await c.stat(M):{type:_};return await this.toFileStat(c,M,U,d.length,r,o)}catch(M){return this.logService.trace(M),null}}));u.children=(0,R.coalesce)(v)}catch(d){this.logService.trace(d),u.children=[]}return u}return u}async resolveAll(c){return n.Promises.settled(c.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(c){const i=await this.withProvider(c),s=await i.stat(c);return this.toFileStat(i,c,s,void 0,!0,()=>!1)}async exists(c){const i=await this.withProvider(c);try{return!!await i.stat(c)}catch{return!1}}async canCreateFile(c,i){try{await this.doValidateCreateFile(c,i)}catch(s){return s}return!0}async doValidateCreateFile(c,i){if(!i?.overwrite&&await this.exists(c))throw new C.FileOperationError((0,y.localize)(3,null,this.resourceForError(c)),3,i)}async createFile(c,i=k.VSBuffer.fromString(""),s){await this.doValidateCreateFile(c,s);const t=await this.writeFile(c,i);return this._onDidRunOperation.fire(new C.FileOperationEvent(c,0,t)),t}async writeFile(c,i,s){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:r}=this.getExtUri(t);try{await this.validateWriteFile(t,c,s)||await this.mkdirp(t,r.dirname(c));let l;if((0,C.hasReadWriteCapability)(t)&&!(i instanceof k.VSBuffer))if((0,h.isReadableStream)(i)){const u=await(0,h.peekStream)(i,3);u.ended?l=k.VSBuffer.concat(u.buffer):l=u}else l=(0,h.peekReadable)(i,u=>k.VSBuffer.concat(u),3);else l=i;!(0,C.hasOpenReadWriteCloseCapability)(t)||(0,C.hasReadWriteCapability)(t)&&l instanceof k.VSBuffer?await this.doWriteUnbuffered(t,c,s,l):await this.doWriteBuffered(t,c,s,l instanceof k.VSBuffer?(0,k.bufferToReadable)(l):l),this._onDidRunOperation.fire(new C.FileOperationEvent(c,4))}catch(o){throw new C.FileOperationError((0,y.localize)(4,null,this.resourceForError(c),(0,C.ensureFileSystemProviderError)(o).toString()),(0,C.toFileOperationResult)(o),s)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,i,s){if(!!s?.unlock&&!(c.capabilities&8192))throw new Error((0,y.localize)(5,null,this.resourceForError(i)));let r;try{r=await c.stat(i)}catch{return}if((r.type&C.FileType.Directory)!==0)throw new C.FileOperationError((0,y.localize)(6,null,this.resourceForError(i)),0,s);if(this.throwIfFileIsReadonly(i,r),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==C.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&s.mtime<r.mtime&&s.etag!==(0,C.etag)({mtime:s.mtime,size:r.size}))throw new C.FileOperationError((0,y.localize)(7,null),3,s);return r}async readFile(c,i,s){const t=await this.withReadProvider(c);return i?.atomic?this.doReadFileAtomic(t,c,i,s):this.doReadFile(t,c,i,s)}async doReadFileAtomic(c,i,s,t){return new Promise((r,o)=>{this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(c,i,s,t);r(l)}catch(l){o(l)}})})}async doReadFile(c,i,s,t){const r=await this.doReadFileStream(c,i,{...s,preferUnbuffered:!0},t);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(c,i,s){const t=await this.withReadProvider(c);return this.doReadFileStream(t,c,i,s)}async doReadFileStream(c,i,s,t){const r=new T.CancellationTokenSource(t),o=this.validateReadFile(i,s).then(u=>u,u=>{throw r.cancel(),u});let l;try{return typeof s?.etag=="string"&&s.etag!==C.ETAG_DISABLED&&await o,s?.atomic&&(0,C.hasFileAtomicReadCapability)(c)||!((0,C.hasOpenReadWriteCloseCapability)(c)||(0,C.hasFileReadStreamCapability)(c))||(0,C.hasReadWriteCapability)(c)&&s?.preferUnbuffered?l=this.readFileUnbuffered(c,i,s):(0,C.hasFileReadStreamCapability)(c)?l=this.readFileStreamed(c,i,r.token,s):l=this.readFileBuffered(c,i,r.token,s),{...await o,value:l}}catch(u){l&&await(0,h.consumeStream)(l);const d=(0,y.localize)(8,null,this.resourceForError(i),(0,C.ensureFileSystemProviderError)(u).toString());throw u instanceof C.NotModifiedSinceFileOperationError?new C.NotModifiedSinceFileOperationError(d,u.stat,s):new C.FileOperationError(d,(0,C.toFileOperationResult)(u),s)}}readFileStreamed(c,i,s,t=Object.create(null)){const r=c.readFileStream(i,t,s);return(0,h.transform)(r,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>new C.FileOperationError((0,y.localize)(9,null,this.resourceForError(i),(0,C.ensureFileSystemProviderError)(o).toString()),(0,C.toFileOperationResult)(o),t)},o=>k.VSBuffer.concat(o))}readFileBuffered(c,i,s,t=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,p.readFileIntoStream)(c,i,r,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new C.FileOperationError((0,y.localize)(10,null,this.resourceForError(i),(0,C.ensureFileSystemProviderError)(o).toString()),(0,C.toFileOperationResult)(o),t)},s),r}readFileUnbuffered(c,i,s){const t=(0,h.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;s?.atomic&&(0,C.hasFileAtomicReadCapability)(c)?r=await c.readFile(i,{atomic:!0}):r=await c.readFile(i),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.validateReadFileLimits(i,r.byteLength,s),t.end(k.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async validateReadFile(c,i){const s=await this.resolve(c,{resolveMetadata:!0});if(s.isDirectory)throw new C.FileOperationError((0,y.localize)(11,null,this.resourceForError(c)),0,i);if(typeof i?.etag=="string"&&i.etag!==C.ETAG_DISABLED&&i.etag===s.etag)throw new C.NotModifiedSinceFileOperationError((0,y.localize)(12,null),s,i);return this.validateReadFileLimits(c,s.size,i),s}validateReadFileLimits(c,i,s){if(s?.limits){let t;if(typeof s.limits.memory=="number"&&i>s.limits.memory&&(t=9),typeof s.limits.size=="number"&&i>s.limits.size&&(t=7),typeof t=="number")throw new C.FileOperationError((0,y.localize)(13,null,this.resourceForError(c)),t)}}async canMove(c,i,s){return this.doCanMoveCopy(c,i,"move",s)}async canCopy(c,i,s){return this.doCanMoveCopy(c,i,"copy",s)}async doCanMoveCopy(c,i,s,t){if(c.toString()!==i.toString())try{const r=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(r,c,o,i,s,t)}catch(r){return r}return!0}async move(c,i,s){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(t,c,r,i,"move",!!s),l=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(c,o==="move"?2:3,l)),l}async copy(c,i,s){const t=await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(t,c,r,i,"copy",!!s),l=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(c,o==="copy"?3:2,l)),l}async doMoveCopy(c,i,s,t,r,o){if(i.toString()===t.toString())return r;const{exists:l,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(c,i,s,t,r,o);if(l&&!u&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(t)),r==="copy"){if(c===s&&(0,C.hasFileFolderCopyCapability)(c))await c.copy(i,t,{overwrite:o});else{const d=await this.resolve(i);d.isDirectory?await this.doCopyFolder(c,d,s,t):await this.doCopyFile(c,i,s,t)}return r}else return c===s?(await c.rename(i,t,{overwrite:o}),r):(await this.doMoveCopy(c,i,s,t,"copy",o),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(c,i,s,t){if((0,C.hasOpenReadWriteCloseCapability)(c)&&(0,C.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(c,i,s,t);if((0,C.hasOpenReadWriteCloseCapability)(c)&&(0,C.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(c,i,s,t);if((0,C.hasReadWriteCapability)(c)&&(0,C.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(c,i,s,t);if((0,C.hasReadWriteCapability)(c)&&(0,C.hasReadWriteCapability)(s))return this.doPipeUnbuffered(c,i,s,t)}async doCopyFolder(c,i,s,t){await s.mkdir(t),Array.isArray(i.children)&&await n.Promises.settled(i.children.map(async r=>{const o=this.getExtUri(s).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.doCopyFolder(c,await this.resolve(r.resource),s,o):this.doCopyFile(c,r.resource,s,o)}))}async doValidateMoveCopy(c,i,s,t,r,o){let l=!1;if(c===s){const{providerExtUri:d,isPathCaseSensitive:v}=this.getExtUri(c);if(v||(l=d.isEqual(i,t)),l&&r==="copy")throw new Error((0,y.localize)(14,null,this.resourceForError(i),this.resourceForError(t)));if(!l&&d.isEqualOrParent(t,i))throw new Error((0,y.localize)(15,null,this.resourceForError(i),this.resourceForError(t)))}const u=await this.exists(t);if(u&&!l){if(!o)throw new C.FileOperationError((0,y.localize)(16,null,this.resourceForError(i),this.resourceForError(t)),4);if(c===s){const{providerExtUri:d}=this.getExtUri(c);if(d.isEqualOrParent(i,t))throw new Error((0,y.localize)(17,null,this.resourceForError(i),this.resourceForError(t)))}}return{exists:u,isSameResourceWithDifferentPathCase:l}}getExtUri(c){const i=this.isPathCaseSensitive(c);return{providerExtUri:i?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(i,c);const s=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(c,0,s)),s}async mkdirp(c,i){const s=[],{providerExtUri:t}=this.getExtUri(c);for(;!t.isEqual(i,t.dirname(i));)try{if(((await c.stat(i)).type&C.FileType.Directory)===0)throw new Error((0,y.localize)(18,null,this.resourceForError(i)));break}catch(r){if((0,C.toFileSystemProviderErrorCode)(r)!==C.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(t.basename(i)),i=t.dirname(i)}for(let r=s.length-1;r>=0;r--){i=t.joinPath(i,s[r]);try{await c.mkdir(i)}catch(o){if((0,C.toFileSystemProviderErrorCode)(o)!==C.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(c,i){try{await this.doValidateDelete(c,i)}catch(s){return s}return!0}async doValidateDelete(c,i){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!i?.useTrash&&!(s.capabilities&4096))throw new Error((0,y.localize)(19,null,this.resourceForError(c)));let r;try{r=await s.stat(c)}catch{}if(r)this.throwIfFileIsReadonly(c,r);else throw new C.FileOperationError((0,y.localize)(20,null,this.resourceForError(c)),1);if(!!!i?.recursive){const l=await this.resolve(c);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,y.localize)(21,null,this.resourceForError(c)))}return s}async del(c,i){const s=await this.doValidateDelete(c,i),t=!!i?.useTrash,r=!!i?.recursive;await s.delete(c,{recursive:r,useTrash:t}),this._onDidRunOperation.fire(new C.FileOperationEvent(c,1))}async cloneFile(c,i){const s=await this.withProvider(c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(s===t&&this.getExtUri(s).providerExtUri.isEqual(c,i))return;if(s===t&&(0,C.hasFileCloneCapability)(s))return s.cloneFile(c,i);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i));const r=this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri);return s===t&&(0,C.hasFileFolderCopyCapability)(s)?r.queue(()=>s.copy(c,i,{overwrite:!0})):r.queue(()=>this.doCopyFile(s,c,t,i))}watch(c,i={recursive:!1,excludes:[]}){const s=new P.DisposableStore;let t=!1,r=()=>{t=!0};return s.add((0,P.toDisposable)(()=>r())),(async()=>{try{const o=await this.doWatch(c,i);t?(0,P.dispose)(o):r=()=>(0,P.dispose)(o)}catch(o){this.logService.error(o)}})(),s}async doWatch(c,i){const s=await this.withProvider(c),t=(0,I.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(c),i]);let r=this.activeWatchers.get(t);return r||(r={count:0,disposable:s.watch(c,i)},this.activeWatchers.set(t,r)),r.count+=1,(0,P.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,P.dispose)(r.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,P.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,i,s,t){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(async()=>{const r=await c.open(i,{create:!0,unlock:s?.unlock??!1});try{(0,h.isReadableStream)(t)||(0,h.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(c,r,t):await this.doWriteReadableBufferedQueued(c,r,t)}catch(o){throw(0,C.ensureFileSystemProviderError)(o)}finally{await c.close(r)}})}async doWriteStreamBufferedQueued(c,i,s){let t=0,r;if((0,h.isReadableBufferedStream)(s)){if(s.buffer.length>0){const o=k.VSBuffer.concat(s.buffer);await this.doWriteBuffer(c,i,o,o.byteLength,t,0),t+=o.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((o,l)=>{(0,h.listenStream)(r,{onData:async u=>{r.pause();try{await this.doWriteBuffer(c,i,u,u.byteLength,t,0)}catch(d){return l(d)}t+=u.byteLength,setTimeout(()=>r.resume())},onError:u=>l(u),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(c,i,s){let t=0,r;for(;(r=s.read())!==null;)await this.doWriteBuffer(c,i,r,r.byteLength,t,0),t+=r.byteLength}async doWriteBuffer(c,i,s,t,r,o){let l=0;for(;l<t;)l+=await c.write(i,r+l,s.buffer,o+l,t-l)}async doWriteUnbuffered(c,i,s,t){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,i,s,t))}async doWriteUnbufferedQueued(c,i,s,t){let r;t instanceof k.VSBuffer?r=t:(0,h.isReadableStream)(t)?r=await(0,k.streamToBuffer)(t):(0,h.isReadableBufferedStream)(t)?r=await(0,k.bufferedStreamToBuffer)(t):r=(0,k.readableToBuffer)(t),await c.writeFile(i,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(c,i,s,t){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,i,s,t))}async doPipeBufferedQueued(c,i,s,t){let r,o;try{r=await c.open(i,{create:!1}),o=await s.open(t,{create:!0,unlock:!1});const l=k.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,d=0,v=0;do v=await c.read(r,u,l.buffer,d,l.byteLength-d),await this.doWriteBuffer(s,o,l,v,u,d),u+=v,d+=v,d===l.byteLength&&(d=0);while(v>0)}catch(l){throw(0,C.ensureFileSystemProviderError)(l)}finally{await n.Promises.settled([typeof r=="number"?c.close(r):Promise.resolve(),typeof o=="number"?s.close(o):Promise.resolve()])}}async doPipeUnbuffered(c,i,s,t){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,i,s,t))}async doPipeUnbufferedQueued(c,i,s,t){return s.writeFile(t,await c.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,i,s,t){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,i,s,t))}async doPipeUnbufferedToBufferedQueued(c,i,s,t){const r=await s.open(t,{create:!0,unlock:!1});try{const o=await c.readFile(i);await this.doWriteBuffer(s,r,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,C.ensureFileSystemProviderError)(o)}finally{await s.close(r)}}async doPipeBufferedToUnbuffered(c,i,s,t){const r=await(0,k.streamToBuffer)(this.readFileBuffered(c,i,T.CancellationToken.None));await this.doWriteUnbuffered(s,t,void 0,r)}throwIfFileSystemIsReadonly(c,i){if(c.capabilities&2048)throw new C.FileOperationError((0,y.localize)(22,null,this.resourceForError(i)),6);return c}throwIfFileIsReadonly(c,i){if((i.permissions??0)&C.FilePermission.Readonly)throw new C.FileOperationError((0,y.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===w.Schemas.file?c.fsPath:c.toString(!0)}};a=pe([G(0,g.ILogService)],a),e.FileService=a}),define(ne[192],re([0,1,53,274,6,34,16,3,46,2,10,4,17,41,27,153,13,94,189,38,184,183]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C,p,g,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(R)}catch(s){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(s)}`)}})();class i extends g.AbstractDiskFileSystemProvider{constructor(t,r){super(t,r),this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new T.ResourceMap(o=>m.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:r,symbolicLink:o}=await h.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(t){try{const r=await h.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async l=>{try{let u;l.isSymbolicLink()?u=(await this.stat((0,m.joinPath)(t,l.name))).type:u=this.toType(l),o.push([l.name,u])}catch(u){this.logService.trace(u)}})),o}catch(r){throw this.toFileSystemProviderError(r)}}toType(t,r){let o;return r?.dangling?o=C.FileType.Unknown:t.isFile()?o=C.FileType.File:t.isDirectory()?o=C.FileType.Directory:o=C.FileType.Unknown,r&&(o|=C.FileType.SymbolicLink),o}async createResourceLock(t){const r=this.toFilePath(t);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.resourceLocks.get(t);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const l=new k.Barrier;return this.resourceLocks.set(t,l),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,P.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(t)===l&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),l.open()})}async readFile(t,r){let o;try{r?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),o=await this.createResourceLock(t));const l=this.toFilePath(t);return await h.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{o?.dispose()}}readFileStream(t,r,o){const l=(0,S.newWriteableStream)(u=>A.VSBuffer.concat(u.map(d=>A.VSBuffer.wrap(d))).buffer);return(0,p.readFileIntoStream)(this,t,l,u=>u.buffer,{...r,bufferSize:256*1024},o),l}async writeFile(t,r,o){let l;try{const u=this.toFilePath(t);if(!o.create||!o.overwrite){if(await h.Promises.exists(u)){if(!o.overwrite)throw(0,C.createFileSystemProviderError)((0,y.localize)(0,null),C.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,C.createFileSystemProviderError)((0,y.localize)(1,null),C.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(l,0,r,0,r.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(t,u)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(t){i.canFlush=t}async open(t,r){const o=this.toFilePath(t);let l;(0,C.isFileOpenForWriteOptions)(r)&&(l=await this.createResourceLock(t));let u;try{if((0,C.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:v}=await h.SymlinkSupport.stat(o);v.mode&128||await h.Promises.chmod(o,v.mode|128)}catch(v){this.logService.trace(v)}let d;if((0,C.isFileOpenForWriteOptions)(r)){if(w.isWindows)try{await h.Promises.truncate(o,0),d="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}d||(d="w")}else d="r";u=await h.Promises.open(o,d)}catch(d){throw l?.dispose(),(0,C.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(t,d):this.toFileSystemProviderError(d)}if(this.mapHandleToPos.set(u,0),(0,C.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(u,t),l){const d=this.mapHandleToLock.get(u);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${o})`),this.mapHandleToLock.set(u,l),d&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${o})`),d.dispose())}return u}async close(t){const r=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&i.canFlush)try{await h.Promises.fdatasync(t)}catch(o){i.configureFlushOnWrite(!1),this.logService.error(o)}return await h.Promises.close(t)}catch(o){throw this.toFileSystemProviderError(o)}finally{r&&(this.mapHandleToLock.get(t)===r&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),r.dispose())}}async read(t,r,o,l,u){const d=this.normalizePos(t,r);let v=null;try{v=(await h.Promises.read(t,o,l,u,d)).bytesRead}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(t,d,v)}return v}normalizePos(t,r){return r===this.mapHandleToPos.get(t)?null:r}updatePos(t,r,o){const l=this.mapHandleToPos.get(t);typeof l=="number"&&(typeof r=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,l+o):this.mapHandleToPos.delete(t)))}async write(t,r,o,l,u){return(0,k.retry)(()=>this.doWrite(t,r,o,l,u),100,3)}async doWrite(t,r,o,l,u){const d=this.normalizePos(t,r);let v=null;try{v=(await h.Promises.write(t,o,l,u,d)).bytesWritten}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),L)}finally{this.updatePos(t,d,v)}return v}async mkdir(t){try{await h.Promises.mkdir(this.toFilePath(t))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(t,r){try{const o=this.toFilePath(t);r.recursive?await h.Promises.rm(o,h.RimRafMode.MOVE):await h.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(t,r,o){const l=this.toFilePath(t),u=this.toFilePath(r);if(l!==u)try{await this.validateTargetDeleted(t,r,"move",o.overwrite),await h.Promises.move(l,u)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,y.localize)(2,null,(0,b.basename)(l),(0,b.basename)((0,b.dirname)(u)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(t,r,o){const l=this.toFilePath(t),u=this.toFilePath(r);if(l!==u)try{await this.validateTargetDeleted(t,r,"copy",o.overwrite),await h.Promises.copy(l,u,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,y.localize)(3,null,(0,b.basename)(l),(0,b.basename)((0,b.dirname)(u)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(t,r,o,l){const u=this.toFilePath(t),d=this.toFilePath(r);let v=!1;if(!!(this.capabilities&1024)||(v=(0,E.isEqual)(u,d,!0)),v&&o==="copy")throw(0,C.createFileSystemProviderError)((0,y.localize)(4,null),C.FileSystemProviderErrorCode.FileExists);if(!v&&await h.Promises.exists(d)){if(!l)throw(0,C.createFileSystemProviderError)((0,y.localize)(5,null),C.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(t,r){return this.doCloneFile(t,r,!1)}async doCloneFile(t,r,o){const l=this.toFilePath(t),u=this.toFilePath(r),d=!!(this.capabilities&1024);if((0,E.isEqual)(l,u,!d))return;const v=new P.DisposableStore;try{const[L,_]=await Promise.all([this.createResourceLock(t),this.createResourceLock(r)]);v.add(L),v.add(_),o&&await h.Promises.mkdir((0,b.dirname)(u),{recursive:!0}),await h.Promises.copyFile(l,u)}catch(L){if(L.code==="ENOENT"&&!o)return this.doCloneFile(t,r,!0);throw this.toFileSystemProviderError(L)}finally{v.dispose()}}createUniversalWatcher(t,r,o){return new f.UniversalWatcherClient(l=>t(l),l=>r(l),o)}createNonRecursiveWatcher(t,r,o){return new c.NodeJSWatcherClient(l=>t(l),l=>r(l),o)}toFileSystemProviderError(t){if(t instanceof C.FileSystemProviderError)return t;let r;switch(t.code){case"ENOENT":r=C.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=C.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=C.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=C.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=C.FileSystemProviderErrorCode.NoPermissions;break;default:r=C.FileSystemProviderErrorCode.Unknown}return(0,C.createFileSystemProviderError)(t,r)}async toFileSystemProviderWriteError(t,r){let o=this.toFileSystemProviderError(r);if(t&&o.code===C.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await h.SymlinkSupport.stat(this.toFilePath(t));l.mode&128||(o=(0,C.createFileSystemProviderError)(r,C.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return o}}e.DiskFileSystemProvider=i,i.canFlush=!0}),define(ne[96],re([0,1,3,7,8]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(m){this.service=m,this.onDidChangeLogLevel=R.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,S){switch(S){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${S}`)}async call(m,S,h){switch(S){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${S}`)}}e.LogLevelChannel=T;class A{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){A.setLevel(this.channel,m)}static setLevel(m,S){return m.call("setLevel",S)}}e.LogLevelChannelClient=A;class I{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,S){throw new Error(`Event not found: ${S}`)}async call(m,S,h){switch(S){case"createLogger":this.createLogger(n.URI.revive(h[0]),h[1]);return;case"log":return this.log(n.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${S}`)}createLogger(m,S){this.loggers.set(m.toString(),this.loggerService.createLogger(m,S))}consoleLog(m,S){let h=console.log;switch(m){case k.LogLevel.Error:h=console.error;break;case k.LogLevel.Warning:h=console.warn;break;case k.LogLevel.Info:h=console.info;break}h.call(console,...S)}log(m,S){const h=this.loggers.get(m.toString());if(!h)throw new Error("Create the logger before logging");for(const[y,C]of S)(0,k.log)(h,y,C)}}e.LoggerChannel=I;class E extends k.AbstractLoggerService{constructor(m,S,h){super(m,S),this.channel=h}createConsoleMainLogger(){return new k.AdapterLogger({log:(m,S)=>{this.channel.call("consoleLog",[m,S])}})}doCreateLogger(m,S,h){return new P(this.channel,m,S,h)}}e.LoggerChannelClient=E;class P extends k.AbstractMessageLogger{constructor(m,S,h,y){super(y?.always),this.channel=m,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[S,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,S){const h=[[m,S]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(m){this.channel.call("log",[this.file,m])}}class b extends k.LogService{constructor(m,S){super(S),this.parent=m,this._register(m.onDidChangeLogLevel(h=>S.setLevel(h)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=b}),define(ne[58],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(ne[59],re([0,1,3,51,2,5]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,T.createDecorator)("policy");class A extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(P){const b=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...P,...this.policyDefinitions},b!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(P),n.Iterable.reduce(this.policies.entries(),(w,[m,S])=>({...w,[m]:S}),{})}getPolicyValue(P){return this.policies.get(P)}serialize(){return n.Iterable.reduce(Object.entries(this.policyDefinitions),(P,[b,w])=>({...P,[b]:{definition:w,value:this.policies.get(b)}}),{})}}e.AbstractPolicyService=A;class I{constructor(){this.onDidChange=R.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(ne[193],re([0,1,3,2,59]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class T{constructor(E){this.service=E,this.disposables=new n.DisposableStore}listen(E,P){switch(P){case"onDidChange":return R.Event.map(this.service.onDidChange,b=>b.reduce((w,m)=>({...w,[m]:this.service.getPolicyValue(m)??null}),{}),this.disposables)}throw new Error(`Event not found: ${P}`)}call(E,P,b){switch(P){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(b)}throw new Error(`Call not found: ${P}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=T;class A extends k.AbstractPolicyService{constructor(E,P){super(),this.channel=P;for(const b in E){const{definition:w,value:m}=E[b];this.policyDefinitions[b]=w,m!==void 0&&this.policies.set(b,m)}this.channel.listen("onDidChange")(b=>{for(const w in b){const m=b[w];m===null?this.policies.delete(w):this.policies.set(w,m)}this._onDidChange.fire(Object.keys(b))})}async initializePolicies(E){const P=await this.channel.call("registerPolicyDefinitions",E);for(const b in P)this.policies.set(b,P[b])}}e.PolicyChannelClient=A}),define(ne[97],re([0,1,20,4,36,17]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof n.globals.vscode<"u"&&typeof n.globals.vscode.context<"u"){const I=n.globals.vscode.context.configuration();if(I)A=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const I=(0,T.dirname)(R.FileAccess.asFileUri("",Q));A=Q.__$__nodeRequire((0,T.joinPath)(I,"product.json").fsPath);const E=Q.__$__nodeRequire((0,T.joinPath)(I,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{version:E.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(ne[25],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[194],re([0,1,6,9,2,10,27,8,25]),function(Q,e,R,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let P=class extends k.Disposable{constructor(w,m,S){super(),this.productService=m,this.logService=S,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(w)},3e4)).schedule()}async cleanUpCodeCaches(w){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),S=(0,T.dirname)(w),h=(0,T.basename)(w),y=await A.Promises.readdir(S);await Promise.all(y.map(async C=>{if(C===h)return;const p=(0,T.join)(S,C),g=await A.Promises.stat(p);if(g.isDirectory()&&m-g.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${C}.`),A.Promises.rm(p)}))}catch(m){(0,n.onUnexpectedError)(m)}}};P=pe([G(1,E.IProductService),G(2,I.ILogService)],P),e.CodeCacheCleaner=P}),define(ne[195],re([0,1,6,9,2,10,27,15,8,25]),function(Q,e,R,n,k,T,A,I,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let b=class extends k.Disposable{constructor(m,S,h){super(),this.environmentService=m,this.logService=S,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),S=JSON.parse(await A.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const g of Object.keys(S)){const a=S[g];m[`${a.hash}.${g}`]=!0}const h=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(h))return;const C=await A.Promises.readdir(h);for(const g of C){if(m[g]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${g}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${g}`),await A.Promises.rm((0,T.join)(h,g))}const p=Date.now();for(const g of Object.keys(m)){const a=(0,T.join)(h,g),f=await A.Promises.readdir(a);for(const c of f){if(c==="tcf.json")continue;const i=(0,T.join)(a,c),s=await A.Promises.stat(i);s.isDirectory()&&p-s.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(g,c)}`),await A.Promises.rm(i))}}}catch(m){(0,n.onUnexpectedError)(m)}}};b=pe([G(0,I.INativeEnvironmentService),G(1,E.ILogService),G(2,P.IProductService)],b),e.LanguagePackCachedDataCleaner=b}),define(ne[196],re([0,1,10,5]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var k;(function(T){function A(I,E="noAbsolutePaths"){for(const P of I.nodes)P.callFrame&&P.callFrame.url&&((0,R.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(P.callFrame.url))&&(P.callFrame.url=(0,R.join)(E,(0,R.basename)(P.callFrame.url)));return I}T.rewriteAbsolutePaths=A})(k=e.Utils||(e.Utils={}))}),define(ne[197],re([0,1,30]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this._sessions=new Map}async startProfiling(T){const I=await(await new Promise((P,b)=>{Q(["v8-inspect-profiler"],P,b)})).startProfiling({port:T.port,checkForPaused:!0}),E=(0,R.generateUuid)();return this._sessions.set(E,I),E}async stopProfiling(T){const A=this._sessions.get(T);if(!A)throw new Error(`UNKNOWN session '${T}'`);const I=await A.stop();return this._sessions.delete(T),I.profile}}e.InspectProfilingService=n}),define(ne[40],re([0,1,113,14]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(A,I){R.ok(n.isString(A)),R.ok(n.isObject(I)),R.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,I)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new k}),define(ne[98],re([0,1,3,40]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class T{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,P){this.schemasById[k(E)]=P,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;n.Registry.add(e.Extensions.JSONContribution,A)}),define(ne[42],re([0,1,18,3,14,139,19,98,40]),function(Q,e,R,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=E.Registry.as(I.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const t=this.doRegisterConfigurations(i,s);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(i){const s=this.doDeregisterConfigurations(i);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:i,remove:s}){const t=[];t.push(...this.doDeregisterConfigurations(s)),t.push(...this.doRegisterConfigurations(i,!1)),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,R.distinct)(t)})}registerDefaultConfigurations(i){const s=[],t=[];for(const{overrides:r,source:o}of i)for(const l in r)if(s.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const u=this.configurationDefaultsOverrides.get(l),d=u?.valuesSources??new Map;if(o)for(const M of Object.keys(r[l]))d.set(M,o);const v={...u?.value||{},...r[l]};this.configurationDefaultsOverrides.set(l,{source:o,value:v,valuesSources:d});const L=(0,A.getLanguageTagSettingPlainKey)(l),_={type:"object",default:v,description:T.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:k.isString(o)?void 0:o,defaultValueSource:o};t.push(...y(l)),this.configurationProperties[l]=_,this.defaultLanguageConfigurationOverridesNode.properties[l]=_}else{this.configurationDefaultsOverrides.set(l,{value:r[l],source:o});const u=this.configurationProperties[l];u&&(this.updatePropertyDefaultValue(l,u),this.updateSchema(l,u))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const s=[];for(const{overrides:t,source:r}of i)for(const o in t){const l=this.configurationDefaultsOverrides.get(o),u=k.isString(r)?r:r?.id,d=k.isString(l?.source)?l?.source:l?.source?.id;if(u===d)if(s.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const v=this.configurationProperties[o];v&&(this.updatePropertyDefaultValue(o,v),this.updateSchema(o,v))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const s of i)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,s){const t=[];return i.forEach(r=>{t.push(...this.validateAndRegisterProperties(r,s,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),t}doDeregisterConfigurations(i){const s=[],t=r=>{if(r.properties)for(const o in r.properties){s.push(o);const l=this.configurationProperties[o];l?.policy?.name&&this.policyConfigurations.delete(l.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o])}r.allOf?.forEach(o=>t(o))};for(const r of i){t(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}return s}validateAndRegisterProperties(i,s=!0,t,r,o=3){o=k.isUndefinedOrNull(i.scope)?o:i.scope;const l=[],u=i.properties;if(u)for(const v in u){const L=u[v];if(s&&a(v,L)){delete u[v];continue}if(L.source=t,L.defaultDefaultValue=u[v].default,this.updatePropertyDefaultValue(v,L),e.OVERRIDE_PROPERTY_REGEX.test(v)?L.scope=void 0:(L.scope=k.isUndefinedOrNull(L.scope)?o:L.scope,L.restricted=k.isUndefinedOrNull(L.restricted)?!!r?.includes(v):L.restricted),u[v].hasOwnProperty("included")&&!u[v].included){this.excludedConfigurationProperties[v]=u[v],delete u[v];continue}else this.configurationProperties[v]=u[v],u[v].policy?.name&&this.policyConfigurations.set(u[v].policy.name,v);!u[v].deprecationMessage&&u[v].markdownDeprecationMessage&&(u[v].deprecationMessage=u[v].markdownDeprecationMessage),l.push(v)}const d=i.allOf;if(d)for(const v of d)l.push(...this.validateAndRegisterProperties(v,s,t,r,o));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const s=t=>{const r=t.properties;if(r)for(const l in r)this.updateSchema(l,r[l]);t.allOf?.forEach(s)};s(i)}updateSchema(i,s){switch(e.allSettings.properties[i]=s,s.scope){case 1:e.applicationSettings.properties[i]=s;break;case 2:e.machineSettings.properties[i]=s;break;case 6:e.machineOverridableSettings.properties[i]=s;break;case 3:e.windowSettings.properties[i]=s;break;case 4:e.resourceSettings.properties[i]=s;break;case 5:e.resourceSettings.properties[i]=s,this.resourceLanguageSettingsSchema.properties[i]=s;break}}removeFromSchema(i,s){switch(delete e.allSettings.properties[i],s.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const s=`[${i}]`,t={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,t),e.allSettings.properties[s]=t,e.applicationSettings.properties[s]=t,e.machineSettings.properties[s]=t,e.machineOverridableSettings.properties[s]=t,e.windowSettings.properties[s]=t,e.resourceSettings.properties[s]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,s){const t=this.configurationDefaultsOverrides.get(i);let r=t?.value,o=t?.source;k.isUndefined(r)&&(r=s.defaultDefaultValue,o=void 0),k.isUndefined(r)&&(r=p(s.type)),s.default=r,s.defaultValueSource=o}}const S="\\[([^\\]]+)\\]",h=new RegExp(S,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(c){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let s=h.exec(c);for(;s?.length;){const t=s[1].trim();t&&i.push(t),s=h.exec(c)}}return(0,R.distinct)(i)}e.overrideIdentifiersFromKey=y;function C(c){return c.reduce((i,s)=>`${i}[${s}]`,"")}e.keyFromOverrideIdentifiers=C;function p(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const g=new m;E.Registry.add(e.Extensions.Configuration,g);function a(c,i){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?T.localize(7,null,c):g.getConfigurationProperties()[c]!==void 0?T.localize(8,null,c):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?T.localize(9,null,c,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:T.localize(6,null)}e.validateProperty=a;function f(){const c=[],i=g.getConfigurationProperties();for(const s of Object.keys(i))c.push([s,i[s].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=f}),define(ne[69],re([0,1,18,3,35,2,34,31,14,7,19,42,40]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class S{constructor(i={},s=[],t=[]){this._contents=i,this._keys=s,this._overrides=t,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(i){return i?(0,b.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,s){const t=this.getContentsForOverrideIdentifer(s);return t?i?(0,b.getConfigurationValue)(t,i):t:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const t of this.overrides)t.identifiers.includes(i)&&s.push(...t.keys);return R.distinct(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return R.distinct(i)}override(i){let s=this.overrideConfigurations.get(i);return s||(s=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,s)),s}merge(...i){const s=I.deepClone(this.contents),t=I.deepClone(this.overrides),r=[...this.keys];for(const o of i)if(!o.isEmpty()){this.mergeContents(s,o.contents);for(const l of o.overrides){const[u]=t.filter(d=>R.equals(d.identifiers,l.identifiers));u?(this.mergeContents(u.contents,l.contents),u.keys.push(...l.keys),u.keys=R.distinct(u.keys)):t.push(I.deepClone(l))}for(const l of o.keys)r.indexOf(l)===-1&&r.push(l)}return new S(s,r,t)}freeze(){return this.frozen=!0,this}clone(){return new S(I.deepClone(this.contents),[...this.keys],I.deepClone(this.overrides))}createOverrideConfigurationModel(i){const s=this.getContentsForOverrideIdentifer(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of R.distinct([...Object.keys(this.contents),...Object.keys(s)])){let o=this.contents[r];const l=s[r];l&&(typeof o=="object"&&typeof l=="object"?(o=I.deepClone(o),this.mergeContents(o,l)):o=l),t[r]=o}return new S(t,this.keys,this.overrides)}mergeContents(i,s){for(const t of Object.keys(s)){if(t in i&&E.isObject(i[t])&&E.isObject(s[t])){this.mergeContents(i[t],s[t]);continue}i[t]=I.deepClone(s[t])}}checkAndFreeze(i){return this.frozen&&!Object.isFrozen(i)?I.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let s=null,t=null;const r=o=>{o&&(t?this.mergeContents(t,o):t=I.deepClone(o))};for(const o of this.overrides)R.equals(o.identifiers,[i])?s=o.contents:o.identifiers.includes(i)&&r(o.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,s){this.addKey(i),(0,b.addToValueTree)(this.contents,i,s,t=>{throw new Error(t)})}removeValue(i){this.removeKey(i)&&(0,b.removeFromValueTree)(this.contents,i)}addKey(i){let s=this.keys.length;for(let t=0;t<s;t++)i.indexOf(this.keys[t])===0&&(s=t);this.keys.splice(s,1,i)}removeKey(i){const s=this.keys.indexOf(i);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=S;class h{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,s){if(!E.isUndefinedOrNull(i)){const t=this.doParseContent(i);this.parseRaw(t,s)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,s){this._raw=i;const{contents:t,keys:r,overrides:o,restricted:l}=this.doParseRaw(i,s);this._configurationModel=new S(t,r,o),this._restrictedConfigurations=l||[]}doParseContent(i){let s={},t=null,r=[];const o=[],l=[];function u(v){Array.isArray(r)?r.push(v):t!==null&&(r[t]=v)}const d={onObjectBegin:()=>{const v={};u(v),o.push(r),r=v,t=null},onObjectProperty:v=>{t=v},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const v=[];u(v),o.push(r),r=v,t=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:u,onError:(v,L,_)=>{l.push({error:v,offset:L,length:_})}};if(i)try{k.visit(i,d),s=r[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return s}doParseRaw(i,s){const t=m.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,t,!0,s);i=r.raw;const o=(0,b.toValuesTree)(i,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),l=Object.keys(i),u=this.toOverrides(i,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:o,keys:l,overrides:u,restricted:r.restricted}}filter(i,s,t,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[]};const o={},l=[];for(const u in i)if(w.OVERRIDE_PROPERTY_REGEX.test(u)&&t){const d=this.filter(i[u],s,!1,r);o[u]=d.raw,l.push(...d.restricted)}else{const d=s[u],v=d?typeof d.scope<"u"?d.scope:3:void 0;d?.restricted&&l.push(u),(v===void 0||r.scopes===void 0||r.scopes.includes(v))&&(r.skipRestricted&&d?.restricted||(o[u]=i[u]))}return{raw:o,restricted:l}}toOverrides(i,s){const t=[];for(const r of Object.keys(i))if(w.OVERRIDE_PROPERTY_REGEX.test(r)){const o={};for(const l in i[r])o[l]=i[r][l];t.push({identifiers:(0,w.overrideIdentifiersFromKey)(r),keys:Object.keys(o),contents:(0,b.toValuesTree)(o,s)})}return t}}e.ConfigurationModelParser=h;class y extends T.Disposable{constructor(i,s,t,r){super(),this.userSettingsResource=i,this.scopes=s,this.fileService=r,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&t.isEqual(o.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class C{constructor(i,s,t,r,o=new S,l=new S,u=new A.ResourceMap,d=new S,v=new A.ResourceMap,L=!0){this._defaultConfiguration=i,this._policyConfiguration=s,this._applicationConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=o,this._workspaceConfiguration=l,this._folderConfigurations=u,this._memoryConfiguration=d,this._memoryConfigurationByResource=v,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(i,s,t){return this.getConsolidatedConfigurationModel(i,s,t).getValue(i)}updateValue(i,s,t={}){let r;t.resource?(r=this._memoryConfigurationByResource.get(t.resource),r||(r=new S,this._memoryConfigurationByResource.set(t.resource,r))):r=this._memoryConfiguration,s===void 0?r.removeValue(i):r.setValue(i,s),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,s,t){const r=this.getConsolidatedConfigurationModel(i,s,t),o=this.getFolderConfigurationModelForResource(s.resource,t),l=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,u=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),d=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(i),v=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(i),L=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),_=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),M=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),U=t?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,D=o?s.overrideIdentifier?o.freeze().override(s.overrideIdentifier).getValue(i):o.freeze().getValue(i):void 0,F=s.overrideIdentifier?l.override(s.overrideIdentifier).getValue(i):l.getValue(i),$=r.getValue(i),j=R.distinct(r.overrides.map(J=>J.identifiers).flat()).filter(J=>r.getOverrideValue(i,J)!==void 0);return{defaultValue:u,policyValue:d,applicationValue:v,userValue:L,userLocalValue:_,userRemoteValue:M,workspaceValue:U,workspaceFolderValue:D,memoryValue:F,value:$,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,policy:d!==void 0?{value:d}:void 0,application:v!==void 0?{value:v,override:s.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userRemote:M!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspaceFolder:D!==void 0?{value:o?.freeze().getValue(i),override:s.overrideIdentifier?o?.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:l.getValue(i),override:s.overrideIdentifier?l.getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(i){const s=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,s){this._folderConfigurations.set(i,s),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const t=[];if(!s){const{added:r,updated:o,removed:l}=a(this._defaultConfiguration,i);s=[...r,...o,...l]}for(const r of s)for(const o of(0,w.overrideIdentifiersFromKey)(r)){const l=this._defaultConfiguration.getKeysForOverrideIdentifier(o),u=i.getKeysForOverrideIdentifier(o),d=[...u.filter(v=>l.indexOf(v)===-1),...l.filter(v=>u.indexOf(v)===-1),...l.filter(v=>!I.equals(this._defaultConfiguration.override(o).getValue(v),i.override(o).getValue(v)))];t.push([o,d])}return this.updateDefaultConfiguration(i),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(i){const{added:s,updated:t,removed:r}=a(this._policyConfiguration,i),o=[...s,...t,...r];return o.length&&this.updatePolicyConfiguration(i),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:s,updated:t,removed:r,overrides:o}=a(this.applicationConfiguration,i),l=[...s,...t,...r];return l.length&&this.updateApplicationConfiguration(i),{keys:l,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:t,removed:r,overrides:o}=a(this.localUserConfiguration,i),l=[...s,...t,...r];return l.length&&this.updateLocalUserConfiguration(i),{keys:l,overrides:o}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:t,removed:r,overrides:o}=a(this.remoteUserConfiguration,i),l=[...s,...t,...r];return l.length&&this.updateRemoteUserConfiguration(i),{keys:l,overrides:o}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:t,removed:r,overrides:o}=a(this.workspaceConfiguration,i),l=[...s,...t,...r];return l.length&&this.updateWorkspaceConfiguration(i),{keys:l,overrides:o}}compareAndUpdateFolderConfiguration(i,s){const t=this.folderConfigurations.get(i),{added:r,updated:o,removed:l,overrides:u}=a(t,s),d=[...r,...o,...l];return(d.length||!t)&&this.updateFolderConfiguration(i,s),{keys:d,overrides:u}}compareAndDeleteFolderConfiguration(i){const s=this.folderConfigurations.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:t,updated:r,removed:o,overrides:l}=a(s,void 0);return{keys:[...t,...r,...o],overrides:l}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,s,t){let r=this.getConsolidatedConfigurationModelForResource(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:i},s){let t=this.getWorkspaceConsolidatedConfiguration();if(s&&i){const r=s.getFolder(i);r&&(t=this.getFolderConsolidatedConfiguration(r.uri)||t);const o=this._memoryConfigurationByResource.get(i);o&&(t=t.merge(o))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let s=this._foldersConsolidatedConfigurations.get(i);if(!s){const t=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(s=t.merge(r),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(i,s)):s=t}return s}getFolderConfigurationModelForResource(i,s){if(s&&i){const t=s.getFolder(i);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,s)=>{const{contents:t,overrides:r,keys:o}=this._folderConfigurations.get(s);return i.push([s,{contents:t,overrides:r,keys:o}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>i.add(s)),this.userConfiguration.freeze().keys.forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(t=>i.add(t))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>s.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>s.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r))),[...s.values()]}static parse(i){const s=this.parseConfigurationModel(i.defaults),t=this.parseConfigurationModel(i.policy),r=this.parseConfigurationModel(i.application),o=this.parseConfigurationModel(i.user),l=this.parseConfigurationModel(i.workspace),u=i.folders.reduce((d,v)=>(d.set(P.URI.revive(v[0]),this.parseConfigurationModel(v[1])),d),new A.ResourceMap);return new C(s,t,r,o,new S,l,u,new S,new A.ResourceMap,!1)}static parseConfigurationModel(i){return new S(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=C;function p(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,s=new Map;for(const r of c)r.keys.forEach(o=>i.add(o)),r.overrides.forEach(([o,l])=>{const u=(0,A.getOrSet)(s,o,new Set);l.forEach(d=>u.add(d))});const t=[];return s.forEach((r,o)=>t.push([o,[...r.values()]])),{keys:[...i.values()],overrides:t}}e.mergeChanges=p;class g{constructor(i,s,t,r){this.change=i,this.previous=s,this.currentConfiguraiton=t,this.currentWorkspace=r,this._previousConfiguration=void 0;const o=new Set;i.keys.forEach(u=>o.add(u)),i.overrides.forEach(([,u])=>u.forEach(d=>o.add(d))),this.affectedKeys=[...o.values()];const l=new S;this.affectedKeys.forEach(u=>l.setValue(u,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(s){const t=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,s,this.currentWorkspace);return!I.equals(t,r)}return!0}return!1}doesAffectedKeysTreeContains(i,s){let t=(0,b.toValuesTree)({[s]:!0},()=>{}),r;for(;typeof t=="object"&&(r=Object.keys(t)[0]);){if(i=i[r],!i)return!1;t=t[r]}return!0}}e.ConfigurationChangeEvent=g;function a(c,i){const{added:s,removed:t,updated:r}=f(i,c),o=[],l=c?.getAllOverrideIdentifiers()||[],u=i?.getAllOverrideIdentifiers()||[];if(i){const d=u.filter(v=>!l.includes(v));for(const v of d)o.push([v,i.getKeysForOverrideIdentifier(v)])}if(c){const d=l.filter(v=>!u.includes(v));for(const v of d)o.push([v,c.getKeysForOverrideIdentifier(v)])}if(i&&c){for(const d of l)if(u.includes(d)){const v=f({contents:c.getOverrideValue(void 0,d)||{},keys:c.getKeysForOverrideIdentifier(d)},{contents:i.getOverrideValue(void 0,d)||{},keys:i.getKeysForOverrideIdentifier(d)});o.push([d,[...v.added,...v.removed,...v.updated]])}}return{added:s,removed:t,updated:r,overrides:o}}function f(c,i){const s=c?i?c.keys.filter(o=>i.keys.indexOf(o)===-1):[...c.keys]:[],t=i?c?i.keys.filter(o=>c.keys.indexOf(o)===-1):[...i.keys]:[],r=[];if(c&&i){for(const o of i.keys)if(c.keys.indexOf(o)!==-1){const l=(0,b.getConfigurationValue)(i.contents,o),u=(0,b.getConfigurationValue)(c.contents,o);I.equals(l,u)||r.push(o)}}return{added:s,removed:t,updated:r}}}),define(ne[198],re([0,1,18,3,2,31,14,19,69,42,8,59,40]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class S extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new h(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(m.Registry.as(P.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:a})=>this.onDidUpdateConfiguration(g,a))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(g,a){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=S;class h extends E.ConfigurationModel{constructor(g={}){const a=m.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(a),c=Object.create(null),i=[];for(const s in a){const t=g[s],r=t!==void 0?t:a[s].default;(0,I.addToValueTree)(c,s,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const s of Object.keys(c))P.OVERRIDE_PROPERTY_REGEX.test(s)&&i.push({identifiers:(0,P.overrideIdentifiersFromKey)(s),keys:Object.keys(c[s]),contents:(0,I.toValuesTree)(c[s],t=>console.error(`Conflict in default settings file: ${t}`))});super(c,f,i)}}e.DefaultConfigurationModel=h;class y{constructor(){this.onDidChangeConfiguration=n.Event.None,this.configurationModel=new E.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=y;let C=class extends k.Disposable{constructor(g,a,f){super(),this.defaultConfiguration=g,this.policyService=a,this.logService=f,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new E.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.registerPolicyDefinitions(g),!0))),this._configurationModel}async registerPolicyDefinitions(g){const a={},f=[],c=m.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(const i of g){const s=c[i];if(!s){f.push(i);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.logService.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}f.push(i),a[s.policy.name]={type:s.type}}}return(0,A.isEmptyObject)(a)||await this.policyService.registerPolicyDefinitions(a),f}onDidChangePolicies(g){const a=m.Registry.as(P.Extensions.Configuration).getPolicyConfigurations(),f=(0,R.coalesce)(g.map(c=>a.get(c)));this.update(f,!0)}update(g,a){const f=m.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),c=[],i=this._configurationModel.isEmpty();for(const s of g){const t=f[s]?.policy?.name;if(t){const r=this.policyService.getPolicyValue(t);(i?r!==void 0:!(0,T.equals)(this._configurationModel.getValue(s),r))&&c.push([s,r])}else this._configurationModel.getValue(s)!==void 0&&c.push([s,void 0])}if(c.length){const s=this._configurationModel;this._configurationModel=new E.ConfigurationModel;for(const t of s.keys)this._configurationModel.setValue(t,s.getValue(t));for(const[t,r]of c)r===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,r);a&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};C=pe([G(1,w.IPolicyService),G(2,b.ILogService)],C),e.PolicyConfiguration=C}),define(ne[199],re([0,1,6,3,2,17,19,69,198,59]),function(Q,e,R,n,k,T,A,I,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends k.Disposable{constructor(m,S,h,y){super(),this.settingsResource=m,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new E.DefaultConfiguration),this.policyConfiguration=h instanceof P.NullPolicyService?new E.NullPolicyConfiguration:this._register(new E.PolicyConfiguration(this.defaultConfiguration,h,y)),this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,S)),this.configuration=new I.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:C,properties:p})=>this.onDidDefaultConfigurationChange(C,p))),this._register(this.policyConfiguration.onDidChangeConfiguration(C=>this.onDidPolicyConfigurationChange(C))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[m,S,h]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new I.Configuration(m,S,new I.ConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(m,S){const h=typeof m=="string"?m:void 0,y=(0,A.isConfigurationOverrides)(m)?m:(0,A.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(h,y,void 0)}updateValue(m,S,h,y){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const S=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(h,S,2)}onDidDefaultConfigurationChange(m,S){const h=this.configuration.toData(),y=this.configuration.compareAndUpdateDefaultConfiguration(m,S);this.trigger(y,h,7)}onDidPolicyConfigurationChange(m){const S=this.configuration.toData(),h=this.configuration.compareAndUpdatePolicyConfiguration(m);this.trigger(h,S,7)}trigger(m,S,h){const y=new I.ConfigurationChangeEvent(m,{data:S},this.configuration);y.source=h,y.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(m){switch(m){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(ne[200],re([0,1,9,5]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,n.createDecorator)("remoteAuthorityResolverService");var k;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends R.ErrorNoTelemetry{constructor(I,E=k.Unknown,P){super(I),this._message=I,this._code=E,this._detail=P,this.isHandled=E===k.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(I){return I instanceof T&&I._code===k.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof T&&I._code===k.NoResolverFound}static isHandled(I){return I instanceof T&&I.isHandled}}e.RemoteAuthorityResolverError=T}),define(ne[99],re([0,1,20]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function n(P){return P.scheme===R.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=n;function k(P){if(!P)return;const b=P.indexOf("+");return b<0?P:P.substr(0,b)}e.getRemoteName=k;function T(P){return`/${P.quality??"oss"}-${P.commit??"dev"}`}e.getRemoteServerRootPath=T;function A(P){const{host:b,port:w}=E(P);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:w}}e.parseAuthorityWithPort=A;function I(P,b){let{host:w,port:m}=E(P);return typeof m>"u"&&(m=b),{host:w,port:m}}e.parseAuthorityWithOptionalPort=I;function E(P){const b=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const w=P.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const m=P.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:P,port:void 0}}}),define(ne[43],re([0,1,24,5,99]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=T;function A(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var E;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,C){if(typeof y>"u"||y===null)return typeof C>"u"||C===null;if(typeof C>"u"||C===null)return!1;if(typeof y=="string"||typeof C=="string"){const p=typeof y=="string"?y:y.value,g=typeof C=="string"?C:C.value;return R.equalsIgnoreCase(p,g)}return y._lower===C._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=P;function b(h){return w(h)}e.isApplicationScopedExtension=b;function w(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function m(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function S(h,y){if(y){const C=`onResolveRemoteAuthority:${(0,k.getRemoteName)(y)}`;return h.activationEvents?.indexOf(C)!==-1}return!1}e.isResolverExtension=S,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[32],re([0,1,24,29,43,4,7,9,36]),function(Q,e,R,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(s,t){return s.uuid&&t.uuid?s.uuid===t.uuid:s.id===t.id?!0:(0,R.compareIgnoreCase)(s.id,t.id)===0}e.areSameExtensions=P;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{constructor(t,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=t.id}static create(t){const r=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new w(t.identifier,r,o)}static parse(t){const r=b.exec(t);return r&&r[1]&&r[2]?new w({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof w?P(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=w;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(s){const t=m.exec(s);return t&&t[1]?[y(t[1]),t[2]]:[y(s),void 0]}e.getIdAndVersion=S;function h(s,t){return`${s}.${t}`}e.getExtensionId=h;function y(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=y;function C(s,t){return y(h(s,t))}e.getGalleryExtensionId=C;function p(s,t){const r=[],o=l=>{for(const u of r)if(u.some(d=>P(t(d),t(l))))return u;return null};for(const l of s){const u=o(l);u?u.push(l):r.push([l])}return r}e.groupByExtension=p;function g(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function a(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=a,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function f(s,t){const r=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&r.every(u=>!P(u.identifier,{id:l}))){const u=s.filter(d=>P(d.identifier,{id:l}));u.length===1&&(r.push(u[0]),o.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=f;async function c(s,t){if(!T.isLinux)return!1;let r;try{r=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){t.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(l))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=c;async function i(s,t){const r=await c(s,t),o=(0,n.getTargetPlatform)(r?"alpine":T.platform,E.arch);return t.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=i}),define(ne[48],re([0,1,6,16,2,34,7,32,13,5,8]),function(Q,e,R,n,k,T,A,I,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,P.createDecorator)("IExtensionsProfileScannerService");let w=class extends k.Disposable{constructor(S,h){super(),this.fileService=S,this.logService=h,this.resourcesAccessQueueMap=new T.ResourceMap}scanProfileExtensions(S){return this.withProfileExtensions(S)}addExtensionsToProfile(S,h){return this.withProfileExtensions(h,y=>(y=y.filter(C=>S.some(([p])=>!(0,I.areSameExtensions)(C.identifier,p.identifier))),y.push(...S.map(([C,p])=>({identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:p}))),y))}removeExtensionFromProfile(S,h){return this.withProfileExtensions(h,y=>y.filter(C=>!(0,I.areSameExtensions)(C.identifier,S)))}async withProfileExtensions(S,h){return this.getResourceAccessQueue(S).queue(async()=>{let y=[];try{const C=await this.fileService.readFile(S),p=JSON.parse(C.value.toString());for(const g of p){if(!g.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",g);continue}if(!g.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",g);continue}if(!g.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",g);continue}y.push({identifier:g.identifier,location:A.URI.revive(g.location),version:g.version,metadata:g.metadata})}}catch(C){C.fileOperationResult!==1&&this.logService.error(C)}if(h){y=h(y);const C=y.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),metadata:p.metadata}));await this.fileService.writeFile(S,n.VSBuffer.fromString(JSON.stringify(C)))}return y})}getResourceAccessQueue(S){let h=this.resourcesAccessQueueMap.get(S);return h||(h=new R.Queue,this.resourcesAccessQueueMap.set(S,h)),h}};w=pe([G(0,E.IFileService),G(1,b.ILogService)],w),e.ExtensionsProfileScannerService=w}),define(ne[201],re([0,1,21,32]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function k(T,A,I,E,P){try{const b=await T.getExtensionsControlManifest();if(!b.deprecated)return;const w=await T.getInstalled(1);for(const[m,S]of Object.entries(b.deprecated)){if(!S?.extension)continue;const{id:h,autoMigrate:y,preRelease:C}=S.extension;if(!y)continue;const p=w.find(a=>(0,n.areSameExtensions)(a.identifier,{id:m}));if(!p)continue;const g=(await A.getExtensions([{id:h,preRelease:C}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!g){P.info(`Skipping migrating '${p.identifier.id}' extension because, the comaptible target '${h}' extension is not found`);continue}try{P.info(`Migrating '${p.identifier.id}' extension to '${h}' extension...`);const a=!E.getDisabledExtensions().some(c=>(0,n.areSameExtensions)(c,p.identifier));await T.uninstall(p),P.info(`Uninstalled the unsupported extension '${p.identifier.id}'`);let f=w.find(c=>(0,n.areSameExtensions)(c.identifier,{id:h}));(!f||!f.isPreReleaseVersion&&a)&&(f=await T.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:p.isMachineScoped,operation:4}),P.info(`Installed the pre-release extension '${f.identifier.id}'`),a||(await E.disableExtension(f.identifier),P.info(`Disabled the pre-release extension '${f.identifier.id}' because the unsupported extension '${p.identifier.id}' is disabled`)),y.storage&&(I.addToMigrationList((0,n.getExtensionId)(p.manifest.publisher,p.manifest.name),(0,n.getExtensionId)(f.manifest.publisher,f.manifest.name)),P.info("Added pre-release extension to the storage migration list"))),P.info(`Migrated '${p.identifier.id}' extension to '${h}' extension.`)}catch(a){P.error(a)}}}catch(b){P.error(b)}}e.migrateUnsupportedExtensions=k}),define(ne[202],re([0,1,6,9,2,4,17,55,7,30,27,15,29,32,13,8]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let C=class extends k.Disposable{constructor(g,a,f,c){super(),this.fileService=a,this.extensionGalleryService=f,this.logService=c,this.extensionsDownloadDir=E.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,a){await this.cleanUpPromise;const f=this.getName(g),c=(0,A.joinPath)(this.extensionsDownloadDir,f);if(!await this.fileService.exists(c)){const i=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(g,i,a);try{await this.rename(i,c,Date.now()+2*60*1e3)}catch(s){try{await this.fileService.del(i)}catch{}if(s.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(s)}. Deleted the vsix from downloaded location`,i.path),s}}return c}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,a,f){try{await b.Promises.rename(g.fsPath,a.fsPath)}catch(c){if(T.isWindows&&c&&c.code==="EPERM"&&Date.now()<f)return this.logService.info(`Failed renaming ${g} to ${a} with 'EPERM' error. Trying again...`),this.rename(g,a,f);throw c}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const a=[],f=[];for(const s of g.children){const t=S.ExtensionKey.parse(s.name);t&&f.push([t,s])}const c=(0,S.groupByExtension)(f,([s])=>s),i=[];for(const s of c)s.sort((t,r)=>I.rcompare(t[0].version,r[0].version)),a.push(...s.slice(1).map(t=>t[1].resource)),i.push(s[0][1]);i.sort((s,t)=>s.mtime-t.mtime),a.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(s=>s.resource)),await R.Promises.settled(a.map(s=>(this.logService.trace("Deleting vsix from cache",s.path),this.fileService.del(s))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?S.ExtensionKey.create(g).toString().toLowerCase():(0,P.generateUuid)()}};C=pe([G(0,w.INativeEnvironmentService),G(1,h.IFileService),G(2,m.IExtensionGalleryService),G(3,y.ILogService)],C),e.ExtensionsDownloader=C}),define(ne[203],re([0,1,2,10,27,43]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends R.Disposable{constructor(E,P){super(),this.environmentService=E,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(P.onDidInstallExtensions(b=>this.onDidInstallExtensions(b))),this._register(P.onDidUninstallExtension(b=>this.onDidUnInstallExtension(b)))}onDidInstallExtensions(E){E.some(P=>!!P.local)&&this.invalidate()}onDidUnInstallExtension(E){E.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(ne[204],re([0,1,93,18,6,2,20,10,27,15,29,32,8,68]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let h=class extends S.LanguagePackBaseService{constructor(g,a,f,c){super(f),this.extensionManagementService=g,this.logService=c,this.cache=this._register(new y(a,c)),this.extensionManagementService.registerParticipant({postInstall:async i=>this.postInstallExtension(i),postUninstall:async i=>this.postUninstallExtension(i)})}async getInstalledLanguages(){const g=await this.cache.getLanguagePacks(),a=Object.keys(g).map(f=>{const c=g[f];return{...this.createQuickPickItem(f,c.label),extensionId:c.extensions[0].extensionIdentifier.id}});return a.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),a.sort((f,c)=>f.label.localeCompare(c.label)),a}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const a=await this.cache.getLanguagePacks();Object.keys(a).some(f=>a[f]&&a[f].extensions.some(c=>(0,w.areSameExtensions)(c.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,a]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(a);return!(0,n.equals)(Object.keys(g),Object.keys(f))}};h=pe([G(0,b.IExtensionManagementService),G(1,P.INativeEnvironmentService),G(2,b.IExtensionGalleryService),G(3,m.ILogService)],h),e.NativeLanguagePackService=h;let y=class extends T.Disposable{constructor(g,a){super(),this.logService=a,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new k.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(a=>{Object.keys(a).forEach(f=>delete a[f]),this.createLanguagePacksFromExtensions(a,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...a){for(const f of a)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,f);Object.keys(g).forEach(f=>this.updateHash(g[f]))}createLanguagePacksFromExtension(g,a){const f=a.identifier,c=a.manifest.contributes&&a.manifest.contributes.localizations?a.manifest.contributes.localizations:[];for(const i of c)if(a.location.scheme===A.Schemas.file&&C(i)){let s=g[i.languageId];s||(s={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},g[i.languageId]=s);const t=s.extensions.filter(r=>(0,w.areSameExtensions)(r.extensionIdentifier,f))[0];t?t.version=a.manifest.version:s.extensions.push({extensionIdentifier:f,version:a.manifest.version});for(const r of i.translations)s.translations[r.id]=(0,I.join)(a.location.fsPath,r.path)}}updateHash(g){if(g){const a=(0,R.createHash)("md5");for(const f of g.extensions)a.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);g.hash=a.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let a=null;return E.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch{return{}}}).then(f=>(a=g(f),f)).then(f=>{for(const i of Object.keys(f))f[i]||delete f[i];this.languagePacks=f,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),E.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>a,f=>this.logService.error(f))})}};y=pe([G(0,P.INativeEnvironmentService),G(1,m.ILogService)],y);function C(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const g of p.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(ne[205],re([0,1,6,16,21,9,3,2,30,85,200,99]),function(Q,e,R,n,k,T,A,I,E,P,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const m=30*1e3;var S;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(S=e.ConnectionType||(e.ConnectionType={}));function h(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function y(z){const V=new k.CancellationTokenSource;return setTimeout(()=>V.cancel(),z),V.token}function C(z,V){if(z.isCancellationRequested||V.isCancellationRequested)return k.CancellationToken.Cancelled;const O=new k.CancellationTokenSource;return z.onCancellationRequested(()=>O.cancel()),V.onCancellationRequested(()=>O.cancel()),O.token}class p{constructor(V){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((O,N)=>{this._resolvePromise=O,this._rejectPromise=N}),V.isCancellationRequested?this._timeout():this._disposables.add(V.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(V){this._state==="pending"?this._disposables.add(V):V.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const V=new Error("Time limit reached");return V.code="ETIMEDOUT",V.syscall="connect",V}resolve(V){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(V))}reject(V){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(V))}}function g(z,V){const O=new p(V);return O.registerDisposable(z.onControlMessage(N=>{const W=JSON.parse(N.toString()),x=q(W);x?O.reject(x):O.resolve(W)})),O.promise}function a(z,V,O,N,W,x,Z,oe){const X=new p(oe);return V.connect(O,N,W,x,Z,(ie,se)=>{X.didTimeout?(ie&&z.error(ie),se?.dispose()):ie||!se?X.reject(ie):X.resolve(se)}),X.promise}function f(z,V){const O=new p(V);return z.then(N=>{O.didTimeout||O.resolve(N)},N=>{O.didTimeout||O.reject(N)}),O.promise}async function c(z,V,O,N){const W=te(z,V);z.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let x;try{x=await a(z.logService,z.socketFactory,z.host,z.port,(0,w.getRemoteServerRootPath)(z),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,`renderer-${h(V)}-${z.reconnectionToken}`,N)}catch(se){throw z.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),z.logService.error(se),se}z.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let Z,oe;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(x,null),Z=z.reconnectionProtocol,oe=!1):(Z=new P.PersistentProtocol(x,null),oe=!0),z.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const X=await f(z.signService.createNewMessage((0,E.generateUuid)()),N),ie={type:"auth",auth:z.connectionToken||"00000000000000000000",data:X.data};Z.sendControl(n.VSBuffer.fromString(JSON.stringify(ie)));try{const se=await g(Z,C(N,y(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(z.logService.trace(`${W} 4/6. received SignRequest control message.`),!await f(z.signService.validate(X,se.signedData),N)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const he=await f(z.signService.sign(se.data),N),ve={type:"connectionType",commit:z.commit,signedData:he,desiredConnectionType:V};return O&&(ve.args=O),z.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(n.VSBuffer.fromString(JSON.stringify(ve))),{protocol:Z,ownsProtocol:oe}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(z.logService.error(`${W} the handshake timed out. Error:`),z.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${W} received error control message when negotiating connection. Error:`),z.logService.error(se)),oe&&K(Z),se}}async function i(z,V,O,N){const W=Date.now(),x=te(z,V),{protocol:Z,ownsProtocol:oe}=await c(z,V,O,N),X=new p(N);return X.registerDisposable(Z.onControlMessage(ie=>{const se=JSON.parse(ie.toString()),ue=q(se);ue?(z.logService.error(`${x} received error control message when negotiating connection. Error:`),z.logService.error(ue),oe&&K(Z),X.reject(ue)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${ce(W)}!`),X.resolve({protocol:Z,firstMessage:se}))})),X.promise}async function s(z,V){const{protocol:O}=await i(z,1,void 0,V);return{protocol:O}}async function t(z,V,O){const{protocol:N,firstMessage:W}=await i(z,2,V,O),x=W&&W.debugPort;return{protocol:N,debugPort:x}}async function r(z,V,O){const N=Date.now(),W=te(z,3),{protocol:x}=await c(z,3,V,O);return z.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${ce(N)}!`),x}async function o(z,V,O){const{host:N,port:W,connectionToken:x}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,host:N,port:W,connectionToken:x,reconnectionToken:V,reconnectionProtocol:O,socketFactory:z.socketFactory,signService:z.signService,logService:z.logService}}async function l(z,V,O){return d(z,async N=>{const{protocol:W}=await s(N,k.CancellationToken.None);return new J(z,V,O,N.reconnectionToken,W)})}e.connectRemoteAgentManagement=l;async function u(z,V){return d(z,async O=>{const{protocol:N,debugPort:W}=await t(O,V,k.CancellationToken.None);return new H(z,V,O.reconnectionToken,N,W)})}e.connectRemoteAgentExtensionHost=u;async function d(z,V){for(let N=1;;N++)try{const W=(0,E.generateUuid)(),x=await o(z,W,null);return await V(x)}catch(W){if(N<5)z.logService.error(`[remote-connection][attempt ${N}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(W);else throw z.logService.error(`[remote-connection][attempt ${N}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(W),j.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(W)),W}}async function v(z,V,O){const N=await o(z,(0,E.generateUuid)(),null);return await r(N,{host:V,port:O},k.CancellationToken.None)}e.connectRemoteAgentTunnel=v;function L(z){return(0,R.createCancelablePromise)(V=>new Promise((O,N)=>{const W=setTimeout(O,z*1e3);V.onCancellationRequested(()=>{clearTimeout(W),O()})}))}var _;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(_=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class M{constructor(V,O){this.reconnectionToken=V,this.millisSinceLastIncomingData=O,this.type=0}}e.ConnectionLostEvent=M;class U{constructor(V,O,N,W){this.reconnectionToken=V,this.millisSinceLastIncomingData=O,this.durationSeconds=N,this.cancellableTimer=W,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=U;class D{constructor(V,O,N){this.reconnectionToken=V,this.millisSinceLastIncomingData=O,this.attempt=N,this.type=2}}e.ReconnectionRunningEvent=D;class F{constructor(V,O,N){this.reconnectionToken=V,this.millisSinceLastIncomingData=O,this.attempt=N,this.type=4}}e.ConnectionGainEvent=F;class ${constructor(V,O,N,W){this.reconnectionToken=V,this.millisSinceLastIncomingData=O,this.attempt=N,this.handled=W,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class j extends I.Disposable{constructor(V,O,N,W,x){super(),this._connectionType=V,this._options=O,this.reconnectionToken=N,this.protocol=W,this._reconnectionFailureIsFatal=x,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new F(this.reconnectionToken,0,0)),this._register(W.onSocketClose(Z=>{const oe=Y(this._connectionType,this.reconnectionToken,!0);Z?Z.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this._options.logService.error(Z.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this._options.logService.error(Z.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(W.onSocketTimeout(Z=>{const oe=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),j._instances.push(this),this._register((0,I.toDisposable)(()=>{const Z=j._instances.indexOf(this);Z>=0&&j._instances.splice(Z,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(j._permanentFailureMillisSinceLastIncomingData,j._permanentFailureAttempt,j._permanentFailureHandled)}static triggerPermanentFailure(V,O,N){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=V,this._permanentFailureAttempt=O,this._permanentFailureHandled=N,this._instances.forEach(W=>W._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(V=>V._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(V=>V._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||j._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const V=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${V} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const W=N<O.length?O[N]:O[O.length-1];try{if(W>0){const Z=L(W);this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,Z)),this._options.logService.info(`${V} waiting for ${W} seconds before reconnecting...`);try{await Z}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${V} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new D(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this._options.logService.info(`${V} resolving connection...`);const x=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${V} connecting to ${x.host}:${x.port}...`),await this._reconnect(x,y(m)),this._options.logService.info(`${V} reconnected!`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(x){if(x.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${V} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this._options.logService.error(`${V} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(x)){this._options.logService.info(`${V} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if((x.code==="ETIMEDOUT"||x.code==="ENETUNREACH"||x.code==="ECONNREFUSED"||x.code==="ECONNRESET")&&x.syscall==="connect"){this._options.logService.info(`${V} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if((0,T.isCancellationError)(x)){this._options.logService.info(`${V} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if(x instanceof b.RemoteAuthorityResolverError){this._options.logService.error(`${V} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,b.RemoteAuthorityResolverError.isHandled(x));break}this._options.logService.error(`${V} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(V,O,N){this._reconnectionFailureIsFatal?j.triggerPermanentFailure(V,O,N):this._gotoPermanentFailure(V,O,N)}_gotoPermanentFailure(V,O,N){this._onDidStateChange.fire(new $(this.reconnectionToken,V,O,N)),K(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=j,j._permanentFailure=!1,j._permanentFailureMillisSinceLastIncomingData=0,j._permanentFailureAttempt=0,j._permanentFailureHandled=!1,j._instances=[];class J extends j{constructor(V,O,N,W,x){super(1,V,W,x,!0),this.client=this._register(new P.Client(x,{remoteAuthority:O,clientId:N},V.ipcLogger))}async _reconnect(V,O){await s(V,O)}}e.ManagementPersistentConnection=J;class H extends j{constructor(V,O,N,W,x){super(2,V,N,W,!1),this._startArguments=O,this.debugPort=x}async _reconnect(V,O){await t(V,this._startArguments,O)}}e.ExtensionHostPersistentConnection=H;function K(z){try{z.acceptDisconnect();const V=z.getSocket();z.dispose(),V.dispose()}catch(V){(0,T.onUnexpectedError)(V)}}function q(z){if(z&&z.type==="error"){const V=new Error(`Connection error: ${z.reason}`);return V.code="VSCODE_CONNECTION_ERROR",V}return null}function B(z,V){for(;z.length<V;)z+=" ";return z}function Y(z,V,O){return`[remote-connection][${B(h(z),13)}][${V.substr(0,5)}\u2026][${O?"reconnect":"initial"}]`}function te(z,V){return`${Y(V,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.host}:${z.port}]`}function ce(z){return`${Date.now()-z} ms`}}),define(ne[206],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[207],re([0,1,77,137]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,T,A,I,E,P){const b=m=>P(m,void 0),w=R.createConnection({host:k,port:T},()=>{w.removeListener("error",b);const m=Buffer.alloc(16);for(let C=0;C<16;C++)m[C]=Math.round(Math.random()*256);const S=m.toString("base64"),h=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${T}${A}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`];w.write(h.join(`\r
`)+`\r
\r
`);const y=C=>{C.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",y),P(void 0,new n.NodeSocket(w,E)))};w.on("data",y)});w.setNoDelay(!0),w.once("error",b)}}}),define(ne[208],re([0,1,120,19,8]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(I,E){this.configurationService=I,this.logService=E}async request(I,E){this.logService.trace("RequestService#request (browser) - begin",I.url),I.proxyAuthorization||(I.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const P=await(0,R.request)(I,E);return this.logService.trace("RequestService#request (browser) - success",I.url),P}catch(P){throw this.logService.error("RequestService#request (browser) - error",I.url,P),P}}async resolveProxy(I){}};T=pe([G(0,n.IConfigurationService),G(1,k.ILogService)],T),e.RequestService=T}),define(ne[44],re([0,1,16,155,42,5,40]),function(Q,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function I(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.isSuccess=I;function E(y){return y.res.statusCode===204}async function P(y){return E(y)?null:(await(0,R.streamToBuffer)(y.stream)).toString()}e.asText=P;async function b(y){if(!I(y))throw new Error("Server returned "+y.res.statusCode);return P(y)}e.asTextOrError=b;async function w(y){if(!I(y))throw new Error("Server returned "+y.res.statusCode);if(E(y))return null;const p=(await(0,R.streamToBuffer)(y.stream)).toString();try{return JSON.parse(p)}catch(g){throw g.message+=`:
`+p,g}}e.asJson=w;function m(y){h(y)}e.updateProxyConfigurationsScope=m;let S;function h(y){const C=A.Registry.as(k.Extensions.Configuration),p=S;S={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},C.updateConfigurations({add:[S],remove:p?[p]:[]})}h(2)}),define(ne[209],re([0,1,21,20,13,44]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(E,P){this.requestService=E,this.fileService=P}async download(E,P,b=R.CancellationToken.None){if(E.scheme===n.Schemas.file||E.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(E,P);return}const w={type:"GET",url:E.toString(!0)},m=await this.requestService.request(w,b);if(m.res.statusCode===200)await this.fileService.writeFile(P,m.stream);else{const S=await(0,T.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${S}`)}}};A=pe([G(0,T.IRequestService),G(1,k.IFileService)],A),e.DownloadService=A}),define(ne[210],re([0,1,18,21,2,17,172,13,8,25,44]),function(Q,e,R,n,k,T,A,I,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let w=class extends k.Disposable{constructor(S,h,y,C){super(),this.fileService=S,this.productService=h,this.requestService=y,this.logService=C,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,p])=>this.allConfigBasedTips.set(p.configPath,p))}getConfigBasedTips(S){return this.getValidConfigBasedTips(S)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(S){const h=[];for(const[y,C]of this.allConfigBasedTips)if(!(C.configScheme&&C.configScheme!==S.scheme))try{const p=await this.fileService.readFile((0,T.joinPath)(S,y)),g=new Map;Object.entries(C.recommendations).forEach(([f,c])=>{if((0,R.isNonEmptyArray)(c.remotes))for(const i of c.remotes)g.set(i,{extensionId:f,extensionName:c.name,configName:C.configName,important:!!c.important,isExtensionPack:!!c.isExtensionPack,whenNotInstalled:c.whenNotInstalled});else h.push({extensionId:f,extensionName:c.name,configName:C.configName,important:!!c.important,isExtensionPack:!!c.isExtensionPack,whenNotInstalled:c.whenNotInstalled})});const a=(0,A.getDomainsOfRemotes)(p.value.toString(),[...g.keys()]);for(const f of a){const c=g.get(f);c&&h.push(c)}}catch{}return h}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const S=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},n.CancellationToken.None);if(S.res.statusCode!==200)return[];const h=await(0,b.asJson)(S);return h?h.workspaceRecommendations||[]:[]}catch(S){return this.logService.error(S),[]}}};w=pe([G(0,I.IFileService),G(1,P.IProductService),G(2,b.IRequestService),G(3,E.ILogService)],w),e.ExtensionTipsService=w}),define(ne[211],re([0,1,16,21]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(I){this.service=I}listen(I,E){throw new Error("Invalid listen")}call(I,E,P,b=n.CancellationToken.None){switch(E){case"request":return this.service.request(P[0],b).then(async({res:w,stream:m})=>{const S=await(0,R.streamToBuffer)(m);return[{statusCode:w.statusCode,headers:w.headers},S]});case"resolveProxy":return this.service.resolveProxy(P[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class T{constructor(I){this.channel=I}async request(I,E){const[P,b]=await this.channel.call("request",[I],E);return{res:P,stream:(0,R.bufferToStream)(b)}}async resolveProxy(I){return this.channel.call("resolveProxy",[I])}}e.RequestChannelClient=T}),define(ne[212],re([0,1,208,211]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class k{constructor(A,I,E){this.configurationService=I,this.logService=E,this.browserRequestService=new R.RequestService(I,E),this.mainRequestService=new n.RequestChannelClient(A.getChannel("request"))}request(A,I){return this.getRequestService().request(A,I)}async resolveProxy(A){return this.getRequestService().resolveProxy(A)}getRequestService(){return this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}}e.SharedProcessRequestService=k}),define(ne[100],re([0,1,63,5]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function k(T){return(0,R.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=k,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[213],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var R;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(R=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[214],re([0,1,86,6,21,3,2,20,30,8,100,213]),function(Q,e,R,n,k,T,A,I,E,P,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let m=class{constructor(y){this.logService=y,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(y){const C=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${C})`);const p=(0,b.hash)(y);this.processeDisposables.has(p)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${C})`),this.doDisposeWorker(y));const g=new k.CancellationTokenSource;let a,f,c;this.processeDisposables.set(p,r=>{g.dispose(!0),a?.terminate(y,k.CancellationToken.None),f?.close(),c?.close(),this.processeDisposables.delete(p);const o=this.processResolvers.get(p);o&&(this.processResolvers.delete(p),o({reason:r}))}),a=await this.getOrCreateWebWorker(y);const i=new Promise(r=>{this.processResolvers.set(p,r)});if(g.token.isCancellationRequested)return i;const{port1:s,port2:t}=new MessageChannel;return f=s,c=t,await a.spawn(y,c,g.token),g.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${C})`),R.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",y,[f])),i}getOrCreateWebWorker(y){let C=this.workers.get(y.process.moduleId);if(!C){this.logService.trace(`SharedProcess: creating new web worker (${y.process.moduleId})`);const p=new S(y.process.type,this.logService);C=p.init(),p.onDidProcessSelfTerminate(({configuration:g,reason:a})=>{this.doDisposeWorker(g,a)}),this.workers.set(y.process.moduleId,C)}return C}async disposeWorker(y){return this.doDisposeWorker(y)}doDisposeWorker(y,C){const p=this.processeDisposables.get((0,b.hash)(y));p&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),p(C))}};m=pe([G(0,P.ILogService)],m),e.SharedProcessWorkerService=m;class S extends A.Disposable{constructor(y,C){super(),this.type=y,this.logService=C,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const y=new n.DeferredPromise,C=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return C.onerror=p=>{this.logService.error(`SharedProcess: worker error (${this.type})`,p.message)},C.onmessageerror=p=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,p)},C.onmessage=p=>{const{id:g,message:a,configuration:f,nonce:c}=p.data;switch(g){case w.SharedProcessWorkerMessages.Ready:y.complete(C);break;case w.SharedProcessWorkerMessages.Ack:if(c){const i=this.mapMessageNonceToPendingMessageResolve.get(c);i&&(this.mapMessageNonceToPendingMessageResolve.delete(c),i())}break;case w.SharedProcessWorkerMessages.SelfTerminated:f&&a&&this._onDidProcessSelfTerminate.fire({configuration:f,reason:JSON.parse(a)});break;case w.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,a);break;case w.SharedProcessWorkerMessages.Info:a&&this.logService.info(a);break;case w.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,a);break;case w.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,a);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,p)}},C.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),y.p}async send(y,C,p){const g=await this.workerReady;if(!C.isCancellationRequested)return new Promise(a=>{const f=(0,E.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(f,a);const c={...y,nonce:f};p?g.postMessage(c,[p]):g.postMessage(c),C.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(f)&&a()})})}spawn(y,C,p){const g={id:w.SharedProcessWorkerMessages.Spawn,configuration:y,environment:{bootstrapPath:I.FileAccess.asFileUri("bootstrap-fork",Q).fsPath}};return this.send(g,p,C)}terminate(y,C){const p={id:w.SharedProcessWorkerMessages.Terminate,configuration:y};return this.send(p,C)}}}),define(ne[215],re([0,1,61,20,171]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends k.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.vscodeUserData})}}pe([R.memoize],T.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=T}),define(ne[216],re([0,1,54,10,156,21,38,9,4,30,134,169,6]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const S=1e4;let h;async function y(p,g,a){return g["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):E.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(a)&&!g["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(a)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=m.Promises.withAsyncBody(async(f,c)=>{const i=new T.CancellationTokenSource,s=setTimeout(()=>{i.dispose(!0),c(new Error((0,k.localize)(0,null)))},S);try{f(await C(p,i.token))}catch(t){!(0,I.isCancellationError)(t)&&!i.token.isCancellationRequested?c(new Error((0,k.localize)(1,null,(0,A.toErrorMessage)(t)))):f({})}finally{clearTimeout(s),i.dispose()}})),h)}e.getResolvedShellEnv=y;async function C(p,g){const a=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",a);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",f);const c=(0,P.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(c+"(.*)"+c),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",s);const t=await(0,b.getSystemShell)(E.OS,s);return p.trace("getUnixShellEnvironment#shell",t),new Promise((r,o)=>{if(g.isCancellationRequested)return o((0,I.canceled)());const l=(0,n.basename)(t);let u,d;const v=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(u=`& '${process.execPath}' ${v} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,d=["-Login","-Command"]):(u=`'${process.execPath}' ${v} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,l==="tcsh"?d=["-ic"]:d=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),u);const L=(0,R.spawn)(t,[...d,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});g.onCancellationRequested(()=>(L.kill(),o((0,I.canceled)()))),L.on("error",U=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(U)),o(U)});const _=[];L.stdout.on("data",U=>_.push(U));const M=[];L.stderr.on("data",U=>M.push(U)),L.on("close",(U,D)=>{const F=Buffer.concat(_).toString("utf8");p.trace("getUnixShellEnvironment#raw",F);const $=Buffer.concat(M).toString("utf8");if($.trim()&&p.trace("getUnixShellEnvironment#stderr",$),U||D)return o(new Error((0,k.localize)(2,null,U,D)));const j=i.exec(F),J=j?j[1]:"{}";try{const H=JSON.parse(J);a?H.ELECTRON_RUN_AS_NODE=a:delete H.ELECTRON_RUN_AS_NODE,f?H.ELECTRON_NO_ATTACH_CONSOLE=f:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",H),r(H)}catch(H){p.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(H)),o(H)}})})}}),define(ne[101],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[217],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R{constructor(){this.validators=new Map}vsda(){return new Promise((k,T)=>Q(["vsda"],k,T))}async createNewMessage(k){try{const T=await this.vsda(),A=new T.validator;if(A){const I=String(R._nextId++);return this.validators.set(I,A),{id:I,data:A.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,T){if(!k.id)return!0;const A=this.validators.get(k.id);if(!A)return!1;this.validators.delete(k.id);try{return A.validate(T)==="ok"}catch{return!1}}async sign(k){try{const T=await this.vsda(),A=new T.signer;if(A)return A.sign(k)}catch{}return k}}e.SignService=R,R._nextId=1}),define(ne[102],re([0,1,3,2]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class k extends n.Disposable{constructor(w,m,S){super(),this.channel=w,this.profile=m,this.workspace=S}async getItems(){const w={profile:this.profile,workspace:this.workspace},m=await this.channel.call("getItems",w);return new Map(m)}updateItems(w){const m={profile:this.profile,workspace:this.workspace};return w.insert&&(m.insert=Array.from(w.insert.entries())),w.delete&&(m.delete=Array.from(w.delete.values())),this.channel.call("updateItems",m)}}class T extends k{constructor(w,m){super(w,m,void 0),this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(w=>this.onDidChangeStorage(w)))}onDidChangeStorage(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this._onDidChangeItemsExternal.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}}class A extends T{constructor(w){super(w,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=A;class I extends T{constructor(w,m){super(w,m)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=I;class E extends k{constructor(w,m){super(w,void 0,m),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=E;class P{constructor(w){this.channel=w}isUsed(w){const m={payload:w,profile:void 0,workspace:void 0};return this.channel.call("isUsed",m)}}e.StorageClient=P}),define(ne[103],re([0,1,4,36,7,30]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(P){if(R.platform===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}async function I(P,b,w,m,S,h,y,C,p,g){const a=Object.create(null);a["common.machineId"]=y,a.sessionID=(0,T.generateUuid)()+Date.now(),a.commitHash=S,a.version=h,a["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,R.PlatformToString)(R.platform),a["common.nodePlatform"]=n.platform,a["common.nodeArch"]=m,a["common.product"]=g||"desktop",C&&(a["common.msftInternal"]=C);let f=0;const c=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),R.isLinuxSnap&&(a["common.snap"]="true");const i=A(w);i&&(a["common.platformDetail"]=i);try{const s=await P.readFile(k.URI.file(p));a["common.source"]=s.value.toString().slice(0,30)}catch{}return a}e.resolveCommonProperties=I;function E(P){const b=n.env.USERDNSDOMAIN;if(!b)return!1;const w=b.toLowerCase();return P.some(m=>w===m)}e.verifyMicrosoftInternalDomain=E}),define(ne[22],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[218],re([0,1,37,51,6,35,20,10,4,7,131,27,133,90,13,25,22]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function g(s,t){const r=`${s}::${t.join(":")}`,o=p.get(r);if(o)return o;const l=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,d=new Map,v=2e4;function L(M,U,D,F){const $=U.substring(M.length+1);return k.Promises.withAsyncBody(async j=>{let J;try{J=await w.Promises.readdir(U,{withFileTypes:!0})}catch{j();return}if(F.count>=v){F.count+=J.length,F.maxReached=!0,j();return}let H=J.length;if(H===0){j();return}let K=J;F.count+J.length>v&&(F.maxReached=!0,H=v-F.count,K=J.slice(0,H)),F.count+=J.length;for(const q of K)if(q.isDirectory()){if(D.includes(q.name)||await L(M,(0,I.join)(U,q.name),D,F),--H===0){j();return}}else{const B=q.name.lastIndexOf(".");if(B>=0){const Y=q.name.substring(B+1);Y&&u.set(Y,(u.get(Y)??0)+1)}for(const Y of l)Y.relativePathPattern?.test($)!==!1&&Y.filePattern.test(q.name)&&d.set(Y.tag,(d.get(Y.tag)??0)+1);if(--H===0){j();return}}})}const _=k.Promises.withAsyncBody(async M=>{const U={count:0,maxReached:!1};await L(s,s,t,U);const D=await c(s);M({configFiles:a(d),fileTypes:a(u),fileCount:U.count,maxFilesReached:U.maxReached,launchConfigFiles:D})});return p.set(r,_),_}e.collectWorkspaceStats=g;function a(s){return[...n.Iterable.map(s.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function f(){const s={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.virtualMachineHint.value()*100)}%`},t=R.cpus();return t&&t.length>0&&(s.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),s}e.getMachineInfo=f;async function c(s){try{const t=new Map,r=(0,I.join)(s,".vscode","launch.json"),o=await w.Promises.readFile(r),l=[],u=(0,T.parse)(o.toString(),l);if(l.length)return console.log(`Unable to parse ${r}`),[];if((0,T.getNodeType)(u)==="object"&&u.configurations)for(const d of u.configurations){const v=d.type;v&&(t.has(v)?t.set(v,t.get(v)+1):t.set(v,1))}return a(t)}catch{return[]}}e.collectLaunchConfigs=c;let i=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const o=R.cpus();return o&&o.length>0&&r.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),r.push(`Memory (System):  ${(R.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),E.isWindows||r.push(`Load (avg):       ${R.loadavg().map(l=>Math.round(l)).join(", ")}`),r.push(`VM:               ${Math.round(b.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([(0,m.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async o=>{let[l,u]=o,d=this.formatProcessList(t,l);return r.forEach(v=>{if((0,S.isRemoteDiagnosticError)(v))d+=`
${v.errorMessage}`,u+=`
${v.errorMessage}`;else if(d+=`

Remote: ${v.hostName}`,v.processes&&(d+=`
${this.formatProcessList(t,v.processes)}`),v.workspaceMetadata){u+=`
|  Remote: ${v.hostName}`;for(const L of Object.keys(v.workspaceMetadata)){const _=v.workspaceMetadata[L];let M=`${_.fileCount} files`;_.maxFilesReached&&(M=`more than ${M}`),u+=`|    Folder (${L}): ${M}`,u+=this.formatWorkspaceStats(_)}}}),{processInfo:d,workspaceInfo:u}})}async getSystemInfo(t,r){const{memory:o,vmHint:l,os:u,cpus:d}=f(),v={os:u,memory:o,cpus:d,vmHint:l,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return E.isWindows||(v.load=`${R.loadavg().map(L=>Math.round(L)).join(", ")}`),E.isLinux&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(t,r){const o=[];return(0,m.listProcesses)(t.mainPID).then(async l=>(o.push(""),o.push(this.formatEnvironment(t)),o.push(""),o.push(this.formatProcessList(t,l)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(t))),r.forEach(u=>{if((0,S.isRemoteDiagnosticError)(u))o.push(`
${u.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${u.hostName}`),o.push(this.formatMachineInfo(u.machineInfo)),u.processes&&o.push(this.formatProcessList(t,u.processes)),u.workspaceMetadata)for(const d of Object.keys(u.workspaceMetadata)){const v=u.workspaceMetadata[d];let L=`${v.fileCount} files`;v.maxFilesReached&&(L=`more than ${L}`),o.push(`Folder (${d}): ${L}`),o.push(this.formatWorkspaceStats(v))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(t){const r=[];let l=0;const u=(_,M)=>{const U=` ${_}(${M})`;l+U.length>60?(r.push(d),d="|                 ",l=d.length):l+=U.length,d+=U};let d="|      File types:";const v=10,L=t.fileTypes.length>v?v:t.fileTypes.length;for(let _=0;_<L;_++){const M=t.fileTypes[_];u(M.name,M.count)}if(r.push(d),t.configFiles.length>=0&&(d="|      Conf files:",l=0,t.configFiles.forEach(_=>{u(_.name,_.count)}),r.push(d)),t.launchConfigFiles.length>0){let _="|      Launch Configs:";t.launchConfigFiles.forEach(M=>{_+=M.count>1?` ${M.name}(${M.count})`:` ${M.name}`}),r.push(_)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(o=>o.length));return Object.keys(t).map(o=>`${o}:  ${" ".repeat(r-o.length)}  ${t[o]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],o=[];return t.windows.forEach(l=>{l.folderURIs.length===0||!!l.remoteAuthority||(r.push(`|  Window (${l.title})`),l.folderURIs.forEach(u=>{const d=P.URI.revive(u);if(d.scheme===A.Schemas.file){const v=d.fsPath;o.push(g(v,["node_modules",".git"]).then(L=>{let _=`${L.fileCount} files`;L.maxFilesReached&&(_=`more than ${_}`),r.push(`|    Folder (${(0,I.basename)(v)}): ${_}`),r.push(this.formatWorkspaceStats(L))}).catch(L=>{r.push(`|      Error: Unable to collect workspace stats for folder ${v} (${L.toString()})`)}))}else r.push(`|    Folder (${d.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(l=>r.join(`
`)).catch(l=>`Unable to collect workspace stats: ${l}`)}formatProcessList(t,r){const o=new Map;t.windows.forEach(u=>o.set(u.pid,u.title));const l=[];return l.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,o,l,r,0),l.join(`
`)}formatProcessItem(t,r,o,l,u){const d=u===0;let v;d?v=l.pid===t?`${this.productService.applicationName} main`:"remote agent":(v=`${"  ".repeat(u)} ${l.name}`,l.name==="window"&&(v=`${v} (${r.get(l.pid)})`));const L=process.platform==="win32"?l.mem:R.totalmem()*(l.mem/100);o.push(`${l.load.toFixed(0).padStart(5," ")}	${(L/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${l.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(l.children)&&l.children.forEach(_=>this.formatProcessItem(t,r,o,_,u+1))}async getWorkspaceFileExtensions(t){const r=new Set;for(const{uri:o}of t.folders){const l=P.URI.revive(o);if(l.scheme!==A.Schemas.file)continue;const u=l.fsPath;try{(await g(u,["node_modules",".git"])).fileTypes.forEach(v=>r.add(v.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const o=P.URI.revive(r);if(o.scheme!==A.Schemas.file)continue;const l=o.fsPath;try{const u=await g(l,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:d.name,count:d.count})}),u.launchConfigFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:d.name,count:d.count})}),u.configFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:d.name,count:d.count})})}catch{}}}};i=pe([G(0,C.ITelemetryService),G(1,y.IProductService)],i),e.DiagnosticsService=i}),define(ne[104],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(T){this.appenders=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,{eventName:I,data:E}){return this.appenders.forEach(P=>P.log(I,E)),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class n{constructor(T){this.channel=T}log(T,A){return this.channel.call("log",{eventName:T,data:A}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(ne[49],re([0,1,31,79,14,19,103,22]),function(Q,e,R,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class E{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,n.staticObservableValue)(0)}publicLog(i,s){return Promise.resolve(void 0)}publicLog2(i,s){return this.publicLog(i,s)}publicLogError(i,s){return Promise.resolve(void 0)}publicLogError2(i,s){return this.publicLogError(i,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=E,e.NullTelemetryService=new E;class P{async publicLog(i,s,t){}async publicLogError(i,s,t){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(c,i){return i.onDidChangeConfiguration(s=>{s.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(s.source),configurationKeys:p(s.sourceConfig)})})}e.configurationTelemetry=b;function w(c,i){return!(i.disableTelemetry||!c.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=w;function m(c){const i=c.getValue(I.TELEMETRY_SETTING_ID),s=c.getValue("telemetry.enableCrashReporter");if(c.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function S(c){const i={},s={},t={};C(c,t);for(let r in t){r=r.length>150?r.substr(r.length-149):r;const o=t[r];typeof o=="number"?s[r]=o:typeof o=="boolean"?s[r]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${o.length}`),i[r]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(i[r]=o)}return{properties:i,measurements:s}}e.validateTelemetryData=S;const h=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function y(c){if(!c)return"none";for(const i of h)if(c.startsWith(`${i}+`))return i;return"other"}e.cleanRemoteAuthority=y;function C(c,i,s=0,t){if(!!c)for(const r of Object.getOwnPropertyNames(c)){const o=c[r],l=t?t+r:r;Array.isArray(o)?i[l]=(0,R.safeStringify)(o):o instanceof Date?i[l]=o.toISOString():(0,k.isObject)(o)?s<2?C(o,i,s+1,l+"."):i[l]=(0,R.safeStringify)(o):i[l]=o}}function p(c){if(!c)return[];const i=[];return g(i,"",c),i}function g(c,i,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(t=>g(c,i?`${i}.${t}`:t,s[t])):c.push(i)}function a(c,i){const s=c.msftInternalDomains||[],t=i.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(s)||t}e.isInternalTelemetry=a;function f(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=f}),define(ne[219],re([0,1,47,49]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(T,A,I,E,P,b,w){const m={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${A.nameShort})`};if((0,n.supportsTelemetry)(A,I)&&(0,n.getTelemetryLevel)(E)===3){const S=await(0,R.getServiceMachineId)(I,P,b),{sessionId:h}=await w.getTelemetryInfo();m["X-Market-User-Id"]=S,m["VSCode-SessionId"]=h}return m}e.resolveMarketplaceHeaders=k}),define(ne[220],re([0,1,9,31,49]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function A(E,P,b){const w=await new Promise((C,p)=>{Q(["@microsoft/1ds-core-js"],C,p)}),m=await new Promise((C,p)=>{Q(["@microsoft/1ds-post-js"],C,p)}),S=new w.AppInsightsCore,h=new m.PostChannel,y={instrumentationKey:E,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[h]]};if(b){y.extensionConfig={};const C={alwaysUseXhrOverride:!0,httpXHROverride:b};y.extensionConfig[h.identifier]=C}return S.initialize(y,[]),S.addTelemetryInitializer(C=>{P&&(C.ext=C.ext??{},C.ext.utc=C.ext.utc??{},C.ext.utc.flags=8462029)}),S}class I{constructor(P,b,w,m,S){this._isInternalTelemetry=P,this._eventPrefix=b,this._defaultData=w,this._xhrOverride=S,this.endPointUrl=T,this._defaultData||(this._defaultData={}),typeof m=="function"?this._aiCoreOrKey=m():this._aiCoreOrKey=m,this._asyncAiCore=null}_withAIClient(P){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){P(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=A(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(b=>{P(b)},b=>{(0,R.onUnexpectedError)(b),console.error(b)})}}log(P,b){if(!this._aiCoreOrKey)return;b=(0,n.mixin)(b,this._defaultData),b=(0,k.validateTelemetryData)(b);const w=this._eventPrefix+"/"+P;try{this._withAIClient(m=>{m.pluginVersionString=b?.properties.version??"Unknown",m.track({name:w,baseData:{name:w,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(P=>{this._withAIClient(b=>{b.unload(!0,()=>{this._aiCoreOrKey=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(ne[105],re([0,1,2,15,8,49]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends R.Disposable{constructor(E,P,b=""){super(),this.prefix=b;const w=E.getLogger(P.telemetryLogResource);w?this.logger=this._register(w):(this.logger=this._register(E.createLogger(P.telemetryLogResource)),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(E,P){this.logger.trace(`${this.prefix}telemetry/${E}`,(0,T.validateTelemetryData)(P))}};A=pe([G(0,k.ILoggerService),G(1,n.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(ne[106],re([0,1,2,31,79,4,24,157,19,42,97,25,40,22,49]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(g,a,f){this._configurationService=a,this._productService=f,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,a){this._experimentProperties[g]=a}_updateTelemetryLevel(){let g=(0,h.getTelemetryLevel)(this._configurationService);const a=this._productService.enabledTelemetryLevels;if(a){this._sendErrorTelemetry=this.sendErrorTelemetry?a.error:!1;const f=a.usage?3:a.error?2:0;g=Math.min(g,f)}this.telemetryLevel.value=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const g=await this._commonProperties,a=g.sessionID,f=g["common.machineId"],c=g["common.firstSessionDate"],i=g["common.msftInternal"];return{sessionId:a,machineId:f,firstSessionDate:c,msftInternal:i}}dispose(){this._disposables.dispose()}_log(g,a,f,c){return this.telemetryLevel.value<a?Promise.resolve(void 0):this._commonProperties.then(i=>{f=(0,n.mixin)(f,i),f=(0,n.mixin)(f,this._experimentProperties),f=(0,n.cloneAndChange)(f,s=>{if(typeof s=="string")return this._cleanupInfo(s,c)}),this._appenders.forEach(s=>s.log(g,f))},i=>{console.error(i)})}publicLog(g,a,f){return this._log(g,3,a,f)}publicLog2(g,a,f){return this.publicLog(g,a,f)}publicLogError(g,a){return this._sendErrorTelemetry?this._log(g,2,a,!0):Promise.resolve(void 0)}publicLogError2(g,a){return this.publicLogError(g,a)}_anonymizeFilePaths(g){let a=g;const f=[];for(const t of this._cleanupPatterns)for(;;){const r=t.exec(g);if(!r)break;f.push([r.index,t.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(a="";;){const t=i.exec(g);if(!t)break;!c.test(t[0])&&f.every(([r,o])=>t.index<r||t.index>=o)&&(a+=g.substring(s,t.index)+"<REDACTED: user-file-path>",s=i.lastIndex)}return s<g.length&&(a+=g.substr(s)),a}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const a=g.toLowerCase(),f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const c of f)if(c.regex.test(a))return`<REDACTED: ${c.label}>`;return g}_cleanupInfo(g,a){let f=g;a&&(f=this._anonymizeFilePaths(f));for(const c of this._cleanupPatterns)f=f.replace(c,"");return f=this._removePropertiesWithPossibleUserInfo(f),f}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=pe([G(1,E.IConfigurationService),G(2,w.IProductService)],y),e.TelemetryService=y;function C(){const p=(0,I.localize)(0,null,b.default.nameLong),g=b.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),a=T.isWeb?"":(0,I.localize)(3,null),f=(0,I.localize)(4,null),c=(0,I.localize)(5,null),i=(0,I.localize)(6,null),s=(0,I.localize)(7,null),t=`
|       | ${f} | ${c} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,I.localize)(8,null);return`
${p} ${g} ${a}

&nbsp;

${s}
${t}

&nbsp;

${r}
`}m.Registry.as(P.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:C(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),m.Registry.as(P.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,I.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,I.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[221],re([0,1,275,220]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends n.AbstractOneDataSystemAppender{constructor(A,I,E,P){const b={sendPOST:(w,m)=>{const S={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const h=R.request(w.urlString,S,y=>{y.on("data",function(C){m(y.statusCode??200,y.headers,C.toString())}),y.on("error",function(C){m(0,{})})});h.write(w.data),h.end()}catch{m(0,{})}}};super(A,I,E,P,b)}}e.OneDataSystemAppender=k}),define(ne[222],re([0,1,20,65,19,15,8,25,22,104,105,106]),function(Q,e,R,n,k,T,A,I,E,P,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(h,y,C,p,g){this.configurationService=h,this.telemetryService=y,this.loggerService=C,this.environmentService=p,this.productService=g,this.customTelemetryServices=new Map}async getCustomTelemetryService(h){if(!this.customTelemetryServices.has(h.id)){const{machineId:y,sessionId:C}=await this.telemetryService.getTelemetryInfo(),p=Object.create(null);p["common.vscodemachineid"]=y,p["common.vscodesessionid"]=C;const g=[h.id,JSON.stringify(p),h.aiKey],f=new n.Client(R.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new P.TelemetryAppenderClient(f),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${h.id}] `)];this.customTelemetryServices.set(h.id,new w.TelemetryService({appenders:c,sendErrorTelemetry:h.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(h.id)}async publicLog(h,y,C){await(await this.getCustomTelemetryService(h)).publicLog(y,C)}async publicLogError(h,y,C){await(await this.getCustomTelemetryService(h)).publicLogError(y,C)}};m=pe([G(0,k.IConfigurationService),G(1,E.ITelemetryService),G(2,A.ILoggerService),G(3,T.IEnvironmentService),G(4,I.IProductService)],m),e.CustomEndpointTelemetryService=m}),define(ne[223],re([0,1,6,21,3,2,8]),function(Q,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let I=class extends T.Disposable{constructor(P,b){super(),this._logService=b,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new k.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=P===void 0?15e3:P}createRequest(P){return new Promise((b,w)=>{const m=++this._lastRequestId;this._pendingRequests.set(m,b),this._onCreateRequest.fire({requestId:m,...P});const S=new n.CancellationTokenSource;(0,R.timeout)(this._timeout,S.token).then(()=>w(`Request ${m} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(m,[(0,T.toDisposable)(()=>S.cancel())])})}acceptReply(P,b){const w=this._pendingRequests.get(P);w?(this._pendingRequests.delete(P),(0,T.dispose)(this._pendingRequestDisposables.get(P)||[]),this._pendingRequestDisposables.delete(P),w(b)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${P}`)}};I=pe([G(1,A.ILogService)],I),e.RequestStore=I}),define(ne[107],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(a){a.Shell="terminal.integrated.shell.",a.ShellArgs="terminal.integrated.shellArgs.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var k;(function(a){a.ShellLinux="terminal.integrated.shell.linux",a.ShellMacOs="terminal.integrated.shell.osx",a.ShellWindows="terminal.integrated.shell.windows",a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationShellLinux="terminal.integrated.automationShell.linux",a.AutomationShellMacOs="terminal.integrated.automationShell.osx",a.AutomationShellWindows="terminal.integrated.automationShell.windows",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ShellArgsLinux="terminal.integrated.shellArgs.linux",a.ShellArgsMacOs="terminal.integrated.shellArgs.osx",a.ShellArgsWindows="terminal.integrated.shellArgs.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.CustomGlyphs="terminal.integrated.customGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.SmoothScrolling="terminal.integrated.smoothScrolling"})(k=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(a){a.FileName="ptyhost"})(T=e.TerminalLogConstants||(e.TerminalLogConstants={}));var A;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh"})(A=e.PosixShellType||(e.PosixShellType={}));var I;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash"})(I=e.WindowsShellType||(e.WindowsShellType={}));var E;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(E=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.Log="log",a.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,R.createDecorator)("ptyService");var b;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b=e.ProcessPropertyType||(e.ProcessPropertyType={}));var w;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w=e.HeartbeatConstants||(e.HeartbeatConstants={}));var m;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(m=e.TerminalLocation||(e.TerminalLocation={}));var S;(function(a){a.TerminalView="view",a.Editor="editor"})(S=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var y;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(y=e.FlowControlConstants||(e.FlowControlConstants={}));var C;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(C=e.ProfileSource||(e.ProfileSource={}));var p;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(p=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var g;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(g=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ne[224],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,R.createDecorator)("localPtyService")}),define(ne[225],re([0,1,37,20,31,10,4,36,24,14,27]),function(Q,e,R,n,k,T,A,I,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function w(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(R.release());let c=0;return f&&f.length===4&&(c=parseInt(f[3])),c}e.getWindowsBuildNumber=w;async function m(f,c,i,s=I.env,t=b.Promises.exists){if(T.isAbsolute(f))return await t(f)?f:void 0;if(c===void 0&&(c=I.cwd()),T.dirname(f)!=="."){const u=T.join(c,f);return await t(u)?u:void 0}const o=(0,k.getCaseInsensitive)(s,"PATH");if(i===void 0&&(0,P.isString)(o)&&(i=o.split(T.delimiter)),i===void 0||i.length===0){const u=T.join(c,f);return await t(u)?u:void 0}for(const u of i){let d;if(T.isAbsolute(u)?d=T.join(u,f):d=T.join(c,u,f),await t(d))return d;if(A.isWindows){let v=d+".com";if(await t(v)||(v=d+".exe",await t(v)))return v}}const l=T.join(c,f);return await t(l)?l:void 0}e.findExecutable=m;function S(f,c,i,s){if(!c.enabled||!f.executable||f.isFeatureTerminal||f.hideFromUser||f.ignoreShellIntegration)return;const t=f.args,r=I.platform==="win32"?T.basename(f.executable).toLowerCase():T.basename(f.executable),o=T.dirname(n.FileAccess.asFileUri("",Q).fsPath);let l;const u={VSCODE_INJECTION:"1"};if(A.isWindows){if(r==="pwsh.exe")return!t||g(t)?l=e.shellIntegrationArgs.get(h.WindowsPwsh):p(t)&&(l=e.shellIntegrationArgs.get(h.WindowsPwshLogin)),l?(l=[...l],l[l.length-1]=(0,E.format)(l[l.length-1],o,""),{newArgs:l,envMixin:u}):void 0;s.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args);return}switch(r){case"bash":return!t||t.length===0?l=e.shellIntegrationArgs.get(h.Bash):a(t)&&(u.VSCODE_SHELL_LOGIN="1",l=e.shellIntegrationArgs.get(h.Bash)),l?(l=[...l],l[l.length-1]=(0,E.format)(l[l.length-1],o),{newArgs:l,envMixin:u}):void 0;case"pwsh":return!t||g(t)?l=e.shellIntegrationArgs.get(h.Pwsh):p(t)&&(l=e.shellIntegrationArgs.get(h.PwshLogin)),l?(l=[...l],l[l.length-1]=(0,E.format)(l[l.length-1],o,""),{newArgs:l,envMixin:u}):void 0;case"zsh":{if(!t||t.length===0?l=e.shellIntegrationArgs.get(h.Zsh):a(t)?l=e.shellIntegrationArgs.get(h.ZshLogin):(t===e.shellIntegrationArgs.get(h.Zsh)||t===e.shellIntegrationArgs.get(h.ZshLogin))&&(l=t),!l)return;l=[...l],l[l.length-1]=(0,E.format)(l[l.length-1],o);const d=T.join(R.tmpdir(),`${R.userInfo().username}-vscode-zsh`);u.ZDOTDIR=d;const v=i?.ZDOTDIR??R.homedir();u.USER_ZDOTDIR=v;const L=[];return L.push({source:T.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:T.join(d,".zshrc")}),L.push({source:T.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:T.join(d,".zprofile")}),L.push({source:T.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:T.join(d,".zshenv")}),L.push({source:T.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:T.join(d,".zlogin")}),{newArgs:l,envMixin:u,filesToCopy:L}}}s.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args)}e.getShellIntegrationInjection=S;var h;(function(f){f.WindowsPwsh="windows-pwsh",f.WindowsPwshLogin="windows-pwsh-login",f.Pwsh="pwsh",f.PwshLogin="pwsh-login",f.Zsh="zsh",f.ZshLogin="zsh-login",f.Bash="bash"})(h=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(h.Zsh,["-i"]),e.shellIntegrationArgs.set(h.ZshLogin,["-il"]),e.shellIntegrationArgs.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const y=["-login","-l"],C=["-nol","-nologo"];function p(f){return typeof f=="string"?y.includes(f.toLowerCase()):f.length===1&&y.includes(f[0].toLowerCase())||f.length===2&&(y.includes(f[0].toLowerCase())||y.includes(f[1].toLowerCase()))&&(C.includes(f[0].toLowerCase())||C.includes(f[1].toLowerCase()))}function g(f){return typeof f=="string"?C.includes(f.toLowerCase()):f.length===0||f?.length===1&&C.includes(f[0].toLowerCase())}function a(f){return f==="string"&&y.includes(f.toLowerCase())||typeof f!="string"&&f.length===1&&y.includes(f[0].toLowerCase())}}),define(ne[226],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var R;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST_DARK="hcDark",T.HIGH_CONTRAST_LIGHT="hcLight"})(R=e.ColorScheme||(e.ColorScheme={}));function n(T){return T===R.HIGH_CONTRAST_DARK||T===R.HIGH_CONTRAST_LIGHT}e.isHighContrast=n;function k(T){return T===R.DARK||T===R.HIGH_CONTRAST_DARK}e.isDark=k}),define(ne[108],re([0,1,50,3,2,5,40,226]),function(Q,e,R,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var E;(function(C){function p(g){return g&&typeof g=="object"&&typeof g.id=="string"}C.isThemeColor=p})(E=e.ThemeColor||(e.ThemeColor={}));function P(C){return{id:C}}e.themeColorFromId=P;var b;(function(C){function p(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||E.isThemeColor(r.color))}C.isThemeIcon=p;const g=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function a(r){const o=g.exec(r);if(!o)return;const[,l]=o;return{id:l}}C.fromString=a;function f(r){return{id:r}}C.fromId=f;function c(r,o){let l=r.id;const u=l.lastIndexOf("~");return u!==-1&&(l=l.substring(0,u)),o&&(l=`${l}~${o}`),{id:l}}C.modify=c;function i(r){const o=r.id.lastIndexOf("~");if(o!==-1)return r.id.substring(o+1)}C.getModifier=i;function s(r,o){return r.id===o.id&&r.color?.id===o.color?.id}C.isEqual=s;function t(r,o){return{id:r.id,color:o?P(o):void 0}}C.asThemeIcon=t,C.asClassNameArray=R.CSSIcon.asClassNameArray,C.asClassName=R.CSSIcon.asClassName,C.asCSSSelector=R.CSSIcon.asCSSSelector})(b=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function w(C){switch(C){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,k.toDisposable)(()=>{const g=this.themingParticipants.indexOf(p);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const S=new m;A.Registry.add(e.Extensions.ThemingContribution,S);function h(C){return S.onColorThemeChange(C)}e.registerThemingParticipant=h;class y extends k.Disposable{constructor(p){super(),this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,g){let a=this.theme.getColor(p);return a&&g&&(a=g(a,this.theme)),a?a.toString():null}}e.Themable=y}),define(ne[227],re([0,1,50,7,159,108]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function A(m,S){const h=[{name:null,description:(0,k.localize)(0,null)}];return h.push(...m.map(y=>({name:y.profileName,description:I(y)}))),S&&h.push(...S.map(y=>({name:y.title,description:E(y)}))),{values:h.map(y=>y.name),markdownDescriptions:h.map(y=>y.description)}}e.createProfileSchemaEnums=A;function I(m){let S=`$(${T.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:R.Codicon.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?S+=`
- args: "${m.args}"`:S+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&(S+=`
- overrideName: ${m.overrideName}`),m.color&&(S+=`
- color: ${m.color}`),m.env&&(S+=`
- env: ${JSON.stringify(m.env)}`),S}function E(m){return`$(${T.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:R.Codicon.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function P(m,S){if(!m&&!S)return!0;if(typeof m=="string"&&typeof S=="string")return m===S;if(Array.isArray(m)&&Array.isArray(S)){if(m.length!==S.length)return!1;for(let h=0;h<m.length;h++)if(m[h]!==S[h])return!1;return!0}return!1}e.terminalProfileArgsMatch=P;function b(m,S){if(!m&&!S)return!0;if(!m||!S)return!1;if(T.ThemeIcon.isThemeIcon(m)&&T.ThemeIcon.isThemeIcon(S))return m.id===S.id&&m.color===S.color;if(typeof m=="object"&&"light"in m&&"dark"in m&&typeof S=="object"&&"light"in S&&"dark"in S){const h=m,y=S;if((n.URI.isUri(h.light)||w(h.light))&&(n.URI.isUri(h.dark)||w(h.dark))&&(n.URI.isUri(y.light)||w(y.light))&&(n.URI.isUri(y.dark)||w(y.dark)))return h.light.path===y.light.path&&h.dark.path===y.dark.path}if(n.URI.isUri(m)&&n.URI.isUri(S)||w(m)||w(S)){const h=m,y=S;return h.path===y.path&&h.scheme===y.scheme}return!1}e.terminalIconsEqual=b;function w(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}e.isUriComponents=w}),define(ne[228],re([0,1,50,158,42,40,227]),function(Q,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(R.Codicon.getAll(),f=>f.id),markdownEnumDescriptions:Array.from(R.Codicon.getAll(),f=>`$(${f.id})`)};const I={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),...e.terminalIconSchema},color:{description:(0,n.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},E={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...I}},P={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...I}},b=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),w=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),S=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),y=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),C={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...I}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...I}},{type:"null"},E]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...I}},{type:"null"},E]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...I}},{type:"null"},E]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function p(){T.Registry.as(k.Extensions.Configuration).registerConfiguration(C),a()}e.registerTerminalPlatformConfiguration=p;let g;function a(f,c){const i=T.Registry.as(k.Extensions.Configuration);let s;f&&(s=(0,A.createProfileSchemaEnums)(f?.profiles,c));const t=g;g={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?s?.values:void 0,markdownEnumDescriptions:f?.os===3?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?s?.values:void 0,markdownEnumDescriptions:f?.os===2?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?s?.values:void 0,markdownEnumDescriptions:f?.os===1?s?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[g],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=a}),define(ne[229],re([0,1,54,50,10,4,27,83,225,108]),function(Q,e,R,n,k,T,A,I,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let b,w=!0;function m(s,t,r,o,l=process.env,u,d,v,L){return u=u||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},T.isWindows?S(r,u,l,d,o.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?{...s}:o.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:o.getValue("terminal.integrated.defaultProfile.windows"),L,v):f(u,d,r,s&&typeof s=="object"?{...s}:o.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:o.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),L,v,l)}e.detectAvailableProfiles=m;async function S(s,t,r,o,l,u,d,v,L){const _=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),M=`${process.env.windir}\\${_?"Sysnative":"System32"}`;let U=!1;(0,E.getWindowsBuildNumber)()>=16299&&(U=!0),await C(v);const D=new Map;s&&(D.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),D.set("Windows PowerShell",{path:`${M}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),D.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),D.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),D.set("Command Prompt",{path:`${M}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),c(u,D);const F=await h(D.entries(),d,t,r,o,L);if(s||l)try{const $=await g(`${M}\\${U?"wsl":"bash"}.exe`,d);for(const j of $)(!u||!(j.profileName in u))&&F.push(j)}catch{w&&(o?.info("WSL is not installed, so could not detect WSL profiles"),w=!1)}return F}async function h(s,t,r,o=process.env,l,u){const d=[];for(const[v,L]of s){if(L===null)continue;let _,M,U;if("source"in L){const $=b?.get(L.source);if(!$)continue;_=$.paths,M=L.args||$.args,L.icon?U=y(L.icon):$.icon&&(U=$.icon)}else _=Array.isArray(L.path)?L.path:[L.path],M=T.isWindows||Array.isArray(L.args)?L.args:void 0,U=y(L.icon);const D=await u?.(_)||_.slice(),F=await i(v,t,D,r,o,M,L.env,L.overrideName,L.isAutoDetected,l);F?(F.isAutoDetected=L.isAutoDetected,F.icon=U,F.color=L.color,d.push(F)):l?.debug("Terminal profile not validated",v,_)}return l?.debug("Validated terminal profiles",d),d}function y(s){return typeof s=="string"?{id:s}:s}async function C(s){b&&!s||(b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),b.set("PowerShell",{profileName:"PowerShell",paths:s||await p(),icon:P.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function p(){const s=[];for await(const t of(0,I.enumeratePowerShellInstallations)())s.push(t.exePath);return s}async function g(s,t){const r=[],o=await new Promise((d,v)=>{R.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(L,_)=>{if(L)return v("Problem occurred when getting wsl distros");d(_)})});if(!o)return[];const l=new RegExp(/[\r?\n]/),u=o.split(l).filter(d=>d.trim().length>0&&d!=="");for(const d of u){if(d===""||d.startsWith("docker-desktop"))continue;const v=`${d} (WSL)`,L={profileName:v,path:s,args:["-d",`${d}`],isDefault:v===t,icon:a(d),isAutoDetected:!1};r.push(L)}return r}function a(s){return s.includes("Ubuntu")?P.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):s.includes("Debian")?P.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):P.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function f(s,t,r,o,l,u,d,v){const L=new Map;if(r){const _=(await s.readFile("/etc/shells")).toString(),M=u||_.split(`
`).filter(D=>D.trim().indexOf("#")!==0&&D.trim().length>0),U=new Map;for(const D of M){let F=(0,k.basename)(D),$=U.get(F)||0;$++,$>1&&(F=`${F} (${$})`),U.set(F,$),L.set(F,{path:D,isAutoDetected:!0})}}return c(o,L),await h(L.entries(),l,s,v,t,d)}function c(s,t){if(!!s)for(const[r,o]of Object.entries(s))o===null||!("path"in o)&&!("source"in o)?t.delete(r):(o.icon=o.icon||t.get(r)?.icon,t.set(r,o))}async function i(s,t,r,o,l,u,d,v,L,_){if(r.length===0)return Promise.resolve(void 0);const M=r.shift();if(M==="")return i(s,t,r,o,l,u,d,v,L);const U={profileName:s,path:M,args:u,env:d,overrideName:v,isAutoDetected:L,isDefault:s===t};if((0,k.basename)(M)===M){const F=l.PATH?l.PATH.split(k.delimiter):void 0,$=await(0,E.findExecutable)(M,void 0,F,void 0,o.existsFile);return $?(U.path=$,U.isFromPath=!0,U):i(s,t,r,o,l,u)}return await o.existsFile((0,k.normalize)(M))?U:i(s,t,r,o,l,u,d,v,L)}}),define(ne[230],re([0,1,3,2,20,4,39,65,19,15,88,216,8,96,223,107,228,229]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(c){c[c.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let a=0,f=class extends n.Disposable{constructor(i,s,t,r){super(),this._reconnectConstants=i,this._configurationService=s,this._environmentService=t,this._logService=r,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new R.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new R.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new R.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new R.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new R.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new R.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new R.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new R.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new R.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new R.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new R.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new R.Emitter),this.onProcessExit=this._onProcessExit.event,(0,C.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,w.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(i){return this._logService.error("ptyHost was unable to resolve shell environment",i),{}}}_startPtyHost(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:a,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},s=(0,b.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);s&&(s.break&&s.port?i.debugBrk=s.port:!s.break&&s.port&&(i.debug=s.port));const t=new I.Client(k.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,i);this._onPtyHostStart.fire(),A.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(u=>{this._onPtyHostExit.fire(u.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}, giving up`))}));const o=t.getChannel(y.TerminalIpcChannels.Log);S.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{S.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const l=A.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.PtyHost));return this._register(l.onProcessData(u=>this._onProcessData.fire(u))),this._register(l.onProcessReady(u=>this._onProcessReady.fire(u))),this._register(l.onProcessExit(u=>this._onProcessExit.fire(u))),this._register(l.onDidChangeProperty(u=>this._onDidChangeProperty.fire(u))),this._register(l.onProcessReplay(u=>this._onProcessReplay.fire(u))),this._register(l.onProcessOrphanQuestion(u=>this._onProcessOrphanQuestion.fire(u))),this._register(l.onDidRequestDetach(u=>this._onDidRequestDetach.fire(u))),[t,l]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(i,s,t,r,o,l,u,d,v,L,_){const M=setTimeout(()=>this._handleUnresponsiveCreateProcess(),y.HeartbeatConstants.CreateProcessTimeout),U=await this._proxy.createProcess(i,s,t,r,o,l,u,d,v,L,_);return clearTimeout(M),a=Math.max(a,U),U}updateTitle(i,s,t){return this._proxy.updateTitle(i,s,t)}updateIcon(i,s,t){return this._proxy.updateIcon(i,s,t)}attachToProcess(i){return this._proxy.attachToProcess(i)}detachFromProcess(i,s){return this._proxy.detachFromProcess(i,s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(i){return this._proxy.start(i)}shutdown(i,s){return this._proxy.shutdown(i,s)}input(i,s){return this._proxy.input(i,s)}processBinary(i,s){return this._proxy.processBinary(i,s)}resize(i,s,t){return this._proxy.resize(i,s,t)}acknowledgeDataEvent(i,s){return this._proxy.acknowledgeDataEvent(i,s)}setUnicodeVersion(i,s){return this._proxy.setUnicodeVersion(i,s)}getInitialCwd(i){return this._proxy.getInitialCwd(i)}getCwd(i){return this._proxy.getCwd(i)}getLatency(i){return this._proxy.getLatency(i)}orphanQuestionReply(i){return this._proxy.orphanQuestionReply(i)}installAutoReply(i,s){return this._proxy.installAutoReply(i,s)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(i){return this._proxy.uninstallAutoReply(i)}getDefaultSystemShell(i){return this._proxy.getDefaultSystemShell(i)}async getProfiles(i,s,t,r=!1){const o=await this._shellEnv;return(0,p.detectAvailableProfiles)(s,t,r,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,i))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(i){return this._proxy.getWslPath(i)}getRevivedPtyNewId(i){return this._proxy.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this._proxy.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this._proxy.getTerminalLayoutInfo(i)}async requestDetachInstance(i,s){return this._proxy.requestDetachInstance(i,s)}async acceptDetachInstanceReply(i,s){return this._proxy.acceptDetachInstanceReply(i,s)}async serializeTerminalState(i){return this._proxy.serializeTerminalState(i)}async reviveTerminalProcesses(i,s){return this._proxy.reviveTerminalProcesses(i,s)}async refreshProperty(i,s){return this._proxy.refreshProperty(i,s)}async updateProperty(i,s,t){return this._proxy.updateProperty(i,s,t)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(i,s){return this._resolveVariablesRequestStore.createRequest({workspaceId:i,originalText:s})}async acceptPtyHostResolvedVariables(i,s){this._resolveVariablesRequestStore.acceptReply(i,s)}};f=pe([G(1,E.IConfigurationService),G(2,P.IEnvironmentService),G(3,m.ILogService)],f),e.PtyHostService=f}),define(ne[70],re([0,1,3,4,5,8]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var A;(function(y){y.Http="http",y.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(y){y.ConstantPrivate="constantPrivate",y.Private="private",y.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const C=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!C)return{address:C[1],port:+C[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=w;function m(y,C){return C?C!==1&&y<1024:!n.isWindows&&y<1024}e.isPortPrivileged=m;class S{constructor(C,p,g){this.remoteAddress=C,this.localAddress=p,this._dispose=g,this._onDispose=new R.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=S;let h=class{constructor(C){this.logService=C,this._onTunnelOpened=new R.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new R.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new R.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(C){return this._tunnelProvider=C,C?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(C){this._canElevate=C.elevation,this._privacyOptions=C.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const C=[],p=Array.from(this._tunnels.values());for(const g of p){const a=Array.from(g.values());for(const f of a){const c=await f.value;c&&C.push(c)}}return C}async dispose(){for(const C of this._tunnels.values()){for(const{value:p}of C.values())await p.then(g=>g?.dispose());C.clear()}this._tunnels.clear()}openTunnel(C,p,g,a,f=!1,c,i){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${g} on local port ${a}.`),!C)return;if(p||(p="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.retainOrCreateTunnel(C,p,g,a,f,c,i);return s?s.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(t);return(t.tunnelRemoteHost!==p||t.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(C){return{tunnelRemotePort:C.tunnelRemotePort,tunnelRemoteHost:C.tunnelRemoteHost,tunnelLocalPort:C.tunnelLocalPort,localAddress:C.localAddress,privacy:C.privacy,protocol:C.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${C.tunnelRemoteHost}:${C.tunnelRemotePort} `);const p=this._tunnels.get(C.tunnelRemoteHost);if(p){const g=p.get(C.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(C.tunnelRemoteHost,C.tunnelRemotePort,g))}}}}async tryDisposeTunnel(C,p,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${C}:${p}.`);const a=g.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(C)&&this._tunnels.get(C).delete(p),a}}async closeTunnel(C,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${C}:${p} `);const g=this._tunnels.get(C);if(g&&g.has(p)){const a=g.get(p);a.refcount=0,await this.tryDisposeTunnel(C,p,a)}}addTunnelToMap(C,p,g){this._tunnels.has(C)||this._tunnels.set(C,new Map),this._tunnels.get(C).set(p,{refcount:1,value:g})}async removeEmptyTunnelFromMap(C,p){const g=this._tunnels.get(C);g&&(await g.get(p)||g.delete(p),g.size===0&&this._tunnels.delete(C))}getTunnelFromMap(C,p){const g=[C];b(C)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):w(C)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const a=g.map(f=>this._tunnels.get(f));for(const f of a){const c=f?.get(p);if(c)return c}}canTunnel(C){return!!P(C)}createWithProvider(C,p,g,a,f,c,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${g} on local port ${a}.`);const s=g;this._factoryInProgress.add(s);const r={elevationRequired:f?m(a===void 0?g:a):!1},o={remoteAddress:{host:p,port:g},localAddressPort:a,privacy:c,public:c?c!==I.Private:void 0,protocol:i},l=C.forwardPort(o,r);return l?(this.addTunnelToMap(p,g,l),l.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),l}};h=pe([G(0,T.ILogService)],h),e.AbstractTunnelService=h}),define(ne[231],re([0,1,8,70,2,9,6]),function(Q,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class I extends k.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(b){this._address=b,this._addressPromise&&(this._addressPromise.complete(b),this._addressPromise=null)}setTunnel(b){this._register(b)}}let E=class bt extends k.Disposable{constructor(b,w){super(),this._tunnelService=b,this._logService=w,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(b=>b.dispose())}async createTunnel(){return{id:String(++bt._lastId)}}async startTunnel(b,w,m,S,h,y){const C=new I,p=await Promise.resolve(this._tunnelService.openTunnel(b,C,m,S,h,y));if(!p)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${S} (remote).`),C.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(w))throw this._disposedTunnels.delete(w),C.dispose(),await p.dispose(),(0,T.canceled)();return C.setTunnel(p),this._tunnels.set(w,C),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${p.localAddress} (local) to ${m}:${S} (remote).`),{tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress}}async setAddress(b,w){const m=this._tunnels.get(b);!m||m.setAddress(w)}async destroyTunnel(b){const w=this._tunnels.get(b);if(w){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${b}.`),this._tunnels.delete(b),await w.dispose();return}this._disposedTunnels.add(b)}};E._lastId=0,E=pe([G(0,n.ISharedTunnelsService),G(1,R.ILogService)],E),e.SharedProcessTunnelService=E}),define(ne[232],re([0,1,77,118,207,6,2,19,8,25,205,70,101]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function S(g,a,f,c,i){let s;for(let t=3;t&&(s?.dispose(),s=await new h(g,a,f,c,i).waitForReady(),!(i&&n.BROWSER_RESTRICTED_PORTS[i]||!n.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));t--);return s}class h extends A.Disposable{constructor(a,f,c,i,s){super(),this.defaultTunnelHost=f,this.suggestedLocalPort=s,this.privacy=w.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=a,this._server=R.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=t=>this._onConnection(t),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(f=>{f()})}async waitForReady(){let a=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),f=null;return this._server.listen(a,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address(),f||(a=0,this._server.listen(a,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address()),this.tunnelLocalPort=f.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${f.port}`,this}async _onConnection(a){a.pause();const f=(0,w.isLocalhost)(this.tunnelRemoteHost)||(0,w.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,b.connectRemoteAgentTunnel)(this._options,f,this.tunnelRemotePort),i=c.getSocket().socket,s=c.readEntireBuffer();c.dispose(),s.byteLength>0&&a.write(s.buffer),a.on("end",()=>{a.localAddress&&this._socketsDispose.delete(a.localAddress),i.end()}),a.on("close",()=>i.end()),a.on("error",()=>{a.localAddress&&this._socketsDispose.delete(a.localAddress),i.destroy()}),i.on("end",()=>a.end()),i.on("close",()=>a.end()),i.on("error",()=>{a.destroy()}),a.pipe(i),i.pipe(a),a.localAddress&&this._socketsDispose.set(a.localAddress,()=>{a.end(),i.end()})}}let y=class extends w.AbstractTunnelService{constructor(a,f,c,i,s){super(f),this.socketFactory=a,this.signService=c,this.productService=i,this.configurationService=s}get defaultTunnelHost(){const a=this.configurationService.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(a,f,c,i,s,t,r){const o=this.getTunnelFromMap(f,c);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,f,c,i,s,t,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${c} on local port ${i}.`);const l={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:a,signService:this.signService,logService:this.logService,ipcLogger:null},u=S(l,this.defaultTunnelHost,f,c,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(f,c,u),u}}};y=pe([G(1,E.ILogService),G(2,m.ISignService),G(3,P.IProductService),G(4,I.IConfigurationService)],y),e.BaseTunnelService=y;let C=class extends y{constructor(a,f,c,i){super(k.nodeSocketFactory,a,f,c,i)}};C=pe([G(0,E.ILogService),G(1,m.ISignService),G(2,P.IProductService),G(3,I.IConfigurationService)],C),e.TunnelService=C;let p=class extends A.Disposable{constructor(a,f,c,i){super(),this.logService=a,this.productService=f,this.signService=c,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(a,f,c,i,s,t,r,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${i} on local port ${s}.`),!this._tunnelServices.has(a)){const l=new C(this.logService,this.signService,this.productService,this.configurationService);this._register(l),this._tunnelServices.set(a,l),l.onTunnelClosed(async()=>{(await l.tunnels).length===0&&(l.dispose(),this._tunnelServices.delete(a))})}return this._tunnelServices.get(a).openTunnel(f,c,i,s,t,r,o)}};p=pe([G(0,E.ILogService),G(1,P.IProductService),G(2,m.ISignService),G(3,I.IConfigurationService)],p),e.SharedTunnelsService=p}),define(ne[33],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,R.createDecorator)("IUriIdentityService")}),define(ne[233],re([0,1,3,2,7,15,32,13,8,33]),function(Q,e,R,n,k,T,A,I,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let b=class extends n.Disposable{constructor(m,S,h,y,C){super(),this.extensionsManagementService=m,this.logService=y,this.uriIdentityService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(g=>{this.installedExtensions=g.map(a=>a.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(g=>this.onInstallExtension(g))),this._register(m.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(m.onDidUninstallExtension(g=>this.onDidUninstallExtension(g)));const p=k.URI.file(h.extensionsPath);this._register(S.watch(p)),this._register(R.Event.filter(S.onDidFilesChange,g=>g.rawChanges.some(a=>this.doesChangeAffects(a,p)))(()=>this.onDidChange()))}doesChangeAffects(m,S){return m.type!==1&&m.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(m.resource),S)?!1:this.uriIdentityService.extUri.isEqual(m.resource,this.uriIdentityService.extUri.joinPath(S,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(m.resource).startsWith(".")}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const S of m)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(S=>!(0,A.areSameExtensions)(S,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,A.areSameExtensions)(S,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(),S=m.filter(y=>[...this.installingExtensions,...this.installedExtensions].some(C=>(0,A.areSameExtensions)(C,y.identifier))?!1:y.installedTimestamp&&y.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",y.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",y.identifier.id),!1)),h=this.installedExtensions.filter(y=>this.installingExtensions.some(C=>(0,A.areSameExtensions)(C,y))?!1:m.every(C=>!(0,A.areSameExtensions)(C.identifier,y))?(this.logService.info("Detected extension removed from another source",y.id),!0):!1);this.installedExtensions=m.map(y=>y.identifier),(S.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:h})}}};b=pe([G(1,I.IFileService),G(2,T.INativeEnvironmentService),G(3,E.ILogService),G(4,P.IUriIdentityService)],b),e.ExtensionsWatcher=b}),define(ne[234],re([0,1,33,89,13,17,116,3,2]),function(Q,e,R,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class P{constructor(m){this.uri=m,this.time=P._clock++}touch(){return this.time=P._clock++,this}}P._clock=0;let b=class{constructor(m){this._fileService=m,this._dispooables=new E.DisposableStore,this._limit=2**16;const S=new Map,h=y=>{let C=S.get(y.scheme);return C===void 0&&(C=m.hasProvider(y)&&!this._fileService.hasCapability(y,1024),S.set(y.scheme,C)),C};this._dispooables.add(I.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(y=>{S.delete(y.scheme)})),this.extUri=new T.ExtUri(h),this._canonicalUris=new A.SkipList((y,C)=>this.extUri.compare(y,C,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,T.normalizePath)(m));const S=this._canonicalUris.get(m);return S?S.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new P(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((h,y)=>h[1].touch<y[1].touch?1:h[1].touch>y[1].touch?-1:0);P._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let h=0;h<S;h++)this._canonicalUris.set(m[h][0],m[h][1].touch())}};b=pe([G(0,k.IFileService)],b),e.UriIdentityService=b,(0,n.registerSingleton)(R.IUriIdentityService,b,!0)}),define(ne[235],re([0,1,3,2,13,41,34,16]),function(Q,e,R,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class E extends n.Disposable{constructor(b,w,m,S){super(),this.fileSystemScheme=b,this.fileSystemProvider=w,this.userDataScheme=m,this.logService=S,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(h=>this.handleFileChanges(h)))}get capabilities(){return this.fileSystemProvider.capabilities&-5}watch(b,w){this.watchResources.set(b,b);const m=this.fileSystemProvider.watch(this.toFileSystemResource(b),w);return(0,n.toDisposable)(()=>{this.watchResources.delete(b),m.dispose()})}stat(b){return this.fileSystemProvider.stat(this.toFileSystemResource(b))}mkdir(b){return this.fileSystemProvider.mkdir(this.toFileSystemResource(b))}rename(b,w,m){return this.fileSystemProvider.rename(this.toFileSystemResource(b),this.toFileSystemResource(w),m)}readFile(b){return this.fileSystemProvider.readFile(this.toFileSystemResource(b),{atomic:!0})}readFileStream(b,w,m){const S=(0,T.newWriteableStream)(h=>I.VSBuffer.concat(h.map(y=>I.VSBuffer.wrap(y))).buffer);return(async()=>{try{const h=await this.readFile(b);S.end(h)}catch(h){S.error(h),S.end()}})(),S}readdir(b){return this.fileSystemProvider.readdir(this.toFileSystemResource(b))}writeFile(b,w,m){return this.fileSystemProvider.writeFile(this.toFileSystemResource(b),w,m)}delete(b,w){return this.fileSystemProvider.delete(this.toFileSystemResource(b),w)}copy(b,w,m){if((0,k.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(b),this.toFileSystemResource(w),m);throw new Error("copy not supported")}handleFileChanges(b){const w=[];for(const m of b){if(m.resource.scheme!==this.fileSystemScheme)continue;const S=this.toUserDataResource(m.resource);this.watchResources.findSubstr(S)&&w.push({resource:S,type:m.type})}w.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(w))}toFileSystemResource(b){return b.with({scheme:this.fileSystemScheme})}toUserDataResource(b){return b.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=E}),define(ne[60],re([0,1,76]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(A,I,E,P){const b=(0,R.setProperty)(A,I,E,P)[0];return b&&(A=A.substring(0,b.offset)+b.content+A.substring(b.offset+b.length)),A}e.edit=n;function k(A,I,E){let P=E;for(;P>=0;){if(A.charAt(P)===I.charAt(I.length-1)&&I.length===1)return P+1;if(P--,I.length===2&&P>=0&&A.charAt(P)===I.charAt(0))return P+2}return 0}e.getLineStartOffset=k;function T(A,I,E){let P=E;for(;P>=0;)if(A.charAt(P)===I.charAt(I.length-1)&&I.length===1||(P++,I.length===2&&P>=0&&A.charAt(P)===I.charAt(1)))return P;return A.length-1}e.getLineEndOffset=T}),define(ne[236],re([0,1,31,55,14]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(m,S,h,y,C){const p=[],g=[],a=[];if(!S){const M=m.filter(({identifier:U})=>C.every(D=>D.toLowerCase()!==U.id.toLowerCase()));return{local:{added:p,removed:g,updated:a},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}m=m.map(b),S=S.map(b),h=h?h.map(b):null;const f=new Map,c=M=>{M.uuid&&f.set(M.id.toLowerCase(),M.uuid)};m.forEach(({identifier:M})=>c(M)),S.forEach(({identifier:M})=>c(M)),h?.forEach(({identifier:M})=>c(M));const i=M=>{const U=M.identifier.uuid||f.get(M.identifier.id.toLowerCase());return U?`uuid:${U}`:`id:${M.identifier.id.toLowerCase()}`},s=(M,U)=>(M.set(i(U),U),M),t=m.reduce(s,new Map),r=S.reduce(s,new Map),o=S.reduce((M,U)=>{const D=i(U);U=(0,R.deepClone)(U);const F=t.get(D);return F&&(F.installed&&(U.installed=!0),U.version||(U.version=F.version)),s(M,U)},new Map),l=h?h.reduce(s,new Map):null,u=y.reduce(s,new Map),d=C.reduce((M,U)=>{const D=f.get(U.toLowerCase());return M.add(D?`uuid:${D}`:`id:${U.toLowerCase()}`)},new Set),v=A(t,r,d);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const M=A(l,t,d),U=A(l,r,d),D=(F,$)=>{const j=t.get(F);if(j){const J=r.get(F),H=$?J:j;return{...H,version:J.version&&(!j.installed||n.gt(J.version,j.version))?J.version:j.version,state:I(j,J,l?.get(F)),preRelease:(0,k.isUndefined)(H.preRelease)?j.preRelease:j.installed?H.preRelease:J.preRelease}}};for(const F of U.removed.values()){const $=t.get(F);$&&g.push($.identifier)}for(const F of U.added.values())if(M.added.has(F)){if(v.updated.has(F)){const $=D(F,!0);$&&(a.push(w($,F)),o.set(F,$))}}else{const $=r.get(F);$.installed&&p.push(w($,F))}for(const F of U.updated.values()){const $=D(F,!0);$&&(a.push(w($,F)),o.set(F,$))}for(const F of M.added.values())U.added.has(F)||o.set(F,t.get(F));for(const F of M.updated.values())if(!U.removed.has(F)&&!U.updated.has(F)){const $=D(F,!1);$&&(o.get(F)?.installed&&($.installed=!0),o.set(F,$))}for(const F of M.removed.values())!u.has(F)&&!U.updated.has(F)&&l?.get(F)?.installed&&o.delete(F)}const L=[],_=A(r,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&o.forEach((M,U)=>L.push(w(M,U))),{local:{added:p,removed:g,updated:a},remote:L.length?{added:[..._.added].map(M=>o.get(M)),updated:[..._.updated].map(M=>o.get(M)),removed:[..._.removed].map(M=>r.get(M)),all:L}:null}}e.merge=T;function A(m,S,h,{checkInstalledProperty:y,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const p=m?[...m.keys()].filter(i=>!h.has(i)):[],g=[...S.keys()].filter(i=>!h.has(i)),a=g.filter(i=>p.indexOf(i)===-1).reduce((i,s)=>(i.add(s),i),new Set),f=p.filter(i=>g.indexOf(i)===-1).reduce((i,s)=>(i.add(s),i),new Set),c=new Set;for(const i of p){if(f.has(i))continue;const s=m.get(i),t=S.get(i);(!t||s.disabled!==t.disabled||s.installed&&t.installed&&s.preRelease!==t.preRelease||!P(s.state,t.state)||C&&s.version!==t.version||y&&s.installed!==t.installed)&&c.add(i)}return{added:a,removed:f,updated:c}}function I(m,S,h){const y=m.state,C=S.state,p=h?.state;if(!S.version||y&&n.gt(m.version,S.version))return y;if(C&&n.gt(S.version,m.version)||!y)return C;if(!C)return y;const g=(0,R.deepClone)(y),a=p?E(p,C):{added:Object.keys(C).reduce((c,i)=>(c.add(i),c),new Set),removed:new Set,updated:new Set},f=p?E(p,y):{added:Object.keys(y).reduce((c,i)=>(c.add(i),c),new Set),removed:new Set,updated:new Set};for(const c of[...a.added.values(),...a.updated.values()])g[c]=C[c];for(const c of a.removed.values())f.updated.has(c)||delete g[c];return g}function E(m,S){const h=Object.keys(m),y=Object.keys(S),C=y.filter(a=>h.indexOf(a)===-1).reduce((a,f)=>(a.add(f),a),new Set),p=h.filter(a=>y.indexOf(a)===-1).reduce((a,f)=>(a.add(f),a),new Set),g=new Set;for(const a of h){if(p.has(a))continue;const f=m[a],c=S[a];(0,R.equals)(f,c)||g.add(a)}return{added:C,removed:p,updated:g}}function P(m={},S={}){const{added:h,removed:y,updated:C}=E(m,S);return h.size===0&&y.size===0&&C.size===0}function b(m){return{...m,disabled:!!m.disabled,installed:!!m.installed}}function w(m,S){const h={identifier:{id:m.identifier.id,uuid:S.startsWith("uuid:")?S.substring(5):void 0},preRelease:!!m.preRelease};return m.version&&(h.version=m.version),m.disabled&&(h.disabled=!0),m.installed&&(h.installed=!0),m.state&&(h.state=m.state),h}}),define(ne[109],re([0,1,18,19,5]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,k.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(I){this.configurationService=I}hasToNeverSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,E){let P=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(b=>b.toLowerCase());return P=P.filter(b=>b!==I&&b!==`-${I}`),E&&P.push(I.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",P.length?P:void 0,2)}updateSynchronizedExtensions(I,E){let P=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(b=>b.toLowerCase());return P=P.filter(b=>b!==I&&b!==`-${I}`),E&&P.push(`-${I.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",P.length?P:void 0,2)}getIgnoredExtensions(I){const E=I.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),P=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),b=[],w=[];if(Array.isArray(P))for(const m of P)m.startsWith("-")?w.push(m.substring(1)):b.push(m);return(0,R.distinct)([...E,...b].filter(m=>w.indexOf(m)===-1))}getConfiguredIgnoredExtensions(){let I=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.configurationService.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(E=>E.toLowerCase())}};T=pe([G(0,n.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(ne[237],re([0,1,18,35,31,177,60]),function(Q,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function I(f){return(0,n.parse)(f)||[]}e.parseKeybindings=I;async function E(f,c,i,s,t){const r=I(f),o=I(c),l=i?I(i):null,u=[...r,...o,...l||[]].map(J=>J.key),d=await t.resolveUserBindings(u),v=b(r,o,l,d);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:f,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:f,hasChanges:!0,hasConflicts:!1};const L=m(r),_=m(o),M=l?m(l):null,U=h(L,_,d),D=M?h(M,L,d):{added:[...L.keys()].reduce((J,H)=>(J.add(H),J),new Set),removed:new Set,updated:new Set},F=M?h(M,_,d):{added:[..._.keys()].reduce((J,H)=>(J.add(H),J),new Set),removed:new Set,updated:new Set},$=P(U,D,F);let j=f;for(const J of $.removed.values())$.conflicts.has(J)||(j=g(j,J,s));for(const J of $.added.values()){if($.conflicts.has(J))continue;const H=_.get(J);if(H.some(K=>K.command!==`-${J}`&&v.conflicts.has(d[K.key]))){$.conflicts.add(J);continue}j=p(j,H,s)}for(const J of $.updated.values()){if($.conflicts.has(J))continue;const H=_.get(J);if(H.some(K=>K.command!==`-${J}`&&v.conflicts.has(d[K.key]))){$.conflicts.add(J);continue}j=a(j,J,H,s)}return{mergeContent:j,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=E;function P(f,c,i){const s=new Set,t=new Set,r=new Set,o=new Set;for(const l of c.removed.values())i.updated.has(l)&&o.add(l);for(const l of i.removed.values())o.has(l)||(c.updated.has(l)?o.add(l):t.add(l));for(const l of c.added.values())o.has(l)||i.added.has(l)&&f.updated.has(l)&&o.add(l);for(const l of i.added.values())o.has(l)||(c.added.has(l)?f.updated.has(l)&&o.add(l):s.add(l));for(const l of c.updated.values())o.has(l)||i.updated.has(l)&&f.updated.has(l)&&o.add(l);for(const l of i.updated.values())o.has(l)||(c.updated.has(l)?f.updated.has(l)&&o.add(l):r.add(l));return{added:s,removed:t,updated:r,conflicts:o}}function b(f,c,i,s){const t=new Set,r=w(f,s),o=w(c,s),l=i?w(i,s):null,u=S(r,o);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const d=l?S(l,r):{added:[...r.keys()].reduce((D,F)=>(D.add(F),D),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const v=l?S(l,o):{added:[...o.keys()].reduce((D,F)=>(D.add(F),D),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:L,removed:_,updated:M,conflicts:U}=P(u,d,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:L,removed:_,updated:M,conflicts:U}}function w(f,c){const i=new Map;for(const s of f){const t=c[s.key];let r=i.get(t);r||(r=[],i.set(t,r)),r.push(s)}return i}function m(f){const c=new Map;for(const i of f){const s=i.command[0]==="-"?i.command.substring(1):i.command;let t=c.get(s);t||(t=[],c.set(s,t)),t.push(i)}return c}function S(f,c){const i=[...f.keys()],s=[...c.keys()],t=s.filter(l=>i.indexOf(l)===-1).reduce((l,u)=>(l.add(u),l),new Set),r=i.filter(l=>s.indexOf(l)===-1).reduce((l,u)=>(l.add(u),l),new Set),o=new Set;for(const l of i){if(r.has(l))continue;const u=f.get(l).map(v=>({...v,key:l})),d=c.get(l).map(v=>({...v,key:l}));(0,R.equals)(u,d,(v,L)=>C(v,L))||o.add(l)}return{added:t,removed:r,updated:o}}function h(f,c,i){const s=[...f.keys()],t=[...c.keys()],r=t.filter(u=>s.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),o=s.filter(u=>t.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),l=new Set;for(const u of s){if(o.has(u))continue;const d=f.get(u).map(L=>({...L,key:i[L.key]})),v=c.get(u).map(L=>({...L,key:i[L.key]}));y(d,v)||l.add(u)}return{added:r,removed:o,updated:l}}function y(f,c){return!(!(0,R.equals)(f.filter(({command:i})=>i[0]!=="-"),c.filter(({command:i})=>i[0]!=="-"),(i,s)=>C(i,s))||!(0,R.equals)(f.filter(({command:i})=>i[0]==="-"),c.filter(({command:i})=>i[0]==="-"),(i,s)=>C(i,s)))}function C(f,c){if(f.command!==c.command||f.key!==c.key)return!1;const i=T.ContextKeyExpr.deserialize(f.when),s=T.ContextKeyExpr.deserialize(c.when);return!(i&&!s||!i&&s||i&&s&&!i.equals(s)||!k.equals(f.args,c.args))}function p(f,c,i){for(const s of c)f=A.edit(f,[-1],s,i);return f}function g(f,c,i){const s=I(f);for(let t=s.length-1;t>=0;t--)(s[t].command===c||s[t].command===`-${c}`)&&(f=A.edit(f,[t],void 0,i));return f}function a(f,c,i,s){const t=I(f),r=t.findIndex(o=>o.command===c||o.command===`-${c}`);for(let o=t.length-1;o>=0;o--)(t[o].command===c||t[o].command===`-${c}`)&&(f=A.edit(f,[o],void 0,s));for(let o=i.length-1;o>=0;o--)f=A.edit(f,[r],i[o],s);return f}}),define(ne[238],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(T,A,I){const E={},P={},b=new Set;if(!A)return{local:{added:E,updated:P,removed:[...b.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const w=n(T,A);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:E,updated:P,removed:[...b.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=n(I,T),S=n(I,A),h={},y={},C=new Set,p=new Set;for(const g of m.removed.values())S.updated.has(g)?E[g]=A[g]:C.add(g);for(const g of S.removed.values())p.has(g)||(m.updated.has(g)?p.add(g):b.add(g));for(const g of m.updated.values())p.has(g)||(S.updated.has(g)?w.updated.has(g)&&p.add(g):y[g]=T[g]);for(const g of S.updated.values())p.has(g)||(m.updated.has(g)?w.updated.has(g)&&p.add(g):T[g]!==void 0&&(P[g]=A[g]));for(const g of m.added.values())p.has(g)||(S.added.has(g)?w.updated.has(g)&&p.add(g):h[g]=T[g]);for(const g of S.added.values())p.has(g)||(m.added.has(g)?w.updated.has(g)&&p.add(g):E[g]=A[g]);return{local:{added:E,removed:[...b.values()],updated:P},remote:{added:h,removed:[...C.values()],updated:y},conflicts:[...p.values()]}}e.merge=R;function n(T,A){const I=T?Object.keys(T):[],E=A?Object.keys(A):[],P=E.filter(m=>I.indexOf(m)===-1).reduce((m,S)=>(m.add(S),m),new Set),b=I.filter(m=>E.indexOf(m)===-1).reduce((m,S)=>(m.add(S),m),new Set),w=new Set;for(const m of I){if(b.has(m))continue;const S=T[m],h=A[m];S!==h&&w.add(m)}return{added:P,removed:b,updated:w}}function k(T,A){const{added:I,removed:E,updated:P}=n(T,A);return I.size===0&&E.size===0&&P.size===0}e.areSame=k}),define(ne[26],re([0,1,18,17,14,165,42,29,5,98,40]),function(Q,e,R,n,k,T,A,I,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function w(){const l=b.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(l).filter(u=>!!l[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=w;function m(){const l=b.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(l).filter(L=>!!l[L].ignoreSync),d=Object.keys(l).filter(L=>l[L].scope===2||l[L].scope===6),v=w();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...d,...v])}e.getDefaultIgnoredSettings=m,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function S(){const l="vscode://schemas/ignoredSettings",u=b.Registry.as(A.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:I.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:l,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const d=b.Registry.as(P.Extensions.JSONContribution),v=()=>{const L=w(),_=m().filter(F=>F!==e.CONFIGURATION_SYNC_STORE_KEY),M=Object.keys(A.allSettings.properties).filter(F=>_.indexOf(F)===-1),U=_.filter(F=>L.indexOf(F)===-1),D={items:{type:"string",enum:[...M,...U.map(F=>`-${F}`)]}};d.registerSchema(l,D)};return u.onDidUpdateConfiguration(()=>v())}e.registerConfiguration=S;function h(l){return l&&(0,k.isObject)(l)&&(0,k.isString)(l.id)&&Array.isArray(l.scopes)}e.isAuthenticationProvider=h;var y;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(y=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function C(l,u,d){return d.joinPath(u.userDataSyncHome,l,`lastSync${l}.json`)}e.getLastSyncResourceUri=C,e.IUserDataSyncStoreManagementService=(0,E.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,E.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,E.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function p(l){const u={};return u[e.HEADER_EXECUTION_ID]=l,u}e.createSyncHeaders=p;var g;(function(l){l.Unauthorized="Unauthorized",l.Conflict="Conflict",l.Gone="Gone",l.PreconditionFailed="PreconditionFailed",l.TooLarge="TooLarge",l.UpgradeRequired="UpgradeRequired",l.PreconditionRequired="PreconditionRequired",l.TooManyRequests="RemoteTooManyRequests",l.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",l.RequestFailed="RequestFailed",l.RequestCanceled="RequestCanceled",l.RequestTimeout="RequestTimeout",l.RequestProtocolNotSupported="RequestProtocolNotSupported",l.RequestPathNotEscaped="RequestPathNotEscaped",l.RequestHeadersNotObject="RequestHeadersNotObject",l.NoRef="NoRef",l.EmptyResponse="EmptyResponse",l.TurnedOff="TurnedOff",l.SessionExpired="SessionExpired",l.ServiceChanged="ServiceChanged",l.DefaultServiceChanged="DefaultServiceChanged",l.LocalTooManyRequests="LocalTooManyRequests",l.LocalPreconditionFailed="LocalPreconditionFailed",l.LocalInvalidContent="LocalInvalidContent",l.LocalError="LocalError",l.IncompatibleLocalContent="IncompatibleLocalContent",l.IncompatibleRemoteContent="IncompatibleRemoteContent",l.UnresolvedConflicts="UnresolvedConflicts",l.Unknown="Unknown"})(g=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class a extends Error{constructor(u,d,v,L){super(u),this.code=d,this.resource=v,this.operationId=L,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=a;class f extends a{constructor(u,d,v,L,_){super(u,v,void 0,_),this.url=d,this.serverCode=L}}e.UserDataSyncStoreError=f;class c extends a{constructor(u,d){super(u,d)}}e.UserDataAutoSyncError=c,function(l){function u(d){if(d instanceof l)return d;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(d.name);if(v&&v[1]){const L=v[2]==="unknown"?void 0:v[2],_=v[3]==="unknown"?void 0:v[3];return new l(d.message,v[1],L,_)}return new l(d.message,"Unknown")}l.toUserDataSyncError=u}(a=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(l){l.Uninitialized="uninitialized",l.Idle="idle",l.Syncing="syncing",l.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var s;(function(l){l[l.None=0]="None",l[l.Added=1]="Added",l[l.Modified=2]="Modified",l[l.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var t;(function(l){l.Preview="preview",l.Conflict="conflict",l.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(l){return`sync.enable.${l}`}e.getEnablementKey=r,e.IUserDataSyncEnablementService=(0,E.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,E.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,E.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,E.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,E.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(l,u){if(l.scheme!==e.USER_DATA_SYNC_SCHEME)return l=l.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(d=>(0,n.isEqualOrParent)(l,(0,n.joinPath)(u.userDataSyncHome,d,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(ne[239],re([0,1,31,26]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(I,E,P,b,w){if(!E)return{remote:Object.keys(I).length>0?I:null,local:{added:{},removed:[],updated:{}}};const m=T(I,E);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const S=P?T(P,E):{added:Object.keys(E).reduce((g,a)=>(g.add(a),g),new Set),removed:new Set,updated:new Set},h=P?T(P,I):{added:Object.keys(I).reduce((g,a)=>(g.add(a),g),new Set),removed:new Set,updated:new Set},y={added:{},removed:[],updated:{}},C=R.deepClone(E),p=!P;for(const g of h.added.values())g!==n.SYNC_SERVICE_URL_TYPE&&p&&S.added.has(g)||(C[g]=I[g]);for(const g of h.updated.values())C[g]=I[g];for(const g of h.removed.values())b.unregistered.includes(g)||delete C[g];for(const g of S.added.values()){const a=E[g];if(b.machine.includes(g)){w.info(`GlobalState: Skipped adding ${g} in local storage because it is declared as machine scoped.`);continue}if(P&&h.added.has(g))continue;const f=I[g];f&&f.value===a.value||g===n.SYNC_SERVICE_URL_TYPE&&p&&h.added.has(g)||(f?y.updated[g]=a:y.added[g]=a)}for(const g of S.updated.values()){const a=E[g];if(b.machine.includes(g)){w.info(`GlobalState: Skipped updating ${g} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(g)||h.removed.has(g))continue;const f=I[g];f&&f.value===a.value||(y.updated[g]=a)}for(const g of S.removed.values()){if(b.machine.includes(g)){w.trace(`GlobalState: Skipped removing ${g} in local storage because it is declared as machine scoped.`);continue}h.updated.has(g)||h.removed.has(g)||y.removed.push(g)}return{local:y,remote:A(C,E)?null:C}}e.merge=k;function T(I,E){const P=Object.keys(I),b=Object.keys(E),w=b.filter(h=>P.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),m=P.filter(h=>b.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),S=new Set;for(const h of P){if(m.has(h))continue;const y=I[h],C=E[h];R.equals(y,C)||S.add(h)}return{added:w,removed:m,updated:S}}function A(I,E){const{added:P,removed:b,updated:w}=T(I,E);return P.size===0&&b.size===0&&w.size===0}}),define(ne[240],re([0,1,18,35,76,52,31,60,26]),function(Q,e,R,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function P(u,d,v){let L=[];v?L=w(v):L=b(d);const _=[],M=[...(0,E.getDisallowedIgnoredSettings)()];if(Array.isArray(L))for(const U of L)U.startsWith("-")?M.push(U.substring(1)):_.push(U);return(0,R.distinct)([...u,..._].filter(U=>M.indexOf(U)===-1))}e.getIgnoredSettings=P;function b(u){let d=u.inspect("settingsSync.ignoredSettings").userValue;return d!==void 0||(d=u.inspect("sync.ignoredSettings").userValue,d!==void 0)?d:u.getValue("settingsSync.ignoredSettings")||[]}function w(u){const d=(0,n.parse)(u);return d?d["settingsSync.ignoredSettings"]||d["sync.ignoredSettings"]||[]:[]}function m(u,d){const v=(0,n.parse)(u)||{};let L="{}";for(const _ of Object.keys(v)){const M=(0,k.setProperty)(L,[_],v[_],d);L=(0,k.applyEdits)(L,M)}return L}e.removeComments=m;function S(u,d,v,L){if(v.length){const _=l(d),M=(0,n.parse)(d)||{},U=(0,n.parse)(u);if(!U)return u;const D=[];for(const F of v){const $=M[F],j=U[F];$===void 0?u=I.edit(u,[F],void 0,L):j!==void 0?u=I.edit(u,[F],$,L):D.push(i(F,_))}D.sort((F,$)=>F.startOffset-$.startOffset),D.forEach(F=>u=g(F.setting.key,d,u,L))}return u}e.updateIgnoredSettings=S;function h(u,d,v,L,_,M){const U=S(u,d,L,M),D=v!==U,F=v!==d;if(!D&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(D&&!F)return{conflictsSettings:[],localContent:null,remoteContent:U,hasConflicts:!1};if(F&&!D)return{conflictsSettings:[],localContent:S(d,u,L,M),remoteContent:null,hasConflicts:!1};if(v===null&&C(u)){const x=y(u,d,L)?null:S(d,u,L,M);return{conflictsSettings:[],localContent:x,remoteContent:null,hasConflicts:!1}}let $=u,j=d;const J=(0,n.parse)(u),H=(0,n.parse)(d),K=v?(0,n.parse)(v):null,q=L.reduce((x,Z)=>(x.add(Z),x),new Set),B=p(J,H,q),Y=p(K,J,q),te=p(K,H,q),ce=new Map,z=new Set,V=x=>{z.add(x);const Z=_.filter(({key:oe})=>oe===x)[0];Z?($=I.edit($,[x],Z.value,M),j=I.edit(j,[x],Z.value,M)):ce.set(x,{key:x,localValue:J[x],remoteValue:H[x]})};for(const x of Y.removed.values())te.updated.has(x)?V(x):j=I.edit(j,[x],void 0,M);for(const x of te.removed.values())z.has(x)||(Y.updated.has(x)?V(x):$=I.edit($,[x],void 0,M));for(const x of Y.updated.values())z.has(x)||(te.updated.has(x)?B.updated.has(x)&&V(x):j=I.edit(j,[x],J[x],M));for(const x of te.updated.values())z.has(x)||(Y.updated.has(x)?B.updated.has(x)&&V(x):$=I.edit($,[x],H[x],M));for(const x of Y.added.values())z.has(x)||(te.added.has(x)?B.updated.has(x)&&V(x):j=g(x,$,j,M));for(const x of te.added.values())z.has(x)||(Y.added.has(x)?B.updated.has(x)&&V(x):$=g(x,j,$,M));const O=ce.size>0||!y($,j,L),N=O||!y($,u,[]),W=O||!y(j,d,[]);return{localContent:N?$:null,remoteContent:W?j:null,conflictsSettings:[...ce.values()],hasConflicts:O}}e.merge=h;function y(u,d,v){if(u===d)return!0;const L=(0,n.parse)(u),_=(0,n.parse)(d),M=v.reduce((F,$)=>(F.add($),F),new Set),U=l(u).filter(F=>!(F.setting&&M.has(F.setting.key))),D=l(d).filter(F=>!(F.setting&&M.has(F.setting.key)));if(U.length!==D.length)return!1;for(let F=0;F<U.length;F++){const $=U[F],j=D[F];if($.setting&&j.setting){if($.setting.key!==j.setting.key||!A.equals(L[$.setting.key],_[$.setting.key]))return!1}else if(!$.setting&&!j.setting){if($.value!==j.value)return!1}else return!1}return!0}e.areSame=y;function C(u){return u?l(u).length===0:!0}e.isEmpty=C;function p(u,d,v){const L=u?Object.keys(u).filter(F=>!v.has(F)):[],_=Object.keys(d).filter(F=>!v.has(F)),M=_.filter(F=>L.indexOf(F)===-1).reduce((F,$)=>(F.add($),F),new Set),U=L.filter(F=>_.indexOf(F)===-1).reduce((F,$)=>(F.add($),F),new Set),D=new Set;if(u)for(const F of L){if(U.has(F))continue;const $=u[F],j=d[F];A.equals($,j)||D.add(F)}return{added:M,removed:U,updated:D}}function g(u,d,v,L){const _=(0,n.parse)(d),M=l(d),U=l(v),D=a(u,M,U);return f(v,u,_[u],D,U,L)}e.addSetting=g;function a(u,d,v){const L=d.findIndex(M=>M.setting?.key===u),_=d[L-1];if(_){if(_.setting){const U=i(_.setting.key,v);if(U)return{index:v.indexOf(U),insertAfter:!0}}else{const U=s(L,d);if(U){const D=i(U.setting.key,v);if(D){const F=t(v.indexOf(D),v),$=r(d,U,d[L]);if(F){const j=r(v,D,F),J=o($,j);return J?{index:v.indexOf(J),insertAfter:!0}:{index:v.indexOf(F),insertAfter:!1}}else{const j=r(v,D,v[v.length-1]),J=o($,j);return J?{index:v.indexOf(J),insertAfter:!0}:{index:v.length-1,insertAfter:!0}}}}}const M=d[L+1];if(M)if(M.setting){const U=i(M.setting.key,v);if(U)return{index:v.indexOf(U),insertAfter:!1}}else{const U=t(L,d);if(U){const D=i(U.setting.key,v);if(D){const F=s(v.indexOf(D),v),$=r(d,d[L],U);if(F){const j=r(v,F,D),J=o($.reverse(),j.reverse());return J?{index:v.indexOf(J),insertAfter:!1}:{index:v.indexOf(F),insertAfter:!0}}else{const j=r(v,v[0],D),J=o($.reverse(),j.reverse());return J?{index:v.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:v.length-1,insertAfter:!0}}function f(u,d,v,L,_,M){let U;return L.index===-1?U=(0,k.setProperty)(u,[d],v,M):U=c(u,d,v,L,_,M).map(D=>(0,k.withFormatting)(u,D,M)[0]),(0,k.applyEdits)(u,U)}function c(u,d,v,L,_,M){const U=`${JSON.stringify(d)}: ${JSON.stringify(v)}`,D=(0,T.getEOL)(M,u),F=_[L.index];if(L.insertAfter){const $=[];if(F.setting)$.push({offset:F.endOffset,length:0,content:","+U});else{const j=t(L.index,_),J=s(L.index,_),H=J?.setting?.commaOffset;J&&H===void 0&&$.push({offset:J.endOffset,length:0,content:","});const K=H!==void 0&&H>F.endOffset;$.push({offset:K?H+1:F.endOffset,length:0,content:j?D+U+",":D+U})}return $}else{if(F.setting)return[{offset:F.startOffset,length:0,content:U+","}];const $=(_[L.index-1]&&!_[L.index-1].setting?D:"")+U+(t(L.index,_)?",":"")+D;return[{offset:F.startOffset,length:0,content:$}]}}function i(u,d){return d.filter(v=>v.setting?.key===u)[0]}function s(u,d){for(let v=u-1;v>=0;v--)if(d[v].setting)return d[v]}function t(u,d){for(let v=u+1;v<d.length;v++)if(d[v].setting)return d[v]}function r(u,d,v){const L=u.indexOf(d),_=u.indexOf(v);return u.filter((M,U)=>L<U&&U<_)}function o(u,d){if(u.length&&d.length){let v=0;for(;v<d.length&&v<u.length;v++)if(u[v].value!==d[v].value)return d[v-1];return d[v-1]}}function l(u){const d=[];let v=-1,L,_;const M={onObjectBegin:U=>{v++},onObjectProperty:(U,D,F)=>{v===0&&(L=D,_=U)},onObjectEnd:(U,D)=>{v--,v===0&&d.push({startOffset:L,endOffset:U+D,value:u.substring(L,U+D),setting:{key:_,commaOffset:void 0}})},onArrayBegin:(U,D)=>{v++},onArrayEnd:(U,D)=>{v--,v===0&&d.push({startOffset:L,endOffset:U+D,value:u.substring(L,U+D),setting:{key:_,commaOffset:void 0}})},onLiteralValue:(U,D,F)=>{v===0&&d.push({startOffset:L,endOffset:D+F,value:u.substring(L,D+F),setting:{key:_,commaOffset:void 0}})},onSeparator:(U,D,F)=>{if(v===0&&U===","){let $=d.length-1;for(;$>=0&&!d[$].setting;$--);const j=d[$];j&&d.splice($,1,{startOffset:j.startOffset,endOffset:j.endOffset,value:j.value,setting:{key:j.setting.key,commaOffset:D}})}},onComment:(U,D)=>{v===0&&d.push({startOffset:U,endOffset:U+D,value:u.substring(U,U+D)})}};return(0,n.visit)(u,M),d}}),define(ne[71],re([0,1,3,2,5,26]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,k.createDecorator)("IUserDataSyncAccountService");let A=class extends n.Disposable{constructor(E,P){super(),this.userDataSyncStoreService=E,this.logService=P,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(E.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(E.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(E){(E&&this._account?E.token!==this._account.token||E.authenticationProviderId!==this._account.authenticationProviderId:E!==this._account)&&(this._account=E,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(E))}};A=pe([G(0,T.IUserDataSyncStoreService),G(1,T.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(ne[241],re([0,1,6,16,62,2,17,19,15,13,26]),function(Q,e,R,n,k,T,A,I,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let w=class extends T.Disposable{constructor(S,h,y,C){super(),this.environmentService=S,this.fileService=h,this.configurationService=y,this.logService=C,b.ALL_SYNC_RESOURCES.forEach(p=>this.cleanUpBackup(p))}async getAllRefs(S){const h=(0,A.joinPath)(this.environmentService.userDataSyncHome,S),y=await this.fileService.resolve(h);return y.children?y.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.getCreationTime(p)})):[]}async resolveContent(S,h){if(!h){const y=await this.getAllRefs(S);y.length&&(h=y[y.length-1].ref)}if(h){const y=(0,A.joinPath)(this.environmentService.userDataSyncHome,S,h);return(await this.fileService.readFile(y)).value.toString()}return null}async backup(S,h){const y=(0,A.joinPath)(this.environmentService.userDataSyncHome,S),C=(0,A.joinPath)(y,`${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(C,n.VSBuffer.fromString(h))}catch(p){this.logService.error(p)}try{this.cleanUpBackup(S)}catch{}}async cleanUpBackup(S){const h=(0,A.joinPath)(this.environmentService.userDataSyncHome,S);try{try{if(!await this.fileService.exists(h))return}catch{return}const y=await this.fileService.resolve(h);if(y.children){const C=y.children.filter(f=>f.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(f.name)).sort(),p=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let g=C.filter(f=>Date.now()-this.getCreationTime(f)>p);const a=C.length-g.length;a<10&&(g=g.slice(10-a)),await R.Promises.settled(g.map(async f=>{this.logService.info("Deleting from backup",f.resource.path),await this.fileService.del(f.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(S){return S.ctime||new Date(parseInt(S.name.substring(0,4)),parseInt(S.name.substring(4,6))-1,parseInt(S.name.substring(6,8)),parseInt(S.name.substring(9,11)),parseInt(S.name.substring(11,13)),parseInt(S.name.substring(13,15))).getTime()}};w=pe([G(0,E.IEnvironmentService),G(1,P.IFileService),G(2,I.IConfigurationService),G(3,b.IUserDataSyncLogService)],w),e.UserDataSyncBackupStoreService=w}),define(ne[242],re([0,1,2,7]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class k{constructor(m){this.service=m}listen(m,S){switch(S){case"onError":return this.service.onError}throw new Error(`Event not found: ${S}`)}call(m,S,h){switch(S){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=k;class T{constructor(m){this.service=m}listen(m,S){throw new Error(`Event not found: ${S}`)}call(m,S,h){switch(S){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(n.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class A{constructor(m){this.channel=m}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.channel.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.channel.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=A;class I{constructor(m){this.service=m}listen(m,S){switch(S){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${S}`)}async call(m,S,h){switch(S){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablements":return this.service.setEnablements(h)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=I;class E{constructor(m){this.service=m}listen(m,S){switch(S){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${S}`)}call(m,S,h){switch(S){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=E;class P{constructor(m){this.service=m}listen(m,S){switch(S){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${S}`)}call(m,S,h){switch(S){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=P;class b extends R.Disposable{constructor(m){super(),this.channel=m,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.channel.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(m)}revive(m){return{url:n.URI.revive(m.url),type:m.type,defaultUrl:n.URI.revive(m.defaultUrl),insidersUrl:n.URI.revive(m.insidersUrl),stableUrl:n.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=b}),define(ne[243],re([0,1,15,8]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let k=class extends n.AbstractLogger{constructor(A,I){super(),this.logger=this._register(A.createLogger(I.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...I){this.logger.trace(A,...I)}debug(A,...I){this.logger.debug(A,...I)}info(A,...I){this.logger.info(A,...I)}warn(A,...I){this.logger.warn(A,...I)}error(A,...I){this.logger.error(A,...I)}critical(A,...I){this.logger.critical(A,...I)}flush(){this.logger.flush()}};k=pe([G(0,n.ILoggerService),G(1,R.IEnvironmentService)],k),e.UserDataSyncLogService=k}),define(ne[244],re([0,1,3,2,7,26]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class A{constructor(b,w){this.service=b,this.logService=w,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(b,w){switch(w){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${w}`)}async call(b,w,m){try{return await this._call(b,w,m)}catch(S){throw this.logService.error(S),S}}async _call(b,w,m){switch(w){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(k.URI.revive(m[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(m[0],k.URI.revive(m[1]),m[2],m[3]);case"resolveContent":return this.service.resolveContent(k.URI.revive(m[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(m[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(m[0]);case"getAssociatedResources":return this.service.getAssociatedResources(m[0],{created:m[1].created,uri:k.URI.revive(m[1].uri)});case"getMachineId":return this.service.getMachineId(m[0],{created:m[1].created,uri:k.URI.revive(m[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(w.startsWith("manualSync/")){const S=w.substring(11),h=m[0],y=this.getManualSyncTask(h);switch(m=m.slice(1),S){case"preview":return y.preview();case"accept":return y.accept(k.URI.revive(m[0]),m[1]);case"merge":return y.merge(k.URI.revive(m[0]));case"discard":return y.discard(k.URI.revive(m[0]));case"discardConflicts":return y.discardConflicts();case"apply":return y.apply();case"pull":return y.pull();case"push":return y.push();case"stop":return y.stop();case"_getStatus":return y.status;case"dispose":return this.disposeManualSyncTask(y)}}throw new Error("Invalid call")}getManualSyncTask(b){const w=this.manualSyncTasks.get(this.createKey(b));if(!w)throw new Error(`Manual sync taks not found: ${b}`);return w.manualSyncTask}async createManualSyncTask(){const b=new n.DisposableStore,w=b.add(await this.service.createManualSyncTask());return b.add(w.onSynchronizeResources(m=>this.onManualSynchronizeResources.fire({manualSyncTaskId:w.id,data:m}))),this.manualSyncTasks.set(this.createKey(w.id),{manualSyncTask:w,disposables:b}),{id:w.id,manifest:w.manifest,status:w.status}}disposeManualSyncTask(b){b.dispose();const w=this.createKey(b.id);this.manualSyncTasks.get(w)?.disposables.dispose(),this.manualSyncTasks.delete(w)}createKey(b){return`manualSyncTask-${b}`}}e.UserDataSyncChannel=A;class I extends n.Disposable{constructor(b){super(),this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(w,m,S){return b.call(w,m,S).then(null,h=>{throw T.UserDataSyncError.toUserDataSyncError(h)})},listen(w,m){return b.listen(w,m)}},this.channel.call("_getInitialData").then(([w,m,S])=>{this.updateStatus(w),this.updateConflicts(m),S&&this.updateLastSyncTime(S),this._register(this.channel.listen("onDidChangeStatus")(h=>this.updateStatus(h))),this._register(this.channel.listen("onDidChangeLastSyncTime")(h=>this.updateLastSyncTime(h)))}),this._register(this.channel.listen("onDidChangeConflicts")(w=>this.updateConflicts(w))),this._register(this.channel.listen("onSyncErrors")(w=>this._onSyncErrors.fire(w.map(([m,S])=>[m,T.UserDataSyncError.toUserDataSyncError(S)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:b,manifest:w,status:m}=await this.channel.call("createManualSyncTask"),S=this,h=new E(b,w,m,{async call(y,C,p){return S.channel.call(`manualSync/${y}`,[b,...Array.isArray(C)?C:[C]],p)},listen(y,C){return R.Event.map(R.Event.filter(S.channel.listen(`manualSync/${y}`,C),p=>!h.isDiposed()&&p.manualSyncTaskId===b),p=>p.data)}});return h}replace(b){return this.channel.call("replace",[b])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(b,w,m,S){return this.channel.call("accept",[b,w,m,S])}resolveContent(b){return this.channel.call("resolveContent",[b])}async getLocalSyncResourceHandles(b){return(await this.channel.call("getLocalSyncResourceHandles",[b])).map(({created:m,uri:S})=>({created:m,uri:k.URI.revive(S)}))}async getRemoteSyncResourceHandles(b){return(await this.channel.call("getRemoteSyncResourceHandles",[b])).map(({created:m,uri:S})=>({created:m,uri:k.URI.revive(S)}))}async getAssociatedResources(b,w){return(await this.channel.call("getAssociatedResources",[b,w])).map(({resource:S,comparableResource:h})=>({resource:k.URI.revive(S),comparableResource:k.URI.revive(h)}))}async getMachineId(b,w){return this.channel.call("getMachineId",[b,w])}async updateStatus(b){this._status=b,this._onDidChangeStatus.fire(b)}async updateConflicts(b){this._conflicts=b.map(([w,m])=>[w,m.map(S=>({...S,baseResource:k.URI.revive(S.baseResource),localResource:k.URI.revive(S.localResource),remoteResource:k.URI.revive(S.remoteResource),previewResource:k.URI.revive(S.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(b){this._lastSyncTime!==b&&(this._lastSyncTime=b,this._onDidChangeLastSyncTime.fire(b))}}e.UserDataSyncChannelClient=I;class E extends n.Disposable{constructor(b,w,m,S){super(),this.id=b,this.manifest=w,this._disposed=!1,this._status=m;const h=this;this.channel={async call(y,C,p){try{const g=await S.call(y,C,p);return h.isDiposed()||(h._status=await S.call("_getStatus")),g}catch(g){throw T.UserDataSyncError.toUserDataSyncError(g)}},listen(y,C){return S.listen(y,C)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const b=await this.channel.call("preview");return this.deserializePreviews(b)}async accept(b,w){const m=await this.channel.call("accept",[b,w]);return this.deserializePreviews(m)}async merge(b){const w=await this.channel.call("merge",[b]);return this.deserializePreviews(w)}async discard(b){const w=await this.channel.call("discard",[b]);return this.deserializePreviews(w)}async discardConflicts(){const b=await this.channel.call("discardConflicts");return this.deserializePreviews(b)}async apply(){const b=await this.channel.call("apply");return this.deserializePreviews(b)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(b){return b.map(([w,m])=>[w,{isLastSyncFromCurrentMachine:m.isLastSyncFromCurrentMachine,resourcePreviews:m.resourcePreviews.map(S=>({...S,baseResource:k.URI.revive(S.baseResource),localResource:k.URI.revive(S.localResource),remoteResource:k.URI.revive(S.remoteResource),previewResource:k.URI.revive(S.previewResource),acceptedResource:k.URI.revive(S.acceptedResource)}))}])}}}),define(ne[245],re([0,1,6,3,2]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends k.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:E,getActiveWindowId:P}){super(),this.disposables=this._register(new k.DisposableStore),n.Event.latch(n.Event.any(I,E))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>P()),(async()=>{try{const w=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:w}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(ne[110],re([0,1,167,10,34,17,7,5,20]),function(Q,e,R,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function P(s){const t=s;return typeof t?.id=="string"&&A.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function b(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,n.basename)(s)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=s;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=b;function w(s){const t=s;return typeof t?.id=="string"&&A.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=w;function m(s){const t=s;if(t?.uri)return{id:t.id,uri:A.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:A.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=m;var S;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function h(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=h;function y(s){const t=s;return!!(t&&typeof t=="object"&&A.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=y;class C{constructor(t,r,o,l,u){this._id=t,this._transient=o,this._configuration=l,this._ignorePathCasing=u,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=C;class p{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,T.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function g(s){return new p({uri:s,index:0,name:(0,T.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function a(s,t){return T.extUriBiasedIgnorePathCase.isEqualOrParent(s,t.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function f(s){let t;return A.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=f;function c(s,t){return!a(s,t)&&!f(s)}e.isSavedWorkspace=c;function i(s){return(typeof s=="string"?(0,n.extname)(s):(0,T.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ne[28],re([0,1,63,3,2,17,14,7,160,15,13,5,8,110,34,33,6,30,24]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function a(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&I.URI.isUri(t.location)&&I.URI.isUri(t.globalStorageHome)&&I.URI.isUri(t.settingsResource)&&I.URI.isUri(t.keybindingsResource)&&I.URI.isUri(t.tasksResource)&&I.URI.isUri(t.snippetsHome)&&((0,A.isUndefined)(t.extensionsResource)||I.URI.isUri(t.extensionsResource)))}e.isUserDataProfile=a,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,w.createDecorator)("IUserDataProfilesService");function f(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,location:I.URI.revive(s.location).with({scheme:t}),globalStorageHome:I.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:I.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:I.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:I.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:I.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:I.URI.revive(s.extensionsResource)?.with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.reviveProfile=f,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function c(s,t,r,o){return{id:(0,R.hash)(t.path).toString(16),name:s,location:t,isDefault:!1,globalStorageHome:(0,T.joinPath)(t,"globalStorage"),settingsResource:(0,T.joinPath)(t,"settings.json"),keybindingsResource:(0,T.joinPath)(t,"keybindings.json"),tasksResource:(0,T.joinPath)(t,"tasks.json"),snippetsHome:(0,T.joinPath)(t,"snippets"),extensionsResource:(0,T.joinPath)(t,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:r,isTransient:o}}e.toUserDataProfile=c;let i=class extends k.Disposable{constructor(t,r,o,l){super(),this.environmentService=t,this.fileService=r,this.uriIdentityService=o,this.logService=l,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new n.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new n.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new n.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new n.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap},this.profilesHome=(0,T.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}setEnablement(t){this.enabled!==t&&(this._profilesObject=void 0,this.enabled=t)}get profilesObject(){if(!this._profilesObject){const t=this.enabled?this.getStoredProfiles().map(u=>c(u.name,u.location,u.useDefaultFlags)):[];let r;const o=new h.ResourceMap,l=c((0,E.localize)(0,null),this.environmentService.userRoamingDataHome);if(t.unshift({...l,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||t.length>0||this.transientProfilesObject.profiles.length>0?l.extensionsResource:void 0}),t.length){const u=this.getStoredProfileAssociations();if(u.workspaces)for(const[d,v]of Object.entries(u.workspaces)){const L=I.URI.parse(d),_=I.URI.parse(v),M=t.find(U=>this.uriIdentityService.extUri.isEqual(U.location,_));M&&o.set(L,M)}if(u.emptyWindow){const d=I.URI.parse(u.emptyWindow);r=t.find(v=>this.uriIdentityService.extUri.isEqual(v.location,d))}}this._profilesObject={profiles:t,workspaces:o,emptyWindow:r}}return this._profilesObject}async createTransientProfile(t){const r="Temp",o=new RegExp(`${(0,g.escapeRegExpCharacters)(r)}\\s(\\d+)`);let l=0;for(const d of this.profiles){const v=o.exec(d.name),L=v?parseInt(v[1]):0;l=L>l?L:l}const u=`${r} ${l+1}`;return this.createProfile(u,void 0,t,!0)}async createProfile(t,r,o,l){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=await this.doCreateProfile(t,r,l);return o&&await this.setProfileForWorkspace(o,u),u}async doCreateProfile(t,r,o){let l=this.profileCreationPromises.get(t);return l||(l=(async()=>{try{const u=this.profiles.find(L=>L.name===t);if(u)return u;const d=c(t,(0,T.joinPath)(this.profilesHome,(0,R.hash)((0,p.generateUuid)()).toString(16)),r,o);await this.fileService.createFolder(d.location);const v=[];return this._onWillCreateProfile.fire({profile:d,join(L){v.push(L)}}),await C.Promises.settled(v),this.updateProfiles([d],[],[]),d}finally{this.profileCreationPromises.delete(t)}})(),this.profileCreationPromises.set(t,l)),l}async updateProfile(t,r,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let l=this.profiles.find(u=>u.id===t.id);if(!l)throw new Error(`Profile '${t.name}' does not exist`);return l=c(r,l.location,o),this.updateProfiles([],[],[l]),l}async removeProfile(t){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(l=>l.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this._onWillRemoveProfile.fire({profile:r,join(l){o.push(l)}}),await C.Promises.settled(o),r.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const l of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(l)?.id&&this.profilesObject.workspaces.delete(l);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(l){this.logService.error(l)}}getOrSetProfileForWorkspace(t,r=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let o=this.getProfileForWorkspace(t);return o||(o=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(t,o)),o}async setProfileForWorkspace(t,r){this.setProfileForWorkspaceSync(t,r)}setProfileForWorkspaceSync(t,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=this.profiles.find(l=>l.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(t,o)}unsetWorkspace(t,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(t,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const t=await this.fileService.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.uriIdentityService.extUri.isEqual(o.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const t=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.getWorkspace(t);return I.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(t){return(0,S.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,S.isWorkspaceIdentifier)(t)?t.configPath:"empty-window"}isProfileAssociatedToWorkspace(t){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,t.location)||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,t.location)||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location)))}updateProfiles(t,r,o){const l=[...this.profiles,...t],u=[];this.transientProfilesObject.profiles=[];for(let d of l)d.isDefault||r.some(v=>d.id===v.id)||(d=o.find(v=>d.id===v.id)??d,d.isTransient?this.transientProfilesObject.profiles.push(d):u.push({location:d.location,name:d.name,useDefaultFlags:d.useDefaultFlags}));this.saveStoredProfiles(u),this._profilesObject=void 0,this.triggerProfilesChanges(t,r,o)}triggerProfilesChanges(t,r,o){this._onDidChangeProfiles.fire({added:t,removed:r,updated:o,all:this.profiles})}updateWorkspaceAssociation(t,r,o){o=r?.isTransient?!0:o,o||this.updateWorkspaceAssociation(t,void 0,!0);const l=this.getWorkspace(t),u=o?this.transientProfilesObject:this.profilesObject;I.URI.isUri(l)?(u.workspaces.delete(l),r&&u.workspaces.set(l,r)):u.emptyWindow=r,o||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const t={};for(const[o,l]of this.profilesObject.workspaces.entries())t[o.toString()]=l.location.toString();const r=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:t,emptyWindow:r}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(t){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(t){throw new Error("not implemented")}};i.PROFILES_KEY="userDataProfiles",i.PROFILE_ASSOCIATIONS_KEY="profileAssociations",i=pe([G(0,P.IEnvironmentService),G(1,b.IFileService),G(2,y.IUriIdentityService),G(3,m.ILogService)],i),e.UserDataProfilesService=i}),define(ne[246],re([0,1,6,2,28]),function(Q,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let T=class extends n.Disposable{constructor(I){super(),this._register(new R.RunOnceScheduler(()=>{I.cleanUp()},10*1e3)).schedule()}};T=pe([G(0,k.IUserDataProfilesService)],T),e.UserDataProfilesCleaner=T}),define(ne[247],re([0,1,18,6,21,9,3,2,4,7,142,29,32,43,8,25,22,28]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends I.Disposable{constructor(t,r,o,l,u){super(),this.galleryService=t,this.telemetryService=r,this.logService=o,this.productService=l,this.userDataProfilesService=u,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(({task:d})=>d.cancel()),this.uninstallingExtensions.forEach(d=>d.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,w.isTargetPlatformCompatible)(o,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.galleryService.isEnabled())throw new w.ExtensionManagementError(b.localize(0,null),w.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(t,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,r)}catch(o){throw c(this.telemetryService,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(t),error:o}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(o),f(o)}}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,r)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(b.localize(1,null));const r=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:r,compatible:!0},k.CancellationToken.None);if(!o)throw new Error(b.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,r,o){const l=M=>`${m.ExtensionKey.create(M).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const M=this.installingExtensions.get(l(r));if(M){this.logService.info("Extensions is already requested to install",r.identifier.id);const{local:U}=await M.task.waitUntilTaskIsFinished();return U}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const u=[],d=[],v=[],L=this.createInstallExtensionTask(t,r,o);P.URI.isUri(r)||this.installingExtensions.set(l(r),{task:L,waitingTasks:[]}),this._onInstallExtension.fire({identifier:L.identifier,source:r,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",L.identifier.id),u.push({task:L,manifest:t});let _=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",L.identifier.id);else try{const U=await this.getAllDepsAndPackExtensions(L.identifier,t,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),D=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:F,manifest:$}of U){_=_||!!$.extensionDependencies?.some(H=>(0,m.areSameExtensions)({id:H},L.identifier));const j=l(F),J=this.installingExtensions.get(j);if(J){if(this.canWaitForTask(L,J.task)){this.logService.info("Waiting for already requested installing extension",F.identifier.id,L.identifier.id),J.waitingTasks.push(L);const H=J.task.identifier;d.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,K=>K.some(q=>(0,m.areSameExtensions)(q.identifier,H)))).then(K=>{if(!K.find(B=>(0,m.areSameExtensions)(B.identifier,H))?.local)throw new Error(`Extension ${H.id} is not installed`)}))}}else if(!D.some(({identifier:H})=>(0,m.areSameExtensions)(H,F.identifier))){const H=this.createInstallExtensionTask($,F,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(j,{task:H,waitingTasks:[L]}),this._onInstallExtension.fire({identifier:H.identifier,source:F,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",H.identifier.id,L.identifier.id),u.push({task:H,manifest:$})}}}catch(U){if(P.URI.isUri(L.source))(0,R.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",L.identifier.id,U.message),(0,R.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",L.identifier.id,U.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",L.identifier.id),U}const M=u.reduce((U,{task:D,manifest:F})=>(U.set(D.identifier.id.toLowerCase(),{task:D,manifest:F}),U),new Map);for(;M.size;){let U;const D=[...M.values()].filter(({manifest:F})=>!F.extensionDependencies?.some($=>M.has($.toLowerCase())));D.length?U=M.size===1?D:D.filter(({task:F})=>!(F===L&&!_)):(this.logService.info("Found extensions with circular dependencies",D.map(({task:F})=>F.identifier.id)),U=[...M.values()]),await this.joinAllSettled(U.map(async({task:F})=>{const $=new Date().getTime();try{const{local:j}=await F.run();if(await this.joinAllSettled(this.participants.map(J=>J.postInstall(j,F.source,o,k.CancellationToken.None))),!P.URI.isUri(F.source)){const J=F.operation===3,H=J?void 0:(new Date().getTime()-F.source.lastUpdated)/1e3;if(c(this.telemetryService,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(F.source),duration:new Date().getTime()-$,durationSinceUpdate:H}),E.isWeb&&F.operation!==3)try{await this.galleryService.reportStatistic(j.manifest.publisher,j.manifest.name,j.manifest.version,"install")}catch{}}v.push({local:j,identifier:F.identifier,operation:F.operation,source:F.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:j.isApplicationScoped})}catch(j){throw P.URI.isUri(F.source)||c(this.telemetryService,F.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(F.source),duration:new Date().getTime()-$,error:j}),this.logService.error("Error while installing the extension:",F.identifier.id),j}finally{M.delete(F.identifier.id.toLowerCase())}}))}return d.length&&await this.joinAllSettled(d),v.forEach(({identifier:U})=>this.logService.info("Extension installed successfully:",U.id)),this._onDidInstallExtensions.fire(v),v.filter(({identifier:U})=>(0,m.areSameExtensions)(U,L.identifier))[0].local}catch(M){if(u.forEach(({task:U})=>U.cancel()),v.length)try{const U=await Promise.allSettled(v.map(({local:D})=>this.createUninstallExtensionTask(D,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let D=0;D<U.length;D++){const F=U[D],{identifier:$}=v[D];F.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",$.id):this.logService.warn("Rollback: Error while uninstalling extension",$.id,(0,T.getErrorMessage)(F.reason))}}catch(U){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(U),v.map(({identifier:D})=>D.id))}throw this._onDidInstallExtensions.fire(u.map(({task:U})=>({identifier:U.identifier,operation:2,source:U.source,context:o.context,profileLocation:o.profileLocation}))),M}finally{for(const[M,{task:U,waitingTasks:D}]of this.installingExtensions.entries()){const F=D.indexOf(L);F!==-1&&D.splice(F,1),D.length===0&&(U===L||F!==-1)&&this.installingExtensions.delete(M)}}}canWaitForTask(t,r){for(const[,{task:o,waitingTasks:l}]of this.installingExtensions.entries())if(o===t&&(l.includes(r)||l.some(u=>this.canWaitForTask(u,r)))||o===r&&l[0]&&!this.canWaitForTask(t,l[0]))return!1;return!0}async joinAllSettled(t){const r=[],o=[],l=await Promise.allSettled(t);for(const u of l)u.status==="fulfilled"?r.push(u.value):o.push(u.reason);if(o.length)throw a(o);return r}async getAllDepsAndPackExtensions(t,r,o,l,u){if(!this.galleryService.isEnabled())return[];const d=await this.getInstalled(void 0,u),v=[t],L=[],_=async(M,U)=>{const D=U.extensionDependencies||[],F=[...D];if(U.extensionPack){const $=o?d.find(j=>(0,m.areSameExtensions)(j.identifier,M)):void 0;for(const j of U.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(J=>(0,m.areSameExtensions)({id:J},{id:j}))||F.every(J=>!(0,m.areSameExtensions)({id:J},{id:j}))&&F.push(j)}if(F.length){const $=[...v,...L.map(J=>J.gallery.identifier)],j=F.filter(J=>$.every(H=>!(0,m.areSameExtensions)(H,{id:J})));if(j.length){const J=await this.galleryService.getExtensions(j.map(H=>({id:H,preRelease:l})),k.CancellationToken.None);for(const H of J){if($.find(B=>(0,m.areSameExtensions)(B,H.identifier)))continue;const K=D.some(B=>(0,m.areSameExtensions)({id:B},H.identifier));let q;try{q=await this.checkAndGetCompatibleVersion(H,!1,l)}catch(B){if(B instanceof w.ExtensionManagementError&&B.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!K){this.logService.info("Skipping the packed extension as it cannot be installed",H.identifier.id);continue}else throw B}L.push({gallery:q.extension,manifest:q.manifest}),await _(q.extension.identifier,q.manifest)}}}};return await _(t,r),L}async checkAndGetCompatibleVersion(t,r,o){if((await this.getExtensionsControlManifest()).malicious.some(v=>(0,m.areSameExtensions)(t.identifier,v)))throw new w.ExtensionManagementError(b.localize(3,null,t.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const v=await this.getTargetPlatform();throw new w.ExtensionManagementError(b.localize(4,null,t.identifier.id,this.productService.nameLong,(0,w.TargetPlatformToString)(v)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const u=await this.getCompatibleVersion(t,r,o);if(u){if(o&&!r&&t.hasPreReleaseVersion&&!u.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(b.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],k.CancellationToken.None))[0]?new w.ExtensionManagementError(b.localize(6,null,t.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(b.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",u.identifier.id);const d=await this.galleryService.getManifest(u,k.CancellationToken.None);if(d===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(d.version!==u.version)throw new w.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:u,manifest:d}}async getCompatibleVersion(t,r,o){const l=await this.getTargetPlatform();let u=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(u=(await this.galleryService.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:l,compatible:!0},k.CancellationToken.None))[0]||null),!u&&await this.galleryService.isExtensionCompatible(t,o,l)&&(u=t),u||(r?u=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:l,compatible:!0},k.CancellationToken.None))[0]||null:u=await this.galleryService.getCompatibleExtension(t,o,l)),u}async uninstallExtension(t,r){const o=_=>`${_.id.toLowerCase()}${r.versionOnly?`-${t.manifest.version}`:""}${r.profileLocation?`@${r.profileLocation.toString()}`:""}`,l=this.uninstallingExtensions.get(o(t.identifier));if(l)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),l.waitUntilTaskIsFinished();const u=(_,M)=>{const U=this.createUninstallExtensionTask(_,M);return this.uninstallingExtensions.set(o(U.extension.identifier),U),r.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,r.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this._onUninstallExtension.fire({identifier:_.identifier,profileLocation:r.profileLocation,applicationScoped:_.isApplicationScoped}),U},d=(_,M)=>{M?r.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,r.profileLocation.toString(),M.message):this.logService.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,M.message):r.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,r.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),c(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(_),error:M}),this._onDidUninstallExtension.fire({identifier:_.identifier,version:_.manifest.version,error:M?.code,profileLocation:r.profileLocation,applicationScoped:_.isApplicationScoped})},v=[],L=[];try{v.push(u(t,r));const _=await this.getInstalled(1,r.profileLocation);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const M=this.getAllPackExtensionsToUninstall(t,_);for(const U of M)this.uninstallingExtensions.has(o(U.identifier))?this.logService.info("Extensions is already requested to uninstall",U.identifier.id):v.push(u(U,r))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(v.map(M=>M.extension),_,t),await this.joinAllSettled(v.map(async M=>{try{if(await M.run(),await this.joinAllSettled(this.participants.map(U=>U.postUninstall(M.extension,r,k.CancellationToken.None))),M.extension.identifier.uuid)try{await this.galleryService.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}d(M.extension)}catch(U){const D=U instanceof w.ExtensionManagementError?U:new w.ExtensionManagementError((0,T.getErrorMessage)(U),w.ExtensionManagementErrorCode.Internal);throw d(M.extension,D),D}finally{L.push(M)}}))}catch(_){const M=_ instanceof w.ExtensionManagementError?_:new w.ExtensionManagementError((0,T.getErrorMessage)(_),w.ExtensionManagementErrorCode.Internal);for(const U of v){try{U.cancel()}catch{}L.includes(U)||d(U.extension,M)}throw M}finally{for(const _ of v)this.uninstallingExtensions.delete(o(_.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}checkForDependents(t,r,o){for(const l of t){const u=this.getDependents(l,r);if(u.length){const d=u.filter(v=>!t.some(L=>(0,m.areSameExtensions)(L.identifier,v.identifier)));if(d.length)throw new Error(this.getDependentsErrorMessage(l,d,o))}}}getDependentsErrorMessage(t,r,o){return o===t?r.length===1?b.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(9,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(10,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?b.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(12,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(13,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const l=t.manifest.extensionPack?t.manifest.extensionPack:[];if(l.length){const u=r.filter(v=>!v.isBuiltin&&l.some(L=>(0,m.areSameExtensions)({id:L},v.identifier))),d=[];for(const v of u)d.push(...this.getAllPackExtensionsToUninstall(v,r,o));return[...u,...d]}return[]}getDependents(t,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(l=>(0,m.areSameExtensions)({id:l},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(t,r,o){return o.profileLocation&&(0,S.isApplicationScopedExtension)(t)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(t,r,o)}createUninstallExtensionTask(t,r){return r.profileLocation&&t.isApplicationScoped&&(r={...r,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(t,r)}};g=pe([G(0,w.IExtensionGalleryService),G(1,C.ITelemetryService),G(2,h.ILogService),G(3,y.IProductService),G(4,p.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function a(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=a;function f(s){if(s instanceof w.ExtensionManagementError)return s;const t=new w.ExtensionManagementError(s.message,w.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}function c(s,t,{extensionData:r,duration:o,error:l,durationSinceUpdate:u}){const d=l?l instanceof w.ExtensionManagementError?l.code:w.ExtensionManagementErrorCode.Internal:void 0;s.publicLog(t,{...r,success:!l,duration:o,errorcode:d,durationSinceUpdate:u})}e.reportTelemetry=c;class i{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(t=>new Promise((r,o)=>{const l=t.onCancellationRequested(()=>{l.dispose(),o(new T.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=i}),define(ne[72],re([0,1,18,6,31,16,9,35,124,2,20,10,4,17,55,81,14,7,145,15,32,43,66,13,5,8,25,3,64,48,28,33,173]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C,p,g,a,f,c,i,s,t,r,o,l,u,d,v,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var M;(function(H){function K(q,B){if(q===B)return!0;const Y=Object.keys(q),te=new Set;for(const ce of Object.keys(B))te.add(ce);if(Y.length!==te.size)return!1;for(const ce of Y){if(q[ce]!==B[ce])return!1;te.delete(ce)}return te.size===0}H.equals=K})(M=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let U=class extends P.Disposable{constructor(K,q,B,Y,te,ce,z,V,O,N,W){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=q,this.extensionsControlLocation=B,this.cacheLocation=Y,this.userDataProfilesService=te,this.extensionsProfileScannerService=ce,this.fileService=z,this.logService=V,this.environmentService=O,this.productService=N,this.instantiationService=W,this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,S.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance($,(0,S.joinPath)(this.cacheLocation,c.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance($,(0,S.joinPath)(this.cacheLocation,c.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(F,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(K,q,B){const[Y,te]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(q)]),ce=B?await this.scanExtensionsUnderDevelopment(K,[...Y,...te]):[];return this.dedupExtensions(Y,te,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const q=[];q.push(this.scanDefaultSystemExtensions(!!K.useCache,K.language)),q.push(this.scanDevSystemExtensions(K.language,!!K.checkControlFile));const[B,Y]=await Promise.all(q);return this.applyScanOptions([...B,...Y],0,K,!1)}async scanUserExtensions(K){this.logService.trace("Started scanning user extensions");const q=await this.createExtensionScannerInput(K.profileLocation??this.userExtensionsLocation,!!K.profileLocation,1,!K.includeUninstalled,K.language);let Y=await(K.useCache&&!q.devMode&&q.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(q);return Y=await this.applyScanOptions(Y,1,K,!0),this.logService.trace("Scanned user extensions:",Y.length),Y}async scanExtensionsUnderDevelopment(K,q){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const B=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(Y=>Y.scheme===b.Schemas.file).map(async Y=>{const te=await this.createExtensionScannerInput(Y,!1,1,!0,K.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(te)).map(z=>(z.type=q.find(V=>(0,f.areSameExtensions)(V.identifier,z.identifier))?.type??z.type,this.extensionsScanner.validate(z,te)))}))).flat();return this.applyScanOptions(B,"development",K,!0)}return[]}async scanExistingExtension(K,q,B){const Y=await this.createExtensionScannerInput(K,!1,q,!0,B.language),te=await this.extensionsScanner.scanExtension(Y);return!te||!B.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(K,q,B){const Y=await this.createExtensionScannerInput(K,!1,q,!0,B.language),te=await this.extensionsScanner.scanOneOrMultipleExtensions(Y);return this.applyScanOptions(te,q,B,!0)}async scanMetadata(K){const q=(0,S.joinPath)(K,"package.json"),B=(await this.fileService.readFile(q)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(K,q){const B=(0,S.joinPath)(K,"package.json"),Y=(await this.fileService.readFile(B)).value.toString(),te=JSON.parse(Y);q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,q.installedTimestamp=q.installedTimestamp||void 0,te.__metadata={...te.__metadata,...q},await this.fileService.writeFile((0,S.joinPath)(K,"package.json"),T.VSBuffer.fromString(JSON.stringify(te,null,"	")))}async applyScanOptions(K,q,B,Y){return B.includeAllVersions||(K=this.dedupExtensions(q===0?K:void 0,q===1?K:void 0,q==="development"?K:void 0,await this.getTargetPlatform(),Y)),B.includeInvalid||(K=K.filter(te=>te.isValid)),K.sort((te,ce)=>{const z=w.basename(te.location.fsPath),V=w.basename(ce.location.fsPath);return z<V?-1:z>V?1:0})}dedupExtensions(K,q,B,Y,te){const ce=(V,O,N)=>{if(V.isValid&&!O.isValid)return!1;if(V.isValid===O.isValid){if(te&&h.gt(V.manifest.version,O.manifest.version))return this.logService.debug(`Skipping extension ${O.location.path} with lower version ${O.manifest.version} in favour of ${V.location.path} with version ${V.manifest.version}`),!1;if(h.eq(V.manifest.version,O.manifest.version)){if(V.type===0)return this.logService.debug(`Skipping extension ${O.location.path} in favour of system extension ${V.location.path} with same version`),!1;if(V.targetPlatform===Y)return this.logService.debug(`Skipping extension ${O.location.path} from different target platform ${O.targetPlatform}`),!1}}return N?this.logService.warn(`Overwriting user extension ${V.location.path} with ${O.location.path}.`):this.logService.debug(`Overwriting user extension ${V.location.path} with ${O.location.path}.`),!0},z=new Map;return K?.forEach(V=>{const O=c.ExtensionIdentifier.toKey(V.identifier.id),N=z.get(O);(!N||ce(N,V,!1))&&z.set(O,V)}),q?.forEach(V=>{const O=c.ExtensionIdentifier.toKey(V.identifier.id),N=z.get(O);if(!N&&K&&V.type===0){this.logService.debug(`Skipping obsolete system extension ${V.location.path}.`);return}(!N||ce(N,V,!1))&&z.set(O,V)}),B?.forEach(V=>{const O=c.ExtensionIdentifier.toKey(V.identifier.id),N=z.get(O);(!N||ce(N,V,!0))&&z.set(O,V),z.set(O,V)}),[...z.values()]}async scanDefaultSystemExtensions(K,q){this.logService.trace("Started scanning system extensions");const B=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,q),te=await(K&&!B.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(B);return this.logService.trace("Scanned system extensions:",te.length),te}async scanDevSystemExtensions(K,q){const B=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!B?.length)return[];this.logService.trace("Started scanning dev system extensions");const Y=q?await this.getBuiltInExtensionControl():{},te=[],ce=p.URI.file(w.normalize(w.join(b.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions")));for(const V of B){const O=Y[V.name]||"marketplace";switch(O){case"disabled":break;case"marketplace":te.push((0,S.joinPath)(ce,V.name));break;default:te.push(p.URI.file(O));break}}const z=await Promise.all(te.map(async V=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(V,!1,0,!0,K))));return this.logService.trace("Scanned dev system extensions:",z.length),(0,R.coalesce)(z)}async getBuiltInExtensionControl(){try{const K=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(K.value.toString())}catch{return{}}}async createExtensionScannerInput(K,q,B,Y,te,ce=!0){const z=await this.getTranslations(te??m.language),V=await this.getMtime(K),O=q?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,N=O?await this.getMtime(O):void 0;return new D(K,V,O,N,q,B,Y,ce,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,te,z)}async getMtime(K){try{const q=await this.fileService.stat(K);if(typeof q.mtime=="number")return q.mtime}catch{}}};U=pe([G(4,v.IUserDataProfilesService),G(5,d.IExtensionsProfileScannerService),G(6,s.IFileService),G(7,r.ILogService),G(8,a.IEnvironmentService),G(9,o.IProductService),G(10,t.IInstantiationService)],U),e.AbstractExtensionsScannerService=U;class D{constructor(K,q,B,Y,te,ce,z,V,O,N,W,x,Z,oe){this.location=K,this.mtime=q,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=Y,this.profile=te,this.type=ce,this.excludeObsolete=z,this.validate=V,this.productVersion=O,this.productDate=N,this.productCommit=W,this.devMode=x,this.language=Z,this.translations=oe}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,q){return(0,S.isEqual)(K.location,q.location)&&K.mtime===q.mtime&&(0,S.isEqual)(K.applicationExtensionslocation,q.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===q.applicationExtensionslocationMtime&&K.profile===q.profile&&K.type===q.type&&K.excludeObsolete===q.excludeObsolete&&K.validate===q.validate&&K.productVersion===q.productVersion&&K.productDate===q.productDate&&K.productCommit===q.productCommit&&K.devMode===q.devMode&&K.language===q.language&&M.equals(K.translations,q.translations)}}let F=class extends P.Disposable{constructor(K,q,B,Y,te){super(),this.obsoleteFile=K,this.extensionsProfileScannerService=q,this.uriIdentityService=B,this.fileService=Y,this.logService=te}async scanExtensions(K){const q=K.profile?await this.scanExtensionsFromProfile(K):await this.scanExtensionsFromLocation(K);let B={};if(K.excludeObsolete&&K.type===1)try{const Y=(await this.fileService.readFile(this.obsoleteFile)).value.toString();B=JSON.parse(Y)}catch{}return(0,C.isEmptyObject)(B)?q:q.filter(Y=>!B[f.ExtensionKey.create(Y).toString()])}async scanExtensionsFromLocation(K){const q=await this.fileService.resolve(K.location);if(!q.children?.length)return[];const B=await Promise.all(q.children.map(async Y=>{if(!Y.isDirectory||K.type===1&&(0,S.basename)(Y.resource).indexOf(".")===0)return null;const te=new D(Y.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(te)}));return(0,R.coalesce)(B).sort((Y,te)=>Y.location.path<te.location.path?-1:1)}async scanExtensionsFromProfile(K){let q=await this.scanExtensionsFromProfileResource(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(K.location,K.applicationExtensionslocation)){q=q.filter(Y=>!Y.metadata?.isApplicationScoped);const B=await this.scanExtensionsFromProfileResource(K.applicationExtensionslocation,Y=>!!Y.metadata?.isApplicationScoped,K);q.push(...B)}return q}async scanExtensionsFromProfileResource(K,q,B){const Y=await this.extensionsProfileScannerService.scanProfileExtensions(K);if(!Y.length)return[];const te=await Promise.all(Y.map(async ce=>{if(q(ce)){const z=new D(ce.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(z,ce.metadata)}return null}));return(0,R.coalesce)(te)}async scanOneOrMultipleExtensions(K){try{if(await this.fileService.exists((0,S.joinPath)(K.location,"package.json"))){const q=await this.scanExtension(K);return q?[q]:[]}else return await this.scanExtensions(K)}catch(q){return this.logService.error(`Error scanning extensions at ${K.location.path}:`,(0,A.getErrorMessage)(q)),[]}}async scanExtension(K,q){try{let B=await this.scanExtensionManifest(K.location);if(B){B.publisher||(B.publisher=c.UNDEFINED_PUBLISHER),q=q??B.__metadata,delete B.__metadata;const Y=(0,f.getGalleryExtensionId)(B.publisher,B.name),te=q?.id?{id:Y,uuid:q.id}:{id:Y},ce=q?.isSystem?0:K.type,z=ce===0||!!q?.isBuiltin;B=await this.translateManifest(K.location,B,D.createNlsConfiguration(K));const V={type:ce,identifier:te,manifest:B,location:K.location,isBuiltin:z,targetPlatform:q?.targetPlatform??"undefined",metadata:q,isValid:!0,validations:[]};return K.validate?this.validate(V,K):V}}catch(B){K.type!==0&&this.logService.error(B)}return null}validate(K,q){let B=!0;const Y=(0,i.validateExtensionManifest)(q.productVersion,q.productDate,q.location,K.manifest,K.isBuiltin);for(const[te,ce]of Y)te===y.default.Error&&(B=!1,this.logService.error(this.formatMessage(q.location,ce)));return K.isValid=B,K.validations=Y,K}async scanExtensionManifest(K){const q=(0,S.joinPath)(K,"package.json");let B;try{B=(await this.fileService.readFile(q)).value.toString()}catch(te){return(0,s.toFileOperationResult)(te)!==1&&this.logService.error(this.formatMessage(K,(0,g.localize)(0,null,q.path,te.message))),null}let Y;try{Y=JSON.parse(B)}catch{const ce=[];(0,I.parse)(B,ce);for(const z of ce)this.logService.error(this.formatMessage(K,(0,g.localize)(1,null,q.path,z.offset,z.length,(0,E.getParseErrorMessage)(z.error))));return null}return(0,I.getNodeType)(Y)!=="object"?(this.logService.error(this.formatMessage(K,(0,g.localize)(2,null,q.path))),null):Y}async translateManifest(K,q,B){const Y=await this.getLocalizedMessages(K,q,B);if(Y)try{const te=[],ce=await this.resolveOriginalMessageBundle(Y.default,te);if(te.length>0)return te.forEach(V=>{this.logService.error(this.formatMessage(K,(0,g.localize)(3,null,Y.default?.path,(0,E.getParseErrorMessage)(V.error))))}),q;if((0,I.getNodeType)(Y)!=="object")return this.logService.error(this.formatMessage(K,(0,g.localize)(4,null,Y.default?.path))),q;const z=Y.values||Object.create(null);return(0,_.localizeManifest)(q,z,ce)}catch{}return q}async getLocalizedMessages(K,q,B){const Y=(0,S.joinPath)(K,"package.nls.json"),te=(O,N)=>{N.forEach(W=>{this.logService.error(this.formatMessage(K,(0,g.localize)(5,null,O?.path,(0,E.getParseErrorMessage)(W.error))))})},ce=O=>{this.logService.error(this.formatMessage(K,(0,g.localize)(6,null,O?.path)))},z=`${q.publisher}.${q.name}`,V=B.translations[z];if(V)try{const O=p.URI.file(V),N=(await this.fileService.readFile(O)).value.toString(),W=[],x=(0,I.parse)(N,W);return W.length>0?(te(O,W),{values:void 0,default:Y}):(0,I.getNodeType)(x)!=="object"?(ce(O),{values:void 0,default:Y}):{values:x.contents?x.contents.package:void 0,default:Y}}catch{return{values:void 0,default:Y}}else{if(!await this.fileService.exists(Y))return;let N;try{N=await this.findMessageBundles(K,B)}catch{return}if(!N.localized)return{values:void 0,default:N.original};try{const W=(await this.fileService.readFile(N.localized)).value.toString(),x=[],Z=(0,I.parse)(W,x);return x.length>0?(te(N.localized,x),{values:void 0,default:N.original}):(0,I.getNodeType)(Z)!=="object"?(ce(N.localized),{values:void 0,default:N.original}):{values:Z,default:N.original}}catch{return{values:void 0,default:N.original}}}}async resolveOriginalMessageBundle(K,q){if(K)try{const B=(await this.fileService.readFile(K)).value.toString();return(0,I.parse)(B,q)}catch{}}findMessageBundles(K,q){return new Promise((B,Y)=>{const te=ce=>{const z=(0,S.joinPath)(K,`package.nls.${ce}.json`);this.fileService.exists(z).then(V=>{V&&B({localized:z,original:(0,S.joinPath)(K,"package.nls.json")});const O=ce.lastIndexOf("-");O===-1?B({localized:(0,S.joinPath)(K,"package.nls.json"),original:null}):(ce=ce.substring(0,O),te(ce))})};if(q.devMode||q.pseudo||!q.language)return B({localized:(0,S.joinPath)(K,"package.nls.json"),original:null});te(q.language)})}formatMessage(K,q){return`[${K.path}]: ${q}`}};F=pe([G(1,d.IExtensionsProfileScannerService),G(2,L.IUriIdentityService),G(3,s.IFileService),G(4,r.ILogService)],F);let $=class extends F{constructor(K,q,B,Y,te,ce){super(q,B,Y,te,ce),this.cacheFile=K,this.cacheValidatorThrottler=this._register(new n.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(K){const q=await this.readExtensionCache();if(this.input=K,q&&q.input&&D.equals(q.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),q.result.map(Y=>(Y.location=p.URI.revive(Y.location),Y));const B=await super.scanExtensions(K);return await this.writeExtensionCache({input:K,result:B}),B}async readExtensionCache(){try{const K=await this.fileService.readFile(this.cacheFile),q=JSON.parse(K.value.toString());return{result:q.result,input:(0,u.revive)(q.input)}}catch(K){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(K))}return null}async writeExtensionCache(K){try{await this.fileService.writeFile(this.cacheFile,T.VSBuffer.fromString(JSON.stringify(K)))}catch(q){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(q))}}async validateCache(){if(!this.input)return;const K=await this.readExtensionCache();if(!K)return;const q=K.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(B,q))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(Y){this.logService.error(Y)}}};$=pe([G(2,d.IExtensionsProfileScannerService),G(3,L.IUriIdentityService),G(4,s.IFileService),G(5,r.ILogService)],$);function j(H,K){const q=(0,f.getExtensionId)(H.manifest.publisher,H.manifest.name);return{id:q,identifier:new c.ExtensionIdentifier(q),isBuiltin:H.type===0,isUserBuiltin:H.type===1&&H.isBuiltin,isUnderDevelopment:K,extensionLocation:H.location,uuid:H.identifier.uuid,targetPlatform:H.targetPlatform,...H.manifest}}e.toExtensionDescription=j;class J extends U{constructor(K,q,B,Y,te,ce,z,V,O,N,W){super(K,q,(0,S.joinPath)(B,".vscode-oss-dev","extensions","control.json"),(0,S.joinPath)(Y,c.MANIFEST_CACHE_FOLDER),te,ce,z,V,O,N,W),this.translationsPromise=(async()=>{if(m.translationsConfigFile)try{const x=await this.fileService.readFile(p.URI.file(m.translationsConfigFile));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}getTranslations(K){return this.translationsPromise}}e.NativeExtensionsScannerService=J}),define(ne[248],re([0,1,54,6,38,3,2,20,10,27,8,28]),function(Q,e,R,n,k,T,A,I,E,P,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends A.Disposable{constructor(h,y){super(),this.userDataProfilesService=h,this.logService=y,this.processesLimiter=new n.Limiter(5)}async postUninstall(h){const y=this.parseScript(h,"uninstall");return y&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(y.script,"uninstall",y.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),C=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${C}`)))),P.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,C=>this.logService.error("Error while removing extension storage path",C))}parseScript(h,y){const C=`vscode:${y}`;if(h.location.scheme===I.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[C]=="string"){const p=h.manifest.scripts[C].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${C} should be a node script`),null):{script:(0,E.join)(h.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(h,y,C,p,g){return new Promise((a,f)=>{const c=this.start(h,y,C,g);let i;const s=t=>{i&&(clearTimeout(i),i=null),t?f(t):a(void 0)};c.on("error",t=>{s((0,k.toErrorMessage)(t)||"Unknown")}),c.on("exit",(t,r)=>{s(t?`post-${y} process exited with code ${t}`:void 0)}),p&&(i=setTimeout(()=>{i=null,c.kill(),f("timed out")},5e3))})}start(h,y,C,p){const g={silent:!0,execArgv:void 0},a=(0,R.fork)(h,[`--type=extension-post-${y}`,...C],g);a.stdout.setEncoding("utf8"),a.stderr.setEncoding("utf8");const f=T.Event.fromNodeEventEmitter(a.stdout,"data"),c=T.Event.fromNodeEventEmitter(a.stderr,"data");f(t=>this.logService.info(p.identifier.id,p.manifest.version,`post-${y}`,t)),c(t=>this.logService.error(p.identifier.id,p.manifest.version,`post-${y}`,t));const i=T.Event.any(T.Event.map(f,t=>({data:`%c${t}`,format:[""]})),T.Event.map(c,t=>({data:`%c${t}`,format:["color: red"]})));return T.Event.debounce(i,(t,r)=>t?{data:t.data+r.data,format:[...t.format,...r.format]}:{data:r.data,format:r.format},100)(t=>{console.group(p.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),a}getExtensionStoragePath(h){return(0,E.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};m=pe([G(0,w.IUserDataProfilesService),G(1,b.ILogService)],m),e.ExtensionsLifecycle=m}),define(ne[249],re([0,1,7,15,48,72,13,5,8,25,28]),function(Q,e,R,n,k,T,A,I,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let w=class extends T.NativeExtensionsScannerService{constructor(S,h,y,C,p,g,a){super(R.URI.file(p.builtinExtensionsPath),R.URI.file(p.extensionsPath),p.userHome,R.URI.file(p.userDataPath),S,h,y,C,p,g,a)}};w=pe([G(0,b.IUserDataProfilesService),G(1,k.IExtensionsProfileScannerService),G(2,A.IFileService),G(3,E.ILogService),G(4,n.INativeEnvironmentService),G(5,P.IProductService),G(6,I.IInstantiationService)],w),e.ExtensionsScannerService=w}),define(ne[23],re([0,1,6,3,2,191,14,87,5,28]),function(Q,e,R,n,k,T,A,I,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const b="__$__targetStorageMarker";e.IStorageService=(0,E.createDecorator)("storageService");var w;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var m;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(m=e.StorageScope||(e.StorageScope={}));var S;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(S=e.StorageTarget||(e.StorageTarget={}));class h extends k.Disposable{constructor(a={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super(),this.options=a,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(a,f){if(f===b){switch(a){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:a})}else this._onDidChangeValue.fire({scope:a,key:f,target:this.getKeyTargets(a)[f]})}emitWillSaveState(a){this._onWillSaveState.fire({reason:a})}get(a,f,c){return this.getStorage(f)?.get(a,c)}getBoolean(a,f,c){return this.getStorage(f)?.getBoolean(a,c)}getNumber(a,f,c){return this.getStorage(f)?.getNumber(a,c)}store(a,f,c,i){if((0,A.isUndefinedOrNull)(f)){this.remove(a,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(a,c,i),this.getStorage(c)?.set(a,f)})}remove(a,f){this.withPausedEmitters(()=>{this.updateKeyTarget(a,f,void 0),this.getStorage(f)?.delete(a)})}withPausedEmitters(a){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{a()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(a,f){const c=[],i=this.getKeyTargets(a);for(const s of Object.keys(i))i[s]===f&&c.push(s);return c}updateKeyTarget(a,f,c){const i=this.getKeyTargets(f);typeof c=="number"?i[a]!==c&&(i[a]=c,this.getStorage(f)?.set(b,JSON.stringify(i))):typeof i[a]=="number"&&(delete i[a],this.getStorage(f)?.set(b,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(a){switch(a){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(a){const f=this.get(b,a);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}isNew(a){return this.getBoolean(e.IS_NEW_KEY,a)===!0}async flush(a=w.NONE){this._onWillSaveState.fire({reason:a});const f=this.getStorage(-1),c=this.getStorage(0),i=this.getStorage(1);switch(a){case w.NONE:await R.Promises.settled([f?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await R.Promises.settled([f?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const a=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,c=this.getStorage(1)?.items??new Map;return p(a,f,c,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(a,f){return this.emitWillSaveState(w.NONE),(0,P.isUserDataProfile)(a)?this.switchToProfile(a,f):this.switchToWorkspace(a,f)}canSwitchProfile(a,f){return!(a.id===f.id||y(f)&&y(a))}switchData(a,f,c,i){this.withPausedEmitters(()=>{if(i)for(const[s,t]of a)f.set(s,t);else{const s=new Set;for(const[t,r]of a)s.add(t),f.get(t)!==r&&this.emitDidChangeValue(c,t);for(const[t]of f.items)s.has(t)||this.emitDidChangeValue(c,t)}})}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;function y(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=y;class C extends h{constructor(){super(),this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(a=>this.emitDidChangeValue(1,a))),this._register(this.profileStorage.onDidChangeStorage(a=>this.emitDidChangeValue(0,a))),this._register(this.applicationStorage.onDidChangeStorage(a=>this.emitDidChangeValue(-1,a)))}getStorage(a){switch(a){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(a){switch(a){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=C;async function p(g,a,f,c,i,s){const t=M=>{try{return JSON.parse(M)}catch{return M}},r=new Map,o=new Map;g.forEach((M,U)=>{r.set(U,M),o.set(U,t(M))});const l=new Map,u=new Map;a.forEach((M,U)=>{l.set(U,M),u.set(U,t(M))});const d=new Map,v=new Map;f.forEach((M,U)=>{d.set(U,M),v.set(U,t(M))}),console.group(c!==i?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const L=[];if(r.forEach((M,U)=>{L.push({key:U,value:M})}),console.table(L),console.groupEnd(),console.log(o),c!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const M=[];l.forEach((U,D)=>{M.push({key:D,value:U})}),console.table(M),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${s})`);const _=[];d.forEach((M,U)=>{_.push({key:U,value:M})}),console.table(_),console.groupEnd(),console.log(v)}e.logStorage=p}),define(ne[250],re([0,1,3,2,14,29,32,23]),function(Q,e,R,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let E=class extends n.Disposable{constructor(w,m){super(),this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new P(w)),this._register(this.storageManger.onDidChange(S=>this._onDidChangeEnablement.fire({extensions:S,source:"storage"}))),this._register(m.onDidInstallExtensions(S=>S.forEach(({local:h,operation:y})=>{h&&y===4&&this._removeFromDisabledExtensions(h.identifier)})))}async enableExtension(w,m){return this._removeFromDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:m}),!0):!1}async disableExtension(w,m){return this._addToDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(w){const m=this.getDisabledExtensions();return m.every(S=>!(0,A.areSameExtensions)(S,w))?(m.push(w),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(w){const m=this.getDisabledExtensions();for(let S=0;S<m.length;S++){const h=m[S];if((0,A.areSameExtensions)(h,w))return m.splice(S,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(w){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,w)}_getExtensions(w){return this.storageManger.get(w,0)}_setExtensions(w,m){this.storageManger.set(w,m,0)}};E=pe([G(0,I.IStorageService),G(1,T.IExtensionManagementService)],E),e.GlobalExtensionEnablementService=E;class P extends n.Disposable{constructor(w){super(),this.storageService=w,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(w.onDidChangeValue(m=>this.onDidStorageChange(m)))}get(w,m){let S;return m===0?((0,k.isUndefinedOrNull)(this.storage[w])&&(this.storage[w]=this._get(w,m)),S=this.storage[w]):S=this._get(w,m),JSON.parse(S)}set(w,m,S){const h=JSON.stringify(m.map(({id:C,uuid:p})=>({id:C,uuid:p})));this._get(w,S)!==h&&(S===0&&(m.length?this.storage[w]=h:delete this.storage[w]),this._set(w,m.length?h:void 0,S))}onDidStorageChange(w){if(w.scope===0&&!(0,k.isUndefinedOrNull)(this.storage[w.key])&&this._get(w.key,w.scope)!==this.storage[w.key]){const S=this.get(w.key,w.scope);delete this.storage[w.key];const h=this.get(w.key,w.scope),y=S.filter(p=>!h.some(g=>(0,A.areSameExtensions)(p,g))),C=h.filter(p=>!S.some(g=>(0,A.areSameExtensions)(g,p)));(y.length||C.length)&&this._onDidChange.fire([...y,...C])}}_get(w,m){return this.storageService.get(w,m,"[]")}_set(w,m,S){m?this.storageService.store(w,m,S,1):this.storageService.remove(w,S)}}e.StorageManager=P}),define(ne[251],re([0,1,18,21,9,4,36,14,7,19,15,29,32,66,13,8,25,44,219,23,22]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C,p,g,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const c=T.isWeb?"web":(0,w.getTargetPlatform)(T.platform,A.arch);var i;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function s(...O){return String(O.reduce((N,W)=>N|W,0))}var t;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},u={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class d{constructor(N=u){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,W=this.state.pageSize){return new d({...this.state,pageNumber:N,pageSize:W})}withFilter(N,...W){const x=[...this.state.criteria,...W.length?W.map(Z=>({filterType:N,value:Z})):[{filterType:N}]];return new d({...this.state,criteria:x})}withSortBy(N){return new d({...this.state,sortBy:N})}withSortOrder(N){return new d({...this.state,sortOrder:N})}withFlags(...N){return new d({...this.state,flags:N.reduce((W,x)=>W|x,0)})}withAssetTypes(...N){return new d({...this.state,assetTypes:N})}withSource(N){return new d({...this.state,source:N})}get raw(){const{criteria:N,pageNumber:W,pageSize:x,sortBy:Z,sortOrder:oe,flags:X,assetTypes:ie}=this.state;return{filters:[{criteria:N,pageNumber:W,pageSize:x,sortBy:Z,sortOrder:oe}],assetTypes:ie,flags:X}}get searchText(){const N=this.state.criteria.filter(W=>W.filterType===t.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function v(O,N){const W=(O||[]).filter(x=>x.statisticName===N)[0];return W?W.value:0}function L(O){const N="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(x=>x.assetType.indexOf(N)===0).reduce((x,Z)=>{const oe=U(O,Z.assetType);return oe&&x.push([Z.assetType.substring(N.length),oe]),x},[])}function _(O){if(O.properties){const N=O.properties.filter(Z=>Z.key===r.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),x=N.filter(Z=>W.test(Z.value))[0];return x?{uri:x.value,fallbackUri:x.value}:null}return U(O,r.Repository)}function M(O){return{uri:`${O.fallbackAssetUri}/${r.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${r.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function U(O,N){return O.files.filter(x=>x.assetType===N)[0]?{uri:`${O.assetUri}/${N}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${N}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function D(O,N){const W=O.properties?O.properties.filter(Z=>Z.key===N):[],x=W.length>0&&W[0].value;return x?x.split(",").map(Z=>(0,m.adoptToGalleryExtensionId)(Z)):[]}function F(O){const N=O.properties?O.properties.filter(W=>W.key===o.Engine):[];return N.length>0&&N[0].value||""}function $(O){const N=O.properties?O.properties.filter(W=>W.key===o.PreRelease):[];return N.length>0&&N[0].value==="true"}function j(O){const N=O.properties?O.properties.filter(x=>x.key===o.LocalizedLanguages):[],W=N.length>0&&N[0].value||"";return W?W.split(","):[]}function J(O){return O.properties?.find(N=>N.key===o.SponsorLink)?.value}function H(O){return O.indexOf("preview")!==-1}function K(O){return O.targetPlatform?(0,w.toTargetPlatform)(O.targetPlatform):"undefined"}function q(O){const N=(0,R.distinct)(O.versions.map(K)),W=!!O.tags?.includes(w.WEB_EXTENSION_TAG),x=N.indexOf("web");return W?x===-1&&N.push("web"):x!==-1&&N.splice(x,1),N}function B(O,N){const W=(0,w.getFallbackTargetPlarforms)(N);for(let x=0;x<O.length;x++){const Z=O[x];if(Z.version===O[x-1]?.version){let oe=x;const X=K(Z);if(X===N)for(;oe>0&&O[oe-1].version===Z.version;)oe--;else if(W.includes(X))for(;oe>0&&O[oe-1].version===Z.version&&K(O[oe-1])!==N;)oe--;oe!==x&&(O.splice(x,1),O.splice(oe,0,Z))}}return O}e.sortExtensionVersions=B;function Y(O,N,W){O.telemetryData={index:N,querySource:W}}function te(O,N,W){const x=O.versions[0],Z={manifest:U(N,r.Manifest),readme:U(N,r.Details),changelog:U(N,r.Changelog),license:U(N,r.License),repository:_(N),download:M(N),icon:U(N,r.Icon),coreTranslations:L(N)};return{identifier:{id:(0,m.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:N.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:J(x),description:O.shortDescription||"",installCount:v(O.statistics,"install"),rating:v(O.statistics,"averagerating"),ratingCount:v(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:W,assets:Z,properties:{dependencies:D(N,o.Dependency),extensionPack:D(N,o.ExtensionPack),engine:F(N),localizedLanguages:j(N),targetPlatform:K(N),isPreReleaseVersion:$(N)},hasPreReleaseVersion:$(x),hasReleaseVersion:!0,preview:H(O.flags)}}let ce=class{constructor(N,W,x,Z,oe,X,ie,se){this.requestService=W,this.logService=x,this.environmentService=Z,this.telemetryService=oe,this.fileService=X,this.productService=ie,this.configurationService=se;const ue=ie.extensionsGallery;this.extensionsGalleryUrl=ue&&ue.serviceUrl,this.extensionsControlUrl=ue&&ue.controlUrl,this.commonHeadersPromise=(0,g.resolveMarketplaceHeaders)(ie.version,ie,this.environmentService,this.configurationService,this.fileService,N,this.telemetryService)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,W,x){const Z=n.CancellationToken.isCancellationToken(W)?{}:W,oe=n.CancellationToken.isCancellationToken(W)?W:x,X=[],ie=[],se=[],ue=[];let he=!0;for(const Ee of N){Ee.uuid?ie.push(Ee.uuid):X.push(Ee.id);const Pe=!!(Ee.version||Ee.preRelease);se.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Pe}),Ee.version&&ue.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),he=he&&!!Ee.hasPreRelease&&!Pe}if(!ie.length&&!X.length)return[];let ve=new d().withPage(1,N.length);ie.length&&(ve=ve.withFilter(t.ExtensionId,...ie)),X.length&&(ve=ve.withFilter(t.ExtensionName,...X)),(Z.queryAllVersions||he)&&(ve=ve.withFlags(ve.flags,i.IncludeVersions)),Z.source&&(ve=ve.withSource(Z.source));const{extensions:we}=await this.queryGalleryExtensions(ve,{targetPlatform:Z.targetPlatform??c,includePreRelease:se,versions:ue,compatible:!!Z.compatible},oe);return Z.source&&we.forEach((Ee,Pe)=>Y(Ee,Pe,Z.source)),we}async getCompatibleExtension(N,W,x){if((0,w.isNotWebExtensionInWebTargetPlatform)(N.allTargetPlatforms,x))return null;if(await this.isExtensionCompatible(N,W,x))return N;const Z=new d().withFlags(i.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,N.identifier.uuid),{extensions:oe}=await this.queryGalleryExtensions(Z,{targetPlatform:x,compatible:!0,includePreRelease:W},n.CancellationToken.None);return oe[0]||null}async isExtensionCompatible(N,W,x){if(!(0,w.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,x)||!W&&N.properties.isPreReleaseVersion)return!1;let Z=N.properties.engine;if(!Z){const oe=await this.getManifest(N,n.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");Z=oe.engines.vscode}return(0,S.isEngineValid)(Z,this.productService.version,this.productService.date)}async isValidVersion(N,W,x,Z,oe){if(!(0,w.isTargetPlatformCompatible)(K(N),Z,oe)||W!=="any"&&$(N)!==(W==="prerelease"))return!1;if(x)try{const X=await this.getEngine(N);if(!(0,S.isEngineValid)(X,this.productService.version,this.productService.date))return!1}catch(X){return this.logService.error(`Error while getting the engine for the version ${N.version}.`,(0,k.getErrorMessage)(X)),!1}return!0}async query(N,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let x=N.text||"";const Z=N.pageSize??50;let oe=new d().withPage(1,Z);x?(x=x.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,ve,we)=>(oe=oe.withFilter(t.Category,we||ve),"")),x=x.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,ve,we)=>(oe=oe.withFilter(t.Tag,we||ve),"")),x=x.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(t.Featured),"")),x=x.trim(),x&&(x=x.length<200?x:x.substring(0,200),oe=oe.withFilter(t.SearchText,x)),oe=oe.withSortBy(0)):N.ids?oe=oe.withFilter(t.ExtensionId,...N.ids):N.names?oe=oe.withFilter(t.ExtensionName,...N.names):oe=oe.withSortBy(4),typeof N.sortBy=="number"&&(oe=oe.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(oe=oe.withSortOrder(N.sortOrder)),N.source&&(oe=oe.withSource(N.source));const X=async(he,ve)=>{const{extensions:we,total:Ee}=await this.queryGalleryExtensions(he,{targetPlatform:c,compatible:!1,includePreRelease:!!N.includePreRelease},ve);return we.forEach((Pe,Ue)=>Y(Pe,(he.pageNumber-1)*he.pageSize+Ue,N.source)),{extensions:we,total:Ee}},{extensions:ie,total:se}=await X(oe,W),ue=async(he,ve)=>{if(ve.isCancellationRequested)throw new k.CancellationError;const{extensions:we}=await X(oe.withPage(he+1),ve);return we};return{firstPage:ie,total:se,pageSize:oe.pageSize,getPage:ue}}async queryGalleryExtensions(N,W,x){const Z=N.flags;!!(N.flags&i.IncludeLatestVersionOnly)&&!!(N.flags&i.IncludeVersions)&&(N=N.withFlags(N.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(N.flags&i.IncludeLatestVersionOnly)&&!(N.flags&i.IncludeVersions)&&(N=N.withFlags(N.flags,i.IncludeLatestVersionOnly)),W.versions?.length&&(N=N.withFlags(N.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),N=N.withFlags(N.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:oe,total:X}=await this.queryRawGalleryExtensions(N,x);if(!(N.flags&i.IncludeLatestVersionOnly)){const he=[];for(const ve of oe){const we=await this.toGalleryExtensionWithCriteria(ve,W);we&&he.push(we)}return{extensions:he,total:X}}const se=[],ue=new Map;for(let he=0;he<oe.length;he++){const ve=oe[he],we={id:(0,m.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),uuid:ve.extensionId},Ee=(0,I.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(Ue=>(0,m.areSameExtensions)(Ue,we))?.includePreRelease;if(W.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(q(ve),W.targetPlatform))continue;const Pe=await this.toGalleryExtensionWithCriteria(ve,W);!Pe||Pe.properties.isPreReleaseVersion&&(!Ee||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==W.targetPlatform&&Pe.hasPreReleaseVersion?ue.set(ve.extensionId,he):se.push([he,Pe])}if(ue.size){const he=new Date().getTime(),ve=new d().withFlags(Z&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ue.size).withFilter(t.ExtensionId,...ue.keys()),{extensions:we}=await this.queryGalleryExtensions(ve,W,x);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-he,count:ue.size});for(const Ee of we){const Pe=ue.get(Ee.identifier.uuid);se.push([Pe,Ee])}}return{extensions:se.sort((he,ve)=>he[0]-ve[0]).map(([,he])=>he),total:X}}async toGalleryExtensionWithCriteria(N,W){const x={id:(0,m.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},Z=W.versions?.find(se=>(0,m.areSameExtensions)(se,x))?.version,oe=(0,I.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(se=>(0,m.areSameExtensions)(se,x))?.includePreRelease,X=q(N),ie=B(N.versions,W.targetPlatform);if(W.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(X,W.targetPlatform))return null;for(let se=0;se<ie.length;se++){const ue=ie[se];if(!(Z&&ue.version!==Z)){if(await this.isValidVersion(ue,oe?"any":"release",W.compatible,X,W.targetPlatform))return te(N,ue,X);if(Z&&ue.version===Z)return null}}return Z||W.compatible?null:te(N,N.versions[0],X)}async queryRawGalleryExtensions(N,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,i.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(i.Unpublished));const x=await this.commonHeadersPromise,Z=JSON.stringify(N.raw),oe={...x,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},X=new Date().getTime();let ie,se,ue=0;try{if(ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Z,headers:oe},W),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:ue};const he=await(0,p.asJson)(ie);if(he){const ve=he.results[0],we=ve.extensions,Ee=ve.resultMetadata&&ve.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return ue=Ee&&Ee.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:ue}}return{galleryExtensions:[],total:ue}}catch(he){throw se=he,he}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(Z.length),duration:new Date().getTime()-X,success:!!ie&&(0,p.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:se?(0,k.isCancellationError)(se)?"canceled":(0,k.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(N,W,x,Z){if(!this.isEnabled())return;const oe=T.isWeb?this.api(`/itemName/${N}.${W}/version/${x}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${W}/${x}/stats?statType=${Z}`),X=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.commonHeadersPromise,Accept:X};try{await this.requestService.request({type:"POST",url:oe,headers:se},n.CancellationToken.None)}catch{}}async download(N,W,x){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const Z=(0,m.getGalleryExtensionTelemetryData)(N),oe=new Date().getTime(),X=he=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Z,duration:he}),ie=x===2?"install":x===3?"update":"",se=ie?{uri:`${N.assets.download.uri}${E.URI.parse(N.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${N.assets.download.fallbackUri}${E.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:N.assets.download,ue=await this.getAsset(se);await this.fileService.writeFile(W,ue.stream),X(new Date().getTime()-oe)}async getReadme(N,W){if(N.assets.readme){const x=await this.getAsset(N.assets.readme,{},W);return await(0,p.asTextOrError)(x)||""}return""}async getManifest(N,W){if(N.assets.manifest){const x=await this.getAsset(N.assets.manifest,{},W),Z=await(0,p.asTextOrError)(x);return Z?JSON.parse(Z):null}return null}async getManifestFromRawExtensionVersion(N,W){const x=U(N,r.Manifest);if(!x)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},oe=await this.getAsset(x,{headers:Z});return await(0,p.asJson)(oe)}async getCoreTranslation(N,W){const x=N.assets.coreTranslations.filter(Z=>Z[0]===W.toUpperCase())[0];if(x){const Z=await this.getAsset(x[1]),oe=await(0,p.asTextOrError)(Z);return oe?JSON.parse(oe):null}return null}async getChangelog(N,W){if(N.assets.changelog){const x=await this.getAsset(N.assets.changelog,{},W);return await(0,p.asTextOrError)(x)||""}return""}async getAllCompatibleVersions(N,W,x){let Z=new d().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?Z=Z.withFilter(t.ExtensionId,N.identifier.uuid):Z=Z.withFilter(t.ExtensionName,N.identifier.id);const{galleryExtensions:oe}=await this.queryRawGalleryExtensions(Z,n.CancellationToken.None);if(!oe.length)return[];const X=q(oe[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(X,x))return[];const ie=[];await Promise.all(oe[0].versions.map(async he=>{try{await this.isValidVersion(he,W?"any":"release",!0,X,x)&&ie.push(he)}catch{}}));const se=[],ue=new Set;for(const he of B(ie,x))ue.has(he.version)||(ue.add(he.version),se.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:$(he)}));return se}async getAsset(N,W={},x=n.CancellationToken.None){const Z=await this.commonHeadersPromise,oe={type:"GET"},X={...Z,...W.headers||{}};W={...W,...oe,headers:X};const ie=N.uri,se=N.fallbackUri,ue={...W,url:ie};try{const he=await this.requestService.request(ue,x);if(he.res.statusCode===200)return he;const ve=await(0,p.asTextOrError)(he);throw new Error(`Expected 200, got back ${he.res.statusCode} instead.

${ve}`)}catch(he){if((0,k.isCancellationError)(he))throw he;const ve=(0,k.getErrorMessage)(he);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:ve});const we={...W,url:se};return this.requestService.request(we,x)}}async getEngine(N){let W=F(N);if(!W){const x=await this.getManifestFromRawExtensionVersion(N,n.CancellationToken.None);if(!x)throw new Error("Manifest was not found");W=x.engines.vscode}return W}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,p.asJson)(N),x=[],Z={};if(W){for(const oe of W.malicious)x.push({id:oe});if(W.migrateToPreRelease)for(const[oe,X]of Object.entries(W.migrateToPreRelease))(!X.engine||(0,S.isEngineValid)(X.engine,this.productService.version,this.productService.date))&&(Z[oe.toLowerCase()]={disallowInstall:!0,extension:{id:X.id,displayName:X.displayName,autoMigrate:{storage:!!X.migrateStorage},preRelease:!0}});if(W.deprecated)for(const[oe,X]of Object.entries(W.deprecated))X&&(Z[oe.toLowerCase()]=(0,I.isBoolean)(X)?{}:X)}return{malicious:x,deprecated:Z}}};ce=pe([G(1,p.IRequestService),G(2,y.ILogService),G(3,b.IEnvironmentService),G(4,f.ITelemetryService),G(5,h.IFileService),G(6,C.IProductService),G(7,P.IConfigurationService)],ce);let z=class extends ce{constructor(N,W,x,Z,oe,X,ie,se){super(N,W,x,Z,oe,X,ie,se)}};z=pe([G(0,a.IStorageService),G(1,p.IRequestService),G(2,y.ILogService),G(3,b.IEnvironmentService),G(4,f.ITelemetryService),G(5,h.IFileService),G(6,C.IProductService),G(7,P.IConfigurationService)],z),e.ExtensionGalleryService=z;let V=class extends ce{constructor(N,W,x,Z,oe,X,ie){super(void 0,N,W,x,Z,oe,X,ie)}};V=pe([G(0,p.IRequestService),G(1,y.ILogService),G(2,b.IEnvironmentService),G(3,f.ITelemetryService),G(4,h.IFileService),G(5,C.IProductService),G(6,P.IConfigurationService)],V),e.ExtensionGalleryServiceWithNoStorageService=V}),define(ne[73],re([0,1,5,3,2,23,32,25,18,8,14]),function(Q,e,R,n,k,T,A,I,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,R.createDecorator)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let m=class Qe extends k.Disposable{constructor(h,y,C){super(),this.storageService=h,this.productService=y,this.logService=C,this._onDidChangeExtensionStorageToSync=this._register(new n.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Qe.readAllExtensionsWithKeysForSync(h),this._register(this.storageService.onDidChangeValue(p=>this.onDidChangeStorageValue(p)))}static toKey(h){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static fromKey(h){const y=w.exec(h);if(y&&y[1])return{id:y[1],version:y[2]}}static async removeOutdatedExtensionVersions(h,y){const C=await h.getInstalled(),p=[];for(const[g,a]of Qe.readAllExtensionsWithKeysForSync(y)){const f=C.find(c=>(0,A.areSameExtensions)(c.identifier,{id:g}))?.manifest.version;for(const c of a)f!==c&&p.push(Qe.toKey({id:g,version:c}))}for(const g of p)y.remove(g,0)}static readAllExtensionsWithKeysForSync(h){const y=new Map,C=h.keys(0,1);for(const p of C){const g=Qe.fromKey(p);if(g){let a=y.get(g.id.toLowerCase());a||y.set(g.id.toLowerCase(),a=[]),a.push(g.version)}}return y}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const y=Qe.fromKey(h.key);if(y){if(this.storageService.get(h.key,0)===void 0)this.extensionsWithKeysForSync.delete(y.id.toLowerCase());else{let C=this.extensionsWithKeysForSync.get(y.id.toLowerCase());C||this.extensionsWithKeysForSync.set(y.id.toLowerCase(),C=[]),C.push(y.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(h){if((0,b.isString)(h))return h;const y=h.manifest?h.manifest.publisher:h.publisher,C=h.manifest?h.manifest.name:h.name;return(0,A.getExtensionId)(y,C)}getExtensionState(h,y){const C=this.getExtensionId(h),p=this.storageService.get(C,y?0:1);if(p)try{return JSON.parse(p)}catch(g){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${C}, global: ${y}): ${g}`)}}setExtensionState(h,y,C){const p=this.getExtensionId(h);y===void 0?this.storageService.remove(p,C?0:1):this.storageService.store(p,JSON.stringify(y),C?0:1,1)}setKeysForSync(h,y){this.storageService.store(Qe.toKey(h),JSON.stringify(y),0,1)}getKeysForSync(h){const y=this.productService.extensionSyncedKeys?.[h.id.toLowerCase()],C=this.storageService.get(Qe.toKey(h),0),p=C?JSON.parse(C):void 0;return p&&y?(0,E.distinct)([...p,...y]):p||y}addToMigrationList(h,y){if(h!==y){const C=this.migrationList.filter(p=>!p.includes(h)&&!p.includes(y));C.push([h,y]),this.migrationList=C}}getSourceExtensionToMigrate(h){const y=this.migrationList.find(([,C])=>h===C);return y?y[0]:void 0}get migrationList(){const h=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const y=JSON.parse(h);if(Array.isArray(y))return y}catch{}return[]}set migrationList(h){h.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(h),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};m=pe([G(0,T.IStorageService),G(1,I.IProductService),G(2,P.ILogService)],m),e.ExtensionStorageService=m}),define(ne[252],re([0,1,18,6,3,10,4,36,7,146,15,29,32,210,92,13,8,58,25,44,23,22]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C,p,g,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const i="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let t=class extends S.ExtensionTipsService{constructor(o,l,u,d,v,L,_,M,U,D){super(_,M,U,D),this.environmentService=o,this.telemetryService=l,this.extensionManagementService=u,this.storageService=d,this.nativeHostService=v,this.extensionRecommendationNotificationService=L,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,M.exeBasedExtensionTips&&Object.entries(M.exeBasedExtensionTips).forEach(([F,$])=>{const j=[],J=[],H=[];Object.entries($.recommendations).forEach(([K,q])=>{q.important?$.important?j.push({extensionId:K,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):J.push({extensionId:K,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):H.push({extensionId:K,extensionName:q.name,isExtensionPack:!!q.isExtensionPack})}),j.length&&this.highImportanceExecutableTips.set(F,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:j}),J.length&&this.mediumImportanceExecutableTips.set(F,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:J}),H.length&&this.allOtherExecutableTips.set(F,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:H})}),(0,n.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,u)}groupImportantTipsByExe(o,l){const u=new Map;o.forEach(M=>u.set(M.extensionId.toLowerCase(),M));const{installed:d,uninstalled:v}=this.groupByInstalled([...u.keys()],l);for(const M of d){const U=u.get(M);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:M,exeName:U.exeName})}for(const M of v){const U=u.get(M);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:M,exeName:U.exeName})}const L=this.getPromptedExecutableTips(),_=new Map;for(const M of v){const U=u.get(M);if(U&&(!L[U.exeName]||!L[U.exeName].includes(U.extensionId))){let D=_.get(U.exeName);D||(D=[],_.set(U.exeName,D)),D.push(U)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":{const d=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const d=this._register((0,n.disposableTimeout)(()=>{d.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),l=Date.now()-o,u=7*24*60*60*1e3;if(l<u){const L=this._register((0,n.disposableTimeout)(()=>{L.dispose(),this.promptMediumImportanceExeBasedTip()},u-l));return}const[d,v]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(v).then(L=>{switch(L){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(v[0].exeName,v);const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},u));break}case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const _=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(o){const l=await this.extensionManagementService.getInstalled(1),u=o.filter(v=>!v.whenNotInstalled||v.whenNotInstalled.every(L=>l.every(_=>!(0,m.areSameExtensions)(_.identifier,{id:L})))).map(({extensionId:v})=>v.toLowerCase()),d=(0,P.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(u,d,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(s,-1);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(s,o,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(i,-1,"{}"))}addToRecommendedExecutables(o,l){const u=this.getPromptedExecutableTips();u[o]=l.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(i,JSON.stringify(u),-1,0)}groupByInstalled(o,l){const u=[],d=[],v=l.reduce((L,_)=>(L.add(_.identifier.id.toLowerCase()),L),new Set);return o.forEach(L=>{v.has(L.toLowerCase())?u.push(L):d.push(L)}),{installed:u,uninstalled:d}}async getValidExecutableBasedExtensionTips(o){const l=[],u=new Map;for(const d of o.keys()){const v=o.get(d);if(!v||!(0,R.isNonEmptyArray)(v.recommendations))continue;const L=[];A.isWindows?v.windowsPath&&L.push(v.windowsPath.replace("%USERPROFILE%",I.env.USERPROFILE).replace("%ProgramFiles(x86)%",I.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",I.env.ProgramFiles).replace("%APPDATA%",I.env.APPDATA).replace("%WINDIR%",I.env.WINDIR)):(L.push((0,T.join)("/usr/local/bin",d)),L.push((0,T.join)("/usr/bin",d)),L.push((0,T.join)(this.environmentService.userHome.fsPath,d)));for(const _ of L){let M=u.get(_);if(M===void 0&&(M=await this.fileService.exists(E.URI.file(_)),u.set(_,M)),M)for(const{extensionId:U,extensionName:D,isExtensionPack:F,whenNotInstalled:$}of v.recommendations)l.push({extensionId:U,extensionName:D,isExtensionPack:F,exeName:d,exeFriendlyName:v.exeFriendlyName,windowsPath:v.windowsPath,whenNotInstalled:$})}}return l}};t=pe([G(0,b.INativeEnvironmentService),G(1,c.ITelemetryService),G(2,w.IExtensionManagementService),G(3,f.IStorageService),G(4,p.INativeHostService),G(5,h.IExtensionRecommendationNotificationService),G(6,y.IFileService),G(7,g.IProductService),G(8,a.IRequestService),G(9,C.ILogService)],t),e.ExtensionTipsService=t}),define(ne[253],re([0,1,6,2,17,87,23,102]),function(Q,e,R,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class E extends A.AbstractStorageService{constructor(b,w,m,S){super(),this.initialWorkspace=b,this.initialProfiles=w,this.mainProcessService=m,this.environmentService=S,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new n.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new n.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const b=this._register(new I.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),w=this._register(new T.Storage(b));return this._register(w.onDidChangeStorage(m=>this.emitDidChangeValue(-1,m))),w}createProfileStorage(b){this.profileStorageDisposables.clear(),this.profileStorageProfile=b;let w;if((0,A.isProfileUsingDefaultStorage)(b))w=this.applicationStorage;else{const m=this.profileStorageDisposables.add(new I.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),b));w=this.profileStorageDisposables.add(new T.Storage(m))}return this.profileStorageDisposables.add(w.onDidChangeStorage(m=>this.emitDidChangeValue(0,m))),w}createWorkspaceStorage(b){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=b?.id;let w;if(b){const m=this.workspaceStorageDisposables.add(new I.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),b));w=this.workspaceStorageDisposables.add(new T.Storage(m)),this.workspaceStorageDisposables.add(w.onDidChangeStorage(S=>this.emitDidChangeValue(1,S)))}return w}async doInitialize(){await R.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(b){switch(b){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(b){switch(b){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,k.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(b,w){if(!this.canSwitchProfile(this.profileStorageProfile,b))return;const m=this.profileStorage,S=m.items;m!==this.applicationStorage&&await m.close(),this.profileStorage=this.createProfileStorage(b),await this.profileStorage.init(),this.switchData(S,this.profileStorage,0,w)}async switchToWorkspace(b,w){const m=this.workspaceStorage,S=m?.items??new Map;await m?.close(),this.workspaceStorage=this.createWorkspaceStorage(b),await this.workspaceStorage.init(),this.switchData(S,this.workspaceStorage,1,w)}}e.NativeStorageService=E}),define(ne[254],re([0,1,3,2,17,15,67,28]),function(Q,e,R,n,k,T,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let E=class extends n.Disposable{constructor(b,w,m){super(),this._profiles=[],this._onDidChangeProfiles=this._register(new R.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.channel=w.getChannel("userDataProfiles"),this.profilesHome=(0,k.joinPath)(m.userRoamingDataHome,"profiles"),this._profiles=b.map(S=>(0,I.reviveProfile)(S,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(S=>{const h=S.added.map(p=>(0,I.reviveProfile)(p,this.profilesHome.scheme)),y=S.removed.map(p=>(0,I.reviveProfile)(p,this.profilesHome.scheme)),C=S.updated.map(p=>(0,I.reviveProfile)(p,this.profilesHome.scheme));this._profiles=S.all.map(p=>(0,I.reviveProfile)(p,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:h,removed:y,updated:C,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}async createProfile(b,w,m){const S=await this.channel.call("createProfile",[b,w,m]);return(0,I.reviveProfile)(S,this.profilesHome.scheme)}async createTransientProfile(b){const w=await this.channel.call("createTransientProfile",[b]);return(0,I.reviveProfile)(w,this.profilesHome.scheme)}async setProfileForWorkspace(b,w){await this.channel.call("setProfileForWorkspace",[b,w])}removeProfile(b){return this.channel.call("removeProfile",[b])}async updateProfile(b,w,m){const S=await this.channel.call("updateProfile",[b,w,m]);return(0,I.reviveProfile)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}};E=pe([G(1,A.IMainProcessService),G(2,T.IEnvironmentService)],E),e.UserDataProfilesNativeService=E}),define(ne[45],re([0,1,18,6,16,21,3,35,2,24,14,7,161,19,15,13,8,47,23,22,33,26,28]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C,p,g,a,f,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function s(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=s;let t=class extends E.Disposable{constructor(d,v,L,_,M,U,D,F,$,j,J){super(),this.resource=d,this.fileService=v,this.environmentService=L,this.userDataSyncStoreService=M,this.userDataSyncBackupStoreService=U,this.userDataSyncEnablementService=D,this.telemetryService=F,this.logService=$,this.configurationService=j,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new n.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,P.uppercaseFirstLetter)(this.resource),this.extUri=J.extUri,this.syncFolder=this.extUri.joinPath(L.userDataSyncHome,d),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,c.PREVIEW_DIR_NAME),this.lastSyncResource=(0,c.getLastSyncResourceUri)(d,L,this.extUri),this.currentMachineIdPromise=(0,p.getServiceMachineId)(L,v,_)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const d=await this.syncPreviewPromise;this.syncPreviewPromise=null;const v=await this.performSync(d.remoteUserData,d.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(v)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const d=await this.getLastSyncUserData();(d?await this.hasRemoteChanged(d):!0)&&this._onDidChangeLocal.fire()}}setStatus(d){this._status!==d&&(this._status=d,this._onDidChangStatus.fire(d))}async sync(d,v={}){await this._sync(d,!0,this.getUserDataSyncConfiguration(),v)}async preview(d,v,L={}){return this._sync(d,!1,v,L)}async apply(d,v={}){try{this.syncHeaders={...v};const L=await this.doApply(d);return this.setStatus(L),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(d,v,L,_){try{if(this.syncHeaders={..._},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let M="idle";try{const U=await this.getLastSyncUserData(),D=await this.getLatestRemoteUserData(d,U);return M=await this.performSync(D,U,v,L),M==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):M==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(M)}}finally{this.syncHeaders={}}}async replace(d){const v=await this.resolveContent(d);if(!v)return!1;const L=this.parseSyncData(v);if(!L)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const _=await this.getLastSyncUserData(),M=await this.getLatestRemoteUserData(null,_),U=await this.isRemoteDataFromCurrentMachine(M),D=await this.generateSyncPreview({ref:M.ref,syncData:L},_,U,this.getUserDataSyncConfiguration(),T.CancellationToken.None),F=[];for(const $ of D){const j=await this.getAcceptResult($,$.remoteResource,void 0,T.CancellationToken.None),{remoteChange:J}=await this.getAcceptResult($,$.previewResource,$.remoteContent,T.CancellationToken.None);F.push([$,{...j,remoteChange:J!==0?J:2}])}await this.applyResult(M,_,F,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(d){const v=await this.currentMachineIdPromise;return!!d.syncData?.machineId&&d.syncData.machineId===v}async getLatestRemoteUserData(d,v){if(v){const L=d&&d.latest?d.latest[this.resource]:void 0;if(v.ref===L||L===void 0&&v.syncData===null)return v}return this.getRemoteUserData(v)}async performSync(d,v,L,_){if(d.syncData&&d.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new c.UserDataSyncError((0,m.localize)(0,null,this.resource,this.version,d.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(d,v,L,_)}catch(M){if(M instanceof c.UserDataSyncError)switch(M.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(d,v,L,_);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),d=await this.getRemoteUserData(null),v=await this.getLastSyncUserData(),this.performSync(d,v,L,_)}throw M}}async doSync(d,v,L,_){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,n.createCancelablePromise)(U=>this.doGenerateSyncResourcePreview(d,v,L,_,U)));const M=await this.syncPreviewPromise;return this.updateConflicts(M.resourcePreviews),M.resourcePreviews.some(({mergeState:U})=>U==="conflict")?"hasConflicts":L?await this.doApply(!1):"syncing"}catch(M){throw this.syncPreviewPromise=null,M}}async merge(d){return await this.updateSyncResourcePreview(d,async v=>{const L=await this.getMergeResult(v,T.CancellationToken.None);await this.fileService.writeFile(v.previewResource,k.VSBuffer.fromString(L?.content||""));const _=L&&!L.hasConflicts?await this.getAcceptResult(v,v.previewResource,void 0,T.CancellationToken.None):void 0;return v.acceptResult=_,v.mergeState=L.hasConflicts?"conflict":_?"accepted":"preview",v.localChange=_?_.localChange:L.localChange,v.remoteChange=_?_.remoteChange:L.remoteChange,v}),this.syncPreviewPromise}async accept(d,v){return await this.updateSyncResourcePreview(d,async L=>{const _=await this.getAcceptResult(L,d,v,T.CancellationToken.None);return L.acceptResult=_,L.mergeState="accepted",L.localChange=_.localChange,L.remoteChange=_.remoteChange,L}),this.syncPreviewPromise}async discard(d){return await this.updateSyncResourcePreview(d,async v=>{const L=await this.getMergeResult(v,T.CancellationToken.None);return await this.fileService.writeFile(v.previewResource,k.VSBuffer.fromString(L.content||"")),v.acceptResult=void 0,v.mergeState="preview",v.localChange=L.localChange,v.remoteChange=L.remoteChange,v}),this.syncPreviewPromise}async updateSyncResourcePreview(d,v){if(!this.syncPreviewPromise)return;let L=await this.syncPreviewPromise;const _=L.resourcePreviews.findIndex(({localResource:M,remoteResource:U,previewResource:D})=>this.extUri.isEqual(M,d)||this.extUri.isEqual(U,d)||this.extUri.isEqual(D,d));_!==-1&&(this.syncPreviewPromise=(0,n.createCancelablePromise)(async M=>{const U=[...L.resourcePreviews];return U[_]=await v(U[_]),{...L,resourcePreviews:U}}),L=await this.syncPreviewPromise,this.updateConflicts(L.resourcePreviews),L.resourcePreviews.some(({mergeState:M})=>M==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(d){if(!this.syncPreviewPromise)return"idle";const v=await this.syncPreviewPromise;return v.resourcePreviews.some(({mergeState:L})=>L==="conflict")?"hasConflicts":v.resourcePreviews.some(({mergeState:L})=>L!=="accepted")?"syncing":(await this.applyResult(v.remoteUserData,v.lastSyncUserData,v.resourcePreviews.map(L=>[L,L.acceptResult]),d),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(d){const v=d.filter(({mergeState:L})=>L==="conflict");(0,R.equals)(this._conflicts,v,(L,_)=>this.extUri.isEqual(L.previewResource,_.previewResource))||(this._conflicts=v,this._onDidChangeConflicts.fire(v))}async hasPreviouslySynced(){const d=await this.getLastSyncUserData();return!!d&&d.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:v,ref:L})=>({created:v,uri:this.toRemoteBackupResource(L)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:v,ref:L})=>({created:v,uri:this.toLocalBackupResource(L)}))}toRemoteBackupResource(d){return w.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${d}`})}toLocalBackupResource(d){return w.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${d}`})}async getMachineId({uri:d}){const v=this.extUri.basename(d);if(this.extUri.isEqual(d,this.toRemoteBackupResource(v))){const{content:L}=await this.getUserData(v);if(L)return this.parseSyncData(L)?.machineId}}async resolveContent(d){const v=this.extUri.basename(d);if(this.extUri.isEqual(d,this.toRemoteBackupResource(v))){const{content:L}=await this.getUserData(v);return L}return this.extUri.isEqual(d,this.toLocalBackupResource(v))?this.userDataSyncBackupStoreService.resolveContent(this.resource,v):null}async resolvePreviewContent(d){const v=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(v)for(const L of v.resourcePreviews){if(this.extUri.isEqual(L.acceptedResource,d))return L.acceptResult?L.acceptResult.content:null;if(this.extUri.isEqual(L.remoteResource,d))return L.remoteContent;if(this.extUri.isEqual(L.localResource,d))return L.localContent;if(this.extUri.isEqual(L.baseResource,d))return L.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(d,v,L,_,M){const U=await this.isRemoteDataFromCurrentMachine(d),D=await this.generateSyncPreview(d,v,U,_,M),F=[];for(const $ of D){const j=$.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"});if($.localChange===0&&$.remoteChange===0)F.push({...$,acceptedResource:j,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const J=L?await this.getMergeResult($,M):void 0;if(M.isCancellationRequested)break;await this.fileService.writeFile($.previewResource,k.VSBuffer.fromString(J?.content||""));const H=J&&!J.hasConflicts?await this.getAcceptResult($,$.previewResource,void 0,M):void 0;F.push({...$,acceptResult:H,mergeState:J?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:J?J.localChange:$.localChange,remoteChange:H?H.remoteChange:J?J.remoteChange:$.remoteChange})}}return{remoteUserData:d,lastSyncUserData:v,resourcePreviews:F,isLastSyncFromCurrentMachine:U}}async getLastSyncUserData(){try{const d=await this.fileService.readFile(this.lastSyncResource),v=JSON.parse(d.value.toString()),L=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=v.version&&L&&v.version!==L,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${v.version} is not compatible with current sync state version ${L}.`),await this.resetLocal(),null;const _=v;if(_.content===null)return{ref:v.ref,syncData:null};const M=JSON.parse(_.content);if(s(M))return{...v,syncData:M,content:void 0}}catch(d){d instanceof y.FileOperationError&&d.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Not synced yet. Last sync resource does not exist.`):this.logService.error(d)}return null}async updateLastSyncUserData(d,v={}){if(v.ref||v.content||v.version)throw new Error("Cannot have core properties as additional");const L=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),_={ref:d.ref,content:d.syncData?JSON.stringify(d.syncData):null,version:L,...v};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(_)))}async getRemoteUserData(d){const{ref:v,content:L}=await this.getUserData(d);let _=null;return L!==null&&(_=this.parseSyncData(L)),{ref:v,syncData:_}}parseSyncData(d){try{const v=JSON.parse(d);if(s(v))return v}catch(v){this.logService.error(v)}throw new c.UserDataSyncError((0,m.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(d){if((0,b.isString)(d)){const v=await this.userDataSyncStoreService.resolveContent(this.resource,d);return{ref:d,content:v}}else{const v=d?{ref:d.ref,content:d.syncData?JSON.stringify(d.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,v,void 0,this.syncHeaders)}}async updateRemoteUserData(d,v){const L=await this.currentMachineIdPromise,_={version:this.version,machineId:L,content:d};try{return v=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(_),v,void 0,this.syncHeaders),{ref:v,syncData:_}}catch(M){throw M instanceof c.UserDataSyncError&&M.code==="TooLarge"&&(M=new c.UserDataSyncError(M.message,M.code,this.resource)),M}}async backupLocal(d){const v={version:this.version,content:d};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(v))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=pe([G(1,y.IFileService),G(2,h.IEnvironmentService),G(3,g.IStorageService),G(4,c.IUserDataSyncStoreService),G(5,c.IUserDataSyncBackupStoreService),G(6,c.IUserDataSyncEnablementService),G(7,a.ITelemetryService),G(8,c.IUserDataSyncLogService),G(9,S.IConfigurationService),G(10,f.IUriIdentityService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(d,v,L,_,M,U,D,F,$,j,J,H){super(v,L,_,M,U,D,F,$,j,J,H),this.file=d,this._register(this.fileService.watch(this.extUri.dirname(d))),this._register(this.fileService.onDidFilesChange(K=>this.onFileChanges(K)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(d,v,L){try{v?await this.fileService.writeFile(this.file,k.VSBuffer.fromString(d),L?void 0:v):await this.fileService.createFile(this.file,k.VSBuffer.fromString(d),{overwrite:L})}catch(_){throw _ instanceof y.FileOperationError&&_.fileOperationResult===1||_ instanceof y.FileOperationError&&_.fileOperationResult===3?new c.UserDataSyncError(_.message,"LocalPreconditionFailed"):_}}onFileChanges(d){!d.contains(this.file)||this.triggerLocalChange()}};r=pe([G(2,y.IFileService),G(3,h.IEnvironmentService),G(4,g.IStorageService),G(5,c.IUserDataSyncStoreService),G(6,c.IUserDataSyncBackupStoreService),G(7,c.IUserDataSyncEnablementService),G(8,a.ITelemetryService),G(9,c.IUserDataSyncLogService),G(10,S.IConfigurationService),G(11,f.IUriIdentityService)],r),e.AbstractFileSynchroniser=r;let o=class extends r{constructor(d,v,L,_,M,U,D,F,$,j,J,H,K){super(d,v,L,_,M,U,D,F,$,j,H,K),this.userDataSyncUtilService=J,this._formattingOptions=void 0}hasErrors(d,v){const L=[],_=(0,I.parse)(d,L,{allowEmptyContent:!0,allowTrailingComma:!0});return L.length>0||!(0,b.isUndefined)(_)&&v!==Array.isArray(_)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};o=pe([G(2,y.IFileService),G(3,h.IEnvironmentService),G(4,g.IStorageService),G(5,c.IUserDataSyncStoreService),G(6,c.IUserDataSyncBackupStoreService),G(7,c.IUserDataSyncEnablementService),G(8,a.ITelemetryService),G(9,c.IUserDataSyncLogService),G(10,c.IUserDataSyncUtilService),G(11,S.IConfigurationService),G(12,f.IUriIdentityService)],o),e.AbstractJsonFileSynchroniser=o;let l=class{constructor(d,v,L,_,M,U){this.resource=d,this.userDataProfilesService=v,this.environmentService=L,this.logService=_,this.fileService=M,this.extUri=U.extUri,this.lastSyncResource=(0,c.getLastSyncResourceUri)(this.resource,L,this.extUri)}async initialize({ref:d,content:v}){if(!v){this.logService.info("Remote content does not exist.",this.resource);return}const L=this.parseSyncData(v);if(!!L)try{await this.doInitialize({ref:d,syncData:L})}catch(_){this.logService.error(_)}}parseSyncData(d){try{const v=JSON.parse(d);if(s(v))return v}catch(v){this.logService.error(v)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(d,v={}){const L={ref:d.ref,content:d.syncData?JSON.stringify(d.syncData):null,...v};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(L)))}};l=pe([G(1,i.IUserDataProfilesService),G(2,h.IEnvironmentService),G(3,C.ILogService),G(4,y.IFileService),G(5,f.IUriIdentityService)],l),e.AbstractInitializer=l}),define(ne[255],re([0,1,6,21,9,3,52,24,7,19,15,29,32,73,13,8,23,22,33,28,45,236,109,26]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C,p,g,a,f,c,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function t(l,u){const d=JSON.parse(l.content);if(l.version===1||l.version===2){const v=(await u.getInstalled(0)).filter(L=>L.isBuiltin);for(const L of d)l.version===1&&(L.enabled===!1&&(L.disabled=!0),delete L.enabled),l.version===2&&v.every(_=>!(0,m.areSameExtensions)(_.identifier,L.identifier))&&(L.installed=!0)}return d}let r=class gt extends f.AbstractSynchroniser{constructor(u,d,v,L,_,M,U,D,F,$,j,J,H,K,q,B){super("extensions",v,d,L,_,M,H,K,$,J,B),this.profileLocation=u,this.extensionManagementService=U,this.extensionEnablementService=D,this.ignoredExtensionsManagementService=F,this.extensionGalleryService=j,this.extensionStorageService=q,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,Y=>Y.some(({local:te})=>!!te)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,Y=>!Y.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(u,d){const v=u.syncData?await t(u.syncData,this.extensionManagementService):null,L=d?.skippedExtensions||[],_=d?.syncData?await t(d.syncData,this.extensionManagementService):null,M=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),U=this.getLocalExtensions(M),D=this.ignoredExtensionsManagementService.getIgnoredExtensions(M);v?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:F,remote:$}=(0,c.merge)(U,v,_,L,D),j={local:F,remote:$,content:this.getPreviewContent(U,F.added,F.updated,F.removed),localChange:F.added.length>0||F.removed.length>0||F.updated.length>0?2:0,remoteChange:$!==null?2:0},J=this.stringify(U,!1);return[{skippedExtensions:L,baseResource:this.baseResource,baseContent:_?this.stringify(_,!1):J,localResource:this.localResource,localContent:J,localExtensions:U,remoteResource:this.remoteResource,remoteContent:v?this.stringify(v,!1):null,previewResource:this.previewResource,previewResult:j,localChange:j.localChange,remoteChange:j.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const d=u.syncData?await t(u.syncData,this.extensionManagementService):null,v=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),L=this.getLocalExtensions(v),_=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),{remote:M}=(0,c.merge)(L,d,d,u.skippedExtensions||[],_);return M!==null}getPreviewContent(u,d,v,L){const _=[...d,...v],M=new Set,U=D=>{M.add(D.id.toLowerCase()),D.uuid&&M.add(D.uuid)};_.forEach(({identifier:D})=>U(D)),L.forEach(U);for(const D of u)M.has(D.identifier.id.toLowerCase())||D.identifier.uuid&&M.has(D.identifier.uuid)||_.push(D);return this.stringify(_,!1)}async getMergeResult(u,d){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,d,v,L){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(d,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(u){const d=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),L=(0,c.merge)(u.localExtensions,null,null,u.skippedExtensions,v),{local:_,remote:M}=L;return{content:u.localContent,local:_,remote:M,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:M!==null?2:0}}async acceptRemote(u){const d=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),L=u.remoteContent?JSON.parse(u.remoteContent):null;if(L!==null){const _=(0,c.merge)(u.localExtensions,L,u.localExtensions,[],v),{local:M,remote:U}=_;return{content:u.remoteContent,local:M,remote:U,localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,d,v,L){let{skippedExtensions:_,localExtensions:M}=v[0][0];const{local:U,remote:D,localChange:F,remoteChange:$}=v[0][1];if(F===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),F!==0&&(await this.backupLocal(JSON.stringify(M)),_=await this.updateLocalExtensions(U.added,U.removed,U.updated,_)),D){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const j=JSON.stringify(D.all);u=await this.updateRemoteUserData(j,L?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${D.added.length?` Added: ${JSON.stringify(D.added.map(J=>J.identifier.id))}.`:""}${D.updated.length?` Updated: ${JSON.stringify(D.updated.map(J=>J.identifier.id))}.`:""}${D.removed.length?` Removed: ${JSON.stringify(D.removed.map(J=>J.identifier.id))}.`:""}`)}d?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(u,{skippedExtensions:_}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${_.length?` Skipped: ${JSON.stringify(_.map(j=>j.identifier.id))}.`:""}`))}async getAssociatedResources({uri:u}){return[{resource:this.extUri.joinPath(u,"extensions.json"),comparableResource:gt.EXTENSIONS_DATA_URI}]}async resolveContent(u){if(this.extUri.isEqual(u,gt.EXTENSIONS_DATA_URI)){const v=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),L=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),_=this.getLocalExtensions(v).filter(M=>!L.some(U=>(0,m.areSameExtensions)({id:U},M.identifier)));return this.stringify(_,!0)}if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)){const v=await this.resolvePreviewContent(u);return v&&this.stringify(JSON.parse(v),!0)}let d=await super.resolveContent(u);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(u)),d){const v=this.parseSyncData(d);if(v)switch(this.extUri.basename(u)){case"extensions.json":return this.stringify(this.parseExtensions(v),!0)}}return null}stringify(u,d){return u.sort((v,L)=>!v.identifier.uuid&&L.identifier.uuid?-1:v.identifier.uuid&&!L.identifier.uuid?1:(0,I.compare)(v.identifier.id,L.identifier.id)),d?(0,A.toFormattedString)(u,{}):JSON.stringify(u)}async hasLocalData(){try{const u=await this.extensionManagementService.getInstalled(void 0,this.profileLocation);if(this.getLocalExtensions(u).some(v=>v.installed||v.disabled))return!0}catch{}return!1}async updateLocalExtensions(u,d,v,L){const _=[],M=[],U=await this.extensionManagementService.getInstalled(void 0,this.profileLocation);if(d.length){const F=U.filter(({identifier:$,isBuiltin:j})=>!j&&d.some(J=>(0,m.areSameExtensions)($,J)));await R.Promises.settled(F.map(async $=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,$.identifier.id),await this.extensionManagementService.uninstall($,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:this.profileLocation}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,$.identifier.id),_.push($.identifier)}))}(u.length||v.length)&&await R.Promises.settled([...u,...v].map(async F=>{const $=U.find(J=>(0,m.areSameExtensions)(J.identifier,F.identifier));if($&&$.isBuiltin){F.state&&$.manifest.version===F.version&&this.updateExtensionState(F.state,$,$.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(H=>(0,m.areSameExtensions)(H,F.identifier))!==!!F.disabled&&(F.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,F.identifier.id),await this.extensionEnablementService.disableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,F.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,F.identifier.id),await this.extensionEnablementService.enableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,F.identifier.id))),_.push(F.identifier);return}const j=(await this.extensionGalleryService.getExtensions([{...F.identifier,preRelease:F.preRelease}],n.CancellationToken.None))[0];if(F.state&&($?$.manifest.version===F.version:!!j)&&this.updateExtensionState(F.state,$||j,$?.manifest.version),j)try{this.extensionEnablementService.getDisabledExtensions().some(H=>(0,m.areSameExtensions)(H,F.identifier))!==!!F.disabled&&(F.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,F.identifier.id,j.version),await this.extensionEnablementService.disableExtension(j.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,F.identifier.id,j.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,F.identifier.id,j.version),await this.extensionEnablementService.enableExtension(j.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,F.identifier.id,j.version))),(!$||$.preRelease!==F.preRelease)&&(await this.extensionManagementService.canInstall(j)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,F.identifier.id,j.version),await this.extensionManagementService.installFromGallery(j,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:F.preRelease,profileLocation:this.profileLocation}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,F.identifier.id,j.version),_.push(j.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,j.displayName||j.identifier.id),M.push(F)))}catch(J){M.push(F),J instanceof w.ExtensionManagementError&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatiblePreRelease,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(J.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,j.displayName||j.identifier.id):(this.logService.error(J),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,j.displayName||j.identifier.id))}else M.push(F),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,F.identifier.id)}));const D=[];for(const F of L)_.some($=>(0,m.areSameExtensions)($,F.identifier))||D.push(F);for(const F of M)D.some($=>(0,m.areSameExtensions)($.identifier,F.identifier))||D.push(F);return D}updateExtensionState(u,d,v){const L=this.extensionStorageService.getExtensionState(d,!0)||{},_=v?this.extensionStorageService.getKeysForSync({id:d.identifier.id,version:v}):void 0;_?_.forEach(M=>{L[M]=u[M]}):Object.keys(u).forEach(M=>L[M]=u[M]),this.extensionStorageService.setExtensionState(d,L,!0)}parseExtensions(u){return JSON.parse(u.content)}getLocalExtensions(u){const d=this.extensionEnablementService.getDisabledExtensions();return u.map(v=>{const{identifier:L,isBuiltin:_,manifest:M,preRelease:U}=v,D={identifier:L,preRelease:U,version:M.version};d.some(F=>(0,m.areSameExtensions)(F,L))&&(D.disabled=!0),_||(D.installed=!0);try{const F=this.extensionStorageService.getKeysForSync({id:L.id,version:M.version});if(F){const $=this.extensionStorageService.getExtensionState(v,!0)||{};D.state=Object.keys($).reduce((j,J)=>(F.includes(J)&&(j[J]=$[J]),j),{})}}catch(F){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,k.getErrorMessage)(F))}return D})}};r.EXTENSIONS_DATA_URI=E.URI.from({scheme:s.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),r=pe([G(1,b.IEnvironmentService),G(2,h.IFileService),G(3,C.IStorageService),G(4,s.IUserDataSyncStoreService),G(5,s.IUserDataSyncBackupStoreService),G(6,w.IExtensionManagementService),G(7,w.IGlobalExtensionEnablementService),G(8,i.IIgnoredExtensionsManagementService),G(9,s.IUserDataSyncLogService),G(10,w.IExtensionGalleryService),G(11,P.IConfigurationService),G(12,s.IUserDataSyncEnablementService),G(13,p.ITelemetryService),G(14,S.IExtensionStorageService),G(15,g.IUriIdentityService)],r),e.ExtensionsSynchroniser=r;let o=class extends f.AbstractInitializer{constructor(u,d,v,L,_,M,U){super("extensions",L,_,M,v,U),this.extensionManagementService=u,this.ignoredExtensionsManagementService=d}async parseExtensions(u){return u.syncData?await t(u.syncData,this.extensionManagementService):null}generatePreview(u,d){const v=[],L=[],_=[];for(const M of u){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(M.identifier.id))continue;const U=d.find(D=>(0,m.areSameExtensions)(D.identifier,M.identifier));U?(v.push(U),M.disabled&&_.push(M.identifier)):M.installed&&(L.push({...M.identifier,preRelease:!!M.preRelease}),M.disabled&&_.push(M.identifier))}return{installedExtensions:v,newExtensions:L,disabledExtensions:_,remoteExtensions:u}}};o=pe([G(0,w.IExtensionManagementService),G(1,i.IIgnoredExtensionsManagementService),G(2,h.IFileService),G(3,a.IUserDataProfilesService),G(4,b.IEnvironmentService),G(5,y.ILogService),G(6,g.IUriIdentityService)],o),e.AbstractExtensionsInitializer=o}),define(ne[256],re([0,1,16,9,3,35,52,4,7,30,19,15,13,8,47,23,22,33,45,60,239,26,28]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C,p,g,a,f,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const s="globalState.argv.",t=["locale"];function r(v,L){const _=v.storage?Object.keys(v.storage).sort():[],M={};return _.forEach(U=>M[U]=v.storage[U]),v.storage=M,L?(0,A.toFormattedString)(v,{}):JSON.stringify(v)}const o=1;let l=class mt extends g.AbstractSynchroniser{constructor(L,_,M,U,D,F,$,j,J,H){super("globalState",L,D,J,_,M,F,$,U,j,H),this.storageService=J,this.version=o,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(L.onDidFilesChange,K=>K.contains(this.environmentService.argvResource)),k.Event.filter(J.onDidChangeValue,K=>K.scope===0&&K.target!==void 0?K.target===0:J.keys(0,0).includes(K.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(L,_,M){const U=L.syncData?JSON.parse(L.syncData.content):null;_=_===null&&M?L:_;const D=_&&_.syncData?JSON.parse(_.syncData.content):null,F=await this.getLocalGlobalState();U?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const $=this.getStorageKeys(D),{local:j,remote:J}=(0,f.merge)(F.storage,U?U.storage:null,D?D.storage:null,$,this.logService),H={content:null,local:j,remote:J,localChange:Object.keys(j.added).length>0||Object.keys(j.updated).length>0||j.removed.length>0?2:0,remoteChange:J!==null?2:0},K=r(F,!1);return[{baseResource:this.baseResource,baseContent:D?r(D,!1):K,localResource:this.localResource,localContent:K,localUserData:F,remoteResource:this.remoteResource,remoteContent:U?r(U,!1):null,previewResource:this.previewResource,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.acceptedResource,storageKeys:$}]}async hasRemoteChanged(L){const _=L.syncData?JSON.parse(L.syncData.content):null;if(_===null)return!0;const M=await this.getLocalGlobalState(),U=this.getStorageKeys(_),{remote:D}=(0,f.merge)(M.storage,_.storage,_.storage,U,this.logService);return D!==null}async getMergeResult(L,_){return{...L.previewResult,hasConflicts:!1}}async getAcceptResult(L,_,M,U){if(this.extUri.isEqual(_,this.localResource))return this.acceptLocal(L);if(this.extUri.isEqual(_,this.remoteResource))return this.acceptRemote(L);if(this.extUri.isEqual(_,this.previewResource))return L.previewResult;throw new Error(`Invalid Resource: ${_.toString()}`)}async acceptLocal(L){return{content:L.localContent,local:{added:{},removed:[],updated:{}},remote:L.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(L){if(L.remoteContent!==null){const _=JSON.parse(L.remoteContent),{local:M,remote:U}=(0,f.merge)(L.localUserData.storage,_.storage,null,L.storageKeys,this.logService);return{content:L.remoteContent,local:M,remote:U,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:L.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(L,_,M,U){const{localUserData:D}=M[0][0],{local:F,remote:$,localChange:j,remoteChange:J}=M[0][1];if(j===0&&J===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),j!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(D)),await this.writeLocalGlobalState(F),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),J!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const H=JSON.stringify({storage:$});L=await this.updateRemoteUserData(H,U?null:L.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}_?.ref!==L.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(L),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:L}){return[{resource:this.extUri.joinPath(L,"globalState.json"),comparableResource:mt.GLOBAL_STATE_DATA_URI}]}async resolveContent(L){if(this.extUri.isEqual(L,mt.GLOBAL_STATE_DATA_URI)){const M=await this.getLocalGlobalState();return r(M,!0)}if(this.extUri.isEqual(this.remoteResource,L)||this.extUri.isEqual(this.baseResource,L)||this.extUri.isEqual(this.localResource,L)||this.extUri.isEqual(this.acceptedResource,L)){const M=await this.resolvePreviewContent(L);return M&&r(JSON.parse(M),!0)}let _=await super.resolveContent(L);if(_)return _;if(_=await super.resolveContent(this.extUri.dirname(L)),_){const M=this.parseSyncData(_);if(M)switch(this.extUri.basename(L)){case"globalState.json":return r(JSON.parse(M.content),!0)}}return null}async hasLocalData(){try{const{storage:L}=await this.getLocalGlobalState();if(Object.keys(L).length>1||L[`${s}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const L={},_=await this.getLocalArgvContent(),M=(0,T.parse)(_);for(const U of t)M[U]!==void 0&&(L[`${s}${U}`]={version:1,value:M[U]});for(const U of this.storageService.keys(0,0)){const D=this.storageService.get(U,0);D&&(L[U]={version:1,value:D})}return{storage:L}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const L=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),L.value.toString()}catch(L){this.logService.debug((0,n.getErrorMessage)(L))}return"{}"}async writeLocalGlobalState({added:L,removed:_,updated:M}){const U={},D={},F=(j,J)=>{for(const H of j){if(H.startsWith(s)){U[H.substring(s.length)]=J?J[H].value:void 0;continue}if(J){const K=J[H];K.value!==String(this.storageService.get(H,0))&&(D[H]=K.value)}else this.storageService.get(H,0)!==void 0&&(D[H]=void 0)}};if(F(Object.keys(L),L),F(Object.keys(M),M),F(_),Object.keys(U).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(U),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(D).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const j of Object.keys(D))this.storageService.store(j,D[j],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(D))}}async updateArgv(L){const _=await this.getLocalArgvContent();let M=_;for(const U of Object.keys(L))M=(0,a.edit)(M,[U],L[U],{});_!==M&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(M)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(L){const _=this.storageService.keys(0,0),M=this.storageService.keys(0,1),U=[..._,...M],D=L?.storage?Object.keys(L.storage).filter(F=>!F.startsWith(s)&&!U.includes(F)&&this.storageService.get(F,0)!==void 0):[];if(!I.isWeb){const F=[...c.ALL_SYNC_RESOURCES.map($=>(0,c.getEnablementKey)($)),c.SYNC_SERVICE_URL_TYPE];D.push(...F),M.push(...F)}return{user:_,machine:M,unregistered:D}}};l.GLOBAL_STATE_DATA_URI=E.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),l=pe([G(0,m.IFileService),G(1,c.IUserDataSyncStoreService),G(2,c.IUserDataSyncBackupStoreService),G(3,c.IUserDataSyncLogService),G(4,w.IEnvironmentService),G(5,c.IUserDataSyncEnablementService),G(6,C.ITelemetryService),G(7,b.IConfigurationService),G(8,y.IStorageService),G(9,p.IUriIdentityService)],l),e.GlobalStateSynchroniser=l;let u=class extends g.AbstractInitializer{constructor(L,_,M,U,D,F){super("globalState",M,U,D,_,F),this.storageService=L}async doInitialize(L){const _=L.syncData?JSON.parse(L.syncData.content):null;if(!_){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const M={},U={};for(const D of Object.keys(_.storage))D.startsWith(s)?M[D.substring(s.length)]=_.storage[D].value:this.storageService.get(D,0)===void 0&&(U[D]=_.storage[D].value);if(Object.keys(M).length){let D="{}";try{D=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const F of Object.keys(M))D=(0,a.edit)(D,[F],M[F],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(D))}if(Object.keys(U).length)for(const D of Object.keys(U))this.storageService.store(D,U[D],0,0)}};u=pe([G(0,y.IStorageService),G(1,m.IFileService),G(2,i.IUserDataProfilesService),G(3,w.IEnvironmentService),G(4,c.IUserDataSyncLogService),G(5,p.IUriIdentityService)],u),e.GlobalStateInitializer=u;let d=class{constructor(L,_,M,U,D){this.userDataSyncStoreClient=L,this.storageService=_,this.environmentService=M,this.fileService=U,this.logService=D}getSyncStoreType(L){return this.parseGlobalState(L)?.storage[c.SYNC_SERVICE_URL_TYPE]?.value}async sync(L){const _=(0,c.createSyncHeaders)((0,P.generateUuid)());try{return await this.doSync(L,_)}catch(M){if(M instanceof c.UserDataSyncError)switch(M.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(L,_)}throw M}}async doSync(L,_){const M=await this.userDataSyncStoreClient.readResource("globalState",null,_),U=this.parseGlobalState(M)||{storage:{}};U.storage[c.SYNC_SERVICE_URL_TYPE]={value:L,version:o};const D=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),F={version:o,machineId:D,content:r(U,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(F),M.ref,_)}parseGlobalState({content:L}){if(!L)return null;const _=JSON.parse(L);if((0,g.isSyncData)(_))return _?JSON.parse(_.content):null;throw new Error("Invalid remote data")}};d=pe([G(1,y.IStorageService),G(2,w.IEnvironmentService),G(3,m.IFileService),G(4,S.ILogService)],d),e.UserDataSyncStoreTypeSynchronizer=d}),define(ne[257],re([0,1,18,16,3,35,4,14,162,19,15,13,23,22,33,28,45,237,26]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function a(i,s,t){try{const r=JSON.parse(i);if(!s)return(0,I.isUndefined)(r.all)?null:r.all;switch(A.OS){case 2:return(0,I.isUndefined)(r.mac)?null:r.mac;case 3:return(0,I.isUndefined)(r.linux)?null:r.linux;case 1:return(0,I.isUndefined)(r.windows)?null:r.windows}}catch(r){return t.error(r),null}}e.getKeybindingsContentFromSyncContent=a;let f=class extends C.AbstractJsonFileSynchroniser{constructor(s,t,r,o,l,u,d,v,L,_,M,U){super(s,"keybindings",d,v,L,t,r,u,M,o,_,l,U),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.filter(l.onDidChangeConfiguration,D=>D.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(s,t,r,o){const l=s.syncData?a(s.syncData.content,o.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&r?s:t;const u=t?this.getKeybindingsContentFromLastSyncUserData(t):null,d=await this.getLocalFileContent(),v=await this.getFormattingOptions();let L=null,_=!1,M=!1,U=!1;if(l){let $=d?d.value.toString():"[]";if($=$||"[]",this.hasErrors($,!0))throw new g.UserDataSyncError((0,E.localize)(0,null),"LocalInvalidContent",this.resource);if(!u||u!==$||u!==l){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const j=await(0,p.merge)($,l,u,v,this.userDataSyncUtilService);j.hasChanges&&(L=j.mergeContent,U=j.hasConflicts,_=U||j.mergeContent!==$,M=U||j.mergeContent!==l)}}else d&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),L=d.value.toString(),M=!0);const D={content:L,localChange:_?d?2:1:0,remoteChange:M?2:0,hasConflicts:U},F=d?d.value.toString():null;return[{fileContent:d,baseResource:this.baseResource,baseContent:u!==null?u:F,localResource:this.localResource,localContent:F,localChange:D.localChange,remoteResource:this.remoteResource,remoteContent:l,remoteChange:D.remoteChange,previewResource:this.previewResource,previewResult:D,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const t=this.getKeybindingsContentFromLastSyncUserData(s);if(t===null)return!0;const r=await this.getLocalFileContent(),o=r?r.value.toString():"",l=await this.getFormattingOptions(),u=await(0,p.merge)(o||"[]",t,t,l,this.userDataSyncUtilService);return u.hasConflicts||u.mergeContent!==t}async getMergeResult(s,t){return s.previewResult}async getAcceptResult(s,t,r,o){if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,r,o){const{fileContent:l}=r[0][0];let{content:u,localChange:d,remoteChange:v}=r[0][1];if(d===0&&v===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),u!==null&&(u=u.trim(),u=u||"[]",this.hasErrors(u,!0)))throw new g.UserDataSyncError((0,E.localize)(1,null),"LocalInvalidContent",this.resource);if(d!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),l&&await this.backupLocal(this.toSyncContent(l.value.toString())),await this.updateLocalFileContent(u||"[]",l,o),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),v!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const L=this.toSyncContent(u||"[]",s.syncData?.content);s=await this.updateRemoteUserData(L,o?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(s,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=(0,T.parse)(s.value.toString());if((0,R.isNonEmptyArray)(t))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"keybindings.json"),comparableResource:t}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.baseResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let t=await super.resolveContent(s);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(s)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(s)){case"keybindings.json":return a(r.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.syncKeybindingsPerPlatform()?null:a(s.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(s,t){let r={};try{r=JSON.parse(t||"{}")}catch(o){this.logService.error(o)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=s,A.OS){case 2:r.mac=s;break;case 3:r.linux=s;break;case 1:r.windows=s;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};f=pe([G(1,g.IUserDataSyncStoreService),G(2,g.IUserDataSyncBackupStoreService),G(3,g.IUserDataSyncLogService),G(4,P.IConfigurationService),G(5,g.IUserDataSyncEnablementService),G(6,w.IFileService),G(7,b.IEnvironmentService),G(8,m.IStorageService),G(9,g.IUserDataSyncUtilService),G(10,S.ITelemetryService),G(11,h.IUriIdentityService)],f),e.KeybindingsSynchroniser=f;let c=class extends C.AbstractInitializer{constructor(s,t,r,o,l){super("keybindings",t,r,o,s,l)}async doInitialize(s){const t=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,n.VSBuffer.fromString(t)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,T.parse)(s.value.toString());return!(0,R.isNonEmptyArray)(t)}catch(s){return s.fileOperationResult===1}}getKeybindingsContentFromSyncContent(s){try{return a(s,!0,this.logService)}catch(t){return this.logService.error(t),null}}};c=pe([G(0,w.IFileService),G(1,y.IUserDataProfilesService),G(2,b.IEnvironmentService),G(3,g.IUserDataSyncLogService),G(4,h.IUriIdentityService)],c),e.KeybindingsInitializer=c}),define(ne[258],re([0,1,16,3,163,19,69,15,29,13,23,22,33,28,45,60,240,26]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function a(i){const s=JSON.parse(i);return g(s)?s:{settings:i}}e.parseSettingsSyncContent=a;let f=class extends h.AbstractJsonFileSynchroniser{constructor(s,t,r,o,l,u,d,v,L,_,M,U,D){super(s,"settings",t,r,o,l,u,_,M,d,v,L,D),this.extensionManagementService=U,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(s){const t=await this.getLastSyncUserData(),r=await this.getLatestRemoteUserData(s,t),o=this.getSettingsSyncContent(r),l=new A.ConfigurationModelParser(p.USER_DATA_SYNC_CONFIGURATION_SCOPE);return o?.settings&&l.parse(o.settings),l.configurationModel.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(s,t,r){const o=await this.getLocalFileContent(),l=await this.getFormattingOptions(),u=this.getSettingsSyncContent(s);t=t===null&&r?s:t;const d=t?this.getSettingsSyncContent(t):null,v=await this.getIgnoredSettings();let L=null,_=!1,M=!1,U=!1;if(u){let $=o?o.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const j=(0,C.merge)($,u.settings,d?d.settings:null,v,[],l);L=j.localContent||j.remoteContent,_=j.localContent!==null,M=j.remoteContent!==null,U=j.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),L=o.value.toString().trim()||"{}",this.validateContent(L),M=!0);const D={content:L,localChange:_?2:0,remoteChange:M?2:0,hasConflicts:U},F=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:d?d.settings:F,localResource:this.localResource,localContent:F,localChange:D.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:D.remoteChange,previewResource:this.previewResource,previewResult:D,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const t=this.getSettingsSyncContent(s);if(t===null)return!0;const r=await this.getLocalFileContent(),o=r?r.value.toString().trim():"",l=await this.getIgnoredSettings(),u=await this.getFormattingOptions();return(0,C.merge)(o||"{}",t.settings,t.settings,l,[],u).remoteContent!==null}async getMergeResult(s,t){const r=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return{...s.previewResult,content:s.previewResult.content?(0,C.updateIgnoredSettings)(s.previewResult.content,"{}",o,r):null}}async getAcceptResult(s,t,r,o){const l=await this.getFormattingOptions(),u=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?(0,C.updateIgnoredSettings)(s.fileContent.value.toString(),"{}",u,l):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent!==null?(0,C.updateIgnoredSettings)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",u,l):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:r!==null?(0,C.updateIgnoredSettings)(r,s.fileContent?s.fileContent.value.toString():"{}",u,l):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,r,o){const{fileContent:l}=r[0][0];let{content:u,localChange:d,remoteChange:v}=r[0][1];if(d===0&&v===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),u=u?u.trim():"{}",u=u||"{}",this.validateContent(u),d!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),l&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(l.value.toString()))),await this.updateLocalFileContent(u,l,o),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),v!==0){const L=await this.getFormattingOptions(),_=this.getSettingsSyncContent(s),M=await this.getIgnoredSettings(u);u=(0,C.updateIgnoredSettings)(u,_?_.settings:"{}",M,L),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),s=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(u)),o?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(s),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=await this.getFormattingOptions(),r=(0,y.edit)(s.value.toString(),[p.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,C.isEmpty)(r)}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"settings.json"),comparableResource:t}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)||this.extUri.isEqual(this.baseResource,s))return this.resolvePreviewContent(s);let t=await super.resolveContent(s);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(s)),t){const r=this.parseSyncData(t);if(r){const o=this.parseSettingsSyncContent(r.content);if(o)switch(this.extUri.basename(s)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(s){let t=await super.resolvePreviewContent(s);if(t){const r=await this.getFormattingOptions(),o=await this.getIgnoredSettings();t=(0,C.updateIgnoredSettings)(t,"{}",o,r)}return t}getSettingsSyncContent(s){return s.syncData?this.parseSettingsSyncContent(s.syncData.content):null}parseSettingsSyncContent(s){try{return a(s)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(s){return{settings:s}}async getIgnoredSettings(s){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const r=n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtensions,o=>o.some(({local:l})=>!!l)),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{r.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,C.getIgnoredSettings)(t,this.configurationService,s)}validateContent(s){if(this.hasErrors(s,!1))throw new p.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}};f=pe([G(1,P.IFileService),G(2,I.IEnvironmentService),G(3,b.IStorageService),G(4,p.IUserDataSyncStoreService),G(5,p.IUserDataSyncBackupStoreService),G(6,p.IUserDataSyncLogService),G(7,p.IUserDataSyncUtilService),G(8,T.IConfigurationService),G(9,p.IUserDataSyncEnablementService),G(10,w.ITelemetryService),G(11,E.IExtensionManagementService),G(12,m.IUriIdentityService)],f),e.SettingsSynchroniser=f;let c=class extends h.AbstractInitializer{constructor(s,t,r,o,l){super("settings",t,r,o,s,l)}async doInitialize(s){const t=s.syncData?this.parseSettingsSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,R.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,C.isEmpty)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}parseSettingsSyncContent(s){try{return a(s)}catch(t){this.logService.error(t)}return null}};c=pe([G(0,P.IFileService),G(1,S.IUserDataProfilesService),G(2,I.IEnvironmentService),G(3,p.IUserDataSyncLogService),G(4,m.IUriIdentityService)],c),e.SettingsInitializer=c}),define(ne[259],re([0,1,16,3,31,19,15,13,23,22,33,28,45,238,26]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let y=class extends m.AbstractSynchroniser{constructor(g,a,f,c,i,s,t,r,o,l,u){super("snippets",f,a,c,i,s,o,l,t,r,u),this.snippetsFolder=g,this.version=1,this._register(this.fileService.watch(a.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(n.Event.filter(this.fileService.onDidFilesChange,d=>d.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,a,f){const c=await this.getSnippetsFileContents(),i=this.toSnippetsContents(c),s=g.syncData?this.parseSnippets(g.syncData):null;a=a===null&&f?g:a;const t=a&&a.syncData?this.parseSnippets(a.syncData):null;s?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const r=(0,S.merge)(i,s,t);return this.getResourcePreviews(r,c,s||{},t||{})}async hasRemoteChanged(g){const a=g.syncData?this.parseSnippets(g.syncData):null;if(a===null)return!0;const f=await this.getSnippetsFileContents(),c=this.toSnippetsContents(f),i=(0,S.merge)(c,a,a);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async getMergeResult(g,a){return g.previewResult}async getAcceptResult(g,a,f,c){if(this.extUri.isEqualOrParent(a,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(a,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(a,this.syncPreviewFolder))return f===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:f,localChange:f===null?g.fileContent!==null?3:0:2,remoteChange:f===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(g,a,f,c){const i=f.map(([s,t])=>({...s,acceptResult:t}));i.every(({localChange:s,remoteChange:t})=>s===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),i.some(({localChange:s})=>s!==0)&&(await this.updateLocalBackup(i),await this.updateLocalSnippets(i,c)),i.some(({remoteChange:s})=>s!==0)&&(g=await this.updateRemoteSnippets(i,g,c)),a?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:s}of i)try{await this.fileService.del(s)}catch{}}getResourcePreviews(g,a,f,c){const i=new Map;for(const s of Object.keys(g.local.added)){const t={content:g.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(g.local.updated)){const t={content:g.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0},r=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[s]??r,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of g.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0},r=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[s]??r,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(g.remote.added)){const t={content:g.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1},r=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[s]??r,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(g.remote.updated)){const t={content:g.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2},r=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[s]??r,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of g.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of g.conflicts){const t={content:a[s]?a[s].value.toString():null,hasConflicts:!0,localChange:a[s]?2:1,remoteChange:f[s]?2:1},r=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[s]??r,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s]||null,localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(a))if(!i.has(s)){const t={content:a[s]?a[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},r=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[s]??r,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s]||null,localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...i.values()]}async getAssociatedResources({uri:g}){const a=await super.resolveContent(g);if(a){const f=this.parseSyncData(a);if(f){const c=this.parseSnippets(f),i=[];for(const s of Object.keys(c)){const t=this.extUri.joinPath(g,s),r=this.extUri.joinPath(this.snippetsFolder,s),o=await this.fileService.exists(r);i.push({resource:t,comparableResource:o?r:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})})}return i}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let a=await super.resolveContent(g);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(g)),a){const f=this.parseSyncData(a);if(f)return this.parseSnippets(f)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const a={};for(const f of g)f.fileContent&&(a[this.extUri.basename(f.localResource)]=f.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(a)))}async updateLocalSnippets(g,a){for(const{fileContent:f,acceptResult:c,localResource:i,remoteResource:s,localChange:t}of g)if(t!==0){const r=s?this.extUri.basename(s):this.extUri.basename(i),o=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(o)),await this.fileService.del(o),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(o))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(o)),await this.fileService.createFile(o,R.VSBuffer.fromString(c.content),{overwrite:a}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(o))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(o)),await this.fileService.writeFile(o,R.VSBuffer.fromString(c.content),a?void 0:f),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(o)))}}async updateRemoteSnippets(g,a,f){const c=a.syncData?this.parseSnippets(a.syncData):{},i=(0,k.deepClone)(c);for(const{acceptResult:s,localResource:t,remoteResource:r,remoteChange:o}of g)if(o!==0){const l=t?this.extUri.basename(t):this.extUri.basename(r);o===3?delete i[l]:i[l]=s.content}return(0,S.areSame)(c,i)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),a=await this.updateRemoteUserData(JSON.stringify(i),f?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),a}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const a={};for(const f of Object.keys(g))a[f]=g[f].value.toString();return a}async getSnippetsFileContents(){const g={};let a;try{a=await this.fileService.resolve(this.snippetsFolder)}catch(f){if(f instanceof I.FileOperationError&&f.fileOperationResult===1)return g;throw f}for(const f of a.children||[]){const c=f.resource,i=this.extUri.extname(c);if(i===".json"||i===".code-snippets"){const s=this.extUri.relativePath(this.snippetsFolder,c),t=await this.fileService.readFile(c);g[s]=t}}return g}};y=pe([G(1,A.IEnvironmentService),G(2,I.IFileService),G(3,E.IStorageService),G(4,h.IUserDataSyncStoreService),G(5,h.IUserDataSyncBackupStoreService),G(6,h.IUserDataSyncLogService),G(7,T.IConfigurationService),G(8,h.IUserDataSyncEnablementService),G(9,P.ITelemetryService),G(10,b.IUriIdentityService)],y),e.SnippetsSynchroniser=y;let C=class extends m.AbstractInitializer{constructor(g,a,f,c,i){super("snippets",a,f,c,g,i)}async doInitialize(g){const a=g.syncData?JSON.parse(g.syncData.content):null;if(!a){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const c of Object.keys(a)){const i=a[c];if(i){const s=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,c);await this.fileService.createFile(s,R.VSBuffer.fromString(i)),this.logService.info("Created snippet",this.extUri.basename(s))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};C=pe([G(0,I.IFileService),G(1,w.IUserDataProfilesService),G(2,A.IEnvironmentService),G(3,h.IUserDataSyncLogService),G(4,b.IUriIdentityService)],C),e.SnippetsInitializer=C}),define(ne[260],re([0,1,16,19,15,13,23,22,33,28,45,26]),function(Q,e,R,n,k,T,A,I,E,P,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function m(C,p){try{return JSON.parse(C).tasks}catch(g){return p.error(g),null}}e.getTasksContentFromSyncContent=m;let S=class extends b.AbstractFileSynchroniser{constructor(p,g,a,f,c,i,s,t,r,o,l){super(p,"tasks",s,t,r,g,a,i,o,f,c,l),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(p,g,a,f){const c=p.syncData?m(p.syncData.content,this.logService):null;g=g===null&&a?p:g;const i=g?.syncData?m(g.syncData.content,this.logService):null,s=await this.getLocalFileContent();let t=null,r=!1,o=!1,l=!1;if(c){const v=s?s.value.toString():null;if(!i||i!==v||i!==c){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const L=y(v,c,i);t=L.content,l=L.hasConflicts,r=L.hasLocalChanged,o=L.hasRemoteChanged}}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=s.value.toString(),o=!0);const u={content:t,localChange:r?s?2:1:0,remoteChange:o?2:0,hasConflicts:l},d=s?s.value.toString():null;return[{fileContent:s,baseResource:this.baseResource,baseContent:i!==null?i:d,localResource:this.localResource,localContent:d,localChange:u.localChange,remoteResource:this.remoteResource,remoteContent:c,remoteChange:u.remoteChange,previewResource:this.previewResource,previewResult:u,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(p){const g=p?.syncData?m(p.syncData.content,this.logService):null;if(g===null)return!0;const a=await this.getLocalFileContent(),f=a?a.value.toString():null,c=y(f,g,g);return c.hasLocalChanged||c.hasRemoteChanged}async getMergeResult(p,g){return p.previewResult}async getAcceptResult(p,g,a,f){if(this.extUri.isEqual(g,this.localResource))return{content:p.fileContent?p.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(g,this.remoteResource))return{content:p.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(g,this.previewResource))return a===void 0?{content:p.previewResult.content,localChange:p.previewResult.localChange,remoteChange:p.previewResult.remoteChange}:{content:a,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(p,g,a,f){const{fileContent:c}=a[0][0],{content:i,localChange:s,remoteChange:t}=a[0][1];if(s===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),s!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),c&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(c.value.toString()))),await this.updateLocalFileContent(i||"{}",c,f),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const r=JSON.stringify(this.toTasksSyncContent(i||"{}"));p=await this.updateRemoteUserData(r,f?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}g?.ref!==p.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(p),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:p}){const g=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(p,"tasks.json"),comparableResource:g}]}async resolveContent(p){if(this.extUri.isEqual(this.remoteResource,p)||this.extUri.isEqual(this.baseResource,p)||this.extUri.isEqual(this.localResource,p)||this.extUri.isEqual(this.acceptedResource,p))return this.resolvePreviewContent(p);let g=await super.resolveContent(p);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(p)),g){const a=this.parseSyncData(g);if(a)switch(this.extUri.basename(p)){case"tasks.json":return m(a.content,this.logService)}}return null}toTasksSyncContent(p){return{tasks:p}}};S=pe([G(1,w.IUserDataSyncStoreService),G(2,w.IUserDataSyncBackupStoreService),G(3,w.IUserDataSyncLogService),G(4,n.IConfigurationService),G(5,w.IUserDataSyncEnablementService),G(6,T.IFileService),G(7,k.IEnvironmentService),G(8,A.IStorageService),G(9,I.ITelemetryService),G(10,E.IUriIdentityService)],S),e.TasksSynchroniser=S;let h=class extends b.AbstractInitializer{constructor(p,g,a,f,c){super("tasks",g,a,f,p,c),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(p){const g=p.syncData?m(p.syncData.content,this.logService):null;if(!g){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,R.VSBuffer.fromString(g)),await this.updateLastSyncUserData(p)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};h=pe([G(0,T.IFileService),G(1,P.IUserDataProfilesService),G(2,k.IEnvironmentService),G(3,w.IUserDataSyncLogService),G(4,E.IUriIdentityService)],h),e.TasksInitializer=h;function y(C,p,g){if(C===null&&p===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(C===p)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const a=g!==C,f=g!==p;return!a&&!f?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:a&&!f?{content:C,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:f&&!a?{content:p,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:C,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ne[261],re([0,1,3,2,4,15,23,22,26]),function(Q,e,R,n,k,T,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const P="sync.enable";let b=class extends n.Disposable{constructor(m,S,h,y){super(),this.storageService=m,this.telemetryService=S,this.environmentService=h,this.userDataSyncStoreManagementService=y,this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(m.onDidChangeValue(C=>this.onDidStorageChange(C)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(P,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(P,{enabled:m}),this.storageService.store(P,m,-1,1))}isResourceEnabled(m){return this.storageService.getBoolean((0,E.getEnablementKey)(m),-1,!0)}setResourceEnablement(m,S){if(this.isResourceEnabled(m)!==S){const h=(0,E.getEnablementKey)(m);this.storeResourceEnablement(h,S)}}getResourceSyncStateVersion(m){}storeResourceEnablement(m,S){this.storageService.store(m,S,-1,k.isWeb?0:1)}onDidStorageChange(m){if(m.scope!==-1)return;if(P===m.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const S=E.ALL_SYNC_RESOURCES.filter(h=>(0,E.getEnablementKey)(h)===m.key)[0];if(S){this._onDidChangeResourceEnablement.fire([S,this.isResourceEnabled(S)]);return}}};b=pe([G(0,A.IStorageService),G(1,I.ITelemetryService),G(2,T.IEnvironmentService),G(3,E.IUserDataSyncStoreManagementService)],b),e.UserDataSyncEnablementService=b}),define(ne[74],re([0,1,3,2,4,24,166,15,13,5,25,47,23,26]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,P.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName",y="Safari",C="Chrome",p="Edge",g="Firefox",a="Android";function f(s){switch(s){case y:case C:case p:case g:case a:case(0,k.PlatformToString)(0):return!0}return!1}e.isWebPlatform=f;function c(){return k.isSafari?y:k.isChrome?C:k.isEdge?p:k.isFirefox?g:k.isAndroid?a:(0,k.PlatformToString)(k.isWeb?0:k.platform)}let i=class nt extends n.Disposable{constructor(t,r,o,l,u,d){super(),this.storageService=o,this.userDataSyncStoreService=l,this.logService=u,this.productService=d,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,w.getServiceMachineId)(t,r,o)}async getMachines(t){const r=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(l=>({...l,isCurrent:l.id===r}))}async addCurrentMachine(t){const r=await this.currentMachineIdPromise,o=await this.readMachinesData(t);o.machines.some(({id:l})=>l===r)||(o.machines.push({id:r,name:this.computeCurrentMachineName(o.machines),platform:c()}),await this.writeMachinesData(o))}async removeCurrentMachine(t){const r=await this.currentMachineIdPromise,o=await this.readMachinesData(t),l=o.machines.filter(({id:u})=>u!==r);l.length!==o.machines.length&&(o.machines=l,await this.writeMachinesData(o))}async renameMachine(t,r,o){const l=await this.readMachinesData(o),u=l.machines.find(({id:d})=>d===t);if(u){u.name=r,await this.writeMachinesData(l);const d=await this.currentMachineIdPromise;t===d&&this.storageService.store(h,r,-1,1)}}async setEnablements(t){const r=await this.readMachinesData();for(const[o,l]of t){const u=r.machines.find(d=>d.id===o);u&&(u.disabled=l?void 0:!0)}await this.writeMachinesData(r)}computeCurrentMachineName(t){const r=this.storageService.get(h,-1);if(r)return r;const o=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${c()} (${this.productService.nameShort})`,l=new RegExp(`${(0,T.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let u=0;for(const d of t){const v=l.exec(d.name),L=v?parseInt(v[1]):0;u=L>u?L:u}return`${o} #${u+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const r=this.parse(this.userData);if(r.version!==nt.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return r}async writeMachinesData(t){const r=JSON.stringify(t),o=await this.userDataSyncStoreService.write(nt.RESOURCE,r,this.userData?.ref||null);this.userData={ref:o,content:r},this._onDidChange.fire()}async readUserData(t){if(this.userData){const r=t&&t.latest?t.latest[nt.RESOURCE]:void 0;if(this.userData.ref===r)return this.userData;if(r===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(nt.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(r){this.logService.error(r)}return{version:nt.VERSION,machines:[]}}};i.VERSION=1,i.RESOURCE="machines",i=pe([G(0,I.IEnvironmentService),G(1,E.IFileService),G(2,m.IStorageService),G(3,S.IUserDataSyncStoreService),G(4,S.IUserDataSyncLogService),G(5,b.IProductService)],i),e.UserDataSyncMachinesService=i}),define(ne[262],re([0,1,6,62,38,9,3,2,4,17,7,164,25,23,22,26,71,74]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const g="sync.disableMachineEventually",a="sync.sessionId",f="sync.storeUrl",c="sync.productQuality";let i=class extends I.Disposable{constructor(r,o,l,u,d,v,L,_,M,U){super(),this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=l,this.userDataSyncEnablementService=u,this.userDataSyncService=d,this.logService=v,this.userDataSyncAccountService=L,this.telemetryService=_,this.userDataSyncMachinesService=M,this.storageService=U,this.autoSync=this._register(new I.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new R.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=r.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(o.onDidChangeUserDataSyncStore(()=>{(0,P.isEqual)(this.syncUrl,o.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(L.onDidChangeAccount(()=>this.updateAutoSync())),this._register(l.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(d.onDidChangeLocal(D=>this.triggerSync([D],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,D])=>D)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const r=this.storageService.get(f,-1);return r?b.URI.parse(r):void 0}set syncUrl(r){r?this.storageService.store(f,r.toString(),-1,1):this.storageService.remove(f,-1)}get productQuality(){return this.storageService.get(c,-1)}set productQuality(r){r?this.storageService.store(c,r,-1,1):this.storageService.remove(c,-1)}updateAutoSync(){const{enabled:r,message:o}=this.isAutoSyncEnabled();r?this.autoSync.value===void 0&&(this.autoSync.value=new s(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(l=>this.onDidFinishSync(l))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(o&&this.logService.info(o),this.autoSync.clear()):o&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(o))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(r,o,l){try{this.userDataSyncAccountService.account&&!l&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,-1),r?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(u){if(o)this.logService.error(u),this.updateEnablement(!1);else throw u}}updateEnablement(r){this.userDataSyncEnablementService.isEnabled()!==r&&(this.userDataSyncEnablementService.setEnablement(r),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(r){if(!r){this.successiveFailures=0;return}const o=y.UserDataSyncError.toUserDataSyncError(r);o instanceof y.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:o.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?E.isWeb&&o.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(o),this.successiveFailures++),this._onError.fire(o)}async disableMachineEventually(){this.storageService.store(g,!0,-1,1),await(0,R.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(g,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(g,-1)}async triggerSync(r,o,l){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(o&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...r),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",l)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};i=pe([G(0,m.IProductService),G(1,y.IUserDataSyncStoreManagementService),G(2,y.IUserDataSyncStoreService),G(3,y.IUserDataSyncEnablementService),G(4,y.IUserDataSyncService),G(5,y.IUserDataSyncLogService),G(6,C.IUserDataSyncAccountService),G(7,h.ITelemetryService),G(8,p.IUserDataSyncMachinesService),G(9,S.IStorageService)],i),e.UserDataAutoSyncService=i;class s extends I.Disposable{constructor(r,o,l,u,d,v,L,_){super(),this.lastSyncUrl=r,this.interval=o,this.userDataSyncStoreManagementService=l,this.userDataSyncStoreService=u,this.userDataSyncService=d,this.userDataSyncMachinesService=v,this.logService=L,this.storageService=_,this.intervalHandler=this._register(new I.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,I.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(s.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>this.sync(s.INTERVAL_SYNCING,!1),this.interval)}sync(r,o){const l=(0,R.createCancelablePromise)(async u=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(d){if((0,T.isCancellationError)(d))return}return this.doSync(r,o,u)});return this.syncPromise=l,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,P.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const r=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),o=this.userDataSyncStoreManagementService.userDataSyncStore;return!!o&&!!r&&(!(0,P.isEqual)(o.defaultUrl,r.defaultUrl)||!(0,P.isEqual)(o.insidersUrl,r.insidersUrl)||!(0,P.isEqual)(o.stableUrl,r.stableUrl))}async doSync(r,o,l){this.logService.info(`Auto Sync: Triggered by ${r}`),this._onDidStartSync.fire();let u;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,o),l.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,w.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,w.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,w.localize)(2,null),"TurnedOff");const d=this.storageService.get(a,-1);if(d&&this.manifest&&d!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,w.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,w.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,w.localize)(5,null),"SessionExpired");const v=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(l.isCancellationRequested)return;const L=v.find(_=>_.isCurrent);if(L?.disabled)throw new y.UserDataAutoSyncError((0,w.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(_){throw new y.UserDataAutoSyncError((0,k.toErrorMessage)(_),_ instanceof y.UserDataSyncError?_.code:"Unknown")}if(this.manifest&&this.manifest.session!==d&&this.storageService.store(a,this.manifest.session,-1,1),l.isCancellationRequested)return;L||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(d){this.logService.error(d),u=d}this._onDidFinishSync.fire(u)}register(r){return super._register(r)}}s.INTERVAL_SYNCING="Interval"}),define(ne[263],re([0,1,18,6,38,3,2,17,14,30,19,29,5,23,22,28,255,256,257,258,259,260,26]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C,p,g,a,f,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const s="sync.lastSyncTime";let t=class extends A.Disposable{constructor(_,M,U,D,F,$,j,J,H){super(),this.userDataSyncStoreService=_,this.userDataSyncStoreManagementService=M,this.instantiationService=U,this.configurationService=D,this.logService=F,this.telemetryService=$,this.storageService=j,this.userDataSyncEnablementService=J,this.userDataProfilesService=H,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this._status=M.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(s,-1,void 0),this._register((0,A.toDisposable)(()=>this.clearProfileSynchronizers()))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(_,M){this.checkEnablement();const U=(0,P.generateUuid)();try{const j=(0,i.createSyncHeaders)(U);M&&(j["Cache-Control"]="no-cache"),_=await this.userDataSyncStoreService.manifest(_,j)}catch(j){const J=i.UserDataSyncError.toUserDataSyncError(j);throw d(J,U,this.userDataSyncStoreManagementService,this.telemetryService),J}const D=!1,F=this;let $;return{manifest:_,async run(){if(D)throw new Error("Can run a task only once");return $=(0,n.createCancelablePromise)(j=>F.sync(_,U,j)),$.finally(()=>$=void 0)},stop(){return $?.cancel(),F.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new i.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const _=(0,P.generateUuid)(),M=(0,i.createSyncHeaders)(_);let U;try{U=await this.userDataSyncStoreService.manifest(null,M)}catch($){const j=i.UserDataSyncError.toUserDataSyncError($);throw d(j,_,this.userDataSyncStoreManagementService,this.telemetryService),j}await this.resetLocal();const D=this.getProfileSynchronizers(),F=async()=>{await this.stop(),await this.resetLocal()};return new r(_,U,M,D[0].enabled,F,this.configurationService,this.logService)}async sync(_,M,U){if(U.isCancellationRequested)return;const D=this.getProfileSynchronizers(),F=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");for(const $ of D){if(U.isCancellationRequested)return;this._syncErrors.push(...await $.sync(_,M,U))}this.logService.info(`Sync done. Took ${new Date().getTime()-F}ms`),this.updateLastSyncTime()}finally{this._onSyncErrors.fire(this._syncErrors)}}async stop(){this.status!=="idle"&&this.profileSynchronizers&&await Promise.allSettled([...this.profileSynchronizers.values()].map(([_])=>_.stop()))}async replace(_){this.checkEnablement(),await this.performSynchronizerAction(async M=>{if(await M.replace(_))return!0})}async accept(_,M,U,D){this.checkEnablement(),await this.performSynchronizerAction(async F=>{if(F.resource===_)return await F.accept(M,U),D&&await F.apply(!1,(0,i.createSyncHeaders)((0,P.generateUuid)())),!0})}async resolveContent(_){return this.performSynchronizerAction(async M=>{const U=await M.resolveContent(_);if(U)return U})}async getRemoteSyncResourceHandles(_){return await this.performSynchronizerAction(async U=>{if(U.resource===_)return U.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(_){return await this.performSynchronizerAction(async U=>{if(U.resource===_)return U.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(_,M){return await this.performSynchronizerAction(async D=>{if(D.resource===_)return D.getAssociatedResources(M)})||[]}async getMachineId(_,M){return await this.performSynchronizerAction(async D=>{if(D.resource===_)return await D.getMachineId(M)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async M=>{if(M.resource!=="globalState"&&await M.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async M=>{if(await M.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(_){this.logService.error(_)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(s,-1),this.profileSynchronizers){for(const[_]of this.profileSynchronizers.values())try{await _.resetLocal()}catch(M){this.logService.error(M)}this.clearProfileSynchronizers()}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(_){const M=new A.DisposableStore;try{let U=this.profileSynchronizers;U||(U=this.createProfileSynchronizers(),U.forEach(([,D])=>M.add(D)));for(const[D]of U.values()){const F=[...D.enabled,...D.disabled.map($=>M.add(D.createSynchronizer($)))];for(const $ of F){const j=await _($);if(!(0,E.isUndefined)(j))return j}}return null}finally{M.dispose()}}setStatus(_){const M=this._status;this._status!==_&&(this._status=_,this._onDidChangeStatus.fire(_),M==="hasConflicts"&&this.updateLastSyncTime())}setConflicts(_){(0,R.equals)(this._conflicts,_,([M,U],[D,F])=>M===M&&(0,R.equals)(U,F,($,j)=>(0,I.isEqual)($.previewResource,j.previewResource)))||(this._conflicts=_,this._onDidChangeConflicts.fire(_))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(s,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getProfileSynchronizers(){return this.profileSynchronizers||(this.profileSynchronizers=this.createProfileSynchronizers()),[...this.profileSynchronizers.values()].map(([_])=>_)}createProfileSynchronizers(){const _=new Map;for(const M of[this.userDataProfilesService.defaultProfile]){const U=new A.DisposableStore,D=U.add(M.isDefault?this.instantiationService.createInstance(l):this.instantiationService.createInstance(o,M));U.add(D.onDidChangeStatus(F=>this.setStatus(F))),U.add(D.onDidChangeConflicts(F=>this.setConflicts(F))),U.add(D.onDidChangeLocal(F=>this._onDidChangeLocal.fire(F))),_.set(M.id,[D,U])}return _}clearProfileSynchronizers(){this.profileSynchronizers&&(this.profileSynchronizers.forEach(([,_])=>_.dispose()),this.profileSynchronizers.clear(),this.profileSynchronizers=void 0)}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};t=pe([G(0,i.IUserDataSyncStoreService),G(1,i.IUserDataSyncStoreManagementService),G(2,m.IInstantiationService),G(3,b.IConfigurationService),G(4,i.IUserDataSyncLogService),G(5,h.ITelemetryService),G(6,S.IStorageService),G(7,i.IUserDataSyncEnablementService),G(8,y.IUserDataProfilesService)],t),e.UserDataSyncService=t;class r extends A.Disposable{constructor(_,M,U,D,F,$,j){super(),this.id=_,this.manifest=M,this.syncHeaders=U,this.synchronisers=D,this.onStop=F,this.configurationService=$,this.logService=j,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new T.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(_=>_.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(_=>_.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,n.createCancelablePromise)(_=>this.getPreviews(_))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(_){throw this.logService.error(_),_}}async accept(_,M){try{return await this.performAction(_,U=>U.accept(_,M))}catch(U){throw this.logService.error(U),U}}async merge(_){try{return _?await this.performAction(_,M=>M.merge(_)):await this.mergeAll()}catch(M){throw this.logService.error(M),M}}async discard(_){try{return await this.performAction(_,M=>M.discard(_))}catch(M){throw this.logService.error(M),M}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const _=[];for(const[,M]of this.previews)for(const U of M.resourcePreviews)U.mergeState==="conflict"&&_.push(U.previewResource);for(const M of _)await this.discard(M);return this.previews}catch(_){throw this.logService.error(_),_}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const _=[];for(const[M,U]of this.previews){this.synchronizingResources.push([M,U.resourcePreviews.map($=>$.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const D=this.synchronisers.find($=>$.resource===M);for(const $ of U.resourcePreviews)($.localChange!==0||$.remoteChange!==0)&&$.mergeState==="preview"&&await D.merge($.previewResource);const F=await D.apply(!1,this.syncHeaders);F&&_.push(this.toSyncResourcePreview(D.resource,F)),this.synchronizingResources.splice(this.synchronizingResources.findIndex($=>$[0]===M),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=_,this.previews}catch(_){throw this.logService.error(_),_}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[_,M]of this.previews){this.synchronizingResources.push([_,M.resourcePreviews.map(D=>D.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const U=this.synchronisers.find(D=>D.resource===_);for(const D of M.resourcePreviews)await U.accept(D.remoteResource);await U.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(D=>D[0]===_),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(_){throw this.logService.error(_),_}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[_,M]of this.previews){this.synchronizingResources.push([_,M.resourcePreviews.map(D=>D.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const U=this.synchronisers.find(D=>D.resource===_);for(const D of M.resourcePreviews)await U.accept(D.localResource);await U.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(D=>D[0]===_),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(_){throw this.logService.error(_),_}}async stop(){await this.onStop(),this.reset()}async performAction(_,M){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const U=this.previews.findIndex(([,q])=>q.resourcePreviews.some(({localResource:B,previewResource:Y,remoteResource:te})=>(0,I.isEqual)(_,B)||(0,I.isEqual)(_,Y)||(0,I.isEqual)(_,te)));if(U===-1)return this.previews;const[D,F]=this.previews[U],$=F.resourcePreviews.find(({localResource:q,remoteResource:B,previewResource:Y})=>(0,I.isEqual)(q,_)||(0,I.isEqual)(B,_)||(0,I.isEqual)(Y,_));if(!$)return this.previews;let j=this.synchronizingResources.find(q=>q[0]===D);j||(j=[D,[]],this.synchronizingResources.push(j)),j[1].some(q=>(0,I.isEqual)(q,$.localResource))||(j[1].push($.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const J=this.synchronisers.find(q=>q.resource===this.previews[U][0]),H=await M(J);H?this.previews.splice(U,1,this.toSyncResourcePreview(J.resource,H)):this.previews.splice(U,1);const K=this.synchronizingResources.findIndex(q=>q[0]===D);return this.synchronizingResources[K][1].splice(j[1].findIndex(q=>(0,I.isEqual)(q,$.localResource)),1),j[1].length||(this.synchronizingResources.splice(K,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const _=[];for(const[M,U]of this.previews){this.synchronizingResources.push([M,U.resourcePreviews.map($=>$.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const D=this.synchronisers.find($=>$.resource===M);let F=U;for(const $ of U.resourcePreviews)($.localChange!==0||$.remoteChange!==0)&&$.mergeState==="preview"&&(F=await D.merge($.previewResource));F&&_.push(this.toSyncResourcePreview(D.resource,F)),this.synchronizingResources.splice(this.synchronizingResources.findIndex($=>$[0]===M),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=_,this.previews}async getPreviews(_){const M=[],U=await this.getUserDataSyncConfiguration();for(const D of this.synchronisers){if(_.isCancellationRequested)return[];const F=await D.preview(this.manifest,U,this.syncHeaders);F&&M.push(this.toSyncResourcePreview(D.resource,F))}return M}async getUserDataSyncConfiguration(){const _=this.configurationService.getValue(i.USER_DATA_SYNC_CONFIGURATION_SCOPE),M=this.synchronisers.find(U=>U instanceof a.SettingsSynchroniser);if(M){const U=await M.getRemoteUserDataSyncConfiguration(this.manifest);return{..._,...U}}return _}toSyncResourcePreview(_,M){return[_,{isLastSyncFromCurrentMachine:M.isLastSyncFromCurrentMachine,resourcePreviews:M.resourcePreviews.map(v)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let o=class extends A.Disposable{constructor(_,M,U,D,F,$,j){super(),this.profile=_,this.userDataSyncEnablementService=M,this.instantiationService=U,this.extensionGalleryService=D,this.userDataSyncStoreManagementService=F,this.telemetryService=$,this.logService=j,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(M.onDidChangeResourceEnablement(([J,H])=>this.onDidChangeResourceEnablement(J,H))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,J])=>J.dispose())));for(const J of i.ALL_SYNC_RESOURCES)M.isResourceEnabled(J)&&this.registerSynchronizer(J)}get enabled(){return this._enabled.sort((_,M)=>_[1]-M[1]).map(([_])=>_)}get disabled(){return i.ALL_SYNC_RESOURCES.filter(_=>!this.userDataSyncEnablementService.isResourceEnabled(_))}get status(){return this._status}get conflicts(){return this._conflicts}onDidChangeResourceEnablement(_,M){M?this.registerSynchronizer(_):this.deRegisterSynchronizer(_)}registerSynchronizer(_){if(this._enabled.some(([F])=>F.resource===_))return;if(_==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const M=new A.DisposableStore,U=M.add(this.createSynchronizer(_));M.add(U.onDidChangeStatus(()=>this.updateStatus())),M.add(U.onDidChangeConflicts(()=>this.updateConflicts())),M.add(U.onDidChangeLocal(()=>this._onDidChangeLocal.fire(_)));const D=this.getOrder(_);this._enabled.push([U,D,M])}deRegisterSynchronizer(_){const M=this._enabled.findIndex(([U])=>U.resource===_);if(M!==-1){const U=this._enabled.splice(M,1);for(const[D,,F]of U){if(D.status!=="idle"){const $=D.conflicts.length>0;D.stop(),$&&this.updateConflicts(),this.updateStatus()}F.dispose()}}}createSynchronizer(_){switch(_){case"settings":return this.instantiationService.createInstance(a.SettingsSynchroniser,this.profile.settingsResource);case"keybindings":return this.instantiationService.createInstance(g.KeybindingsSynchroniser,this.profile.keybindingsResource);case"snippets":return this.instantiationService.createInstance(f.SnippetsSynchroniser,this.profile.snippetsHome);case"tasks":return this.instantiationService.createInstance(c.TasksSynchroniser,this.profile.tasksResource);case"globalState":return this.instantiationService.createInstance(p.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(C.ExtensionsSynchroniser,this.profile.extensionsResource)}}async sync(_,M,U){if(U.isCancellationRequested)return[];const D=this.enabled;if(!D.length)return[];try{const F=[],$=(0,i.createSyncHeaders)(M);for(const j of D){if(U.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(j.resource))return[];try{await j.sync(_,$)}catch(J){const H=i.UserDataSyncError.toUserDataSyncError(J);if(d(H,M,this.userDataSyncStoreManagementService,this.telemetryService),u(J))throw H;this.logService.error(J),this.logService.error(`${j.resource}: ${(0,k.toErrorMessage)(J)}`),F.push([j.resource,H])}}return F}finally{this.updateStatus()}}async stop(){for(const _ of this.enabled)try{_.status!=="idle"&&await _.stop()}catch(M){this.logService.error(M)}}async resetLocal(){for(const _ of this.enabled)try{await _.resetLocal()}catch(M){this.logService.error(`${_.resource}: ${(0,k.toErrorMessage)(M)}`),this.logService.error(M)}}setStatus(_){this._status!==_&&(this._status=_,this._onDidChangeStatus.fire(_))}updateStatus(){return this.updateConflicts(),this.enabled.some(_=>_.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(_=>_.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const _=this.enabled.filter(M=>M.status==="hasConflicts").map(M=>[M.resource,M.conflicts.map(v)]);(0,R.equals)(this._conflicts,_,([M,U],[D,F])=>M===M&&(0,R.equals)(U,F,($,j)=>(0,I.isEqual)($.previewResource,j.previewResource)))||(this._conflicts=_,this._onDidChangeConflicts.fire(_))}getOrder(_){switch(_){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};o=pe([G(1,i.IUserDataSyncEnablementService),G(2,m.IInstantiationService),G(3,w.IExtensionGalleryService),G(4,i.IUserDataSyncStoreManagementService),G(5,h.ITelemetryService),G(6,i.IUserDataSyncLogService)],o);let l=class extends o{constructor(_,M,U,D,F,$,j){super(_.defaultProfile,M,U,D,F,$,j),this._register(_.onDidChangeProfiles(()=>{(_.defaultProfile.extensionsResource&&!this.profile.extensionsResource||!_.defaultProfile.extensionsResource&&this.profile.extensionsResource)&&(this.deRegisterSynchronizer("extensions"),this.profile=_.defaultProfile,this.registerSynchronizer("extensions"))}))}};l=pe([G(0,y.IUserDataProfilesService),G(1,i.IUserDataSyncEnablementService),G(2,m.IInstantiationService),G(3,w.IExtensionGalleryService),G(4,i.IUserDataSyncStoreManagementService),G(5,h.ITelemetryService),G(6,i.IUserDataSyncLogService)],l);function u(L){if(L instanceof i.UserDataSyncError)switch(L.code){case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function d(L,_,M,U){U.publicLog2("sync/error",{code:L.code,serverCode:L instanceof i.UserDataSyncStoreError?String(L.serverCode):void 0,url:L instanceof i.UserDataSyncStoreError?L.url:void 0,resource:L.resource,executionId:_,service:M.userDataSyncStore.url.toString()})}function v(L){return{baseResource:L.baseResource,localResource:L.localResource,previewResource:L.previewResource,remoteResource:L.remoteResource,acceptedResource:L.acceptedResource,localChange:L.localChange,remoteChange:L.remoteChange,mergeState:L.mergeState}}}),define(ne[264],re([0,1,6,21,9,3,2,126,4,17,10,14,7,30,19,15,13,25,44,47,23,26]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C,p,g,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const i="sync.previous.store",s="sync.donot-make-requests-until",t="sync.user-session-id",r="sync.machine-session-id",o=100,l=1e3*60*5;let u=class extends A.Disposable{constructor(U,D,F){super(),this.productService=U,this.configurationService=D,this.storageService=F,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(F.onDidChangeValue,$=>$.key===c.SYNC_SERVICE_URL_TYPE&&$.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(U){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,U,-1,E.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(c.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(U,D){U=E.isWeb&&U?.web?{...U,...U.web}:U;const F={...U||{},...D||{}};if(F&&(0,w.isString)(F.url)&&(0,w.isObject)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every($=>Array.isArray(F.authenticationProviders[$].scopes))){const $=F,j=!!$.canSwitch&&!D?.url,J=$.url===$.insidersUrl?"insiders":"stable",H=(j?this.userDataSyncStoreType:void 0)||J,K=D?.url||(H==="insiders"?$.insidersUrl:H==="stable"?$.stableUrl:$.url);return{url:m.URI.parse(K),type:H,defaultType:J,defaultUrl:m.URI.parse($.url),stableUrl:m.URI.parse($.stableUrl),insidersUrl:m.URI.parse($.insidersUrl),canSwitch:j,authenticationProviders:Object.keys($.authenticationProviders).reduce((q,B)=>(q.push({id:B,scopes:$.authenticationProviders[B].scopes}),q),[])}}}};u=pe([G(0,p.IProductService),G(1,h.IConfigurationService),G(2,f.IStorageService)],u),e.AbstractUserDataSyncStoreManagementService=u;let d=class extends u{constructor(U,D,F){super(U,D,F);const $=this.storageService.get(i,-1);$&&(this.previousConfigurationSyncStore=JSON.parse($));const j=this.productService[c.CONFIGURATION_SYNC_STORE_KEY];j?this.storageService.store(i,JSON.stringify(j),-1,1):this.storageService.remove(i,-1)}async switch(U){U!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=U,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};d=pe([G(0,p.IProductService),G(1,h.IConfigurationService),G(2,f.IStorageService)],d),e.UserDataSyncStoreManagementService=d;let v=class extends A.Disposable{constructor(U,D,F,$,j,J,H){super(),this.requestService=F,this.logService=$,this.storageService=H,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(U),this.commonHeadersPromise=(0,a.getServiceMachineId)(j,J,H).then(K=>{const q={"X-Client-Name":`${D.applicationName}${E.isWeb?"-web":""}`,"X-Client-Version":D.version};return D.commit&&(q["X-Client-Commit"]=D.commit),q}),this.session=new _(o,l,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(U,D){this.authToken={token:U,type:D}}updateUserDataSyncStoreUrl(U){this.userDataSyncStoreUrl=U?(0,P.joinPath)(U,"v1"):void 0}initDonotMakeRequestsUntil(){const U=this.storageService.getNumber(s,-1);U&&Date.now()<U&&this.setDonotMakeRequestsUntil(new Date(U))}setDonotMakeRequestsUntil(U){this._donotMakeRequestsUntil?.getTime()!==U?.getTime()&&(this._donotMakeRequestsUntil=U,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(s,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(D=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),D).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,D=>null)):this.storageService.remove(s,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllResourceRefs(U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const D=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",U),F={},$=await this.request(D.toString(),{type:"GET",headers:F},[],n.CancellationToken.None);return(await(0,g.asJson)($)||[]).map(({url:J,created:H})=>({ref:(0,P.relativePath)(D,D.with({path:J})),created:H*1e3}))}async resolveResourceContent(U,D,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",U,D).toString();F={...F},F["Cache-Control"]="no-cache";const j=await this.request($,{type:"GET",headers:F},[],n.CancellationToken.None);return await(0,g.asTextOrError)(j)}async deleteResource(U,D){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=D!==null?(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",U,D).toString():(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",U).toString(),$={};await this.request(F,{type:"DELETE",headers:$},[],n.CancellationToken.None)}async readResource(U,D,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",U,"latest").toString();F={...F},F["Cache-Control"]="no-cache",D&&(F["If-None-Match"]=D.ref);const j=await this.request($,{type:"GET",headers:F},[304],n.CancellationToken.None);let J=null;if(j.res.statusCode===304&&(J=D),J===null){const H=j.res.headers.etag;if(!H)throw new c.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",j.res.statusCode,j.res.headers[c.HEADER_OPERATION_ID]);const K=await(0,g.asTextOrError)(j);if(!K&&j.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",$,"EmptyResponse",j.res.statusCode,j.res.headers[c.HEADER_OPERATION_ID]);J={ref:H,content:K}}return J}async writeResource(U,D,F,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource",U).toString();$={...$},$["Content-Type"]=I.Mimes.text,F&&($["If-Match"]=F);const J=await this.request(j,{type:"POST",data:D,headers:$},[],n.CancellationToken.None),H=J.res.headers.etag;if(!H)throw new c.UserDataSyncStoreError("Server did not return the ref",j,"NoRef",J.res.statusCode,J.res.headers[c.HEADER_OPERATION_ID]);return H}async manifest(U,D={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,P.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();D={...D},D["Content-Type"]="application/json",U&&(D["If-None-Match"]=U.ref);const $=await this.request(F,{type:"GET",headers:D},[304],n.CancellationToken.None);let j=null;if($.res.statusCode===304&&(j=U),!j){const H=$.res.headers.etag;if(!H)throw new c.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);const K=await(0,g.asTextOrError)($);if(!K&&$.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",F,"EmptyResponse",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);K&&(j={...JSON.parse(K),ref:H})}const J=this.storageService.get(t,-1);return J&&j&&J!==j.session&&this.clearSession(),j===null&&J&&this.clearSession(),j&&this.storageService.store(t,j.session,-1,1),j}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,P.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),D={"Content-Type":I.Mimes.text};await this.request(U,{type:"DELETE",headers:D},[],n.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(t,-1),this.storageService.remove(r,-1)}async request(U,D,F,$){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",U,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${D.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const j=await this.commonHeadersPromise;D.headers={...D.headers||{},...j,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(D.headers),this.logService.trace("Sending request to server",{url:U,type:D.type,headers:{...D.headers,authorization:void 0}});let J;try{J=await this.session.request(U,D,$)}catch(B){if(!(B instanceof c.UserDataSyncStoreError)){let Y="RequestFailed";const te=(0,k.getErrorMessage)(B).toLowerCase();te.includes("xhr timeout")?Y="RequestTimeout":te.includes("protocol")&&te.includes("not supported")?Y="RequestProtocolNotSupported":te.includes("request path contains unescaped characters")?Y="RequestPathNotEscaped":te.includes("headers must be an object")?Y="RequestHeadersNotObject":(0,k.isCancellationError)(B)&&(Y="RequestCanceled"),B=new c.UserDataSyncStoreError(`Connection refused for the request '${U}'.`,U,Y,void 0,void 0)}throw this.logService.info("Request failed",U),B}const H=J.res.headers[c.HEADER_OPERATION_ID],K={url:U,status:J.res.statusCode,"execution-id":D.headers[c.HEADER_EXECUTION_ID],"operation-id":H},q=(0,g.isSuccess)(J)||J.res.statusCode&&F.indexOf(J.res.statusCode)!==-1;if(q?this.logService.trace("Request succeeded",K):this.logService.info("Request failed",K),J.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new c.UserDataSyncStoreError(`Request '${U}' failed because of Unauthorized (401).`,U,"Unauthorized",J.res.statusCode,H);if(this._onTokenSucceed.fire(),J.res.statusCode===409)throw new c.UserDataSyncStoreError(`${D.type} request '${U}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,U,"Conflict",J.res.statusCode,H);if(J.res.statusCode===410)throw new c.UserDataSyncStoreError(`${D.type} request '${U}' failed because the requested resource is not longer available (410).`,U,"Gone",J.res.statusCode,H);if(J.res.statusCode===412)throw new c.UserDataSyncStoreError(`${D.type} request '${U}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,U,"PreconditionFailed",J.res.statusCode,H);if(J.res.statusCode===413)throw new c.UserDataSyncStoreError(`${D.type} request '${U}' failed because of too large payload (413).`,U,"TooLarge",J.res.statusCode,H);if(J.res.statusCode===426)throw new c.UserDataSyncStoreError(`${D.type} request '${U}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,U,"UpgradeRequired",J.res.statusCode,H);if(J.res.statusCode===429){const B=J.res.headers["retry-after"];throw B?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(B)*1e3)),new c.UserDataSyncStoreError(`${D.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",J.res.statusCode,H)):new c.UserDataSyncStoreError(`${D.type} request '${U}' failed because of too many requests (429).`,U,"RemoteTooManyRequests",J.res.statusCode,H)}if(!q)throw new c.UserDataSyncStoreError("Server returned "+J.res.statusCode,U,"Unknown",J.res.statusCode,H);return J}addSessionHeaders(U){let D=this.storageService.get(r,-1);D===void 0&&(D=(0,S.generateUuid)(),this.storageService.store(r,D,-1,1)),U["X-Machine-Session-Id"]=D;const F=this.storageService.get(t,-1);F!==void 0&&(U["X-User-Session-Id"]=F)}};v=pe([G(1,p.IProductService),G(2,g.IRequestService),G(3,c.IUserDataSyncLogService),G(4,y.IEnvironmentService),G(5,C.IFileService),G(6,f.IStorageService)],v),e.UserDataSyncStoreClient=v;let L=class extends v{constructor(U,D,F,$,j,J,H){super(U.userDataSyncStore?.url,D,F,$,j,J,H),this._register(U.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(U.userDataSyncStore?.url)))}getAllRefs(U,D){return this.getAllResourceRefs(D?this.getProfileResource(U,D):U)}read(U,D,F,$){return this.readResource(F?this.getProfileResource(U,F):U,D,$)}write(U,D,F,$,j){return this.writeResource($?this.getProfileResource(U,$):U,D,F,j)}delete(U,D,F){return this.deleteResource(F?this.getProfileResource(U,F):U,D)}resolveContent(U,D,F,$){return this.resolveResourceContent(F?this.getProfileResource(U,F):U,D,$)}getProfileResource(U,D){if(U==="profiles")throw new Error(`Invalid Resource Argument: ${U}`);return(0,b.join)("profiles",D,U)}};L=pe([G(0,c.IUserDataSyncStoreManagementService),G(1,p.IProductService),G(2,g.IRequestService),G(3,c.IUserDataSyncLogService),G(4,y.IEnvironmentService),G(5,C.IFileService),G(6,f.IStorageService)],L),e.UserDataSyncStoreService=L;class _{constructor(U,D,F,$){this.limit=U,this.interval=D,this.requestService=F,this.logService=$,this.requests=[],this.startTime=void 0}request(U,D,F){if(this.isExpired()&&this.reset(),D.url=U,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,U,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(U),this.requestService.request(D,F)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=_}),define(ne[265],re([0,1,3,58,25,23,22,262,26,71,74]),function(Q,e,R,n,k,T,A,I,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=class extends I.UserDataAutoSyncService{constructor(S,h,y,C,p,g,a,f,c,i,s){super(S,h,y,C,p,a,f,c,i,s),this._register(R.Event.debounce(R.Event.any(R.Event.map(g.onDidFocusWindow,()=>"windowFocus"),R.Event.map(g.onDidOpenWindow,()=>"windowOpen")),(t,r)=>t?[...t,r]:[r],1e3)(t=>this.triggerSync(t,!0,!1)))}};w=pe([G(0,k.IProductService),G(1,E.IUserDataSyncStoreManagementService),G(2,E.IUserDataSyncStoreService),G(3,E.IUserDataSyncEnablementService),G(4,E.IUserDataSyncService),G(5,n.INativeHostService),G(6,E.IUserDataSyncLogService),G(7,P.IUserDataSyncAccountService),G(8,A.ITelemetryService),G(9,b.IUserDataSyncMachinesService),G(10,T.IStorageService)],w),e.UserDataAutoSyncService=w}),define(ne[266],re([0,1,93,20,4,17]),function(Q,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function A(P){function b(){let w=P.scheme===n.Schemas.file?(0,T.originalFSPath)(P):P.toString();return k.isLinux||(w=w.toLowerCase()),(0,R.createHash)("md5").update(w).digest("hex")}return{id:b(),configPath:P}}e.getWorkspaceIdentifier=A;function I(P,b){function w(){if(P.scheme!==n.Schemas.file)return(0,R.createHash)("md5").update(P.toString()).digest("hex");if(!b)return;let S;return k.isLinux?S=b.ino:k.isMacintosh?S=b.birthtime.getTime():k.isWindows&&(typeof b.birthtimeMs=="number"?S=Math.floor(b.birthtimeMs):S=b.birthtime.getTime()),(0,R.createHash)("md5").update(P.fsPath).update(S?String(S):"").digest("hex")}const m=w();if(typeof m=="string")return{id:m,uri:P}}e.getSingleFolderWorkspaceIdentifier=I;function E(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=E}),define(ne[267],re([0,1,6,9,2,10,27,15,67,8,58,102,110,266]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let h=class extends k.Disposable{constructor(C,p,g,a){super(),this.environmentService=C,this.logService=p,this.nativeHostService=g,this.mainProcessService=a,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const C=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),p=new w.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(C.map(async g=>{const a=(0,T.join)(this.environmentService.workspaceStorageHome.fsPath,g);g.length===S.NON_EMPTY_WORKSPACE_ID_LENGTH||g===m.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(i=>i.workspace?.id===g)||await p.isUsed(a)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${g} as it seems to be an unused empty workspace.`),await A.Promises.rm(a))}))}catch(C){(0,n.onUnexpectedError)(C)}}};h=pe([G(0,I.INativeEnvironmentService),G(1,P.ILogService),G(2,b.INativeHostService),G(3,E.IMainProcessService)],h),e.UnusedWorkspaceStorageDataCleaner=h}),define(ne[111],re([0,1,53,6,10,14,27,138,276,277]),function(Q,e,R,n,k,T,A,I,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class b extends Error{constructor(i,s){let t=s.message;switch(i){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=i,this.cause=s}}e.ExtractError=b;function w(c){const i=c.externalFileAttributes>>16||33188;return[448,56,7].map(s=>i&s).reduce((s,t)=>s+t,i&61440)}function m(c){if(c instanceof b)return c;let i;return/end of central directory record signature not found/.test(c.message)&&(i="CorruptZip"),new b(i,c)}function S(c,i,s,t,r,o){const l=k.dirname(i),u=k.join(t,l);if(!u.startsWith(t))return Promise.reject(new Error(I.localize(0,null,i)));const d=k.join(t,i);let v;return o.onCancellationRequested(()=>{v?.destroy()}),Promise.resolve(A.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((L,_)=>{if(!o.isCancellationRequested)try{v=(0,R.createWriteStream)(d,{mode:s}),v.once("close",()=>L()),v.once("error",_),c.once("error",_),c.pipe(v)}catch(M){_(M)}}))}function h(c,i,s,t){let r=(0,n.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{r.cancel(),c.close()}),new Promise((l,u)=>{const d=new n.Sequencer,v=L=>{L.isCancellationRequested||(o++,c.readEntry())};c.once("error",u),c.once("close",()=>r.then(()=>{t.isCancellationRequested||c.entryCount===o?l():u(new b("Incomplete",new Error(I.localize(1,null,o,c.entryCount))))},u)),c.readEntry(),c.on("entry",L=>{if(t.isCancellationRequested)return;if(!s.sourcePathRegex.test(L.fileName)){v(t);return}const _=L.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(_)){const D=k.join(i,_);r=(0,n.createCancelablePromise)(F=>A.Promises.mkdir(D,{recursive:!0}).then(()=>v(F)).then(void 0,u));return}const M=C(c,L),U=w(L);r=(0,n.createCancelablePromise)(D=>d.queue(()=>M.then(F=>S(F,_,U,i,s,D).then(()=>v(D)))).then(null,u))})})}function y(c,i=!1){return new Promise((s,t)=>{(0,E.open)(c,i?{lazyEntries:!0}:void 0,(r,o)=>{r?t(m(r)):s((0,T.assertIsDefined)(o))})})}function C(c,i){return new Promise((s,t)=>{c.openReadStream(i,(r,o)=>{r?t(m(r)):s((0,T.assertIsDefined)(o))})})}function p(c,i){return new Promise((s,t)=>{const r=new P.ZipFile;i.forEach(l=>{l.contents?r.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&r.addFile(l.localPath,l.path)}),r.end();const o=(0,R.createWriteStream)(c);r.outputStream.pipe(o),r.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>s(c))})}e.zip=p;function g(c,i,s={},t){const r=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let o=y(c,!0);return s.overwrite&&(o=o.then(l=>A.Promises.rm(i).then(()=>l))),o.then(l=>h(l,i,{sourcePathRegex:r},t))}e.extract=g;function a(c,i){return y(c).then(s=>new Promise((t,r)=>{s.on("entry",o=>{o.fileName===i&&C(s,o).then(l=>t(l),l=>r(l))}),s.once("close",()=>r(new Error(I.localize(2,null,i))))}))}function f(c,i){return a(c,i).then(s=>new Promise((t,r)=>{const o=[];s.once("error",r),s.on("data",l=>o.push(l)),s.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=f}),define(ne[268],re([0,1,111,148]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(T){return(0,R.buffer)(T,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=k}),define(ne[112],re([0,1,6,38,9,2,20,10,4,17,55,14,7,30,27,111,147,91,15,247,29,32,48,72,202,248,268,203,233,43,66,13,5,8,25,22,33,28]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C,p,g,a,f,c,i,s,t,r,o,l,u,d,v,L,_,M,U,D,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,_.refineServiceDecorator)(f.IExtensionManagementService);let j=class extends a.AbstractExtensionManagementService{constructor(z,V,O,N,W,x,Z,oe,X,ie,se,ue){super(z,V,O,ie,ue),this.extensionsScannerService=W,this.extensionsProfileScannerService=x,this.downloadService=Z,this.fileService=X,this.installGalleryExtensionsTasks=new Map;const he=this._register(oe.createInstance(r.ExtensionsLifecycle));this.extensionsScanner=this._register(oe.createInstance(J,we=>he.postUninstall(we))),this.manifestCache=this._register(new l.ExtensionsManifestCache(N,this)),this.extensionsDownloader=this._register(oe.createInstance(t.ExtensionsDownloader));const ve=this._register(new u.ExtensionsWatcher(this,X,N,O,se));this._register(ve.onDidChangeExtensionsByAnotherSource(({added:we,removed:Ee})=>{we.length&&this._onDidInstallExtensions.fire(we.map(Pe=>({identifier:Pe.identifier,operation:1,local:Pe}))),Ee.forEach(Pe=>this._onDidUninstallExtension.fire({identifier:Pe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,c.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(z){this.logService.trace("ExtensionManagementService#zip",z.identifier.id);const V=await this.collectFiles(z),O=await(0,y.zip)((0,P.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,S.generateUuid)()).fsPath,V);return m.URI.file(O)}async unzip(z){return this.logService.trace("ExtensionManagementService#unzip",z.toString()),(await this.install(z)).identifier}async getManifest(z){const{location:V,cleanup:O}=await this.downloadVsix(z),N=I.resolve(V.fsPath);try{return await(0,o.getManifest)(N)}finally{await O()}}getInstalled(z,V){return this.extensionsScanner.scanExtensions(z??null,V)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(z,V={}){this.logService.trace("ExtensionManagementService#install",z.toString());const{location:O,cleanup:N}=await this.downloadVsix(z);try{const W=await(0,o.getManifest)(I.resolve(O.fsPath));if(W.engines&&W.engines.vscode&&!(0,v.isEngineValid)(W.engines.vscode,this.productService.version,this.productService.date))throw new Error(C.localize(0,null,(0,c.getGalleryExtensionId)(W.publisher,W.name),this.productService.version));return await this.installExtension(W,O,V)}finally{await N()}}getMetadata(z){return this.extensionsScannerService.scanMetadata(z.location)}async updateMetadata(z,V){this.logService.trace("ExtensionManagementService#updateMetadata",z.identifier.id);const O={...V};return V.isPreReleaseVersion&&(O.preRelease=!0),z=await this.extensionsScanner.updateMetadata(z,O),this.manifestCache.invalidate(),z}async updateExtensionScope(z,V){return this.logService.trace("ExtensionManagementService#updateExtensionScope",z.identifier.id),z=await this.extensionsScanner.updateMetadata(z,{isMachineScoped:V}),this.manifestCache.invalidate(),z}removeUninstalledExtensions(z){return this.extensionsScanner.cleanUp(z)}async downloadVsix(z){if(z.scheme===A.Schemas.file)return{location:z,async cleanup(){}};this.logService.trace("Downloading extension from",z.toString());const V=(0,P.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,S.generateUuid)());return await this.downloadService.download(z,V),this.logService.info("Downloaded extension to",V.toString()),{location:V,cleanup:async()=>{try{await this.fileService.del(V)}catch(N){this.logService.error(N)}}}}doCreateInstallExtensionTask(z,V,O){let N;if(m.URI.isUri(V))N=new q(z,V,O,this.galleryService,this.extensionsScanner,this.logService);else{const W=c.ExtensionKey.create(V).toString();N=this.installGalleryExtensionsTasks.get(W),N||(this.installGalleryExtensionsTasks.set(W,N=new K(z,V,O,this.extensionsDownloader,this.extensionsScanner,this.logService)),N.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(W)))}return O.profileLocation?new B(N,O.profileLocation,this.extensionsProfileScannerService):N}doCreateUninstallExtensionTask(z,V){return V.profileLocation?new te(z,V.profileLocation,this.extensionsProfileScannerService):new Y(z,V,this.extensionsScanner)}async collectFiles(z){const V=async N=>{let W=await h.Promises.readdir(N);W=W.map(oe=>I.join(N,oe));const x=await Promise.all(W.map(oe=>h.Promises.stat(oe)));let Z=Promise.resolve([]);return x.forEach((oe,X)=>{const ie=W[X];oe.isFile()&&(Z=Z.then(se=>[...se,ie])),oe.isDirectory()&&(Z=Z.then(se=>V(ie).then(ue=>[...se,...ue])))}),Z};return(await V(z.location.fsPath)).map(N=>({path:`extension/${I.relative(z.location.fsPath,N)}`,localPath:N}))}};j=pe([G(0,f.IExtensionGalleryService),G(1,D.ITelemetryService),G(2,M.ILogService),G(3,g.INativeEnvironmentService),G(4,s.IExtensionsScannerService),G(5,i.IExtensionsProfileScannerService),G(6,p.IDownloadService),G(7,_.IInstantiationService),G(8,L.IFileService),G(9,U.IProductService),G(10,F.IUriIdentityService),G(11,$.IUserDataProfilesService)],j),e.ExtensionManagementService=j;let J=class extends T.Disposable{constructor(z,V,O,N){super(),this.beforeRemovingExtension=z,this.fileService=V,this.extensionsScannerService=O,this.logService=N,this.uninstalledPath=(0,P.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new R.Queue}async cleanUp(z){await this.removeUninstalledExtensions(),z&&await this.removeOutdatedExtensions()}async scanExtensions(z,V){const O={includeInvalid:!0,profileLocation:V};let N=[];return z===null||z===0?N.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},O,!1)):z===1&&N.push(...await this.extensionsScannerService.scanUserExtensions(O)),N=z!==null?N.filter(W=>W.type===z):N,Promise.all(N.map(W=>this.toLocalExtension(W)))}async scanUserExtensions(z){const V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!z,includeInvalid:!0});return Promise.all(V.map(O=>this.toLocalExtension(O)))}async extractUserExtension(z,V,O,N){const W=z.toString(),x=I.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,S.generateUuid)()}`),Z=I.join(this.extensionsScannerService.userExtensionsLocation.fsPath,W);try{await h.Promises.rm(Z)}catch{throw new f.ExtensionManagementError(C.localize(1,null,Z,z.id),f.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(z,V,x,N),O={...O,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(m.URI.file(x),O);try{await this.rename(z,x,Z,Date.now()+2*60*1e3),this.logService.info("Renamed to",Z)}catch(oe){try{await h.Promises.rm(x)}catch{}if(oe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",z.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(oe)}. Deleted from extracted location`,x),oe}return this.scanLocalExtension(m.URI.file(Z),1)}async updateMetadata(z,V){return await this.extensionsScannerService.updateMetadata(z.location,V),this.scanLocalExtension(z.location,z.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...z){const V=z.map(O=>c.ExtensionKey.create(O));await this.withUninstalledExtensions(O=>{V.forEach(N=>O[N.toString()]=!0)})}async setInstalled(z){await this.withUninstalledExtensions(N=>delete N[z.toString()]);const O=(await this.scanUserExtensions(!0)).find(N=>c.ExtensionKey.create(N).equals(z))||null;return O?this.updateMetadata(O,{installedTimestamp:Date.now()}):null}async removeExtension(z,V){this.logService.trace(`Deleting ${V} extension from disk`,z.identifier.id,z.location.fsPath),await h.Promises.rm(z.location.fsPath),this.logService.info("Deleted from disk",z.identifier.id,z.location.fsPath)}async removeUninstalledExtension(z){await this.removeExtension(z,"uninstalled"),await this.withUninstalledExtensions(V=>delete V[c.ExtensionKey.create(z).toString()])}async withUninstalledExtensions(z){return this.uninstalledFileLimiter.queue(async()=>{let V;try{V=await h.Promises.readFile(this.uninstalledPath,"utf8")}catch(N){if(N.code!=="ENOENT")throw N}let O={};if(V)try{O=JSON.parse(V)}catch{}return z&&(z(O),Object.keys(O).length?await h.Promises.writeFile(this.uninstalledPath,JSON.stringify(O)):await h.Promises.rm(this.uninstalledPath)),O})}async extractAtLocation(z,V,O,N){this.logService.trace(`Started extracting the extension from ${V} to ${O}`);try{await h.Promises.rm(O)}catch(W){throw new f.ExtensionManagementError(this.joinErrors(W).message,f.ExtensionManagementErrorCode.Delete)}try{await(0,y.extract)(V,O,{sourcePath:"extension",overwrite:!0},N),this.logService.info(`Extracted extension to ${O}:`,z.id)}catch(W){try{await h.Promises.rm(O)}catch{}let x=f.ExtensionManagementErrorCode.Extract;throw W instanceof y.ExtractError&&(W.type==="CorruptZip"?x=f.ExtensionManagementErrorCode.CorruptZip:W.type==="Incomplete"&&(x=f.ExtensionManagementErrorCode.IncompleteZip)),new f.ExtensionManagementError(W.message,x)}}async rename(z,V,O,N){try{await h.Promises.rename(V,O)}catch(W){if(E.isWindows&&W&&W.code==="EPERM"&&Date.now()<N)return this.logService.info(`Failed renaming ${V} to ${O} with 'EPERM' error. Trying again...`,z.id),this.rename(z,V,O,N);throw new f.ExtensionManagementError(W.message||C.localize(2,null,V,O),W.code||f.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(z,V){const O=await this.extensionsScannerService.scanExistingExtension(z,V,{includeInvalid:!0});if(O)return this.toLocalExtension(O);throw new Error(C.localize(3,null,z.path))}async toLocalExtension(z){const V=await this.fileService.resolve(z.location);let O,N;return V.children&&(O=V.children.find(({name:W})=>/^readme(\.txt|\.md|)$/i.test(W))?.resource,N=V.children.find(({name:W})=>/^changelog(\.txt|\.md|)$/i.test(W))?.resource),{identifier:z.identifier,type:z.type,isBuiltin:z.isBuiltin||!!z.metadata?.isBuiltin,location:z.location,manifest:z.manifest,targetPlatform:z.targetPlatform,validations:z.validations,isValid:z.isValid,readmeUrl:O,changelogUrl:N,publisherDisplayName:z.metadata?.publisherDisplayName||null,publisherId:z.metadata?.publisherId||null,isApplicationScoped:!!z.metadata?.isApplicationScoped,isMachineScoped:!!z.metadata?.isMachineScoped,isPreReleaseVersion:!!z.metadata?.isPreReleaseVersion,preRelease:!!z.metadata?.preRelease,installedTimestamp:z.metadata?.installedTimestamp,updated:!!z.metadata?.updated}}async removeUninstalledExtensions(){const z=await this.getUninstalledExtensions(),V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=new Set;for(const x of V)z[c.ExtensionKey.create(x).toString()]||O.add(x.identifier.id.toLowerCase());const N=(0,c.groupByExtension)(V,x=>x.identifier);await R.Promises.settled(N.map(async x=>{const Z=x.sort((oe,X)=>b.rcompare(oe.manifest.version,X.manifest.version))[0];O.has(Z.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(Z))}));const W=V.filter(x=>z[c.ExtensionKey.create(x).toString()]);await R.Promises.settled(W.map(x=>this.removeUninstalledExtension(x)))}async removeOutdatedExtensions(){const z=await this.extensionsScannerService.scanSystemExtensions({}),V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=[],N=await this.extensionsScannerService.getTargetPlatform(),W=(0,c.groupByExtension)(V,x=>x.identifier);for(const x of W)if(x.length>1&&O.push(...x.sort((Z,oe)=>{const X=b.rcompare(Z.manifest.version,oe.manifest.version);return X!==0?X:Z.targetPlatform===N?-1:1}).slice(1)),x[0].type===0){const Z=z.find(oe=>(0,c.areSameExtensions)(oe.identifier,x[0].identifier));(!Z||b.gte(Z.manifest.version,x[0].manifest.version))&&O.push(x[0])}await R.Promises.settled(O.map(x=>this.removeExtension(x,"outdated")))}joinErrors(z){const V=Array.isArray(z)?z:[z];return V.length===1?V[0]instanceof Error?V[0]:new Error(V[0]):V.reduce((O,N)=>new Error(`${O.message}${O.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}};J=pe([G(1,L.IFileService),G(2,s.IExtensionsScannerService),G(3,M.ILogService)],J);class H extends a.AbstractExtensionTask{constructor(z,V,O,N,W){super(),this.identifier=z,this.source=V,this.options=O,this.extensionsScanner=N,this.logService=W,this._operation=2}get operation(){return(0,w.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(z,V){try{const O=await this.unsetUninstalledAndGetLocal(z.key);if(O)return z.metadata?this.extensionsScanner.updateMetadata(O,z.metadata):O}catch{throw E.isMacintosh?new f.ExtensionManagementError(C.localize(4,null),f.ExtensionManagementErrorCode.Internal):new f.ExtensionManagementError(C.localize(5,null),f.ExtensionManagementErrorCode.Internal)}return this.extract(z,V)}async unsetUninstalledAndGetLocal(z){if(!await this.isUninstalled(z))return null;this.logService.trace("Removing the extension from uninstalled list:",z.id);const O=await this.extensionsScanner.setInstalled(z);return this.logService.info("Removed the extension from uninstalled list:",z.id),O}async isUninstalled(z){return!!(await this.extensionsScanner.getUninstalledExtensions())[z.toString()]}async extract({zipPath:z,key:V,metadata:O},N){const W=await this.extensionsScanner.extractUserExtension(V,z,O,N);return this.logService.info("Extracting completed.",V.id),W}}class K extends H{constructor(z,V,O,N,W,x){super(V.identifier,V,O,W,x),this.manifest=z,this.gallery=V,this.extensionsDownloader=N}async doRun(z){const O=(await this.extensionsScanner.scanExtensions(null,void 0)).find(x=>(0,c.areSameExtensions)(x.identifier,this.gallery.identifier));O&&(this._operation=3);const N={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,d.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,isSystem:O?.type===0?!0:void 0,updated:!!O,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,w.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:O?.preRelease)};if(O?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(O,N),metadata:N};const W=await this.downloadExtension(this.gallery,this._operation);try{const x=await this.installExtension({zipPath:W,key:c.ExtensionKey.create(this.gallery),metadata:N},z);return O&&!this.options.profileLocation&&(O.targetPlatform!==x.targetPlatform||b.neq(O.manifest.version,x.manifest.version))&&await this.extensionsScanner.setUninstalled(O),{local:x,metadata:N}}catch(x){throw await this.deleteDownloadedVSIX(W),x}}async deleteDownloadedVSIX(z){try{await this.extensionsDownloader.delete(m.URI.file(z))}catch(V){this.logService.warn("Error while deleting the downloaded vsix",z.toString(),(0,k.getErrorMessage)(V))}}async downloadExtension(z,V){let O;try{this.logService.trace("Started downloading extension:",z.identifier.id),O=(await this.extensionsDownloader.downloadExtension(z,V)).fsPath,this.logService.info("Downloaded extension:",z.identifier.id,O)}catch(N){throw new f.ExtensionManagementError((0,a.joinErrors)(N).message,f.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(O),O}catch(N){throw await this.deleteDownloadedVSIX(O),new f.ExtensionManagementError((0,a.joinErrors)(N).message,f.ExtensionManagementErrorCode.Invalid)}}}class q extends H{constructor(z,V,O,N,W,x){super({id:(0,c.getGalleryExtensionId)(z.publisher,z.name)},V,O,W,x),this.manifest=z,this.location=V,this.galleryService=N}async doRun(z){const V=new c.ExtensionKey(this.identifier,this.manifest.version),N=(await this.extensionsScanner.scanExtensions(1,void 0)).find(Z=>(0,c.areSameExtensions)(this.identifier,Z.identifier)),W=await this.getMetadata(this.identifier.id,this.manifest.version,z);if(W.isApplicationScoped=(0,d.isApplicationScopedExtension)(this.manifest),W.isMachineScoped=this.options.isMachineScoped||N?.isMachineScoped,W.isBuiltin=this.options.isBuiltin||N?.isBuiltin,N)if(this._operation=3,V.equals(new c.ExtensionKey(N.identifier,N.manifest.version)))try{await this.extensionsScanner.removeExtension(N,"existing")}catch{throw new Error(C.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&b.gt(N.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(N);else{const Z=await this.unsetUninstalledAndGetLocal(V);if(Z)try{await this.extensionsScanner.removeExtension(Z,"existing")}catch{throw new Error(C.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:I.resolve(this.location.fsPath),key:V,metadata:W},z),metadata:W}}async getMetadata(z,V,O){try{let[N]=await this.galleryService.getExtensions([{id:z,version:V}],O);if(N||([N]=await this.galleryService.getExtensions([{id:z}],O)),N)return{id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId,isPreReleaseVersion:N.properties.isPreReleaseVersion,preRelease:N.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class B{constructor(z,V,O){this.task=z,this.profileLocation=V,this.extensionsProfileScannerService=O,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const z=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[z.local,z.metadata]],this.profileLocation),z}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class Y extends a.AbstractExtensionTask{constructor(z,V,O){super(),this.extension=z,this.options=V,this.extensionsScanner=O}async doRun(z){const V=[],O=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const N=c.ExtensionKey.create(this.extension);V.push(...O.filter(W=>N.equals(c.ExtensionKey.create(W))))}else V.push(...O.filter(N=>(0,c.areSameExtensions)(N.identifier,this.extension.identifier)));if(!V.length)throw new Error(C.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...V),this.options.remove)for(const N of V)try{z.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(N)}catch(W){throw new Error(C.localize(9,null,(0,n.toErrorMessage)(W)))}}}class te extends a.AbstractExtensionTask{constructor(z,V,O){super(),this.extension=z,this.profileLocation=V,this.extensionsProfileScannerService=O}async doRun(z){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(ne[269],re([0,1,2,29,32,48,73,201,112,43,5,8,23,33,28]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const y={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let C=class extends R.Disposable{constructor(a,f,c,i,s,t,r,o){super(),this.userDataProfilesService=f,a.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===1),(0,I.migrateUnsupportedExtensions)(a,c,i,s,o),A.ExtensionStorageService.removeOutdatedExtensionVersions(a,r),this._register(t.createInstance(p))}};C=pe([G(0,E.INativeServerExtensionManagementService),G(1,h.IUserDataProfilesService),G(2,n.IExtensionGalleryService),G(3,A.IExtensionStorageService),G(4,n.IGlobalExtensionEnablementService),G(5,b.IInstantiationService),G(6,m.IStorageService),G(7,w.ILogService)],C),e.ExtensionsCleaner=C;let p=class extends R.Disposable{constructor(a,f,c,i,s){super(),this.extensionManagementService=a,this.userDataProfilesService=f,this.extensionsProfileScannerService=c,this.uriIdentityService=i,this.logService=s,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new R.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:a,removed:f,all:c}){try{await Promise.all(f.map(i=>i.extensionsResource?this.removeExtensionsFromProfile(i.extensionsResource):Promise.resolve()))}catch(i){this.logService.error(i)}if(c.length===1){this.profileModeDisposables.clear();const i=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{i.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{a.length&&(await Promise.all(a.map(i=>i.extensionsResource?this.populateExtensionsFromProfile(i.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new R.DisposableStore,this.profileModeDisposables.value.add((0,R.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(i=>this.onDidChangeProfiles(i))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(i=>this.onDidUninstallExtension(i))),await this.uninstallExtensionsNotInProfiles()))}catch(i){this.logService.error(i)}}async uninstallExtensionsNotInProfiles(){const f=(await this.extensionManagementService.getAllUserInstalled()).filter(c=>!this.profileExtensionsLocations.has(this.getKey(c.identifier,c.manifest.version)));f.length&&await Promise.all(f.map(c=>this.extensionManagementService.uninstall(c,y)))}async onDidInstallExtensions(a){for(const{local:f,profileLocation:c}of a)!f||!c||this.addExtensionWithKey(this.getKey(f.identifier,f.manifest.version),c)}async onDidUninstallExtension(a){!a.profileLocation||!a.version||this.removeExtensionWithKey(this.getKey(a.identifier,a.version),a.profileLocation)&&await this.uninstallExtensions([{identifier:a.identifier,version:a.version}])}async populateExtensionsFromProfile(a){const f=await this.extensionsProfileScannerService.scanProfileExtensions(a);for(const c of f)this.addExtensionWithKey(this.getKey(c.identifier,c.version),a)}async removeExtensionsFromProfile(a){const f=[];for(const c of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(c,a))continue;const i=this.fromKey(c);i&&f.push(i)}f.length&&await this.uninstallExtensions(f)}addExtensionWithKey(a,f){let c=this.profileExtensionsLocations.get(a);c||(c=[],this.profileExtensionsLocations.set(a,c)),c.push(f)}removeExtensionWithKey(a,f){const c=this.profileExtensionsLocations.get(a);if(c){const i=c.findIndex(s=>this.uriIdentityService.extUri.isEqual(s,f));i>-1&&c.splice(i,1)}return c?.length?!1:(this.profileExtensionsLocations.delete(a),!0)}async uninstallExtensions(a){const c=(await this.extensionManagementService.getAllUserInstalled()).filter(i=>a.some(s=>this.getKey(i.identifier,i.manifest.version)===this.getKey(s.identifier,s.version)));c.length&&await Promise.all(c.map(i=>this.extensionManagementService.uninstall(i,y)))}getKey(a,f){return`${P.ExtensionIdentifier.toKey(a.id)}@${f}`}fromKey(a){const[f,c]=(0,k.getIdAndVersion)(a);return c?{identifier:{id:f},version:c}:void 0}};p=pe([G(0,E.INativeServerExtensionManagementService),G(1,h.IUserDataProfilesService),G(2,T.IExtensionsProfileScannerService),G(3,S.IUriIdentityService),G(4,w.ILogService)],p)}),define(ne[278],re([0,1,86,37,38,9,2,20,17,7,39,136,194,269,195,187,188,267,176,179,19,199,90,218,91,209,15,215,250,251,29,178,252,112,92,174,13,190,192,56,5,185,95,186,67,68,204,8,96,58,97,25,44,23,253,103,22,104,105,106,49,222,107,224,230,73,109,26,71,241,242,243,74,261,263,244,264,265,245,101,217,70,232,206,231,100,214,33,234,4,235,180,197,196,72,249,28,48,193,59,254,212,221,246]),function(Q,e,R,n,k,T,A,I,E,P,b,w,m,S,h,y,C,p,g,a,f,c,i,s,t,r,o,l,u,d,v,L,_,M,U,D,F,$,j,J,H,K,q,B,Y,te,ce,z,V,O,N,W,x,Z,oe,X,ie,se,ue,he,ve,we,Ee,Pe,Ue,ze,Ve,We,ae,de,fe,Ce,Ie,Me,De,$e,Ae,Fe,_e,ke,ee,le,me,ge,Se,be,Re,Te,qe,Le,Ne,je,Xe,Ze,Ct,Pt,It,pt,Rt,vt,Dt,kt,Lt,Tt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class At extends A.Disposable{constructor(ye){super(),this.configuration=ye,this.server=this._register(new w.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ye=()=>this.dispose();process.once("exit",ye),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Oe="vscode:electron-main->shared-process=disposeWorker",xe=(He,et)=>{this.onDisposeWorker(et)};R.ipcRenderer.on(Oe,xe),this._register((0,A.toDisposable)(()=>R.ipcRenderer.removeListener(Oe,xe)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,We.registerConfiguration)(),ye.invokeFunction(Oe=>{const xe=Oe.get(z.ILogService);xe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(xe)}),this._register((0,A.combinedDisposable)(ye.createInstance(m.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(h.LanguagePackCachedDataCleaner),ye.createInstance(p.UnusedWorkspaceStorageDataCleaner),ye.createInstance(C.LogsDataCleaner),ye.createInstance(y.LocalizationsUpdater),ye.createInstance(S.ExtensionsCleaner),ye.createInstance(Tt.UserDataProfilesCleaner)))}async initServices(){const ye=new q.ServiceCollection,Oe={_serviceBrand:void 0,...N.default};ye.set(W.IProductService,Oe);const xe=new b.StaticRouter(Ye=>Ye==="main"),He=new B.MessagePortMainProcessService(this.server,xe);ye.set(Y.IMainProcessService,He);const et=this.configuration.policiesData?new Rt.PolicyChannelClient(this.configuration.policiesData,He.getChannel("policy")):new vt.NullPolicyService;ye.set(vt.IPolicyService,et);const Be=new l.SharedProcessEnvironmentService(this.configuration.args,Oe);ye.set(o.INativeEnvironmentService,Be);const ot=new V.LogLevelChannelClient(this.server.getChannel("logLevel",xe)),tt=new V.LoggerChannelClient(this.configuration.logLevel,ot.onDidChangeLogLevel,He.getChannel("logger"));ye.set(z.ILoggerService,tt);const lt=this._register(new z.MultiplexLogService([this._register(new z.ConsoleLogger(this.configuration.logLevel)),this._register(tt.createLogger((0,E.joinPath)(P.URI.file(Be.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new V.FollowerLogService(ot,lt));ye.set(z.ILogService,Ge),this.sharedProcessWorkerService=new Re.SharedProcessWorkerService(Ge),ye.set(be.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Je=this._register(new $.FileService(Ge));ye.set(F.IFileService,Je);const ut=this._register(new j.DiskFileSystemProvider(Ge));Je.registerProvider(I.Schemas.file,ut);const ht=this._register(new Ne.FileUserDataProvider(I.Schemas.file,this._register(new je.DiskFileSystemProviderClient(He.getChannel(je.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Le.isLinux})),I.Schemas.vscodeUserData,Ge));Je.registerProvider(I.Schemas.vscodeUserData,ht);const it=this._register(new Dt.UserDataProfilesNativeService(this.configuration.profiles,He,Be));ye.set(It.IUserDataProfilesService,it);const Ke=this._register(new c.ConfigurationService(it.defaultProfile.settingsResource,Je,et,Ge));ye.set(f.IConfigurationService,Ke);const rt=new oe.NativeStorageService(void 0,{defaultProfile:it.defaultProfile,currentProfile:it.defaultProfile},He,Be);ye.set(Z.IStorageService,rt),this._register((0,A.toDisposable)(()=>rt.flush())),await Promise.all([Ke.initialize(),rt.initialize()]),ye.set(Te.IUriIdentityService,new qe.UriIdentityService(Je)),ye.set(x.IRequestService,new kt.SharedProcessRequestService(He,Ke,Ge)),ye.set(g.IChecksumService,new J.SyncDescriptor(a.ChecksumService,void 0,!1)),ye.set(Ze.IV8InspectProfilingService,new J.SyncDescriptor(Xe.InspectProfilingService,void 0,!1));const at=b.ProxyChannel.toService(He.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(O.INativeHostService,at),ye.set(t.IDownloadService,new J.SyncDescriptor(r.DownloadService,void 0,!0));const dt=this._register(new _e.ActiveWindowManager(at)),Ot=new b.StaticRouter(Ye=>dt.getActiveClientId().then(ft=>Ye===ft));ye.set(U.IExtensionRecommendationNotificationService,new D.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Ot)));let ct;const st=[],yt=(0,ve.isInternalTelemetry)(Oe,Ke);if((0,ve.supportsTelemetry)(Oe,Be)){const Ye=new ue.TelemetryLogAppender(tt,Be);st.push(Ye);const{installSourcePath:ft}=Be;if(Oe.aiConfig?.ariaKey){const Et=new Lt.OneDataSystemAppender(yt,"monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,A.toDisposable)(()=>Et.flush())),st.push(Et)}ct=new he.TelemetryService({appenders:st,commonProperties:(0,X.resolveCommonProperties)(Je,(0,n.release)(),(0,n.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,yt,ft),sendErrorTelemetry:!0,piiPaths:(0,ve.getPiiPathsFromEnvironment)(Be)},Ke,Oe)}else{ct=ve.NullTelemetryService;const Ye=ve.NullAppender;st.push(Ye)}this.server.registerChannel("telemetryAppender",new se.TelemetryAppenderChannel(st)),ye.set(ie.ITelemetryService,ct);const Ut=new we.CustomEndpointTelemetryService(Ke,ct,tt,Be,Oe);ye.set(ie.ICustomEndpointTelemetryService,Ut),ye.set(pt.IExtensionsProfileScannerService,new J.SyncDescriptor(pt.ExtensionsProfileScannerService,void 0,!0)),ye.set(Ct.IExtensionsScannerService,new J.SyncDescriptor(Pt.ExtensionsScannerService,void 0,!0)),ye.set(M.INativeServerExtensionManagementService,new J.SyncDescriptor(M.ExtensionManagementService,void 0,!0)),ye.set(v.IExtensionGalleryService,new J.SyncDescriptor(d.ExtensionGalleryService,void 0,!0)),ye.set(v.IExtensionTipsService,new J.SyncDescriptor(_.ExtensionTipsService,void 0,!1)),ye.set(te.ILanguagePackService,new J.SyncDescriptor(ce.NativeLanguagePackService,void 0,!1)),ye.set(i.IDiagnosticsService,new J.SyncDescriptor(s.DiagnosticsService,void 0,!1)),ye.set(ae.IUserDataSyncAccountService,new J.SyncDescriptor(ae.UserDataSyncAccountService,void 0,!0)),ye.set(We.IUserDataSyncLogService,new J.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),ye.set(We.IUserDataSyncUtilService,new fe.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ye=>Ye.ctx!=="main"))),ye.set(v.IGlobalExtensionEnablementService,new J.SyncDescriptor(u.GlobalExtensionEnablementService,void 0,!1)),ye.set(Ve.IIgnoredExtensionsManagementService,new J.SyncDescriptor(Ve.IgnoredExtensionsManagementService,void 0,!0)),ye.set(ze.IExtensionStorageService,new J.SyncDescriptor(ze.ExtensionStorageService)),ye.set(We.IUserDataSyncStoreManagementService,new J.SyncDescriptor(Ae.UserDataSyncStoreManagementService,void 0,!0)),ye.set(We.IUserDataSyncStoreService,new J.SyncDescriptor(Ae.UserDataSyncStoreService,void 0,!0)),ye.set(Ie.IUserDataSyncMachinesService,new J.SyncDescriptor(Ie.UserDataSyncMachinesService,void 0,!0)),ye.set(We.IUserDataSyncBackupStoreService,new J.SyncDescriptor(de.UserDataSyncBackupStoreService,void 0,!1)),ye.set(We.IUserDataSyncEnablementService,new J.SyncDescriptor(Me.UserDataSyncEnablementService,void 0,!0)),ye.set(We.IUserDataSyncService,new J.SyncDescriptor(De.UserDataSyncService,void 0,!1));const wt=new Ue.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ke.getValue("terminal.integrated.persistentSessionScrollback")??100},Ke,Be,Ge);return wt.initialize(),ye.set(Pe.ILocalPtyService,this._register(wt)),ye.set(ke.ISignService,new J.SyncDescriptor(ee.SignService,void 0,!1)),ye.set(le.ISharedTunnelsService,new J.SyncDescriptor(me.SharedTunnelsService)),ye.set(ge.ISharedProcessTunnelService,new J.SyncDescriptor(Se.SharedProcessTunnelService)),new K.InstantiationService(ye)}initChannels(ye){const Oe=new L.ExtensionManagementChannel(ye.get(v.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const xe=b.ProxyChannel.fromService(ye.get(te.ILanguagePackService));this.server.registerChannel("languagePacks",xe);const He=b.ProxyChannel.fromService(ye.get(i.IDiagnosticsService));this.server.registerChannel("diagnostics",He);const et=new L.ExtensionTipsChannel(ye.get(v.IExtensionTipsService));this.server.registerChannel("extensionTipsService",et);const Be=b.ProxyChannel.fromService(ye.get(g.IChecksumService));this.server.registerChannel("checksum",Be);const ot=b.ProxyChannel.fromService(ye.get(Ze.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",ot);const tt=new fe.UserDataSyncMachinesServiceChannel(ye.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",tt);const lt=b.ProxyChannel.fromService(ye.get(ie.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",lt);const Ge=new fe.UserDataSyncAccountServiceChannel(ye.get(ae.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ge);const Je=new fe.UserDataSyncStoreManagementServiceChannel(ye.get(We.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Je);const ut=new $e.UserDataSyncChannel(ye.get(We.IUserDataSyncService),ye.get(z.ILogService));this.server.registerChannel("userDataSync",ut);const ht=this._register(ye.get(H.IInstantiationService).createInstance(Fe.UserDataAutoSyncService)),it=new fe.UserDataAutoSyncChannel(ht);this.server.registerChannel("userDataAutoSync",it);const Ke=ye.get(Pe.ILocalPtyService),rt=b.ProxyChannel.fromService(Ke);this.server.registerChannel(Ee.TerminalIpcChannels.LocalPty,rt);const at=b.ProxyChannel.fromService(ye.get(ge.ISharedProcessTunnelService));this.server.registerChannel(ge.ipcSharedProcessTunnelChannelName,at);const dt=b.ProxyChannel.fromService(ye.get(be.ISharedProcessWorkerService));this.server.registerChannel(be.ipcSharedProcessWorkerChannelName,dt)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Oe=>{(0,T.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Oe=>{const xe=(0,k.toErrorMessage)(Oe,!0);!xe||ye.error(`[uncaught exception in sharedProcess]: ${xe}`)})}}async function _t(St){const ye=new At(St);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=_t})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/2a74e7d5a806e537438158dc8b426b313329f1d1/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
