/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/platform/files/common/files","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","os","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/map","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","vs/platform/state/electron-main/state","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/userDataProfile/electron-main/userDataProfile","vs/base/common/json","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ee=function(q){for(var e=[],v=0,t=q.length;v<t;v++)e[v]=Z[q[v]];return e};define(Z[119],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function v(M){return M?M.replace(/\$\((.*?)\)/g,(E,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=v;class t{constructor(E,l,m){this.id=E,this.definition=l,this.description=m,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(M,E){const l=["codicon","codicon-"+M];return E&&l.push("codicon-modifier-"+E),l}e.getClassNamesArray=k;var R;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function l(b){if(b instanceof t)return["codicon","codicon-"+b.id];const y=E.exec(b.id);if(!y)return l(t.error);const[,h,d]=y,S=["codicon","codicon-"+h];return d&&S.push("codicon-modifier-"+d.substr(1)),S}M.asClassNameArray=l;function m(b){return l(b).join(" ")}M.asClassName=m;function I(b){return"."+l(b).join(".")}M.asCSSSelector=I})(R=e.CSSIcon||(e.CSSIcon={}))}),define(Z[120],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function v(E,l){const m=Math.pow(10,l);return Math.round(E*m)/m}class t{constructor(l,m,I,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,I))|0,this.a=v(Math.max(Math.min(1,b),0),3)}static equals(l,m){return l.r===m.r&&l.g===m.g&&l.b===m.b&&l.a===m.a}}e.RGBA=t;class k{constructor(l,m,I,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=v(Math.max(Math.min(1,m),0),3),this.l=v(Math.max(Math.min(1,I),0),3),this.a=v(Math.max(Math.min(1,b),0),3)}static equals(l,m){return l.h===m.h&&l.s===m.s&&l.l===m.l&&l.a===m.a}static fromRGBA(l){const m=l.r/255,I=l.g/255,b=l.b/255,y=l.a,h=Math.max(m,I,b),d=Math.min(m,I,b);let S=0,C=0;const w=(d+h)/2,p=h-d;if(p>0){switch(C=Math.min(w<=.5?p/(2*w):p/(2-2*w),1),h){case m:S=(I-b)/p+(I<b?6:0);break;case I:S=(b-m)/p+2;break;case b:S=(m-I)/p+4;break}S*=60,S=Math.round(S)}return new k(S,C,w,y)}static _hue2rgb(l,m,I){return I<0&&(I+=1),I>1&&(I-=1),I<1/6?l+(m-l)*6*I:I<1/2?m:I<2/3?l+(m-l)*(2/3-I)*6:l}static toRGBA(l){const m=l.h/360,{s:I,l:b,a:y}=l;let h,d,S;if(I===0)h=d=S=b;else{const C=b<.5?b*(1+I):b+I-b*I,w=2*b-C;h=k._hue2rgb(w,C,m+1/3),d=k._hue2rgb(w,C,m),S=k._hue2rgb(w,C,m-1/3)}return new t(Math.round(h*255),Math.round(d*255),Math.round(S*255),y)}}e.HSLA=k;class R{constructor(l,m,I,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=v(Math.max(Math.min(1,m),0),3),this.v=v(Math.max(Math.min(1,I),0),3),this.a=v(Math.max(Math.min(1,b),0),3)}static equals(l,m){return l.h===m.h&&l.s===m.s&&l.v===m.v&&l.a===m.a}static fromRGBA(l){const m=l.r/255,I=l.g/255,b=l.b/255,y=Math.max(m,I,b),h=Math.min(m,I,b),d=y-h,S=y===0?0:d/y;let C;return d===0?C=0:y===m?C=((I-b)/d%6+6)%6:y===I?C=(b-m)/d+2:C=(m-I)/d+4,new R(Math.round(C*60),S,y,l.a)}static toRGBA(l){const{h:m,s:I,v:b,a:y}=l,h=b*I,d=h*(1-Math.abs(m/60%2-1)),S=b-h;let[C,w,p]=[0,0,0];return m<60?(C=h,w=d):m<120?(C=d,w=h):m<180?(w=h,p=d):m<240?(w=d,p=h):m<300?(C=d,p=h):m<=360&&(C=h,p=d),C=Math.round((C+S)*255),w=Math.round((w+S)*255),p=Math.round((p+S)*255),new t(C,w,p,y)}}e.HSVA=R;class M{constructor(l){if(l)if(l instanceof t)this.rgba=l;else if(l instanceof k)this._hsla=l,this.rgba=k.toRGBA(l);else if(l instanceof R)this._hsva=l,this.rgba=R.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(l){return M.Format.CSS.parseHex(l)||M.red}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}equals(l){return!!l&&t.equals(this.rgba,l.rgba)&&k.equals(this.hsla,l.hsla)&&R.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=M._relativeLuminanceForComponent(this.rgba.r),m=M._relativeLuminanceForComponent(this.rgba.g),I=M._relativeLuminanceForComponent(this.rgba.b),b=.2126*l+.7152*m+.0722*I;return v(b,4)}static _relativeLuminanceForComponent(l){const m=l/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(l){const m=this.getRelativeLuminance(),I=l.getRelativeLuminance();return m>I?(m+.05)/(I+.05):(I+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const m=this.getRelativeLuminance(),I=l.getRelativeLuminance();return m>I}isDarkerThan(l){const m=this.getRelativeLuminance(),I=l.getRelativeLuminance();return m<I}lighten(l){return new M(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new M(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:m,g:I,b,a:y}=this.rgba;return new M(new t(m,I,b,y*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const m=l.rgba,I=this.rgba.a,b=m.a,y=I+b*(1-I);if(y<1e-6)return M.transparent;const h=this.rgba.r*I/y+m.r*b*(1-I)/y,d=this.rgba.g*I/y+m.g*b*(1-I)/y,S=this.rgba.b*I/y+m.b*b*(1-I)/y;return new M(new t(h,d,S,y))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:m,g:I,b,a:y}=this.rgba;return new M(new t(l.rgba.r-y*(l.rgba.r-m),l.rgba.g-y*(l.rgba.g-I),l.rgba.b-y*(l.rgba.b-b),1))}flatten(...l){const m=l.reduceRight((I,b)=>M._flatten(b,I));return M._flatten(this,m)}static _flatten(l,m){const I=1-l.rgba.a;return new M(new t(I*m.rgba.r+l.rgba.a*l.rgba.r,I*m.rgba.g+l.rgba.a*l.rgba.g,I*m.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this._toString||(this._toString=M.Format.CSS.format(this)),this._toString}static getLighterColor(l,m,I){if(l.isLighterThan(m))return l;I=I||.5;const b=l.getRelativeLuminance(),y=m.getRelativeLuminance();return I=I*(y-b)/y,l.lighten(I)}static getDarkerColor(l,m,I){if(l.isDarkerThan(m))return l;I=I||.5;const b=l.getRelativeLuminance(),y=m.getRelativeLuminance();return I=I*(b-y)/b,l.darken(I)}}e.Color=M,M.white=new M(new t(255,255,255,1)),M.black=new M(new t(0,0,0,1)),M.red=new M(new t(255,0,0,1)),M.blue=new M(new t(0,0,255,1)),M.green=new M(new t(0,255,0,1)),M.cyan=new M(new t(0,255,255,1)),M.lightgrey=new M(new t(211,211,211,1)),M.transparent=new M(new t(0,0,0,0)),function(E){let l;(function(m){let I;(function(b){function y(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:E.Format.CSS.formatRGBA(n)}b.formatRGB=y;function h(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}b.formatRGBA=h;function d(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(n)}b.formatHSL=d;function S(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}b.formatHSLA=S;function C(n){const o=n.toString(16);return o.length!==2?"0"+o:o}function w(n){return`#${C(n.rgba.r)}${C(n.rgba.g)}${C(n.rgba.b)}`}b.formatHex=w;function p(n,o=!1){return o&&n.rgba.a===1?E.Format.CSS.formatHex(n):`#${C(n.rgba.r)}${C(n.rgba.g)}${C(n.rgba.b)}${C(Math.round(n.rgba.a*255))}`}b.formatHexA=p;function f(n){return n.isOpaque()?E.Format.CSS.formatHex(n):E.Format.CSS.formatRGBA(n)}b.format=f;function g(n){const o=n.length;if(o===0||n.charCodeAt(0)!==35)return null;if(o===7){const i=16*a(n.charCodeAt(1))+a(n.charCodeAt(2)),r=16*a(n.charCodeAt(3))+a(n.charCodeAt(4)),s=16*a(n.charCodeAt(5))+a(n.charCodeAt(6));return new E(new t(i,r,s,1))}if(o===9){const i=16*a(n.charCodeAt(1))+a(n.charCodeAt(2)),r=16*a(n.charCodeAt(3))+a(n.charCodeAt(4)),s=16*a(n.charCodeAt(5))+a(n.charCodeAt(6)),c=16*a(n.charCodeAt(7))+a(n.charCodeAt(8));return new E(new t(i,r,s,c/255))}if(o===4){const i=a(n.charCodeAt(1)),r=a(n.charCodeAt(2)),s=a(n.charCodeAt(3));return new E(new t(16*i+i,16*r+r,16*s+s))}if(o===5){const i=a(n.charCodeAt(1)),r=a(n.charCodeAt(2)),s=a(n.charCodeAt(3)),c=a(n.charCodeAt(4));return new E(new t(16*i+i,16*r+r,16*s+s,(16*c+c)/255))}return null}b.parseHex=g;function a(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(I=m.CSS||(m.CSS={}))})(l=E.Format||(E.Format={}))}(M=e.Color||(e.Color={}))}),define(Z[53],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(M){return(E,l,m)=>{let I=null,b=null;if(typeof m.value=="function"?(I="value",b=m.value):typeof m.get=="function"&&(I="get",b=m.get),!b)throw new Error("not supported");m[I]=M(b,l)}}e.createDecorator=v;function t(M,E,l){let m=null,I=null;if(typeof l.value=="function"?(m="value",I=l.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(m="get",I=l.get),!I)throw new Error("not supported");const b=`$memoize$${E}`;l[m]=function(...y){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,y)}),this[b]}}e.memoize=t;function k(M,E,l){return v((m,I)=>{const b=`$debounce$${I}`,y=`$debounce$result$${I}`;return function(...h){this[y]||(this[y]=l?l():void 0),clearTimeout(this[b]),E&&(this[y]=E(this[y],...h),h=[this[y]]),this[b]=setTimeout(()=>{m.apply(this,h),this[y]=l?l():void 0},M)}})}e.debounce=k;function R(M,E,l){return v((m,I)=>{const b=`$throttle$timer$${I}`,y=`$throttle$result$${I}`,h=`$throttle$lastRun$${I}`,d=`$throttle$pending$${I}`;return function(...S){if(this[y]||(this[y]=l?l():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),E&&(this[y]=E(this[y],...S)),this[d])return;const C=this[h]+M;C<=Date.now()?(this[h]=Date.now(),m.apply(this,[this[y]]),this[y]=l?l():void 0):(this[d]=!0,this[b]=setTimeout(()=>{this[d]=!1,this[h]=Date.now(),m.apply(this,[this[y]]),this[y]=l?l():void 0},C-Date.now()))}})}e.throttle=R}),define(Z[17],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?f.isErrorNoTelemetry(n)?new f(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(o=>{o(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=v,e.errorHandler=new v;function t(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=t;function k(a){l(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=k;function R(a){l(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=R;function M(a){if(a instanceof Error){const{name:n,message:o}=a,i=a.stacktrace||a.stack;return{$isError:!0,name:n,message:o,stack:i,noTelemetry:f.isErrorNoTelemetry(a)}}return a}e.transformErrorForSerialization=M;const E="Canceled";function l(a){return a instanceof m?!0:a instanceof Error&&a.name===E&&a.message===E}e.isCancellationError=l;class m extends Error{constructor(){super(E),this.name=this.message}}e.CancellationError=m;function I(){const a=new Error(E);return a.name=a.message,a}e.canceled=I;function b(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=b;function y(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=y;function h(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function d(a){const n=new Error(`${a} has been disposed`);return n.name="DISPOSED",n}e.disposed=d;function S(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=S;class C extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=C;class w extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=w;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class f extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof f)return n;const o=new f;return o.message=n.message,o.stack=n.stack,o}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=f;class g extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype);debugger}}e.BugIndicatingError=g}),define(Z[24],ee([0,1,17]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(j,ie=0){return j[j.length-(1+ie)]}e.tail=t;function k(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=k;function R(j,ie,ne=(ae,fe)=>ae===fe){if(j===ie)return!0;if(!j||!ie||j.length!==ie.length)return!1;for(let ae=0,fe=j.length;ae<fe;ae++)if(!ne(j[ae],ie[ae]))return!1;return!0}e.equals=R;function M(j,ie){const ne=j.length-1;ie<ne&&(j[ie]=j[ne]),j.pop()}e.removeFastWithoutKeepingOrder=M;function E(j,ie,ne){return l(j.length,ae=>ne(j[ae],ie))}e.binarySearch=E;function l(j,ie){let ne=0,ae=j-1;for(;ne<=ae;){const fe=(ne+ae)/2|0,De=ie(fe);if(De<0)ne=fe+1;else if(De>0)ae=fe-1;else return fe}return-(ne+1)}e.binarySearch2=l;function m(j,ie){let ne=0,ae=j.length;if(ae===0)return 0;for(;ne<ae;){const fe=Math.floor((ne+ae)/2);ie(j[fe])?ae=fe:ne=fe+1}return ne}e.findFirstInSorted=m;function I(j,ie,ne){if(j=j|0,j>=ie.length)throw new TypeError("invalid index");const ae=ie[Math.floor(ie.length*Math.random())],fe=[],De=[],Le=[];for(const ke of ie){const Ae=ne(ke,ae);Ae<0?fe.push(ke):Ae>0?De.push(ke):Le.push(ke)}return j<fe.length?I(j,fe,ne):j<fe.length+Le.length?Le[0]:I(j-(fe.length+Le.length),De,ne)}e.quickSelect=I;function b(j,ie){const ne=[];let ae;for(const fe of j.slice(0).sort(ie))!ae||ie(ae[0],fe)!==0?(ae=[fe],ne.push(ae)):ae.push(fe);return ne}e.groupBy=b;function y(j,ie,ne){const ae=[];function fe(ke,Ae,He){if(Ae===0&&He.length===0)return;const ge=ae[ae.length-1];ge&&ge.start+ge.deleteCount===ke?(ge.deleteCount+=Ae,ge.toInsert.push(...He)):ae.push({start:ke,deleteCount:Ae,toInsert:He})}let De=0,Le=0;for(;;){if(De===j.length){fe(De,0,ie.slice(Le));break}if(Le===ie.length){fe(De,j.length-De,[]);break}const ke=j[De],Ae=ie[Le],He=ne(ke,Ae);He===0?(De+=1,Le+=1):He<0?(fe(De,1,[]),De+=1):He>0&&(fe(De,0,[Ae]),Le+=1)}return ae}e.sortedDiff=y;function h(j,ie,ne){const ae=y(j,ie,ne),fe=[],De=[];for(const Le of ae)fe.push(...j.slice(Le.start,Le.start+Le.deleteCount)),De.push(...Le.toInsert);return{removed:fe,added:De}}e.delta=h;function d(j,ie,ne){if(ne===0)return[];const ae=j.slice(0,ne).sort(ie);return C(j,ie,ae,ne,j.length),ae}e.top=d;function S(j,ie,ne,ae,fe){return ne===0?Promise.resolve([]):new Promise((De,Le)=>{(async()=>{const ke=j.length,Ae=j.slice(0,ne).sort(ie);for(let He=ne,ge=Math.min(ne+ae,ke);He<ke;He=ge,ge=Math.min(ge+ae,ke)){if(He>ne&&await new Promise(we=>setTimeout(we)),fe&&fe.isCancellationRequested)throw new v.CancellationError;C(j,ie,Ae,He,ge)}return Ae})().then(De,Le)})}e.topAsync=S;function C(j,ie,ne,ae,fe){for(const De=ne.length;ae<fe;ae++){const Le=j[ae];if(ie(Le,ne[De-1])<0){ne.pop();const ke=m(ne,Ae=>ie(Le,Ae)<0);ne.splice(ke,0,Le)}}}function w(j){return j.filter(ie=>!!ie)}e.coalesce=w;function p(j){let ie=0;for(let ne=0;ne<j.length;ne++)j[ne]&&(j[ie]=j[ne],ie+=1);j.length=ie}e.coalesceInPlace=p;function f(j,ie,ne){j.splice(ne,0,j.splice(ie,1)[0])}e.move=f;function g(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=g;function a(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=a;function n(j,ie=ne=>ne){const ne=new Set;return j.filter(ae=>{const fe=ie(ae);return ne.has(fe)?!1:(ne.add(fe),!0)})}e.distinct=n;function o(j){const ie=new Set;return ne=>{const ae=j(ne);return ie.has(ae)?!1:(ie.add(ae),!0)}}e.uniqueFilter=o;function i(j,ie){const ne=r(j,ie);if(ne!==-1)return j[ne]}e.findLast=i;function r(j,ie){for(let ne=j.length-1;ne>=0;ne--){const ae=j[ne];if(ie(ae))return ne}return-1}e.lastIndex=r;function s(j,ie){return j.length>0?j[0]:ie}e.firstOrDefault=s;function c(j,ie){return j.length>0?j[j.length-1]:ie}e.lastOrDefault=c;function u(j,ie,ne=(ae,fe)=>ae===fe){let ae=0;for(let fe=0,De=Math.min(j.length,ie.length);fe<De&&ne(j[fe],ie[fe]);fe++)ae++;return ae}e.commonPrefixLength=u;function P(j){return[].concat(...j)}e.flatten=P;function D(j,ie){let ne=typeof ie=="number"?j:0;typeof ie=="number"?ne=j:(ne=0,ie=j);const ae=[];if(ne<=ie)for(let fe=ne;fe<ie;fe++)ae.push(fe);else for(let fe=ne;fe>ie;fe--)ae.push(fe);return ae}e.range=D;function T(j,ie,ne){return j.reduce((ae,fe)=>(ae[ie(fe)]=ne?ne(fe):fe,ae),Object.create(null))}e.index=T;function N(j,ie){return j.push(ie),()=>U(j,ie)}e.insert=N;function U(j,ie){const ne=j.indexOf(ie);if(ne>-1)return j.splice(ne,1),ie}e.remove=U;function $(j,ie,ne){const ae=j.slice(0,ie),fe=j.slice(ie);return ae.concat(ne,fe)}e.arrayInsert=$;function Y(j,ie){let ne;if(typeof ie=="number"){let ae=ie;ne=()=>{const fe=Math.sin(ae++)*179426549;return fe-Math.floor(fe)}}else ne=Math.random;for(let ae=j.length-1;ae>0;ae-=1){const fe=Math.floor(ne()*(ae+1)),De=j[ae];j[ae]=j[fe],j[fe]=De}}e.shuffle=Y;function oe(j,ie){const ne=j.indexOf(ie);ne>-1&&(j.splice(ne,1),j.unshift(ie))}e.pushToStart=oe;function ue(j,ie){const ne=j.indexOf(ie);ne>-1&&(j.splice(ne,1),j.push(ie))}e.pushToEnd=ue;function se(j,ie){for(const ne of ie)j.push(ne)}e.pushMany=se;function de(j,ie){return Array.isArray(j)?j.map(ie):ie(j)}e.mapArrayOrNot=de;function G(j){return Array.isArray(j)?j:[j]}e.asArray=G;function K(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=K;function F(j,ie){for(const ne of j){const ae=ie(ne);if(ae!==void 0)return ae}}e.mapFind=F;function A(j,ie,ne){const ae=z(j,ie),fe=j.length,De=ne.length;j.length=fe+De;for(let Le=fe-1;Le>=ae;Le--)j[Le+De]=j[Le];for(let Le=0;Le<De;Le++)j[Le+ae]=ne[Le]}e.insertInto=A;function W(j,ie,ne,ae){const fe=z(j,ie),De=j.splice(fe,ne);return A(j,fe,ae),De}e.splice=W;function z(j,ie){return ie<0?Math.max(ie+j.length,0):Math.min(ie,j.length)}var te;(function(j){function ie(fe){return fe<0}j.isLessThan=ie;function ne(fe){return fe>0}j.isGreaterThan=ne;function ae(fe){return fe===0}j.isNeitherLessOrGreaterThan=ae,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(te=e.CompareResult||(e.CompareResult={}));function B(j,ie){return(ne,ae)=>ie(j(ne),j(ae))}e.compareBy=B;function H(...j){return(ie,ne)=>{for(const ae of j){const fe=ae(ie,ne);if(!te.isNeitherLessOrGreaterThan(fe))return fe}return te.neitherLessOrGreaterThan}}e.tieBreakComparators=H;const L=(j,ie)=>j-ie;e.numberComparator=L;function O(j,ie){if(j.length===0)return;let ne=j[0];for(let ae=1;ae<j.length;ae++){const fe=j[ae];ie(fe,ne)>0&&(ne=fe)}return ne}e.findMaxBy=O;function _(j,ie){if(j.length===0)return;let ne=j[0];for(let ae=1;ae<j.length;ae++){const fe=j[ae];ie(fe,ne)>=0&&(ne=fe)}return ne}e.findLastMaxBy=_;function V(j,ie){return O(j,(ne,ae)=>-ie(ne,ae))}e.findMinBy=V;class x{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let ne=this.firstIdx;for(;ne<this.items.length&&ie(this.items[ne]);)ne++;const ae=ne===this.firstIdx?null:this.items.slice(this.firstIdx,ne);return this.firstIdx=ne,ae}takeFromEndWhile(ie){let ne=this.lastIdx;for(;ne>=0&&ie(this.items[ne]);)ne--;const ae=ne===this.lastIdx?null:this.items.slice(ne+1,this.lastIdx+1);return this.lastIdx=ne,ae}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const ne=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,ne}}e.ArrayQueue=x;class re{constructor(ie){this.iterate=ie}forEach(ie){this.iterate(ne=>(ie(ne),!0))}toArray(){const ie=[];return this.iterate(ne=>(ie.push(ne),!0)),ie}filter(ie){return new re(ne=>this.iterate(ae=>ie(ae)?ne(ae):!0))}map(ie){return new re(ne=>this.iterate(ae=>ne(ie(ae))))}some(ie){let ne=!1;return this.iterate(ae=>(ne=ie(ae),!ne)),ne}findFirst(ie){let ne;return this.iterate(ae=>ie(ae)?(ne=ae,!1):!0),ne}findLast(ie){let ne;return this.iterate(ae=>(ie(ae)&&(ne=ae),!0)),ne}findLastMaxBy(ie){let ne,ae=!0;return this.iterate(fe=>((ae||te.isGreaterThan(ie(fe,ne)))&&(ae=!1,ne=fe),!0)),ne}}e.CallbackIterable=re,re.empty=new re(j=>{})}),define(Z[121],ee([0,1,17]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(l,m){if(!l)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=t;function k(l,m="Unreachable"){throw new Error(m)}e.assertNever=k;function R(l){if(!l)throw new v.BugIndicatingError("Assertion Failed")}e.assert=R;function M(l){if(!l()){debugger;l(),(0,v.onUnexpectedError)(new v.BugIndicatingError("Assertion Failed"))}}e.assertFn=M;function E(l,m){let I=0;for(;I<l.length-1;){const b=l[I],y=l[I+1];if(!m(b,y))return!1;I++}return!0}e.checkAdjacentItems=E}),define(Z[49],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(t){const k=this;let R=!1,M;return function(){return R||(R=!0,M=t.apply(k,arguments)),M}}e.once=v}),define(Z[57],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(t){function k(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function M(){return R}t.empty=M;function*E(o){yield o}t.single=E;function l(o){return o||R}t.from=l;function m(o){return!o||o[Symbol.iterator]().next().done===!0}t.isEmpty=m;function I(o){return o[Symbol.iterator]().next().value}t.first=I;function b(o,i){for(const r of o)if(i(r))return!0;return!1}t.some=b;function y(o,i){for(const r of o)if(i(r))return r}t.find=y;function*h(o,i){for(const r of o)i(r)&&(yield r)}t.filter=h;function*d(o,i){let r=0;for(const s of o)yield i(s,r++)}t.map=d;function*S(...o){for(const i of o)for(const r of i)yield r}t.concat=S;function*C(o){for(const i of o)for(const r of i)yield r}t.concatNested=C;function w(o,i,r){let s=r;for(const c of o)s=i(s,c);return s}t.reduce=w;function p(o,i){let r=0;for(const s of o)i(s,r++)}t.forEach=p;function*f(o,i,r=o.length){for(i<0&&(i+=o.length),r<0?r+=o.length:r>o.length&&(r=o.length);i<r;i++)yield o[i]}t.slice=f;function g(o,i=Number.POSITIVE_INFINITY){const r=[];if(i===0)return[r,o];const s=o[Symbol.iterator]();for(let c=0;c<i;c++){const u=s.next();if(u.done)return[r,t.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return s}}]}t.consume=g;function a(o){return g(o)[0]}t.collect=a;function n(o,i,r=(s,c)=>s===c){const s=o[Symbol.iterator](),c=i[Symbol.iterator]();for(;;){const u=s.next(),P=c.next();if(u.done!==P.done)return!1;if(u.done)return!0;if(!r(u.value,P.value))return!1}}t.equals=n})(v=e.Iterable||(e.Iterable={}))}),define(Z[43],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(n){n.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function M(n,o=!1){let i=0;const r=n.length;let s="",c=0,u=16,P=0;function D(ue){let se=0,de=0;for(;se<ue;){const G=n.charCodeAt(i);if(G>=48&&G<=57)de=de*16+G-48;else if(G>=65&&G<=70)de=de*16+G-65+10;else if(G>=97&&G<=102)de=de*16+G-97+10;else break;i++,se++}return se<ue&&(de=-1),de}function T(ue){i=ue,s="",c=0,u=16,P=0}function N(){const ue=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&m(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&m(n.charCodeAt(i)))for(i++;i<n.length&&m(n.charCodeAt(i));)i++;else return P=3,n.substring(ue,i);let se=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&m(n.charCodeAt(i))){for(i++;i<n.length&&m(n.charCodeAt(i));)i++;se=i}else P=3;return n.substring(ue,se)}function U(){let ue="",se=i;for(;;){if(i>=r){ue+=n.substring(se,i),P=2;break}const de=n.charCodeAt(i);if(de===34){ue+=n.substring(se,i),i++;break}if(de===92){if(ue+=n.substring(se,i),i++,i>=r){P=2;break}switch(n.charCodeAt(i++)){case 34:ue+='"';break;case 92:ue+="\\";break;case 47:ue+="/";break;case 98:ue+="\b";break;case 102:ue+="\f";break;case 110:ue+=`
`;break;case 114:ue+="\r";break;case 116:ue+="	";break;case 117:{const K=D(4);K>=0?ue+=String.fromCharCode(K):P=4;break}default:P=5}se=i;continue}if(de>=0&&de<=31)if(l(de)){ue+=n.substring(se,i),P=2;break}else P=6;i++}return ue}function $(){if(s="",P=0,c=i,i>=r)return c=r,u=17;let ue=n.charCodeAt(i);if(E(ue)){do i++,s+=String.fromCharCode(ue),ue=n.charCodeAt(i);while(E(ue));return u=15}if(l(ue))return i++,s+=String.fromCharCode(ue),ue===13&&n.charCodeAt(i)===10&&(i++,s+=`
`),u=14;switch(ue){case 123:return i++,u=1;case 125:return i++,u=2;case 91:return i++,u=3;case 93:return i++,u=4;case 58:return i++,u=6;case 44:return i++,u=5;case 34:return i++,s=U(),u=10;case 47:{const se=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<r&&!l(n.charCodeAt(i));)i++;return s=n.substring(se,i),u=12}if(n.charCodeAt(i+1)===42){i+=2;const de=r-1;let G=!1;for(;i<de;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,G=!0;break}i++}return G||(i++,P=1),s=n.substring(se,i),u=13}return s+=String.fromCharCode(ue),i++,u=16}case 45:if(s+=String.fromCharCode(ue),i++,i===r||!m(n.charCodeAt(i)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),u=11;default:for(;i<r&&Y(ue);)i++,ue=n.charCodeAt(i);if(c!==i){switch(s=n.substring(c,i),s){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return s+=String.fromCharCode(ue),i++,u=16}}function Y(ue){if(E(ue)||l(ue))return!1;switch(ue){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let ue;do ue=$();while(ue>=12&&ue<=15);return ue}return{setPosition:T,getPosition:()=>i,scan:o?oe:$,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>P}}e.createScanner=M;function E(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function l(n){return n===10||n===13||n===8232||n===8233}function m(n){return n>=48&&n<=57}var I;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(I||(I={}));function b(n,o){const i=[],r=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function P(D,T,N,U){c.value=D,c.offset=T,c.length=N,c.type=U,c.colonOffset=void 0,s=c}try{f(n,{onObjectBegin:(D,T)=>{if(o<=D)throw r;s=void 0,u=o>D,i.push("")},onObjectProperty:(D,T,N)=>{if(o<T||(P(D,T,N,"property"),i[i.length-1]=D,o<=T+N))throw r},onObjectEnd:(D,T)=>{if(o<=D)throw r;s=void 0,i.pop()},onArrayBegin:(D,T)=>{if(o<=D)throw r;s=void 0,i.push(0)},onArrayEnd:(D,T)=>{if(o<=D)throw r;s=void 0,i.pop()},onLiteralValue:(D,T,N)=>{if(o<T||(P(D,T,N,a(D)),o<=T+N))throw r},onSeparator:(D,T,N)=>{if(o<=T)throw r;if(D===":"&&s&&s.type==="property")s.colonOffset=T,u=!1,s=void 0;else if(D===","){const U=i[i.length-1];typeof U=="number"?i[i.length-1]=U+1:(u=!0,i[i.length-1]=""),s=void 0}}})}catch(D){if(D!==r)throw D}return{path:i,previousNode:s,isAtPropertyKey:u,matches:D=>{let T=0;for(let N=0;T<D.length&&N<i.length;N++)if(D[T]===i[N]||D[T]==="*")T++;else if(D[T]!=="**")return!1;return T===D.length}}}e.getLocation=b;function y(n,o=[],i=R.DEFAULT){let r=null,s=[];const c=[];function u(D){Array.isArray(s)?s.push(D):r!==null&&(s[r]=D)}return f(n,{onObjectBegin:()=>{const D={};u(D),c.push(s),s=D,r=null},onObjectProperty:D=>{r=D},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const D=[];u(D),c.push(s),s=D,r=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:u,onError:(D,T,N)=>{o.push({error:D,offset:T,length:N})}},i),s[0]}e.parse=y;function h(n,o=[],i=R.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(D){r.type==="property"&&(r.length=D-r.offset,r=r.parent)}function c(D){return r.children.push(D),D}f(n,{onObjectBegin:D=>{r=c({type:"object",offset:D,length:-1,parent:r,children:[]})},onObjectProperty:(D,T,N)=>{r=c({type:"property",offset:T,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:D,offset:T,length:N,parent:r})},onObjectEnd:(D,T)=>{r.length=D+T-r.offset,r=r.parent,s(D+T)},onArrayBegin:(D,T)=>{r=c({type:"array",offset:D,length:-1,parent:r,children:[]})},onArrayEnd:(D,T)=>{r.length=D+T-r.offset,r=r.parent,s(D+T)},onLiteralValue:(D,T,N)=>{c({type:a(D),offset:T,length:N,parent:r,value:D}),s(T+N)},onSeparator:(D,T,N)=>{r.type==="property"&&(D===":"?r.colonOffset=T:D===","&&s(T))},onError:(D,T,N)=>{o.push({error:D,offset:T,length:N})}},i);const P=r.children[0];return P&&delete P.parent,P}e.parseTree=h;function d(n,o){if(!n)return;let i=n;for(const r of o)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===r){i=c.children[1],s=!0;break}if(!s)return}else{const s=r;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=d;function S(n){if(!n.parent||!n.parent.children)return[];const o=S(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;o.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&o.push(i)}return o}e.getNodePath=S;function C(n){switch(n.type){case"array":return n.children.map(C);case"object":{const o=Object.create(null);for(const i of n.children){const r=i.children[1];r&&(o[i.children[0].value]=C(r))}return o}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=C;function w(n,o,i=!1){return o>=n.offset&&o<n.offset+n.length||i&&o===n.offset+n.length}e.contains=w;function p(n,o,i=!1){if(w(n,o,i)){const r=n.children;if(Array.isArray(r))for(let s=0;s<r.length&&r[s].offset<=o;s++){const c=p(r[s],o,i);if(c)return c}return n}}e.findNodeAtOffset=p;function f(n,o,i=R.DEFAULT){const r=M(n,!1);function s(B){return B?()=>B(r.getTokenOffset(),r.getTokenLength()):()=>!0}function c(B){return B?H=>B(H,r.getTokenOffset(),r.getTokenLength()):()=>!0}const u=s(o.onObjectBegin),P=c(o.onObjectProperty),D=s(o.onObjectEnd),T=s(o.onArrayBegin),N=s(o.onArrayEnd),U=c(o.onLiteralValue),$=c(o.onSeparator),Y=s(o.onComment),oe=c(o.onError),ue=i&&i.disallowComments,se=i&&i.allowTrailingComma;function de(){for(;;){const B=r.scan();switch(r.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:ue||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(B){case 12:case 13:ue?G(10):Y();break;case 16:G(1);break;case 15:case 14:break;default:return B}}}function G(B,H=[],L=[]){if(oe(B),H.length+L.length>0){let O=r.getToken();for(;O!==17;){if(H.indexOf(O)!==-1){de();break}else if(L.indexOf(O)!==-1)break;O=de()}}}function K(B){const H=r.getTokenValue();return B?U(H):P(H),de(),!0}function F(){switch(r.getToken()){case 11:{let B=0;try{B=JSON.parse(r.getTokenValue()),typeof B!="number"&&(G(2),B=0)}catch{G(2)}U(B);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return de(),!0}function A(){return r.getToken()!==10?(G(3,[],[2,5]),!1):(K(!1),r.getToken()===6?($(":"),de(),te()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function W(){u(),de();let B=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(B||G(4,[],[]),$(","),de(),r.getToken()===2&&se)break}else B&&G(6,[],[]);A()||G(4,[],[2,5]),B=!0}return D(),r.getToken()!==2?G(7,[2],[]):de(),!0}function z(){T(),de();let B=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(B||G(4,[],[]),$(","),de(),r.getToken()===4&&se)break}else B&&G(6,[],[]);te()||G(4,[],[4,5]),B=!0}return N(),r.getToken()!==4?G(8,[4],[]):de(),!0}function te(){switch(r.getToken()){case 3:return z();case 1:return W();case 10:return K(!0);default:return F()}}return de(),r.getToken()===17?i.allowEmptyContent?!0:(G(4,[],[]),!1):te()?(r.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=f;function g(n,o){const i=M(n),r=[];let s,c=0,u;do switch(u=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:c!==u&&r.push(n.substring(c,u)),o!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,o)),c=i.getPosition();break}while(s!==17);return r.join("")}e.stripComments=g;function a(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(Z[122],ee([0,1,43]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(m,I,b){let y,h,d,S,C;if(I){for(S=I.offset,C=S+I.length,d=S;d>0&&!l(m,d-1);)d--;let u=C;for(;u<m.length&&!l(m,u);)u++;h=m.substring(d,u),y=M(h,b)}else h=m,y=0,d=0,S=0,C=m.length;const w=E(b,m);let p=!1,f=0,g;b.insertSpaces?g=R(" ",b.tabSize||4):g="	";const a=(0,v.createScanner)(h,!1);let n=!1;function o(){return w+R(g,y+f)}function i(){let u=a.scan();for(p=!1;u===15||u===14;)p=p||u===14,u=a.scan();return n=u===16||a.getTokenError()!==0,u}const r=[];function s(u,P,D){!n&&P<C&&D>S&&m.substring(P,D)!==u&&r.push({offset:P,length:D-P,content:u})}let c=i();if(c!==17){const u=a.getTokenOffset()+d,P=R(g,y);s(P,d,u)}for(;c!==17;){let u=a.getTokenOffset()+a.getTokenLength()+d,P=i(),D="";for(;!p&&(P===12||P===13);){const N=a.getTokenOffset()+d;s(" ",u,N),u=a.getTokenOffset()+a.getTokenLength()+d,D=P===12?o():"",P=i()}if(P===2)c!==1&&(f--,D=o());else if(P===4)c!==3&&(f--,D=o());else{switch(c){case 3:case 1:f++,D=o();break;case 5:case 12:D=o();break;case 13:p?D=o():D=" ";break;case 6:D=" ";break;case 10:if(P===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?D=" ":P!==5&&P!==17&&(n=!0);break;case 16:n=!0;break}p&&(P===12||P===13)&&(D=o())}const T=a.getTokenOffset()+d;s(D,u,T),c=P}return r}e.format=t;function k(m,I){const b=JSON.stringify(m,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?b.replace(/\r\n|\r|\n/g,I.eol):b}e.toFormattedString=k;function R(m,I){let b="";for(let y=0;y<I;y++)b+=m;return b}function M(m,I){let b=0,y=0;const h=I.tabSize||4;for(;b<m.length;){const d=m.charAt(b);if(d===" ")y++;else if(d==="	")y+=h;else break;b++}return Math.floor(y/h)}function E(m,I){for(let b=0;b<I.length;b++){const y=I.charAt(b);if(y==="\r")return b+1<I.length&&I.charAt(b+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=E;function l(m,I){return`\r
`.indexOf(m.charAt(I))!==-1}e.isEOL=l}),define(Z[123],ee([0,1,43,122]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(m,I,b){return R(m,I,void 0,b)}e.removeProperty=k;function R(m,I,b,y,h){const d=I.slice(),S=[],C=(0,v.parseTree)(m,S);let w,p;for(;d.length>0&&(p=d.pop(),w=(0,v.findNodeAtLocation)(C,d),w===void 0&&b!==void 0);)typeof p=="string"?b={[p]:b}:b=[b];if(w)if(w.type==="object"&&typeof p=="string"&&Array.isArray(w.children)){const f=(0,v.findNodeAtLocation)(w,[p]);if(f!==void 0)if(b===void 0){if(!f.parent)throw new Error("Malformed AST");const g=w.children.indexOf(f.parent);let a,n=f.parent.offset+f.parent.length;if(g>0){const o=w.children[g-1];a=o.offset+o.length}else a=w.offset+1,w.children.length>1&&(n=w.children[1].offset);return M(m,{offset:a,length:n-a,content:""},y)}else return M(m,{offset:f.offset,length:f.length,content:JSON.stringify(b)},y);else{if(b===void 0)return[];const g=`${JSON.stringify(p)}: ${JSON.stringify(b)}`,a=h?h(w.children.map(o=>o.children[0].value)):w.children.length;let n;if(a>0){const o=w.children[a-1];n={offset:o.offset+o.length,length:0,content:","+g}}else w.children.length===0?n={offset:w.offset+1,length:0,content:g}:n={offset:w.offset+1,length:0,content:g+","};return M(m,n,y)}}else if(w.type==="array"&&typeof p=="number"&&Array.isArray(w.children))if(b!==void 0){const f=`${JSON.stringify(b)}`;let g;if(w.children.length===0||p===0)g={offset:w.offset+1,length:0,content:w.children.length===0?f:f+","};else{const a=p===-1||p>w.children.length?w.children.length:p,n=w.children[a-1];g={offset:n.offset+n.length,length:0,content:","+f}}return M(m,g,y)}else{const f=p,g=w.children[f];let a;if(w.children.length===1)a={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===f){const n=w.children[f-1],o=n.offset+n.length,i=w.offset+w.length;a={offset:o,length:i-2-o,content:""}}else a={offset:g.offset,length:w.children[f+1].offset-g.offset,content:""};return M(m,a,y)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${w.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return M(m,{offset:C?C.offset:0,length:C?C.length:0,content:JSON.stringify(b)},y)}}e.setProperty=R;function M(m,I,b){let y=E(m,I),h=I.offset,d=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;h>0&&!(0,t.isEOL)(y,h-1);)h--;for(;d<y.length&&!(0,t.isEOL)(y,d);)d++}const S=(0,t.format)(y,{offset:h,length:d-h},b);for(let w=S.length-1;w>=0;w--){const p=S[w];y=E(y,p),h=Math.min(h,p.offset),d=Math.max(d,p.offset+p.length),d+=p.content.length-p.length}const C=m.length-(y.length-d)-h;return[{offset:h,length:C,content:y.substring(h,d)}]}e.withFormatting=M;function E(m,I){return m.substring(0,I.offset)+I.content+m.substring(I.offset+I.length)}e.applyEdit=E;function l(m,I){const b=I.slice(0).sort((h,d)=>{const S=h.offset-d.offset;return S===0?h.length-d.length:S});let y=m.length;for(let h=b.length-1;h>=0;h--){const d=b[h];if(d.offset+d.length<=y)m=E(m,d);else throw new Error("Overlapping edit");y=d.offset}return m}e.applyEdits=l}),define(Z[124],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new v(()=>k(this.getValue()))}}e.Lazy=v}),define(Z[2],ee([0,1,49,57]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function M(s){R=s}if(e.setDisposableTracker=M,k){const s="__is_disposable_tracked__";M(new class{trackDisposable(c){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[s]||console.log(u)},3e3)}setParent(c,u){if(c&&c!==p.None)try{c[s]=!0}catch{}}markAsDisposed(c){if(c&&c!==p.None)try{c[s]=!0}catch{}}markAsSingleton(c){}})}function E(s){return R?.trackDisposable(s),s}function l(s){R?.markAsDisposed(s)}function m(s,c){R?.setParent(s,c)}function I(s,c){if(!!R)for(const u of s)R.setParent(u,c)}function b(s){return R?.markAsSingleton(s),s}e.markAsSingleton=b;function y(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=y;function h(s){if(t.Iterable.is(s)){const c=[];for(const u of s)if(u)try{u.dispose()}catch(P){c.push(P)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=h;function d(s){for(const c of s)y(c)&&c.dispose();return[]}e.disposeIfDisposable=d;function S(...s){const c=C(()=>h(s));return I(s,c),c}e.combinedDisposable=S;function C(s){const c=E({dispose:(0,v.once)(()=>{l(c),s()})});return c}e.toDisposable=C;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(l(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return m(c,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new w,E(this),m(this._store,this)}dispose(){l(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){this._isDisposed||c===this._value||(this._value?.dispose(),c&&m(c,this),this._value=c)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,l(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&m(c,null),c}}e.MutableDisposable=f;class g{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=g;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(c){let u=c;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,l(this))},this}}e.SafeDisposable=a;class n{constructor(){this.references=new Map}acquire(c,...u){let P=this.references.get(c);P||(P={counter:0,object:this.createReferencedObject(c,...u)},this.references.set(c,P));const{object:D}=P,T=(0,v.once)(()=>{--P.counter===0&&(this.destroyReferencedObject(c,P.object),this.references.delete(c))});return P.counter++,{object:D,dispose:T}}}e.ReferenceCollection=n;class o{constructor(c){this.referenceCollection=c}async acquire(c,...u){const P=this.referenceCollection.acquire(c,...u);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(D){throw P.dispose(),D}}}e.AsyncReferenceCollection=o;class i{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=i;function r(s){const c=new w;try{s(c)}finally{c.dispose()}}e.disposeOnReturn=r}),define(Z[125],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(R){this.element=R,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class t{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let R=this._first;for(;R!==v.Undefined;){const M=R.next;R.prev=v.Undefined,R.next=v.Undefined,R=M}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,M){const E=new v(R);if(this._first===v.Undefined)this._first=E,this._last=E;else if(M){const m=this._last;this._last=E,E.prev=m,m.next=E}else{const m=this._first;this._first=E,E.next=m,m.prev=E}this._size+=1;let l=!1;return()=>{l||(l=!0,this._remove(E))}}shift(){if(this._first!==v.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==v.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==v.Undefined&&R.next!==v.Undefined){const M=R.prev;M.next=R.next,R.next.prev=M}else R.prev===v.Undefined&&R.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):R.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):R.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==v.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function q(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function M(l){R.push(l,Date.now())}function E(){const l=[];for(let m=0;m<R.length;m+=2)l.push({name:R[m],startTime:R[m+1]});return l}return{mark:M,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const M of performance.getEntriesByType("mark"))R.push({name:M.name,startTime:Math.round(k+M.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function v(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=v(t))}(),function(q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var t in v)(typeof exports=="object"?exports:q)[t]=v[t]}}(typeof self<"u"?self:this,function(){return function(q){var e={};function v(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return q[t].call(k.exports,k,k.exports,v),k.l=!0,k.exports}return v.m=q,v.c=e,v.d=function(t,k,R){v.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},v.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},v.t=function(t,k){if(1&k&&(t=v(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(v.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var M in t)v.d(R,M,function(E){return t[E]}.bind(null,M));return R},v.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return v.d(k,"a",k),k},v.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},v.p="",v(v.s=0)}([function(q,e,v){(function(t){var k;e=q.exports=L,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],l=e.src=[],m=0,I=m++;l[I]="0|[1-9]\\d*";var b=m++;l[b]="[0-9]+";var y=m++;l[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=m++;l[h]="("+l[I]+")\\.("+l[I]+")\\.("+l[I]+")";var d=m++;l[d]="("+l[b]+")\\.("+l[b]+")\\.("+l[b]+")";var S=m++;l[S]="(?:"+l[I]+"|"+l[y]+")";var C=m++;l[C]="(?:"+l[b]+"|"+l[y]+")";var w=m++;l[w]="(?:-("+l[S]+"(?:\\."+l[S]+")*))";var p=m++;l[p]="(?:-?("+l[C]+"(?:\\."+l[C]+")*))";var f=m++;l[f]="[0-9A-Za-z-]+";var g=m++;l[g]="(?:\\+("+l[f]+"(?:\\."+l[f]+")*))";var a=m++,n="v?"+l[h]+l[w]+"?"+l[g]+"?";l[a]="^"+n+"$";var o="[v=\\s]*"+l[d]+l[p]+"?"+l[g]+"?",i=m++;l[i]="^"+o+"$";var r=m++;l[r]="((?:<|>)?=?)";var s=m++;l[s]=l[b]+"|x|X|\\*";var c=m++;l[c]=l[I]+"|x|X|\\*";var u=m++;l[u]="[v=\\s]*("+l[c]+")(?:\\.("+l[c]+")(?:\\.("+l[c]+")(?:"+l[w]+")?"+l[g]+"?)?)?";var P=m++;l[P]="[v=\\s]*("+l[s]+")(?:\\.("+l[s]+")(?:\\.("+l[s]+")(?:"+l[p]+")?"+l[g]+"?)?)?";var D=m++;l[D]="^"+l[r]+"\\s*"+l[u]+"$";var T=m++;l[T]="^"+l[r]+"\\s*"+l[P]+"$";var N=m++;l[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=m++;l[U]="(?:~>?)";var $=m++;l[$]="(\\s*)"+l[U]+"\\s+",E[$]=new RegExp(l[$],"g");var Y=m++;l[Y]="^"+l[U]+l[u]+"$";var oe=m++;l[oe]="^"+l[U]+l[P]+"$";var ue=m++;l[ue]="(?:\\^)";var se=m++;l[se]="(\\s*)"+l[ue]+"\\s+",E[se]=new RegExp(l[se],"g");var de=m++;l[de]="^"+l[ue]+l[u]+"$";var G=m++;l[G]="^"+l[ue]+l[P]+"$";var K=m++;l[K]="^"+l[r]+"\\s*("+o+")$|^$";var F=m++;l[F]="^"+l[r]+"\\s*("+n+")$|^$";var A=m++;l[A]="(\\s*)"+l[r]+"\\s*("+o+"|"+l[u]+")",E[A]=new RegExp(l[A],"g");var W=m++;l[W]="^\\s*("+l[u]+")\\s+-\\s+("+l[u]+")\\s*$";var z=m++;l[z]="^\\s*("+l[P]+")\\s+-\\s+("+l[P]+")\\s*$";var te=m++;l[te]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)k(B,l[B]),E[B]||(E[B]=new RegExp(l[B]));function H(X,ce){if(X instanceof L)return X;if(typeof X!="string"||X.length>R||!(ce?E[i]:E[a]).test(X))return null;try{return new L(X,ce)}catch{return null}}function L(X,ce){if(X instanceof L){if(X.loose===ce)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(X,ce);k("SemVer",X,ce),this.loose=ce;var he=X.trim().match(ce?E[i]:E[a]);if(!he)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Ee=+ye;if(Ee>=0&&Ee<M)return Ee}return ye}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=H,e.valid=function(X,ce){var he=H(X,ce);return he?he.version:null},e.clean=function(X,ce){var he=H(X.trim().replace(/^[=v]+/,""),ce);return he?he.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(X){return k("SemVer.compare",this.version,this.loose,X),X instanceof L||(X=new L(X,this.loose)),this.compareMain(X)||this.comparePre(X)},L.prototype.compareMain=function(X){return X instanceof L||(X=new L(X,this.loose)),_(this.major,X.major)||_(this.minor,X.minor)||_(this.patch,X.patch)},L.prototype.comparePre=function(X){if(X instanceof L||(X=new L(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var ce=0;do{var he=this.prerelease[ce],ye=X.prerelease[ce];if(k("prerelease compare",ce,he,ye),he===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(he===void 0)return-1;if(he!==ye)return _(he,ye)}while(++ce)},L.prototype.inc=function(X,ce){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ce),this.inc("pre",ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ce),this.inc("pre",ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ce&&(this.prerelease[0]===ce?isNaN(this.prerelease[1])&&(this.prerelease=[ce,0]):this.prerelease=[ce,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,ce,he,ye){typeof he=="string"&&(ye=he,he=void 0);try{return new L(X,he).inc(ce,ye).version}catch{return null}},e.diff=function(X,ce){if(j(X,ce))return null;var he=H(X),ye=H(ce);if(he.prerelease.length||ye.prerelease.length){for(var Ee in he)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&he[Ee]!==ye[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in he)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&he[Ee]!==ye[Ee])return Ee},e.compareIdentifiers=_;var O=/^[0-9]+$/;function _(X,ce){var he=O.test(X),ye=O.test(ce);return he&&ye&&(X=+X,ce=+ce),he&&!ye?-1:ye&&!he?1:X<ce?-1:X>ce?1:0}function V(X,ce,he){return new L(X,he).compare(new L(ce,he))}function x(X,ce,he){return V(X,ce,he)>0}function re(X,ce,he){return V(X,ce,he)<0}function j(X,ce,he){return V(X,ce,he)===0}function ie(X,ce,he){return V(X,ce,he)!==0}function ne(X,ce,he){return V(X,ce,he)>=0}function ae(X,ce,he){return V(X,ce,he)<=0}function fe(X,ce,he,ye){var Ee;switch(ce){case"===":typeof X=="object"&&(X=X.version),typeof he=="object"&&(he=he.version),Ee=X===he;break;case"!==":typeof X=="object"&&(X=X.version),typeof he=="object"&&(he=he.version),Ee=X!==he;break;case"":case"=":case"==":Ee=j(X,he,ye);break;case"!=":Ee=ie(X,he,ye);break;case">":Ee=x(X,he,ye);break;case">=":Ee=ne(X,he,ye);break;case"<":Ee=re(X,he,ye);break;case"<=":Ee=ae(X,he,ye);break;default:throw new TypeError("Invalid operator: "+ce)}return Ee}function De(X,ce){if(X instanceof De){if(X.loose===ce)return X;X=X.value}if(!(this instanceof De))return new De(X,ce);k("comparator",X,ce),this.loose=ce,this.parse(X),this.semver===Le?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(X,ce){return _(ce,X)},e.major=function(X,ce){return new L(X,ce).major},e.minor=function(X,ce){return new L(X,ce).minor},e.patch=function(X,ce){return new L(X,ce).patch},e.compare=V,e.compareLoose=function(X,ce){return V(X,ce,!0)},e.rcompare=function(X,ce,he){return V(ce,X,he)},e.sort=function(X,ce){return X.sort(function(he,ye){return e.compare(he,ye,ce)})},e.rsort=function(X,ce){return X.sort(function(he,ye){return e.rcompare(he,ye,ce)})},e.gt=x,e.lt=re,e.eq=j,e.neq=ie,e.gte=ne,e.lte=ae,e.cmp=fe,e.Comparator=De;var Le={};function ke(X,ce){if(X instanceof ke)return X.loose===ce?X:new ke(X.raw,ce);if(X instanceof De)return new ke(X.value,ce);if(!(this instanceof ke))return new ke(X,ce);if(this.loose=ce,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Ae(X){return!X||X.toLowerCase()==="x"||X==="*"}function He(X,ce,he,ye,Ee,We,Te,Ne,Be,ze,Ue,qe,Q){return((ce=Ae(he)?"":Ae(ye)?">="+he+".0.0":Ae(Ee)?">="+he+"."+ye+".0":">="+ce)+" "+(Ne=Ae(Be)?"":Ae(ze)?"<"+(+Be+1)+".0.0":Ae(Ue)?"<"+Be+"."+(+ze+1)+".0":qe?"<="+Be+"."+ze+"."+Ue+"-"+qe:"<="+Ne)).trim()}function ge(X,ce){for(var he=0;he<X.length;he++)if(!X[he].test(ce))return!1;if(ce.prerelease.length){for(he=0;he<X.length;he++)if(k(X[he].semver),X[he].semver!==Le&&X[he].semver.prerelease.length>0){var ye=X[he].semver;if(ye.major===ce.major&&ye.minor===ce.minor&&ye.patch===ce.patch)return!0}return!1}return!0}function we(X,ce,he){try{ce=new ke(ce,he)}catch{return!1}return ce.test(X)}function Ce(X,ce,he,ye){var Ee,We,Te,Ne,Be;switch(X=new L(X,ye),ce=new ke(ce,ye),he){case">":Ee=x,We=ae,Te=re,Ne=">",Be=">=";break;case"<":Ee=re,We=ne,Te=x,Ne="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(X,ce,ye))return!1;for(var ze=0;ze<ce.set.length;++ze){var Ue=ce.set[ze],qe=null,Q=null;if(Ue.forEach(function(le){le.semver===Le&&(le=new De(">=0.0.0")),qe=qe||le,Q=Q||le,Ee(le.semver,qe.semver,ye)?qe=le:Te(le.semver,Q.semver,ye)&&(Q=le)}),qe.operator===Ne||qe.operator===Be||(!Q.operator||Q.operator===Ne)&&We(X,Q.semver)||Q.operator===Be&&Te(X,Q.semver))return!1}return!0}De.prototype.parse=function(X){var ce=this.loose?E[K]:E[F],he=X.match(ce);if(!he)throw new TypeError("Invalid comparator: "+X);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new L(he[2],this.loose):this.semver=Le},De.prototype.toString=function(){return this.value},De.prototype.test=function(X){return k("Comparator.test",X,this.loose),this.semver===Le||(typeof X=="string"&&(X=new L(X,this.loose)),fe(X,this.operator,this.semver,this.loose))},De.prototype.intersects=function(X,ce){if(!(X instanceof De))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new ke(X.value,ce),we(this.value,he,ce);if(X.operator==="")return he=new ke(this.value,ce),we(X.semver,he,ce);var ye=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),We=this.semver.version===X.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),Ne=fe(this.semver,"<",X.semver,ce)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),Be=fe(this.semver,">",X.semver,ce)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return ye||Ee||We&&Te||Ne||Be},e.Range=ke,ke.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},ke.prototype.toString=function(){return this.range},ke.prototype.parseRange=function(X){var ce=this.loose;X=X.trim(),k("range",X,ce);var he=ce?E[z]:E[W];X=X.replace(he,He),k("hyphen replace",X),X=X.replace(E[A],"$1$2$3"),k("comparator trim",X,E[A]),X=(X=(X=X.replace(E[$],"$1~")).replace(E[se],"$1^")).split(/\s+/).join(" ");var ye=ce?E[K]:E[F],Ee=X.split(" ").map(function(We){return function(Te,Ne){return k("comp",Te),Te=function(Be,ze){return Be.trim().split(/\s+/).map(function(Ue){return function(qe,Q){k("caret",qe,Q);var le=Q?E[G]:E[de];return qe.replace(le,function(pe,me,Se,Re,Fe){var Ve;return k("caret",qe,pe,me,Se,Re,Fe),Ae(me)?Ve="":Ae(Se)?Ve=">="+me+".0.0 <"+(+me+1)+".0.0":Ae(Re)?Ve=me==="0"?">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0":">="+me+"."+Se+".0 <"+(+me+1)+".0.0":Fe?(k("replaceCaret pr",Fe),Fe.charAt(0)!=="-"&&(Fe="-"+Fe),Ve=me==="0"?Se==="0"?">="+me+"."+Se+"."+Re+Fe+" <"+me+"."+Se+"."+(+Re+1):">="+me+"."+Se+"."+Re+Fe+" <"+me+"."+(+Se+1)+".0":">="+me+"."+Se+"."+Re+Fe+" <"+(+me+1)+".0.0"):(k("no pr"),Ve=me==="0"?Se==="0"?">="+me+"."+Se+"."+Re+" <"+me+"."+Se+"."+(+Re+1):">="+me+"."+Se+"."+Re+" <"+me+"."+(+Se+1)+".0":">="+me+"."+Se+"."+Re+" <"+(+me+1)+".0.0"),k("caret return",Ve),Ve})}(Ue,ze)}).join(" ")}(Te,Ne),k("caret",Te),Te=function(Be,ze){return Be.trim().split(/\s+/).map(function(Ue){return function(qe,Q){var le=Q?E[oe]:E[Y];return qe.replace(le,function(pe,me,Se,Re,Fe){var Ve;return k("tilde",qe,pe,me,Se,Re,Fe),Ae(me)?Ve="":Ae(Se)?Ve=">="+me+".0.0 <"+(+me+1)+".0.0":Ae(Re)?Ve=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0":Fe?(k("replaceTilde pr",Fe),Fe.charAt(0)!=="-"&&(Fe="-"+Fe),Ve=">="+me+"."+Se+"."+Re+Fe+" <"+me+"."+(+Se+1)+".0"):Ve=">="+me+"."+Se+"."+Re+" <"+me+"."+(+Se+1)+".0",k("tilde return",Ve),Ve})}(Ue,ze)}).join(" ")}(Te,Ne),k("tildes",Te),Te=function(Be,ze){return k("replaceXRanges",Be,ze),Be.split(/\s+/).map(function(Ue){return function(qe,Q){qe=qe.trim();var le=Q?E[T]:E[D];return qe.replace(le,function(pe,me,Se,Re,Fe,Ve){k("xRange",qe,pe,me,Se,Re,Fe,Ve);var et=Ae(Se),je=et||Ae(Re),xe=je||Ae(Fe);return me==="="&&xe&&(me=""),et?pe=me===">"||me==="<"?"<0.0.0":"*":me&&xe?(je&&(Re=0),xe&&(Fe=0),me===">"?(me=">=",je?(Se=+Se+1,Re=0,Fe=0):xe&&(Re=+Re+1,Fe=0)):me==="<="&&(me="<",je?Se=+Se+1:Re=+Re+1),pe=me+Se+"."+Re+"."+Fe):je?pe=">="+Se+".0.0 <"+(+Se+1)+".0.0":xe&&(pe=">="+Se+"."+Re+".0 <"+Se+"."+(+Re+1)+".0"),k("xRange return",pe),pe})}(Ue,ze)}).join(" ")}(Te,Ne),k("xrange",Te),Te=function(Be,ze){return k("replaceStars",Be,ze),Be.trim().replace(E[te],"")}(Te,Ne),k("stars",Te),Te}(We,ce)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(We){return!!We.match(ye)})),Ee=Ee.map(function(We){return new De(We,ce)})},ke.prototype.intersects=function(X,ce){if(!(X instanceof ke))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(ye){return X.set.some(function(Ee){return Ee.every(function(We){return ye.intersects(We,ce)})})})})},e.toComparators=function(X,ce){return new ke(X,ce).set.map(function(he){return he.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},ke.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new L(X,this.loose));for(var ce=0;ce<this.set.length;ce++)if(ge(this.set[ce],X))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(X,ce,he){var ye=null,Ee=null;try{var We=new ke(ce,he)}catch{return null}return X.forEach(function(Te){We.test(Te)&&(ye&&Ee.compare(Te)!==-1||(Ee=new L(ye=Te,he)))}),ye},e.minSatisfying=function(X,ce,he){var ye=null,Ee=null;try{var We=new ke(ce,he)}catch{return null}return X.forEach(function(Te){We.test(Te)&&(ye&&Ee.compare(Te)!==1||(Ee=new L(ye=Te,he)))}),ye},e.validRange=function(X,ce){try{return new ke(X,ce).range||"*"}catch{return null}},e.ltr=function(X,ce,he){return Ce(X,ce,"<",he)},e.gtr=function(X,ce,he){return Ce(X,ce,">",he)},e.outside=Ce,e.prerelease=function(X,ce){var he=H(X,ce);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(X,ce,he){return X=new ke(X,he),ce=new ke(ce,he),X.intersects(ce)},e.coerce=function(X){if(X instanceof L)return X;if(typeof X!="string")return null;var ce=X.match(E[N]);return ce==null?null:H((ce[1]||"0")+"."+(ce[2]||"0")+"."+(ce[3]||"0"))}}).call(this,v(1))},function(q,e){var v,t,k=q.exports={};function R(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function E(C){if(v===setTimeout)return setTimeout(C,0);if((v===R||!v)&&setTimeout)return v=setTimeout,setTimeout(C,0);try{return v(C,0)}catch{try{return v.call(null,C,0)}catch{return v.call(this,C,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:R}catch{v=R}try{t=typeof clearTimeout=="function"?clearTimeout:M}catch{t=M}})();var l,m=[],I=!1,b=-1;function y(){I&&l&&(I=!1,l.length?m=l.concat(m):b=-1,m.length&&h())}function h(){if(!I){var C=E(y);I=!0;for(var w=m.length;w;){for(l=m,m=[];++b<w;)l&&l[b].run();b=-1,w=m.length}l=null,I=!1,function(p){if(t===clearTimeout)return clearTimeout(p);if((t===M||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(p);try{t(p)}catch{try{return t.call(null,p)}catch{return t.call(this,p)}}}(C)}}function d(C,w){this.fun=C,this.array=w}function S(){}k.nextTick=function(C){var w=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)w[p-1]=arguments[p];m.push(new d(C,w)),m.length!==1||I||E(h)},d.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=S,k.addListener=S,k.once=S,k.off=S,k.removeListener=S,k.removeAllListeners=S,k.emit=S,k.prependListener=S,k.prependOnceListener=S,k.listeners=function(C){return[]},k.binding=function(C){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(C){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Z[126],ee([0,1]),function(q,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(E,l,m){this.level=E,this.key=l,this.value=m,this.forward=[]}}const k=void 0;class R{constructor(E,l=2**16){this.comparator=E,this[v]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new t(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,k,k)}has(E){return Boolean(R._search(this,E,this.comparator))}get(E){return R._search(this,E,this.comparator)?.value}set(E,l){return R._insert(this,E,l,this.comparator)&&(this._size+=1),this}delete(E){const l=R._delete(this,E,this.comparator);return l&&(this._size-=1),l}forEach(E,l){let m=this._header.forward[0];for(;m;)E.call(l,m.value,m.key,this),m=m.forward[0]}[(v=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this._header.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this._header.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this._header.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",l=this._header.forward[0];for(;l;)E+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return E}static _search(E,l,m){let I=E._header;for(let b=E._level-1;b>=0;b--)for(;I.forward[b]&&m(I.forward[b].key,l)<0;)I=I.forward[b];if(I=I.forward[0],I&&m(I.key,l)===0)return I}static _insert(E,l,m,I){const b=[];let y=E._header;for(let h=E._level-1;h>=0;h--){for(;y.forward[h]&&I(y.forward[h].key,l)<0;)y=y.forward[h];b[h]=y}if(y=y.forward[0],y&&I(y.key,l)===0)return y.value=m,!1;{const h=R._randomLevel(E);if(h>E._level){for(let d=E._level;d<h;d++)b[d]=E._header;E._level=h}y=new t(h,l,m);for(let d=0;d<h;d++)y.forward[d]=b[d].forward[d],b[d].forward[d]=y;return!0}}static _randomLevel(E,l=.5){let m=1;for(;Math.random()<l&&m<E._maxLevel;)m+=1;return m}static _delete(E,l,m){const I=[];let b=E._header;for(let y=E._level-1;y>=0;y--){for(;b.forward[y]&&m(b.forward[y].key,l)<0;)b=b.forward[y];I[y]=b}if(b=b.forward[0],!b||m(b.key,l)!==0)return!1;for(let y=0;y<E._level&&I[y].forward[y]===b;y++)I[y].forward[y]=b.forward[y];for(;E._level>0&&E._header.forward[E._level-1]===k;)E._level-=1;return!0}}e.SkipList=R}),define(Z[58],ee([0,1,17,2]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(g){const a=g;return a?typeof a.read=="function":!1}e.isReadable=k;function R(g){const a=g;return a?[a.on,a.pause,a.resume,a.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=R;function M(g){const a=g;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=M;function E(g,a){return new l(g,a)}e.newWriteableStream=E;class l{constructor(a,n){this.reducer=a,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a<"u"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(n=>n(a))}emitError(a){this.listeners.error.length===0?(0,v.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(n=>n(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,n){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(a,n){if(this.state.destroyed)return;let o;switch(a){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const i=o.indexOf(n);i>=0&&o.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(g,a){const n=[];let o;for(;(o=g.read())!==null;)n.push(o);return a(n)}e.consumeReadable=m;function I(g,a,n){const o=[];let i;for(;(i=g.read())!==null&&o.length<n;)o.push(i);return i===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof i<"u"){const r=i;return i=void 0,r}return g.read()}}}e.peekReadable=I;function b(g,a){return new Promise((n,o)=>{const i=[];y(g,{onData:r=>{a&&i.push(r)},onError:r=>{a?o(r):n(void 0)},onEnd:()=>{n(a?a(i):void 0)}})})}e.consumeStream=b;function y(g,a){let n=!1;return g.on("error",o=>{n||a.onError(o)}),g.on("end",()=>{n||a.onEnd()}),g.on("data",o=>{n||a.onData(o)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=y;function h(g,a){return new Promise((n,o)=>{const i=new t.DisposableStore,r=[],s=P=>{if(r.push(P),r.length>a)return i.dispose(),g.pause(),n({stream:g,buffer:r,ended:!1})},c=P=>o(P),u=()=>n({stream:g,buffer:r,ended:!0});i.add((0,t.toDisposable)(()=>g.removeListener("error",c))),g.on("error",c),i.add((0,t.toDisposable)(()=>g.removeListener("end",u))),g.on("end",u),i.add((0,t.toDisposable)(()=>g.removeListener("data",s))),g.on("data",s)})}e.peekStream=h;function d(g,a){const n=E(a);return n.end(g),n}e.toStream=d;function S(){const g=E(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=S;function C(g){let a=!1;return{read:()=>a?null:(a=!0,g)}}e.toReadable=C;function w(g,a,n){const o=E(n);return y(g,{onData:i=>o.write(a.data(i)),onError:i=>o.error(a.error?a.error(i):i),onEnd:()=>o.end()}),o}e.transform=w;function p(g,a,n){let o=!1;return{read:()=>{const i=a.read();return o?i:(o=!0,i!==null?n([g,i]):g)}}}e.prefixedReadable=p;function f(g,a,n){let o=!1;const i=E(n);return y(a,{onData:r=>o?i.write(r):(o=!0,i.write(n([g,r]))),onError:r=>i.error(r),onEnd:()=>{o||(o=!0,i.write(g)),i.end()}}),i}e.prefixedStream=f}),define(Z[18],ee([0,1,58]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,R;class M{constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}static alloc(P){return t?new M(Buffer.allocUnsafe(P)):new M(new Uint8Array(P))}static wrap(P){return t&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new M(P)}static fromString(P,D){return!(D?.dontUseNodeBuffer||!1)&&t?new M(Buffer.from(P)):(k||(k=new TextEncoder),new M(k.encode(P)))}static fromByteArray(P){const D=M.alloc(P.length);for(let T=0,N=P.length;T<N;T++)D.buffer[T]=P[T];return D}static concat(P,D){if(typeof D>"u"){D=0;for(let U=0,$=P.length;U<$;U++)D+=P[U].byteLength}const T=M.alloc(D);let N=0;for(let U=0,$=P.length;U<$;U++){const Y=P[U];T.set(Y,N),N+=Y.byteLength}return T}clone(){const P=M.alloc(this.byteLength);return P.set(this),P}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(P,D){return new M(this.buffer.subarray(P,D))}set(P,D){if(P instanceof M)this.buffer.set(P.buffer,D);else if(P instanceof Uint8Array)this.buffer.set(P,D);else if(P instanceof ArrayBuffer)this.buffer.set(new Uint8Array(P),D);else if(ArrayBuffer.isView(P))this.buffer.set(new Uint8Array(P.buffer,P.byteOffset,P.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(P){return m(this.buffer,P)}writeUInt32BE(P,D){I(this.buffer,P,D)}readUInt32LE(P){return b(this.buffer,P)}writeUInt32LE(P,D){y(this.buffer,P,D)}readUInt8(P){return h(this.buffer,P)}writeUInt8(P,D){d(this.buffer,P,D)}}e.VSBuffer=M;function E(u,P){return u[P+0]<<0>>>0|u[P+1]<<8>>>0}e.readUInt16LE=E;function l(u,P,D){u[D+0]=P&255,P=P>>>8,u[D+1]=P&255}e.writeUInt16LE=l;function m(u,P){return u[P]*2**24+u[P+1]*2**16+u[P+2]*2**8+u[P+3]}e.readUInt32BE=m;function I(u,P,D){u[D+3]=P,P=P>>>8,u[D+2]=P,P=P>>>8,u[D+1]=P,P=P>>>8,u[D]=P}e.writeUInt32BE=I;function b(u,P){return u[P+0]<<0>>>0|u[P+1]<<8>>>0|u[P+2]<<16>>>0|u[P+3]<<24>>>0}e.readUInt32LE=b;function y(u,P,D){u[D+0]=P&255,P=P>>>8,u[D+1]=P&255,P=P>>>8,u[D+2]=P&255,P=P>>>8,u[D+3]=P&255}e.writeUInt32LE=y;function h(u,P){return u[P]}e.readUInt8=h;function d(u,P,D){u[D]=P}e.writeUInt8=d;function S(u){return v.consumeReadable(u,P=>M.concat(P))}e.readableToBuffer=S;function C(u){return v.toReadable(u)}e.bufferToReadable=C;function w(u){return v.consumeStream(u,P=>M.concat(P))}e.streamToBuffer=w;async function p(u){return u.ended?M.concat(u.buffer):M.concat([...u.buffer,await w(u.stream)])}e.bufferedStreamToBuffer=p;function f(u){return v.toStream(u,P=>M.concat(P))}e.bufferToStream=f;function g(u){return v.transform(u,{data:P=>typeof P=="string"?M.fromString(P):M.wrap(P)},P=>M.concat(P))}e.streamToBufferReadableStream=g;function a(u){return v.newWriteableStream(P=>M.concat(P),u)}e.newWriteableBufferStream=a;function n(u,P){return v.prefixedReadable(u,P,D=>M.concat(D))}e.prefixedBufferReadable=n;function o(u,P){return v.prefixedStream(u,P,D=>M.concat(D))}e.prefixedBufferStream=o;function i(u){let P=0,D=0,T=0;const N=new Uint8Array(Math.floor(u.length/4*3)),U=Y=>{switch(D){case 3:N[T++]=P|Y,D=0;break;case 2:N[T++]=P|Y>>>2,P=Y<<6,D=3;break;case 1:N[T++]=P|Y>>>4,P=Y<<4,D=2;break;default:P=Y<<2,D=1}};for(let Y=0;Y<u.length;Y++){const oe=u.charCodeAt(Y);if(oe>=65&&oe<=90)U(oe-65);else if(oe>=97&&oe<=122)U(oe-97+26);else if(oe>=48&&oe<=57)U(oe-48+52);else if(oe===43||oe===45)U(62);else if(oe===47||oe===95)U(63);else{if(oe===61)break;throw new SyntaxError(`Unexpected base64 character ${u[Y]}`)}}const $=T;for(;D>0;)U(0);return M.wrap(N).slice(0,$)}e.decodeBase64=i;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:u},P=!0,D=!1){const T=D?s:r;let N="";const U=u.byteLength%3;let $=0;for(;$<u.byteLength-U;$+=3){const Y=u[$+0],oe=u[$+1],ue=u[$+2];N+=T[Y>>>2],N+=T[(Y<<4|oe>>>4)&63],N+=T[(oe<<2|ue>>>6)&63],N+=T[ue&63]}if(U===1){const Y=u[$+0];N+=T[Y>>>2],N+=T[Y<<4&63],P&&(N+="==")}else if(U===2){const Y=u[$+0],oe=u[$+1];N+=T[Y>>>2],N+=T[(Y<<4|oe>>>4)&63],N+=T[oe<<2&63],P&&(N+="=")}return N}e.encodeBase64=c}),define(Z[12],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function v(o){return typeof o=="string"}e.isString=v;function t(o){return Array.isArray(o)&&o.every(i=>v(i))}e.isStringArray=t;function k(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=k;function R(o){const i=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof i}e.isTypedArray=R;function M(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=M;function E(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=E;function l(o){return o===!0||o===!1}e.isBoolean=l;function m(o){return typeof o>"u"}e.isUndefined=m;function I(o){return!b(o)}e.isDefined=I;function b(o){return m(o)||o===null}e.isUndefinedOrNull=b;function y(o,i){if(!o)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=y;function h(o){if(b(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=h;function d(...o){const i=[];for(let r=0;r<o.length;r++){const s=o[r];if(b(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);i.push(s)}return i}e.assertAllDefined=d;const S=Object.prototype.hasOwnProperty;function C(o){if(!k(o))return!1;for(const i in o)if(S.call(o,i))return!1;return!0}e.isEmptyObject=C;function w(o){return typeof o=="function"}e.isFunction=w;function p(...o){return o.length>0&&o.every(w)}e.areFunctions=p;function f(o,i){const r=Math.min(o.length,i.length);for(let s=0;s<r;s++)g(o[s],i[s])}e.validateConstraints=f;function g(o,i){if(v(i)){if(typeof o!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(w(i)){try{if(o instanceof i)return}catch{}if(!b(o)&&o.constructor===i||i.length===1&&i.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=g;function a(o){return o===null?void 0:o}e.withNullAsUndefined=a;function n(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=n}),define(Z[50],ee([0,1,12]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const p=Array.isArray(w)?[]:{};return Object.keys(w).forEach(f=>{w[f]&&typeof w[f]=="object"?p[f]=t(w[f]):p[f]=w[f]}),p}e.deepClone=t;function k(w){if(!w||typeof w!="object")return w;const p=[w];for(;p.length>0;){const f=p.shift();Object.freeze(f);for(const g in f)if(R.call(f,g)){const a=f[g];typeof a=="object"&&!Object.isFrozen(a)&&!(0,v.isTypedArray)(a)&&p.push(a)}}return w}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function M(w,p){return E(w,p,new Set)}e.cloneAndChange=M;function E(w,p,f){if((0,v.isUndefinedOrNull)(w))return w;const g=p(w);if(typeof g<"u")return g;if(Array.isArray(w)){const a=[];for(const n of w)a.push(E(n,p,f));return a}if((0,v.isObject)(w)){if(f.has(w))throw new Error("Cannot clone recursive data-structure");f.add(w);const a={};for(const n in w)R.call(w,n)&&(a[n]=E(w[n],p,f));return f.delete(w),a}return w}function l(w,p,f=!0){return(0,v.isObject)(w)?((0,v.isObject)(p)&&Object.keys(p).forEach(g=>{g in w?f&&((0,v.isObject)(w[g])&&(0,v.isObject)(p[g])?l(w[g],p[g],f):w[g]=p[g]):w[g]=p[g]}),w):p}e.mixin=l;function m(w,p){if(w===p)return!0;if(w==null||p===null||p===void 0||typeof w!=typeof p||typeof w!="object"||Array.isArray(w)!==Array.isArray(p))return!1;let f,g;if(Array.isArray(w)){if(w.length!==p.length)return!1;for(f=0;f<w.length;f++)if(!m(w[f],p[f]))return!1}else{const a=[];for(g in w)a.push(g);a.sort();const n=[];for(g in p)n.push(g);if(n.sort(),!m(a,n))return!1;for(f=0;f<a.length;f++)if(!m(w[a[f]],p[a[f]]))return!1}return!0}e.equals=m;function I(w){const p=new Set;return JSON.stringify(w,(f,g)=>{if((0,v.isObject)(g)||Array.isArray(g)){if(p.has(g))return"[Circular]";p.add(g)}return g})}e.safeStringify=I;function b(w,p){const f=Object.create(null);return!w||!p||Object.keys(p).forEach(a=>{const n=w[a],o=p[a];m(n,o)||(f[a]=o)}),f}e.distinct=b;function y(w,p){const f=p.toLowerCase(),g=Object.keys(w).find(a=>a.toLowerCase()===f);return g?w[g]:w[p]}e.getCaseInsensitive=y;function h(w,p){const f=Object.create(null);for(const[g,a]of Object.entries(w))p(g,a)&&(f[g]=a);return f}e.filter=h;function d(w){let p=[],f=Object.getPrototypeOf(w);for(;Object.prototype!==f;)p=p.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return p}e.getAllPropertyNames=d;function S(w){const p=[];for(const f of d(w))typeof w[f]=="function"&&p.push(f);return p}e.getAllMethodNames=S;function C(w,p){const f=a=>function(){const n=Array.prototype.slice.call(arguments,0);return p(a,n)},g={};for(const a of w)g[a]=f(a);return g}e.createProxyObject=C}),define(Z[29],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return v.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(E){for(let l=0;l<E.length;l++)E[l]=Math.floor(Math.random()*256);return E};const R=new Uint8Array(16),M=[];for(let E=0;E<256;E++)M.push(E.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let l=0,m="";return m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+="-",m+=M[R[l++]],m+=M[R[l++]],m+="-",m+=M[R[l++]],m+=M[R[l++]],m+="-",m+=M[R[l++]],m+=M[R[l++]],m+="-",m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m+=M[R[l++]],m}}()}),define(Z[127],ee([0,1,76,40,49]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(M,E){if(await new Promise((I,b)=>{const y=t.createReadStream(M),h=v.createHash("sha1");y.pipe(h);const d=(0,k.once)((S,C)=>{y.removeAllListeners(),h.removeAllListeners(),S?b(S):I(C)});y.once("error",d),y.once("end",d),h.once("error",d),h.once("data",S=>d(void 0,S.toString("hex")))})!==E)throw new Error("Hash mismatch")}e.checksum=R}),define(Z[128],ee([0,1,28]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(M){const E=M.replace(/\-/g,":").toLowerCase();return!t.has(E)}function R(){const M=(0,v.networkInterfaces)();for(const E in M){const l=M[E];if(l){for(const{mac:m}of l)if(k(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(Z[93],ee([0,1,77]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(E,l,m,I=1){let b=!1;return new Promise(y=>{const h=setTimeout(()=>{if(!b)return b=!0,y(0)},m);k(E,l,I,d=>{if(!b)return b=!0,clearTimeout(h),y(d)})})}e.findFreePort=t;function k(E,l,m,I){if(l===0)return I(0);const b=new v.Socket;b.once("connect",()=>(M(b),k(E+m,l-1,m,I))),b.once("data",()=>{}),b.once("error",y=>(M(b),y.code!=="ECONNREFUSED"?k(E+m,l-1,m,I):I(E))),b.connect(E,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(E,l,m){let I=!1,b,y=1;const h=v.createServer({pauseOnConnect:!0});function d(S,C){I||(I=!0,h.removeAllListeners(),h.close(),b&&clearTimeout(b),C(S))}return new Promise(S=>{b=setTimeout(()=>{d(0,S)},m),h.on("listening",()=>{d(E,S)}),h.on("error",C=>{C&&(C.code==="EADDRINUSE"||C.code==="EACCES")&&y<l?(E++,y++,h.listen(E,"127.0.0.1")):d(0,S)}),h.on("close",()=>{d(0,S)}),h.listen(E,"127.0.0.1")})}e.findFreePortFaster=R;function M(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(l){console.error(l)}}}),define(Z[129],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[130],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(k,R){this.sender=k,this.onMessage=R}send(k){try{this.sender.send("vscode:message",k.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(Z[41],ee([0,1,15,17]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(M,E){const l=(m,...I)=>{this.validateEvent(M,m)&&E(m,...I)};return this.mapListenerToWrapper.set(E,l),v.ipcMain.on(M,l),this}once(M,E){return v.ipcMain.once(M,(l,...m)=>{this.validateEvent(M,l)&&E(l,...m)}),this}handle(M,E){return v.ipcMain.handle(M,(l,...m)=>this.validateEvent(M,l)?E(l,...m):Promise.reject(`Invalid channel '${M}' or sender for ipcMain.handle() usage.`)),this}removeHandler(M){return v.ipcMain.removeHandler(M),this}removeListener(M,E){const l=this.mapListenerToWrapper.get(E);return l&&(v.ipcMain.removeListener(M,l),this.mapListenerToWrapper.delete(E)),this}validateEvent(M,E){if(!M||!M.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because the channel is unknown.`),!1;const l=E.senderFrame,m=l.url;if(!m)return!0;let I="unknown";try{I=new URL(m).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a malformed URL '${m}'.`),!1}return I!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a bad origin of '${I}'.`),!1):l.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because sender of origin '${I}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(Z[131],ee([0,1,15,41,12,129]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(l,m,I,b,y)=>{const h=E(l,b,I);h.popup({window:(0,k.withNullAsUndefined)(v.BrowserWindow.fromWebContents(l.sender)),x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{h&&l.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,m)}})})}e.registerContextMenuListener=M;function E(l,m,I){const b=new v.Menu;return I.forEach(y=>{let h;y.type==="separator"?h=new v.MenuItem({type:y.type}):Array.isArray(y.submenu)?h=new v.MenuItem({submenu:E(l,m,y.submenu),label:y.label}):h=new v.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(d,S,C)=>l.sender.send(m,y.id,C)}),b.append(h)}),b}}),define(Z[132],ee([11,10]),function(q,e){return q.create("vs/base/common/date",e)}),define(Z[133],ee([0,1,132]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,M=R*7,E=R*30,l=R*365;function m(b,y,h){typeof b!="number"&&(b=b.getTime());const d=Math.round((new Date().getTime()-b)/1e3);if(d<-30)return(0,v.localize)(0,null,m(new Date().getTime()+d*1e3,!1));if(d<30)return(0,v.localize)(1,null);let S;return d<t?(S=d,y?S===1?h?(0,v.localize)(2,null,S):(0,v.localize)(3,null,S):h?(0,v.localize)(4,null,S):(0,v.localize)(5,null,S):S===1?h?(0,v.localize)(6,null,S):(0,v.localize)(7,null,S):h?(0,v.localize)(8,null,S):(0,v.localize)(9,null,S)):d<k?(S=Math.floor(d/t),y?S===1?h?(0,v.localize)(10,null,S):(0,v.localize)(11,null,S):h?(0,v.localize)(12,null,S):(0,v.localize)(13,null,S):S===1?h?(0,v.localize)(14,null,S):(0,v.localize)(15,null,S):h?(0,v.localize)(16,null,S):(0,v.localize)(17,null,S)):d<R?(S=Math.floor(d/k),y?S===1?h?(0,v.localize)(18,null,S):(0,v.localize)(19,null,S):h?(0,v.localize)(20,null,S):(0,v.localize)(21,null,S):S===1?h?(0,v.localize)(22,null,S):(0,v.localize)(23,null,S):h?(0,v.localize)(24,null,S):(0,v.localize)(25,null,S)):d<M?(S=Math.floor(d/R),y?S===1?(0,v.localize)(26,null,S):(0,v.localize)(27,null,S):S===1?(0,v.localize)(28,null,S):(0,v.localize)(29,null,S)):d<E?(S=Math.floor(d/M),y?S===1?h?(0,v.localize)(30,null,S):(0,v.localize)(31,null,S):h?(0,v.localize)(32,null,S):(0,v.localize)(33,null,S):S===1?h?(0,v.localize)(34,null,S):(0,v.localize)(35,null,S):h?(0,v.localize)(36,null,S):(0,v.localize)(37,null,S)):d<l?(S=Math.floor(d/E),y?S===1?h?(0,v.localize)(38,null,S):(0,v.localize)(39,null,S):h?(0,v.localize)(40,null,S):(0,v.localize)(41,null,S):S===1?h?(0,v.localize)(42,null,S):(0,v.localize)(43,null,S):h?(0,v.localize)(44,null,S):(0,v.localize)(45,null,S)):(S=Math.floor(d/l),y?S===1?h?(0,v.localize)(46,null,S):(0,v.localize)(47,null,S):h?(0,v.localize)(48,null,S):(0,v.localize)(49,null,S):S===1?h?(0,v.localize)(50,null,S):(0,v.localize)(51,null,S):h?(0,v.localize)(52,null,S):(0,v.localize)(53,null,S))}e.fromNow=m;function I(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(Z[134],ee([11,10]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(Z[44],ee([0,1,24,12,134]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(b,y){return y&&(b.stack||b.stacktrace)?k.localize(0,null,E(b),M(b.stack)||M(b.stacktrace)):E(b)}function M(b){return Array.isArray(b)?b.join(`
`):b}function E(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?k.localize(1,null,b.message):b.message||k.localize(2,null)}function l(b=null,y=!1){if(!b)return k.localize(3,null);if(Array.isArray(b)){const h=v.coalesce(b),d=l(h[0],y);return h.length>1?k.localize(4,null,d,h.length):d}if(t.isString(b))return b;if(b.detail){const h=b.detail;if(h.error)return R(h.error,y);if(h.exception)return R(h.exception,y)}return b.stack?R(b,y):b.message?b.message:k.localize(5,null)}e.toErrorMessage=l;function m(b){const y=b;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=m;function I(b,y){let h;return typeof b=="string"?h=new Error(b):h=b,h.actions=y,h}e.createErrorWithActions=I}),define(Z[135],ee([11,10]),function(q,e){return q.create("vs/base/common/jsonErrorMessages",e)}),define(Z[136],ee([0,1,135]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,v.localize)(0,null);case 2:return(0,v.localize)(1,null);case 3:return(0,v.localize)(2,null);case 4:return(0,v.localize)(3,null);case 5:return(0,v.localize)(4,null);case 6:return(0,v.localize)(5,null);case 7:return(0,v.localize)(6,null);case 8:return(0,v.localize)(7,null);case 9:return(0,v.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(Z[137],ee([11,10]),function(q,e){return q.create("vs/base/common/platform",e)}),define(Z[4],ee([0,1,137]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let k=!1,R=!1,M=!1,E=!1,l=!1,m=!1,I=!1,b=!1,y=!1,h,d=t,S,C;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?w=e.globals.vscode.process:typeof process<"u"&&(w=process);const p=typeof w?.versions?.electron=="string",f=p&&w?.type==="renderer";if(typeof navigator=="object"&&!f)C=navigator.userAgent,k=C.indexOf("Windows")>=0,R=C.indexOf("Macintosh")>=0,b=(C.indexOf("Macintosh")>=0||C.indexOf("iPad")>=0||C.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=C.indexOf("Linux")>=0,m=!0,h=v.getConfiguredDefaultLocale(v.localize(0,null))||t,d=h;else if(typeof w=="object"){k=w.platform==="win32",R=w.platform==="darwin",M=w.platform==="linux",E=M&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,I=p,y=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=t,d=t;const u=w.env.VSCODE_NLS_CONFIG;if(u)try{const P=JSON.parse(u),D=P.availableLanguages["*"];h=P.locale,d=D||t,S=P._translationsConfigFile}catch{}l=!0}else console.error("Unable to resolve platform.");var g;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function a(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=a;let n=0;R?n=1:k?n=3:M&&(n=2),e.isWindows=k,e.isMacintosh=R,e.isLinux=M,e.isLinuxSnap=E,e.isNative=l,e.isElectron=I,e.isWeb=m,e.isWebWorker=m&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isCI=y,e.platform=n,e.userAgent=C,e.language=d;var o;(function(u){function P(){return e.language}u.value=P;function D(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=D;function T(){return e.language==="en"}u.isDefault=T})(o=e.Language||(e.Language={})),e.locale=h,e.translationsConfigFile=S,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const u=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let T=0,N=u.length;T<N;T++){const U=u[T];if(U.id===D.data.vscodeScheduleAsyncWork){u.splice(T,1),U.callback();return}}});let P=0;return D=>{const T=++P;u.push({id:T,callback:D}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return u=>setTimeout(u)})();var i;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||b?2:k?1:3;let r=!0,s=!1;function c(){if(!s){s=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,r=new Uint16Array(u.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Z[33],ee([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof v.globals.vscode<"u"&&typeof v.globals.vscode.process<"u"){const k=v.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Z[9],ee([0,1,33]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,M=122,E=46,l=47,m=92,I=58,b=63;class y extends Error{constructor(g,a,n){let o;typeof a=="string"&&a.indexOf("not ")===0?(o="must not be",a=a.replace(/^not /,"")):o="must be";const i=g.indexOf(".")!==-1?"property":"argument";let r=`The "${g}" ${i} ${o} of type ${a}`;r+=`. Received type ${typeof n}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function h(f,g){if(typeof f!="string")throw new y(g,"string",f)}function d(f){return f===l||f===m}function S(f){return f===l}function C(f){return f>=t&&f<=R||f>=k&&f<=M}function w(f,g,a,n){let o="",i=0,r=-1,s=0,c=0;for(let u=0;u<=f.length;++u){if(u<f.length)c=f.charCodeAt(u);else{if(n(c))break;c=l}if(n(c)){if(!(r===u-1||s===1))if(s===2){if(o.length<2||i!==2||o.charCodeAt(o.length-1)!==E||o.charCodeAt(o.length-2)!==E){if(o.length>2){const P=o.lastIndexOf(a);P===-1?(o="",i=0):(o=o.slice(0,P),i=o.length-1-o.lastIndexOf(a)),r=u,s=0;continue}else if(o.length!==0){o="",i=0,r=u,s=0;continue}}g&&(o+=o.length>0?`${a}..`:"..",i=2)}else o.length>0?o+=`${a}${f.slice(r+1,u)}`:o=f.slice(r+1,u),i=u-r-1;r=u,s=0}else c===E&&s!==-1?++s:s=-1}return o}function p(f,g){if(g===null||typeof g!="object")throw new y("pathObject","Object",g);const a=g.dir||g.root,n=g.base||`${g.name||""}${g.ext||""}`;return a?a===g.root?`${a}${n}`:`${a}${f}${n}`:n}e.win32={resolve(...f){let g="",a="",n=!1;for(let o=f.length-1;o>=-1;o--){let i;if(o>=0){if(i=f[o],h(i,"path"),i.length===0)continue}else g.length===0?i=v.cwd():(i=v.env[`=${g}`]||v.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==g.toLowerCase()&&i.charCodeAt(2)===m)&&(i=`${g}\\`));const r=i.length;let s=0,c="",u=!1;const P=i.charCodeAt(0);if(r===1)d(P)&&(s=1,u=!0);else if(d(P))if(u=!0,d(i.charCodeAt(1))){let D=2,T=D;for(;D<r&&!d(i.charCodeAt(D));)D++;if(D<r&&D!==T){const N=i.slice(T,D);for(T=D;D<r&&d(i.charCodeAt(D));)D++;if(D<r&&D!==T){for(T=D;D<r&&!d(i.charCodeAt(D));)D++;(D===r||D!==T)&&(c=`\\\\${N}\\${i.slice(T,D)}`,s=D)}}}else s=1;else C(P)&&i.charCodeAt(1)===I&&(c=i.slice(0,2),s=2,r>2&&d(i.charCodeAt(2))&&(u=!0,s=3));if(c.length>0)if(g.length>0){if(c.toLowerCase()!==g.toLowerCase())continue}else g=c;if(n){if(g.length>0)break}else if(a=`${i.slice(s)}\\${a}`,n=u,u&&g.length>0)break}return a=w(a,!n,"\\",d),n?`${g}\\${a}`:`${g}${a}`||"."},normalize(f){h(f,"path");const g=f.length;if(g===0)return".";let a=0,n,o=!1;const i=f.charCodeAt(0);if(g===1)return S(i)?"\\":f;if(d(i))if(o=!0,d(f.charCodeAt(1))){let s=2,c=s;for(;s<g&&!d(f.charCodeAt(s));)s++;if(s<g&&s!==c){const u=f.slice(c,s);for(c=s;s<g&&d(f.charCodeAt(s));)s++;if(s<g&&s!==c){for(c=s;s<g&&!d(f.charCodeAt(s));)s++;if(s===g)return`\\\\${u}\\${f.slice(c)}\\`;s!==c&&(n=`\\\\${u}\\${f.slice(c,s)}`,a=s)}}}else a=1;else C(i)&&f.charCodeAt(1)===I&&(n=f.slice(0,2),a=2,g>2&&d(f.charCodeAt(2))&&(o=!0,a=3));let r=a<g?w(f.slice(a),!o,"\\",d):"";return r.length===0&&!o&&(r="."),r.length>0&&d(f.charCodeAt(g-1))&&(r+="\\"),n===void 0?o?`\\${r}`:r:o?`${n}\\${r}`:`${n}${r}`},isAbsolute(f){h(f,"path");const g=f.length;if(g===0)return!1;const a=f.charCodeAt(0);return d(a)||g>2&&C(a)&&f.charCodeAt(1)===I&&d(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let g,a;for(let i=0;i<f.length;++i){const r=f[i];h(r,"path"),r.length>0&&(g===void 0?g=a=r:g+=`\\${r}`)}if(g===void 0)return".";let n=!0,o=0;if(typeof a=="string"&&d(a.charCodeAt(0))){++o;const i=a.length;i>1&&d(a.charCodeAt(1))&&(++o,i>2&&(d(a.charCodeAt(2))?++o:n=!1))}if(n){for(;o<g.length&&d(g.charCodeAt(o));)o++;o>=2&&(g=`\\${g.slice(o)}`)}return e.win32.normalize(g)},relative(f,g){if(h(f,"from"),h(g,"to"),f===g)return"";const a=e.win32.resolve(f),n=e.win32.resolve(g);if(a===n||(f=a.toLowerCase(),g=n.toLowerCase(),f===g))return"";let o=0;for(;o<f.length&&f.charCodeAt(o)===m;)o++;let i=f.length;for(;i-1>o&&f.charCodeAt(i-1)===m;)i--;const r=i-o;let s=0;for(;s<g.length&&g.charCodeAt(s)===m;)s++;let c=g.length;for(;c-1>s&&g.charCodeAt(c-1)===m;)c--;const u=c-s,P=r<u?r:u;let D=-1,T=0;for(;T<P;T++){const U=f.charCodeAt(o+T);if(U!==g.charCodeAt(s+T))break;U===m&&(D=T)}if(T!==P){if(D===-1)return n}else{if(u>P){if(g.charCodeAt(s+T)===m)return n.slice(s+T+1);if(T===2)return n.slice(s+T)}r>P&&(f.charCodeAt(o+T)===m?D=T:T===2&&(D=3)),D===-1&&(D=0)}let N="";for(T=o+D+1;T<=i;++T)(T===i||f.charCodeAt(T)===m)&&(N+=N.length===0?"..":"\\..");return s+=D,N.length>0?`${N}${n.slice(s,c)}`:(n.charCodeAt(s)===m&&++s,n.slice(s,c))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const g=e.win32.resolve(f);if(g.length<=2)return f;if(g.charCodeAt(0)===m){if(g.charCodeAt(1)===m){const a=g.charCodeAt(2);if(a!==b&&a!==E)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(C(g.charCodeAt(0))&&g.charCodeAt(1)===I&&g.charCodeAt(2)===m)return`\\\\?\\${g}`;return f},dirname(f){h(f,"path");const g=f.length;if(g===0)return".";let a=-1,n=0;const o=f.charCodeAt(0);if(g===1)return d(o)?f:".";if(d(o)){if(a=n=1,d(f.charCodeAt(1))){let s=2,c=s;for(;s<g&&!d(f.charCodeAt(s));)s++;if(s<g&&s!==c){for(c=s;s<g&&d(f.charCodeAt(s));)s++;if(s<g&&s!==c){for(c=s;s<g&&!d(f.charCodeAt(s));)s++;if(s===g)return f;s!==c&&(a=n=s+1)}}}}else C(o)&&f.charCodeAt(1)===I&&(a=g>2&&d(f.charCodeAt(2))?3:2,n=a);let i=-1,r=!0;for(let s=g-1;s>=n;--s)if(d(f.charCodeAt(s))){if(!r){i=s;break}}else r=!1;if(i===-1){if(a===-1)return".";i=a}return f.slice(0,i)},basename(f,g){g!==void 0&&h(g,"ext"),h(f,"path");let a=0,n=-1,o=!0,i;if(f.length>=2&&C(f.charCodeAt(0))&&f.charCodeAt(1)===I&&(a=2),g!==void 0&&g.length>0&&g.length<=f.length){if(g===f)return"";let r=g.length-1,s=-1;for(i=f.length-1;i>=a;--i){const c=f.charCodeAt(i);if(d(c)){if(!o){a=i+1;break}}else s===-1&&(o=!1,s=i+1),r>=0&&(c===g.charCodeAt(r)?--r===-1&&(n=i):(r=-1,n=s))}return a===n?n=s:n===-1&&(n=f.length),f.slice(a,n)}for(i=f.length-1;i>=a;--i)if(d(f.charCodeAt(i))){if(!o){a=i+1;break}}else n===-1&&(o=!1,n=i+1);return n===-1?"":f.slice(a,n)},extname(f){h(f,"path");let g=0,a=-1,n=0,o=-1,i=!0,r=0;f.length>=2&&f.charCodeAt(1)===I&&C(f.charCodeAt(0))&&(g=n=2);for(let s=f.length-1;s>=g;--s){const c=f.charCodeAt(s);if(d(c)){if(!i){n=s+1;break}continue}o===-1&&(i=!1,o=s+1),c===E?a===-1?a=s:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||o===-1||r===0||r===1&&a===o-1&&a===n+1?"":f.slice(a,o)},format:p.bind(null,"\\"),parse(f){h(f,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return g;const a=f.length;let n=0,o=f.charCodeAt(0);if(a===1)return d(o)?(g.root=g.dir=f,g):(g.base=g.name=f,g);if(d(o)){if(n=1,d(f.charCodeAt(1))){let D=2,T=D;for(;D<a&&!d(f.charCodeAt(D));)D++;if(D<a&&D!==T){for(T=D;D<a&&d(f.charCodeAt(D));)D++;if(D<a&&D!==T){for(T=D;D<a&&!d(f.charCodeAt(D));)D++;D===a?n=D:D!==T&&(n=D+1)}}}}else if(C(o)&&f.charCodeAt(1)===I){if(a<=2)return g.root=g.dir=f,g;if(n=2,d(f.charCodeAt(2))){if(a===3)return g.root=g.dir=f,g;n=3}}n>0&&(g.root=f.slice(0,n));let i=-1,r=n,s=-1,c=!0,u=f.length-1,P=0;for(;u>=n;--u){if(o=f.charCodeAt(u),d(o)){if(!c){r=u+1;break}continue}s===-1&&(c=!1,s=u+1),o===E?i===-1?i=u:P!==1&&(P=1):i!==-1&&(P=-1)}return s!==-1&&(i===-1||P===0||P===1&&i===s-1&&i===r+1?g.base=g.name=f.slice(r,s):(g.name=f.slice(r,i),g.base=f.slice(r,s),g.ext=f.slice(i,s))),r>0&&r!==n?g.dir=f.slice(0,r-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let g="",a=!1;for(let n=f.length-1;n>=-1&&!a;n--){const o=n>=0?f[n]:v.cwd();h(o,"path"),o.length!==0&&(g=`${o}/${g}`,a=o.charCodeAt(0)===l)}return g=w(g,!a,"/",S),a?`/${g}`:g.length>0?g:"."},normalize(f){if(h(f,"path"),f.length===0)return".";const g=f.charCodeAt(0)===l,a=f.charCodeAt(f.length-1)===l;return f=w(f,!g,"/",S),f.length===0?g?"/":a?"./":".":(a&&(f+="/"),g?`/${f}`:f)},isAbsolute(f){return h(f,"path"),f.length>0&&f.charCodeAt(0)===l},join(...f){if(f.length===0)return".";let g;for(let a=0;a<f.length;++a){const n=f[a];h(n,"path"),n.length>0&&(g===void 0?g=n:g+=`/${n}`)}return g===void 0?".":e.posix.normalize(g)},relative(f,g){if(h(f,"from"),h(g,"to"),f===g||(f=e.posix.resolve(f),g=e.posix.resolve(g),f===g))return"";const a=1,n=f.length,o=n-a,i=1,r=g.length-i,s=o<r?o:r;let c=-1,u=0;for(;u<s;u++){const D=f.charCodeAt(a+u);if(D!==g.charCodeAt(i+u))break;D===l&&(c=u)}if(u===s)if(r>s){if(g.charCodeAt(i+u)===l)return g.slice(i+u+1);if(u===0)return g.slice(i+u)}else o>s&&(f.charCodeAt(a+u)===l?c=u:u===0&&(c=0));let P="";for(u=a+c+1;u<=n;++u)(u===n||f.charCodeAt(u)===l)&&(P+=P.length===0?"..":"/..");return`${P}${g.slice(i+c)}`},toNamespacedPath(f){return f},dirname(f){if(h(f,"path"),f.length===0)return".";const g=f.charCodeAt(0)===l;let a=-1,n=!0;for(let o=f.length-1;o>=1;--o)if(f.charCodeAt(o)===l){if(!n){a=o;break}}else n=!1;return a===-1?g?"/":".":g&&a===1?"//":f.slice(0,a)},basename(f,g){g!==void 0&&h(g,"ext"),h(f,"path");let a=0,n=-1,o=!0,i;if(g!==void 0&&g.length>0&&g.length<=f.length){if(g===f)return"";let r=g.length-1,s=-1;for(i=f.length-1;i>=0;--i){const c=f.charCodeAt(i);if(c===l){if(!o){a=i+1;break}}else s===-1&&(o=!1,s=i+1),r>=0&&(c===g.charCodeAt(r)?--r===-1&&(n=i):(r=-1,n=s))}return a===n?n=s:n===-1&&(n=f.length),f.slice(a,n)}for(i=f.length-1;i>=0;--i)if(f.charCodeAt(i)===l){if(!o){a=i+1;break}}else n===-1&&(o=!1,n=i+1);return n===-1?"":f.slice(a,n)},extname(f){h(f,"path");let g=-1,a=0,n=-1,o=!0,i=0;for(let r=f.length-1;r>=0;--r){const s=f.charCodeAt(r);if(s===l){if(!o){a=r+1;break}continue}n===-1&&(o=!1,n=r+1),s===E?g===-1?g=r:i!==1&&(i=1):g!==-1&&(i=-1)}return g===-1||n===-1||i===0||i===1&&g===n-1&&g===a+1?"":f.slice(g,n)},format:p.bind(null,"/"),parse(f){h(f,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return g;const a=f.charCodeAt(0)===l;let n;a?(g.root="/",n=1):n=0;let o=-1,i=0,r=-1,s=!0,c=f.length-1,u=0;for(;c>=n;--c){const P=f.charCodeAt(c);if(P===l){if(!s){i=c+1;break}continue}r===-1&&(s=!1,r=c+1),P===E?o===-1?o=c:u!==1&&(u=1):o!==-1&&(u=-1)}if(r!==-1){const P=i===0&&a?1:i;o===-1||u===0||u===1&&o===r-1&&o===i+1?g.base=g.name=f.slice(P,r):(g.name=f.slice(P,o),g.base=f.slice(P,r),g.ext=f.slice(o,r))}return i>0?g.dir=f.slice(0,i-1):a&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[78],ee([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(E,...l){const m=l.reduce((y,h)=>(y[h]=!0,y),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(y=>!m[y]).forEach(y=>{for(let h=0;h<I.length;h++)if(y.search(I[h])!==-1){delete E[y];break}})}e.sanitizeProcessEnvironment=R;function M(E){!E||(delete E.DEBUG,v.isMacintosh&&delete E.DYLD_LIBRARY_PATH,v.isLinux&&delete E.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(Z[79],ee([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=v.globals.performance&&typeof v.globals.performance.now=="function";class k{constructor(M){this._highResolution=t&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new k(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=k}),define(Z[3],ee([0,1,17,49,2,125,79]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const E=!1,l=!1;var m;(function(c){c.None=()=>k.Disposable.None;function u(O){if(l){const{onListenerDidAdd:_}=O,V=d.create();let x=0;O.onListenerDidAdd=()=>{++x===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),_?.()}}}function P(O){return(_,V=null,x)=>{let re=!1,j;return j=O(ie=>{if(!re)return j?j.dispose():re=!0,_.call(V,ie)},null,x),re&&j.dispose(),j}}c.once=P;function D(O,_,V){return oe((x,re=null,j)=>O(ie=>x.call(re,_(ie)),null,j),V)}c.map=D;function T(O,_,V){return oe((x,re=null,j)=>O(ie=>{_(ie),x.call(re,ie)},null,j),V)}c.forEach=T;function N(O,_,V){return oe((x,re=null,j)=>O(ie=>_(ie)&&x.call(re,ie),null,j),V)}c.filter=N;function U(O){return O}c.signal=U;function $(...O){return(_,V=null,x)=>(0,k.combinedDisposable)(...O.map(re=>re(j=>_.call(V,j),null,x)))}c.any=$;function Y(O,_,V,x){let re=V;return D(O,j=>(re=_(re,j),re),x)}c.reduce=Y;function oe(O,_){let V;const x={onFirstListenerAdd(){V=O(re.fire,re)},onLastListenerRemove(){V?.dispose()}};_||u(x);const re=new C(x);return _?.add(re),re.event}function ue(O,_,V=100,x=!1,re,j){let ie,ne,ae,fe=0;const De={leakWarningThreshold:re,onFirstListenerAdd(){ie=O(ke=>{fe++,ne=_(ne,ke),x&&!ae&&(Le.fire(ne),ne=void 0),clearTimeout(ae),ae=setTimeout(()=>{const Ae=ne;ne=void 0,ae=void 0,(!x||fe>1)&&Le.fire(Ae),fe=0},V)})},onLastListenerRemove(){ie.dispose()}};j||u(De);const Le=new C(De);return j?.add(Le),Le.event}c.debounce=ue;function se(O,_=(x,re)=>x===re,V){let x=!0,re;return N(O,j=>{const ie=x||!_(j,re);return x=!1,re=j,ie},V)}c.latch=se;function de(O,_,V){return[c.filter(O,_,V),c.filter(O,x=>!_(x),V)]}c.split=de;function G(O,_=!1,V=[]){let x=V.slice(),re=O(ne=>{x?x.push(ne):ie.fire(ne)});const j=()=>{x?.forEach(ne=>ie.fire(ne)),x=null},ie=new C({onFirstListenerAdd(){re||(re=O(ne=>ie.fire(ne)))},onFirstListenerDidAdd(){x&&(_?setTimeout(j):j())},onLastListenerRemove(){re&&re.dispose(),re=null}});return ie.event}c.buffer=G;class K{constructor(_){this.event=_,this.disposables=new k.DisposableStore}map(_){return new K(D(this.event,_,this.disposables))}forEach(_){return new K(T(this.event,_,this.disposables))}filter(_){return new K(N(this.event,_,this.disposables))}reduce(_,V){return new K(Y(this.event,_,V,this.disposables))}latch(){return new K(se(this.event,void 0,this.disposables))}debounce(_,V=100,x=!1,re){return new K(ue(this.event,_,V,x,re,this.disposables))}on(_,V,x){return this.event(_,V,x)}once(_,V,x){return P(this.event)(_,V,x)}dispose(){this.disposables.dispose()}}function F(O){return new K(O)}c.chain=F;function A(O,_,V=x=>x){const x=(...ne)=>ie.fire(V(...ne)),re=()=>O.on(_,x),j=()=>O.removeListener(_,x),ie=new C({onFirstListenerAdd:re,onLastListenerRemove:j});return ie.event}c.fromNodeEventEmitter=A;function W(O,_,V=x=>x){const x=(...ne)=>ie.fire(V(...ne)),re=()=>O.addEventListener(_,x),j=()=>O.removeEventListener(_,x),ie=new C({onFirstListenerAdd:re,onLastListenerRemove:j});return ie.event}c.fromDOMEventEmitter=W;function z(O){return new Promise(_=>P(O)(_))}c.toPromise=z;function te(O,_){return _(void 0),O(V=>_(V))}c.runAndSubscribe=te;function B(O,_){let V=null;function x(j){V?.dispose(),V=new k.DisposableStore,_(j,V)}x(void 0);const re=O(j=>x(j));return(0,k.toDisposable)(()=>{re.dispose(),V?.dispose()})}c.runAndSubscribeWithStore=B;class H{constructor(_,V){this.obs=_,this._counter=0,this._hasChanged=!1;const x={onFirstListenerAdd:()=>{_.addObserver(this)},onLastListenerRemove:()=>{_.removeObserver(this)}};V||u(x),this.emitter=new C(x),V&&V.add(this.emitter)}beginUpdate(_){this._counter++}handleChange(_,V){this._hasChanged=!0}endUpdate(_){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(O,_){return new H(O,_).emitter.event}c.fromObservable=L})(m=e.Event||(e.Event={}));class I{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${I._idPool++}`}start(u){this._stopWatch=new M.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}I._idPool=0;let b=-1;function y(c){const u=b;return b=c,{dispose(){b=u}}}e.setGlobalLeakWarningThreshold=y;class h{constructor(u,P=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=P,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u,P){let D=b;if(typeof this.customThreshold=="number"&&(D=this.customThreshold),D<=0||P<D)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(u.value)||0;if(this._stacks.set(u.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=D*.5;let N,U=0;for(const[$,Y]of this._stacks)(!N||U<Y)&&(N=$,U=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${U}):`),console.warn(N)}return()=>{const N=this._stacks.get(u.value)||0;this._stacks.set(u.value,N-1)}}}class d{constructor(u){this.value=u}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(u,P,D){this.callback=u,this.callbackThis=P,this.stack=D,this.subscription=new k.SafeDisposable}invoke(u){this.callback.call(this.callbackThis,u)}}class C{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=b>0?new h(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(E){const u=Array.from(this._listeners);queueMicrotask(()=>{for(const P of u)P.subscription.isset()&&(P.subscription.unset(),P.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(u,P,D)=>{this._listeners||(this._listeners=new R.LinkedList);const T=this._listeners.isEmpty();T&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let N,U;this._leakageMon&&this._listeners.size>=30&&(U=d.create(),N=this._leakageMon.check(U,this._listeners.size+1)),E&&(U=U??d.create());const $=new S(u,P,U),Y=this._listeners.push($);T&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,P);const oe=$.subscription.set(()=>{N?.(),this._disposed||(Y(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return D instanceof k.DisposableStore?D.add(oe):Array.isArray(D)&&D.push(oe),oe}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new p);for(const P of this._listeners)this._deliveryQueue.push(this,P,u);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=C;class w{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(u,P,D){this._queue.push(new f(u,P,D))}clear(u){const P=new R.LinkedList;for(const D of this._queue)D.emitter!==u&&P.push(D);this._queue=P}deliver(){for(;this._queue.size>0;){const u=this._queue.shift();try{u.listener.invoke(u.event)}catch(P){(0,v.onUnexpectedError)(P)}}}}e.EventDeliveryQueue=w;class p extends w{clear(u){this._queue.clear()}}class f{constructor(u,P,D){this.emitter=u,this.listener=P,this.event=D}}class g extends C{async fireAsync(u,P,D){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,u]);for(;this._asyncDeliveryQueue.size>0&&!P.isCancellationRequested;){const[T,N]=this._asyncDeliveryQueue.shift(),U=[],$={...N,token:P,waitUntil:Y=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");D&&(Y=D(Y,T.callback)),U.push(Y)}};try{T.invoke($)}catch(Y){(0,v.onUnexpectedError)(Y);continue}Object.freeze(U),await Promise.allSettled(U).then(Y=>{for(const oe of Y)oe.status==="rejected"&&(0,v.onUnexpectedError)(oe.reason)})}}}}e.AsyncEmitter=g;class a extends C{constructor(u){super(u),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=a;class n extends a{constructor(u){super(u),this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=n;class o extends C{constructor(u){super(u),this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){!this.hasListeners()||(this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(P=>super.fire(P)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new C({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const P={event:u,listener:null};this.events.push(P),this.hasListeners&&this.hook(P);const D=()=>{this.hasListeners&&this.unhook(P);const T=this.events.indexOf(P);this.events.splice(T,1)};return(0,k.toDisposable)((0,t.once)(D))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(P=>this.emitter.fire(P))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class r{constructor(){this.buffers=[]}wrapEvent(u){return(P,D,T)=>u(N=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>P.call(D,N)):P.call(D,N)},void 0,T)}bufferEvents(u){const P=[];this.buffers.push(P);const D=u();return this.buffers.pop(),P.forEach(T=>T()),D}}e.EventBufferer=r;class s{constructor(){this.listening=!1,this.inputEvent=m.None,this.inputEventListener=k.Disposable.None,this.emitter=new C({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(Z[22],ee([0,1,3]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(E,l){const m=setTimeout(E.bind(l),0);return{dispose(){clearTimeout(m)}}});var k;(function(E){function l(m){return m===E.None||m===E.Cancelled||m instanceof R?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}E.isCancellationToken=l,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(l=!1){l&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=M}),define(Z[138],ee([0,1,22]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(E){this.task=E,this.result=null}get(){if(this.result)return this.result;const E=new v.CancellationTokenSource,l=this.task(E.token);return this.result={promise:l,dispose:()=>{this.result=null,E.cancel(),E.dispose()}},this.result}}e.Cache=t;class k{constructor(E){this.fn=E,this.lastCache=void 0,this.lastArgKey=void 0}get(E){const l=JSON.stringify(E);return this.lastArgKey!==l&&(this.lastArgKey=l,this.lastCache=this.fn(E)),this.lastCache}}e.LRUCachedFunction=k;class R{constructor(E){this.fn=E,this._map=new Map}get cachedValues(){return this._map}get(E){if(this._map.has(E))return this._map.get(E);const l=this.fn(E);return this._map.set(E,l),l}}e.CachedFunction=R}),define(Z[94],ee([0,1,3,2]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=M=>({onDidChange:v.Event.None,value:M});e.staticObservableValue=k;class R extends t.Disposable{constructor(E){super(),this._value=E,this.changeEmitter=this._register(new v.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(E){E!==this._value&&(this._value=E,this.changeEmitter.fire(E))}}e.MutableObservableValue=R}),define(Z[25],ee([0,1,138,124]),function(q,e,v,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=R;const M=/{(\d+)}/g;function E(Q,...le){return le.length===0?Q:Q.replace(M,function(pe,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=le.length?pe:le[Se]})}e.format=E;const l=/{([^}]+)}/g;function m(Q,le){return Q.replace(l,(pe,me)=>le[me]??pe)}e.format2=m;function I(Q){return Q.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=I;function b(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function y(Q,le){let pe=0;const me=le.charCodeAt(0);for(let Se=Q.length-1;Se>=0;Se--)Q.charCodeAt(Se)===me&&pe++;return pe}e.count=y;function h(Q,le,pe="\u2026"){return Q.length<=le?Q:`${Q.substr(0,le)}${pe}`}e.truncate=h;function d(Q,le=" "){const pe=S(Q,le);return C(pe,le)}e.trim=d;function S(Q,le){if(!Q||!le)return Q;const pe=le.length;if(pe===0||Q.length===0)return Q;let me=0;for(;Q.indexOf(le,me)===me;)me=me+pe;return Q.substring(me)}e.ltrim=S;function C(Q,le){if(!Q||!le)return Q;const pe=le.length,me=Q.length;if(pe===0||me===0)return Q;let Se=me,Re=-1;for(;Re=Q.lastIndexOf(le,Se-1),!(Re===-1||Re+pe!==Se);){if(Re===0)return"";Se=Re}return Q.substring(0,Se)}e.rtrim=C;function w(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=w;function p(Q){return Q.replace(/\*/g,"")}e.stripWildcards=p;function f(Q,le,pe={}){if(!Q)throw new Error("Cannot create regex from empty string");le||(Q=b(Q)),pe.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let me="";return pe.global&&(me+="g"),pe.matchCase||(me+="i"),pe.multiline&&(me+="m"),pe.unicode&&(me+="u"),new RegExp(Q,me)}e.createRegExp=f;function g(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=g;function a(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=a;function n(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=n;function o(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=o;function i(Q){for(let le=0,pe=Q.length;le<pe;le++){const me=Q.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=i;function r(Q,le=0,pe=Q.length){for(let me=le;me<pe;me++){const Se=Q.charCodeAt(me);if(Se!==32&&Se!==9)return Q.substring(le,me)}return Q.substring(le,pe)}e.getLeadingWhitespace=r;function s(Q,le=Q.length-1){for(let pe=le;pe>=0;pe--){const me=Q.charCodeAt(pe);if(me!==32&&me!==9)return pe}return-1}e.lastNonWhitespaceIndex=s;function c(Q,le,pe){const me=[];let Se=0;for(const Re of Q.matchAll(le)){if(me.push(Q.slice(Se,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Se=Re.index+Re[0].length,me.push(pe(Re[0],...Re.slice(1),Re.index,Q,Re.groups))}return me.push(Q.slice(Se)),Promise.all(me).then(Re=>Re.join(""))}e.replaceAsync=c;function u(Q,le){return Q<le?-1:Q>le?1:0}e.compare=u;function P(Q,le,pe=0,me=Q.length,Se=0,Re=le.length){for(;pe<me&&Se<Re;pe++,Se++){const et=Q.charCodeAt(pe),je=le.charCodeAt(Se);if(et<je)return-1;if(et>je)return 1}const Fe=me-pe,Ve=Re-Se;return Fe<Ve?-1:Fe>Ve?1:0}e.compareSubstring=P;function D(Q,le){return T(Q,le,0,Q.length,0,le.length)}e.compareIgnoreCase=D;function T(Q,le,pe=0,me=Q.length,Se=0,Re=le.length){for(;pe<me&&Se<Re;pe++,Se++){let et=Q.charCodeAt(pe),je=le.charCodeAt(Se);if(et===je)continue;if(et>=128||je>=128)return P(Q.toLowerCase(),le.toLowerCase(),pe,me,Se,Re);U(et)&&(et-=32),U(je)&&(je-=32);const xe=et-je;if(xe!==0)return xe}const Fe=me-pe,Ve=Re-Se;return Fe<Ve?-1:Fe>Ve?1:0}e.compareSubstringIgnoreCase=T;function N(Q){return Q>=48&&Q<=57}e.isAsciiDigit=N;function U(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=U;function $(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=$;function Y(Q,le){return Q.length===le.length&&T(Q,le)===0}e.equalsIgnoreCase=Y;function oe(Q,le){const pe=le.length;return le.length>Q.length?!1:T(Q,le,0,pe)===0}e.startsWithIgnoreCase=oe;function ue(Q,le){const pe=Math.min(Q.length,le.length);let me;for(me=0;me<pe;me++)if(Q.charCodeAt(me)!==le.charCodeAt(me))return me;return pe}e.commonPrefixLength=ue;function se(Q,le){const pe=Math.min(Q.length,le.length);let me;const Se=Q.length-1,Re=le.length-1;for(me=0;me<pe;me++)if(Q.charCodeAt(Se-me)!==le.charCodeAt(Re-me))return me;return pe}e.commonSuffixLength=se;function de(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=de;function G(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=G;function K(Q,le){return(Q-55296<<10)+(le-56320)+65536}e.computeCodePoint=K;function F(Q,le,pe){const me=Q.charCodeAt(pe);if(de(me)&&pe+1<le){const Se=Q.charCodeAt(pe+1);if(G(Se))return K(me,Se)}return me}e.getNextCodePoint=F;function A(Q,le){const pe=Q.charCodeAt(le-1);if(G(pe)&&le>1){const me=Q.charCodeAt(le-2);if(de(me))return K(me,pe)}return pe}class W{constructor(le,pe=0){this._str=le,this._len=le.length,this._offset=pe}get offset(){return this._offset}setOffset(le){this._offset=le}prevCodePoint(){const le=A(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=F(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class z{constructor(le,pe=0){this._iterator=new W(le,pe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const le=Ee.getInstance(),pe=this._iterator,me=pe.offset;let Se=le.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Re=pe.offset,Fe=le.getGraphemeBreakType(pe.nextCodePoint());if(he(Se,Fe)){pe.setOffset(Re);break}Se=Fe}return pe.offset-me}prevGraphemeLength(){const le=Ee.getInstance(),pe=this._iterator,me=pe.offset;let Se=le.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Re=pe.offset,Fe=le.getGraphemeBreakType(pe.prevCodePoint());if(he(Fe,Se)){pe.setOffset(Re);break}Se=Fe}return me-pe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=z;function te(Q,le){return new z(Q,le).nextGraphemeLength()}e.nextCharLength=te;function B(Q,le){return new z(Q,le).prevGraphemeLength()}e.prevCharLength=B;function H(Q,le){le>0&&G(Q.charCodeAt(le))&&le--;const pe=le+te(Q,le);return[pe-B(Q,pe),pe]}e.getCharContainingOffset=H;let L;function O(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(Q){return L||(L=O()),L.test(Q)}e.containsRTL=_;const V=/^[\t\n\r\x20-\x7E]*$/;function x(Q){return V.test(Q)}e.isBasicASCII=x,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function re(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=re;function j(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=j;function ie(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=ie;function ne(Q,le){if(Q.length<le)return Q;const pe=/\b/g;let me=0;for(;pe.test(Q)&&!(Q.length-pe.lastIndex<le);)me=pe.lastIndex,pe.lastIndex+=1;return Q.substring(me).replace(/^\s/,"")}e.lcut=ne;const ae=/\x1B\x5B[12]?K/g,fe=/\x1b\[\d+m/g,De=/\x1b\[0?m/g;function Le(Q){return Q&&(Q=Q.replace(ae,""),Q=Q.replace(fe,""),Q=Q.replace(De,"")),Q}e.removeAnsiEscapeCodes=Le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Ae(Q){return ke(Q)?Q.substr(1):Q}e.stripUTF8BOM=Ae;function He(Q,le){if(!Q||!le||Q.length<le.length)return!1;const pe=le.length,me=Q.toLowerCase();let Se=0,Re=-1;for(;Se<pe;){const Fe=me.indexOf(le[Se],Re+1);if(Fe<0)return!1;Re=Fe,Se++}return!0}e.fuzzyContains=He;function ge(Q,le=!1){return Q?(le&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=ge;function we(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=we;function Ce(Q,le=1){if(le===0)return"";let pe=-1;do pe=Q.indexOf(`
`,pe+1),le--;while(le>0&&pe>=0);return pe===-1?Q:(Q[pe-1]==="\r"&&pe--,Q.substr(0,pe))}e.getNLines=Ce;function X(Q){return Q=Q%(2*26),Q<26?String.fromCharCode(97+Q):String.fromCharCode(65+Q-26)}e.singleLetterHash=X;function ce(Q){return Ee.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=ce;function he(Q,le){return Q===0?le!==5&&le!==7:Q===2&&le===3?!1:Q===4||Q===2||Q===3||le===4||le===2||le===3?!0:!(Q===8&&(le===8||le===9||le===11||le===12)||(Q===11||Q===9)&&(le===9||le===10)||(Q===12||Q===10)&&le===10||le===5||le===13||le===7||Q===1||Q===13&&le===14||Q===6&&le===6)}var ye;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(ye=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ee{constructor(){this._data=We()}static getInstance(){return Ee._INSTANCE||(Ee._INSTANCE=new Ee),Ee._INSTANCE}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const pe=this._data,me=pe.length/3;let Se=1;for(;Se<=me;)if(le<pe[3*Se])Se=2*Se;else if(le>pe[3*Se+1])Se=2*Se+1;else return pe[3*Se+2];return 0}}Ee._INSTANCE=null;function We(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(Q,le){if(Q===0)return 0;const pe=Ne(Q,le);if(pe!==void 0)return pe;const me=new W(le,Q);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=Te;function Ne(Q,le){const pe=new W(le,Q);let me=pe.prevCodePoint();for(;Be(me)||me===65039||me===8419;){if(pe.offset===0)return;me=pe.prevCodePoint()}if(!ie(me))return;let Se=pe.offset;return Se>0&&pe.prevCodePoint()===8205&&(Se=pe.offset),Se}function Be(Q){return 127995<=Q&&Q<=127999}var ze;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class Ue{constructor(le){this.confusableDictionary=le}static getInstance(le){return Ue.cache.get(Array.from(le))}static getLocales(){return Ue._locales.getValue()}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ue,k=Ue,Ue.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ue.cache=new v.LRUCachedFunction(Q=>{function le(je){const xe=new Map;for(let it=0;it<je.length;it+=2)xe.set(je[it],je[it+1]);return xe}function pe(je,xe){const it=new Map(je);for(const[at,ft]of xe)it.set(at,ft);return it}function me(je,xe){if(!je)return xe;const it=new Map;for(const[at,ft]of je)xe.has(at)&&it.set(at,ft);return it}const Se=k.ambiguousCharacterData.getValue();let Re=Q.filter(je=>!je.startsWith("_")&&je in Se);Re.length===0&&(Re=["_default"]);let Fe;for(const je of Re){const xe=le(Se[je]);Fe=me(Fe,xe)}const Ve=le(Se._common),et=pe(Ve,Fe);return new Ue(et)}),Ue._locales=new t.Lazy(()=>Object.keys(Ue.ambiguousCharacterData.getValue()).filter(Q=>!Q.startsWith("_")));class qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(qe.getRawData())),this._data}static isInvisibleCharacter(le){return qe.getData().has(le)}static get codePoints(){return qe.getData()}}e.InvisibleCharacters=qe,qe._data=void 0}),define(Z[30],ee([0,1,9,4,25,12]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(s){return s===47||s===92}e.isPathSeparator=M;function E(s){return s.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=E;function l(s){return s.indexOf("/")===-1&&(s=E(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=l;function m(s,c=v.posix.sep){if(!s)return"";const u=s.length,P=s.charCodeAt(0);if(M(P)){if(M(s.charCodeAt(1))&&!M(s.charCodeAt(2))){let T=3;const N=T;for(;T<u&&!M(s.charCodeAt(T));T++);if(N!==T&&!M(s.charCodeAt(T+1))){for(T+=1;T<u;T++)if(M(s.charCodeAt(T)))return s.slice(0,T+1).replace(/[\\/]/g,c)}}return c}else if(w(P)&&s.charCodeAt(1)===58)return M(s.charCodeAt(2))?s.slice(0,2)+c:s.slice(0,2);let D=s.indexOf("://");if(D!==-1){for(D+=3;D<u;D++)if(M(s.charCodeAt(D)))return s.slice(0,D+1)}return""}e.getRoot=m;function I(s){if(!t.isWindows||!s||s.length<5)return!1;let c=s.charCodeAt(0);if(c!==92||(c=s.charCodeAt(1),c!==92))return!1;let u=2;const P=u;for(;u<s.length&&(c=s.charCodeAt(u),c!==92);u++);return!(P===u||(c=s.charCodeAt(u+1),isNaN(c)||c===92))}e.isUNC=I;const b=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,c=t.isWindows){const u=c?b:y;return!(!s||s.length===0||/^\s+$/.test(s)||(u.lastIndex=0,u.test(s))||c&&h.test(s)||s==="."||s===".."||c&&s[s.length-1]==="."||c&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function S(s,c,u){const P=s===c;return!u||P?P:!s||!c?!1:(0,k.equalsIgnoreCase)(s,c)}e.isEqual=S;function C(s,c,u,P=v.sep){if(s===c)return!0;if(!s||!c||c.length>s.length)return!1;if(u){if(!(0,k.startsWithIgnoreCase)(s,c))return!1;if(c.length===s.length)return!0;let T=c.length;return c.charAt(c.length-1)===P&&T--,s.charAt(T)===P}return c.charAt(c.length-1)!==P&&(c+=P),s.indexOf(c)===0}e.isEqualOrParent=C;function w(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=w;function p(s,c){return t.isWindows&&s.endsWith(":")&&(s+=v.sep),(0,v.isAbsolute)(s)||(s=(0,v.join)(c,s)),s=(0,v.normalize)(s),t.isWindows?(s=(0,k.rtrim)(s,v.sep),s.endsWith(":")&&(s+=v.sep)):(s=(0,k.rtrim)(s,v.sep),s||(s=v.sep)),s}e.sanitizeFilePath=p;function f(s){const c=(0,v.normalize)(s);return t.isWindows?s.length>3?!1:g(c)&&(s.length===2||c.charCodeAt(2)===92):c===v.posix.sep}e.isRootOrDriveLetter=f;function g(s,c=t.isWindows){return c?w(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function a(s){return g(s)?s[0]:void 0}e.getDriveLetter=a;function n(s,c,u){return c.length>s.length?-1:s===c?0:(u&&(s=s.toLowerCase(),c=c.toLowerCase()),s.indexOf(c))}e.indexOfPath=n;function o(s){const c=s.split(":");let u,P,D;for(const T of c){const N=Number(T);(0,R.isNumber)(N)?P===void 0?P=N:D===void 0&&(D=N):u=u?[u,T].join(":"):T}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:P!==void 0?P:void 0,column:D!==void 0?D:P!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(s,c,u=8){let P="";for(let T=0;T<u;T++)P+=i.charAt(Math.floor(Math.random()*i.length));let D;return c?D=`${c}-${P}`:D=P,s?(0,v.join)(s,D):D}e.randomPath=r}),define(Z[66],ee([0,1,25]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(w){return k(w,0)}e.hash=t;function k(w,p){switch(typeof w){case"object":return w===null?R(349,p):Array.isArray(w)?l(w,p):m(w,p);case"string":return E(w,p);case"boolean":return M(w,p);case"number":return R(w,p);case"undefined":return R(937,p);default:return R(617,p)}}e.doHash=k;function R(w,p){return(p<<5)-p+w|0}e.numberHash=R;function M(w,p){return R(w?433:863,p)}function E(w,p){p=R(149417,p);for(let f=0,g=w.length;f<g;f++)p=R(w.charCodeAt(f),p);return p}e.stringHash=E;function l(w,p){return p=R(104579,p),w.reduce((f,g)=>k(g,f),p)}function m(w,p){return p=R(181387,p),Object.keys(w).sort().reduce((f,g)=>(f=E(g,f),k(w[g],f)),p)}class I{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=k(p,this._value),this._value}}e.Hasher=I;var b;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function y(w,p,f=32){const g=f-p,a=~((1<<g)-1);return(w<<p|(a&w)>>>g)>>>0}function h(w,p=0,f=w.byteLength,g=0){for(let a=0;a<f;a++)w[p+a]=g}function d(w,p,f="0"){for(;w.length<p;)w=f+w;return w}function S(w,p=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(f=>f.toString(16).padStart(2,"0")).join(""):d((w>>>0).toString(16),p/4)}e.toHexString=S;class C{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const f=p.length;if(f===0)return;const g=this._buff;let a=this._buffLen,n=this._leftoverHighSurrogate,o,i;for(n!==0?(o=n,i=-1,n=0):(o=p.charCodeAt(0),i=0);;){let r=o;if(v.isHighSurrogate(o))if(i+1<f){const s=p.charCodeAt(i+1);v.isLowSurrogate(s)?(i++,r=v.computeCodePoint(o,s)):r=65533}else{n=o;break}else v.isLowSurrogate(o)&&(r=65533);if(a=this._push(g,a,r),i++,i<f)o=p.charCodeAt(i);else break}this._buffLen=a,this._leftoverHighSurrogate=n}_push(p,f,g){return g<128?p[f++]=g:g<2048?(p[f++]=192|(g&1984)>>>6,p[f++]=128|(g&63)>>>0):g<65536?(p[f++]=224|(g&61440)>>>12,p[f++]=128|(g&4032)>>>6,p[f++]=128|(g&63)>>>0):(p[f++]=240|(g&1835008)>>>18,p[f++]=128|(g&258048)>>>12,p[f++]=128|(g&4032)>>>6,p[f++]=128|(g&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=C._bigBlock32,f=this._buffDV;for(let u=0;u<64;u+=4)p.setUint32(u,f.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)p.setUint32(u,y(p.getUint32(u-12,!1)^p.getUint32(u-32,!1)^p.getUint32(u-56,!1)^p.getUint32(u-64,!1),1),!1);let g=this._h0,a=this._h1,n=this._h2,o=this._h3,i=this._h4,r,s,c;for(let u=0;u<80;u++)u<20?(r=a&n|~a&o,s=1518500249):u<40?(r=a^n^o,s=1859775393):u<60?(r=a&n|a&o|n&o,s=2400959708):(r=a^n^o,s=3395469782),c=y(g,5)+r+i+s+p.getUint32(u*4,!1)&4294967295,i=o,o=n,n=y(a,30),a=g,g=c;this._h0=this._h0+g&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=C,C._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[31],ee([0,1,24,25]),function(q,e,v,t){"use strict";var k,R,M;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(i,r,s){let c=i.get(r);return c===void 0&&(c=s,i.set(r,c)),c}e.getOrSet=E;function l(i){const r=[];return i.forEach((s,c)=>{r.push(`${c} => ${s}`)}),`Map(${i.size}) {${r.join(", ")}}`}e.mapToString=l;function m(i){const r=[];return i.forEach(s=>{r.push(s)}),`Set(${i.size}) {${r.join(", ")}}`}e.setToString=m;class I{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),c=this._value.charCodeAt(this._pos);return s-c}value(){return this._value[this._pos]}}e.StringIterator=I;class b{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class y{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let s=r.length-1;s>=0;s--,this._valueLen--){const c=this._value.charCodeAt(s);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var h;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(h||(h={}));class d{constructor(r,s){this._ignorePathCasing=r,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,t.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(C||(C={}));class w{constructor(r){this._iter=r}static forUris(r=()=>!1,s=()=>!1){return new w(new d(r,s))}static forPaths(r=!1){return new w(new y(void 0,!r))}static forStrings(){return new w(new I)}static forConfigKeys(){return new w(new b)}clear(){this._root=void 0}fill(r,s){if(s){const c=s.slice(0);(0,v.shuffle)(c);for(const u of c)this.set(u,r)}else{const c=r.slice(0);(0,v.shuffle)(c);for(const u of c)this.set(u[0],u[1])}}set(r,s){const c=this._iter.reset(r);let u;this._root||(this._root=new S,this._root.segment=c.value());const P=[];for(u=this._root;;){const T=c.cmp(u.segment);if(T>0)u.left||(u.left=new S,u.left.segment=c.value()),P.push([-1,u]),u=u.left;else if(T<0)u.right||(u.right=new S,u.right.segment=c.value()),P.push([1,u]),u=u.right;else if(c.hasNext())c.next(),u.mid||(u.mid=new S,u.mid.segment=c.value()),P.push([0,u]),u=u.mid;else break}const D=u.value;u.value=s,u.key=r;for(let T=P.length-1;T>=0;T--){const N=P[T][1];N.updateHeight();const U=N.balanceFactor();if(U<-1||U>1){const $=P[T][0],Y=P[T+1][0];if($===1&&Y===1)P[T][1]=N.rotateLeft();else if($===-1&&Y===-1)P[T][1]=N.rotateRight();else if($===1&&Y===-1)N.right=P[T+1][1]=P[T+1][1].rotateRight(),P[T][1]=N.rotateLeft();else if($===-1&&Y===1)N.left=P[T+1][1]=P[T+1][1].rotateLeft(),P[T][1]=N.rotateRight();else throw new Error;if(T>0)switch(P[T-1][0]){case-1:P[T-1][1].left=P[T][1];break;case 1:P[T-1][1].right=P[T][1];break;case 0:P[T-1][1].mid=P[T][1];break}else this._root=P[0][1]}}return D}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let c=this._root;for(;c;){const u=s.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else break}return c}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const c=this._iter.reset(r),u=[];let P=this._root;for(;P;){const D=c.cmp(P.segment);if(D>0)u.push([-1,P]),P=P.left;else if(D<0)u.push([1,P]),P=P.right;else if(c.hasNext())c.next(),u.push([0,P]),P=P.mid;else break}if(!!P){if(s?(P.left=void 0,P.mid=void 0,P.right=void 0,P.height=1):(P.key=void 0,P.value=void 0),!P.mid&&!P.value)if(P.left&&P.right){const D=this._min(P.right),{key:T,value:N,segment:U}=D;this._delete(D.key,!1),P.key=T,P.value=N,P.segment=U}else{const D=P.left??P.right;if(u.length>0){const[T,N]=u[u.length-1];switch(T){case-1:N.left=D;break;case 0:N.mid=D;break;case 1:N.right=D;break}}else this._root=D}for(let D=u.length-1;D>=0;D--){const T=u[D][1];T.updateHeight();const N=T.balanceFactor();if(N>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),u[D][1]=T.rotateLeft()):N<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),u[D][1]=T.rotateRight()),D>0)switch(u[D-1][0]){case-1:u[D-1][1].left=u[D][1];break;case 1:u[D-1][1].right=u[D][1];break;case 0:u[D-1][1].mid=u[D][1];break}else this._root=u[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const s=this._iter.reset(r);let c=this._root,u;for(;c;){const P=s.cmp(c.segment);if(P>0)c=c.left;else if(P<0)c=c.right;else if(s.hasNext())s.next(),u=c.value||u,c=c.mid;else break}return c&&c.value||u}findSuperstr(r){const s=this._iter.reset(r);let c=this._root;for(;c;){const u=s.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(r){for(const[s,c]of this)r(c,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const s=[];return this._dfsEntries(r,s),s[Symbol.iterator]()}_dfsEntries(r,s){!r||(r.left&&this._dfsEntries(r.left,s),r.value&&s.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,s),r.right&&this._dfsEntries(r.right,s))}_isBalanced(){const r=s=>{if(!s)return!0;const c=s.balanceFactor();return c<-1||c>1?!1:r(s.left)&&r(s.right)};return r(this._root)}}e.TernarySearchTree=w;class p{constructor(r,s){this.uri=r,this.value=s}}class f{constructor(r,s){this[k]="ResourceMap",r instanceof f?(this.map=new Map(r.map),this.toKey=s??f.defaultToKey):(this.map=new Map,this.toKey=r??f.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),new p(r,s)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[c,u]of this.map)r(u.value,u.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=f,f.defaultToKey=i=>i.toString();class g{constructor(r,s){this[R]="ResourceSet",!r||typeof r=="function"?this._map=new f(r):(this._map=new f(s),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,s){this._map.forEach((c,u)=>r.call(s,u,u,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=g;var a;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class n{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const c=this._map.get(r);if(!!c)return s!==0&&this.touch(c,s),c.value}set(r,s,c=0){let u=this._map.get(r);if(u)u.value=s,c!==0&&this.touch(u,c);else{switch(u={key:r,value:s,next:void 0,previous:void 0},c){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const c=this._state;let u=this._head;for(;u;){if(s?r.bind(s)(u.value,u.key,this):r(u.value,u.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,s=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const P={value:c.key,done:!1};return c=c.next,P}else return{value:void 0,done:!0}}};return u}values(){const r=this,s=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const P={value:c.value,done:!1};return c=c.next,P}else return{value:void 0,done:!0}}};return u}entries(){const r=this,s=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const P={value:[c.key,c.value],done:!1};return c=c.next,P}else return{value:void 0,done:!0}}};return u}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,c=this.size;for(;s&&c>r;)this._map.delete(s.key),s=s.next,c--;this._head=s,this._size=c,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,c=r.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const c=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(c.previous=u,u.next=c),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const c=r.next,u=r.previous;r===this._head?(c.previous=void 0,this._head=c):(c.previous=u,u.next=c),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,c)=>{r.push([c,s])}),r}fromJSON(r){this.clear();for(const[s,c]of r)this.set(s,c)}}e.LinkedMap=n;class o extends n{constructor(r,s=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o}),define(Z[80],ee([0,1,31]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new v.LRUCache(1e4);function k(m){return l(m,"NFC",t)}e.normalizeNFC=k;const R=new v.LRUCache(1e4);function M(m){return l(m,"NFD",R)}e.normalizeNFD=M;const E=/[^\u0000-\u0080]/;function l(m,I,b){if(!m)return m;const y=b.get(m);if(y)return y;let h;return E.test(m)?h=m.normalize(I):h=m,b.set(m,h),h}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(I){return M(I).replace(m,"")}}()}),define(Z[95],ee([0,1,25]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",M="warning",E="warn",l="info",m="ignore";function I(y){return y?v.equalsIgnoreCase(R,y)?k.Error:v.equalsIgnoreCase(M,y)||v.equalsIgnoreCase(E,y)?k.Warning:v.equalsIgnoreCase(l,y)?k.Info:k.Ignore:k.Ignore}k.fromValue=I;function b(y){switch(y){case k.Error:return R;case k.Warning:return M;case k.Info:return l;default:return m}}k.toString=b}(t||(t={})),e.default=t}),define(Z[7],ee([0,1,9,4]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,M=/^\/\//;function E(i,r){if(!i.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(i,r){return!i&&!r?"file":i}function m(i,r){switch(i){case"https":case"http":case"file":r?r[0]!==b&&(r=b+r):r=b;break}return r}const I="",b="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(r,s,c,u,P,D=!1){typeof r=="object"?(this.scheme=r.scheme||I,this.authority=r.authority||I,this.path=r.path||I,this.query=r.query||I,this.fragment=r.fragment||I):(this.scheme=l(r,D),this.authority=s||I,this.path=m(this.scheme,c||I),this.query=u||I,this.fragment=P||I,E(this,D))}static isUri(r){return r instanceof h?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return f(this,!1)}with(r){if(!r)return this;let{scheme:s,authority:c,path:u,query:P,fragment:D}=r;return s===void 0?s=this.scheme:s===null&&(s=I),c===void 0?c=this.authority:c===null&&(c=I),u===void 0?u=this.path:u===null&&(u=I),P===void 0?P=this.query:P===null&&(P=I),D===void 0?D=this.fragment:D===null&&(D=I),s===this.scheme&&c===this.authority&&u===this.path&&P===this.query&&D===this.fragment?this:new S(s,c,u,P,D)}static parse(r,s=!1){const c=y.exec(r);return c?new S(c[2]||I,o(c[4]||I),o(c[5]||I),o(c[7]||I),o(c[9]||I),s):new S(I,I,I,I,I)}static file(r){let s=I;if(t.isWindows&&(r=r.replace(/\\/g,b)),r[0]===b&&r[1]===b){const c=r.indexOf(b,2);c===-1?(s=r.substring(2),r=b):(s=r.substring(2,c),r=r.substring(c)||b)}return new S("file",s,r,I,I)}static from(r){const s=new S(r.scheme,r.authority,r.path,r.query,r.fragment);return E(s,!0),s}static joinPath(r,...s){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&r.scheme==="file"?c=h.file(v.win32.join(f(r,!0),...s)).path:c=v.posix.join(r.path,...s),r.with({path:c})}toString(r=!1){return g(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof h)return r;{const s=new S(r);return s._formatted=r.external,s._fsPath=r._sep===d?r.fsPath:null,s}}else return r}}e.URI=h;const d=t.isWindows?1:void 0;class S extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(r=!1){return r?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=d),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(i,r){let s,c=-1;for(let u=0;u<i.length;u++){const P=i.charCodeAt(u);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||r&&P===47)c!==-1&&(s+=encodeURIComponent(i.substring(c,u)),c=-1),s!==void 0&&(s+=i.charAt(u));else{s===void 0&&(s=i.substr(0,u));const D=C[P];D!==void 0?(c!==-1&&(s+=encodeURIComponent(i.substring(c,u)),c=-1),s+=D):c===-1&&(c=u)}}return c!==-1&&(s+=encodeURIComponent(i.substring(c))),s!==void 0?s:i}function p(i){let r;for(let s=0;s<i.length;s++){const c=i.charCodeAt(s);c===35||c===63?(r===void 0&&(r=i.substr(0,s)),r+=C[c]):r!==void 0&&(r+=i[s])}return r!==void 0?r:i}function f(i,r){let s;return i.authority&&i.path.length>1&&i.scheme==="file"?s=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?r?s=i.path.substr(1):s=i.path[1].toLowerCase()+i.path.substr(2):s=i.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=f;function g(i,r){const s=r?p:w;let c="",{scheme:u,authority:P,path:D,query:T,fragment:N}=i;if(u&&(c+=u,c+=":"),(P||u==="file")&&(c+=b,c+=b),P){let U=P.indexOf("@");if(U!==-1){const $=P.substr(0,U);P=P.substr(U+1),U=$.indexOf(":"),U===-1?c+=s($,!1):(c+=s($.substr(0,U),!1),c+=":",c+=s($.substr(U+1),!1)),c+="@"}P=P.toLowerCase(),U=P.indexOf(":"),U===-1?c+=s(P,!1):(c+=s(P.substr(0,U),!1),c+=P.substr(U))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const U=D.charCodeAt(1);U>=65&&U<=90&&(D=`/${String.fromCharCode(U+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const U=D.charCodeAt(0);U>=65&&U<=90&&(D=`${String.fromCharCode(U+32)}:${D.substr(2)}`)}c+=s(D,!0)}return T&&(c+="?",c+=s(T,!1)),N&&(c+="#",c+=r?N:w(N,!1)),c}function a(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+a(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(i){return i.match(n)?i.replace(n,r=>a(r)):i}}),define(Z[139],ee([0,1,7]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(m){const I=m;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=t;function k(m){const I=[];let b;try{const y=JSON.parse(m.arguments),h=y[y.length-1];h&&h.__$stack&&(y.pop(),b=h.__$stack),I.push(...y)}catch{I.push("Unable to log remote console arguments",m.arguments)}return{args:I,stack:b}}e.parse=k;function R(m){if(typeof m!="string")return R(k(m).stack);const I=m;if(I){const b=M(I),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(y&&y.length===4)return{uri:v.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=R;function M(m){if(!m)return m;const I=m.indexOf(`
`);return I===-1?m:m.substring(0,I)}function E(m,I){const{args:b,stack:y}=k(m),h=typeof b[0]=="string"&&b.length===1;let d=M(y);d&&(d=`(${d.trim()})`);let S=[];if(typeof b[0]=="string"?d&&h?S=[`%c[${I}] %c${b[0]} %c${d}`,l("blue"),l(""),l("grey")]:S=[`%c[${I}] %c${b[0]}`,l("blue"),l(""),...b.slice(1)]:S=[`%c[${I}]%`,l("blue"),...b],d&&!h&&S.push(d),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,S)}e.log=E;function l(m){return`color: ${m}`}}),define(Z[67],ee([0,1,18,25,7]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(m){return JSON.stringify(m,E)}e.stringify=R;function M(m){let I=JSON.parse(m);return I=l(I),I}e.parse=M;function E(m,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,t.regExpFlags)(I)}:I}function l(m,I=0){if(!m||I>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return k.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 14:return new Date(m.source)}if(m instanceof v.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let b=0;b<m.length;++b)m[b]=l(m[b],I+1);else for(const b in m)Object.hasOwnProperty.call(m,b)&&(m[b]=l(m[b],I+1))}return m}e.revive=l}),define(Z[13],ee([0,1,4,7]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebook="vscode-notebook",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractive="vscode-interactive",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}setServerRootPath(m){this._remoteResourcesPath=`${m}/${k.vscodeRemoteResource}`}set(m,I,b){this._hosts[m]=I,this._ports[m]=b}setConnectionToken(m,I){this._connectionTokens[m]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(m){if(this._delegate)return this._delegate(m);const I=m.authority;let b=this._hosts[I];b&&b.indexOf(":")!==-1&&(b=`[${b}]`);const y=this._ports[I],h=this._connectionTokens[I];let d=`path=${encodeURIComponent(m.path)}`;return typeof h=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(h)}`),t.URI.from({scheme:v.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${b}:${y}`,path:this._remoteResourcesPath,query:d})}}e.RemoteAuthorities=new R;class M{asBrowserUri(m,I){const b=this.toUri(m,I);return b.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===k.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${k.vscodeFileResource}://${M.FALLBACK_AUTHORITY}`)?b.with({scheme:k.vscodeFileResource,authority:b.authority||M.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(m,I){const b=this.toUri(m,I);return b.scheme===k.vscodeFileResource?b.with({scheme:k.file,authority:b.authority!==M.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(m,I){return t.URI.isUri(m)?m:t.URI.parse(I.toUrl(m))}}M.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new M;var E;(function(l){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(m.get("3"));const I="vscode-coi";function b(h){let d;typeof h=="string"?d=new URL(h).searchParams:h instanceof URL?d=h.searchParams:t.URI.isUri(h)&&(d=new URL(h.toString(!0)).searchParams);const S=d?.get(I);if(!!S)return m.get(S)}l.getHeadersFromQuery=b;function y(h,d,S){if(!globalThis.crossOriginIsolated)return;const C=d&&S?"3":S?"2":"1";h instanceof URLSearchParams?h.set(I,C):h[I]=C}l.addSearchParam=y})(E=e.COI||(e.COI={}))}),define(Z[16],ee([0,1,30,13,9,4,25,7]),function(q,e,v,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function l(h){return(0,E.uriToFsPath)(h,!0)}e.originalFSPath=l;class m{constructor(d){this._ignorePathCasing=d}compare(d,S,C=!1){return d===S?0:(0,M.compare)(this.getComparisonKey(d,C),this.getComparisonKey(S,C))}isEqual(d,S,C=!1){return d===S?!0:!d||!S?!1:this.getComparisonKey(d,C)===this.getComparisonKey(S,C)}getComparisonKey(d,S=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,S,C=!1){if(d.scheme===S.scheme){if(d.scheme===t.Schemas.file)return v.isEqualOrParent(l(d),l(S),this._ignorePathCasing(d))&&d.query===S.query&&(C||d.fragment===S.fragment);if((0,e.isEqualAuthority)(d.authority,S.authority))return v.isEqualOrParent(d.path,S.path,this._ignorePathCasing(d),"/")&&d.query===S.query&&(C||d.fragment===S.fragment)}return!1}joinPath(d,...S){return E.URI.joinPath(d,...S)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let S;return d.scheme===t.Schemas.file?S=E.URI.file(k.dirname(l(d))).path:(S=k.posix.dirname(d.path),d.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),S="/")),d.with({path:S})}normalizePath(d){if(!d.path.length)return d;let S;return d.scheme===t.Schemas.file?S=E.URI.file(k.normalize(l(d))).path:S=k.posix.normalize(d.path),d.with({path:S})}relativePath(d,S){if(d.scheme!==S.scheme||!(0,e.isEqualAuthority)(d.authority,S.authority))return;if(d.scheme===t.Schemas.file){const p=k.relative(l(d),l(S));return R.isWindows?v.toSlashes(p):p}let C=d.path||"/";const w=S.path||"/";if(this._ignorePathCasing(d)){let p=0;for(const f=Math.min(C.length,w.length);p<f&&!(C.charCodeAt(p)!==w.charCodeAt(p)&&C.charAt(p).toLowerCase()!==w.charAt(p).toLowerCase());p++);C=w.substr(0,p)+C.substr(p)}return k.posix.relative(C,w)}resolvePath(d,S){if(d.scheme===t.Schemas.file){const C=E.URI.file(k.resolve(l(d),S));return d.with({authority:C.authority,path:C.path})}return S=v.toPosixPath(S),d.with({path:k.posix.resolve(d.path,S)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,S){return d===S||d!==void 0&&S!==void 0&&(0,M.equalsIgnoreCase)(d,S)}hasTrailingPathSeparator(d,S=k.sep){if(d.scheme===t.Schemas.file){const C=l(d);return C.length>v.getRoot(C).length&&C[C.length-1]===S}else{const C=d.path;return C.length>1&&C.charCodeAt(C.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,S=k.sep){return(0,e.hasTrailingPathSeparator)(d,S)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,S=k.sep){let C=!1;if(d.scheme===t.Schemas.file){const w=l(d);C=w!==void 0&&w.length===v.getRoot(w).length&&w[w.length-1]===S}else{S="/";const w=d.path;C=w.length===1&&w.charCodeAt(w.length-1)===47}return!C&&!(0,e.hasTrailingPathSeparator)(d,S)?d.with({path:d.path+"/"}):d}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(h=>h.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new m(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(h,d){const S=[];for(let C=0;C<h.length;C++){const w=d(h[C]);h.some((p,f)=>f===C?!1:(0,e.isEqualOrParent)(w,d(p)))||S.push(h[C])}return S}e.distinctParents=I;var b;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function d(S){const C=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(f=>{const[g,a]=f.split(":");g&&a&&C.set(g,a)});const p=S.path.substring(0,S.path.indexOf(";"));return p&&C.set(h.META_DATA_MIME,p),C}h.parseMetaData=d})(b=e.DataUri||(e.DataUri={}));function y(h,d,S){if(d){let C=h.path;return C&&C[0]!==k.posix.sep&&(C=k.posix.sep+C),h.with({scheme:S,authority:d,path:C})}return h.with({scheme:S})}e.toLocalResource=y}),define(Z[8],ee([0,1,22,17,3,2,16,4]),function(q,e,v,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function l(H){return!!H&&typeof H.then=="function"}e.isThenable=l;function m(H){const L=new v.CancellationTokenSource,O=H(L.token),_=new Promise((V,x)=>{const re=L.token.onCancellationRequested(()=>{re.dispose(),L.dispose(),x(new t.CancellationError)});Promise.resolve(O).then(j=>{re.dispose(),L.dispose(),V(j)},j=>{re.dispose(),L.dispose(),x(j)})});return new class{cancel(){L.cancel()}then(V,x){return _.then(V,x)}catch(V){return this.then(void 0,V)}finally(V){return _.finally(V)}}}e.createCancelablePromise=m;function I(H,L,O){return new Promise((_,V)=>{const x=L.onCancellationRequested(()=>{x.dispose(),_(O)});H.then(_,V).finally(()=>x.dispose())})}e.raceCancellation=I;function b(H,L){return new Promise((O,_)=>{const V=L.onCancellationRequested(()=>{V.dispose(),_(new t.CancellationError)});H.then(O,_).finally(()=>V.dispose())})}e.raceCancellationError=b;async function y(H){let L=-1;const O=H.map((V,x)=>V.then(re=>(L=x,re))),_=await Promise.race(O);return H.forEach((V,x)=>{x!==L&&V.cancel()}),_}e.raceCancellablePromises=y;function h(H,L,O){let _;const V=setTimeout(()=>{_?.(void 0),O?.()},L);return Promise.race([H.finally(()=>clearTimeout(V)),new Promise(x=>_=x)])}e.raceTimeout=h;function d(H){return new Promise((L,O)=>{const _=H();l(_)?_.then(L,O):L(_)})}e.asPromise=d;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(O,O).then(_)})}return new Promise((O,_)=>{this.queuedPromise.then(O,_)})}return this.activePromise=L(),new Promise((O,_)=>{this.activePromise.then(V=>{this.activePromise=null,O(V)},V=>{this.activePromise=null,_(V)})})}}e.Throttler=S;class C{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=C;class w{constructor(){this.promiseMap=new Map}queue(L,O){const V=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(L)===V&&this.promiseMap.delete(L)});return this.promiseMap.set(L,V),V}}e.SequencerByKey=w;const p=(H,L)=>{let O=!0;const _=setTimeout(()=>{O=!1,L()},H);return{isTriggered:()=>O,dispose:()=>{clearTimeout(_),O=!1}}},f=H=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,H())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class g{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,O=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,x)=>{this.doResolve=V,this.doReject=x}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}}));const _=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?f(_):p(O,_),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=g;class a{constructor(L){this.delayer=new g(L),this.throttler=new S}trigger(L,O){return this.delayer.trigger(()=>this.throttler.queue(L),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=a;class n{constructor(){this._isOpen=!1,this._promise=new Promise((L,O)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class o extends n{constructor(L){super(),this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function i(H,L){return L?new Promise((O,_)=>{const V=setTimeout(()=>{x.dispose(),O()},H),x=L.onCancellationRequested(()=>{clearTimeout(V),x.dispose(),_(new t.CancellationError)})}):m(O=>i(H,O))}e.timeout=i;function r(H,L=0){const O=setTimeout(H,L);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=r;function s(H){const L=[];let O=0;const _=H.length;function V(){return O<_?H[O++]():null}function x(re){re!=null&&L.push(re);const j=V();return j?j.then(x):Promise.resolve(L)}return Promise.resolve(null).then(x)}e.sequence=s;function c(H,L=_=>!!_,O=null){let _=0;const V=H.length,x=()=>{if(_>=V)return Promise.resolve(O);const re=H[_++];return Promise.resolve(re()).then(ie=>L(ie)?Promise.resolve(ie):x())};return x()}e.first=c;function u(H,L=_=>!!_,O=null){if(H.length===0)return Promise.resolve(O);let _=H.length;const V=()=>{_=-1;for(const x of H)x.cancel?.()};return new Promise((x,re)=>{for(const j of H)j.then(ie=>{--_>=0&&L(ie)?(V(),x(ie)):_===0&&x(O)}).catch(ie=>{--_>=0&&(V(),re(ie))})})}e.firstParallel=u;class P{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((O,_)=>{this.outstandingPromises.push({factory:L,c:O,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const O=L.factory();O.then(L.c,L.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=P;class D extends P{constructor(){super(1)}}e.Queue=D;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new F;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,O=M.extUri){const _=O.getComparisonKey(L);let V=this.queues.get(_);return V||(V=new D,k.Event.once(V.onDrained)(()=>{V?.dispose(),this.queues.delete(_),this.onDidQueueDrain()}),this.queues.set(_,V)),V}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class N{constructor(L,O){this._token=-1,typeof L=="function"&&typeof O=="number"&&this.setIfNotSet(L,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},O)}setIfNotSet(L,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},O))}}e.TimeoutTimer=N;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setInterval(()=>{L()},O)}}e.IntervalTimer=U;class ${constructor(L,O){this.timeoutToken=-1,this.runner=L,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=$;class Y{constructor(L,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=Y;class oe extends ${constructor(L,O){super(L,O),this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=oe;class ue extends R.Disposable{constructor(L,O){super(),this.options=L,this.handler=O,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new $(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ue,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{(0,E.setTimeout0)(()=>{if(L)return;const O=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=(H,L)=>{const O=requestIdleCallback(H,typeof L=="number"?{timeout:L}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(O))}}}}();class se{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function de(H,L,O){let _;for(let V=0;V<O;V++)try{return await H()}catch(x){_=x,await i(L)}throw _}e.retry=de;class G{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(L,O,_){return this._pending={taskId:L,cancel:()=>_?.(),promise:O},O.then(()=>this.donePending(L),()=>this.donePending(L)),O}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let O,_;const V=new Promise((x,re)=>{O=x,_=re});this._next={run:L,promise:V,promiseResolve:O,promiseReject:_}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=G;class K{constructor(L,O=()=>Date.now()){this.interval=L,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class F{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,O)=>{this.completeCallback=L,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(O=>{this.completeCallback(L),this.resolved=!0,O()})}error(L){return new Promise(O=>{this.errorCallback(L),this.rejected=!0,O()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=F;var A;(function(H){async function L(_){let V;const x=await Promise.all(_.map(re=>re.then(j=>j,j=>{V||(V=j)})));if(typeof V<"u")throw V;return x}H.settled=L;function O(_){return new Promise(async(V,x)=>{try{await _(V,x)}catch(re){x(re)}})}H.withAsyncBody=O})(A=e.Promises||(e.Promises={}));var W;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(W||(W={}));class z{constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const O={emitOne:_=>this.emitOne(_),emitMany:_=>this.emitMany(_),reject:_=>this.reject(_)};try{await Promise.resolve(L(O)),this.resolve()}catch(_){this.reject(_)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(L){return new z(O=>{O.emitMany(L)})}static fromPromise(L){return new z(async O=>{O.emitMany(await L)})}static fromPromises(L){return new z(async O=>{await Promise.all(L.map(async _=>O.emitOne(await _)))})}static merge(L){return new z(async O=>{await Promise.all(L.map(async _=>{for await(const V of _)O.emitOne(V)}))})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,O){return new z(async _=>{for await(const V of L)_.emitOne(O(V))})}map(L){return z.map(this,L)}static filter(L,O){return new z(async _=>{for await(const V of L)O(V)&&_.emitOne(V)})}filter(L){return z.filter(this,L)}static coalesce(L){return z.filter(L,O=>!!O)}coalesce(){return z.coalesce(this)}static async toPromise(L){const O=[];for await(const _ of L)O.push(_);return O}toPromise(){return z.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class te extends z{constructor(L,O){super(O),this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=te;function B(H){const L=new v.CancellationTokenSource,O=H(L.token);return new te(L,async _=>{const V=L.token.onCancellationRequested(()=>{V.dispose(),L.dispose(),_.reject(new t.CancellationError)});try{for await(const x of O){if(L.token.isCancellationRequested)return;_.emitOne(x)}V.dispose(),L.dispose()}catch(x){V.dispose(),L.dispose(),_.reject(x)}})}e.createCancelableAsyncIterable=B}),define(Z[96],ee([0,1,24,8,30,31,9,4,25]),function(q,e,v,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",b="[^/\\\\]",y=/\//g;function h(F,A){switch(F){case 0:return"";case 1:return`${b}*?`;default:return`(?:${I}|${b}+${I}${A?`|${I}${b}+`:""})*?`}}function d(F,A){if(!F)return[];const W=[];let z=!1,te=!1,B="";for(const H of F){switch(H){case A:if(!z&&!te){W.push(B),B="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":te=!0;break;case"]":te=!1;break}B+=H}return B&&W.push(B),W}e.splitGlobAware=d;function S(F){if(!F)return"";let A="";const W=d(F,e.GLOB_SPLIT);if(W.every(z=>z===e.GLOBSTAR))A=".*";else{let z=!1;W.forEach((te,B)=>{if(te===e.GLOBSTAR){if(z)return;A+=h(2,B===W.length-1)}else{let H=!1,L="",O=!1,_="";for(const V of te){if(V!=="}"&&H){L+=V;continue}if(O&&(V!=="]"||!_)){let x;V==="-"?x=V:(V==="^"||V==="!")&&!_?x="^":V===e.GLOB_SPLIT?x="":x=(0,l.escapeRegExpCharacters)(V),_+=x;continue}switch(V){case"{":H=!0;continue;case"[":O=!0;continue;case"}":{A+=`(?:${d(L,",").map(j=>S(j)).join("|")})`,H=!1,L="";break}case"]":{A+="["+_+"]",O=!1,_="";break}case"?":A+=b;continue;case"*":A+=h(1);continue;default:A+=(0,l.escapeRegExpCharacters)(V)}}B<W.length-1&&(W[B+1]!==e.GLOBSTAR||B+2<W.length)&&(A+=I)}z=te===e.GLOBSTAR})}return A}const C=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new R.LRUCache(1e4),o=function(){return!1},i=function(){return null};function r(F,A){if(!F)return i;let W;typeof F!="string"?W=F.pattern:W=F,W=W.trim();const z=`${W}_${!!A.trimForExclusions}`;let te=n.get(z);if(te)return s(te,F);let B;return C.test(W)?te=u(W.substr(4),W):(B=w.exec(c(W,A)))?te=P(B[1],W):(A.trimForExclusions?f:p).test(W)?te=D(W,A):(B=g.exec(c(W,A)))?te=T(B[1].substr(1),W,!0):(B=a.exec(c(W,A)))?te=T(B[1],W,!1):te=N(W),n.set(z,te),s(te,F)}function s(F,A){if(typeof A=="string")return F;const W=function(z,te){return(0,k.isEqualOrParent)(z,A.base,!E.isLinux)?F(z.substr(A.base.length+1),te):null};return W.allBasenames=F.allBasenames,W.allPaths=F.allPaths,W.basenames=F.basenames,W.patterns=F.patterns,W}function c(F,A){return A.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function u(F,A){return function(W,z){return typeof W=="string"&&W.endsWith(F)?A:null}}function P(F,A){const W=`/${F}`,z=`\\${F}`,te=function(H,L){return typeof H!="string"?null:L?L===F?A:null:H===F||H.endsWith(W)||H.endsWith(z)?A:null},B=[F];return te.basenames=B,te.patterns=[A],te.allBasenames=B,te}function D(F,A){const W=G(F.slice(1,-1).split(",").map(L=>r(L,A)).filter(L=>L!==i),F),z=W.length;if(!z)return i;if(z===1)return W[0];const te=function(L,O){for(let _=0,V=W.length;_<V;_++)if(W[_](L,O))return F;return null},B=W.find(L=>!!L.allBasenames);B&&(te.allBasenames=B.allBasenames);const H=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return H.length&&(te.allPaths=H),te}function T(F,A,W){const z=M.sep===M.posix.sep,te=z?F:F.replace(y,M.sep),B=M.sep+te,H=M.posix.sep+F;let L;return W?L=function(O,_){return typeof O=="string"&&(O===te||O.endsWith(B)||!z&&(O===F||O.endsWith(H)))?A:null}:L=function(O,_){return typeof O=="string"&&(O===te||!z&&O===F)?A:null},L.allPaths=[(W?"*/":"./")+F],L}function N(F){try{const A=new RegExp(`^${S(F)}$`);return function(W){return A.lastIndex=0,typeof W=="string"&&A.test(W)?F:null}}catch{return i}}function U(F,A,W){return!F||typeof A!="string"?!1:$(F)(A,void 0,W)}e.match=U;function $(F,A={}){if(!F)return o;if(typeof F=="string"||Y(F)){const W=r(F,A);if(W===i)return o;const z=function(te,B){return!!W(te,B)};return W.allBasenames&&(z.allBasenames=W.allBasenames),W.allPaths&&(z.allPaths=W.allPaths),z}return se(F,A)}e.parse=$;function Y(F){const A=F;return A?typeof A.base=="string"&&typeof A.pattern=="string":!1}e.isRelativePattern=Y;function oe(F){return F.allBasenames||[]}e.getBasenameTerms=oe;function ue(F){return F.allPaths||[]}e.getPathTerms=ue;function se(F,A){const W=G(Object.getOwnPropertyNames(F).map(L=>de(L,F[L],A)).filter(L=>L!==i)),z=W.length;if(!z)return i;if(!W.some(L=>!!L.requiresSiblings)){if(z===1)return W[0];const L=function(V,x){let re;for(let j=0,ie=W.length;j<ie;j++){const ne=W[j](V,x);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(re||(re=[]),re.push(ne))}return re?(async()=>{for(const j of re){const ie=await j;if(typeof ie=="string")return ie}return null})():null},O=W.find(V=>!!V.allBasenames);O&&(L.allBasenames=O.allBasenames);const _=W.reduce((V,x)=>x.allPaths?V.concat(x.allPaths):V,[]);return _.length&&(L.allPaths=_),L}const te=function(L,O,_){let V,x;for(let re=0,j=W.length;re<j;re++){const ie=W[re];ie.requiresSiblings&&_&&(O||(O=(0,M.basename)(L)),V||(V=O.substr(0,O.length-(0,M.extname)(L).length)));const ne=ie(L,O,V,_);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(x||(x=[]),x.push(ne))}return x?(async()=>{for(const re of x){const j=await re;if(typeof j=="string")return j}return null})():null},B=W.find(L=>!!L.allBasenames);B&&(te.allBasenames=B.allBasenames);const H=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return H.length&&(te.allPaths=H),te}function de(F,A,W){if(A===!1)return i;const z=r(F,W);if(z===i)return i;if(typeof A=="boolean")return z;if(A){const te=A.when;if(typeof te=="string"){const B=(H,L,O,_)=>{if(!_||!z(H,L))return null;const V=te.replace("$(basename)",O),x=_(V);return(0,t.isThenable)(x)?x.then(re=>re?F:null):x?F:null};return B.requiresSiblings=!0,B}}return z}function G(F,A){const W=F.filter(L=>!!L.basenames);if(W.length<2)return F;const z=W.reduce((L,O)=>{const _=O.basenames;return _?L.concat(_):L},[]);let te;if(A){te=[];for(let L=0,O=z.length;L<O;L++)te.push(A)}else te=W.reduce((L,O)=>{const _=O.patterns;return _?L.concat(_):L},[]);const B=function(L,O){if(typeof L!="string")return null;if(!O){let V;for(V=L.length;V>0;V--){const x=L.charCodeAt(V-1);if(x===47||x===92)break}O=L.substr(V)}const _=z.indexOf(O);return _!==-1?te[_]:null};B.basenames=z,B.patterns=te,B.allBasenames=z;const H=F.filter(L=>!L.basenames);return H.push(B),H}function K(F,A){return(0,v.equals)(F,A,(W,z)=>typeof W=="string"&&typeof z=="string"?W===z:typeof W!="string"&&typeof z!="string"?W.base===z.base&&W.pattern===z.pattern:!1)}e.patternsEquals=K}),define(Z[34],ee([0,1,24,30,9,4,16,25]),function(q,e,v,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function l(i,r){const{os:s,tildify:c,relative:u}=r;if(u){const T=m(i,u,s);if(typeof T=="string")return T}let P=i.fsPath;if(s===1&&!R.isWindows?P=P.replace(/\//g,"\\"):s!==1&&R.isWindows&&(P=P.replace(/\\/g,"/")),s!==1&&c?.userHome){const T=c.userHome.fsPath;let N;i.scheme!==c.userHome.scheme&&i.path.startsWith(k.posix.sep)?N=c.userHome.with({path:i.path}).fsPath:N=i.fsPath,P=y(N,T,s)}return(s===1?k.win32:k.posix).normalize(I(P,s===1))}e.getPathLabel=l;function m(i,r,s){const c=s===1?k.win32:k.posix,u=s===3?M.extUri:M.extUriIgnorePathCase,P=r.getWorkspace(),D=(0,v.firstOrDefault)(P.folders);if(!D)return;i.scheme!==D.uri.scheme&&i.path.startsWith(k.posix.sep)&&(i=D.uri.with({path:i.path}));const T=r.getWorkspaceFolder(i);if(!T)return;let N;if(u.isEqual(T.uri,i)?N="":N=u.relativePath(T.uri,i)??"",N&&(N=c.normalize(N)),P.folders.length>1&&!r.noPrefix){const U=T.name?T.name:u.basenameOrAuthority(T.uri);N=N?`${U} \u2022 ${N}`:U}return N}function I(i,r=R.isWindows){return(0,t.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let b=Object.create(null);function y(i,r,s=R.OS){if(s===1||!i||!r)return i;let c=b.original===r?b.normalized:void 0;c||(c=r,R.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,E.rtrim)(c,k.posix.sep)}${k.posix.sep}`,b={original:r,normalized:c});let u=i;return R.isWindows&&(u=(0,t.toSlashes)(u)),(s===3?u.startsWith(c):(0,E.startsWithIgnoreCase)(u,c))?`~/${u.substr(c.length)}`:i}e.tildify=y;function h(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=h;const d="\u2026",S="\\\\",C="~";function w(i,r=k.sep){const s=new Array(i.length);let c=!1;for(let u=0;u<i.length;u++){const P=i[u];if(P===""){s[u]=`.${r}`;continue}if(!P){s[u]=P;continue}c=!0;let D="",T=P;T.indexOf(S)===0?(D=T.substr(0,T.indexOf(S)+S.length),T=T.substr(T.indexOf(S)+S.length)):T.indexOf(r)===0?(D=T.substr(0,T.indexOf(r)+r.length),T=T.substr(T.indexOf(r)+r.length)):T.indexOf(C)===0&&(D=T.substr(0,T.indexOf(C)+C.length),T=T.substr(T.indexOf(C)+C.length));const N=T.split(r);for(let U=1;c&&U<=N.length;U++)for(let $=N.length-U;c&&$>=0;$--){c=!1;let Y=N.slice($,$+U).join(r);for(let oe=0;!c&&oe<i.length;oe++)if(oe!==u&&i[oe]&&i[oe].indexOf(Y)>-1){const ue=$+U===N.length,se=$>0&&i[oe].indexOf(r)>-1?r+Y:Y,de=i[oe].endsWith(se);c=!ue||de}if(!c){let oe="";(N[0].endsWith(":")||D!=="")&&($===1&&($=0,U++,Y=N[0]+r+Y),$>0&&(oe=N[0]+r),oe=D+oe),$>0&&(oe=oe+d+r),oe=oe+Y,$+U<N.length&&(oe=oe+r+d),s[u]=oe}}c&&(s[u]=P)}return s}e.shorten=w;var p;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function f(i,r=Object.create(null)){const s=[];let c=!1,u="";for(const P of i)if(P==="$"||c&&P==="{")u&&s.push({value:u,type:p.TEXT}),u="",c=!0;else if(P==="}"&&c){const D=r[u];if(typeof D=="string")D.length&&s.push({value:D,type:p.VARIABLE});else if(D){const T=s[s.length-1];(!T||T.type!==p.SEPARATOR)&&s.push({value:D.label,type:p.SEPARATOR})}u="",c=!1}else u+=P;return u&&!c&&s.push({value:u,type:p.TEXT}),s.filter((P,D)=>{if(P.type===p.SEPARATOR){const T=s[D-1],N=s[D+1];return[T,N].every(U=>U&&(U.type===p.VARIABLE||U.type===p.TEXT)&&U.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=f;function g(i,r){return R.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function a(i,r){return R.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,s=>s==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function n(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=n;function o(i){const r=i.indexOf("/")!==-1?k.posix:k.win32,s=r.basename(i),c=r.dirname(i);return s.length?{name:s,parentPath:c}:{name:c,parentPath:""}}e.splitName=o}),define(Z[140],ee([0,1,7]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(I){return I.toJSON()}class k{constructor(b){this._uriTransformer=b}transformIncoming(b){const y=this._uriTransformer.transformIncoming(b);return y===b?b:t(v.URI.from(y))}transformOutgoing(b){const y=this._uriTransformer.transformOutgoing(b);return y===b?b:t(v.URI.from(y))}transformOutgoingURI(b){const y=this._uriTransformer.transformOutgoing(b);return y===b?b:v.URI.from(y)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,b,y){if(!I||y>200)return null;if(typeof I=="object"){if(I instanceof v.URI)return b.transformOutgoing(I);for(const h in I)if(Object.hasOwnProperty.call(I,h)){const d=R(I[h],b,y+1);d!==null&&(I[h]=d)}}return null}function M(I,b){const y=R(I,b,0);return y===null?I:y}e.transformOutgoingURIs=M;function E(I,b,y,h){if(!I||h>200)return null;if(typeof I=="object"){if(I.$mid===1)return y?v.URI.revive(b.transformIncoming(I)):b.transformIncoming(I);for(const d in I)if(Object.hasOwnProperty.call(I,d)){const S=E(I[d],b,y,h+1);S!==null&&(I[d]=S)}}return null}function l(I,b){const y=E(I,b,!1,0);return y===null?I:y}e.transformIncomingURIs=l;function m(I,b){const y=E(I,b,!0,0);return y===null?I:y}e.transformAndReviveIncomingURIs=m}),define(Z[81],ee([0,1,28,17,31,29,128]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,b=0;const y=(0,v.networkInterfaces)();for(const h in y){const d=y[h];if(d)for(const{mac:S,internal:C}of d)C||(b+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(I+=1))}this._value=b>0?I/b:0}return this._value}};let E;async function l(){return E||(E=(async()=>await m()||R.generateUuid())()),E}e.getMachineId=l;async function m(){try{const I=await new Promise((y,h)=>{q(["crypto"],y,h)}),b=(0,M.getMac)();return I.createHash("sha256").update(b,"utf8").digest("hex")}catch(I){t.onUnexpectedError(I);return}}}),define(Z[23],ee([0,1,40,28,141,8,30,80,9,4,16,7]),function(q,e,v,t,k,R,M,E,l,m,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function h(se,de=y.UNLINK){if((0,M.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return de===y.UNLINK?S(se):d(se)}async function d(se){try{const de=(0,M.randomPath)((0,t.tmpdir)());try{await v.promises.rename(se,de)}catch(G){return G.code==="ENOENT"?void 0:S(se)}S(de).catch(G=>{})}catch(de){if(de.code!=="ENOENT")throw de}}async function S(se){return(0,k.promisify)(v.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function C(se){if((0,M.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");v.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=C;async function w(se,de){return g(await(de?p(se):(0,k.promisify)(v.readdir)(se)))}async function p(se){try{return await(0,k.promisify)(v.readdir)(se,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const de=[],G=await w(se);for(const K of G){let F=!1,A=!1,W=!1;try{const z=await e.Promises.lstat((0,l.join)(se,K));F=z.isFile(),A=z.isDirectory(),W=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}de.push({name:K,isFile:()=>F,isDirectory:()=>A,isSymbolicLink:()=>W})}return de}function f(se){return g(v.readdirSync(se))}e.readdirSync=f;function g(se){return se.map(de=>typeof de=="string"?m.isMacintosh?(0,E.normalizeNFC)(de):de:(de.name=m.isMacintosh?(0,E.normalizeNFC)(de.name):de.name,de))}async function a(se){const de=await w(se),G=[];for(const K of de)await o.existsDirectory((0,l.join)(se,K))&&G.push(K);return G}function n(se,de=1e3){return new Promise(G=>{let K=!1;const F=setInterval(()=>{K||(K=!0,v.access(se,A=>{K=!1,A&&(clearInterval(F),G(void 0))}))},de)})}e.whenDeleted=n;var o;(function(se){async function de(F){let A;try{if(A=await e.Promises.lstat(F),!A.isSymbolicLink())return{stat:A}}catch{}try{return{stat:await e.Promises.stat(F),symbolicLink:A?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(m.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw z}throw W}}se.stat=de;async function G(F){try{const{stat:A,symbolicLink:W}=await se.stat(F);return A.isFile()&&W?.dangling!==!0}catch{}return!1}se.existsFile=G;async function K(F){try{const{stat:A,symbolicLink:W}=await se.stat(F);return A.isDirectory()&&W?.dangling!==!0}catch{}return!1}se.existsDirectory=K})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function r(se,de,G){return i.queueFor(b.URI.file(se),I.extUriBiasedIgnorePathCase).queue(()=>{const K=D(G);return new Promise((F,A)=>u(se,de,K,W=>W?A(W):F()))})}let s=!0;function c(se){s=se}e.configureFlushOnWrite=c;function u(se,de,G,K){if(!s)return v.writeFile(se,de,{mode:G.mode,flag:G.flag},K);v.open(se,G.flag,G.mode,(F,A)=>{if(F)return K(F);v.writeFile(A,de,W=>{if(W)return v.close(A,()=>K(W));v.fdatasync(A,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),c(!1)),v.close(A,te=>K(te))))})})}function P(se,de,G){const K=D(G);if(!s)return v.writeFileSync(se,de,{mode:K.mode,flag:K.flag});const F=v.openSync(se,K.flag,K.mode);try{v.writeFileSync(F,de);try{v.fdatasyncSync(F)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),c(!1)}}finally{v.closeSync(F)}}e.writeFileSync=P;function D(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function T(se,de){if(se!==de)try{await e.Promises.rename(se,de)}catch(G){if(se.toLowerCase()!==de.toLowerCase()&&G.code==="EXDEV"||se.endsWith("."))await N(se,de,{preserveSymlinks:!1}),await h(se,y.MOVE);else throw G}}async function N(se,de,G){return $(se,de,{root:{source:se,target:de},options:G,handledSourcePaths:new Set})}const U=511;async function $(se,de,G){if(G.handledSourcePaths.has(se))return;G.handledSourcePaths.add(se);const{stat:K,symbolicLink:F}=await o.stat(se);if(F){if(G.options.preserveSymlinks)try{return await ue(se,de,G)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(F.dangling)return}return K.isDirectory()?Y(se,de,K.mode&U,G):oe(se,de,K.mode&U)}async function Y(se,de,G,K){await e.Promises.mkdir(de,{recursive:!0,mode:G});const F=await w(se);for(const A of F)await $((0,l.join)(se,A),(0,l.join)(de,A),K)}async function oe(se,de,G){await e.Promises.copyFile(se,de),await e.Promises.chmod(de,G)}async function ue(se,de,G){let K=await e.Promises.readlink(se);(0,M.isEqualOrParent)(K,G.root.source,!m.isLinux)&&(K=(0,l.join)(G.root.target,K.substr(G.root.source.length+1))),await e.Promises.symlink(K,de)}e.Promises=new class{get access(){return(0,k.promisify)(v.access)}get stat(){return(0,k.promisify)(v.stat)}get lstat(){return(0,k.promisify)(v.lstat)}get utimes(){return(0,k.promisify)(v.utimes)}get read(){return(se,de,G,K,F)=>new Promise((A,W)=>{v.read(se,de,G,K,F,(z,te,B)=>z?W(z):A({bytesRead:te,buffer:B}))})}get readFile(){return(0,k.promisify)(v.readFile)}get write(){return(se,de,G,K,F)=>new Promise((A,W)=>{v.write(se,de,G,K,F,(z,te,B)=>z?W(z):A({bytesWritten:te,buffer:B}))})}get appendFile(){return(0,k.promisify)(v.appendFile)}get fdatasync(){return(0,k.promisify)(v.fdatasync)}get truncate(){return(0,k.promisify)(v.truncate)}get rename(){return(0,k.promisify)(v.rename)}get copyFile(){return(0,k.promisify)(v.copyFile)}get open(){return(0,k.promisify)(v.open)}get close(){return(0,k.promisify)(v.close)}get symlink(){return(0,k.promisify)(v.symlink)}get readlink(){return(0,k.promisify)(v.readlink)}get chmod(){return(0,k.promisify)(v.chmod)}get mkdir(){return(0,k.promisify)(v.mkdir)}get unlink(){return(0,k.promisify)(v.unlink)}get rmdir(){return(0,k.promisify)(v.rmdir)}get realpath(){return(0,k.promisify)(v.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return a}get writeFile(){return r}get rm(){return h}get move(){return T}get copy(){return N}}}),define(Z[97],ee([0,1,40,9,4,25,23]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function E(y){if(k.isLinux)return y;const h=(0,t.dirname)(y);if(y===h)return y;const d=((0,t.basename)(y)||y).toLowerCase();try{const C=(0,M.readdirSync)(h).filter(w=>w.toLowerCase()===d);if(C.length===1){const w=E(h);if(w)return(0,t.join)(w,C[0])}else if(C.length>1){const w=C.indexOf(d);if(w>=0){const p=E(h);if(p)return(0,t.join)(p,C[w])}}}catch{}return null}e.realcaseSync=E;async function l(y){if(k.isLinux)return y;const h=(0,t.dirname)(y);if(y===h)return y;const d=((0,t.basename)(y)||y).toLowerCase();try{const C=(await M.Promises.readdir(h)).filter(w=>w.toLowerCase()===d);if(C.length===1){const w=await l(h);if(w)return(0,t.join)(w,C[0])}else if(C.length>1){const w=C.indexOf(d);if(w>=0){const p=await l(h);if(p)return(0,t.join)(p,C[w])}}}catch{}return null}e.realcase=l;async function m(y){try{return await M.Promises.realpath(y)}catch{const d=b(y);return await M.Promises.access(d,v.constants.R_OK),d}}e.realpath=m;function I(y){try{return v.realpathSync(y)}catch{const d=b(y);return v.accessSync(d,v.constants.R_OK),d}}e.realpathSync=I;function b(y){return(0,R.rtrim)((0,t.normalize)(y),t.sep)}}),define(Z[142],ee([0,1,28,9,23]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,M=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var l;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(l||(l={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class b{constructor(a,n,o){this.exePath=a,this.displayName=n,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function y({useAlternateBitness:g=!1}={}){return g?m===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:g=!1,findPreview:a=!1}={}){const n=y({useAlternateBitness:g});if(!n)return null;const o=t.join(n,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(o))return null;let i=-1,r=null;for(const u of await k.Promises.readdir(o)){let P=-1;if(a){const T=u.indexOf("-");if(T<0)continue;const N=u.substring(0,T);if(!R.test(N)||u.substring(T+1)!=="preview")continue;P=parseInt(N,10)}else{if(!R.test(u))continue;P=parseInt(u,10)}if(P<=i)continue;const D=t.join(o,u,"pwsh.exe");!await k.SymlinkSupport.existsFile(D)||(r=D,i=P)}if(!r)return null;const s=n.includes("x86")?" (x86)":"",c=a?" Preview":"";return new b(r,`PowerShell${c}${s}`,!0)}async function d({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const a=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:n,pwshMsixName:o}=g?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(a))if(n.test(i)){const r=t.join(a,i,"pwsh.exe");return new b(r,o)}return null}function S(){const g=t.join(v.homedir(),".dotnet","tools","pwsh.exe");return new b(g,".NET Core PowerShell Global Tool")}function C(){const g=t.join(process.env.windir,m===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(g,"Windows PowerShell",!0)}async function*w(){let g=await h();g&&(yield g),g=await h({useAlternateBitness:!0}),g&&(yield g),g=await d(),g&&(yield g),g=S(),g&&(yield g),g=await h({findPreview:!0}),g&&(yield g),g=await d({findPreview:!0}),g&&(yield g),g=await h({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=C(),g&&(yield g)}async function*p(){for await(const g of w())await g.exists()&&(yield g)}e.enumeratePowerShellInstallations=p;async function f(){for await(const g of p())return g;return null}e.getFirstAvailablePowerShellInstallation=f}),define(Z[82],ee([0,1,9,4,33,78,12,23]),function(q,e,v,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function l(b=k.env){return b.comspec||"cmd.exe"}e.getWindowsShell=l;function m(b){let y=[],h=!1;const d=function(S){if(h){y.push(S);return}(!b.send(S,w=>{if(w&&console.error(w),h=!1,y.length>0){const p=y.slice(0);y=[],p.forEach(f=>d(f))}})||t.isWindows)&&(h=!0)};return{send:d}}e.createQueuedSender=m;var I;(function(b){async function y(h,d,S){if(v.isAbsolute(h))return h;if(d===void 0&&(d=k.cwd()),v.dirname(h)!=="."||(S===void 0&&M.isString(k.env.PATH)&&(S=k.env.PATH.split(v.delimiter)),S===void 0||S.length===0))return v.join(d,h);async function w(p){if(await E.Promises.exists(p)){let f;try{f=await E.Promises.stat(p)}catch(g){g.message.startsWith("EACCES")&&(f=await E.Promises.lstat(p))}return f?!f.isDirectory():!1}return!1}for(const p of S){let f;if(v.isAbsolute(p)?f=v.join(p,h):f=v.join(d,p,h),await w(f))return f;let g=f+".com";if(await w(g)||(g=f+".exe",await w(g)))return g}return v.join(d,h)}b.findExecutable=y})(I=e.win32||(e.win32={}))}),define(Z[98],ee([0,1,45,13]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(M){return new Promise((E,l)=>{let m;const I=new Map;function b(h,d,S,C,w){const p=I.get(d);if(h===M||p){const f={name:y(S),cmd:S,pid:h,ppid:d,load:C,mem:w};I.set(h,f),h===M&&(m=f),p&&(p.children||(p.children=[]),p.children.push(f),p.children.length>1&&(p.children=p.children.sort((g,a)=>g.pid-a.pid)))}}function y(h){const d=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,C=/--vscode-window-kind=process-explorer/,w=/--utility-sub-type=network/,p=/--utility-sub-type=node.mojom.NodeService/,f=/--crashes-directory/,g=/\\pipe\\winpty-control/,a=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(f.exec(h))return"electron-crash-reporter";if(g.exec(h))return"winpty-process";if(a.exec(h))return"console-window-host (Windows internal process)";let o=n.exec(h);if(o&&o.length===2){if(o[1]==="renderer")return d.exec(h)?"shared-process":S.exec(h)?"issue-reporter":C.exec(h)?"process-explorer":"window";if(o[1]==="utility"){if(w.exec(h))return"utility-network-service";if(p.exec(h))return"extension-host"}return o[1]}const i=/[a-zA-Z-]+\.js/g;let r="";do o=i.exec(h),o&&(r+=o+" ");while(o);return r&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron_node ${r}`:h}if(process.platform==="win32"){const h=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,S)=>{q(["windows-process-tree"],d,S)}).then(d=>{d.getProcessList(M,S=>{if(!S){l(new Error(`Root process ${M} not found`));return}d.getProcessCpuUsage(S,C=>{const w=new Map;C.forEach(p=>{const f=h(p.commandLine||"");w.set(p.pid,{name:y(f),cmd:f,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),m=w.get(M),m?(w.forEach(p=>{const f=w.get(p.ppid);f&&(f.children||(f.children=[]),f.children.push(p))}),w.forEach(p=>{p.children&&(p.children=p.children.sort((f,g)=>f.pid-g.pid))}),E(m)):l(new Error(`Root process ${M} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let h=function(){let d=[m];const S=[];for(;d.length;){const w=d.shift();w&&(S.push(w.pid),w.children&&(d=d.concat(w.children)))}let C=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",q).fsPath);C+=" "+S.join(" "),(0,v.exec)(C,{},(w,p,f)=>{if(w||f)l(w||new Error(f.toString()));else{const g=p.toString().split(`
`);for(let a=0;a<S.length;a++){const n=I.get(S[a]);n.load=parseFloat(g[a])}if(!m){l(new Error(`Root process ${M} not found`));return}E(m)}})};(0,v.exec)("which ps",{},(d,S,C)=>{if(d||C)if(process.platform!=="linux")l(d||new Error(C.toString()));else{const w=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",q).fsPath);(0,v.exec)(w,{},(p,f,g)=>{p||g?l(p||new Error(g.toString())):(R(f,b),h())})}else{const w=S.toString().trim(),p="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${w} ${p}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,g,a)=>{f||a&&!a.includes("screen size is bogus")?l(f||new Error(a.toString())):(R(g,b),process.platform==="linux"?h():m?E(m):l(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=k;function R(M,E){const l=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=M.toString().split(`
`);for(const I of m){const b=l.exec(I.trim());b&&b.length===6&&E(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(Z[143],ee([0,1,28,4,142,82]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(h,d){return h===1?t.isWindows?b():R.getWindowsShell(d):m(h,d)}e.getSystemShell=M;function E(h,d){return h===1?t.isWindows?y(d):R.getWindowsShell(d):m(h,d)}e.getSystemShellSync=E;let l=null;function m(h,d){if(t.isLinux&&h===2||t.isMacintosh&&h===3)return"/bin/bash";if(!l){let S;if(t.isWindows)S="/bin/bash";else{if(S=d.SHELL,!S)try{S=(0,v.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}l=S}return l}let I=null;async function b(){return I||(I=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),I}function y(h){if(I)return I;const d=t.isWindows&&parseFloat((0,v.release)())>=10,S=h.hasOwnProperty("PROCESSOR_ARCHITEW6432"),C=`${h.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?C:R.getWindowsShell(h)}});var ve=this&&this.__decorate||function(q,e,v,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,v):t,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(q,e,v,t);else for(var E=q.length-1;E>=0;E--)(M=q[E])&&(R=(k<3?M(R):k>3?M(e,v,R):M(e,v))||R);return k>3&&R&&Object.defineProperty(e,v,R),R};define(Z[46],ee([0,1,24,8,18,22,53,17,3,2,67,25,12]),function(q,e,v,t,k,R,M,E,l,m,I,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var h;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(h=e.RequestType||(e.RequestType={}));function d(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function C(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(w||(w={}));class p{constructor(A){this.buffer=A,this.pos=0}read(A){const W=this.buffer.slice(this.pos,this.pos+A);return this.pos+=W.byteLength,W}}class f{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var g;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(g||(g={}));function a(F){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(F,0),A}function n(F){return F.read(4).readUInt32BE(0)}function o(F){const A=k.VSBuffer.alloc(1);return A.writeUInt8(F,0),A}const i={Undefined:o(g.Undefined),String:o(g.String),Buffer:o(g.Buffer),VSBuffer:o(g.VSBuffer),Array:o(g.Array),Object:o(g.Object)},r=typeof Buffer<"u";function s(F,A){if(typeof A>"u")F.write(i.Undefined);else if(typeof A=="string"){const W=k.VSBuffer.fromString(A);F.write(i.String),F.write(a(W.byteLength)),F.write(W)}else if(r&&Buffer.isBuffer(A)){const W=k.VSBuffer.wrap(A);F.write(i.Buffer),F.write(a(W.byteLength)),F.write(W)}else if(A instanceof k.VSBuffer)F.write(i.VSBuffer),F.write(a(A.byteLength)),F.write(A);else if(Array.isArray(A)){F.write(i.Array),F.write(a(A.length));for(const W of A)s(F,W)}else{const W=k.VSBuffer.fromString(JSON.stringify(A));F.write(i.Object),F.write(a(W.byteLength)),F.write(W)}}function c(F){switch(F.read(1).readUInt8(0)){case g.Undefined:return;case g.String:return F.read(n(F)).toString();case g.Buffer:return F.read(n(F)).buffer;case g.VSBuffer:return F.read(n(F));case g.Array:{const W=n(F),z=[];for(let te=0;te<W;te++)z.push(c(F));return z}case g.Object:return JSON.parse(F.read(n(F)).toString())}}class u{constructor(A,W,z=null,te=1e3){this.protocol=A,this.ctx=W,this.logger=z,this.timeoutDelay=te,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(A,W){this.channels.set(A,W),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const W=this.send([A.type]);this.logger?.logOutgoing(W,0,1,C(A.type));return}case 201:case 202:case 204:case 203:{const W=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(W,A.id,1,C(A.type),A.data);return}}}send(A,W=void 0){const z=new f;return s(z,A),s(z,W),this.sendBuffer(z.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const W=new p(A),z=c(W),te=c(W),B=z[0];switch(B){case 100:return this.logger?.logIncoming(A.byteLength,z[1],1,`${d(B)}: ${z[2]}.${z[3]}`,te),this.onPromise({type:B,id:z[1],channelName:z[2],name:z[3],arg:te});case 102:return this.logger?.logIncoming(A.byteLength,z[1],1,`${d(B)}: ${z[2]}.${z[3]}`,te),this.onEventListen({type:B,id:z[1],channelName:z[2],name:z[3],arg:te});case 101:return this.logger?.logIncoming(A.byteLength,z[1],1,`${d(B)}`),this.disposeActiveRequest({type:B,id:z[1]});case 103:return this.logger?.logIncoming(A.byteLength,z[1],1,`${d(B)}`),this.disposeActiveRequest({type:B,id:z[1]})}}onPromise(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const z=new R.CancellationTokenSource;let te;try{te=W.call(this.ctx,A.name,A.arg,z.token)}catch(L){te=Promise.reject(L)}const B=A.id;te.then(L=>{this.sendResponse({id:B,data:L,type:201}),this.activeRequests.delete(A.id)},L=>{L instanceof Error?this.sendResponse({id:B,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:B,data:L,type:203}),this.activeRequests.delete(A.id)});const H=(0,m.toDisposable)(()=>z.cancel());this.activeRequests.set(A.id,H)}onEventListen(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const z=A.id,B=W.listen(this.ctx,A.name,A.arg)(H=>this.sendResponse({id:z,data:H,type:204}));this.activeRequests.set(A.id,B)}disposeActiveRequest(A){const W=this.activeRequests.get(A.id);W&&(W.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let W=this.pendingRequests.get(A.channelName);W||(W=[],this.pendingRequests.set(A.channelName,W));const z=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:A,timeoutTimer:z})}flushPendingRequests(A){const W=this.pendingRequests.get(A);if(W){for(const z of W)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=u;var P;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(A,W=null){this.protocol=A,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=W}getChannel(A){const W=this;return{call(z,te,B){return W.isDisposed?Promise.reject(new E.CancellationError):W.requestPromise(A,z,te,B)},listen(z,te){return W.isDisposed?l.Event.None:W.requestEvent(A,z,te)}}}requestPromise(A,W,z,te=R.CancellationToken.None){const B=this.lastRequestId++,L={id:B,type:100,channelName:A,name:W,arg:z};if(te.isCancellationRequested)return Promise.reject(new E.CancellationError);let O;return new Promise((V,x)=>{if(te.isCancellationRequested)return x(new E.CancellationError);const re=()=>{const ae=fe=>{switch(fe.type){case 201:this.handlers.delete(B),V(fe.data);break;case 202:{this.handlers.delete(B);const De=new Error(fe.data.message);De.stack=fe.data.stack,De.name=fe.data.name,x(De);break}case 203:this.handlers.delete(B),x(fe.data);break}};this.handlers.set(B,ae),this.sendRequest(L)};let j=null;this.state===w.Idle?re():(j=(0,t.createCancelablePromise)(ae=>this.whenInitialized()),j.then(()=>{j=null,re()}));const ie=()=>{j?(j.cancel(),j=null):this.sendRequest({id:B,type:101}),x(new E.CancellationError)},ne=te.onCancellationRequested(ie);O=(0,m.combinedDisposable)((0,m.toDisposable)(ie),ne),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(A,W,z){const te=this.lastRequestId++,H={id:te,type:102,channelName:A,name:W,arg:z};let L=null;const O=new l.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(V=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(O),this.sendRequest(H)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(O),this.sendRequest({id:te,type:103}))}}),_=V=>O.fire(V.data);return this.handlers.set(te,_),O.event}sendRequest(A){switch(A.type){case 100:case 102:{const W=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(W,A.id,0,`${d(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const W=this.send([A.type,A.id]);this.logger?.logOutgoing(W,A.id,0,d(A.type));return}}}send(A,W=void 0){const z=new f;return s(z,A),s(z,W),this.sendBuffer(z.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const W=new p(A),z=c(W),te=c(W),B=z[0];switch(B){case 200:return this.logger?.logIncoming(A.byteLength,0,0,C(B)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,z[1],0,C(B),te),this.onResponse({type:z[0],id:z[1],data:te})}}onResponse(A){if(A.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ve([M.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class T{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:W,onDidClientDisconnect:z})=>{l.Event.once(W.onMessage)(B=>{const H=new p(B),L=c(H),O=new u(W,L),_=new D(W);this.channels.forEach((x,re)=>O.registerChannel(re,x));const V={channelServer:O,channelClient:_,ctx:L};this._connections.add(V),this._onDidAddConnection.fire(V),z(()=>{O.dispose(),_.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const A=[];return this._connections.forEach(W=>A.push(W)),A}getChannel(A,W){const z=this;return{call(te,B,H){let L;if((0,y.isFunction)(W)){const _=(0,v.getRandomElement)(z.connections.filter(W));L=_?Promise.resolve(_):l.Event.toPromise(l.Event.filter(z.onDidAddConnection,W))}else L=W.routeCall(z,te,B);const O=L.then(_=>_.channelClient.getChannel(A));return U(O).call(te,B,H)},listen(te,B){if((0,y.isFunction)(W))return z.getMulticastEvent(A,W,te,B);const H=W.routeEvent(z,te,B).then(L=>L.channelClient.getChannel(A));return U(H).listen(te,B)}}}getMulticastEvent(A,W,z,te){const B=this;let H=new m.DisposableStore;const L=new l.Emitter({onFirstListenerAdd:()=>{H=new m.DisposableStore;const O=new l.EventMultiplexer,_=new Map,V=re=>{const ie=re.channelClient.getChannel(A).listen(z,te),ne=O.add(ie);_.set(re,ne)},x=re=>{const j=_.get(re);!j||(j.dispose(),_.delete(re))};B.connections.filter(W).forEach(V),l.Event.filter(B.onDidAddConnection,W)(V,void 0,H),B.onDidRemoveConnection(x,void 0,H),O.event(L.fire,L,H),H.add(O)},onLastListenerRemove:()=>{H.dispose()}});return L.event}registerChannel(A,W){this.channels.set(A,W),this._connections.forEach(z=>{z.channelServer.registerChannel(A,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class N{constructor(A,W,z=null){const te=new f;s(te,W),A.send(te.buffer),this.channelClient=new D(A,z),this.channelServer=new u(A,W,z)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,W){this.channelServer.registerChannel(A,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=N;function U(F){return{call(A,W,z){return F.then(te=>te.call(A,W,z))},listen(A,W){const z=new l.Relay;return F.then(te=>z.input=te.listen(A,W)),z.event}}}e.getDelayedChannel=U;function $(F){let A=!1;return{call(W,z,te){return A?F.call(W,z,te):(0,t.timeout)(0).then(()=>A=!0).then(()=>F.call(W,z,te))},listen(W,z){if(A)return F.listen(W,z);const te=new l.Relay;return(0,t.timeout)(0).then(()=>A=!0).then(()=>te.input=F.listen(W,z)),te.event}}}e.getNextTickChannel=$;class Y{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const W of A.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await l.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=Y;var oe;(function(F){function A(B,H){const L=B,O=H&&H.disableMarshalling,_=new Map;for(const V in L)z(V)&&_.set(V,l.Event.buffer(L[V],!0));return new class{listen(V,x,re){const j=_.get(x);if(j)return j;if(te(x)){const ie=L[x];if(typeof ie=="function")return ie.call(L,re)}throw new Error(`Event not found: ${x}`)}call(V,x,re){const j=L[x];if(typeof j=="function"){if(!O&&Array.isArray(re))for(let ie=0;ie<re.length;ie++)re[ie]=(0,I.revive)(re[ie]);return j.apply(L,re)}throw new Error(`Method not found: ${x}`)}}}F.fromService=A;function W(B,H){const L=H&&H.disableMarshalling;return new Proxy({},{get(O,_){if(typeof _=="string")return H?.properties?.has(_)?H.properties.get(_):te(_)?function(V){return B.listen(_,V)}:z(_)?B.listen(_):async function(...V){let x;H&&!(0,y.isUndefinedOrNull)(H.context)?x=[H.context,...V]:x=V;const re=await B.call(_,x);return L?re:(0,I.revive)(re)};throw new Error(`Property not found: ${String(_)}`)}})}F.toService=W;function z(B){return B[0]==="o"&&B[1]==="n"&&b.isUpperAsciiLetter(B.charCodeAt(2))}function te(B){return/^onDynamic/.test(B)&&b.isUpperAsciiLetter(B.charCodeAt(9))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const A=F.toString();if(A!=="[object Object]")return A}return F}function de(F){return Array.isArray(F)?F.map(se):se(F)}function G(F,A,W,z,te,B,H){H=de(H);const L=ue[te],O=L[z%L.length];let _=[`%c[${F}]%c[${String(A).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(B)?(_=_.concat(H),_.push(")")):_.push(H),console.log.apply(console,_)}e.logWithColors=G;class K{constructor(A,W){this._outgoingPrefix=A,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,W,z,te,B){this._totalOutgoing+=A,G(this._outgoingPrefix,this._totalOutgoing,A,W,z,te,B)}logIncoming(A,W,z,te,B){this._totalIncoming+=A,G(this._incomingPrefix,this._totalIncoming,A,W,z,te,B)}}e.IPCLogger=K}),define(Z[144],ee([0,1,18,3,46]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(l){this.port=l,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",m=>v.VSBuffer.wrap(m.data)),l.start()}send(l){this.port.postMessage(l.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class M extends k.IPCClient{constructor(l,m){const I=new R(l);super(I,m),this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=M}),define(Z[99],ee([0,1,18,3,2,46]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(M=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var E;(function(r){r.enableDiagnostics=!1,r.records=[];const s=new WeakMap;let c=0;function u(D,T){if(!s.has(D)){const N=String(++c);s.set(D,N)}return s.get(D)}function P(D,T,N,U){if(!r.enableDiagnostics)return;const $=u(D,T);if(U instanceof v.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const Y=v.VSBuffer.alloc(U.byteLength);Y.set(U),r.records.push({timestamp:Date.now(),id:$,label:T,type:N,buff:Y})}else r.records.push({timestamp:Date.now(),id:$,label:T,type:N,data:U})}r.traceSocketEvent=P})(E=e.SocketDiagnostics||(e.SocketDiagnostics={}));var l;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(l=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function I(){return m||(m=v.VSBuffer.alloc(0)),m}class b{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,c){if(s===0)return I();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const T=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=s),T}if(this._chunks[0].byteLength>s){const T=this._chunks[0].slice(0,s);return c&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),T}const u=v.VSBuffer.alloc(s);let P=0,D=0;for(;s>0;){const T=this._chunks[D];if(T.byteLength>s){const N=T.slice(0,s);u.set(N,P),P+=s,c&&(this._chunks[D]=T.slice(s),this._totalLength-=s),s-=s}else u.set(T,P),P+=T.byteLength,c?(this._chunks.shift(),this._totalLength-=T.byteLength):D++,s-=T.byteLength}return u}}e.ChunkStream=b;var y;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(y||(y={}));function h(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(s,c,u,P){this.type=s,this.id=c,this.ack=u,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class C extends k.Disposable{constructor(s){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:h(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const u=this._state.messageType,P=this._state.id,D=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new S(u,P,D,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class w{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=v.VSBuffer.alloc(13);c.writeUInt8(s.type,0),c.writeUInt32BE(s.id,1),c.writeUInt32BE(s.ack,5),c.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:h(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(c,s.data)}_bufferAdd(s,c){const u=this._totalLength===0;return this._data.push(s,c),this._totalLength+=s.byteLength+c.byteLength,u}_bufferTake(){const s=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,c){this._bufferAdd(s,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class p extends k.Disposable{constructor(s){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new w(this._socket)),this._socketReader=this._register(new C(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new S(1,0,0,s))}}e.Protocol=p;class f extends R.IPCClient{constructor(s,c,u=null){super(s,c,u),this.protocol=s}static fromSocket(s,c){return new f(new p(s),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=f;class g{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=g;class a{constructor(s){this.data=s,this.next=null}}class n{constructor(){this._first=null,this._last=null}length(){let s=0,c=this._first;for(;c;)c=c.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let c=0,u=this._first;for(;u;)s[c++]=u.data,u=u.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const c=new a(s);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class o{constructor(){this.lastRuns=[];const s=Date.now();for(let c=0;c<o._HISTORY_LENGTH;c++)this.lastRuns[c]=s-1e3*c;setInterval(()=>{for(let c=o._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}load(){const s=Date.now(),c=(1+o._HISTORY_LENGTH)*1e3;let u=0;for(let P=0;P<o._HISTORY_LENGTH;P++)s-this.lastRuns[P]<=c&&u++;return 1-u/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class i{constructor(s,c=null,u=o.getInstance()){this._onControlMessage=new g,this.onControlMessage=this._onControlMessage.event,this._onMessage=new g,this.onMessage=this._onMessage.event,this._onDidDispose=new g,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new g,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new g,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(P=>this._receiveMessage(P))),this._socketDisposables.push(this._socket.onClose(P=>this._onSocketClose.fire(P))),c&&this._socketReader.acceptChunk(c),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new S(5,0,0,I());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new S(7,0,0,I());this._socketWriter.write(s)}sendResume(){const s=new S(8,0,0,I());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,c){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new S(3,0,this._incomingAckId,I());this._socketWriter.write(s);const c=this._outgoingUnackMsg.toArray();for(let u=0,P=c.length;u<P;u++)this._socketWriter.write(c[u]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new S(6,0,0,I())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let u=0,P=c.length;u<P;u++)this._socketWriter.write(c[u]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new S(1,c,this._incomingAckId,s);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(s){const c=new S(2,0,0,s);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),c=Date.now()-s.writtenTime,u=Date.now()-this._socketReader.lastReadTime,P=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&u>=2e4&&P>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:u});return}const D=Math.max(2e4-c,2e4-u,2e4-P,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},D)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new S(3,0,this._incomingAckId,I());this._socketWriter.write(s)}_sendKeepAlive(){const s=new S(9,0,0,I());this._socketWriter.write(s)}}e.PersistentProtocol=i}),define(Z[145],ee([0,1,41,18,3,2,46,130]),function(q,e,v,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function l(I,b){const y=k.Event.fromNodeEventEmitter(v.validatedIpcMain,b,(d,S)=>({event:d,message:S})),h=k.Event.filter(y,({event:d})=>d.sender.id===I);return k.Event.map(h,({message:d})=>d&&t.VSBuffer.wrap(d))}class m extends M.IPCServer{constructor(){super(m.getOnDidClientConnect())}static getOnDidClientConnect(){const b=k.Event.fromNodeEventEmitter(v.validatedIpcMain,"vscode:hello",({sender:y})=>y);return k.Event.map(b,y=>{const h=y.id;m.Clients.get(h)?.dispose();const S=new k.Emitter;m.Clients.set(h,(0,R.toDisposable)(()=>S.fire()));const C=l(h,"vscode:message"),w=k.Event.any(k.Event.signal(l(h,"vscode:disconnect")),S.event);return{protocol:new E.Protocol(y,C),onDidClientDisconnect:w}})}}e.Server=m,m.Clients=new Map}),define(Z[100],ee([0,1,41,3,29,144]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends R.Client{constructor(m,I){super({addEventListener:(b,y)=>m.addListener(b,y),removeEventListener:(b,y)=>m.removeListener(b,y),postMessage:b=>m.postMessage(b),start:()=>m.start(),close:()=>m.close()},I)}}e.Client=M;async function E(l){if(l.isDestroyed()||l.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,k.generateUuid)();l.webContents.send("vscode:createMessageChannel",m);const I=t.Event.fromNodeEventEmitter(v.validatedIpcMain,"vscode:createMessageChannelResult",(y,h)=>({nonce:h,port:y.ports[0]})),{port:b}=await t.Event.toPromise(t.Event.once(t.Event.filter(I,y=>y.nonce===m)));return b}e.connect=E}),define(Z[146],ee([0,1,45,8,18,22,139,17,3,2,50,82,78,46]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends h.ChannelServer{constructor(w){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",p=>k.VSBuffer.wrap(Buffer.from(p,"base64")))},w),process.once("disconnect",()=>this.dispose())}}e.Server=d;class S{constructor(w,p){this.modulePath=w,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new t.Delayer(f),this.child=null,this._client=null}getChannel(w){const p=this;return{call(f,g,a){return p.requestPromise(w,f,g,a)},listen(f,g){return p.requestEvent(w,f,g)}}}requestPromise(w,p,f,g=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(w),n=(0,t.createCancelablePromise)(r=>a.call(p,f,r)),o=g.onCancellationRequested(()=>n.cancel()),i=(0,m.toDisposable)(()=>n.cancel());return this.activeRequests.add(i),n.finally(()=>{o.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(w,p,f){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let g;const a=new l.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(w).listen(p,f)(a.fire,a),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const w=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,y.removeDangerousEnvVariables)(p.env),this.child=(0,v.fork)(this.modulePath,w,p);const f=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,M.isRemoteConsoleLog)(s)){(0,M.log)(s,`IPC Library: ${this.options.serverName}`);return}f.fire(k.VSBuffer.wrap(Buffer.from(s,"base64")))});const a=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,n=s=>this.child&&this.child.connected&&a.send(s.buffer.toString("base64")),o=f.event,i={send:n,onMessage:o};this._client=new h.ChannelClient(i);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,c)=>{process.removeListener("exit",r),this.activeRequests.forEach(u=>(0,m.dispose)(u)),this.activeRequests.clear(),s!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:c})})}return this._client}getCachedChannel(w){let p=this.channels.get(w);return p||(p=this.client.getChannel(w),this.channels.set(w,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(Z[83],ee([0,1,18,17,3,2,9,4,29,46,99]),function(q,e,v,t,k,R,M,E,l,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function b(){return{crypto:q.__$__nodeRequire("crypto"),zlib:q.__$__nodeRequire("zlib"),net:q.__$__nodeRequire("net"),os:q.__$__nodeRequire("os")}}class y{constructor(u,P=""){this.debugLabel=P,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,t.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener)}traceSocketEvent(u,P){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,P)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const P=D=>{this.traceSocketEvent("read",D),u(v.VSBuffer.wrap(D))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(u){const P=D=>{this.traceSocketEvent("close",{hadError:D}),u({type:0,hadError:D,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(u){const P=()=>{this.traceSocketEvent("nodeEndReceived"),u()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(u){if(!this.socket.destroyed)try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=y;var h;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(h||(h={}));var d;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(d||(d={}));class S extends R.Disposable{constructor(u,P,D,T){super(),this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:D?.byteLength||0,recordInflateBytes:T}),this._flowManager=this._register(new C(this,P,D,T,this._onData,(N,U)=>this._write(N,U))),this._register(this._flowManager.onError(N=>{console.error(N),(0,t.onUnexpectedError)(N),this._onClose.fire({type:0,hadError:!0,error:N})})),this._incomingData=new I.ChunkStream,this._register(this.socket.onData(N=>this._acceptChunk(N))),this._register(this.socket.onClose(N=>this._onClose.fire(N)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(u,P){this.socket.traceSocketEvent(u,P)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._flowManager.writeMessage(u)}_write(u,P){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let D=2;u.byteLength<126?D+=0:u.byteLength<2**16?D+=2:D+=8;const T=v.VSBuffer.alloc(D);if(P?T.writeUInt8(194,0):T.writeUInt8(130,0),u.byteLength<126)T.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){T.writeUInt8(126,1);let N=1;T.writeUInt8(u.byteLength>>>8&255,++N),T.writeUInt8(u.byteLength>>>0&255,++N)}else{T.writeUInt8(127,1);let N=1;T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(u.byteLength>>>24&255,++N),T.writeUInt8(u.byteLength>>>16&255,++N),T.writeUInt8(u.byteLength>>>8&255,++N),T.writeUInt8(u.byteLength>>>0&255,++N)}this.socket.write(v.VSBuffer.concat([T,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const P=this._incomingData.peek(this._state.readLen),D=P.readUInt8(0),T=(D&128)>>>7,N=(D&64)>>>6,U=P.readUInt8(1),$=(U&128)>>>7,Y=U&127;this._state.state=2,this._state.readLen=2+($?4:0)+(Y===126?2:0)+(Y===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(N)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const P=this._incomingData.read(this._state.readLen),D=P.readUInt8(1),T=(D&128)>>>7;let N=D&127,U=1;N===126?N=P.readUInt8(++U)*2**8+P.readUInt8(++U):N===127&&(N=P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U));let $=0;T&&($=P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U)),this._state.state=3,this._state.readLen=N,this._state.mask=$,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const P=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",P),f(P,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",P),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(P,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class C extends R.Disposable{constructor(u,P,D,T,N,U){super(),this._tracer=u,this._onData=N,this._writeFn=U,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,P?(this._zlibInflateStream=this._register(new w(this._tracer,T,D,{windowBits:15})),this._zlibDeflateStream=this._register(new p(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError($=>this._onError.fire($))),this._register(this._zlibDeflateStream.onError($=>this._onError.fire($)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:v.VSBuffer.alloc(0)}writeMessage(u){this._writeQueue.push(u),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const u=this._writeQueue.shift();if(this._zlibDeflateStream){const P=await this._deflateMessage(this._zlibDeflateStream,u);this._writeFn(P,!0)}else this._writeFn(u,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(u,P){return new Promise((D,T)=>{u.write(P),u.flush(N=>D(N))})}acceptFrame(u,P,D){this._readQueue.push({data:u,isCompressed:P,isLastFrameOfMessage:D}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const u=this._readQueue.shift();if(this._zlibInflateStream&&u.isCompressed){const P=await this._inflateFrame(this._zlibInflateStream,u.data,u.isLastFrameOfMessage);this._onData.fire(P)}else this._onData.fire(u.data)}this._isProcessingReadQueue=!1}}_inflateFrame(u,P,D){return new Promise((T,N)=>{u.write(P),D&&u.write(v.VSBuffer.fromByteArray([0,0,255,255])),u.flush(U=>T(U))})}}class w extends R.Disposable{constructor(u,P,D,T){super(),this._tracer=u,this._recordInflateBytes=P,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=b().zlib.createInflateRaw(T),this._zlibInflate.on("error",N=>{this._tracer.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibInflate.on("data",N=>{this._tracer.traceSocketEvent("zlibInflateData",N),this._pendingInflateData.push(v.VSBuffer.wrap(N))}),D&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this._zlibInflate.write(D.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?v.VSBuffer.concat(this._recordedInflateBytes):v.VSBuffer.alloc(0)}write(u){this._recordInflateBytes&&this._recordedInflateBytes.push(u.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",u),this._zlibInflate.write(u.buffer)}flush(u){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const P=v.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,u(P)})}}class p extends R.Disposable{constructor(u,P){super(),this._tracer=u,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=b().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",D=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this._onError.fire(D)}),this._zlibDeflate.on("data",D=>{this._tracer.traceSocketEvent("zlibDeflateData",D),this._pendingDeflateData.push(v.VSBuffer.wrap(D))})}write(u){this._tracer.traceSocketEvent("zlibDeflateWrite",u.buffer),this._zlibDeflate.write(u.buffer)}flush(u){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let P=v.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,P=P.slice(0,P.byteLength-4),u(P)})}}function f(c,u){if(u===0)return;const P=c.byteLength>>>2;for(let Y=0;Y<P;Y++){const oe=c.readUInt32BE(Y*4);c.writeUInt32BE(oe^u,Y*4)}const D=P*4,T=c.byteLength-D,N=u>>>24&255,U=u>>>16&255,$=u>>>8&255;T>=1&&c.writeUInt8(c.readUInt8(D)^N,D),T>=2&&c.writeUInt8(c.readUInt8(D+1)^U,D+1),T>=3&&c.writeUInt8(c.readUInt8(D+2)^$,D+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const g={[2]:107,[1]:103};function a(){const c=(0,l.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):u=(0,M.join)(b().os.tmpdir(),`vscode-ipc-${c}.sock`),o(u),u}e.createRandomIPCHandle=a;function n(c,u,P){const D=b().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${P}-${u}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-${D.substr(0,8)}-${P}-${u}.sock`):T=(0,M.join)(c,`${P}-${u}.sock`),o(T),T}e.createStaticIPCHandle=n;function o(c){const u=g[E.platform];typeof u=="number"&&c.length>=u&&console.warn(`WARNING: IPC handle "${c}" is longer than ${u} chars, try a shorter --user-data-dir`)}class i extends m.IPCServer{constructor(u){super(i.toClientConnectionEvent(u)),this.server=u}static toClientConnectionEvent(u){const P=k.Event.fromNodeEventEmitter(u,"connection");return k.Event.map(P,D=>({protocol:new I.Protocol(new y(D,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(D,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function r(c){return new Promise((u,P)=>{const D=b().net.createServer();D.on("error",P),D.listen(c,()=>{D.removeListener("error",P),u(new i(D))})})}e.serve=r;function s(c,u){return new Promise((P,D)=>{const T=b().net.createConnection(c,()=>{T.removeListener("error",D),P(I.Client.fromSocket(new y(T,`ipc-client${u}`),u))});T.once("error",D)})}e.connect=s}),define(Z[101],ee([0,1,8,3,2,12]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));function E(b){const y=b;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=E;var l;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(l=e.StorageState||(e.StorageState={}));class m extends k.Disposable{constructor(y,h=Object.create(null)){super(),this.database=y,this.options=h,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){y.changed?.forEach((h,d)=>this.accept(d,h)),y.deleted?.forEach(h=>this.accept(h,void 0))}accept(y,h){if(this.state===l.Closed)return;let d=!1;(0,R.isUndefinedOrNull)(h)?d=this.cache.delete(y):this.cache.get(y)!==h&&(this.cache.set(y,h),d=!0),d&&this._onDidChangeStorage.fire(y)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,h){const d=this.cache.get(y);return(0,R.isUndefinedOrNull)(d)?h:d}getBoolean(y,h){const d=this.get(y);return(0,R.isUndefinedOrNull)(d)?h:d==="true"}getNumber(y,h){const d=this.get(y);return(0,R.isUndefinedOrNull)(d)?h:parseInt(d,10)}async set(y,h){if(this.state===l.Closed)return;if((0,R.isUndefinedOrNull)(h))return this.delete(y);const d=String(h);if(this.cache.get(y)!==d)return this.cache.set(y,d),this.pendingInserts.set(y,d),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.doFlush()}async delete(y){if(!(this.state===l.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(y){if(!!this.hasPending)return this.doFlush(y)}async doFlush(y){return this.flushDelayer.trigger(()=>this.flushPending(),y)}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert?.forEach((h,d)=>this.items.set(d,h)),y.delete?.forEach(h=>this.items.delete(h))}async close(){}}e.InMemoryStorageDatabase=I}),define(Z[147],ee([0,1,8,3,31,9,23]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class E{constructor(I,b=Object.create(null)){this.path=I,this.options=b,this.name=(0,R.basename)(this.path),this.logger=new l(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return t.Event.None}async getItems(){const I=await this.whenConnected,b=new Map;return(await this.all(I,"SELECT * FROM ItemTable")).forEach(h=>b.set(h.key,h.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${b.size} rows`),b}async updateItems(I){const b=await this.whenConnected;return this.doUpdateItems(b,I)}doUpdateItems(I,b){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${b.insert?(0,k.mapToString)(b.insert):"0"}), delete(${b.delete?(0,k.setToString)(b.delete):"0"})`),this.transaction(I,()=>{const y=b.insert,h=b.delete;if(y&&y.size>0){const d=[];d.push([]);let S=0;y.forEach((C,w)=>{let p=d[S];p.length>E.MAX_HOST_PARAMETERS&&(S++,p=[],d.push(p)),p.push(w,C)}),d.forEach(C=>{this.prepare(I,`INSERT INTO ItemTable VALUES ${new Array(C.length/2).fill("(?,?)").join(",")}`,w=>w.run(C),()=>{const w=[];let p=0;return y.forEach((f,g)=>{w.push(g),p+=f.length}),`Keys: ${w.join(", ")} Length: ${p}`})})}if(h&&h.size){const d=[];d.push([]);let S=0;h.forEach(C=>{let w=d[S];w.length>E.MAX_HOST_PARAMETERS&&(S++,w=[],d.push(w)),w.push(C)}),d.forEach(C=>{this.prepare(I,`DELETE FROM ItemTable WHERE key IN (${new Array(C.length).fill("?").join(",")})`,w=>w.run(C),()=>{const w=[];return h.forEach(p=>{w.push(p)}),`Keys: ${w.join(", ")}`})})}})}async close(I){this.logger.trace(`[storage ${this.name}] close()`);const b=await this.whenConnected;return this.doClose(b,I)}doClose(I,b){return new Promise((y,h)=>{I.db.close(d=>(d&&this.handleSQLiteError(I,`[storage ${this.name}] close(): ${d}`),this.path===E.IN_MEMORY_PATH?y():!I.isErroneous&&!I.isInMemory?this.backup().then(y,S=>(this.logger.error(`[storage ${this.name}] backup(): ${S}`),y())):typeof b=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(S=>{const C=()=>this.doClose(S,void 0);return this.doUpdateItems(S,{insert:b()}).then(()=>C(),w=>(C(),Promise.reject(w)))})).then(y,h):h(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const I=this.toBackupPath(this.path);return M.Promises.copy(this.path,I,{preserveSymlinks:!1})}toBackupPath(I){return`${I}.backup`}async checkIntegrity(I){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${I})`);const b=await this.whenConnected,y=await this.get(b,I?"PRAGMA integrity_check":"PRAGMA quick_check"),h=I?y.integrity_check:y.quick_check;return b.isErroneous?`${h} (last error: ${b.lastError})`:b.isInMemory?`${h} (in-memory!)`:h}async connect(I,b=!0){this.logger.trace(`[storage ${this.name}] open(${I}, retryOnBusy: ${b})`);try{return await this.doConnect(I)}catch(y){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&b)return await(0,v.timeout)(E.BUSY_OPEN_TIMEOUT),this.connect(I,!1);try{await M.Promises.unlink(I);try{await M.Promises.rename(this.toBackupPath(I),I)}catch{}return await this.doConnect(I)}catch(h){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${h}`),this.doConnect(E.IN_MEMORY_PATH)}}}handleSQLiteError(I,b){I.isErroneous=!0,I.lastError=b,this.logger.error(b)}doConnect(I){return new Promise((b,y)=>{new Promise((h,d)=>{q(["@vscode/sqlite3"],h,d)}).then(h=>{const d={db:new(this.logger.isTracing?h.verbose().Database:h.Database)(I,S=>S?d.db&&S.code!=="SQLITE_CANTOPEN"?d.db.close(()=>y(S)):y(S):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(d),C=>d.db.close(()=>y(C)))),isInMemory:I===E.IN_MEMORY_PATH};d.db.on("error",S=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${S}`)),this.logger.isTracing&&d.db.on("trace",S=>this.logger.trace(`[storage ${this.name}] Trace (event): ${S}`))},y)})}exec(I,b){return new Promise((y,h)=>{I.db.exec(b,d=>d?(this.handleSQLiteError(I,`[storage ${this.name}] exec(): ${d}`),h(d)):y())})}get(I,b){return new Promise((y,h)=>{I.db.get(b,(d,S)=>d?(this.handleSQLiteError(I,`[storage ${this.name}] get(): ${d}`),h(d)):y(S))})}all(I,b){return new Promise((y,h)=>{I.db.all(b,(d,S)=>d?(this.handleSQLiteError(I,`[storage ${this.name}] all(): ${d}`),h(d)):y(S))})}transaction(I,b){return new Promise((y,h)=>{I.db.serialize(()=>{I.db.run("BEGIN TRANSACTION"),b(),I.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(I,`[storage ${this.name}] transaction(): ${d}`),h(d)):y())})})}prepare(I,b,y,h){const d=I.db.prepare(b),S=C=>{this.handleSQLiteError(I,`[storage ${this.name}] prepare(): ${C} (${b}). Details: ${h()}`)};d.on("error",S),y(d),d.finalize(C=>{C&&S(C),d.removeListener("error",S)})}}e.SQLiteStorageDatabase=E,E.IN_MEMORY_PATH=":memory:",E.BUSY_OPEN_TIMEOUT=2e3,E.MAX_HOST_PARAMETERS=256;class l{constructor(I){I&&typeof I.logTrace=="function"&&process.env[l.VSCODE_TRACE_STORAGE]&&(this.logTrace=I.logTrace),I&&typeof I.logError=="function"&&(this.logError=I.logError)}get isTracing(){return!!this.logTrace}trace(I){this.logTrace?.(I)}error(I){this.logError?.(I)}}l.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[148],ee([11,10]),function(q,e){return q.create("vs/code/electron-main/app",e)}),define(Z[149],ee([11,10]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[150],ee([11,10]),function(q,e){return q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[151],ee([11,10]),function(q,e){return q.create("vs/platform/environment/node/argv",e)}),define(Z[152],ee([11,10]),function(q,e){return q.create("vs/platform/environment/node/argvHelper",e)}),define(Z[153],ee([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[154],ee([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Z[155],ee([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[156],ee([11,10]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[157],ee([11,10]),function(q,e){return q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[158],ee([11,10]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(Z[159],ee([11,10]),function(q,e){return q.create("vs/platform/files/common/files",e)}),define(Z[160],ee([11,10]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(Z[161],ee([11,10]),function(q,e){return q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(Z[162],ee([11,10]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[163],ee([11,10]),function(q,e){return q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[164],ee([11,10]),function(q,e){return q.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[165],ee([11,10]),function(q,e){return q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[166],ee([11,10]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(Z[167],ee([11,10]),function(q,e){return q.create("vs/platform/shell/node/shellEnv",e)}),define(Z[168],ee([11,10]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[169],ee([11,10]),function(q,e){return q.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[170],ee([11,10]),function(q,e){return q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[171],ee([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(Z[172],ee([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[173],ee([11,10]),function(q,e){return q.create("vs/platform/workspace/common/workspace",e)}),define(Z[174],ee([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[175],ee([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[176],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function v(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=v;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(Z[177],ee([0,1,7]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(M){return typeof M?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function k(M){let E=[];try{Array.isArray(M.workspaces)&&(E=M.workspaces.map(l=>({workspace:{id:l.id,configPath:v.URI.parse(l.configURIPath)},remoteAuthority:l.remoteAuthority})))}catch{}return E}e.deserializeWorkspaceInfos=k;function R(M){let E=[];try{Array.isArray(M.folders)&&(E=M.folders.map(l=>({folderUri:v.URI.parse(l.folderUri),remoteAuthority:l.remoteAuthority})))}catch{}return E}e.deserializeFolderInfos=R}),define(Z[178],ee([0,1,3,2]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(E,l,m){switch(l){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(E,l,m){switch(l){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(E){super(),this.channel=E}reload(E){this.channel.call("reload",[E])}get onReload(){return this.channel.listen("reload")}close(E){this.channel.call("close",[E])}get onClose(){return this.channel.listen("close")}attachSession(E,l,m){this.channel.call("attach",[E,l,m])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(E,l){this.channel.call("terminate",[E,l])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(E,l){return this.channel.call("openExtensionDevelopmentHostWindow",[E,l])}}e.ExtensionHostDebugChannelClient=R}),define(Z[179],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class v{constructor(k){this.machineId=k}encryption(){return new Promise((k,R)=>q(["vscode-encrypt"],k,R))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch{return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch{return k}}}e.EncryptionMainService=v}),define(Z[180],ee([0,1,133,53,13,9,33,16,7]),function(q,e,v,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class m{constructor(S,C,w){this._args=S,this.paths=C,this.productService=w,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("",q).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get stateResource(){return(0,E.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,E.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return l.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(l.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=M.env.VSCODE_PORTABLE;return S?l.URI.file((0,R.join)(S,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,R.resolve)(S):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,R.resolve)(S):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,R.resolve)(S);const C=M.env.VSCODE_EXTENSIONS;if(C)return C;const w=M.env.VSCODE_PORTABLE;return w?(0,R.join)(w,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(C=>/^[^:/?#]+?:\/\//.test(C)?l.URI.parse(C):l.URI.file((0,R.normalize)(C)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?l.URI.parse(S):l.URI.file((0,R.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,E.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return l.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return l.URI.file((0,R.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=M.env.VSCODE_PORTABLE;return S?l.URI.file((0,R.join)(S,"policy.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}ve([t.memoize],m.prototype,"appRoot",null),ve([t.memoize],m.prototype,"userHome",null),ve([t.memoize],m.prototype,"userDataPath",null),ve([t.memoize],m.prototype,"appSettingsHome",null),ve([t.memoize],m.prototype,"tmpDir",null),ve([t.memoize],m.prototype,"cacheHome",null),ve([t.memoize],m.prototype,"stateResource",null),ve([t.memoize],m.prototype,"userRoamingDataHome",null),ve([t.memoize],m.prototype,"userDataSyncHome",null),ve([t.memoize],m.prototype,"userDataSyncLogResource",null),ve([t.memoize],m.prototype,"editSessionsLogResource",null),ve([t.memoize],m.prototype,"sync",null),ve([t.memoize],m.prototype,"machineSettingsResource",null),ve([t.memoize],m.prototype,"workspaceStorageHome",null),ve([t.memoize],m.prototype,"localHistoryHome",null),ve([t.memoize],m.prototype,"keyboardLayoutResource",null),ve([t.memoize],m.prototype,"argvResource",null),ve([t.memoize],m.prototype,"isExtensionDevelopment",null),ve([t.memoize],m.prototype,"untitledWorkspacesHome",null),ve([t.memoize],m.prototype,"installSourcePath",null),ve([t.memoize],m.prototype,"builtinExtensionsPath",null),ve([t.memoize],m.prototype,"extensionsPath",null),ve([t.memoize],m.prototype,"extensionDevelopmentLocationURI",null),ve([t.memoize],m.prototype,"extensionDevelopmentKind",null),ve([t.memoize],m.prototype,"extensionTestsLocationURI",null),ve([t.memoize],m.prototype,"debugExtensionHost",null),ve([t.memoize],m.prototype,"serviceMachineIdResource",null),ve([t.memoize],m.prototype,"telemetryLogResource",null),ve([t.memoize],m.prototype,"disableWorkspaceTrust",null),ve([t.memoize],m.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=m;function I(d,S){return h(d["inspect-extensions"],d["inspect-brk-extensions"],5870,S,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=I;function b(d,S){return h(d["inspect-search"],d["inspect-brk-search"],5876,S,d.extensionEnvironment)}e.parseSearchPort=b;function y(d,S){return h(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,S,d.extensionEnvironment)}e.parsePtyHostPort=y;function h(d,S,C,w,p,f){const a=Number(S||d)||(w?null:C),n=a?Boolean(!!S):!1;let o;if(f)try{o=JSON.parse(f)}catch{}return{port:a,break:n,debugId:p,env:o}}}),define(Z[102],ee([0,1,274,4,151]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},category:{type:"string",cat:"e",description:(0,k.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(d,S,C=M){const w={},p=["_"],f=[];for(const o in S){const i=S[o];i.alias&&(w[o]=i.alias),i.type==="string"||i.type==="string[]"?(p.push(o),i.deprecates&&p.push(...i.deprecates)):i.type==="boolean"&&(f.push(o),i.deprecates&&f.push(...i.deprecates))}const g=v(d,{string:p,boolean:f,alias:w}),a={},n=g;a._=g._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(const o in S){const i=S[o];i.alias&&delete n[i.alias];let r=n[o];if(i.deprecates)for(const s of i.deprecates)n.hasOwnProperty(s)&&(r||(r=n[s],r&&C.onDeprecatedOption(s,i.deprecationMessage||(0,k.localize)(35,null,o))),delete n[s]);if(typeof r<"u"){if(i.type==="string[]"){if(Array.isArray(r)||(r=[r]),!i.allowEmptyValue){const s=r.filter(c=>c.length>0);s.length!==r.length&&(C.onEmptyValue(o),r=s.length>0?s:void 0)}}else i.type==="string"&&(Array.isArray(r)?(r=r.pop(),C.onMultipleValues(o,r)):!r&&!i.allowEmptyValue&&(C.onEmptyValue(o),r=void 0));a[o]=r,i.deprecationMessage&&C.onDeprecatedOption(o,i.deprecationMessage)}delete n[o]}for(const o in n)C.onUnknownOption(o);return a}e.parseArgs=E;function l(d,S){let C="";return S.args&&(Array.isArray(S.args)?C=` <${S.args.join("> <")}>`:C=` <${S.args}>`),S.alias?`-${S.alias} --${d}${C}`:`--${d}${C}`}function m(d,S){let C=0;const w=[];for(const a in d){const n=d[a],o=l(a,n);C=Math.max(C,o.length),w.push([o,n.description])}const p=C+2+1;if(S-p<25)return w.reduce((a,n)=>a.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const f=S-p-1,g=[];for(const a of w){const n=a[0],o=b(a[1],f),i=I(p-n.length-2);g.push("  "+n+i+o[0]);for(let r=1;r<o.length;r++)g.push(I(p)+o[r])}return g}e.formatOptions=m;function I(d){return" ".repeat(d)}function b(d,S){const C=[];for(;d.length;){const w=d.length<S?d.length:d.lastIndexOf(" ",S),p=d.slice(0,w).trim();d=d.slice(w),C.push(p)}return C}function y(d,S,C,w,p){const f=process.stdout.isTTY&&process.stdout.columns||80,g=p?.noInputFiles!==!0?`[${(0,k.localize)(36,null)}...]`:"",a=[`${d} ${C}`];a.push(""),a.push(`${(0,k.localize)(37,null)}: ${S} [${(0,k.localize)(38,null)}]${g}`),a.push(""),p?.noPipe!==!0&&(t.isWindows?a.push((0,k.localize)(39,null,S)):a.push((0,k.localize)(40,null,S)),a.push(""));const n={};for(const o in w){const i=w[o];if(i.description&&i.cat){let r=n[i.cat];r||(n[i.cat]=r={}),r[o]=i}}for(const o in n){const i=o,r=n[i];r&&(a.push(R[i]),a.push(...m(r,f)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=y;function h(d,S){return`${d||(0,k.localize)(41,null)}
${S||(0,k.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=h}),define(Z[181],ee([0,1,77,178,102]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(E,l){super(),this.windowsMainService=E,this.userDataProfilesMainService=l}call(E,l,m){return l==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(m[0],m[1]):super.call(E,l,m)}async openExtensionDevelopmentHostWindow(E,l){const m=(0,k.parseArgs)(E,k.OPTIONS);m.debugRenderer=l;const I=m.extensionDevelopmentPath;if(!I)return{success:!1};const[b]=await this.windowsMainService.openExtensionDevelopmentHostWindow(I,{context:5,cli:m,profile:await this.userDataProfilesMainService.checkAndCreateProfileFromCli(m)});if(!l)return{success:!0};const y=b.win;if(!y)return{success:!0};const h=y.webContents.debugger;let d=h.isAttached()?1/0:0;const S=(0,v.createServer)(C=>{d++===0&&h.attach();let w=!1;const p=a=>{w||C.write(JSON.stringify(a)+"\0")},f=(a,n,o,i)=>p({method:n,params:o,sessionId:i});y.on("close",()=>{h.removeListener("message",f),C.end(),w=!0}),h.addListener("message",f);let g=Buffer.alloc(0);C.on("data",a=>{g=Buffer.concat([g,a]);for(let n=g.indexOf(0);n!==-1;n=g.indexOf(0)){let o;try{const i=g.slice(0,n).toString("utf8");g=g.slice(n+1),o=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}h.sendCommand(o.method,o.params,o.sessionId).then(i=>p({id:o.id,sessionId:o.sessionId,result:i})).catch(i=>p({id:o.id,sessionId:o.sessionId,error:{code:0,message:i.message}}))}}),C.on("error",a=>{console.error("error on cdp pipe:",a)}),C.on("close",()=>{w=!0,--d===0&&h.detach()})});return await new Promise(C=>S.listen(0,C)),y.on("close",()=>S.close()),{rendererDebugPort:S.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(Z[59],ee([0,1,275,152,102]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function M(y,h){const d={onUnknownOption:C=>{console.warn((0,t.localize)(0,null,C))},onMultipleValues:(C,w)=>{console.warn((0,t.localize)(1,null,C,w))},onEmptyValue:C=>{console.warn((0,t.localize)(2,null,C))},onDeprecatedOption:(C,w)=>{console.warn((0,t.localize)(3,null,C,w))}},S=(0,k.parseArgs)(y,k.OPTIONS,h?d:void 0);return S.goto&&S._.forEach(C=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(C),(0,t.localize)(4,null))),S["max-memory"]&&v(parseInt(S["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),S}function E(y){const h=y.findIndex(d=>!/^-/.test(d));if(h>-1)return[...y.slice(0,h),...y.slice(h+1)]}function l(y){let[,...h]=y;process.env.VSCODE_DEV&&(h=E(h)||[]);const d=!b(process.env);return M(h,d)}e.parseMainProcessArgv=l;function m(y){const[,,...h]=y;return M(h,!0)}e.parseCLIProcessArgv=m;function I(y,...h){const d=y.indexOf("--");return d===-1?y.push(...h):y.splice(d,0,...h),y}e.addArg=I;function b(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),function(){"use strict";function q(e,v,t,k){function R(E){const l=M(E),m=[l];return e.isAbsolute(l)||m.unshift(k),e.resolve(...m)}function M(E){const l=process.env.VSCODE_PORTABLE;if(l)return e.join(l,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,t);const I=E["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(b,"AppData","Roaming")}break;case"darwin":m=e.join(v.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,t)}return{getUserDataPath:R}}if(typeof define=="function")define(Z[182],ee([0,183,28,13,16,33]),function(e,v,t,k,R,M){const E=R.dirname(k.FileAccess.asFileUri("",e)),l=e.__$__nodeRequire(R.joinPath(E,"package.json").fsPath);return q(v,t,l.name,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),t=require("os");module.exports=q(v,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[184],ee([0,1,28,180,182]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(E,l){super(E,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,k.getUserDataPath)(E)},l)}}e.NativeEnvironmentService=R}),define(Z[185],ee([0,1,40,28,30]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(M){const E=(0,k.randomPath)((0,t.tmpdir)());try{return(0,v.writeFileSync)(E,""),M&&console.log(`Marker file for --wait created: ${E}`),E}catch(l){M&&console.error(`Failed to create marker file for --wait: ${l}`);return}}e.createWaitMarkerFileSync=R}),define(Z[186],ee([0,1,12,154]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(M,E,l){try{R(M,E,l)}catch{}return M}e.localizeManifest=k;function R(M,E,l){const m=(I,b,y)=>{const h=I[b];if((0,v.isString)(h)){const d=h,S=d.length;if(S>1&&d[0]==="%"&&d[S-1]==="%"){const C=d.substr(1,S-2);let w=E[C];w===void 0&&l&&(w=l[C]);const p=typeof w=="string"?w:w.message;if(p!==void 0){const f=l?.[C],g=typeof f=="string"?f:f?.message;if(y&&(b==="title"||b==="category")&&g&&g!==p){const a={value:p,original:g};I[b]=a}else I[b]=p}else console.warn(`[${M.name}]: ${(0,t.localize)(0,null,C)}`)}}else if((0,v.isObject)(h))for(const d in h)h.hasOwnProperty(d)&&(d==="commands"?m(h,d,!0):m(h,d,y));else if(Array.isArray(h))for(let d=0;d<h.length;d++)m(h,d,y)};for(const I in M)M.hasOwnProperty(I)&&m(M,I)}}),define(Z[187],ee([0,1,16,95,156,188]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function l(w){return w=w.trim(),w==="*"||M.test(w)}e.isValidVersionStr=l;function m(w){if(!l(w))return null;if(w=w.trim(),w==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=w.match(M);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=m;function I(w){if(!w)return null;const p=w.majorBase,f=w.majorMustEqual,g=w.minorBase;let a=w.minorMustEqual;const n=w.patchBase;let o=w.patchMustEqual;w.hasCaret&&(p===0||(a=!1),o=!1);let i=0;if(w.preRelease){const r=E.exec(w.preRelease);if(r){const[,s,c,u]=r;i=Date.UTC(Number(s),Number(c)-1,Number(u))}}return{majorBase:p,majorMustEqual:f,minorBase:g,minorMustEqual:a,patchBase:n,patchMustEqual:o,isMinimum:w.hasGreaterEquals,notBefore:i}}e.normalizeVersion=I;function b(w,p,f){let g;typeof w=="string"?g=I(m(w)):g=w;let a;p instanceof Date?a=p.getTime():typeof p=="string"&&(a=new Date(p).getTime());let n;if(typeof f=="string"?n=I(m(f)):n=f,!g||!n)return!1;const o=g.majorBase,i=g.minorBase,r=g.patchBase;let s=n.majorBase,c=n.minorBase,u=n.patchBase;const P=n.notBefore;let D=n.majorMustEqual,T=n.minorMustEqual,N=n.patchMustEqual;return n.isMinimum?o>s?!0:o<s?!1:i>c?!0:i<c||a&&a<P?!1:r>=u:(o===1&&s===0&&(!D||!T||!N)&&(s=1,c=0,u=0,D=!0,T=!1,N=!1),o<s?!1:o>s?!D:i<c?!1:i>c?!T:r<u?!1:r>u?!N:!(a&&a<P))}e.isValidVersion=b;function y(w,p,f,g,a){const n=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return n.push([t.default.Error,k.localize(0,null)]),n;if(typeof g.name!="string")return n.push([t.default.Error,k.localize(1,null,"name")]),n;if(typeof g.version!="string")return n.push([t.default.Error,k.localize(2,null,"version")]),n;if(!g.engines)return n.push([t.default.Error,k.localize(3,null,"engines")]),n;if(typeof g.engines.vscode!="string")return n.push([t.default.Error,k.localize(4,null,"engines.vscode")]),n;if(typeof g.extensionDependencies<"u"&&!C(g.extensionDependencies))return n.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),n;if(typeof g.activationEvents<"u"){if(!C(g.activationEvents))return n.push([t.default.Error,k.localize(6,null,"activationEvents")]),n;if(typeof g.main>"u"&&typeof g.browser>"u")return n.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),n}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&n.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return n.push([t.default.Error,k.localize(9,null,"main")]),n;{const r=(0,v.joinPath)(f,g.main);(0,v.isEqualOrParent)(r,f)||n.push([t.default.Warning,k.localize(10,null,r.path,f.path)])}if(typeof g.activationEvents>"u")return n.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),n}if(typeof g.browser<"u"){if(typeof g.browser!="string")return n.push([t.default.Error,k.localize(12,null,"browser")]),n;{const r=(0,v.joinPath)(f,g.browser);(0,v.isEqualOrParent)(r,f)||n.push([t.default.Warning,k.localize(13,null,r.path,f.path)])}if(typeof g.activationEvents>"u")return n.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),n}if(!R.valid(g.version))return n.push([t.default.Error,k.localize(15,null)]),n;const o=[];if(!h(w,p,g,a,o))for(const r of o)n.push([t.default.Error,r]);return n}e.validateExtensionManifest=y;function h(w,p,f,g,a){return g||typeof f.main>"u"&&typeof f.browser>"u"?!0:S(w,p,f.engines.vscode,a)}e.isValidExtensionVersion=h;function d(w,p,f){return w==="*"||S(p,f,w)}e.isEngineValid=d;function S(w,p,f,g=[]){const a=I(m(f));if(!a)return g.push(k.localize(16,null,f)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return g.push(k.localize(17,null,f)),!1}else if(!a.majorMustEqual)return g.push(k.localize(18,null,f)),!1;return b(w,p,a)?!0:(g.push(k.localize(19,null,w,f)),!1)}function C(w){if(!Array.isArray(w))return!1;for(let p=0,f=w.length;p<f;p++)if(typeof w[p]!="string")return!1;return!0}}),define(Z[189],ee([0,1,18,29]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,M,E){let l=E&&E.get("storage.serviceMachineId",-1)||null;if(l)return l;try{const I=(await M.readFile(R.serviceMachineIdResource)).value.toString();l=(0,t.isUUID)(I)?I:null}catch{l=null}if(!l){l=(0,t.generateUuid)();try{await M.writeFile(R.serviceMachineIdResource,v.VSBuffer.fromString(l))}catch{}}return E?.store("storage.serviceMachineId",l,-1,1),l}e.getServiceMachineId=k}),define(Z[68],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(k,R=[],M=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=v}),define(Z[190],ee([0,1,68]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function R(E,l,m){l instanceof v.SyncDescriptor||(l=new v.SyncDescriptor(l,[],Boolean(m))),t.push([E,l])}e.registerSingleton=R;function M(){return t}e.getSingletonServiceDescriptors=M}),define(Z[191],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(R,M){this.key=R,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.Node=v;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const M of this._nodes.values())M.outgoing.size===0&&R.push(M);return R}insertEdge(R,M){const E=this.lookupOrInsertNode(R),l=this.lookupOrInsertNode(M);E.outgoing.set(l.key,l),l.incoming.set(E.key,E)}removeNode(R){const M=this._hashFn(R);this._nodes.delete(M);for(const E of this._nodes.values())E.outgoing.delete(M),E.incoming.delete(M)}lookupOrInsertNode(R){const M=this._hashFn(R);let E=this._nodes.get(M);return E||(E=new v(M,R),this._nodes.set(M,E)),E}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[M,E]of this._nodes)R.push(`${M}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,M]of this._nodes){const E=new Set([R]),l=this._findCycle(M,E);if(l)return l}}_findCycle(R,M){for(const[E,l]of R.outgoing){if(M.has(E))return[...M,E].join(" -> ");M.add(E);const m=this._findCycle(l,M);if(m)return m;M.delete(E)}}}e.Graph=t}),define(Z[5],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function E(l){return l[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=E})(v=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(M,E,l){E[v.DI_TARGET]===E?E[v.DI_DEPENDENCIES].push({id:M,index:l}):(E[v.DI_DEPENDENCIES]=[{id:M,index:l}],E[v.DI_TARGET]=E)}function k(M){if(v.serviceIds.has(M))return v.serviceIds.get(M);const E=function(l,m,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(E,l,I)};return E.toString=()=>M,v.serviceIds.set(M,E),E}e.createDecorator=k;function R(M){return M}e.refineServiceDecorator=R}),define(Z[60],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService")}),define(Z[19],ee([0,1,12,7,5]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(w){return w&&typeof w=="object"&&(!w.overrideIdentifier||typeof w.overrideIdentifier=="string")&&(!w.resource||w.resource instanceof t.URI)}e.isConfigurationOverrides=R;function M(w){return w&&typeof w=="object"&&(!w.overrideIdentifiers||Array.isArray(w.overrideIdentifiers))&&!w.overrideIdentifier&&(!w.resource||w.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=M;var E;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.USER=2]="USER",w[w.USER_LOCAL=3]="USER_LOCAL",w[w.USER_REMOTE=4]="USER_REMOTE",w[w.WORKSPACE=5]="WORKSPACE",w[w.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",w[w.DEFAULT=7]="DEFAULT",w[w.MEMORY=8]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function l(w){switch(w){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=l;function m(w,p){const f=Object.create(null);for(const g in w)I(f,g,w[g],p);return f}e.toValuesTree=m;function I(w,p,f,g){const a=p.split("."),n=a.pop();let o=w;for(let i=0;i<a.length;i++){const r=a[i];let s=o[r];switch(typeof s){case"undefined":s=o[r]=Object.create(null);break;case"object":break;default:g(`Ignoring ${p} as ${a.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[n]=f}catch{g(`Ignoring ${p} as ${a.join(".")} is ${JSON.stringify(o)}`)}else g(`Ignoring ${p} as ${a.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=I;function b(w,p){const f=p.split(".");y(w,f)}e.removeFromValueTree=b;function y(w,p){const f=p.shift();if(p.length===0){delete w[f];return}if(Object.keys(w).indexOf(f)!==-1){const g=w[f];typeof g=="object"&&!Array.isArray(g)&&(y(g,p),Object.keys(g).length===0&&delete w[f])}}function h(w,p,f){function g(o,i){let r=o;for(const s of i){if(typeof r!="object"||r===null)return;r=r[s]}return r}const a=p.split("."),n=g(w,a);return typeof n>"u"?f:n}e.getConfigurationValue=h;function d(w,p,f){Object.keys(p).forEach(g=>{g!=="__proto__"&&(g in w?v.isObject(w[g])&&v.isObject(p[g])?d(w[g],p[g],f):f&&(w[g]=p[g]):w[g]=p[g])})}e.merge=d;function S(w,p,f){const g=w.inspect(p),a=w.inspect(f);return typeof g.userValue<"u"||typeof g.workspaceValue<"u"||typeof g.workspaceFolderValue<"u"?g.value:typeof a.userValue<"u"||typeof a.workspaceValue<"u"||typeof a.workspaceFolderValue<"u"?a.value:g.defaultValue}e.getMigratedSettingValue=S;function C(w){return w.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=C}),define(Z[69],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,v.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,v.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,M){return this.secretVault[R]?.[M]??null}async setPassword(R,M,E){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][M]=E}async deletePassword(R,M){return this.secretVault[R]?.[M]?(delete this.secretVault[R][M],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const M=[];for(const E of Object.keys(this.secretVault[R]||{}))M.push({account:E,password:this.secretVault[R][E]});return M}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(Z[84],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(M,E){return{}}async getSystemInfo(M,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,E){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=k}),define(Z[103],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService")}),define(Z[35],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[26],ee([0,1,53,9,83,35,184,5]),function(q,e,v,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,E.refineServiceDecorator)(R.IEnvironmentService);class l extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([v.memoize],l.prototype,"cachedLanguagesPath",null),ve([v.memoize],l.prototype,"backupHome",null),ve([v.memoize],l.prototype,"mainIPCHandle",null),ve([v.memoize],l.prototype,"mainLockfile",null),ve([v.memoize],l.prototype,"disableUpdates",null),ve([v.memoize],l.prototype,"disableKeytar",null),ve([v.memoize],l.prototype,"crossOriginIsolated",null),ve([v.memoize],l.prototype,"codeCachePath",null),ve([v.memoize],l.prototype,"useCodeCache",null),e.EnvironmentMainService=l}),define(Z[192],ee([0,1,153,5]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(w){switch(w){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(w){switch(w){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function M(w,p){switch(w){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function E(w,p){return p==="web"&&!w.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function l(w,p,f){return E(p,f)?!1:w==="undefined"||w==="universal"?!0:w==="unknown"?!1:w===f?!0:m(f).includes(w)}e.isTargetPlatformCompatible=l;function m(w){switch(w){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function I(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=I;var b;(function(w){w[w.NoneOrRelevance=0]="NoneOrRelevance",w[w.LastUpdatedDate=1]="LastUpdatedDate",w[w.Title=2]="Title",w[w.PublisherName=3]="PublisherName",w[w.InstallCount=4]="InstallCount",w[w.PublishedDate=10]="PublishedDate",w[w.AverageRating=6]="AverageRating",w[w.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var y;(function(w){w[w.Default=0]="Default",w[w.Ascending=1]="Ascending",w[w.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var h;(function(w){w.Install="install",w.Uninstall="uninstall"})(h=e.StatisticType||(e.StatisticType={}));var d;(function(w){w[w.None=1]="None",w[w.Install=2]="Install",w[w.Update=3]="Update",w[w.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var S;(function(w){w.Unsupported="Unsupported",w.Deprecated="Deprecated",w.Malicious="Malicious",w.Incompatible="Incompatible",w.IncompatiblePreRelease="IncompatiblePreRelease",w.IncompatibleTargetPlatform="IncompatibleTargetPlatform",w.ReleaseVersionNotFound="ReleaseVersionNotFound",w.Invalid="Invalid",w.Download="Download",w.Extract="Extract",w.Delete="Delete",w.Rename="Rename",w.CorruptZip="CorruptZip",w.IncompleteZip="IncompleteZip",w.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class C extends Error{constructor(p,f){super(p),this.code=f,this.name=f}}e.ExtensionManagementError=C,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Z[193],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(Z[194],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,v.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[104],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(Z[195],ee([0,1,45,13,9,4,78,23,82,157,104]),function(q,e,v,t,k,R,M,E,l,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=m.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await S.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends y{openTerminal(g,a){return this.spawnTerminal(v,g,l.getWindowsShell(),a)}spawnTerminal(g,a,n,o){const i=a.windowsExec||h.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const r=k.basename(i).toLowerCase();if(r==="cmder"||r==="cmder.exe")return g.spawn(i,o?[o]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return i.indexOf(" ")>=0&&s.push('""'),s.push(i),(r==="wt"||r==="wt.exe")&&s.push("-d ."),new Promise((c,u)=>{const P=C(process),D=g.spawn(n,s,{cwd:o,env:P});D.on("error",u),D.on("exit",()=>c())})}runInTerminal(g,a,n,o,i){const r="windowsExec"in i&&i.windowsExec?i.windowsExec:h.getDefaultTerminalWindows();return new Promise((s,c)=>{const u=`"${a} - ${b}"`,P=`""${n.join('" "')}" & pause"`,D=["/c","start",u,"/wait",r,"/c",P],T=Object.assign({},C(process),o);Object.keys(T).filter($=>T[$]===null).forEach($=>delete T[$]);const N={cwd:a,env:T,windowsVerbatimArguments:!0};v.spawn(h.CMD,D,N).on("error",$=>{c(w($))}),s(void 0)})}static getDefaultTerminalWindows(){if(!h._DEFAULT_TERMINAL_WINDOWS){const g=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${g?"Sysnative":"System32"}\\cmd.exe`}return h._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=h,h.CMD="cmd.exe";class d extends y{openTerminal(g,a){return this.spawnTerminal(v,g,a)}runInTerminal(g,a,n,o,i){const r=i.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((s,c)=>{if(r===I.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const u=r===I.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${u}.scpt`,q).fsPath,"-t",g||b,"-w",a];for(const U of n)D.push("-a"),D.push(U);if(o){const U=Object.assign({},C(process),o);for(const $ in U){const Y=U[$];Y===null?(D.push("-u"),D.push($)):(D.push("-e"),D.push(`${$}=${Y}`))}}let T="";const N=v.spawn(d.OSASCRIPT,D);N.on("error",U=>{c(w(U))}),N.stderr.on("data",U=>{T+=U.toString()}),N.on("exit",U=>{if(U===0)s(void 0);else if(T){const $=T.split(`
`,1);c(new Error($[0]))}else c(new Error(m.localize(1,null,u,U)))})}else c(new Error(m.localize(2,null,r)))})}spawnTerminal(g,a,n){const o=a.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((i,r)=>{const s=["-a",o];n&&s.push(n);const c=C(process),u=g.spawn("/usr/bin/open",s,{cwd:n,env:c});u.on("error",r),u.on("exit",()=>i())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class S extends y{openTerminal(g,a){return this.spawnTerminal(v,g,a)}runInTerminal(g,a,n,o,i){const r=i.linuxExec?Promise.resolve(i.linuxExec):S.getDefaultTerminalLinuxReady();return new Promise((s,c)=>{const u=[];r.then(P=>{P.indexOf("gnome-terminal")>=0?u.push("-x"):u.push("-e"),u.push("bash"),u.push("-c");const D=`${p(n)}; echo; read -p "${S.WAIT_MESSAGE}" -n1;`;u.push(`''${D}''`);const T=Object.assign({},C(process),o);Object.keys(T).filter(Y=>T[Y]===null).forEach(Y=>delete T[Y]);const N={cwd:a,env:T};let U="";const $=v.spawn(P,u,N);$.on("error",Y=>{c(w(Y))}),$.stderr.on("data",Y=>{U+=Y.toString()}),$.on("exit",Y=>{if(Y===0)s(void 0);else if(U){const oe=U.split(`
`,1);c(new Error(oe[0]))}else c(new Error(m.localize(4,null,P,Y)))})})})}static async getDefaultTerminalLinuxReady(){if(!S._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)S._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const g=await E.Promises.exists("/etc/debian_version");S._DEFAULT_TERMINAL_LINUX_READY=new Promise(a=>{g?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return S._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(g,a,n){const o=a.linuxExec?Promise.resolve(a.linuxExec):S.getDefaultTerminalLinuxReady();return new Promise((i,r)=>{o.then(s=>{const c=C(process),u=g.spawn(s,[],{cwd:n,env:c});u.on("error",r),u.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=S,S.WAIT_MESSAGE=m.localize(3,null);function C(f){const g={...f.env};return(0,M.sanitizeProcessEnvironment)(g),g}function w(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(m.localize(5,null,f.path)):f}function p(f){let g="";for(const a of f)a.indexOf(" ")>=0?g+='"'+a+'"':g+=a,g+=" ";return g}}),define(Z[14],ee([0,1,31,9,25,12,7,159,5]),function(q,e,v,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,l.createDecorator)("fileService");function m(G){return G.create===!0}e.isFileOpenForWriteOptions=m;var I;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var b;(function(G){G[G.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var y;(function(G){G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(G){return!!(G.capabilities&2)}e.hasReadWriteCapability=h;function d(G){return!!(G.capabilities&8)}e.hasFileFolderCopyCapability=d;function S(G){return!!(G.capabilities&32768)}e.hasFileCloneCapability=S;function C(G){return!!(G.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function w(G){return!!(G.capabilities&16)}e.hasFileReadStreamCapability=w;function p(G){return h(G)?!!(G.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var f;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(f=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(K,F){super(K),this.code=F}}e.FileSystemProviderError=g;function a(G,K){const F=new g(G.toString(),K);return o(F,K),F}e.createFileSystemProviderError=a;function n(G){return G||a((0,E.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=n;function o(G,K){return G.name=K?`${K} (FileSystemError)`:"FileSystemError",G}e.markAsFileSystemProviderError=o;function i(G){if(!G)return f.Unknown;if(G instanceof g)return G.code;const K=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!K)return f.Unknown;switch(K[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=i;function r(G){if(G instanceof T)return G.fileOperationResult;switch(i(G)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.FileWriteLocked:return 5;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class c{constructor(K,F,A){this.resource=K,this.operation=F,this.target=A}isOperation(K){return this.operation===K}}e.FileOperationEvent=c;var u;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class P{constructor(K,F){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=K;const A=new Map;for(const W of K){const z=A.get(W.type);switch(z?z.push([W.resource,W]):A.set(W.type,[[W.resource,W]]),W.type){case 1:this.rawAdded.push(W.resource);break;case 0:this.rawUpdated.push(W.resource);break;case 2:this.rawDeleted.push(W.resource);break}}for(const[W,z]of A)switch(W){case 1:this.added=v.TernarySearchTree.forUris(()=>F),this.added.fill(z);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>F),this.updated.fill(z);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>F),this.deleted.fill(z);break}}contains(K,...F){return this.doContains(K,{includeChildren:!1},...F)}affects(K,...F){return this.doContains(K,{includeChildren:!0},...F)}doContains(K,F,...A){if(!K)return!1;const W=A.length>0;return!!((!W||A.includes(1))&&(this.added?.get(K)||F.includeChildren&&this.added?.findSuperstr(K))||(!W||A.includes(0))&&(this.updated?.get(K)||F.includeChildren&&this.updated?.findSuperstr(K))||(!W||A.includes(2))&&(this.deleted?.findSubstr(K)||F.includeChildren&&this.deleted?.findSuperstr(K)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=P;function D(G,K,F){return!G||!K||G===K||K.length>G.length?!1:(K.charAt(K.length-1)!==t.sep&&(K+=t.sep),F?(0,k.startsWithIgnoreCase)(G,K):G.indexOf(K)===0)}e.isParent=D;class T extends Error{constructor(K,F,A){super(K),this.fileOperationResult=F,this.options=A}}e.FileOperationError=T;class N extends T{constructor(K,F,A){super(K,2,A),this.stat=F}}e.NotModifiedSinceFileOperationError=N;var U;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",G[G.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(U=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var $;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})($=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function Y(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}e.etag=Y;async function oe(G,K){if(!K.hasProvider(M.URI.from({scheme:G.scheme})))return new Promise(F=>{const A=K.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===G.scheme&&W.added&&(A.dispose(),F())})})}e.whenProviderRegistered=oe,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ue{static formatSize(K){return(0,R.isNumber)(K)||(K=0),K<ue.KB?(0,E.localize)(1,null,K.toFixed(0)):K<ue.MB?(0,E.localize)(2,null,(K/ue.KB).toFixed(2)):K<ue.GB?(0,E.localize)(3,null,(K/ue.MB).toFixed(2)):K<ue.TB?(0,E.localize)(4,null,(K/ue.GB).toFixed(2)):(0,E.localize)(5,null,(K/ue.TB).toFixed(2))}}e.ByteSize=ue,ue.KB=1024,ue.MB=ue.KB*ue.KB,ue.GB=ue.MB*ue.KB,ue.TB=ue.GB*ue.KB;var se;(function(G){G[G.IA32=0]="IA32",G[G.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function de(G){return{maxFileSize:G===0?300*ue.MB:16*ue.GB,maxHeapSize:G===0?700*ue.MB:2*700*ue.MB}}e.getPlatformLimits=de}),define(Z[196],ee([0,1,18,44,17,3,2,58,7,29,14]),function(q,e,v,t,k,R,M,E,l,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends M.Disposable{constructor(h,d){super(),this.channel=h,this.extraCapabilities=d,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,m.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(h){return this.channel.call("stat",[h])}readdir(h){return this.channel.call("readdir",[h])}async readFile(h,d){const{buffer:S}=await this.channel.call("readFile",[h,d]);return S}readFileStream(h,d,S){const C=(0,E.newWriteableStream)(p=>v.VSBuffer.concat(p.map(f=>v.VSBuffer.wrap(f))).buffer),w=this.channel.listen("readFileStream",[h,d])(p=>{if(p instanceof v.VSBuffer)C.write(p.buffer);else{if(p==="end")C.end();else{let f=p;f instanceof Error||(f=(0,I.createFileSystemProviderError)((0,t.toErrorMessage)(f),I.FileSystemProviderErrorCode.Unknown)),C.error(f),C.end()}w.dispose()}});return S.onCancellationRequested(()=>{C.error((0,k.canceled)()),C.end(),w.dispose()}),C}writeFile(h,d,S){return this.channel.call("writeFile",[h,v.VSBuffer.wrap(d),S])}open(h,d){return this.channel.call("open",[h,d])}close(h){return this.channel.call("close",[h])}async read(h,d,S,C,w){const[p,f]=await this.channel.call("read",[h,d,w]);return S.set(p.buffer.slice(0,f),C),f}write(h,d,S,C,w){return this.channel.call("write",[h,d,v.VSBuffer.wrap(S),C,w])}mkdir(h){return this.channel.call("mkdir",[h])}delete(h,d){return this.channel.call("delete",[h,d])}rename(h,d,S){return this.channel.call("rename",[h,d,S])}copy(h,d,S){return this.channel.call("copy",[h,d,S])}cloneFile(h,d){return this.channel.call("cloneFile",[h,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(h=>{if(Array.isArray(h)){const d=h;this._onDidChange.fire(d.map(S=>({resource:l.URI.revive(S.resource),type:S.type})))}else{const d=h;this._onDidWatchError.fire(d)}}))}watch(h,d){const S=(0,m.generateUuid)();return this.channel.call("watch",[this.sessionId,S,h,d]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,S]))}}e.DiskFileSystemProviderClient=b}),define(Z[105],ee([0,1,18,17,160,14]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(I,b,y,h,d,S){let C;try{await E(I,b,y,h,d,S)}catch(w){C=w}finally{C&&d.errorTransformer&&(C=d.errorTransformer(C)),typeof C<"u"&&y.error(C),y.end()}}e.readFileIntoStream=M;async function E(I,b,y,h,d,S){l(S);const C=await I.open(b,{create:!1});try{l(S);let w=0,p=0,f=d&&typeof d.length=="number"?d.length:void 0,g=v.VSBuffer.alloc(Math.min(d.bufferSize,typeof f=="number"?f:d.bufferSize)),a=d&&typeof d.position=="number"?d.position:0,n=0;do p=await I.read(C,a,g.buffer,n,g.byteLength-n),a+=p,n+=p,w+=p,typeof f=="number"&&(f-=p),n===g.byteLength&&(await y.write(h(g)),g=v.VSBuffer.alloc(Math.min(d.bufferSize,typeof f=="number"?f:d.bufferSize)),n=0);while(p>0&&(typeof f!="number"||f>0)&&l(S)&&m(w,d));if(n>0){let o=n;typeof f=="number"&&(o=Math.min(n,f)),y.write(h(g.slice(0,o)))}}catch(w){throw(0,R.ensureFileSystemProviderError)(w)}finally{await I.close(C)}}function l(I){if(I.isCancellationRequested)throw(0,t.canceled)();return!0}function m(I,b){if(b?.limits){if(typeof b.limits.memory=="number"&&I>b.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&I>b.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[70],ee([0,1,96,2,9,4,7,14]),function(q,e,v,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function l(w){return w.recursive===!0}e.isRecursiveWatchRequest=l;class m extends t.Disposable{constructor(p,f,g,a){super(),this.onFileChanges=p,this.onLogMessage=f,this.verboseLogging=g,this.options=a,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const p=new t.DisposableStore;this.watcherDisposables.value=p,this.watcher=this.createWatcher(p),this.watcher.setVerboseLogging(this.verboseLogging),p.add(this.watcher.onDidChangeFile(f=>this.onFileChanges(f))),p.add(this.watcher.onDidLogMessage(f=>this.onLogMessage(f))),p.add(this.watcher.onDidError(f=>this.onError(f)))}onError(p){this.options.restartOnError?this.restartCounter<m.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${p}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${p}`):this.error(p)}restart(p){this.restartCounter++,this.init(),this.watch(p)}async watch(p){this.requests=p,await this.watcher?.watch(p)}async setVerboseLogging(p){this.verboseLogging=p,await this.watcher?.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${p}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.MAX_RESTARTS=5;class I extends m{constructor(p,f,g){super(p,f,g,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class b extends m{constructor(p,f,g){super(p,f,g,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function y(w){return w.map(p=>({type:p.type,resource:M.URI.file(p.path)}))}e.toFileChanges=y;function h(w){const p=new C;for(const f of w)p.processEvent(f);return p.coalesce()}e.coalesceEvents=h;function d(w,p){return typeof p=="string"&&!p.startsWith(v.GLOBSTAR)&&!(0,k.isAbsolute)(p)?{base:w,pattern:p}:p}e.normalizeWatcherPattern=d;function S(w,p){const f=[];for(const g of p)f.push((0,v.parse)(d(w,g)));return f}e.parseWatcherPatterns=S;class C{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(p){return R.isLinux?p.path:p.path.toLowerCase()}processEvent(p){const f=this.mapPathToChange.get(this.toKey(p));let g=!1;if(f){const a=f.type,n=p.type;f.path!==p.path&&(p.type===2||p.type===1)?g=!0:a===1&&n===2?(this.mapPathToChange.delete(this.toKey(p)),this.coalesced.delete(f)):a===2&&n===1?f.type=0:a===1&&n===0||(f.type=n)}else g=!0;g&&(this.coalesced.add(p),this.mapPathToChange.set(this.toKey(p),p))}coalesce(){const p=[],f=[];return Array.from(this.coalesced).filter(g=>g.type!==2?(p.push(g),!1):!0).sort((g,a)=>g.path.length-a.path.length).filter(g=>f.some(a=>(0,E.isParent)(g.path,a,!R.isLinux))?!1:(f.push(g.path),!0)).concat(p)}}}),define(Z[197],ee([0,1,40,8,22,30,2,80,9,4,97,23,70]),function(q,e,v,t,k,R,M,E,l,m,I,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class h extends M.Disposable{constructor(C,w,p,f){super(),this.request=C,this.onDidFilesChange=w,this.onLogMessage=p,this.verboseLogging=f,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},g=>this.onDidFilesChange(g)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(h.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,y.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,y.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const C=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const w=await b.Promises.stat(C);this._register(await this.doWatch(C,w.isDirectory()))}catch(C){C.code!=="ENOENT"?this.error(C):this.trace(C)}}async normalizePath(C){let w=C.path;try{w=await b.Promises.realpath(C.path),C.path===w&&(w=await(0,I.realcase)(C.path)??C.path),C.path!==w&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${C.path}, real: ${w})`)}catch{}return w}async doWatch(C,w){if(m.isMacintosh&&(0,R.isEqualOrParent)(C,"/Volumes/",!0))return this.error(`Refusing to watch ${C} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const p=new k.CancellationTokenSource(this.cts.token),f=new M.DisposableStore;try{const g=(0,l.basename)(C),a=(0,v.watch)(C);f.add((0,M.toDisposable)(()=>{a.removeAllListeners(),a.close()})),this.trace(`Started watching: '${C}'`);const n=new Set;if(w)try{for(const i of await b.Promises.readdir(C))n.add(i)}catch(i){this.error(i)}const o=new Map;f.add((0,M.toDisposable)(()=>{for(const[,i]of o)i.dispose();o.clear()})),a.on("error",(i,r)=>{this.error(`Failed to watch ${C} for changes using fs.watch() (${i}, ${r})`),this.dispose()}),a.on("change",(i,r)=>{if(p.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${r}`);let s="";if(r&&(s=r.toString(),m.isMacintosh&&(s=(0,E.normalizeNFC)(s))),!(!s||i!=="change"&&i!=="rename"))if(w)if(i==="rename"){o.get(s)?.dispose();const c=setTimeout(async()=>{if(o.delete(s),s===g&&!await b.Promises.exists(C)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.existsChildStrictCase((0,l.join)(C,s));if(p.token.isCancellationRequested)return;let P;u?n.has(s)?P=0:(P=1,n.add(s)):(n.delete(s),P=2),this.onFileChange({path:(0,l.join)(this.request.path,s),type:P})},h.FILE_DELETE_HANDLER_DELAY);o.set(s,(0,M.toDisposable)(()=>clearTimeout(c)))}else{let c;n.has(s)?c=0:(c=1,n.add(s)),this.onFileChange({path:(0,l.join)(this.request.path,s),type:c})}else if(i==="rename"||s!==g){const c=setTimeout(async()=>{const u=await b.Promises.exists(C);p.token.isCancellationRequested||(u?(this.onFileChange({path:this.request.path,type:0},!0),f.add(await this.doWatch(C,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},h.FILE_DELETE_HANDLER_DELAY);f.clear(),f.add((0,M.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(g){await b.Promises.exists(C)&&!p.token.isCancellationRequested&&this.error(`Failed to watch ${C} for changes using fs.watch() (${g.toString()})`)}return(0,M.toDisposable)(()=>{p.dispose(!0),f.dispose()})}async onFileChange(C,w=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),!w&&this.excludes.some(p=>p(C.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${C.path}`):!w&&this.includes&&this.includes.length>0&&!this.includes.some(p=>p(C.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${C.path}`):this.fileChangesBuffer.push(C);try{await this.fileChangesDelayer.trigger(async()=>{const p=this.fileChangesBuffer;this.fileChangesBuffer=[];const f=(0,y.coalesceEvents)(p);if(f.length>0){if(this.verboseLogging)for(const a of f)this.trace(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`);this.throttledFileChangesWorker.work(f)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(C){if(m.isLinux)return b.Promises.exists(C);try{const w=(0,l.basename)(C);return(await b.Promises.readdir((0,l.dirname)(C))).some(f=>f===w)}catch(w){return this.trace(w),!1}}setVerboseLogging(C){this.verboseLogging=C}error(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${C}`})}warn(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${C}`})}trace(C){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=h,h.FILE_DELETE_HANDLER_DELAY=100,h.FILE_CHANGES_HANDLER_DELAY=50;async function d(S,C,w,p,f=512){const g=await b.Promises.open(S,"r"),a=Buffer.allocUnsafe(f),n=new k.CancellationTokenSource(p);let o,i=!1;const r={path:S,excludes:[],recursive:!1},s=new h(r,c=>{(async()=>{for(const{type:u}of c)if(u===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:P}=await b.Promises.read(g,a,0,f,null);if(!P||n.token.isCancellationRequested)break;C(a.slice(0,P))}}catch(P){o=new Error(P),n.dispose(!0)}finally{i=!1}}})()});return await s.ready,w(),new Promise((c,u)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await b.Promises.close(g)}catch(P){o=new Error(P)}o?u(o):c()})})}e.watchFileContents=d}),define(Z[198],ee([0,1,3,96,2,4,197]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class E extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new v.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new v.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=v.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(m){const I=this.normalizeRequests(m),b=I.filter(h=>{const d=this.watchers.get(h.path);return d?!(0,t.patternsEquals)(d.request.excludes,h.excludes)||!(0,t.patternsEquals)(d.request.includes,h.includes):!0}),y=Array.from(this.watchers.values()).filter(({request:h})=>!I.find(d=>d.path===h.path&&(0,t.patternsEquals)(d.excludes,h.excludes)&&(0,t.patternsEquals)(d.includes,h.includes))).map(({request:h})=>h.path);b.length&&this.trace(`Request to start watching: ${b.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),y.length&&this.trace(`Request to stop watching: ${y.join(",")}`);for(const h of y)this.stopWatching(h);for(const h of b)this.startWatching(h)}startWatching(m){const I=new M.NodeJSFileWatcherLibrary(m,y=>this._onDidChangeFile.fire(y),y=>this._onDidLogMessage.fire(y),this.verboseLogging),b={request:m,instance:I};this.watchers.set(m.path,b)}async stop(){for(const[m]of this.watchers)this.stopWatching(m);this.watchers.clear()}stopWatching(m){const I=this.watchers.get(m);I&&(this.watchers.delete(m),I.instance.dispose())}normalizeRequests(m){const I=new Map;for(const b of m){const y=R.isLinux?b.path:b.path.toLowerCase();I.set(y,b)}return Array.from(I.values())}async setVerboseLogging(m){this.verboseLogging=m;for(const[,I]of this.watchers)I.instance.setVerboseLogging(m)}trace(m){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(m)})}toMessage(m,I){return I?`[File Watcher (node.js)] ${m} (path: ${I.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=E}),define(Z[199],ee([0,1,70,198]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends v.AbstractNonRecursiveWatcherClient{constructor(M,E,l){super(M,E,l),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(Z[200],ee([0,1,13,46,146,70]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends R.AbstractUniversalWatcherClient{constructor(l,m,I){super(l,m,I),this.init()}createWatcher(l){const m=l.add(new k.Client(v.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(m.onDidProcessExit(({code:I,signal:b})=>this.onError(`terminated by itself with code ${I}, signal: ${b}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(Z[85],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...k){this._entries=new Map;for(const[R,M]of k)this.set(R,M)}set(k,R){const M=this._entries.get(k);return this._entries.set(k,R),M}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=v}),define(Z[201],ee([0,1,8,17,68,191,5,85]),function(q,e,v,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const l=!1;class m extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class I{constructor(d=new E.ServiceCollection,S=!1,C){this._activeInstantiations=new Set,this._services=d,this._strict=S,this._parent=C,this._services.set(M.IInstantiationService,this)}createChild(d){return new I(d,this._strict,this)}invokeFunction(d,...S){const C=y.traceInvocation(d);let w=!1;try{return d({get:f=>{if(w)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(f,C);if(!g)throw new Error(`[invokeFunction] unknown service '${f}'`);return g}},...S)}finally{w=!0,C.stop()}}createInstance(d,...S){let C,w;return d instanceof k.SyncDescriptor?(C=y.traceCreation(d.ctor),w=this._createInstance(d.ctor,d.staticArguments.concat(S),C)):(C=y.traceCreation(d),w=this._createInstance(d,S,C)),C.stop(),w}_createInstance(d,S=[],C){const w=M._util.getServiceDependencies(d).sort((g,a)=>g.index-a.index),p=[];for(const g of w){const a=this._getOrCreateServiceInstance(g.id,C);a||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${g.id}.`,!1),p.push(a)}const f=w.length>0?w[0].index:S.length;if(S.length!==f){console.trace(`[createInstance] First service dependency of ${d.name} at position ${f+1} conflicts with ${S.length} static arguments`);const g=f-S.length;g>0?S=S.concat(new Array(g)):S=S.slice(0,f)}return new d(...S,...p)}_setServiceInstance(d,S){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,S);else if(this._parent)this._parent._setServiceInstance(d,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){const S=this._services.get(d);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):S}_getOrCreateServiceInstance(d,S){const C=this._getServiceInstanceOrDescriptor(d);return C instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,C,S.branch(d,!0)):(S.branch(d,!1),C)}_safeCreateAndCacheServiceInstance(d,S,C){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,S,C)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,S,C){const w=new R.Graph(g=>g.id.toString());let p=0;const f=[{id:d,desc:S,_trace:C}];for(;f.length;){const g=f.pop();if(w.lookupOrInsertNode(g),p++>1e3)throw new m(w);for(const a of M._util.getServiceDependencies(g.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(a.id);if(n||this._throwIfStrict(`[createInstance] ${d} depends on ${a.id} which is NOT registered.`,!0),n instanceof k.SyncDescriptor){const o={id:a.id,desc:n,_trace:g._trace.branch(a.id,!0)};w.insertEdge(g,o),f.push(o)}}}for(;;){const g=w.roots();if(g.length===0){if(!w.isEmpty())throw new m(w);break}for(const{data:a}of g){if(this._getServiceInstanceOrDescriptor(a.id)instanceof k.SyncDescriptor){const o=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,o)}w.removeNode(a)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,S,C=[],w,p){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(S,C,w,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,S,C,w,p);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(d,S=[],C,w){if(C){const p=new v.IdleValue(()=>this._createInstance(d,S,w));return new Proxy(Object.create(null),{get(f,g){if(g in f)return f[g];const a=p.value;let n=a[g];return typeof n!="function"||(n=n.bind(a),f[g]=n),n},set(f,g,a){return p.value[g]=a,!0}})}else return this._createInstance(d,S,w)}_throwIfStrict(d,S){if(S&&console.warn(d),this._strict)throw new Error(d)}}e.InstantiationService=I;var b;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(b||(b={}));class y{constructor(d,S){this.type=d,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return l?new y(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(d){return l?new y(0,d.name):y._None}branch(d,S){const C=new y(2,d.toString());return this._dep.push([d,S,C]),C}stop(){const d=Date.now()-this._start;y._totals+=d;let S=!1;function C(p,f){const g=[],a=new Array(p+1).join("	");for(const[n,o,i]of f._dep)if(o&&i){S=!0,g.push(`${a}CREATES -> ${n}`);const r=C(p+1,i);r&&g.push(r)}else g.push(`${a}uses -> ${n}`);return g.join(`
`)}const w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${C(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(d>2||S)&&console.log(w.join(`
`))}}e.Trace=y,y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(Z[6],ee([0,1,44,3,2,4,5]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,M.createDecorator)("logService"),e.ILoggerService=(0,M.createDecorator)("loggerService");function E(){return new Date().toISOString()}var l;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(l=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=l.Info;function m(o,i,r){switch(i){case l.Trace:o.trace(r);break;case l.Debug:o.debug(r);break;case l.Info:o.info(r);break;case l.Warning:o.warn(r);break;case l.Error:o.error(r);break;case l.Critical:o.critical(r);break;default:throw new Error("Invalid log level")}}e.log=m;function I(o){let i="";for(let r=0;r<o.length;r++){let s=o[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}i+=(r>0?" ":"")+s}return i}e.format=I;class b extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class y extends b{constructor(i){super(),this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...r){this.checkLogLevel(l.Trace)&&this.log(l.Trace,I([i,...r]))}debug(i,...r){this.checkLogLevel(l.Debug)&&this.log(l.Debug,I([i,...r]))}info(i,...r){this.checkLogLevel(l.Info)&&this.log(l.Info,I([i,...r]))}warn(i,...r){this.checkLogLevel(l.Warning)&&this.log(l.Warning,I([i,...r]))}error(i,...r){if(this.checkLogLevel(l.Error))if(i instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=i.stack,this.log(l.Error,I(s))}else this.log(l.Error,I([i,...r]))}critical(i,...r){this.checkLogLevel(l.Critical)&&this.log(l.Critical,I([i,...r]))}flush(){}}e.AbstractMessageLogger=y;class h extends b{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i),this.useColors=!R.isWindows}trace(i,...r){this.getLevel()<=l.Trace&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,i,...r):console.log(`[main ${E()}]`,i,...r))}debug(i,...r){this.getLevel()<=l.Debug&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,i,...r):console.log(`[main ${E()}]`,i,...r))}info(i,...r){this.getLevel()<=l.Info&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,i,...r):console.log(`[main ${E()}]`,i,...r))}warn(i,...r){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,i,...r):console.warn(`[main ${E()}]`,i,...r))}error(i,...r){this.getLevel()<=l.Error&&(this.useColors?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,i,...r):console.error(`[main ${E()}]`,i,...r))}critical(i,...r){this.getLevel()<=l.Critical&&(this.useColors?console.error(`\x1B[90m[main ${E()}]\x1B[0m`,i,...r):console.error(`[main ${E()}]`,i,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class d extends b{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i)}trace(i,...r){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",i,...r)}debug(i,...r){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...r)}info(i,...r){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",i,...r)}warn(i,...r){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",i,...r)}error(i,...r){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",i,...r)}critical(i,...r){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...r)}dispose(){}flush(){}}e.ConsoleLogger=d;class S extends b{constructor(i,r=e.DEFAULT_LOG_LEVEL){super(),this.adapter=i,this.setLevel(r)}trace(i,...r){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(i),...r])}debug(i,...r){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(i),...r])}info(i,...r){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(i),...r])}warn(i,...r){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(i),...r])}error(i,...r){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(i),...r])}critical(i,...r){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(i),...r])}extractMessage(i){return typeof i=="string"?i:(0,v.toErrorMessage)(i,this.getLevel()<=l.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class C extends b{constructor(i){super(),this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const r of this.logServices)r.setLevel(i);super.setLevel(i)}trace(i,...r){for(const s of this.logServices)s.trace(i,...r)}debug(i,...r){for(const s of this.logServices)s.debug(i,...r)}info(i,...r){for(const s of this.logServices)s.info(i,...r)}warn(i,...r){for(const s of this.logServices)s.warn(i,...r)}error(i,...r){for(const s of this.logServices)s.error(i,...r)}critical(i,...r){for(const s of this.logServices)s.critical(i,...r)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=C;class w extends k.Disposable{constructor(i){super(),this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...r){this.logger.trace(i,...r)}debug(i,...r){this.logger.debug(i,...r)}info(i,...r){this.logger.info(i,...r)}warn(i,...r){this.logger.warn(i,...r)}error(i,...r){this.logger.error(i,...r)}critical(i,...r){this.logger.critical(i,...r)}flush(){this.logger.flush()}}e.LogService=w;class p extends k.Disposable{constructor(i,r){super(),this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(s))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,r){let s=this.loggers.get(i.toString());return s||(s=this.doCreateLogger(i,r?.always?l.Trace:this.logLevel,r),this.loggers.set(i.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class f{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return l.Info}trace(i,...r){}debug(i,...r){}info(i,...r){}warn(i,...r){}error(i,...r){}critical(i,...r){}dispose(){}flush(){}}e.NullLogService=f;function g(o){if(o.verbose)return l.Trace;if(typeof o.logLevel=="string"){const i=a(o.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function a(o){switch(o){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}e.parseLogLevel=a;function n(o){switch(o){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}e.LogLevelToString=n});var J=this&&this.__param||function(q,e){return function(v,t){e(v,t,q)}};define(Z[202],ee([0,1,69,3,2,6,4]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let E=class St extends k.Disposable{constructor(m){super(),this.logService=m,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(m,I){let b;try{b=await this.withKeytar()}catch{return null}const y=await b.getPassword(m,I);if(y)try{let{content:h,hasNextChunk:d}=JSON.parse(y);if(!h||!d)return y;let S=1;for(;d;){const C=await b.getPassword(m,`${I}-${S}`),w=JSON.parse(C);h+=w.content,d=w.hasNextChunk,S++}return h}catch{return y}return y}async setPassword(m,I,b){let y;try{y=await this.withKeytar()}catch(S){throw this.surfaceKeytarLoadError?.(S),S}const h=3,d=async(S,C,w)=>{let p=0,f;for(;p<h;)try{await y.setPassword(S,C,w);return}catch(g){f=g,this.logService.warn("Error attempting to set a password: ",g?.message??g),p++,await new Promise(a=>setTimeout(a,200))}throw f};if(M.isWindows&&b.length>St.MAX_PASSWORD_LENGTH){let S=0,C=0,w=!0;for(;w;){const p=b.substring(S,S+St.PASSWORD_CHUNK_SIZE);S+=St.PASSWORD_CHUNK_SIZE,w=b.length-S>0;const f={content:p,hasNextChunk:w};await d(m,C?`${I}-${C}`:I,JSON.stringify(f)),C++}}else await d(m,I,b);this._onDidChangePassword.fire({service:m,account:I})}async deletePassword(m,I){let b;try{b=await this.withKeytar()}catch(d){throw this.surfaceKeytarLoadError?.(d),d}const y=await b.getPassword(m,I);if(!y)return!1;const h=await b.deletePassword(m,I);try{let{content:d,hasNextChunk:S}=JSON.parse(y);if(d&&S){let C=1;for(;S;){const w=`${I}-${C}`,p=await b.getPassword(m,w);await b.deletePassword(m,w),S=JSON.parse(p).hasNextChunk,C++}}}catch{}return h&&this._onDidChangePassword.fire({service:m,account:I}),h}async findPassword(m){let I;try{I=await this.withKeytar()}catch{return null}return I.findPassword(m)}async findCredentials(m){let I;try{I=await this.withKeytar()}catch{return[]}return I.findCredentials(m)}clear(){return this._keytarCache instanceof v.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};E.MAX_PASSWORD_LENGTH=2500,E.PASSWORD_CHUNK_SIZE=E.MAX_PASSWORD_LENGTH-100,E=ve([J(0,R.ILogService)],E),e.BaseCredentialsMainService=E}),define(Z[203],ee([0,1,24,8,17,3,2,9,70,6]),function(q,e,v,t,k,R,M,E,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends M.Disposable{constructor(y,h){super(),this.logService=y,this.options=h,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(y,h){return h.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(y,h):this.watchNonRecursive(y,h)}watchUniversal(y,h){const d={path:this.toFilePath(y),excludes:h.excludes,includes:h.includes,recursive:h.recursive},S=(0,v.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{S(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(y=>(0,k.onUnexpectedError)(y))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(h=>this._onDidChangeFile.fire((0,l.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})));const y=this.options?.watcher?.recursive?.usePolling;if(y===!0)for(const h of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const h of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(h)&&y.includes(h.path)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(y,h){const d={path:this.toFilePath(y),excludes:h.excludes,includes:h.includes,recursive:!1},S=(0,v.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{S(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(y=>(0,k.onUnexpectedError)(y))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(y=>this._onDidChangeFile.fire((0,l.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(y){y.type==="error"&&this._onDidWatchError.fire(y.message),this.logService[y.type](y.message)}toFilePath(y){return(0,E.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(Z[204],ee([0,1,24,8,18,22,3,66,57,2,31,13,71,16,58,158,14,105,6]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S,C,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let f=class extends m.Disposable{constructor(a){super(),this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(a,n){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${a}`);const o=new m.DisposableStore;return this.provider.set(a,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:n}),o.add(n.onDidChangeFile(i=>this._onDidFilesChange.fire(new C.FileChangesEvent(i,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&o.add(n.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),o.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:a}))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:n}),this.provider.delete(a),(0,m.dispose)(o)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(o){n.push(o)}}),!this.provider.has(a)&&await t.Promises.settled(n)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,n){const o=this.provider.get(a.scheme);return!!(o&&o.capabilities&n)}listCapabilities(){return l.Iterable.map(this.provider,([a,n])=>({scheme:a,capabilities:n.capabilities}))}async withProvider(a){if(!(0,h.isAbsolutePath)(a))throw new C.FileOperationError((0,S.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const n=this.provider.get(a.scheme);if(!n){const o=new Error;throw o.name="ENOPRO",o.message=(0,S.localize)(1,null,a.toString()),o}return n}async withReadProvider(a){const n=await this.withProvider(a);if((0,C.hasOpenReadWriteCloseCapability)(n)||(0,C.hasReadWriteCapability)(n)||(0,C.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const n=await this.withProvider(a);if((0,C.hasOpenReadWriteCloseCapability)(n)||(0,C.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,n){try{return await this.doResolveFile(a,n)}catch(o){throw(0,C.toFileSystemProviderErrorCode)(o)===C.FileSystemProviderErrorCode.FileNotFound?new C.FileOperationError((0,S.localize)(2,null,this.resourceForError(a)),1):(0,C.ensureFileSystemProviderError)(o)}}async doResolveFile(a,n){const o=await this.withProvider(a),i=this.isPathCaseSensitive(o),r=n?.resolveTo,s=n?.resolveSingleChildDescendants,c=n?.resolveMetadata,u=await o.stat(a);let P;return this.toFileStat(o,a,u,void 0,!!c,(D,T)=>(P||(P=I.TernarySearchTree.forUris(()=>!i),P.set(a,!0),r&&P.fill(!0,r)),P.get(D.resource)||P.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&s?T===1:!1))}async toFileStat(a,n,o,i,r,s){const{providerExtUri:c}=this.getExtUri(a),u={resource:n,name:c.basename(n),isFile:(o.type&C.FileType.File)!==0,isDirectory:(o.type&C.FileType.Directory)!==0,isSymbolicLink:(o.type&C.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&C.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,C.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(u.isDirectory&&s(u,i)){try{const P=await a.readdir(n),D=await t.Promises.settled(P.map(async([T,N])=>{try{const U=c.joinPath(n,T),$=r?await a.stat(U):{type:N};return await this.toFileStat(a,U,$,P.length,r,s)}catch(U){return this.logService.trace(U),null}}));u.children=(0,v.coalesce)(D)}catch(P){this.logService.trace(P),u.children=[]}return u}return u}async resolveAll(a){return t.Promises.settled(a.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(a){const n=await this.withProvider(a),o=await n.stat(a);return this.toFileStat(n,a,o,void 0,!0,()=>!1)}async exists(a){const n=await this.withProvider(a);try{return!!await n.stat(a)}catch{return!1}}async canCreateFile(a,n){try{await this.doValidateCreateFile(a,n)}catch(o){return o}return!0}async doValidateCreateFile(a,n){if(!n?.overwrite&&await this.exists(a))throw new C.FileOperationError((0,S.localize)(3,null,this.resourceForError(a)),3,n)}async createFile(a,n=k.VSBuffer.fromString(""),o){await this.doValidateCreateFile(a,o);const i=await this.writeFile(a,n);return this._onDidRunOperation.fire(new C.FileOperationEvent(a,0,i)),i}async writeFile(a,n,o){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:r}=this.getExtUri(i);try{await this.validateWriteFile(i,a,o)||await this.mkdirp(i,r.dirname(a));let c;if((0,C.hasReadWriteCapability)(i)&&!(n instanceof k.VSBuffer))if((0,d.isReadableStream)(n)){const u=await(0,d.peekStream)(n,3);u.ended?c=k.VSBuffer.concat(u.buffer):c=u}else c=(0,d.peekReadable)(n,u=>k.VSBuffer.concat(u),3);else c=n;!(0,C.hasOpenReadWriteCloseCapability)(i)||(0,C.hasReadWriteCapability)(i)&&c instanceof k.VSBuffer?await this.doWriteUnbuffered(i,a,o,c):await this.doWriteBuffered(i,a,o,c instanceof k.VSBuffer?(0,k.bufferToReadable)(c):c),this._onDidRunOperation.fire(new C.FileOperationEvent(a,4))}catch(s){throw new C.FileOperationError((0,S.localize)(4,null,this.resourceForError(a),(0,C.ensureFileSystemProviderError)(s).toString()),(0,C.toFileOperationResult)(s),o)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,n,o){if(!!o?.unlock&&!(a.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(n)));let r;try{r=await a.stat(n)}catch{return}if((r.type&C.FileType.Directory)!==0)throw new C.FileOperationError((0,S.localize)(6,null,this.resourceForError(n)),0,o);if(this.throwIfFileIsReadonly(n,r),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==C.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&o.mtime<r.mtime&&o.etag!==(0,C.etag)({mtime:o.mtime,size:r.size}))throw new C.FileOperationError((0,S.localize)(7,null),3,o);return r}async readFile(a,n,o){const i=await this.withReadProvider(a);return n?.atomic?this.doReadFileAtomic(i,a,n,o):this.doReadFile(i,a,n,o)}async doReadFileAtomic(a,n,o,i){return new Promise((r,s)=>{this.writeQueue.queueFor(n,this.getExtUri(a).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(a,n,o,i);r(c)}catch(c){s(c)}})})}async doReadFile(a,n,o,i){const r=await this.doReadFileStream(a,n,{...o,preferUnbuffered:!0},i);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(a,n,o){const i=await this.withReadProvider(a);return this.doReadFileStream(i,a,n,o)}async doReadFileStream(a,n,o,i){const r=new R.CancellationTokenSource(i),s=this.validateReadFile(n,o).then(u=>u,u=>{throw r.cancel(),u});let c;try{return typeof o?.etag=="string"&&o.etag!==C.ETAG_DISABLED&&await s,o?.atomic&&(0,C.hasFileAtomicReadCapability)(a)||!((0,C.hasOpenReadWriteCloseCapability)(a)||(0,C.hasFileReadStreamCapability)(a))||(0,C.hasReadWriteCapability)(a)&&o?.preferUnbuffered?c=this.readFileUnbuffered(a,n,o):(0,C.hasFileReadStreamCapability)(a)?c=this.readFileStreamed(a,n,r.token,o):c=this.readFileBuffered(a,n,r.token,o),{...await s,value:c}}catch(u){c&&await(0,d.consumeStream)(c);const P=(0,S.localize)(8,null,this.resourceForError(n),(0,C.ensureFileSystemProviderError)(u).toString());throw u instanceof C.NotModifiedSinceFileOperationError?new C.NotModifiedSinceFileOperationError(P,u.stat,o):new C.FileOperationError(P,(0,C.toFileOperationResult)(u),o)}}readFileStreamed(a,n,o,i=Object.create(null)){const r=a.readFileStream(n,i,o);return(0,d.transform)(r,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new C.FileOperationError((0,S.localize)(9,null,this.resourceForError(n),(0,C.ensureFileSystemProviderError)(s).toString()),(0,C.toFileOperationResult)(s),i)},s=>k.VSBuffer.concat(s))}readFileBuffered(a,n,o,i=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,w.readFileIntoStream)(a,n,r,s=>s,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new C.FileOperationError((0,S.localize)(10,null,this.resourceForError(n),(0,C.ensureFileSystemProviderError)(s).toString()),(0,C.toFileOperationResult)(s),i)},o),r}readFileUnbuffered(a,n,o){const i=(0,d.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;o?.atomic&&(0,C.hasFileAtomicReadCapability)(a)?r=await a.readFile(n,{atomic:!0}):r=await a.readFile(n),typeof o?.position=="number"&&(r=r.slice(o.position)),typeof o?.length=="number"&&(r=r.slice(0,o.length)),this.validateReadFileLimits(n,r.byteLength,o),i.end(k.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async validateReadFile(a,n){const o=await this.resolve(a,{resolveMetadata:!0});if(o.isDirectory)throw new C.FileOperationError((0,S.localize)(11,null,this.resourceForError(a)),0,n);if(typeof n?.etag=="string"&&n.etag!==C.ETAG_DISABLED&&n.etag===o.etag)throw new C.NotModifiedSinceFileOperationError((0,S.localize)(12,null),o,n);return this.validateReadFileLimits(a,o.size,n),o}validateReadFileLimits(a,n,o){if(o?.limits){let i;if(typeof o.limits.memory=="number"&&n>o.limits.memory&&(i=9),typeof o.limits.size=="number"&&n>o.limits.size&&(i=7),typeof i=="number")throw new C.FileOperationError((0,S.localize)(13,null,this.resourceForError(a)),i)}}async canMove(a,n,o){return this.doCanMoveCopy(a,n,"move",o)}async canCopy(a,n,o){return this.doCanMoveCopy(a,n,"copy",o)}async doCanMoveCopy(a,n,o,i){if(a.toString()!==n.toString())try{const r=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(r,a,s,n,o,i)}catch(r){return r}return!0}async move(a,n,o){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(i,a,r,n,"move",!!o),c=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(a,s==="move"?2:3,c)),c}async copy(a,n,o){const i=await this.withReadProvider(a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(i,a,r,n,"copy",!!o),c=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(a,s==="copy"?3:2,c)),c}async doMoveCopy(a,n,o,i,r,s){if(n.toString()===i.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(a,n,o,i,r,s);if(c&&!u&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(i)),r==="copy"){if(a===o&&(0,C.hasFileFolderCopyCapability)(a))await a.copy(n,i,{overwrite:s});else{const P=await this.resolve(n);P.isDirectory?await this.doCopyFolder(a,P,o,i):await this.doCopyFile(a,n,o,i)}return r}else return a===o?(await a.rename(n,i,{overwrite:s}),r):(await this.doMoveCopy(a,n,o,i,"copy",s),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(a,n,o,i){if((0,C.hasOpenReadWriteCloseCapability)(a)&&(0,C.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(a,n,o,i);if((0,C.hasOpenReadWriteCloseCapability)(a)&&(0,C.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(a,n,o,i);if((0,C.hasReadWriteCapability)(a)&&(0,C.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(a,n,o,i);if((0,C.hasReadWriteCapability)(a)&&(0,C.hasReadWriteCapability)(o))return this.doPipeUnbuffered(a,n,o,i)}async doCopyFolder(a,n,o,i){await o.mkdir(i),Array.isArray(n.children)&&await t.Promises.settled(n.children.map(async r=>{const s=this.getExtUri(o).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.doCopyFolder(a,await this.resolve(r.resource),o,s):this.doCopyFile(a,r.resource,o,s)}))}async doValidateMoveCopy(a,n,o,i,r,s){let c=!1;if(a===o){const{providerExtUri:P,isPathCaseSensitive:D}=this.getExtUri(a);if(D||(c=P.isEqual(n,i)),c&&r==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(n),this.resourceForError(i)));if(!c&&P.isEqualOrParent(i,n))throw new Error((0,S.localize)(15,null,this.resourceForError(n),this.resourceForError(i)))}const u=await this.exists(i);if(u&&!c){if(!s)throw new C.FileOperationError((0,S.localize)(16,null,this.resourceForError(n),this.resourceForError(i)),4);if(a===o){const{providerExtUri:P}=this.getExtUri(a);if(P.isEqualOrParent(n,i))throw new Error((0,S.localize)(17,null,this.resourceForError(n),this.resourceForError(i)))}}return{exists:u,isSameResourceWithDifferentPathCase:c}}getExtUri(a){const n=this.isPathCaseSensitive(a);return{providerExtUri:n?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(n,a);const o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(a,0,o)),o}async mkdirp(a,n){const o=[],{providerExtUri:i}=this.getExtUri(a);for(;!i.isEqual(n,i.dirname(n));)try{if(((await a.stat(n)).type&C.FileType.Directory)===0)throw new Error((0,S.localize)(18,null,this.resourceForError(n)));break}catch(r){if((0,C.toFileSystemProviderErrorCode)(r)!==C.FileSystemProviderErrorCode.FileNotFound)throw r;o.push(i.basename(n)),n=i.dirname(n)}for(let r=o.length-1;r>=0;r--){n=i.joinPath(n,o[r]);try{await a.mkdir(n)}catch(s){if((0,C.toFileSystemProviderErrorCode)(s)!==C.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(a,n){try{await this.doValidateDelete(a,n)}catch(o){return o}return!0}async doValidateDelete(a,n){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!n?.useTrash&&!(o.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(a)));let r;try{r=await o.stat(a)}catch{}if(r)this.throwIfFileIsReadonly(a,r);else throw new C.FileOperationError((0,S.localize)(20,null,this.resourceForError(a)),1);if(!!!n?.recursive){const c=await this.resolve(a);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(a)))}return o}async del(a,n){const o=await this.doValidateDelete(a,n),i=!!n?.useTrash,r=!!n?.recursive;await o.delete(a,{recursive:r,useTrash:i}),this._onDidRunOperation.fire(new C.FileOperationEvent(a,1))}async cloneFile(a,n){const o=await this.withProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(o===i&&this.getExtUri(o).providerExtUri.isEqual(a,n))return;if(o===i&&(0,C.hasFileCloneCapability)(o))return o.cloneFile(a,n);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n));const r=this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri);return o===i&&(0,C.hasFileFolderCopyCapability)(o)?r.queue(()=>o.copy(a,n,{overwrite:!0})):r.queue(()=>this.doCopyFile(o,a,i,n))}watch(a,n={recursive:!1,excludes:[]}){const o=new m.DisposableStore;let i=!1,r=()=>{i=!0};return o.add((0,m.toDisposable)(()=>r())),(async()=>{try{const s=await this.doWatch(a,n);i?(0,m.dispose)(s):r=()=>(0,m.dispose)(s)}catch(s){this.logService.error(s)}})(),o}async doWatch(a,n){const o=await this.withProvider(a),i=(0,E.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(a),n]);let r=this.activeWatchers.get(i);return r||(r={count:0,disposable:o.watch(a,n)},this.activeWatchers.set(i,r)),r.count+=1,(0,m.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,m.dispose)(r.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,m.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,n,o,i){return this.writeQueue.queueFor(n,this.getExtUri(a).providerExtUri).queue(async()=>{const r=await a.open(n,{create:!0,unlock:o?.unlock??!1});try{(0,d.isReadableStream)(i)||(0,d.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(a,r,i):await this.doWriteReadableBufferedQueued(a,r,i)}catch(s){throw(0,C.ensureFileSystemProviderError)(s)}finally{await a.close(r)}})}async doWriteStreamBufferedQueued(a,n,o){let i=0,r;if((0,d.isReadableBufferedStream)(o)){if(o.buffer.length>0){const s=k.VSBuffer.concat(o.buffer);await this.doWriteBuffer(a,n,s,s.byteLength,i,0),i+=s.byteLength}if(o.ended)return;r=o.stream}else r=o;return new Promise((s,c)=>{(0,d.listenStream)(r,{onData:async u=>{r.pause();try{await this.doWriteBuffer(a,n,u,u.byteLength,i,0)}catch(P){return c(P)}i+=u.byteLength,setTimeout(()=>r.resume())},onError:u=>c(u),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(a,n,o){let i=0,r;for(;(r=o.read())!==null;)await this.doWriteBuffer(a,n,r,r.byteLength,i,0),i+=r.byteLength}async doWriteBuffer(a,n,o,i,r,s){let c=0;for(;c<i;)c+=await a.write(n,r+c,o.buffer,s+c,i-c)}async doWriteUnbuffered(a,n,o,i){return this.writeQueue.queueFor(n,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,n,o,i))}async doWriteUnbufferedQueued(a,n,o,i){let r;i instanceof k.VSBuffer?r=i:(0,d.isReadableStream)(i)?r=await(0,k.streamToBuffer)(i):(0,d.isReadableBufferedStream)(i)?r=await(0,k.bufferedStreamToBuffer)(i):r=(0,k.readableToBuffer)(i),await a.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(a,n,o,i){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,n,o,i))}async doPipeBufferedQueued(a,n,o,i){let r,s;try{r=await a.open(n,{create:!1}),s=await o.open(i,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,P=0,D=0;do D=await a.read(r,u,c.buffer,P,c.byteLength-P),await this.doWriteBuffer(o,s,c,D,u,P),u+=D,P+=D,P===c.byteLength&&(P=0);while(D>0)}catch(c){throw(0,C.ensureFileSystemProviderError)(c)}finally{await t.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof s=="number"?o.close(s):Promise.resolve()])}}async doPipeUnbuffered(a,n,o,i){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,n,o,i))}async doPipeUnbufferedQueued(a,n,o,i){return o.writeFile(i,await a.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,n,o,i){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,n,o,i))}async doPipeUnbufferedToBufferedQueued(a,n,o,i){const r=await o.open(i,{create:!0,unlock:!1});try{const s=await a.readFile(n);await this.doWriteBuffer(o,r,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,C.ensureFileSystemProviderError)(s)}finally{await o.close(r)}}async doPipeBufferedToUnbuffered(a,n,o,i){const r=await(0,k.streamToBuffer)(this.readFileBuffered(a,n,R.CancellationToken.None));await this.doWriteUnbuffered(o,i,void 0,r)}throwIfFileSystemIsReadonly(a,n){if(a.capabilities&2048)throw new C.FileOperationError((0,S.localize)(22,null,this.resourceForError(n)),6);return a}throwIfFileIsReadonly(a,n){if((n.permissions??0)&C.FilePermission.Readonly)throw new C.FileOperationError((0,S.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===b.Schemas.file?a.fsPath:a.toString(!0)}};f=ve([J(0,p.ILogService)],f),e.FileService=f}),define(Z[86],ee([0,1,40,276,8,31,18,3,30,2,9,4,16,58,23,162,14,105,203,44,200,199]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S,C,w,p,f,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(v)}catch(o){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(o)}`)}})();class n extends p.AbstractDiskFileSystemProvider{constructor(i,r){super(i,r),this.onDidChangeCapabilities=E.Event.None,this.resourceLocks=new R.ResourceMap(s=>y.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:r,symbolicLink:s}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(r,s),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(i){try{const r=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),s=[];return await Promise.all(r.map(async c=>{try{let u;c.isSymbolicLink()?u=(await this.stat((0,y.joinPath)(i,c.name))).type:u=this.toType(c),s.push([c.name,u])}catch(u){this.logService.trace(u)}})),s}catch(r){throw this.toFileSystemProviderError(r)}}toType(i,r){let s;return r?.dangling?s=C.FileType.Unknown:i.isFile()?s=C.FileType.File:i.isDirectory()?s=C.FileType.Directory:s=C.FileType.Unknown,r&&(s|=C.FileType.SymbolicLink),s}async createResourceLock(i){const r=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let s;for(;s=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await s.wait();const c=new k.Barrier;return this.resourceLocks.set(i,c),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,m.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(i)===c&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),c.open()})}async readFile(i,r){let s;try{r?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),s=await this.createResourceLock(i));const c=this.toFilePath(i);return await d.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{s?.dispose()}}readFileStream(i,r,s){const c=(0,h.newWriteableStream)(u=>M.VSBuffer.concat(u.map(P=>M.VSBuffer.wrap(P))).buffer);return(0,w.readFileIntoStream)(this,i,c,u=>u.buffer,{...r,bufferSize:256*1024},s),c}async writeFile(i,r,s){let c;try{const u=this.toFilePath(i);if(!s.create||!s.overwrite){if(await d.Promises.exists(u)){if(!s.overwrite)throw(0,C.createFileSystemProviderError)((0,S.localize)(0,null),C.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,C.createFileSystemProviderError)((0,S.localize)(1,null),C.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(c,0,r,0,r.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(i,u)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(i){n.canFlush=i}async open(i,r){const s=this.toFilePath(i);let c;(0,C.isFileOpenForWriteOptions)(r)&&(c=await this.createResourceLock(i));let u;try{if((0,C.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:D}=await d.SymlinkSupport.stat(s);D.mode&128||await d.Promises.chmod(s,D.mode|128)}catch(D){this.logService.trace(D)}let P;if((0,C.isFileOpenForWriteOptions)(r)){if(b.isWindows)try{await d.Promises.truncate(s,0),P="r+"}catch(D){D.code!=="ENOENT"&&this.logService.trace(D)}P||(P="w")}else P="r";u=await d.Promises.open(s,P)}catch(P){throw c?.dispose(),(0,C.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(i,P):this.toFileSystemProviderError(P)}if(this.mapHandleToPos.set(u,0),(0,C.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(u,i),c){const P=this.mapHandleToLock.get(u);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${s})`),this.mapHandleToLock.set(u,c),P&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${s})`),P.dispose())}return u}async close(i){const r=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&n.canFlush)try{await d.Promises.fdatasync(i)}catch(s){n.configureFlushOnWrite(!1),this.logService.error(s)}return await d.Promises.close(i)}catch(s){throw this.toFileSystemProviderError(s)}finally{r&&(this.mapHandleToLock.get(i)===r&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),r.dispose())}}async read(i,r,s,c,u){const P=this.normalizePos(i,r);let D=null;try{D=(await d.Promises.read(i,s,c,u,P)).bytesRead}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(i,P,D)}return D}normalizePos(i,r){return r===this.mapHandleToPos.get(i)?null:r}updatePos(i,r,s){const c=this.mapHandleToPos.get(i);typeof c=="number"&&(typeof r=="number"||(typeof s=="number"?this.mapHandleToPos.set(i,c+s):this.mapHandleToPos.delete(i)))}async write(i,r,s,c,u){return(0,k.retry)(()=>this.doWrite(i,r,s,c,u),100,3)}async doWrite(i,r,s,c,u){const P=this.normalizePos(i,r);let D=null;try{D=(await d.Promises.write(i,s,c,u,P)).bytesWritten}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),T)}finally{this.updatePos(i,P,D)}return D}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(i,r){try{const s=this.toFilePath(i);r.recursive?await d.Promises.rm(s,d.RimRafMode.MOVE):await d.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(i,r,s){const c=this.toFilePath(i),u=this.toFilePath(r);if(c!==u)try{await this.validateTargetDeleted(i,r,"move",s.overwrite),await d.Promises.move(c,u)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,S.localize)(2,null,(0,I.basename)(c),(0,I.basename)((0,I.dirname)(u)),P.toString()))),this.toFileSystemProviderError(P)}}async copy(i,r,s){const c=this.toFilePath(i),u=this.toFilePath(r);if(c!==u)try{await this.validateTargetDeleted(i,r,"copy",s.overwrite),await d.Promises.copy(c,u,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,S.localize)(3,null,(0,I.basename)(c),(0,I.basename)((0,I.dirname)(u)),P.toString()))),this.toFileSystemProviderError(P)}}async validateTargetDeleted(i,r,s,c){const u=this.toFilePath(i),P=this.toFilePath(r);let D=!1;if(!!(this.capabilities&1024)||(D=(0,l.isEqual)(u,P,!0)),D&&s==="copy")throw(0,C.createFileSystemProviderError)((0,S.localize)(4,null),C.FileSystemProviderErrorCode.FileExists);if(!D&&await d.Promises.exists(P)){if(!c)throw(0,C.createFileSystemProviderError)((0,S.localize)(5,null),C.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(i,r){return this.doCloneFile(i,r,!1)}async doCloneFile(i,r,s){const c=this.toFilePath(i),u=this.toFilePath(r),P=!!(this.capabilities&1024);if((0,l.isEqual)(c,u,!P))return;const D=new m.DisposableStore;try{const[T,N]=await Promise.all([this.createResourceLock(i),this.createResourceLock(r)]);D.add(T),D.add(N),s&&await d.Promises.mkdir((0,I.dirname)(u),{recursive:!0}),await d.Promises.copyFile(c,u)}catch(T){if(T.code==="ENOENT"&&!s)return this.doCloneFile(i,r,!0);throw this.toFileSystemProviderError(T)}finally{D.dispose()}}createUniversalWatcher(i,r,s){return new g.UniversalWatcherClient(c=>i(c),c=>r(c),s)}createNonRecursiveWatcher(i,r,s){return new a.NodeJSWatcherClient(c=>i(c),c=>r(c),s)}toFileSystemProviderError(i){if(i instanceof C.FileSystemProviderError)return i;let r;switch(i.code){case"ENOENT":r=C.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=C.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=C.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=C.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=C.FileSystemProviderErrorCode.NoPermissions;break;default:r=C.FileSystemProviderErrorCode.Unknown}return(0,C.createFileSystemProviderError)(i,r)}async toFileSystemProviderWriteError(i,r){let s=this.toFileSystemProviderError(r);if(i&&s.code===C.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await d.SymlinkSupport.stat(this.toFilePath(i));c.mode&128||(s=(0,C.createFileSystemProviderError)(r,C.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return s}}e.DiskFileSystemProvider=n,n.canFlush=!0}),define(Z[205],ee([0,1,3,86,2,18,58,22]),function(q,e,v,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class l extends k.Disposable{constructor(b,y){super(),this.provider=b,this.logService=y,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(b,y,h){const d=this.getUriTransformer(b);switch(y){case"stat":return this.stat(d,h[0]);case"readdir":return this.readdir(d,h[0]);case"open":return this.open(d,h[0],h[1]);case"close":return this.close(h[0]);case"read":return this.read(h[0],h[1],h[2]);case"readFile":return this.readFile(d,h[0],h[1]);case"write":return this.write(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.writeFile(d,h[0],h[1],h[2]);case"rename":return this.rename(d,h[0],h[1],h[2]);case"copy":return this.copy(d,h[0],h[1],h[2]);case"cloneFile":return this.cloneFile(d,h[0],h[1]);case"mkdir":return this.mkdir(d,h[0]);case"delete":return this.delete(d,h[0],h[1]);case"watch":return this.watch(d,h[0],h[1],h[2],h[3]);case"unwatch":return this.unwatch(h[0],h[1])}throw new Error(`IPC Command ${y} not found`)}listen(b,y,h){const d=this.getUriTransformer(b);switch(y){case"fileChange":return this.onFileChange(d,h[0]);case"readFileStream":return this.onReadFileStream(d,h[0],h[1])}throw new Error(`Unknown event ${y}`)}stat(b,y){const h=this.transformIncoming(b,y,!0);return this.provider.stat(h)}readdir(b,y){const h=this.transformIncoming(b,y);return this.provider.readdir(h)}async readFile(b,y,h){const d=this.transformIncoming(b,y,!0),S=await this.provider.readFile(d,h);return R.VSBuffer.wrap(S)}onReadFileStream(b,y,h){const d=this.transformIncoming(b,y,!0),S=new E.CancellationTokenSource,C=new v.Emitter({onLastListenerRemove:()=>{S.cancel()}}),w=this.provider.readFileStream(d,h,S.token);return(0,M.listenStream)(w,{onData:p=>C.fire(R.VSBuffer.wrap(p)),onError:p=>C.fire(p),onEnd:()=>{C.fire("end"),C.dispose(),S.dispose()}}),C.event}writeFile(b,y,h,d){const S=this.transformIncoming(b,y);return this.provider.writeFile(S,h.buffer,d)}open(b,y,h){const d=this.transformIncoming(b,y,!0);return this.provider.open(d,h)}close(b){return this.provider.close(b)}async read(b,y,h){const d=R.VSBuffer.alloc(h),S=0,C=await this.provider.read(b,y,d.buffer,S,h);return[d,C]}write(b,y,h,d,S){return this.provider.write(b,y,h.buffer,d,S)}mkdir(b,y){const h=this.transformIncoming(b,y);return this.provider.mkdir(h)}delete(b,y,h){const d=this.transformIncoming(b,y);return this.provider.delete(d,h)}rename(b,y,h,d){const S=this.transformIncoming(b,y),C=this.transformIncoming(b,h);return this.provider.rename(S,C,d)}copy(b,y,h,d){const S=this.transformIncoming(b,y),C=this.transformIncoming(b,h);return this.provider.copy(S,C,d)}cloneFile(b,y,h){const d=this.transformIncoming(b,y),S=this.transformIncoming(b,h);return this.provider.cloneFile(d,S)}onFileChange(b,y){const h=new v.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(y,this.createSessionFileWatcher(b,h))},onLastListenerRemove:()=>{(0,k.dispose)(this.sessionToWatcher.get(y)),this.sessionToWatcher.delete(y)}});return h.event}async watch(b,y,h,d,S){const C=this.sessionToWatcher.get(y);if(C){const w=this.transformIncoming(b,d),p=C.watch(h,w,S);this.watchRequests.set(y+h,p)}}async unwatch(b,y){const h=b+y,d=this.watchRequests.get(h);d&&((0,k.dispose)(d),this.watchRequests.delete(h))}dispose(){super.dispose();for(const[,b]of this.watchRequests)b.dispose();this.watchRequests.clear();for(const[,b]of this.sessionToWatcher)b.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=l;class m extends k.Disposable{constructor(b,y,h,d){super(),this.uriTransformer=b,this.logService=h,this.environmentService=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(y)}registerListeners(b){const y=this._register(new v.Emitter);this._register(y.event(h=>{b.fire(h.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type})))})),this._register(this.fileWatcher.onDidChangeFile(h=>y.fire(h))),this._register(this.fileWatcher.onDidWatchError(h=>b.fire(h)))}getRecursiveWatcherOptions(b){}getExtraExcludes(b){}watch(b,y,h){const d=this.getExtraExcludes(this.environmentService);return Array.isArray(d)&&(h.excludes=[...h.excludes,...d]),this.watcherRequests.set(b,this.fileWatcher.watch(y,h)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.watcherRequests.get(b)),this.watcherRequests.delete(b)})}dispose(){super.dispose();for(const[,b]of this.watcherRequests)b.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=m}),define(Z[206],ee([0,1,15,161,4,7,14,9,205,140]),function(q,e,v,t,k,R,M,E,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class I extends l.AbstractDiskFileSystemProviderChannel{constructor(h,d,S){super(h,d),this.environmentService=S}getUriTransformer(h){return m.DefaultURITransformer}transformIncoming(h,d){return R.URI.revive(d)}async delete(h,d,S){if(!S.useTrash)return super.delete(h,d,S);const C=this.transformIncoming(h,d),w=(0,E.normalize)(C.fsPath);try{await v.shell.trashItem(w)}catch{throw(0,M.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,E.basename)(w)):(0,t.localize)(1,null,(0,E.basename)(w)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(h,d){return new b(h,d,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=I;class b extends l.AbstractSessionFileWatcher{watch(h,d,S){if(S.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(h,d,S)}}}),define(Z[106],ee([0,1,6]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,M){switch(M){case v.LogLevel.Trace:return R.trace;case v.LogLevel.Debug:return R.debug;case v.LogLevel.Info:return R.info;case v.LogLevel.Warning:return R.warn;case v.LogLevel.Error:return R.error;case v.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class k extends v.AbstractLogger{constructor(M=v.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(E=>{this._logger?.setLevel(E)}))}set logger(M){this._logger=M;for(const{level:E,args:l}of this.buffer)t(M,E).apply(M,l);this.buffer=[]}_log(M,...E){this._logger?t(this._logger,M).apply(this._logger,E):this.getLevel()<=M&&this.buffer.push({level:M,args:E})}trace(M,...E){this._log(v.LogLevel.Trace,M,...E)}debug(M,...E){this._log(v.LogLevel.Debug,M,...E)}info(M,...E){this._log(v.LogLevel.Info,M,...E)}warn(M,...E){this._log(v.LogLevel.Warning,M,...E)}error(M,...E){this._log(v.LogLevel.Error,M,...E)}critical(M,...E){this._log(v.LogLevel.Critical,M,...E)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=k}),define(Z[207],ee([0,1,8,18,16,14,5,106,6]),function(q,e,v,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const m=5*R.ByteSize.MB;let I=class extends l.AbstractLogger{constructor(h,d,S,C,w){super(),this.name=h,this.resource=d,this.donotUseFormatters=C,this.fileService=w,this.backupIndex=1,this.setLevel(S),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=l.LogLevel.Trace&&this._log(l.LogLevel.Trace,(0,l.format)(arguments))}debug(){this.getLevel()<=l.LogLevel.Debug&&this._log(l.LogLevel.Debug,(0,l.format)(arguments))}info(){this.getLevel()<=l.LogLevel.Info&&this._log(l.LogLevel.Info,(0,l.format)(arguments))}warn(){this.getLevel()<=l.LogLevel.Warning&&this._log(l.LogLevel.Warning,(0,l.format)(arguments))}error(){if(this.getLevel()<=l.LogLevel.Error){const h=arguments[0];if(h instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=h.stack,this._log(l.LogLevel.Error,(0,l.format)(d))}else this._log(l.LogLevel.Error,(0,l.format)(arguments))}}critical(){this.getLevel()<=l.LogLevel.Critical&&this._log(l.LogLevel.Critical,(0,l.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(h){if(h.fileOperationResult!==3)throw h}}_log(h,d){this.queue.queue(async()=>{await this.initializePromise;let S=await this.loadContent();S.length>m&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(S)),S=""),this.donotUseFormatters?S+=d:S+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(h)}] ${d}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(S))})}getCurrentTimestamp(){const h=C=>C<10?`0${C}`:C,d=C=>C<10?`00${C}`:C<100?`0${C}`:C,S=new Date;return`${S.getFullYear()}-${h(S.getMonth()+1)}-${h(S.getDate())} ${h(S.getHours())}:${h(S.getMinutes())}:${h(S.getSeconds())}.${d(S.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(h){switch(h){case l.LogLevel.Critical:return"critical";case l.LogLevel.Debug:return"debug";case l.LogLevel.Error:return"error";case l.LogLevel.Info:return"info";case l.LogLevel.Trace:return"trace";case l.LogLevel.Warning:return"warning"}return""}};I=ve([J(4,R.IFileService)],I),e.FileLogger=I;let b=class extends l.AbstractLoggerService{constructor(h,d,S){super(h.getLevel(),h.onDidChangeLogLevel),this.instantiationService=d,this.fileService=S}doCreateLogger(h,d,S){const C=new E.BufferLogService(d);return(0,R.whenProviderRegistered)(h,this.fileService).then(()=>C.logger=this.instantiationService.createInstance(I,S?.name||(0,k.basename)(h),h,C.getLevel(),!!S?.donotUseFormatters)),C}};b=ve([J(0,l.ILogService),J(1,M.IInstantiationService),J(2,R.IFileService)],b),e.FileLoggerService=b}),define(Z[208],ee([0,1,3,7,6]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(y){this.service=y,this.onDidChangeLogLevel=v.Event.buffer(y.onDidChangeLogLevel,!0)}listen(y,h){switch(h){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${h}`)}async call(y,h,d){switch(h){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${h}`)}}e.LogLevelChannel=R;class M{constructor(y){this.channel=y}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(y){M.setLevel(this.channel,y)}static setLevel(y,h){return y.call("setLevel",h)}}e.LogLevelChannelClient=M;class E{constructor(y){this.loggerService=y,this.loggers=new Map}listen(y,h){throw new Error(`Event not found: ${h}`)}async call(y,h,d){switch(h){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${h}`)}createLogger(y,h){this.loggers.set(y.toString(),this.loggerService.createLogger(y,h))}consoleLog(y,h){let d=console.log;switch(y){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...h)}log(y,h){const d=this.loggers.get(y.toString());if(!d)throw new Error("Create the logger before logging");for(const[S,C]of h)(0,k.log)(d,S,C)}}e.LoggerChannel=E;class l extends k.AbstractLoggerService{constructor(y,h,d){super(y,h),this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(y,h)=>{this.channel.call("consoleLog",[y,h])}})}doCreateLogger(y,h,d){return new m(this.channel,y,h,d)}}e.LoggerChannelClient=l;class m extends k.AbstractMessageLogger{constructor(y,h,d,S){super(S?.always),this.channel=y,this.file=h,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[h,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,h){const d=[[y,h]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(y){this.channel.call("log",[this.file,y])}}class I extends k.LogService{constructor(y,h){super(h),this.parent=y,this._register(y.onDidChangeLogLevel(d=>h.setLevel(d)))}setLevel(y){super.setLevel(y),this.parent.setLevel(y)}}e.FollowerLogService=I}),define(Z[107],ee([0,1,14,6]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(E,l,m,I,b){try{const y=await new Promise((d,S)=>{q(["spdlog"],d,S)});y.setFlushOn(t.LogLevel.Trace);const h=await y.createAsyncRotatingLogger(E,l,m,I);return b&&h.clearFormatters(),h}catch(y){console.error(y)}return null}function R(E,l,m){switch(l){case t.LogLevel.Trace:E.trace(m);break;case t.LogLevel.Debug:E.debug(m);break;case t.LogLevel.Info:E.info(m);break;case t.LogLevel.Warning:E.warn(m);break;case t.LogLevel.Error:E.error(m);break;case t.LogLevel.Critical:E.critical(m);break;default:throw new Error("Invalid log level")}}class M extends t.AbstractMessageLogger{constructor(l,m,I,b,y){super(),this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(l,m,I,b),this._register(this.onDidChangeLogLevel(h=>{this._logger?.setLevel(h)}))}async _createSpdLogLogger(l,m,I,b){const y=I?6:1,h=30/y*v.ByteSize.MB,d=await k(l,m,h,y,b);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:S,message:C}of this.buffer)R(this._logger,S,C);this.buffer=[]}}log(l,m){this._logger?R(this._logger,l,m):this.getLevel()<=l&&this.buffer.push({level:l,message:m})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=M}),define(Z[209],ee([0,1,13,16,29,14,207,6,107]),function(q,e,v,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let m=class extends E.AbstractLoggerService{constructor(b,y){super(b.getLevel(),b.onDidChangeLogLevel),this.fileService=y}doCreateLogger(b,y,h){return b.scheme===v.Schemas.file?new l.SpdLogLogger(h?.name||(0,k.generateUuid)(),b.fsPath,!h?.donotRotate,!!h?.donotUseFormatters,y):new M.FileLogger(h?.name??(0,t.basename)(b),b,y,!!h?.donotUseFormatters,this.fileService)}};m=ve([J(0,E.ILogService),J(1,R.IFileService)],m),e.LoggerService=m}),define(Z[210],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function t(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(M){return!v(M)&&!t(M)&&!k(M)}e.isMenubarMenuItemAction=R}),define(Z[37],ee([0,1,3,57,2,5]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class M extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(m){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...m,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(m),t.Iterable.reduce(this.policies.entries(),(b,[y,h])=>({...b,[y]:h}),{})}getPolicyValue(m){return this.policies.get(m)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(m,[I,b])=>({...m,[I]:{definition:b,value:this.policies.get(I)}}),{})}}e.AbstractPolicyService=M;class E{constructor(){this.onDidChange=v.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=E}),define(Z[211],ee([0,1,8,3,57,12,14,6,37]),function(q,e,v,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function m(b,y){const h=[];for(const d of k.Iterable.concat(b.keys(),y.keys()))b.get(d)!==y.get(d)&&h.push(d);return h}let I=class extends l.AbstractPolicyService{constructor(y,h,d){super(),this.file=y,this.fileService=h,this.logService=d,this.throttledDelayer=this._register(new v.ThrottledDelayer(500));const S=t.Event.filter(h.onDidFilesChange,C=>C.affects(y));this._register(h.watch(y)),this._register(S(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(y){await this.refresh()}async read(){const y=new Map;try{const h=await this.fileService.readFile(this.file),d=JSON.parse(h.value.toString());if(!(0,R.isObject)(d))throw new Error("Policy file isn't a JSON object");for(const S of Object.keys(d))this.policyDefinitions[S]&&y.set(S,d[S])}catch(h){h.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",h)}return y}async refresh(){const y=await this.read(),h=m(this.policies,y);this.policies=y,h.length>0&&this._onDidChange.fire(h)}};I=ve([J(1,M.IFileService),J(2,E.ILogService)],I),e.FilePolicyService=I}),define(Z[212],ee([0,1,3,2,37]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(l){this.service=l,this.disposables=new t.DisposableStore}listen(l,m){switch(m){case"onDidChange":return v.Event.map(this.service.onDidChange,I=>I.reduce((b,y)=>({...b,[y]:this.service.getPolicyValue(y)??null}),{}),this.disposables)}throw new Error(`Event not found: ${m}`)}call(l,m,I){switch(m){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(I)}throw new Error(`Call not found: ${m}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class M extends k.AbstractPolicyService{constructor(l,m){super(),this.channel=m;for(const I in l){const{definition:b,value:y}=l[I];this.policyDefinitions[I]=b,y!==void 0&&this.policies.set(I,y)}this.channel.listen("onDidChange")(I=>{for(const b in I){const y=I[b];y===null?this.policies.delete(b):this.policies.set(b,y)}this._onDidChange.fire(Object.keys(I))})}async initializePolicies(l){const m=await this.channel.call("registerPolicyDefinitions",l);for(const I in m)this.policies.set(I,m[I])}}e.PolicyChannelClient=M}),define(Z[54],ee([0,1,13,4,33,16]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const E=t.globals.vscode.context.configuration();if(E)M=E.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof q?.__$__nodeRequire=="function"){const E=(0,R.dirname)(v.FileAccess.asFileUri("",q));M=q.__$__nodeRequire((0,R.joinPath)(E,"product.json").fsPath);const l=q.__$__nodeRequire((0,R.joinPath)(E,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),Object.assign(M,{version:l.version})}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=M}),define(Z[20],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[213],ee([0,1,76,6,20]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(E,l){this.productService=E,this.logService=l,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(E,l){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(l);if(!m)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",l),!1;const[,I,b]=m;let y=this.trustedExtensionUrlPublicKeys.get(E);if(!y){if(y=this.productService.trustedExtensionUrlPublicKeys[E],!y||y.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",E),!1;this.trustedExtensionUrlPublicKeys.set(E,[...y])}const h=Buffer.from(decodeURIComponent(b),"base64");if(h.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",l),!1;const d=h.slice(0,6),S=h.readUIntBE(0,6),C=Date.now()-S;if(C<0||C>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",l),!1;const w=h.slice(6),p=v.createVerify("SHA256");p.write(d),p.write(Buffer.from(I)),p.end();for(let f=0;f<y.length;f++){let g=y[f];if(g!==null){if(typeof g=="string")try{g=v.createPublicKey({key:Buffer.from(g,"base64"),format:"der",type:"spki"}),y[f]=g}catch(a){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${f+1} for ${E}:`,a),y[f]=null;continue}if(p.verify(g,w))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",l),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",l),!1}};R=ve([J(0,k.IProductService),J(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(Z[61],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(Z[47],ee([0,1,121,12]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(M,E){v.ok(t.isString(M)),v.ok(t.isObject(E)),v.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,E)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new k}),define(Z[214],ee([0,1,3,47]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class R{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,m){this.schemasById[k(l)]=m,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new R;t.Registry.add(e.Extensions.JSONContribution,M)}),define(Z[62],ee([0,1,24,3,12,149,19,214,47]),function(q,e,v,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=l.Registry.as(E.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,o=!0){this.registerConfigurations([n],o)}registerConfigurations(n,o=!0){const i=this.doRegisterConfigurations(n,o);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(n){const o=this.doDeregisterConfigurations(n);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:n,remove:o}){const i=[];i.push(...this.doDeregisterConfigurations(o)),i.push(...this.doRegisterConfigurations(n,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,v.distinct)(i)})}registerDefaultConfigurations(n){const o=[],i=[];for(const{overrides:r,source:s}of n)for(const c in r)if(o.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const u=this.configurationDefaultsOverrides.get(c),P=u?.valuesSources??new Map;if(s)for(const U of Object.keys(r[c]))P.set(U,s);const D={...u?.value||{},...r[c]};this.configurationDefaultsOverrides.set(c,{source:s,value:D,valuesSources:P});const T=(0,M.getLanguageTagSettingPlainKey)(c),N={type:"object",default:D,description:R.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:k.isString(s)?void 0:s,defaultValueSource:s};i.push(...S(c)),this.configurationProperties[c]=N,this.defaultLanguageConfigurationOverridesNode.properties[c]=N}else{this.configurationDefaultsOverrides.set(c,{value:r[c],source:s});const u=this.configurationProperties[c];u&&(this.updatePropertyDefaultValue(c,u),this.updateSchema(c,u))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const o=[];for(const{overrides:i,source:r}of n)for(const s in i){const c=this.configurationDefaultsOverrides.get(s),u=k.isString(r)?r:r?.id,P=k.isString(c?.source)?c?.source:c?.source?.id;if(u===P)if(o.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const D=this.configurationProperties[s];D&&(this.updatePropertyDefaultValue(s,D),this.updateSchema(s,D))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const o of n)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,o){const i=[];return n.forEach(r=>{i.push(...this.validateAndRegisterProperties(r,o,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),i}doDeregisterConfigurations(n){const o=[],i=r=>{if(r.properties)for(const s in r.properties){o.push(s);const c=this.configurationProperties[s];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,r.properties[s])}r.allOf?.forEach(s=>i(s))};for(const r of n){i(r);const s=this.configurationContributors.indexOf(r);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(n,o=!0,i,r,s=3){s=k.isUndefinedOrNull(n.scope)?s:n.scope;const c=[],u=n.properties;if(u)for(const D in u){const T=u[D];if(o&&f(D,T)){delete u[D];continue}if(T.source=i,T.defaultDefaultValue=u[D].default,this.updatePropertyDefaultValue(D,T),e.OVERRIDE_PROPERTY_REGEX.test(D)?T.scope=void 0:(T.scope=k.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=k.isUndefinedOrNull(T.restricted)?!!r?.includes(D):T.restricted),u[D].hasOwnProperty("included")&&!u[D].included){this.excludedConfigurationProperties[D]=u[D],delete u[D];continue}else this.configurationProperties[D]=u[D],u[D].policy?.name&&this.policyConfigurations.set(u[D].policy.name,D);!u[D].deprecationMessage&&u[D].markdownDeprecationMessage&&(u[D].deprecationMessage=u[D].markdownDeprecationMessage),c.push(D)}const P=n.allOf;if(P)for(const D of P)c.push(...this.validateAndRegisterProperties(D,o,i,r,s));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const o=i=>{const r=i.properties;if(r)for(const c in r)this.updateSchema(c,r[c]);i.allOf?.forEach(o)};o(n)}updateSchema(n,o){switch(e.allSettings.properties[n]=o,o.scope){case 1:e.applicationSettings.properties[n]=o;break;case 2:e.machineSettings.properties[n]=o;break;case 6:e.machineOverridableSettings.properties[n]=o;break;case 3:e.windowSettings.properties[n]=o;break;case 4:e.resourceSettings.properties[n]=o;break;case 5:e.resourceSettings.properties[n]=o,this.resourceLanguageSettingsSchema.properties[n]=o;break}}removeFromSchema(n,o){switch(delete e.allSettings.properties[n],o.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const o=`[${n}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,i),e.allSettings.properties[o]=i,e.applicationSettings.properties[o]=i,e.machineSettings.properties[o]=i,e.machineOverridableSettings.properties[o]=i,e.windowSettings.properties[o]=i,e.resourceSettings.properties[o]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,o){const i=this.configurationDefaultsOverrides.get(n);let r=i?.value,s=i?.source;k.isUndefined(r)&&(r=o.defaultDefaultValue,s=void 0),k.isUndefined(r)&&(r=w(o.type)),o.default=r,o.defaultValueSource=s}}const h="\\[([^\\]]+)\\]",d=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(a){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let o=d.exec(a);for(;o?.length;){const i=o[1].trim();i&&n.push(i),o=d.exec(a)}}return(0,v.distinct)(n)}e.overrideIdentifiersFromKey=S;function C(a){return a.reduce((n,o)=>`${n}[${o}]`,"")}e.keyFromOverrideIdentifiers=C;function w(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=w;const p=new y;l.Registry.add(e.Extensions.Configuration,p);function f(a,n){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?R.localize(7,null,a):p.getConfigurationProperties()[a]!==void 0?R.localize(8,null,a):n.policy?.name&&p.getPolicyConfigurations().get(n.policy?.name)!==void 0?R.localize(9,null,a,n.policy?.name,p.getPolicyConfigurations().get(n.policy?.name)):null:R.localize(6,null)}e.validateProperty=f;function g(){const a=[],n=p.getConfigurationProperties();for(const o of Object.keys(n))a.push([o,n[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=g}),define(Z[108],ee([0,1,24,3,43,2,31,50,12,7,19,62,47]),function(q,e,v,t,k,R,M,E,l,m,I,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class h{constructor(n={},o=[],i=[]){this._contents=n,this._keys=o,this._overrides=i,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,I.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,o){const i=this.getContentsForOverrideIdentifer(o);return i?n?(0,I.getConfigurationValue)(i,n):i:void 0}getKeysForOverrideIdentifier(n){const o=[];for(const i of this.overrides)i.identifiers.includes(n)&&o.push(...i.keys);return v.distinct(o)}getAllOverrideIdentifiers(){const n=[];for(const o of this.overrides)n.push(...o.identifiers);return v.distinct(n)}override(n){let o=this.overrideConfigurations.get(n);return o||(o=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,o)),o}merge(...n){const o=E.deepClone(this.contents),i=E.deepClone(this.overrides),r=[...this.keys];for(const s of n)if(!s.isEmpty()){this.mergeContents(o,s.contents);for(const c of s.overrides){const[u]=i.filter(P=>v.equals(P.identifiers,c.identifiers));u?(this.mergeContents(u.contents,c.contents),u.keys.push(...c.keys),u.keys=v.distinct(u.keys)):i.push(E.deepClone(c))}for(const c of s.keys)r.indexOf(c)===-1&&r.push(c)}return new h(o,r,i)}freeze(){return this.frozen=!0,this}clone(){return new h(E.deepClone(this.contents),[...this.keys],E.deepClone(this.overrides))}createOverrideConfigurationModel(n){const o=this.getContentsForOverrideIdentifer(n);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const i={};for(const r of v.distinct([...Object.keys(this.contents),...Object.keys(o)])){let s=this.contents[r];const c=o[r];c&&(typeof s=="object"&&typeof c=="object"?(s=E.deepClone(s),this.mergeContents(s,c)):s=c),i[r]=s}return new h(i,this.keys,this.overrides)}mergeContents(n,o){for(const i of Object.keys(o)){if(i in n&&l.isObject(n[i])&&l.isObject(o[i])){this.mergeContents(n[i],o[i]);continue}n[i]=E.deepClone(o[i])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?E.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let o=null,i=null;const r=s=>{s&&(i?this.mergeContents(i,s):i=E.deepClone(s))};for(const s of this.overrides)v.equals(s.identifiers,[n])?o=s.contents:s.identifiers.includes(n)&&r(s.contents);return r(o),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,o){this.addKey(n),(0,I.addToValueTree)(this.contents,n,o,i=>{throw new Error(i)})}removeValue(n){this.removeKey(n)&&(0,I.removeFromValueTree)(this.contents,n)}addKey(n){let o=this.keys.length;for(let i=0;i<o;i++)n.indexOf(this.keys[i])===0&&(o=i);this.keys.splice(o,1,n)}removeKey(n){const o=this.keys.indexOf(n);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=h;class d{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,o){if(!l.isUndefinedOrNull(n)){const i=this.doParseContent(n);this.parseRaw(i,o)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,o){this._raw=n;const{contents:i,keys:r,overrides:s,restricted:c}=this.doParseRaw(n,o);this._configurationModel=new h(i,r,s),this._restrictedConfigurations=c||[]}doParseContent(n){let o={},i=null,r=[];const s=[],c=[];function u(D){Array.isArray(r)?r.push(D):i!==null&&(r[i]=D)}const P={onObjectBegin:()=>{const D={};u(D),s.push(r),r=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const D=[];u(D),s.push(r),r=D,i=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:u,onError:(D,T,N)=>{c.push({error:D,offset:T,length:N})}};if(n)try{k.visit(n,P),o=r[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return o}doParseRaw(n,o){const i=y.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),r=this.filter(n,i,!0,o);n=r.raw;const s=(0,I.toValuesTree)(n,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),c=Object.keys(n),u=this.toOverrides(n,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:s,keys:c,overrides:u,restricted:r.restricted}}filter(n,o,i,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:n,restricted:[]};const s={},c=[];for(const u in n)if(b.OVERRIDE_PROPERTY_REGEX.test(u)&&i){const P=this.filter(n[u],o,!1,r);s[u]=P.raw,c.push(...P.restricted)}else{const P=o[u],D=P?typeof P.scope<"u"?P.scope:3:void 0;P?.restricted&&c.push(u),(D===void 0||r.scopes===void 0||r.scopes.includes(D))&&(r.skipRestricted&&P?.restricted||(s[u]=n[u]))}return{raw:s,restricted:c}}toOverrides(n,o){const i=[];for(const r of Object.keys(n))if(b.OVERRIDE_PROPERTY_REGEX.test(r)){const s={};for(const c in n[r])s[c]=n[r][c];i.push({identifiers:(0,b.overrideIdentifiersFromKey)(r),keys:Object.keys(s),contents:(0,I.toValuesTree)(s,o)})}return i}}e.ConfigurationModelParser=d;class S extends R.Disposable{constructor(n,o,i,r){super(),this.userSettingsResource=n,this.scopes=o,this.fileService=r,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&i.isEqual(s.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class C{constructor(n,o,i,r,s=new h,c=new h,u=new M.ResourceMap,P=new h,D=new M.ResourceMap,T=!0){this._defaultConfiguration=n,this._policyConfiguration=o,this._applicationConfiguration=i,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=c,this._folderConfigurations=u,this._memoryConfiguration=P,this._memoryConfigurationByResource=D,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(n,o,i){return this.getConsolidatedConfigurationModel(n,o,i).getValue(n)}updateValue(n,o,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new h,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,o===void 0?r.removeValue(n):r.setValue(n,o),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,o,i){const r=this.getConsolidatedConfigurationModel(n,o,i),s=this.getFolderConfigurationModelForResource(o.resource,i),c=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,u=o.overrideIdentifier?this._defaultConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),P=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(n),D=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(n),T=o.overrideIdentifier?this.userConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),N=o.overrideIdentifier?this.localUserConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),U=o.overrideIdentifier?this.remoteUserConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),$=i?o.overrideIdentifier?this._workspaceConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,Y=s?o.overrideIdentifier?s.freeze().override(o.overrideIdentifier).getValue(n):s.freeze().getValue(n):void 0,oe=o.overrideIdentifier?c.override(o.overrideIdentifier).getValue(n):c.getValue(n),ue=r.getValue(n),se=v.distinct(r.overrides.map(de=>de.identifiers).flat()).filter(de=>r.getOverrideValue(n,de)!==void 0);return{defaultValue:u,policyValue:P,applicationValue:D,userValue:T,userLocalValue:N,userRemoteValue:U,workspaceValue:$,workspaceFolderValue:Y,memoryValue:oe,value:ue,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,policy:P!==void 0?{value:P}:void 0,application:D!==void 0?{value:D,override:o.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,workspace:$!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,workspaceFolder:Y!==void 0?{value:s?.freeze().getValue(n),override:o.overrideIdentifier?s?.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,memory:oe!==void 0?{value:c.getValue(n),override:o.overrideIdentifier?c.getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(n){const o=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,o){this._folderConfigurations.set(n,o),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,o){const i=[];if(!o){const{added:r,updated:s,removed:c}=f(this._defaultConfiguration,n);o=[...r,...s,...c]}for(const r of o)for(const s of(0,b.overrideIdentifiersFromKey)(r)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(s),u=n.getKeysForOverrideIdentifier(s),P=[...u.filter(D=>c.indexOf(D)===-1),...c.filter(D=>u.indexOf(D)===-1),...c.filter(D=>!E.equals(this._defaultConfiguration.override(s).getValue(D),n.override(s).getValue(D)))];i.push([s,P])}return this.updateDefaultConfiguration(n),{keys:o,overrides:i}}compareAndUpdatePolicyConfiguration(n){const{added:o,updated:i,removed:r}=f(this._policyConfiguration,n),s=[...o,...i,...r];return s.length&&this.updatePolicyConfiguration(n),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:o,updated:i,removed:r,overrides:s}=f(this.applicationConfiguration,n),c=[...o,...i,...r];return c.length&&this.updateApplicationConfiguration(n),{keys:c,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:o,updated:i,removed:r,overrides:s}=f(this.localUserConfiguration,n),c=[...o,...i,...r];return c.length&&this.updateLocalUserConfiguration(n),{keys:c,overrides:s}}compareAndUpdateRemoteUserConfiguration(n){const{added:o,updated:i,removed:r,overrides:s}=f(this.remoteUserConfiguration,n),c=[...o,...i,...r];return c.length&&this.updateRemoteUserConfiguration(n),{keys:c,overrides:s}}compareAndUpdateWorkspaceConfiguration(n){const{added:o,updated:i,removed:r,overrides:s}=f(this.workspaceConfiguration,n),c=[...o,...i,...r];return c.length&&this.updateWorkspaceConfiguration(n),{keys:c,overrides:s}}compareAndUpdateFolderConfiguration(n,o){const i=this.folderConfigurations.get(n),{added:r,updated:s,removed:c,overrides:u}=f(i,o),P=[...r,...s,...c];return(P.length||!i)&&this.updateFolderConfiguration(n,o),{keys:P,overrides:u}}compareAndDeleteFolderConfiguration(n){const o=this.folderConfigurations.get(n);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:i,updated:r,removed:s,overrides:c}=f(o,void 0);return{keys:[...i,...r,...s],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,o,i){let r=this.getConsolidatedConfigurationModelForResource(o,i);return o.overrideIdentifier&&(r=r.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:n},o){let i=this.getWorkspaceConsolidatedConfiguration();if(o&&n){const r=o.getFolder(n);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const s=this._memoryConfigurationByResource.get(n);s&&(i=i.merge(s))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let o=this._foldersConsolidatedConfigurations.get(n);if(!o){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(n);r?(o=i.merge(r),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(n,o)):o=i}return o}getFolderConfigurationModelForResource(n,o){if(o&&n){const i=o.getFolder(n);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,o)=>{const{contents:i,overrides:r,keys:s}=this._folderConfigurations.get(o);return n.push([o,{contents:i,overrides:r,keys:s}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>n.add(o)),this.userConfiguration.freeze().keys.forEach(o=>n.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(i=>n.add(i))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>n.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>o.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>o.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>o.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(n).forEach(r=>o.add(r))),[...o.values()]}static parse(n){const o=this.parseConfigurationModel(n.defaults),i=this.parseConfigurationModel(n.policy),r=this.parseConfigurationModel(n.application),s=this.parseConfigurationModel(n.user),c=this.parseConfigurationModel(n.workspace),u=n.folders.reduce((P,D)=>(P.set(m.URI.revive(D[0]),this.parseConfigurationModel(D[1])),P),new M.ResourceMap);return new C(o,i,r,s,new h,c,u,new h,new M.ResourceMap,!1)}static parseConfigurationModel(n){return new h(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=C;function w(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,o=new Map;for(const r of a)r.keys.forEach(s=>n.add(s)),r.overrides.forEach(([s,c])=>{const u=(0,M.getOrSet)(o,s,new Set);c.forEach(P=>u.add(P))});const i=[];return o.forEach((r,s)=>i.push([s,[...r.values()]])),{keys:[...n.values()],overrides:i}}e.mergeChanges=w;class p{constructor(n,o,i,r){this.change=n,this.previous=o,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const s=new Set;n.keys.forEach(u=>s.add(u)),n.overrides.forEach(([,u])=>u.forEach(P=>s.add(P))),this.affectedKeys=[...s.values()];const c=new h;this.affectedKeys.forEach(u=>c.setValue(u,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(o){const i=this.previousConfiguration?this.previousConfiguration.getValue(n,o,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(n,o,this.currentWorkspace);return!E.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(n,o){let i=(0,I.toValuesTree)({[o]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(n=n[r],!n)return!1;i=i[r]}return!0}}e.ConfigurationChangeEvent=p;function f(a,n){const{added:o,removed:i,updated:r}=g(n,a),s=[],c=a?.getAllOverrideIdentifiers()||[],u=n?.getAllOverrideIdentifiers()||[];if(n){const P=u.filter(D=>!c.includes(D));for(const D of P)s.push([D,n.getKeysForOverrideIdentifier(D)])}if(a){const P=c.filter(D=>!u.includes(D));for(const D of P)s.push([D,a.getKeysForOverrideIdentifier(D)])}if(n&&a){for(const P of c)if(u.includes(P)){const D=g({contents:a.getOverrideValue(void 0,P)||{},keys:a.getKeysForOverrideIdentifier(P)},{contents:n.getOverrideValue(void 0,P)||{},keys:n.getKeysForOverrideIdentifier(P)});s.push([P,[...D.added,...D.removed,...D.updated]])}}return{added:o,removed:i,updated:r,overrides:s}}function g(a,n){const o=a?n?a.keys.filter(s=>n.keys.indexOf(s)===-1):[...a.keys]:[],i=n?a?n.keys.filter(s=>a.keys.indexOf(s)===-1):[...n.keys]:[],r=[];if(a&&n){for(const s of n.keys)if(a.keys.indexOf(s)!==-1){const c=(0,I.getConfigurationValue)(n.contents,s),u=(0,I.getConfigurationValue)(a.contents,s);E.equals(c,u)||r.push(s)}}return{added:o,removed:i,updated:r}}}),define(Z[215],ee([0,1,24,3,2,50,12,19,108,62,6,37,47]),function(q,e,v,t,k,R,M,E,l,m,I,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class h extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(y.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:f})=>this.onDidUpdateConfiguration(p,f))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(p,f){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:p})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=h;class d extends l.ConfigurationModel{constructor(p={}){const f=y.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),g=Object.keys(f),a=Object.create(null),n=[];for(const o in f){const i=p[o],r=i!==void 0?i:f[o].default;(0,E.addToValueTree)(a,o,r,s=>console.error(`Conflict in default settings: ${s}`))}for(const o of Object.keys(a))m.OVERRIDE_PROPERTY_REGEX.test(o)&&n.push({identifiers:(0,m.overrideIdentifiersFromKey)(o),keys:Object.keys(a[o]),contents:(0,E.toValuesTree)(a[o],i=>console.error(`Conflict in default settings file: ${i}`))});super(a,g,n)}}e.DefaultConfigurationModel=d;class S{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new l.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let C=class extends k.Disposable{constructor(p,f,g){super(),this.defaultConfiguration=p,this.policyService=f,this.logService=g,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new l.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(p=>this.onDidChangePolicies(p))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:p})=>this.update(await this.registerPolicyDefinitions(p),!0))),this._configurationModel}async registerPolicyDefinitions(p){const f={},g=[],a=y.Registry.as(m.Extensions.Configuration).getConfigurationProperties();for(const n of p){const o=a[n];if(!o){g.push(n);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}g.push(n),f[o.policy.name]={type:o.type}}}return(0,M.isEmptyObject)(f)||await this.policyService.registerPolicyDefinitions(f),g}onDidChangePolicies(p){const f=y.Registry.as(m.Extensions.Configuration).getPolicyConfigurations(),g=(0,v.coalesce)(p.map(a=>f.get(a)));this.update(g,!0)}update(p,f){const g=y.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),a=[],n=this._configurationModel.isEmpty();for(const o of p){const i=g[o]?.policy?.name;if(i){const r=this.policyService.getPolicyValue(i);(n?r!==void 0:!(0,R.equals)(this._configurationModel.getValue(o),r))&&a.push([o,r])}else this._configurationModel.getValue(o)!==void 0&&a.push([o,void 0])}if(a.length){const o=this._configurationModel;this._configurationModel=new l.ConfigurationModel;for(const i of o.keys)this._configurationModel.setValue(i,o.getValue(i));for(const[i,r]of a)r===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,r);f&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};C=ve([J(1,b.IPolicyService),J(2,I.ILogService)],C),e.PolicyConfiguration=C}),define(Z[216],ee([0,1,8,3,2,16,19,108,215,37]),function(q,e,v,t,k,R,M,E,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends k.Disposable{constructor(y,h,d,S){super(),this.settingsResource=y,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new l.DefaultConfiguration),this.policyConfiguration=d instanceof m.NullPolicyService?new l.NullPolicyConfiguration:this._register(new l.PolicyConfiguration(this.defaultConfiguration,d,S)),this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,h)),this.configuration=new E.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new E.ConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:C,properties:w})=>this.onDidDefaultConfigurationChange(C,w))),this._register(this.policyConfiguration.onDidChangeConfiguration(C=>this.onDidPolicyConfigurationChange(C))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[y,h,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new E.Configuration(y,h,new E.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(y,h){const d=typeof y=="string"?y:void 0,S=(0,M.isConfigurationOverrides)(y)?y:(0,M.isConfigurationOverrides)(h)?h:{};return this.configuration.getValue(d,S,void 0)}updateValue(y,h,d,S){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const h=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(d,h,2)}onDidDefaultConfigurationChange(y,h){const d=this.configuration.toData(),S=this.configuration.compareAndUpdateDefaultConfiguration(y,h);this.trigger(S,d,7)}onDidPolicyConfigurationChange(y){const h=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(y);this.trigger(d,h,7)}trigger(y,h,d){const S=new E.ConfigurationChangeEvent(y,{data:h},this.configuration);S.source=d,S.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(y){switch(y){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(Z[217],ee([0,1,17,5]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends v.ErrorNoTelemetry{constructor(E,l=k.Unknown,m){super(E),this._message=E,this._code=l,this._detail=m,this.isHandled=l===k.NotAvailable&&m===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(E){return E instanceof R&&E._code===k.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof R&&E._code===k.NoResolverFound}static isHandled(E){return E instanceof R&&E.isHandled}}e.RemoteAuthorityResolverError=R}),define(Z[63],ee([0,1,13]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(m){return m.scheme===v.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=t;function k(m){if(!m)return;const I=m.indexOf("+");return I<0?m:m.substr(0,I)}e.getRemoteName=k;function R(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=R;function M(m){const{host:I,port:b}=l(m);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:b}}e.parseAuthorityWithPort=M;function E(m,I){let{host:b,port:y}=l(m);return typeof y>"u"&&(y=I),{host:b,port:y}}e.parseAuthorityWithOptionalPort=E;function l(m){const I=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const b=m.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const y=m.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:m,port:void 0}}}),define(Z[109],ee([0,1,25,5,63]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=R;function M(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));var l;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(l=e.TargetPlatform||(e.TargetPlatform={}));class m{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,C){if(typeof S>"u"||S===null)return typeof C>"u"||C===null;if(typeof C>"u"||C===null)return!1;if(typeof S=="string"||typeof C=="string"){const w=typeof S=="string"?S:S.value,p=typeof C=="string"?C:C.value;return v.equalsIgnoreCase(w,p)}return S._lower===C._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=m;function I(d){return b(d)}e.isApplicationScopedExtension=I;function b(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function y(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function h(d,S){if(S){const C=`onResolveRemoteAuthority:${(0,k.getRemoteName)(S)}`;return d.activationEvents?.indexOf(C)!==-1}return!1}e.isResolverExtension=h,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[110],ee([0,1,25,192,109,4,7,17,33]),function(q,e,v,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function m(o,i){return o.uuid&&i.uuid?o.uuid===i.uuid:o.id===i.id?!0:(0,v.compareIgnoreCase)(o.id,i.id)===0}e.areSameExtensions=m;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{constructor(i,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=i.id}static create(i){const r=i.manifest?i.manifest.version:i.version,s=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,r,s)}static parse(i){const r=I.exec(i);return r&&r[1]&&r[2]?new b({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?m(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=b;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(o){const i=y.exec(o);return i&&i[1]?[S(i[1]),i[2]]:[S(o),void 0]}e.getIdAndVersion=h;function d(o,i){return`${o}.${i}`}e.getExtensionId=d;function S(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function C(o,i){return S(d(o,i))}e.getGalleryExtensionId=C;function w(o,i){const r=[],s=c=>{for(const u of r)if(u.some(P=>m(i(P),i(c))))return u;return null};for(const c of o){const u=s(c);u?u.push(c):r.push([c])}return r}e.groupByExtension=w;function p(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function f(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function g(o,i){const r=[],s=i.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const c=s.shift();if(c&&r.every(u=>!m(u.identifier,{id:c}))){const u=o.filter(P=>m(P.identifier,{id:c}));u.length===1&&(r.push(u[0]),s.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=g;async function a(o,i){if(!R.isLinux)return!1;let r;try{r=(await o.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await o.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,E.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=a;async function n(o,i){const r=await a(o,i),s=(0,t.getTargetPlatform)(r?"alpine":R.platform,l.arch);return i.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=n}),define(Z[72],ee([0,1,8,18,2,31,7,110,14,5,6]),function(q,e,v,t,k,R,M,E,l,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,m.createDecorator)("IExtensionsProfileScannerService");let b=class extends k.Disposable{constructor(h,d){super(),this.fileService=h,this.logService=d,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(h){return this.withProfileExtensions(h)}addExtensionsToProfile(h,d){return this.withProfileExtensions(d,S=>(S=S.filter(C=>h.some(([w])=>!(0,E.areSameExtensions)(C.identifier,w.identifier))),S.push(...h.map(([C,w])=>({identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:w}))),S))}removeExtensionFromProfile(h,d){return this.withProfileExtensions(d,S=>S.filter(C=>!(0,E.areSameExtensions)(C.identifier,h)))}async withProfileExtensions(h,d){return this.getResourceAccessQueue(h).queue(async()=>{let S=[];try{const C=await this.fileService.readFile(h),w=JSON.parse(C.value.toString());for(const p of w){if(!p.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",p);continue}if(!p.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",p);continue}if(!p.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",p);continue}S.push({identifier:p.identifier,location:M.URI.revive(p.location),version:p.version,metadata:p.metadata})}}catch(C){C.fileOperationResult!==1&&this.logService.error(C)}if(d){S=d(S);const C=S.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),metadata:w.metadata}));await this.fileService.writeFile(h,t.VSBuffer.fromString(JSON.stringify(C)))}return S})}getResourceAccessQueue(h){let d=this.resourcesAccessQueueMap.get(h);return d||(d=new v.Queue,this.resourcesAccessQueueMap.set(h,d)),d}};b=ve([J(0,l.IFileService),J(1,I.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(Z[218],ee([0,1,8,18,22,17,3,2,29,99,217,63]),function(q,e,v,t,k,R,M,E,l,m,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var h;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(h=e.ConnectionType||(e.ConnectionType={}));function d(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function S(B){const H=new k.CancellationTokenSource;return setTimeout(()=>H.cancel(),B),H.token}function C(B,H){if(B.isCancellationRequested||H.isCancellationRequested)return k.CancellationToken.Cancelled;const L=new k.CancellationTokenSource;return B.onCancellationRequested(()=>L.cancel()),H.onCancellationRequested(()=>L.cancel()),L.token}class w{constructor(H){this._state="pending",this._disposables=new E.DisposableStore,this.promise=new Promise((L,O)=>{this._resolvePromise=L,this._rejectPromise=O}),H.isCancellationRequested?this._timeout():this._disposables.add(H.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(H){this._state==="pending"?this._disposables.add(H):H.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const H=new Error("Time limit reached");return H.code="ETIMEDOUT",H.syscall="connect",H}resolve(H){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(H))}reject(H){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(H))}}function p(B,H){const L=new w(H);return L.registerDisposable(B.onControlMessage(O=>{const _=JSON.parse(O.toString()),V=F(_);V?L.reject(V):L.resolve(_)})),L.promise}function f(B,H,L,O,_,V,x,re){const j=new w(re);return H.connect(L,O,_,V,x,(ie,ne)=>{j.didTimeout?(ie&&B.error(ie),ne?.dispose()):ie||!ne?j.reject(ie):j.resolve(ne)}),j.promise}function g(B,H){const L=new w(H);return B.then(O=>{L.didTimeout||L.resolve(O)},O=>{L.didTimeout||L.reject(O)}),L.promise}async function a(B,H,L,O){const _=z(B,H);B.logService.trace(`${_} 1/6. invoking socketFactory.connect().`);let V;try{V=await f(B.logService,B.socketFactory,B.host,B.port,(0,b.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${d(H)}-${B.reconnectionToken}`,O)}catch(ne){throw B.logService.error(`${_} socketFactory.connect() failed or timed out. Error:`),B.logService.error(ne),ne}B.logService.trace(`${_} 2/6. socketFactory.connect() was successful.`);let x,re;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(V,null),x=B.reconnectionProtocol,re=!1):(x=new m.PersistentProtocol(V,null),re=!0),B.logService.trace(`${_} 3/6. sending AuthRequest control message.`);const j=await g(B.signService.createNewMessage((0,l.generateUuid)()),O),ie={type:"auth",auth:B.connectionToken||"00000000000000000000",data:j.data};x.sendControl(t.VSBuffer.fromString(JSON.stringify(ie)));try{const ne=await p(x,C(O,S(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const Le=new Error("Unexpected handshake message");throw Le.code="VSCODE_CONNECTION_ERROR",Le}if(B.logService.trace(`${_} 4/6. received SignRequest control message.`),!await g(B.signService.validate(j,ne.signedData),O)){const Le=new Error("Refused to connect to unsupported server");throw Le.code="VSCODE_CONNECTION_ERROR",Le}const fe=await g(B.signService.sign(ne.data),O),De={type:"connectionType",commit:B.commit,signedData:fe,desiredConnectionType:H};return L&&(De.args=L),B.logService.trace(`${_} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(t.VSBuffer.fromString(JSON.stringify(De))),{protocol:x,ownsProtocol:re}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(B.logService.error(`${_} the handshake timed out. Error:`),B.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${_} received error control message when negotiating connection. Error:`),B.logService.error(ne)),re&&K(x),ne}}async function n(B,H,L,O){const _=Date.now(),V=z(B,H),{protocol:x,ownsProtocol:re}=await a(B,H,L,O),j=new w(O);return j.registerDisposable(x.onControlMessage(ie=>{const ne=JSON.parse(ie.toString()),ae=F(ne);ae?(B.logService.error(`${V} received error control message when negotiating connection. Error:`),B.logService.error(ae),re&&K(x),j.reject(ae)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${te(_)}!`),j.resolve({protocol:x,firstMessage:ne}))})),j.promise}async function o(B,H){const{protocol:L}=await n(B,1,void 0,H);return{protocol:L}}async function i(B,H,L){const{protocol:O,firstMessage:_}=await n(B,2,H,L),V=_&&_.debugPort;return{protocol:O,debugPort:V}}async function r(B,H,L){const O=Date.now(),_=z(B,3),{protocol:V}=await a(B,3,H,L);return B.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${te(O)}!`),V}async function s(B,H,L){const{host:O,port:_,connectionToken:V}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:O,port:_,connectionToken:V,reconnectionToken:H,reconnectionProtocol:L,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function c(B,H,L){return P(B,async O=>{const{protocol:_}=await o(O,k.CancellationToken.None);return new de(B,H,L,O.reconnectionToken,_)})}e.connectRemoteAgentManagement=c;async function u(B,H){return P(B,async L=>{const{protocol:O,debugPort:_}=await i(L,H,k.CancellationToken.None);return new G(B,H,L.reconnectionToken,O,_)})}e.connectRemoteAgentExtensionHost=u;async function P(B,H){for(let O=1;;O++)try{const _=(0,l.generateUuid)(),V=await s(B,_,null);return await H(V)}catch(_){if(O<5)B.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(_);else throw B.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(_),se.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(_)),_}}async function D(B,H,L){const O=await s(B,(0,l.generateUuid)(),null);return await r(O,{host:H,port:L},k.CancellationToken.None)}e.connectRemoteAgentTunnel=D;function T(B){return(0,v.createCancelablePromise)(H=>new Promise((L,O)=>{const _=setTimeout(L,B*1e3);H.onCancellationRequested(()=>{clearTimeout(_),L()})}))}var N;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(N=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(H,L){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=U;class ${constructor(H,L,O,_){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.durationSeconds=O,this.cancellableTimer=_,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=$;class Y{constructor(H,L,O){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=Y;class oe{constructor(H,L,O){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=4}}e.ConnectionGainEvent=oe;class ue{constructor(H,L,O,_){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=O,this.handled=_,this.type=3}}e.ReconnectionPermanentFailureEvent=ue;class se extends E.Disposable{constructor(H,L,O,_,V){super(),this._connectionType=H,this._options=L,this.reconnectionToken=O,this.protocol=_,this._reconnectionFailureIsFatal=V,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new oe(this.reconnectionToken,0,0)),this._register(_.onSocketClose(x=>{const re=W(this._connectionType,this.reconnectionToken,!0);x?x.type===0?(this._options.logService.info(`${re} received socket close event (hadError: ${x.hadError}).`),x.error&&this._options.logService.error(x.error)):(this._options.logService.info(`${re} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this._options.logService.error(x.event)):this._options.logService.info(`${re} received socket close event.`),this._beginReconnecting()})),this._register(_.onSocketTimeout(x=>{const re=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),se._instances.push(this),this._register((0,E.toDisposable)(()=>{const x=se._instances.indexOf(this);x>=0&&se._instances.splice(x,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(se._permanentFailureMillisSinceLastIncomingData,se._permanentFailureAttempt,se._permanentFailureHandled)}static triggerPermanentFailure(H,L,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=H,this._permanentFailureAttempt=L,this._permanentFailureHandled=O,this._instances.forEach(_=>_._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(H=>H._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(H=>H._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||se._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const H=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${H} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const _=O<L.length?L[O]:L[L.length-1];try{if(_>0){const x=T(_);this._onDidStateChange.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_,x)),this._options.logService.info(`${H} waiting for ${_} seconds before reconnecting...`);try{await x}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${H} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${H} resolving connection...`);const V=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${H} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,S(y)),this._options.logService.info(`${H} reconnected!`),this._onDidStateChange.fire(new oe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${H} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${H} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${H} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${H} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,R.isCancellationError)(V)){this._options.logService.info(`${H} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${H} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,I.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${H} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(H,L,O){this._reconnectionFailureIsFatal?se.triggerPermanentFailure(H,L,O):this._gotoPermanentFailure(H,L,O)}_gotoPermanentFailure(H,L,O){this._onDidStateChange.fire(new ue(this.reconnectionToken,H,L,O)),K(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=se,se._permanentFailure=!1,se._permanentFailureMillisSinceLastIncomingData=0,se._permanentFailureAttempt=0,se._permanentFailureHandled=!1,se._instances=[];class de extends se{constructor(H,L,O,_,V){super(1,H,_,V,!0),this.client=this._register(new m.Client(V,{remoteAuthority:L,clientId:O},H.ipcLogger))}async _reconnect(H,L){await o(H,L)}}e.ManagementPersistentConnection=de;class G extends se{constructor(H,L,O,_,V){super(2,H,O,_,!1),this._startArguments=L,this.debugPort=V}async _reconnect(H,L){await i(H,this._startArguments,L)}}e.ExtensionHostPersistentConnection=G;function K(B){try{B.acceptDisconnect();const H=B.getSocket();B.dispose(),H.dispose()}catch(H){(0,R.onUnexpectedError)(H)}}function F(B){if(B&&B.type==="error"){const H=new Error(`Connection error: ${B.reason}`);return H.code="VSCODE_CONNECTION_ERROR",H}return null}function A(B,H){for(;B.length<H;)B+=" ";return B}function W(B,H,L){return`[remote-connection][${A(d(B),13)}][${H.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function z(B,H){return`${W(H,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function te(B){return`${Date.now()-B} ms`}}),define(Z[219],ee([0,1,77,83]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,M,E,l,m){const I=y=>m(y,void 0),b=v.createConnection({host:k,port:R},()=>{b.removeListener("error",I);const y=Buffer.alloc(16);for(let C=0;C<16;C++)y[C]=Math.round(Math.random()*256);const h=y.toString("base64"),d=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${M}?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`];b.write(d.join(`\r
`)+`\r
\r
`);const S=C=>{C.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",S),m(void 0,new t.NodeSocket(b,l)))};b.on("data",S)});b.setNoDelay(!0),b.once("error",I)}}}),define(Z[220],ee([0,1,28,45,40,183]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let M;async function E(h=!1){return(M===void 0||h)&&(M=l()),M}e.hasWSLFeatureInstalled=E;async function l(){const h=m();if(h===void 0)return!1;if(h>=22e3){const d=b();if(d)return new Promise(S=>{t.execFile(d,["--status"],C=>S(!C))})}else{const d=y();if(d)try{if((await k.promises.stat(d)).isFile())return!0}catch{}}return!1}function m(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(v.release());if(h)return parseInt(h[3])}function I(h){const d=process.env.SystemRoot;if(d){const S=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(d,S?"Sysnative":"System32",h)}}function b(){return I("wsl.exe")}function y(){return I("lxss\\LxssManager.dll")}}),define(Z[55],ee([0,1,18,166,62,5,47]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function E(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=E;function l(S){return S.res.statusCode===204}async function m(S){return l(S)?null:(await(0,v.streamToBuffer)(S.stream)).toString()}e.asText=m;async function I(S){if(!E(S))throw new Error("Server returned "+S.res.statusCode);return m(S)}e.asTextOrError=I;async function b(S){if(!E(S))throw new Error("Server returned "+S.res.statusCode);if(l(S))return null;const w=(await(0,v.streamToBuffer)(S.stream)).toString();try{return JSON.parse(w)}catch(p){throw p.message+=`:
`+w,p}}e.asJson=b;function y(S){d(S)}e.updateProxyConfigurationsScope=y;let h;function d(S){const C=M.Registry.as(k.Extensions.Configuration),w=h;h={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},C.updateConfigurations({add:[h],remove:w?[w]:[]})}d(2)}),define(Z[221],ee([0,1,18,22]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(E){this.service=E}listen(E,l){throw new Error("Invalid listen")}call(E,l,m,I=t.CancellationToken.None){switch(l){case"request":return this.service.request(m[0],I).then(async({res:b,stream:y})=>{const h=await(0,v.streamToBuffer)(y);return[{statusCode:b.statusCode,headers:b.headers},h]});case"resolveProxy":return this.service.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(E){this.channel=E}async request(E,l){const[m,I]=await this.channel.call("request",[E],l);return{res:m,stream:(0,v.bufferToStream)(I)}}async resolveProxy(E){return this.channel.call("resolveProxy",[E])}}e.RequestChannelClient=R}),define(Z[222],ee([0,1,223,12]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(M,E){return M.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:M.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function R(M,E,l={}){const m=(0,v.parse)(M),I=l.proxyUrl||k(m,E);if(!I)return null;const b=(0,v.parse)(I);if(!/^https?:$/.test(b.protocol||""))return null;const y={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,t.isBoolean)(l.strictSSL)?l.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((h,d)=>{q(["http-proxy-agent"],h,d)}))(y):new(await new Promise((h,d)=>{q(["https-proxy-agent"],h,d)}))(y)}e.getProxyAgent=R}),define(Z[111],ee([0,1,45,9,167,22,44,17,4,29,143,59,8]),function(q,e,v,t,k,R,M,E,l,m,I,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const h=1e4;let d;async function S(w,p,f){return p["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(f)&&!p["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(f)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=y.Promises.withAsyncBody(async(g,a)=>{const n=new R.CancellationTokenSource,o=setTimeout(()=>{n.dispose(!0),a(new Error((0,k.localize)(0,null)))},h);try{g(await C(w,n.token))}catch(i){!(0,E.isCancellationError)(i)&&!n.token.isCancellationRequested?a(new Error((0,k.localize)(1,null,(0,M.toErrorMessage)(i)))):g({})}finally{clearTimeout(o),n.dispose()}})),d)}e.getResolvedShellEnv=S;async function C(w,p){const f=process.env.ELECTRON_RUN_AS_NODE;w.trace("getUnixShellEnvironment#runAsNode",f);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;w.trace("getUnixShellEnvironment#noAttach",g);const a=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(a+"(.*)"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};w.trace("getUnixShellEnvironment#env",o);const i=await(0,I.getSystemShell)(l.OS,o);return w.trace("getUnixShellEnvironment#shell",i),new Promise((r,s)=>{if(p.isCancellationRequested)return s((0,E.canceled)());const c=(0,t.basename)(i);let u,P;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(u=`& '${process.execPath}' ${D} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,P=["-Login","-Command"]):(u=`'${process.execPath}' ${D} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,c==="tcsh"?P=["-ic"]:P=["-ilc"]),w.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),u);const T=(0,v.spawn)(i,[...P,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});p.onCancellationRequested(()=>(T.kill(),s((0,E.canceled)()))),T.on("error",$=>{w.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)($)),s($)});const N=[];T.stdout.on("data",$=>N.push($));const U=[];T.stderr.on("data",$=>U.push($)),T.on("close",($,Y)=>{const oe=Buffer.concat(N).toString("utf8");w.trace("getUnixShellEnvironment#raw",oe);const ue=Buffer.concat(U).toString("utf8");if(ue.trim()&&w.trace("getUnixShellEnvironment#stderr",ue),$||Y)return s(new Error((0,k.localize)(2,null,$,Y)));const se=n.exec(oe),de=se?se[1]:"{}";try{const G=JSON.parse(de);f?G.ELECTRON_RUN_AS_NODE=f:delete G.ELECTRON_RUN_AS_NODE,g?G.ELECTRON_NO_ATTACH_CONSOLE=g:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,w.trace("getUnixShellEnvironment#result",G),r(G)}catch(G){w.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(G)),s(G)}})})}}),define(Z[87],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[224],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{constructor(){this.validators=new Map}vsda(){return new Promise((k,R)=>q(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.vsda(),M=new R.validator;if(M){const E=String(v._nextId++);return this.validators.set(E,M),{id:E,data:M.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const M=this.validators.get(k.id);if(!M)return!1;this.validators.delete(k.id);try{return M.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.vsda(),M=new R.signer;if(M)return M.sign(k)}catch{}return k}}e.SignService=v,v._nextId=1}),define(Z[38],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(Z[21],ee([0,1,15,41,8,3,2,4,33,12,5,6,38,26]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,I.createDecorator)("lifecycleMainService");var d;(function(w){w[w.QUIT=1]="QUIT",w[w.KILL=2]="KILL"})(d=e.ShutdownReason||(e.ShutdownReason={}));var S;(function(w){w[w.Starting=1]="Starting",w[w.Ready=2]="Ready",w[w.AfterWindowOpen=3]="AfterWindowOpen",w[w.Eventually=4]="Eventually"})(S=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let C=class yt extends M.Disposable{constructor(p,f,g){super(),this.logService=p,this.stateMainService=f,this.environmentMainService=g,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(yt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(yt.QUIT_AND_RESTART_KEY)}registerListeners(){const p=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),E.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};v.app.addListener("before-quit",p);const f=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!E.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",f),v.app.once("will-quit",g=>{this.trace("Lifecycle#app.on(will-quit)"),g.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",p),v.app.removeListener("window-all-closed",f),v.app.quit()})})}fireOnWillShutdown(p){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.trace("Lifecycle#onWillShutdown.fire()");const f=[];return this._onWillShutdown.fire({reason:p,join(g){f.push(g)}}),this.pendingWillShutdownPromise=(async()=>{try{await k.Promises.settled(f)}catch(g){this.logService.error(g)}try{await this.stateMainService.close()}catch(g){this.logService.error(g)}})(),this.pendingWillShutdownPromise}set phase(p){if(p<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===p)return;this.trace(`lifecycle (main): phase changed (value: ${p})`),this._phase=p;const f=this.phaseWhen.get(this._phase);f&&(f.open(),this.phaseWhen.delete(this._phase))}async when(p){if(p<=this._phase)return;let f=this.phaseWhen.get(p);f||(f=new k.Barrier,this.phaseWhen.set(p,f)),await f.wait()}registerWindow(p){const f=new M.DisposableStore;this.windowCounter++,f.add(p.onWillLoad(a=>this._onWillLoadWindow.fire({window:p,workspace:a.workspace,reason:a.reason})));const g=(0,m.assertIsDefined)(p.win);g.on("close",a=>{const n=p.id;if(this.windowToCloseRequest.has(n)){this.windowToCloseRequest.delete(n);return}this.trace(`Lifecycle#window.on('close') - window ID ${p.id}`),a.preventDefault(),this.unload(p,1).then(o=>{if(o){this.windowToCloseRequest.delete(n);return}this.windowToCloseRequest.add(n),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${n}`),this._onBeforeCloseWindow.fire(p),p.close()})}),g.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${p.id}`),this.windowCounter--,f.dispose(),this.windowCounter===0&&(!E.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(p,f){await this.unload(p,3)||p.reload(f)}unload(p,f){const g=this.mapWindowIdToPendingUnload.get(p.id);if(g)return g;const a=this.doUnload(p,f).finally(()=>{this.mapWindowIdToPendingUnload.delete(p.id)});return this.mapWindowIdToPendingUnload.set(p.id,a),a}async doUnload(p,f){if(!p.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${p.id}`);const g=this._quitRequested?2:f,a=await this.onBeforeUnloadWindowInRenderer(p,g);return a?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${p.id})`),this.handleWindowUnloadVeto(a)):(await this.onWillUnloadWindowInRenderer(p,g),!1)}handleWindowUnloadVeto(p){return p?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(p){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(p),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(p,f){return new Promise(g=>{const a=this.oneTimeListenerTokenGenerator++,n=`vscode:ok${a}`,o=`vscode:cancel${a}`;t.validatedIpcMain.once(n,()=>{g(!1)}),t.validatedIpcMain.once(o,()=>{g(!0)}),p.send("vscode:onBeforeUnload",{okChannel:n,cancelChannel:o,reason:f})})}onWillUnloadWindowInRenderer(p,f){return new Promise(g=>{const n=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(n,()=>g()),p.send("vscode:onWillUnload",{replyChannel:n,reason:f})})}quit(p){return this.trace(`Lifecycle#quit() - begin (willRestart: ${p})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(p&&this.stateMainService.setItem(yt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(f=>{this.pendingQuitPromiseResolve=f,this.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}trace(p){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(p):this.logService.trace(p)}async relaunch(p){this.trace("Lifecycle#relaunch()");const f=process.argv.slice(1);if(p?.addArgs&&f.push(...p.addArgs),p?.removeArgs)for(const n of p.removeArgs){const o=f.indexOf(n);o>=0&&f.splice(o,1)}const g=()=>{try{if(E.isWindows){const n=(0,l.cwd)();n!==process.cwd()&&process.chdir(n)}}catch(n){this.logService.error(n)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:f})};v.app.once("quit",g),await this.quit(!0)&&v.app.removeListener("quit",g)}async kill(p){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const f of v.BrowserWindow.getAllWindows())if(f&&!f.isDestroyed()){let g;f.webContents&&!f.webContents.isDestroyed()?g=new Promise(a=>f.once("closed",a)):g=Promise.resolve(),f.destroy(),await g}})()]),v.app.exit(p)}};C.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",C=ve([J(0,b.ILogService),J(1,y.IStateMainService),J(2,h.IEnvironmentMainService)],C),e.LifecycleMainService=C}),define(Z[225],ee([0,1,4,3,2,5,21]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let E=class extends k.Disposable{constructor(I){super(),this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,I.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const I=await new Promise((b,y)=>{q(["native-keymap"],b,y)});this._keyboardLayoutData=l(I),v.isCI||I.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=l(I),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};E=ve([J(0,M.ILifecycleMainService)],E),e.KeyboardLayoutMainService=E;function l(m){const I=m.getKeyMap(),b=m.getCurrentKeyboardLayout();return{keyboardMapping:I,keyboardLayoutInfo:b}}}),define(Z[226],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,v.createDecorator)("stateService")}),define(Z[227],ee([0,1,8,18,12,35,14,6]),function(q,e,v,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class l{constructor(b,y,h){this.storagePath=b,this.logService=y,this.fileService=h,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(b){b.fileOperationResult!==1&&this.logService.error(b)}}getItem(b,y){const h=this.storage[b];return(0,k.isUndefinedOrNull)(h)?y:h}setItem(b,y){this.setItems([{key:b,data:y}])}setItems(b){let y=!1;for(const{key:h,data:d}of b)this.storage[h]!==d&&((0,k.isUndefinedOrNull)(d)?(0,k.isUndefined)(this.storage[h])||(this.storage[h]=void 0,y=!0):(this.storage[h]=d,y=!0));y&&this.save()}removeItem(b){(0,k.isUndefined)(this.storage[b])||(this.storage[b]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const b=JSON.stringify(this.storage,null,4);if(b!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(b)),this.lastSavedStorageContents=b}catch(y){this.logService.error(y)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=l;let m=class{constructor(b,y,h){this.fileStorage=new l(b.stateResource,y,h)}async init(){await this.fileStorage.init()}getItem(b,y){return this.fileStorage.getItem(b,y)}};m=ve([J(0,R.IEnvironmentService),J(1,E.ILogService),J(2,M.IFileService)],m),e.StateService=m}),define(Z[228],ee([0,1,227]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends v.StateService{setItem(R,M){this.fileStorage.setItem(R,M)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(Z[112],ee([0,1,4,33,7,29]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(m){if(v.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function E(m,I,b,y,h,d,S,C,w,p){const f=Object.create(null);f["common.machineId"]=S,f.sessionID=(0,R.generateUuid)()+Date.now(),f.commitHash=h,f.version=d,f["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,v.PlatformToString)(v.platform),f["common.nodePlatform"]=t.platform,f["common.nodeArch"]=y,f["common.product"]=p||"desktop",C&&(f["common.msftInternal"]=C);let g=0;const a=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),v.isLinuxSnap&&(f["common.snap"]="true");const n=M(b);n&&(f["common.platformDetail"]=n);try{const o=await m.readFile(k.URI.file(w));f["common.source"]=o.value.toString().slice(0,30)}catch{}return f}e.resolveCommonProperties=E;function l(m){const I=t.env.USERDNSDOMAIN;if(!I)return!1;const b=I.toLowerCase();return m.some(y=>b===y)}e.verifyMicrosoftInternalDomain=l}),define(Z[36],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[229],ee([0,1,28,57,8,43,13,9,4,7,81,23,98,84,14,20,36]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const w=new Map;async function p(o,i){const r=`${o}::${i.join(":")}`,s=w.get(r);if(s)return s;const c=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,P=new Map,D=2e4;function T(U,$,Y,oe){const ue=$.substring(U.length+1);return k.Promises.withAsyncBody(async se=>{let de;try{de=await b.Promises.readdir($,{withFileTypes:!0})}catch{se();return}if(oe.count>=D){oe.count+=de.length,oe.maxReached=!0,se();return}let G=de.length;if(G===0){se();return}let K=de;oe.count+de.length>D&&(oe.maxReached=!0,G=D-oe.count,K=de.slice(0,G)),oe.count+=de.length;for(const F of K)if(F.isDirectory()){if(Y.includes(F.name)||await T(U,(0,E.join)($,F.name),Y,oe),--G===0){se();return}}else{const A=F.name.lastIndexOf(".");if(A>=0){const W=F.name.substring(A+1);W&&u.set(W,(u.get(W)??0)+1)}for(const W of c)W.relativePathPattern?.test(ue)!==!1&&W.filePattern.test(F.name)&&P.set(W.tag,(P.get(W.tag)??0)+1);if(--G===0){se();return}}})}const N=k.Promises.withAsyncBody(async U=>{const $={count:0,maxReached:!1};await T(o,o,i,$);const Y=await a(o);U({configFiles:f(P),fileTypes:f(u),fileCount:$.count,maxFilesReached:$.maxReached,launchConfigFiles:Y})});return w.set(r,N),N}e.collectWorkspaceStats=p;function f(o){return[...t.Iterable.map(o.entries(),([i,r])=>({name:i,count:r}))].sort((i,r)=>r.count-i.count)}function g(){const o={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},i=v.cpus();return i&&i.length>0&&(o.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),o}e.getMachineInfo=g;async function a(o){try{const i=new Map,r=(0,E.join)(o,".vscode","launch.json"),s=await b.Promises.readFile(r),c=[],u=(0,R.parse)(s.toString(),c);if(c.length)return console.log(`Unable to parse ${r}`),[];if((0,R.getNodeType)(u)==="object"&&u.configurations)for(const P of u.configurations){const D=P.type;D&&(i.has(D)?i.set(D,i.get(D)+1):i.set(D,1))}return f(i)}catch{return[]}}e.collectLaunchConfigs=a;let n=class{constructor(i,r){this.telemetryService=i,this.productService=r}formatMachineInfo(i){const r=[];return r.push(`OS Version:       ${i.os}`),r.push(`CPUs:             ${i.cpus}`),r.push(`Memory (System):  ${i.memory}`),r.push(`VM:               ${i.vmHint}`),r.join(`
`)}formatEnvironment(i){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const s=v.cpus();return s&&s.length>0&&r.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),r.push(`Memory (System):  ${(v.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),l.isWindows||r.push(`Load (avg):       ${v.loadavg().map(c=>Math.round(c)).join(", ")}`),r.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${i.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(i,r){return Promise.all([(0,y.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async s=>{let[c,u]=s,P=this.formatProcessList(i,c);return r.forEach(D=>{if((0,h.isRemoteDiagnosticError)(D))P+=`
${D.errorMessage}`,u+=`
${D.errorMessage}`;else if(P+=`

Remote: ${D.hostName}`,D.processes&&(P+=`
${this.formatProcessList(i,D.processes)}`),D.workspaceMetadata){u+=`
|  Remote: ${D.hostName}`;for(const T of Object.keys(D.workspaceMetadata)){const N=D.workspaceMetadata[T];let U=`${N.fileCount} files`;N.maxFilesReached&&(U=`more than ${U}`),u+=`|    Folder (${T}): ${U}`,u+=this.formatWorkspaceStats(N)}}}),{processInfo:P,workspaceInfo:u}})}async getSystemInfo(i,r){const{memory:s,vmHint:c,os:u,cpus:P}=g(),D={os:u,memory:s,cpus:P,vmHint:c,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:r};return l.isWindows||(D.load=`${v.loadavg().map(T=>Math.round(T)).join(", ")}`),l.isLinux&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(i,r){const s=[];return(0,y.listProcesses)(i.mainPID).then(async c=>(s.push(""),s.push(this.formatEnvironment(i)),s.push(""),s.push(this.formatProcessList(i,c)),i.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(i))),r.forEach(u=>{if((0,h.isRemoteDiagnosticError)(u))s.push(`
${u.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${u.hostName}`),s.push(this.formatMachineInfo(u.machineInfo)),u.processes&&s.push(this.formatProcessList(i,u.processes)),u.workspaceMetadata)for(const P of Object.keys(u.workspaceMetadata)){const D=u.workspaceMetadata[P];let T=`${D.fileCount} files`;D.maxFilesReached&&(T=`more than ${T}`),s.push(`Folder (${P}): ${T}`),s.push(this.formatWorkspaceStats(D))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(i){const r=[];let c=0;const u=(N,U)=>{const $=` ${N}(${U})`;c+$.length>60?(r.push(P),P="|                 ",c=P.length):c+=$.length,P+=$};let P="|      File types:";const D=10,T=i.fileTypes.length>D?D:i.fileTypes.length;for(let N=0;N<T;N++){const U=i.fileTypes[N];u(U.name,U.count)}if(r.push(P),i.configFiles.length>=0&&(P="|      Conf files:",c=0,i.configFiles.forEach(N=>{u(N.name,N.count)}),r.push(P)),i.launchConfigFiles.length>0){let N="|      Launch Configs:";i.launchConfigFiles.forEach(U=>{N+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),r.push(N)}return r.join(`
`)}expandGPUFeatures(i){const r=Math.max(...Object.keys(i).map(s=>s.length));return Object.keys(i).map(s=>`${s}:  ${" ".repeat(r-s.length)}  ${i[s]}`).join(`
                  `)}formatWorkspaceMetadata(i){const r=[],s=[];return i.windows.forEach(c=>{c.folderURIs.length===0||!!c.remoteAuthority||(r.push(`|  Window (${c.title})`),c.folderURIs.forEach(u=>{const P=m.URI.revive(u);if(P.scheme===M.Schemas.file){const D=P.fsPath;s.push(p(D,["node_modules",".git"]).then(T=>{let N=`${T.fileCount} files`;T.maxFilesReached&&(N=`more than ${N}`),r.push(`|    Folder (${(0,E.basename)(D)}): ${N}`),r.push(this.formatWorkspaceStats(T))}).catch(T=>{r.push(`|      Error: Unable to collect workspace stats for folder ${D} (${T.toString()})`)}))}else r.push(`|    Folder (${P.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(c=>r.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}formatProcessList(i,r){const s=new Map;i.windows.forEach(u=>s.set(u.pid,u.title));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(i.mainPID,s,c,r,0),c.join(`
`)}formatProcessItem(i,r,s,c,u){const P=u===0;let D;P?D=c.pid===i?`${this.productService.applicationName} main`:"remote agent":(D=`${"  ".repeat(u)} ${c.name}`,c.name==="window"&&(D=`${D} (${r.get(c.pid)})`));const T=process.platform==="win32"?c.mem:v.totalmem()*(c.mem/100);s.push(`${c.load.toFixed(0).padStart(5," ")}	${(T/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(c.children)&&c.children.forEach(N=>this.formatProcessItem(i,r,s,N,u+1))}async getWorkspaceFileExtensions(i){const r=new Set;for(const{uri:s}of i.folders){const c=m.URI.revive(s);if(c.scheme!==M.Schemas.file)continue;const u=c.fsPath;try{(await p(u,["node_modules",".git"])).fileTypes.forEach(D=>r.add(D.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(i){for(const{uri:r}of i.folders){const s=m.URI.revive(r);if(s.scheme!==M.Schemas.file)continue;const c=s.fsPath;try{const u=await p(c,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),u.fileTypes.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})}),u.launchConfigFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})}),u.configFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})})}catch{}}}};n=ve([J(0,C.ITelemetryService),J(1,S.IProductService)],n),e.DiagnosticsService=n}),define(Z[230],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(R){this.appenders=R}listen(R,M){throw new Error(`Event not found: ${M}`)}call(R,M,{eventName:E,data:l}){return this.appenders.forEach(m=>m.log(E,l)),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class t{constructor(R){this.channel=R}log(R,M){return this.channel.call("log",{eventName:R,data:M}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(Z[73],ee([0,1,50,94,12,19,112,36]),function(q,e,v,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class l{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(n,o){return Promise.resolve(void 0)}publicLog2(n,o){return this.publicLog(n,o)}publicLogError(n,o){return Promise.resolve(void 0)}publicLogError2(n,o){return this.publicLogError(n,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=l,e.NullTelemetryService=new l;class m{async publicLog(n,o,i){}async publicLogError(n,o,i){}}e.NullEndpointTelemetryService=m,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(a,n){return n.onDidChangeConfiguration(o=>{o.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(o.source),configurationKeys:w(o.sourceConfig)})})}e.configurationTelemetry=I;function b(a,n){return!(n.disableTelemetry||!a.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=b;function y(a){const n=a.getValue(E.TELEMETRY_SETTING_ID),o=a.getValue("telemetry.enableCrashReporter");if(a.getValue(E.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function h(a){const n={},o={},i={};C(a,i);for(let r in i){r=r.length>150?r.substr(r.length-149):r;const s=i[r];typeof s=="number"?o[r]=s:typeof s=="boolean"?o[r]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${s.length}`),n[r]=s.substring(0,8191)):typeof s<"u"&&s!==null&&(n[r]=s)}return{properties:n,measurements:o}}e.validateTelemetryData=h;const d=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function S(a){if(!a)return"none";for(const n of d)if(a.startsWith(`${n}+`))return n;return"other"}e.cleanRemoteAuthority=S;function C(a,n,o=0,i){if(!!a)for(const r of Object.getOwnPropertyNames(a)){const s=a[r],c=i?i+r:r;Array.isArray(s)?n[c]=(0,v.safeStringify)(s):s instanceof Date?n[c]=s.toISOString():(0,k.isObject)(s)?o<2?C(s,n,o+1,c+"."):n[c]=(0,v.safeStringify)(s):n[c]=s}}function w(a){if(!a)return[];const n=[];return p(n,"",a),n}function p(a,n,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(i=>p(a,n?`${n}.${i}`:i,o[i])):a.push(n)}function f(a,n){const o=a.msftInternalDomains||[],i=n.getValue("telemetry.internalTesting");return(0,M.verifyMicrosoftInternalDomain)(o)||i}e.isInternalTelemetry=f;function g(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=g}),define(Z[231],ee([0,1,189,73]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,M,E,l,m,I,b){const y={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${M.nameShort})`};if((0,t.supportsTelemetry)(M,E)&&(0,t.getTelemetryLevel)(l)===3){const h=await(0,v.getServiceMachineId)(E,m,I),{sessionId:d}=await b.getTelemetryInfo();y["X-Market-User-Id"]=h,y["VSCode-SessionId"]=d}return y}e.resolveMarketplaceHeaders=k}),define(Z[232],ee([0,1,2,50,94,4,25,168,19,62,54,20,47,36,73]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(p,f,g){this._configurationService=f,this._productService=g,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=p.appenders,this._commonProperties=p.commonProperties||Promise.resolve({}),this._piiPaths=p.piiPaths||[],this._sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const a of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(a),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(p,f){this._experimentProperties[p]=f}_updateTelemetryLevel(){let p=(0,d.getTelemetryLevel)(this._configurationService);const f=this._productService.enabledTelemetryLevels;if(f){this._sendErrorTelemetry=this.sendErrorTelemetry?f.error:!1;const g=f.usage?3:f.error?2:0;p=Math.min(p,g)}this.telemetryLevel.value=p}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const p=await this._commonProperties,f=p.sessionID,g=p["common.machineId"],a=p["common.firstSessionDate"],n=p["common.msftInternal"];return{sessionId:f,machineId:g,firstSessionDate:a,msftInternal:n}}dispose(){this._disposables.dispose()}_log(p,f,g,a){return this.telemetryLevel.value<f?Promise.resolve(void 0):this._commonProperties.then(n=>{g=(0,t.mixin)(g,n),g=(0,t.mixin)(g,this._experimentProperties),g=(0,t.cloneAndChange)(g,o=>{if(typeof o=="string")return this._cleanupInfo(o,a)}),this._appenders.forEach(o=>o.log(p,g))},n=>{console.error(n)})}publicLog(p,f,g){return this._log(p,3,f,g)}publicLog2(p,f,g){return this.publicLog(p,f,g)}publicLogError(p,f){return this._sendErrorTelemetry?this._log(p,2,f,!0):Promise.resolve(void 0)}publicLogError2(p,f){return this.publicLogError(p,f)}_anonymizeFilePaths(p){let f=p;const g=[];for(const i of this._cleanupPatterns)for(;;){const r=i.exec(p);if(!r)break;g.push([r.index,i.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,n=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(f="";;){const i=n.exec(p);if(!i)break;!a.test(i[0])&&g.every(([r,s])=>i.index<r||i.index>=s)&&(f+=p.substring(o,i.index)+"<REDACTED: user-file-path>",o=n.lastIndex)}return o<p.length&&(f+=p.substr(o)),f}_removePropertiesWithPossibleUserInfo(p){if(!p)return p;const f=p.toLowerCase(),g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const a of g)if(a.regex.test(f))return`<REDACTED: ${a.label}>`;return p}_cleanupInfo(p,f){let g=p;f&&(g=this._anonymizeFilePaths(g));for(const a of this._cleanupPatterns)g=g.replace(a,"");return g=this._removePropertiesWithPossibleUserInfo(g),g}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=ve([J(1,l.IConfigurationService),J(2,b.IProductService)],S),e.TelemetryService=S;function C(){const w=(0,E.localize)(0,null,I.default.nameLong),p=I.default.privacyStatementUrl?(0,E.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,E.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=R.isWeb?"":(0,E.localize)(3,null),g=(0,E.localize)(4,null),a=(0,E.localize)(5,null),n=(0,E.localize)(6,null),o=(0,E.localize)(7,null),i=`
|       | ${g} | ${a} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,E.localize)(8,null);return`
${w} ${p} ${f}

&nbsp;

${o}
${i}

&nbsp;

${r}
`}y.Registry.as(m.Extensions.Configuration).registerConfiguration({id:h.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(9,null),properties:{[h.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,E.localize)(10,null),(0,E.localize)(11,null),(0,E.localize)(12,null),(0,E.localize)(13,null)],markdownDescription:C(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(m.Extensions.Configuration).registerConfiguration({id:h.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(14,null),properties:{[h.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,E.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,E.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,E.localize)(17,null,`\`#${h.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[233],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(v=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===v.HIGH_CONTRAST_DARK||R===v.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===v.DARK||R===v.HIGH_CONTRAST_DARK}e.isDark=k}),define(Z[234],ee([0,1,119,3,2,5,47,233]),function(q,e,v,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var l;(function(C){function w(p){return p&&typeof p=="object"&&typeof p.id=="string"}C.isThemeColor=w})(l=e.ThemeColor||(e.ThemeColor={}));function m(C){return{id:C}}e.themeColorFromId=m;var I;(function(C){function w(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||l.isThemeColor(r.color))}C.isThemeIcon=w;const p=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function f(r){const s=p.exec(r);if(!s)return;const[,c]=s;return{id:c}}C.fromString=f;function g(r){return{id:r}}C.fromId=g;function a(r,s){let c=r.id;const u=c.lastIndexOf("~");return u!==-1&&(c=c.substring(0,u)),s&&(c=`${c}~${s}`),{id:c}}C.modify=a;function n(r){const s=r.id.lastIndexOf("~");if(s!==-1)return r.id.substring(s+1)}C.getModifier=n;function o(r,s){return r.id===s.id&&r.color?.id===s.color?.id}C.isEqual=o;function i(r,s){return{id:r.id,color:s?m(s):void 0}}C.asThemeIcon=i,C.asClassNameArray=v.CSSIcon.asClassNameArray,C.asClassName=v.CSSIcon.asClassName,C.asCSSSelector=v.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function b(C){switch(C){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case E.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class y{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,k.toDisposable)(()=>{const p=this.themingParticipants.indexOf(w);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const h=new y;M.Registry.add(e.Extensions.ThemingContribution,h);function d(C){return h.onColorThemeChange(C)}e.registerThemingParticipant=d;class S extends k.Disposable{constructor(w){super(),this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,p){let f=this.theme.getColor(w);return f&&p&&(f=p(f,this.theme)),f?f.toString():null}}e.Themable=S}),define(Z[64],ee([0,1,15,3,2,4,19,5,38]),function(q,e,v,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const m="#FFFFFF",I="#1E1E1E",b="#000000",y="#FFFFFF",h="theme",d="themeBackground",S="windowSplash";e.IThemeMainService=(0,E.createDecorator)("themeMainService");let C=class extends k.Disposable{constructor(p,f){super(),this.stateMainService=p,this.configurationService=f,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,v.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(v.nativeTheme.shouldUseHighContrastColors)return{dark:v.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors)return{dark:v.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&v.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:v.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const p=this.getColorScheme();if(p.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return p.dark?b:y;let f=this.stateMainService.getItem(d,null);if(!f)switch(this.stateMainService.getItem(h,"vs-dark").split(" ")[0]){case"vs":f=m;break;case"hc-black":f=b;break;case"hc-light":f=y;break;default:f=I}return R.isMacintosh&&f.toUpperCase()===I&&(f="#171717"),f}saveWindowSplash(p,f){this.stateMainService.setItems([{key:h,data:f.baseTheme},{key:d,data:f.colorInfo.background},{key:S,data:f}]),typeof p=="number"&&this.updateBackgroundColor(p,f)}updateBackgroundColor(p,f){for(const g of v.BrowserWindow.getAllWindows())if(g.id===p){g.setBackgroundColor(f.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(S)}};C=ve([J(0,l.IStateMainService),J(1,M.IConfigurationService)],C),e.ThemeMainService=C}),define(Z[113],ee([0,1,3,4,5,6]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var M;(function(S){S.Http="http",S.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var E;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(E=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var l;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(l=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const C=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(!!C)return{address:C[1],port:+C[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}e.isAllInterfaces=b;function y(S,C){return C?C!==1&&S<1024:!t.isWindows&&S<1024}e.isPortPrivileged=y;class h{constructor(C,w,p){this.remoteAddress=C,this.localAddress=w,this._dispose=p,this._onDispose=new v.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=h;let d=class{constructor(C){this.logService=C,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(C){return this._tunnelProvider=C,C?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(C){this._canElevate=C.elevation,this._privacyOptions=C.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const C=[],w=Array.from(this._tunnels.values());for(const p of w){const f=Array.from(p.values());for(const g of f){const a=await g.value;a&&C.push(a)}}return C}async dispose(){for(const C of this._tunnels.values()){for(const{value:w}of C.values())await w.then(p=>p?.dispose());C.clear()}this._tunnels.clear()}openTunnel(C,w,p,f,g=!1,a,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${w}:${p} on local port ${f}.`),!C)return;if(w||(w="localhost"),this._tunnelProvider&&this._factoryInProgress.has(p)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(C,w,p,f,g,a,n);return o?o.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(w,p);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(i);return(i.tunnelRemoteHost!==w||i.tunnelRemotePort!==p)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(C){return{tunnelRemotePort:C.tunnelRemotePort,tunnelRemoteHost:C.tunnelRemoteHost,tunnelLocalPort:C.tunnelLocalPort,localAddress:C.localAddress,privacy:C.privacy,protocol:C.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${C.tunnelRemoteHost}:${C.tunnelRemotePort} `);const w=this._tunnels.get(C.tunnelRemoteHost);if(w){const p=w.get(C.tunnelRemotePort);p&&(p.refcount--,await this.tryDisposeTunnel(C.tunnelRemoteHost,C.tunnelRemotePort,p))}}}}async tryDisposeTunnel(C,w,p){if(p.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${C}:${w}.`);const f=p.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(C)&&this._tunnels.get(C).delete(w),f}}async closeTunnel(C,w){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${C}:${w} `);const p=this._tunnels.get(C);if(p&&p.has(w)){const f=p.get(w);f.refcount=0,await this.tryDisposeTunnel(C,w,f)}}addTunnelToMap(C,w,p){this._tunnels.has(C)||this._tunnels.set(C,new Map),this._tunnels.get(C).set(w,{refcount:1,value:p})}async removeEmptyTunnelFromMap(C,w){const p=this._tunnels.get(C);p&&(await p.get(w)||p.delete(w),p.size===0&&this._tunnels.delete(C))}getTunnelFromMap(C,w){const p=[C];I(C)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):b(C)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const f=p.map(g=>this._tunnels.get(g));for(const g of f){const a=g?.get(w);if(a)return a}}canTunnel(C){return!!m(C)}createWithProvider(C,w,p,f,g,a,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${w}:${p} on local port ${f}.`);const o=p;this._factoryInProgress.add(o);const r={elevationRequired:g?y(f===void 0?p:f):!1},s={remoteAddress:{host:w,port:p},localAddressPort:f,privacy:a,public:a?a!==E.Private:void 0,protocol:n},c=C.forwardPort(s,r);return c?(this.addTunnelToMap(w,p,c),c.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),c}};d=ve([J(0,R.ILogService)],d),e.AbstractTunnelService=d}),define(Z[235],ee([0,1,77,93,219,8,2,19,6,20,218,113,87]),function(q,e,v,t,k,R,M,E,l,m,I,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function h(p,f,g,a,n){let o;for(let i=3;i&&(o?.dispose(),o=await new d(p,f,g,a,n).waitForReady(),!(n&&t.BROWSER_RESTRICTED_PORTS[n]||!t.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));i--);return o}class d extends M.Disposable{constructor(f,g,a,n,o){super(),this.defaultTunnelHost=g,this.suggestedLocalPort=o,this.privacy=b.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=f,this._server=v.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(g=>{g()})}async waitForReady(){let f=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),g=null;return this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),g=this._server.address(),g||(f=0,this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),g=this._server.address()),this.tunnelLocalPort=g.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${g.port}`,this}async _onConnection(f){f.pause();const g=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,I.connectRemoteAgentTunnel)(this._options,g,this.tunnelRemotePort),n=a.getSocket().socket,o=a.readEntireBuffer();a.dispose(),o.byteLength>0&&f.write(o.buffer),f.on("end",()=>{f.localAddress&&this._socketsDispose.delete(f.localAddress),n.end()}),f.on("close",()=>n.end()),f.on("error",()=>{f.localAddress&&this._socketsDispose.delete(f.localAddress),n.destroy()}),n.on("end",()=>f.end()),n.on("close",()=>f.end()),n.on("error",()=>{f.destroy()}),f.pipe(n),n.pipe(f),f.localAddress&&this._socketsDispose.set(f.localAddress,()=>{f.end(),n.end()})}}let S=class extends b.AbstractTunnelService{constructor(f,g,a,n,o){super(g),this.socketFactory=f,this.signService=a,this.productService=n,this.configurationService=o}get defaultTunnelHost(){const f=this.configurationService.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(f,g,a,n,o,i,r){const s=this.getTunnelFromMap(g,a);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,g,a,n,o,i,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${g}:${a} on local port ${n}.`);const c={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:f,signService:this.signService,logService:this.logService,ipcLogger:null},u=h(c,this.defaultTunnelHost,g,a,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(g,a,u),u}}};S=ve([J(1,l.ILogService),J(2,y.ISignService),J(3,m.IProductService),J(4,E.IConfigurationService)],S),e.BaseTunnelService=S;let C=class extends S{constructor(f,g,a,n){super(k.nodeSocketFactory,f,g,a,n)}};C=ve([J(0,l.ILogService),J(1,y.ISignService),J(2,m.IProductService),J(3,E.IConfigurationService)],C),e.TunnelService=C;let w=class extends M.Disposable{constructor(f,g,a,n){super(),this.logService=f,this.productService=g,this.signService=a,this.configurationService=n,this._tunnelServices=new Map}async openTunnel(f,g,a,n,o,i,r,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${n} on local port ${o}.`),!this._tunnelServices.has(f)){const c=new C(this.logService,this.signService,this.productService,this.configurationService);this._register(c),this._tunnelServices.set(f,c),c.onTunnelClosed(async()=>{(await c.tunnels).length===0&&(c.dispose(),this._tunnelServices.delete(f))})}return this._tunnelServices.get(f).openTunnel(g,a,n,o,i,r,s)}};w=ve([J(0,l.ILogService),J(1,m.IProductService),J(2,y.ISignService),J(3,E.IConfigurationService)],w),e.SharedTunnelsService=w}),define(Z[48],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,M)=>({type:"idle",updateType:R,error:M}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(Z[236],ee([0,1,4,169,62,47]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[237],ee([0,1,3,48]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(E){this.service=E}listen(E,l){switch(l){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${l}`)}call(E,l,m){switch(l){case"checkForUpdates":return this.service.checkForUpdates(m);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(m)}throw new Error(`Call not found: ${l}`)}}e.UpdateChannel=k;class R{constructor(E){this.channel=E,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(l=>this.state=l),this.channel.call("_getInitialState").then(l=>this.state=l)}get state(){return this._state}set state(E){this._state=E,this._onStateChange.fire(E)}checkForUpdates(E){return this.channel.call("checkForUpdates",E)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(E){return this.channel.call("_applySpecificUpdate",E)}}e.UpdateChannelClient=R}),define(Z[88],ee([0,1,8,22,3,19,26,21,6,20,55,48]),function(q,e,v,t,k,R,M,E,l,m,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function y(d,S,C){return`${C.updateUrl}/api/update/${d}/${S}/${C.commit}`}e.createUpdateURL=y;let h=class{constructor(S,C,w,p,f,g){this.lifecycleMainService=S,this.configurationService=C,this.environmentMainService=w,this.requestService=p,this.logService=f,this.productService=g,this._state=b.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(S){this.logService.info("update#setState",S.type),this._state=S,this._onStateChange.fire(S)}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const S=this.getUpdateMode(),C=this.getProductQuality(S);if(!C){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(C),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(b.State.Idle(this.getUpdateType())),S==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}S==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,w=>this.logService.error(w))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(S){return S==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(S=60*60*1e3){return(0,v.timeout)(S).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(S){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(S)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(S){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(S=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${S}`),!S&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(S){}getUpdateType(){return 1}doQuitAndInstall(){}};h=ve([J(0,E.ILifecycleMainService),J(1,R.IConfigurationService),J(2,M.IEnvironmentMainService),J(3,I.IRequestService),J(4,l.ILogService),J(5,m.IProductService)],h),e.AbstractUpdateService=h}),define(Z[238],ee([0,1,15,53,3,2,19,26,21,6,20,55,36,48,88]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let S=class extends d.AbstractUpdateService{constructor(w,p,f,g,a,n,o){super(w,p,g,a,n,o),this.telemetryService=f,this.disposables=new R.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"error",(w,p)=>p)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(w,p,f)=>({url:p,version:f,productVersion:f}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(w,p,f,g)=>({releaseNotes:p,version:f,productVersion:f,date:g}))}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(w){this.logService.error("UpdateService error:",w);const f=(this.state.type==="checking for updates"?this.state.explicit:!0)?w:void 0;this.setState(h.State.Idle(1,f))}buildUpdateFeedUrl(w){let p;this.productService.darwinUniversalAssetId?p=this.productService.darwinUniversalAssetId:p=process.arch==="x64"?"darwin":"darwin-arm64";const f=(0,d.createUpdateURL)(p,w,this.productService);try{v.autoUpdater.setFeedURL({url:f})}catch(g){this.logService.error("Failed to set update feed URL",g);return}return f}doCheckForUpdates(w){this.setState(h.State.CheckingForUpdates(w)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(w){this.state.type==="checking for updates"&&this.setState(h.State.Downloading(w))}onUpdateDownloaded(w){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:w.version}),this.setState(h.State.Ready(w)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(h.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ve([t.memoize],S.prototype,"onRawError",null),ve([t.memoize],S.prototype,"onRawUpdateNotAvailable",null),ve([t.memoize],S.prototype,"onRawUpdateAvailable",null),ve([t.memoize],S.prototype,"onRawUpdateDownloaded",null),S=ve([J(0,l.ILifecycleMainService),J(1,M.IConfigurationService),J(2,y.ITelemetryService),J(3,E.IEnvironmentMainService),J(4,b.IRequestService),J(5,m.ILogService),J(6,I.IProductService)],S),e.DarwinUpdateService=S}),define(Z[239],ee([0,1,45,40,8,3,9,26,21,6,36,48]),function(q,e,v,t,k,R,M,E,l,m,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let y=class{constructor(S,C,w){if(this.lifecycleMainService=S,this.logService=w,this._state=b.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,C.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(b.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}get state(){return this._state}setState(S){this.logService.info("update#setState",S.type),this._state=S,this._onStateChange.fire(S)}scheduleCheckForUpdates(S=60*60*1e3){return(0,k.timeout)(S).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(S){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(S)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(S){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(S=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${S}`),!S&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(S){}};y=ve([J(0,l.ILifecycleMainService),J(1,E.IEnvironmentMainService),J(2,m.ILogService)],y);let h=class extends y{constructor(S,C,w,p,f,g){super(w,p,f),this.snap=S,this.snapRevision=C,this.telemetryService=g;const a=(0,t.watch)(M.dirname(this.snap)),n=R.Event.fromNodeEventEmitter(a,"change",(s,c)=>c),o=R.Event.filter(n,s=>s==="current"),r=R.Event.debounce(o,(s,c)=>c,2e3)(()=>this.checkForUpdates(!1));w.onWillShutdown(()=>{r.dispose(),a.close()})}doCheckForUpdates(){this.setState(b.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(S=>{S?this.setState(b.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2)))},S=>{this.logService.error(S),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2,S.message||S))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const S=await new Promise((w,p)=>(0,t.realpath)(`${M.dirname(this.snap)}/current`,(f,g)=>f?p(f):w(g))),C=M.basename(S);return this.snapRevision!==C}isLatestVersion(){return this.isUpdateAvailable().then(void 0,S=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};h=ve([J(2,l.ILifecycleMainService),J(3,E.IEnvironmentMainService),J(4,m.ILogService),J(5,I.ITelemetryService)],h),e.SnapUpdateService=h}),define(Z[51],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,v.createDecorator)("IUriIdentityService")}),define(Z[240],ee([0,1,51,190,14,16,126,3,2]),function(q,e,v,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(y){this.uri=y,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let I=class{constructor(y){this._fileService=y,this._dispooables=new l.DisposableStore,this._limit=2**16;const h=new Map,d=S=>{let C=h.get(S.scheme);return C===void 0&&(C=y.hasProvider(S)&&!this._fileService.hasCapability(S,1024),h.set(S.scheme,C)),C};this._dispooables.add(E.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(S=>{h.delete(S.scheme)})),this.extUri=new R.ExtUri(d),this._canonicalUris=new M.SkipList((S,C)=>this.extUri.compare(S,C,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(y){this._fileService.hasProvider(y)&&(y=(0,R.normalizePath)(y));const h=this._canonicalUris.get(y);return h?h.touch().uri.with({fragment:y.fragment}):(this._canonicalUris.set(y,new m(y)),this._checkTrim(),y)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const y=[...this._canonicalUris.entries()].sort((d,S)=>d[1].touch<S[1].touch?1:d[1].touch>S[1].touch?-1:0);m._clock=0,this._canonicalUris.clear();const h=this._limit*.5;for(let d=0;d<h;d++)this._canonicalUris.set(y[d][0],y[d][1].touch())}};I=ve([J(0,k.IFileService)],I),e.UriIdentityService=I,(0,t.registerSingleton)(v.IUriIdentityService,I,!0)}),define(Z[114],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(Z[241],ee([0,1,7]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(E){this.handler=E}listen(E,l){throw new Error(`Event not found: ${l}`)}call(E,l,m){switch(l){case"handleURL":return this.handler.handleURL(v.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${l}`)}}e.URLHandlerChannel=t;class k{constructor(E){this.channel=E}handleURL(E,l){return this.channel.call("handleURL",[E.toJSON(),l])}}e.URLHandlerChannelClient=k;class R{constructor(E){this.next=E}async routeCall(E,l,m,I){if(l!=="handleURL")throw new Error(`Call not found: ${l}`);if(m){const b=v.URI.revive(m);if(b&&b.query){const y=/\bwindowId=(\d+)/.exec(b.query);if(y){const h=y[1],d=new RegExp(`window:${h}`),S=E.connections.find(C=>d.test(C.ctx));if(S)return S}}}return this.next.routeCall(E,l,m,I)}routeEvent(E,l){throw new Error(`Event not found: ${l}`)}}e.URLHandlerRouter=R}),define(Z[242],ee([0,1,8,2,7,20]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends t.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(m,I){const b=[...this.handlers.values()];return(0,v.first)(b.map(y=>()=>y.handleURL(m,I)),void 0,!1).then(y=>y||!1)}registerHandler(m){return this.handlers.add(m),(0,t.toDisposable)(()=>this.handlers.delete(m))}}e.AbstractURLService=M;let E=class extends M{constructor(m){super(),this.productService=m}create(m){let{authority:I,path:b,query:y,fragment:h}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return I&&b&&b.indexOf("/")!==0&&(b=`/${b}`),k.URI.from({scheme:this.productService.urlProtocol,authority:I,path:b,query:y,fragment:h})}};E=ve([J(0,R.IProductService)],E),e.NativeURLService=E}),define(Z[243],ee([0,1,15,8,3,2,4,7]),function(q,e,v,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function l(I){try{return E.URI.parse(I)}catch{return null}}class m{constructor(b,y,h,d,S){if(this.urlService=y,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=b,M.isWindows){const p=d.isBuilt?[]:[`"${d.appRoot}"`];p.push("--open-url","--"),v.app.setAsDefaultProtocolClient(S.urlProtocol,process.execPath,p)}const C=k.Event.map(k.Event.fromNodeEventEmitter(v.app,"open-url",(p,f)=>({event:p,url:f})),({event:p,url:f})=>(p.preventDefault(),f));this.disposables.add(C(p=>{const f=l(p);!f||this.urlService.open(f,{originalUrl:p})})),h.getWindows().filter(p=>p.isReady).length>0?this.flush():k.Event.once(h.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const b=[];for(const y of this.uris)await this.urlService.open(y.uri,{originalUrl:y.url})||b.push(y);b.length!==0&&(this.uris=b,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=m}),define(Z[244],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(Z[245],ee([0,1,15,2,13,7]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends t.Disposable{constructor(){super();const l=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(k.Schemas.vscodeWebview,l)}handleWebviewRequest(l,m){try{const I=R.URI.parse(l.url),b=M.validWebviewFilePaths.get(I.path);if(typeof b=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${b}`,h=k.FileAccess.asFileUri(y,q);return m({path:decodeURIComponent(h.fsPath),headers:{...k.COI.getHeadersFromQuery(l.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=M,M.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(Z[74],ee([0,1,4]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(I){return!!I.workspaceUri}e.isWorkspaceToOpen=t;function k(I){return!!I.folderUri}e.isFolderToOpen=k;function R(I){return!!I.fileUri}e.isFileToOpen=R;function M(I){const b=E(I),y=I.getValue("window.menuBarVisibility");return y==="default"||b==="native"&&y==="compact"||v.isMacintosh&&v.isNative?"classic":y}e.getMenuBarVisibility=M;function E(I){if(v.isWeb)return"custom";const b=I.getValue("window");if(b){if(v.isMacintosh&&b.nativeTabs===!0||v.isMacintosh&&b.nativeFullScreen===!1)return"native";const d=b.titleBarStyle;if(d==="native"||d==="custom")return d}return v.isLinux?"native":"custom"}e.getTitleBarStyle=E;function l(I,b){if(!v.isWindows||v.isWeb||!b.isBuilt||E(I)==="native")return!1;const y=I.getValue("window.experimental.windowControlsOverlay.enabled");return typeof y=="boolean"?y:!1}e.useWindowControlsOverlay=l;function m(I=0){return Math.pow(1.2,I)}e.zoomLevelToZoomFactor=m}),define(Z[115],ee([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var v;(function(E){E[E.INITIAL=1]="INITIAL",E[E.LOAD=2]="LOAD",E[E.RELOAD=3]="RELOAD"})(v=e.LoadReason||(e.LoadReason={}));var t;(function(E){E[E.CLOSE=1]="CLOSE",E[E.QUIT=2]="QUIT",E[E.RELOAD=3]="RELOAD",E[E.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(E=1){return{width:1024,height:768,mode:E}};e.defaultWindowState=k;var R;(function(E){E[E.Maximized=0]="Maximized",E[E.Normal=1]="Normal",E[E.Minimized=2]="Minimized",E[E.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var M;(function(E){E[E.UNRESPONSIVE=1]="UNRESPONSIVE",E[E.PROCESS_GONE=2]="PROCESS_GONE",E[E.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={}))}),define(Z[32],ee([0,1,5]),function(q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,v.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(Z[246],ee([0,1,15,22,3,66,2,29,69,103,6,20,32]),function(q,e,v,t,k,R,M,E,l,m,I,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var h;(function(S){S[S.Initial=1]="Initial",S[S.StoredCredentialsUsed=2]="StoredCredentialsUsed",S[S.LoginDialogShown=3]="LoginDialogShown"})(h||(h={}));let d=class extends M.Disposable{constructor(C,w,p,f,g){super(),this.logService=C,this.windowsMainService=w,this.credentialsService=p,this.encryptionMainService=f,this.productService=g,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=h.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const C=k.Event.fromNodeEventEmitter(v.app,"login",(w,p,f,g,a)=>({event:w,webContents:p,req:f,authInfo:g,callback:a}));this._register(C(this.onLogin,this))}async onLogin({event:C,authInfo:w,req:p,callback:f}){if(!w.isProxy)return;if(!this.pendingProxyResolve&&this.state===h.LoginDialogShown&&p.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}C.preventDefault();let g;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),g=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(w);try{g=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}f(g?.username,g?.password)}async resolveProxyCredentials(C){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.doResolveProxyCredentials(C);if(w)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(C){this.logService.trace("auth#doResolveProxyCredentials - enter",C);const w=String((0,R.hash)({scheme:C.scheme,host:C.host,port:C.port}));let p,f;try{const o=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,w);if(o){const i=JSON.parse(await this.encryptionMainService.decrypt(o));p=i.username,f=i.password}}catch(o){this.logService.error(o)}if(this.state!==h.StoredCredentialsUsed&&typeof p=="string"&&typeof f=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=h.StoredCredentialsUsed,{username:p,password:f};const g=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!g){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${g.id} to handle proxy login`);const a={authInfo:C,username:this.sessionCredentials?.username??p,password:this.sessionCredentials?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,E.generateUuid)()}`};g.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,a),this.state=h.LoginDialogShown;const n=await new Promise(o=>{const i=async(r,s,c)=>{if(s===a.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${g.id}`),g.win?.webContents.off("ipc-message",i),c){const u={username:c.username,password:c.password};try{if(c.remember){const P=await this.encryptionMainService.encrypt(JSON.stringify(u));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,w,P)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,w)}catch(P){this.logService.error(P)}o({username:u.username,password:u.password})}else o(void 0)};g.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=n,n}};d=ve([J(0,I.ILogService),J(1,y.IWindowsMainService),J(2,l.ICredentialsMainService),J(3,m.IEncryptionMainService),J(4,b.IProductService)],d),e.ProxyAuthHandler=d}),define(Z[247],ee([0,1,69,6,35,20,32,202]),function(q,e,v,t,k,R,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let l=class extends E.BaseCredentialsMainService{constructor(I,b,y,h){super(I),this.environmentMainService=b,this.productService=y,this.windowsMainService=h,this.surfaceKeytarLoadError=d=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",d.message??d)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new v.InMemoryCredentialsProvider,this._keytarCache;const I=await new Promise((b,y)=>{q(["keytar"],b,y)});return await I.findCredentials("test-keytar-loads"),this._keytarCache=I,this._keytarCache}};l=ve([J(0,t.ILogService),J(1,k.INativeEnvironmentService),J(2,R.IProductService),J(3,M.IWindowsMainService)],l),e.CredentialsNativeMainService=l}),define(Z[248],ee([0,1,17,2,3,6,21,79,45,277,8,13,50,4,33,15,32]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const w=S.UtilityProcess,p=typeof w<"u";let f=class Ft{constructor(o,i,r){this._logService=o,this._windowsMainService=r,this._shutdown=!1,this._extHosts=new Map,i.onWillShutdown(s=>{this._shutdown=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(o){const i=this._extHosts.get(o);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(o){return this._getExtHost(o).onStdout}onDynamicStderr(o){return this._getExtHost(o).onStderr}onDynamicMessage(o){return this._getExtHost(o).onMessage}onDynamicError(o){return this._getExtHost(o).onError}onDynamicExit(o){return this._getExtHost(o).onExit}async canUseUtilityProcess(){return p}async createExtensionHost(o){if(this._shutdown)throw(0,v.canceled)();const i=String(++Ft._lastId);let r;if(o){if(!p)throw new Error("Cannot use UtilityProcess!");r=new a(i,this._logService,this._windowsMainService)}else r=new g(i,this._logService);return this._extHosts.set(i,r),r.onExit(({pid:s,code:c,signal:u})=>{this._logService.info(`Extension host with pid ${s} exited with code: ${c}, signal: ${u}.`),setTimeout(()=>{r.dispose(),this._extHosts.delete(i)})}),{id:i}}async start(o,i){if(this._shutdown)throw(0,v.canceled)();return this._getExtHost(o).start(i)}async enableInspectPort(o){if(this._shutdown)throw(0,v.canceled)();const i=this._extHosts.get(o);return i?i.enableInspectPort():!1}async kill(o){if(this._shutdown)throw(0,v.canceled)();const i=this._extHosts.get(o);!i||i.kill()}async _killAllNow(){for(const[,o]of this._extHosts)o.kill()}async _waitForAllExit(o){const i=[];for(const[,r]of this._extHosts)i.push(r.waitForExit(o));return I.Promises.settled(i).then(()=>{})}};f._lastId=0,f=ve([J(0,R.ILogService),J(1,M.ILifecycleMainService),J(2,C.IWindowsMainService)],f),e.ExtensionHostStarter=f;let g=class extends t.Disposable{constructor(o,i){super(),this.id=o,this._logService=i,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(o){h.isCI&&this._logService.info("Calling fork to start extension host...");const i=E.StopWatch.create(!1);this._process=(0,l.fork)(b.FileAccess.asFileUri("bootstrap-fork",q).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,y.mixin)({cwd:(0,d.cwd)()},o));const r=i.elapsed(),s=this._process.pid;this._logService.info(`Starting extension host with pid ${s} (fork() took ${r} ms).`);const c=new m.StringDecoder("utf-8");this._process.stdout?.on("data",P=>{const D=typeof P=="string"?P:c.write(P);this._onStdout.fire(D)});const u=new m.StringDecoder("utf-8");this._process.stderr?.on("data",P=>{const D=typeof P=="string"?P:u.write(P);this._onStderr.fire(D)}),this._process.on("message",P=>{this._onMessage.fire(P)}),this._process.on("error",P=>{this._onError.fire({error:(0,v.transformErrorForSerialization)(P)})}),this._process.on("exit",(P,D)=>{this._hasExited=!0,this._onExit.fire({pid:s,code:P,signal:D})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):h.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(o){if(!this._process)return;const i=this._process.pid;this._logService.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,I.timeout)(o)]),this._hasExited||(this._logService.info(`Extension host with pid ${i} did not exit within ${o}ms.`),this._process.kill())}};g=ve([J(1,R.ILogService)],g);let a=class extends t.Disposable{constructor(o,i,r){super(),this.id=o,this._logService=i,this._windowsMainService=r,this.onStdout=k.Event.None,this.onStderr=k.Event.None,this.onError=k.Event.None,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(o){const i=this._windowsMainService.getWindowById(o.responseWindowId);if(!i){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const r=i.win;if(!r||r.isDestroyed()||r.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=`extensionHost${this.id}`,c=b.FileAccess.asFileUri("bootstrap-fork.js",q).fsPath,u=["--type=extensionHost","--skipWorkspaceStorageLock"],P=o.execArgv||[],D={...o.env};for(const Y of Object.keys(D))D[Y]=String(D[Y]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new w(c,u,{serviceName:s,env:D,execArgv:P}),this._register(k.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const T=k.Event.fromNodeEventEmitter(this._process,"exit",(Y,oe)=>oe);this._register(T(Y=>{this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${Y}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:Y,signal:""})}));const N=(Y,oe)=>{oe.type==="Utility"&&oe.name===s&&(this._logService.info(`UtilityProcess<${this.id}>: terminated unexpectedly with code ${oe.exitCode}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:oe.exitCode,signal:""}))};S.app.on("child-process-gone",N),this._register((0,t.toDisposable)(()=>{S.app.off("child-process-gone",N)}));const{port1:U,port2:$}=new S.MessageChannelMain;this._process.postMessage("port",null,[$]),r.webContents.postMessage(o.responseChannel,o.responseNonce,[U])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):h.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(o){if(!this._process)return;const i=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,I.timeout)(o)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${i} did not exit within ${o}ms, will kill it now.`),this._process.kill())}};a=ve([J(1,R.ILogService),J(2,C.IWindowsMainService)],a)}),define(Z[249],ee([0,1,15,3,2,245,32]),function(q,e,v,t,k,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let E=class extends k.Disposable{constructor(m){super(),this.windowsMainService=m,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,I){let b;if(typeof m.windowId=="number"){const{windowId:y}=m,h=this.windowsMainService.getWindowById(y);if(!h?.win)throw new Error(`Invalid windowId: ${y}`);b=h.win.webContents}else{const{webContentsId:y}=m;if(b=v.webContents.fromId(y),!b)throw new Error(`Invalid webContentsId: ${y}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(I)}async findInFrame(m,I,b,y){const d=this.getFrameByName(m,I);if(typeof d.findInFrame=="function"){d.findInFrame(b,{findNext:y.findNext,forward:y.forward});const S=(C,w)=>{w.finalUpdate&&(this._onFoundInFrame.fire(w),d.removeListener("found-in-frame",S))};d.on("found-in-frame",S)}}async stopFindInFrame(m,I,b){const h=this.getFrameByName(m,I);typeof h.stopFindInFrame=="function"&&h.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}getFrameByName(m,I){const b=this.windowsMainService.getWindowById(m.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${m}`);const y=b.win.webContents.mainFrame.framesInSubtree.find(h=>h.name===I);if(!y)throw new Error(`Unknown frame: ${I}`);return y}};E=ve([J(0,M.IWindowsMainService)],E),e.WebviewMainService=E}),define(Z[250],ee([0,1,8,3,2]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:E,onDidFocusWindow:l,getActiveWindowId:m}){super(),this.disposables=this._register(new k.DisposableStore),t.Event.latch(t.Event.any(E,l))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>m()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(E){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=E}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(Z[27],ee([0,1,173,9,31,16,7,5,13]),function(q,e,v,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,E.createDecorator)("contextService");function m(o){const i=o;return typeof i?.id=="string"&&M.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=m,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function I(o,i){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,t.basename)(o)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=o;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=I;function b(o){const i=o;return typeof i?.id=="string"&&M.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=b;function y(o){const i=o;if(i?.uri)return{id:i.id,uri:M.URI.revive(i.uri)};const r=o;if(r?.configPath)return{id:r.id,configPath:M.URI.revive(r.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=y;var h;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(h=e.WorkbenchState||(e.WorkbenchState={}));function d(o){const i=o;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=d;function S(o){const i=o;return!!(i&&typeof i=="object"&&M.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=S;class C{constructor(i,r,s,c,u){this._id=i,this._transient=s,this._configuration=c,this._ignorePathCasing=u,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=C;class w{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,R.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=w;function p(o){return new w({uri:o,index:0,name:(0,R.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,v.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function f(o,i){return R.extUriBiasedIgnorePathCase.isEqualOrParent(o,i.untitledWorkspacesHome)}e.isUntitledWorkspace=f;function g(o){let i;return M.URI.isUri(o)?i=o:i=o.configuration,i?.scheme===l.Schemas.tmp}e.isTemporaryWorkspace=g;function a(o,i){return!f(o,i)&&!g(o)}e.isSavedWorkspace=a;function n(o){return(typeof o=="string"?(0,t.extname)(o):(0,R.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(Z[56],ee([0,1,15,8,66,34,2,80,4,12,23,150,5,6,27]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let S=class{constructor(w){this.logService=w,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(w,p){return this.doPick({...w,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},p)}pickFolder(w,p){return this.doPick({...w,pickFolders:!0,title:(0,b.localize)(1,null)},p)}pickFile(w,p){return this.doPick({...w,pickFiles:!0,title:(0,b.localize)(2,null)},p)}pickWorkspace(w,p){const f=(0,b.localize)(3,null),g=(0,R.mnemonicButtonLabel)((0,b.localize)(4,null)),a=d.WORKSPACE_FILTER;return this.doPick({...w,pickFiles:!0,title:f,filters:a,buttonLabel:g},p)}async doPick(w,p){const f={title:w.title,buttonLabel:w.buttonLabel,filters:w.filters,defaultPath:w.defaultPath};(typeof w.pickFiles=="boolean"||typeof w.pickFolders=="boolean")&&(f.properties=void 0,w.pickFiles&&w.pickFolders&&(f.properties=["multiSelections","openDirectory","openFile","createDirectory"])),f.properties||(f.properties=["multiSelections",w.pickFolders?"openDirectory":"openFile","createDirectory"]),l.isMacintosh&&f.properties.push("treatPackageAsDirectory");const g=await this.showOpenDialog(f,(0,m.withNullAsUndefined)(p||v.BrowserWindow.getFocusedWindow()));if(g&&g.filePaths&&g.filePaths.length>0)return g.filePaths}getWindowDialogQueue(w){if(w){let p=this.windowDialogQueues.get(w.id);return p||(p=new t.Queue,this.windowDialogQueues.set(w.id,p)),p}else return this.noWindowDialogueQueue}showMessageBox(w,p){return this.getWindowDialogQueue(p).queue(async()=>p?v.dialog.showMessageBox(p,w):v.dialog.showMessageBox(w))}async showSaveDialog(w,p){const f=this.acquireFileDialogLock(w,p);if(!f)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(p).queue(async()=>{let g;return p?g=await v.dialog.showSaveDialog(p,w):g=await v.dialog.showSaveDialog(w),g.filePath=this.normalizePath(g.filePath),g})}finally{(0,M.dispose)(f)}}normalizePath(w){return w&&l.isMacintosh&&(w=(0,E.normalizeNFC)(w)),w}normalizePaths(w){return w.map(p=>this.normalizePath(p))}async showOpenDialog(w,p){w.defaultPath&&(await I.Promises.exists(w.defaultPath)||(w.defaultPath=void 0));const f=this.acquireFileDialogLock(w,p);if(!f)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(p).queue(async()=>{let g;return p?g=await v.dialog.showOpenDialog(p,w):g=await v.dialog.showOpenDialog(w),g.filePaths=this.normalizePaths(g.filePaths),g})}finally{(0,M.dispose)(f)}}acquireFileDialogLock(w,p){if(!p)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",w);let f=this.windowFileDialogLocks.get(p.id);f||(f=new Set,this.windowFileDialogLocks.set(p.id,f));const g=(0,k.hash)(w);if(!f.has(g))return this.logService.trace("[DialogMainService]: new file dialog lock created",w),f.add(g),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",w),f?.delete(g),f?.size===0&&this.windowFileDialogLocks.delete(p.id)})}};S=ve([J(0,h.ILogService)],S),e.DialogMainService=S}),define(Z[251],ee([0,1,3,2,67,27]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends t.Disposable{constructor(l,m){super(),this.logService=l,this.storageMainService=m,this.onDidChangeApplicationStorageEmitter=this._register(new v.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(m.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(l,m){this._register(v.Event.debounce(l.onDidChangeStorage,(I,b)=>(I?I.push(b):I=[b],I),M.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&m.fire(this.serializeStorageChangeEvents(I,l))}))}serializeStorageChangeEvents(l,m){const I=new Map,b=new Set;return l.forEach(y=>{const h=m.get(y.key);typeof h=="string"?I.set(y.key,h):b.add(y.key)}),{changed:Array.from(I.entries()),deleted:Array.from(b.values())}}listen(l,m,I){switch(m){case"onDidChangeStorage":{const b=I.profile?(0,k.revive)(I.profile):void 0;if(!b)return this.onDidChangeApplicationStorageEmitter.event;let y=this.mapProfileToOnDidChangeProfileStorageEmitter.get(b.id);return y||(y=this._register(new v.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(b),y),this.mapProfileToOnDidChangeProfileStorageEmitter.set(b.id,y)),y.event}}throw new Error(`Event not found: ${m}`)}async call(l,m,I){const b=I.profile?(0,k.revive)(I.profile):void 0,y=(0,R.reviveIdentifier)(I.workspace),h=await this.withStorageInitialized(b,y);switch(m){case"getItems":return Array.from(h.items.entries());case"updateItems":{const d=I;if(d.insert)for(const[S,C]of d.insert)h.set(S,C);d.delete?.forEach(S=>h.delete(S));break}case"isUsed":{const d=I.payload;if(typeof d=="string")return this.storageMainService.isUsed(d)}default:throw new Error(`Call not found: ${m}`)}}async withStorageInitialized(l,m){let I;m?I=this.storageMainService.workspaceStorage(m):l?I=this.storageMainService.profileStorage(l):I=this.storageMainService.applicationStorage;try{await I.init()}catch(b){this.logService.error(`StorageIPC#init: Unable to init ${m?"workspace":l?"profile":"application"} storage due to ${b}`)}return I}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[39],ee([0,1,66,3,2,16,12,7,170,35,14,5,6,27,31,51,8,29,25]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S,C,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function f(o){const i=o;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&E.URI.isUri(i.location)&&E.URI.isUri(i.globalStorageHome)&&E.URI.isUri(i.settingsResource)&&E.URI.isUri(i.keybindingsResource)&&E.URI.isUri(i.tasksResource)&&E.URI.isUri(i.snippetsHome)&&((0,M.isUndefined)(i.extensionsResource)||E.URI.isUri(i.extensionsResource)))}e.isUserDataProfile=f,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function g(o,i){return{id:o.id,isDefault:o.isDefault,name:o.name,location:E.URI.revive(o.location).with({scheme:i}),globalStorageHome:E.URI.revive(o.globalStorageHome).with({scheme:i}),settingsResource:E.URI.revive(o.settingsResource).with({scheme:i}),keybindingsResource:E.URI.revive(o.keybindingsResource).with({scheme:i}),tasksResource:E.URI.revive(o.tasksResource).with({scheme:i}),snippetsHome:E.URI.revive(o.snippetsHome).with({scheme:i}),extensionsResource:E.URI.revive(o.extensionsResource)?.with({scheme:i}),useDefaultFlags:o.useDefaultFlags,isTransient:o.isTransient}}e.reviveProfile=g,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function a(o,i,r,s){return{id:(0,v.hash)(i.path).toString(16),name:o,location:i,isDefault:!1,globalStorageHome:(0,R.joinPath)(i,"globalStorage"),settingsResource:(0,R.joinPath)(i,"settings.json"),keybindingsResource:(0,R.joinPath)(i,"keybindings.json"),tasksResource:(0,R.joinPath)(i,"tasks.json"),snippetsHome:(0,R.joinPath)(i,"snippets"),extensionsResource:(0,R.joinPath)(i,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:r,isTransient:s}}e.toUserDataProfile=a;let n=class extends k.Disposable{constructor(i,r,s,c){super(),this.environmentService=i,this.fileService=r,this.uriIdentityService=s,this.logService=c,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new d.ResourceMap},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}get profilesObject(){if(!this._profilesObject){const i=this.enabled?this.getStoredProfiles().map(u=>a(u.name,u.location,u.useDefaultFlags)):[];let r;const s=new d.ResourceMap,c=a((0,l.localize)(0,null),this.environmentService.userRoamingDataHome);if(i.unshift({...c,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||i.length>0||this.transientProfilesObject.profiles.length>0?c.extensionsResource:void 0}),i.length){const u=this.getStoredProfileAssociations();if(u.workspaces)for(const[P,D]of Object.entries(u.workspaces)){const T=E.URI.parse(P),N=E.URI.parse(D),U=i.find($=>this.uriIdentityService.extUri.isEqual($.location,N));U&&s.set(T,U)}if(u.emptyWindow){const P=E.URI.parse(u.emptyWindow);r=i.find(D=>this.uriIdentityService.extUri.isEqual(D.location,P))}}this._profilesObject={profiles:i,workspaces:s,emptyWindow:r}}return this._profilesObject}async createTransientProfile(i){const r="Temp",s=new RegExp(`${(0,p.escapeRegExpCharacters)(r)}\\s(\\d+)`);let c=0;for(const P of this.profiles){const D=s.exec(P.name),T=D?parseInt(D[1]):0;c=T>c?T:c}const u=`${r} ${c+1}`;return this.createProfile(u,void 0,i,!0)}async createProfile(i,r,s,c){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=await this.doCreateProfile(i,r,c);return s&&await this.setProfileForWorkspace(s,u),u}async doCreateProfile(i,r,s){let c=this.profileCreationPromises.get(i);return c||(c=(async()=>{try{const u=this.profiles.find(T=>T.name===i);if(u)return u;const P=a(i,(0,R.joinPath)(this.profilesHome,(0,v.hash)((0,w.generateUuid)()).toString(16)),r,s);await this.fileService.createFolder(P.location);const D=[];return this._onWillCreateProfile.fire({profile:P,join(T){D.push(T)}}),await C.Promises.settled(D),this.updateProfiles([P],[],[]),P}finally{this.profileCreationPromises.delete(i)}})(),this.profileCreationPromises.set(i,c)),c}async updateProfile(i,r,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(u=>u.id===i.id);if(!c)throw new Error(`Profile '${i.name}' does not exist`);return c=a(r,c.location,s),this.updateProfiles([],[],[c]),c}async removeProfile(i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(c=>c.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const s=[];this._onWillRemoveProfile.fire({profile:r,join(c){s.push(c)}}),await C.Promises.settled(s),r.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const c of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(c)?.id&&this.profilesObject.workspaces.delete(c);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(c){this.logService.error(c)}}getOrSetProfileForWorkspace(i,r=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let s=this.getProfileForWorkspace(i);return s||(s=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(i,s)),s}async setProfileForWorkspace(i,r){this.setProfileForWorkspaceSync(i,r)}setProfileForWorkspaceSync(i,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const s=this.profiles.find(c=>c.id===r.id);if(!s)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(i,s)}unsetWorkspace(i,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(i,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(s=>!this.uriIdentityService.extUri.isEqual(s.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.getWorkspace(i);return E.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(i){return(0,h.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,h.isWorkspaceIdentifier)(i)?i.configPath:"empty-window"}isProfileAssociatedToWorkspace(i){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,i.location)||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,i.location)||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location)))}updateProfiles(i,r,s){const c=[...this.profiles,...i],u=[];this.transientProfilesObject.profiles=[];for(let P of c)P.isDefault||r.some(D=>P.id===D.id)||(P=s.find(D=>P.id===D.id)??P,P.isTransient?this.transientProfilesObject.profiles.push(P):u.push({location:P.location,name:P.name,useDefaultFlags:P.useDefaultFlags}));this.saveStoredProfiles(u),this._profilesObject=void 0,this.triggerProfilesChanges(i,r,s)}triggerProfilesChanges(i,r,s){this._onDidChangeProfiles.fire({added:i,removed:r,updated:s,all:this.profiles})}updateWorkspaceAssociation(i,r,s){s=r?.isTransient?!0:s,s||this.updateWorkspaceAssociation(i,void 0,!0);const c=this.getWorkspace(i),u=s?this.transientProfilesObject:this.profilesObject;E.URI.isUri(c)?(u.workspaces.delete(c),r&&u.workspaces.set(c,r)):u.emptyWindow=r,s||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[s,c]of this.profilesObject.workspaces.entries())i[s.toString()]=c.location.toString();const r=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:i,emptyWindow:r}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}};n.PROFILES_KEY="userDataProfiles",n.PROFILE_ASSOCIATIONS_KEY="profileAssociations",n=ve([J(0,m.IEnvironmentService),J(1,I.IFileService),J(2,S.IUriIdentityService),J(3,y.ILogService)],n),e.UserDataProfilesService=n}),define(Z[89],ee([0,1,24,8,50,18,17,43,136,2,13,9,4,16,188,95,12,7,155,35,110,109,187,14,5,6,20,3,67,72,39,51,186]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S,C,w,p,f,g,a,n,o,i,r,s,c,u,P,D,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var U;(function(G){function K(F,A){if(F===A)return!0;const W=Object.keys(F),z=new Set;for(const te of Object.keys(A))z.add(te);if(W.length!==z.size)return!1;for(const te of W){if(F[te]!==A[te])return!1;z.delete(te)}return z.size===0}G.equals=K})(U=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let $=class extends m.Disposable{constructor(K,F,A,W,z,te,B,H,L,O,_){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=F,this.extensionsControlLocation=A,this.cacheLocation=W,this.userDataProfilesService=z,this.extensionsProfileScannerService=te,this.fileService=B,this.logService=H,this.environmentService=L,this.productService=O,this.instantiationService=_,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ue,(0,h.joinPath)(this.cacheLocation,a.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ue,(0,h.joinPath)(this.cacheLocation,a.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(oe,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,g.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(K,F,A){const[W,z]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(F)]),te=A?await this.scanExtensionsUnderDevelopment(K,[...W,...z]):[];return this.dedupExtensions(W,z,te,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const F=[];F.push(this.scanDefaultSystemExtensions(!!K.useCache,K.language)),F.push(this.scanDevSystemExtensions(K.language,!!K.checkControlFile));const[A,W]=await Promise.all(F);return this.applyScanOptions([...A,...W],0,K,!1)}async scanUserExtensions(K){this.logService.trace("Started scanning user extensions");const F=await this.createExtensionScannerInput(K.profileLocation??this.userExtensionsLocation,!!K.profileLocation,1,!K.includeUninstalled,K.language);let W=await(K.useCache&&!F.devMode&&F.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return W=await this.applyScanOptions(W,1,K,!0),this.logService.trace("Scanned user extensions:",W.length),W}async scanExtensionsUnderDevelopment(K,F){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const A=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===I.Schemas.file).map(async W=>{const z=await this.createExtensionScannerInput(W,!1,1,!0,K.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(z)).map(B=>(B.type=F.find(H=>(0,g.areSameExtensions)(H.identifier,B.identifier))?.type??B.type,this.extensionsScanner.validate(B,z)))}))).flat();return this.applyScanOptions(A,"development",K,!0)}return[]}async scanExistingExtension(K,F,A){const W=await this.createExtensionScannerInput(K,!1,F,!0,A.language),z=await this.extensionsScanner.scanExtension(W);return!z||!A.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions(K,F,A){const W=await this.createExtensionScannerInput(K,!1,F,!0,A.language),z=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(z,F,A,!0)}async scanMetadata(K){const F=(0,h.joinPath)(K,"package.json"),A=(await this.fileService.readFile(F)).value.toString();return JSON.parse(A).__metadata}async updateMetadata(K,F){const A=(0,h.joinPath)(K,"package.json"),W=(await this.fileService.readFile(A)).value.toString(),z=JSON.parse(W);F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0,z.__metadata={...z.__metadata,...F},await this.fileService.writeFile((0,h.joinPath)(K,"package.json"),R.VSBuffer.fromString(JSON.stringify(z,null,"	")))}async applyScanOptions(K,F,A,W){return A.includeAllVersions||(K=this.dedupExtensions(F===0?K:void 0,F===1?K:void 0,F==="development"?K:void 0,await this.getTargetPlatform(),W)),A.includeInvalid||(K=K.filter(z=>z.isValid)),K.sort((z,te)=>{const B=b.basename(z.location.fsPath),H=b.basename(te.location.fsPath);return B<H?-1:B>H?1:0})}dedupExtensions(K,F,A,W,z){const te=(H,L,O)=>{if(H.isValid&&!L.isValid)return!1;if(H.isValid===L.isValid){if(z&&d.gt(H.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${H.location.path} with version ${H.manifest.version}`),!1;if(d.eq(H.manifest.version,L.manifest.version)){if(H.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${H.location.path} with same version`),!1;if(H.targetPlatform===W)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${H.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${H.location.path} with ${L.location.path}.`),!0},B=new Map;return K?.forEach(H=>{const L=a.ExtensionIdentifier.toKey(H.identifier.id),O=B.get(L);(!O||te(O,H,!1))&&B.set(L,H)}),F?.forEach(H=>{const L=a.ExtensionIdentifier.toKey(H.identifier.id),O=B.get(L);if(!O&&K&&H.type===0){this.logService.debug(`Skipping obsolete system extension ${H.location.path}.`);return}(!O||te(O,H,!1))&&B.set(L,H)}),A?.forEach(H=>{const L=a.ExtensionIdentifier.toKey(H.identifier.id),O=B.get(L);(!O||te(O,H,!0))&&B.set(L,H),B.set(L,H)}),[...B.values()]}async scanDefaultSystemExtensions(K,F){this.logService.trace("Started scanning system extensions");const A=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,F),z=await(K&&!A.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(A);return this.logService.trace("Scanned system extensions:",z.length),z}async scanDevSystemExtensions(K,F){const A=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!A?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=F?await this.getBuiltInExtensionControl():{},z=[],te=w.URI.file(b.normalize(b.join(I.FileAccess.asFileUri("",q).fsPath,"..",".build","builtInExtensions")));for(const H of A){const L=W[H.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":z.push((0,h.joinPath)(te,H.name));break;default:z.push(w.URI.file(L));break}}const B=await Promise.all(z.map(async H=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(H,!1,0,!0,K))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,v.coalesce)(B)}async getBuiltInExtensionControl(){try{const K=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(K.value.toString())}catch{return{}}}async createExtensionScannerInput(K,F,A,W,z,te=!0){const B=await this.getTranslations(z??y.language),H=await this.getMtime(K),L=F?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=L?await this.getMtime(L):void 0;return new Y(K,H,L,O,F,A,W,te,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,z,B)}async getMtime(K){try{const F=await this.fileService.stat(K);if(typeof F.mtime=="number")return F.mtime}catch{}}};$=ve([J(4,D.IUserDataProfilesService),J(5,P.IExtensionsProfileScannerService),J(6,o.IFileService),J(7,r.ILogService),J(8,f.IEnvironmentService),J(9,s.IProductService),J(10,i.IInstantiationService)],$),e.AbstractExtensionsScannerService=$;class Y{constructor(K,F,A,W,z,te,B,H,L,O,_,V,x,re){this.location=K,this.mtime=F,this.applicationExtensionslocation=A,this.applicationExtensionslocationMtime=W,this.profile=z,this.type=te,this.excludeObsolete=B,this.validate=H,this.productVersion=L,this.productDate=O,this.productCommit=_,this.devMode=V,this.language=x,this.translations=re}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,F){return(0,h.isEqual)(K.location,F.location)&&K.mtime===F.mtime&&(0,h.isEqual)(K.applicationExtensionslocation,F.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===F.applicationExtensionslocationMtime&&K.profile===F.profile&&K.type===F.type&&K.excludeObsolete===F.excludeObsolete&&K.validate===F.validate&&K.productVersion===F.productVersion&&K.productDate===F.productDate&&K.productCommit===F.productCommit&&K.devMode===F.devMode&&K.language===F.language&&U.equals(K.translations,F.translations)}}let oe=class extends m.Disposable{constructor(K,F,A,W,z){super(),this.obsoleteFile=K,this.extensionsProfileScannerService=F,this.uriIdentityService=A,this.fileService=W,this.logService=z}async scanExtensions(K){const F=K.profile?await this.scanExtensionsFromProfile(K):await this.scanExtensionsFromLocation(K);let A={};if(K.excludeObsolete&&K.type===1)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();A=JSON.parse(W)}catch{}return(0,C.isEmptyObject)(A)?F:F.filter(W=>!A[g.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation(K){const F=await this.fileService.resolve(K.location);if(!F.children?.length)return[];const A=await Promise.all(F.children.map(async W=>{if(!W.isDirectory||K.type===1&&(0,h.basename)(W.resource).indexOf(".")===0)return null;const z=new Y(W.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(z)}));return(0,v.coalesce)(A).sort((W,z)=>W.location.path<z.location.path?-1:1)}async scanExtensionsFromProfile(K){let F=await this.scanExtensionsFromProfileResource(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(K.location,K.applicationExtensionslocation)){F=F.filter(W=>!W.metadata?.isApplicationScoped);const A=await this.scanExtensionsFromProfileResource(K.applicationExtensionslocation,W=>!!W.metadata?.isApplicationScoped,K);F.push(...A)}return F}async scanExtensionsFromProfileResource(K,F,A){const W=await this.extensionsProfileScannerService.scanProfileExtensions(K);if(!W.length)return[];const z=await Promise.all(W.map(async te=>{if(F(te)){const B=new Y(te.location,A.mtime,A.applicationExtensionslocation,A.applicationExtensionslocationMtime,A.profile,A.type,A.excludeObsolete,A.validate,A.productVersion,A.productDate,A.productCommit,A.devMode,A.language,A.translations);return this.scanExtension(B,te.metadata)}return null}));return(0,v.coalesce)(z)}async scanOneOrMultipleExtensions(K){try{if(await this.fileService.exists((0,h.joinPath)(K.location,"package.json"))){const F=await this.scanExtension(K);return F?[F]:[]}else return await this.scanExtensions(K)}catch(F){return this.logService.error(`Error scanning extensions at ${K.location.path}:`,(0,M.getErrorMessage)(F)),[]}}async scanExtension(K,F){try{let A=await this.scanExtensionManifest(K.location);if(A){A.publisher||(A.publisher=a.UNDEFINED_PUBLISHER),F=F??A.__metadata,delete A.__metadata;const W=(0,g.getGalleryExtensionId)(A.publisher,A.name),z=F?.id?{id:W,uuid:F.id}:{id:W},te=F?.isSystem?0:K.type,B=te===0||!!F?.isBuiltin;A=await this.translateManifest(K.location,A,Y.createNlsConfiguration(K));const H={type:te,identifier:z,manifest:A,location:K.location,isBuiltin:B,targetPlatform:F?.targetPlatform??"undefined",metadata:F,isValid:!0,validations:[]};return K.validate?this.validate(H,K):H}}catch(A){K.type!==0&&this.logService.error(A)}return null}validate(K,F){let A=!0;const W=(0,n.validateExtensionManifest)(F.productVersion,F.productDate,F.location,K.manifest,K.isBuiltin);for(const[z,te]of W)z===S.default.Error&&(A=!1,this.logService.error(this.formatMessage(F.location,te)));return K.isValid=A,K.validations=W,K}async scanExtensionManifest(K){const F=(0,h.joinPath)(K,"package.json");let A;try{A=(await this.fileService.readFile(F)).value.toString()}catch(z){return(0,o.toFileOperationResult)(z)!==1&&this.logService.error(this.formatMessage(K,(0,p.localize)(0,null,F.path,z.message))),null}let W;try{W=JSON.parse(A)}catch{const te=[];(0,E.parse)(A,te);for(const B of te)this.logService.error(this.formatMessage(K,(0,p.localize)(1,null,F.path,B.offset,B.length,(0,l.getParseErrorMessage)(B.error))));return null}return(0,E.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage(K,(0,p.localize)(2,null,F.path))),null):W}async translateManifest(K,F,A){const W=await this.getLocalizedMessages(K,F,A);if(W)try{const z=[],te=await this.resolveOriginalMessageBundle(W.default,z);if(z.length>0)return z.forEach(H=>{this.logService.error(this.formatMessage(K,(0,p.localize)(3,null,W.default?.path,(0,l.getParseErrorMessage)(H.error))))}),F;if((0,E.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage(K,(0,p.localize)(4,null,W.default?.path))),F;const B=W.values||Object.create(null);return(0,N.localizeManifest)(F,B,te)}catch{}return F}async getLocalizedMessages(K,F,A){const W=(0,h.joinPath)(K,"package.nls.json"),z=(L,O)=>{O.forEach(_=>{this.logService.error(this.formatMessage(K,(0,p.localize)(5,null,L?.path,(0,l.getParseErrorMessage)(_.error))))})},te=L=>{this.logService.error(this.formatMessage(K,(0,p.localize)(6,null,L?.path)))},B=`${F.publisher}.${F.name}`,H=A.translations[B];if(H)try{const L=w.URI.file(H),O=(await this.fileService.readFile(L)).value.toString(),_=[],V=(0,E.parse)(O,_);return _.length>0?(z(L,_),{values:void 0,default:W}):(0,E.getNodeType)(V)!=="object"?(te(L),{values:void 0,default:W}):{values:V.contents?V.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let O;try{O=await this.findMessageBundles(K,A)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const _=(await this.fileService.readFile(O.localized)).value.toString(),V=[],x=(0,E.parse)(_,V);return V.length>0?(z(O.localized,V),{values:void 0,default:O.original}):(0,E.getNodeType)(x)!=="object"?(te(O.localized),{values:void 0,default:O.original}):{values:x,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(K,F){if(K)try{const A=(await this.fileService.readFile(K)).value.toString();return(0,E.parse)(A,F)}catch{}}findMessageBundles(K,F){return new Promise((A,W)=>{const z=te=>{const B=(0,h.joinPath)(K,`package.nls.${te}.json`);this.fileService.exists(B).then(H=>{H&&A({localized:B,original:(0,h.joinPath)(K,"package.nls.json")});const L=te.lastIndexOf("-");L===-1?A({localized:(0,h.joinPath)(K,"package.nls.json"),original:null}):(te=te.substring(0,L),z(te))})};if(F.devMode||F.pseudo||!F.language)return A({localized:(0,h.joinPath)(K,"package.nls.json"),original:null});z(F.language)})}formatMessage(K,F){return`[${K.path}]: ${F}`}};oe=ve([J(1,P.IExtensionsProfileScannerService),J(2,T.IUriIdentityService),J(3,o.IFileService),J(4,r.ILogService)],oe);let ue=class extends oe{constructor(K,F,A,W,z,te){super(F,A,W,z,te),this.cacheFile=K,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(K){const F=await this.readExtensionCache();if(this.input=K,F&&F.input&&Y.equals(F.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),F.result.map(W=>(W.location=w.URI.revive(W.location),W));const A=await super.scanExtensions(K);return await this.writeExtensionCache({input:K,result:A}),A}async readExtensionCache(){try{const K=await this.fileService.readFile(this.cacheFile),F=JSON.parse(K.value.toString());return{result:F.result,input:(0,u.revive)(F.input)}}catch(K){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,M.getErrorMessage)(K))}return null}async writeExtensionCache(K){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(K)))}catch(F){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,M.getErrorMessage)(F))}}async validateCache(){if(!this.input)return;const K=await this.readExtensionCache();if(!K)return;const F=K.result,A=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(A,F))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(W){this.logService.error(W)}}};ue=ve([J(2,P.IExtensionsProfileScannerService),J(3,T.IUriIdentityService),J(4,o.IFileService),J(5,r.ILogService)],ue);function se(G,K){const F=(0,g.getExtensionId)(G.manifest.publisher,G.manifest.name);return{id:F,identifier:new a.ExtensionIdentifier(F),isBuiltin:G.type===0,isUserBuiltin:G.type===1&&G.isBuiltin,isUnderDevelopment:K,extensionLocation:G.location,uuid:G.identifier.uuid,targetPlatform:G.targetPlatform,...G.manifest}}e.toExtensionDescription=se;class de extends ${constructor(K,F,A,W,z,te,B,H,L,O,_){super(K,F,(0,h.joinPath)(A,".vscode-oss-dev","extensions","control.json"),(0,h.joinPath)(W,a.MANIFEST_CACHE_FOLDER),z,te,B,H,L,O,_),this.translationsPromise=(async()=>{if(y.translationsConfigFile)try{const V=await this.fileService.readFile(w.URI.file(y.translationsConfigFile));return JSON.parse(V.value.toString())}catch{}return Object.create(null)})()}getTranslations(K){return this.translationsPromise}}e.NativeExtensionsScannerService=de}),define(Z[252],ee([0,1,7,35,72,89,14,5,6,20,39]),function(q,e,v,t,k,R,M,E,l,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends R.NativeExtensionsScannerService{constructor(h,d,S,C,w,p,f){super(v.URI.file(w.builtinExtensionsPath),v.URI.file(w.extensionsPath),w.userHome,v.URI.file(w.userDataPath),h,d,S,C,w,p,f)}};b=ve([J(0,I.IUserDataProfilesService),J(1,k.IExtensionsProfileScannerService),J(2,M.IFileService),J(3,l.ILogService),J(4,t.INativeEnvironmentService),J(5,m.IProductService),J(6,E.IInstantiationService)],b),e.ExtensionsScannerService=b}),define(Z[253],ee([0,1,15,41,2,31,13,9,4,7,29,35,6,39]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let d=class extends k.Disposable{constructor(C,w,p){super(),this.environmentService=C,this.logService=p,this.validRoots=R.TernarySearchTree.forPaths(!l.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(C.appRoot),this.addValidFileRoot(C.extensionsPath),this.addValidFileRoot(w.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(C.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:C}=v.session;C.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(w,p)=>this.handleResourceRequest(w,p)),C.protocol.interceptFileProtocol(M.Schemas.file,(w,p)=>this.handleFileRequest(w,p)),this._register((0,k.toDisposable)(()=>{C.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),C.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(C){const w=(0,E.normalize)(C);return this.validRoots.get(w)?k.Disposable.None:(this.validRoots.set(w,!0),(0,k.toDisposable)(()=>this.validRoots.delete(w)))}handleFileRequest(C,w){const p=m.URI.parse(C.url);return this.logService.error(`Refused to load resource ${p.fsPath} from ${M.Schemas.file}: protocol (original URL: ${C.url})`),w({error:-3})}handleResourceRequest(C,w){const p=this.requestToNormalizedFilePath(C);let f;return this.environmentService.crossOriginIsolated&&(p.endsWith("/workbench.html")?f=M.COI.CoopAndCoep:f=M.COI.getHeadersFromQuery(C.url)),this.validRoots.findSubstr(p)?w({path:p,headers:f}):this.validExtensions.has((0,E.extname)(p).toLowerCase())?w({path:p}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${p} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${C.url})`),w({error:-3}))}requestToNormalizedFilePath(C){const w=m.URI.parse(C.url),p=M.FileAccess.asFileUri(w);return(0,E.normalize)(p.fsPath)}createIPCObjectUrl(){let C;const w=m.URI.from({scheme:"vscode",path:(0,I.generateUuid)()}),p=w.toString(),f=async()=>C;return t.validatedIpcMain.handle(p,f),this.logService.trace(`IPC Object URL: Registered new channel ${p}.`),{resource:w,update:g=>C=g,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${p}.`),t.validatedIpcMain.removeHandler(p)}}}};d=ve([J(0,b.INativeEnvironmentService),J(1,h.IUserDataProfilesService),J(2,y.ILogService)],d),e.ProtocolMainService=d}),define(Z[254],ee([0,1,15,41,8,3,2,13,12,100,26,21,6,54,61,64,44,39,37]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S,C,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let f=class extends M.Disposable{constructor(a,n,o,i,r,s,c,u,P){super(),this.machineId=a,this.userEnv=n,this.environmentMainService=o,this.userDataProfilesService=i,this.lifecycleMainService=r,this.logService=s,this.policyService=c,this.themeMainService=u,this.protocolMainService=P,this.firstWindowConnectionBarrier=new k.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(a,n)=>this.onWindowConnection(a,n)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(a,n)=>this.onWorkerConnection(a,n)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(a,n){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const o=await this.connect();if(a.sender.isDestroyed())return o.close();a.sender.postMessage("vscode:createSharedProcessMessageChannelResult",n,[o])}onWorkerConnection(a,n){this.logService.trace("SharedProcess: onWorkerConnection",n);const o=new M.DisposableStore,i=s=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${s}')`,n),o.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",n))},r=v.BrowserWindow.fromId(n.reply.windowId);if(!r||r.isDestroyed()||r.webContents.isDestroyed()||!n.reply.channel){i("unavailable");return}o.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===r)(()=>i("load"))),o.add(R.Event.fromNodeEventEmitter(r,"closed")(()=>i("closed"))),r.webContents.postMessage(n.reply.channel,n.reply.nonce,a.ports)}onWillShutdown(){const a=this.window;!a||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(a.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{a.close()}catch{}this.window=void 0},0))}send(a,...n){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${a}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(a,...n)}catch(o){this.logService.warn(`Error sending IPC message to channel '${a}' of shared process: ${(0,C.toErrorMessage)(o)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(a=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),a()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(a=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),a()}))})()),this._whenIpcReady}createWindow(){const a=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${a.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),a.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:h.default,policiesData:this.policyService.serialize()}),this.window.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",q).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=a=>{this.logService.trace("SharedProcess#close prevented"),a.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(a,n)=>this._onDidError.fire({type:2,details:n})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(a,n,o)=>this._onDidError.fire({type:3,details:{reason:o,exitCode:n}})))}async connect(){await this.whenIpcReady;const a=(0,l.assertIsDefined)(this.window);return(0,m.connect)(a)}async toggle(){await this.whenIpcReady,this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const a=this.window;return a?!a.isDestroyed()&&!a.webContents.isDestroyed():!1}};f=ve([J(2,I.IEnvironmentMainService),J(3,w.IUserDataProfilesService),J(4,b.ILifecycleMainService),J(5,y.ILogService),J(6,p.IPolicyService),J(7,S.IThemeMainService),J(8,d.IProtocolMainService)],f),e.SharedProcess=f}),define(Z[116],ee([0,1,8,3,2,71,12,101,5,39]),function(q,e,v,t,k,R,M,E,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const I="__$__targetStorageMarker";e.IStorageService=(0,l.createDecorator)("storageService");var b;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var y;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(y=e.StorageScope||(e.StorageScope={}));var h;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(h=e.StorageTarget||(e.StorageTarget={}));class d extends k.Disposable{constructor(f={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super(),this.options=f,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,g){if(g===I){switch(f){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:f})}else this._onDidChangeValue.fire({scope:f,key:g,target:this.getKeyTargets(f)[g]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,g,a){return this.getStorage(g)?.get(f,a)}getBoolean(f,g,a){return this.getStorage(g)?.getBoolean(f,a)}getNumber(f,g,a){return this.getStorage(g)?.getNumber(f,a)}store(f,g,a,n){if((0,M.isUndefinedOrNull)(g)){this.remove(f,a);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,a,n),this.getStorage(a)?.set(f,g)})}remove(f,g){this.withPausedEmitters(()=>{this.updateKeyTarget(f,g,void 0),this.getStorage(g)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,g){const a=[],n=this.getKeyTargets(f);for(const o of Object.keys(n))n[o]===g&&a.push(o);return a}updateKeyTarget(f,g,a){const n=this.getKeyTargets(g);typeof a=="number"?n[f]!==a&&(n[f]=a,this.getStorage(g)?.set(I,JSON.stringify(n))):typeof n[f]=="number"&&(delete n[f],this.getStorage(g)?.set(I,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(f){switch(f){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(f){const g=this.get(I,f);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=b.NONE){this._onWillSaveState.fire({reason:f});const g=this.getStorage(-1),a=this.getStorage(0),n=this.getStorage(1);switch(f){case b.NONE:await v.Promises.settled([g?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await v.Promises.settled([g?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.getStorage(-1)?.items??new Map,g=this.getStorage(0)?.items??new Map,a=this.getStorage(1)?.items??new Map;return w(f,g,a,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(f,g){return this.emitWillSaveState(b.NONE),(0,m.isUserDataProfile)(f)?this.switchToProfile(f,g):this.switchToWorkspace(f,g)}canSwitchProfile(f,g){return!(f.id===g.id||S(g)&&S(f))}switchData(f,g,a,n){this.withPausedEmitters(()=>{if(n)for(const[o,i]of f)g.set(o,i);else{const o=new Set;for(const[i,r]of f)o.add(i),g.get(i)!==r&&this.emitDidChangeValue(a,i);for(const[i]of g.items)o.has(i)||this.emitDidChangeValue(a,i)}})}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;function S(p){return p.isDefault||!!p.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class C extends d{constructor(){super(),this.applicationStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.profileStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.profileStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),this._register(this.applicationStorage.onDidChangeStorage(f=>this.emitDidChangeValue(-1,f)))}getStorage(f){switch(f){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=C;async function w(p,f,g,a,n,o){const i=U=>{try{return JSON.parse(U)}catch{return U}},r=new Map,s=new Map;p.forEach((U,$)=>{r.set($,U),s.set($,i(U))});const c=new Map,u=new Map;f.forEach((U,$)=>{c.set($,U),u.set($,i(U))});const P=new Map,D=new Map;g.forEach((U,$)=>{P.set($,U),D.set($,i(U))}),console.group(a!==n?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const T=[];if(r.forEach((U,$)=>{T.push({key:$,value:U})}),console.table(T),console.groupEnd(),console.log(s),a!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const U=[];c.forEach(($,Y)=>{U.push({key:Y,value:$})}),console.table(U),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${o})`);const N=[];P.forEach((U,$)=>{N.push({key:$,value:U})}),console.table(N),console.groupEnd(),console.log(D)}e.logStorage=w}),define(Z[255],ee([0,1,24,8,3,2,9,79,7,23,101,147,6,116,36,27]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class C extends R.Disposable{constructor(o,i){super(),this.logService=o,this.fileService=i,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new I.Storage(new I.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=I.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===I.StorageState.None)try{const o=await this.doCreate();this._storage.dispose(),this._storage=o,this._register(o.onDidChangeStorage(r=>this._onDidChangeStorage.fire({key:r}))),await this.doInit(o);const i=o.getBoolean(h.IS_NEW_KEY);i===void 0?o.set(h.IS_NEW_KEY,!0):i&&o.set(h.IS_NEW_KEY,!1)}catch(o){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${o}`)}finally{this.state=I.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===y.LogLevel.Trace?o=>this.logService.trace(o):void 0,logError:o=>this.logService.error(o)}}doInit(o){return o.init()}get items(){return this._storage.items}get(o,i){return this._storage.get(o,i)}set(o,i){return this._storage.set(o,i)}delete(o){return this._storage.delete(o)}async close(){const o=new E.StopWatch(!1);await this.doClose(),o.stop(),o.elapsed()>C.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(o),this._onDidCloseStorage.fire()}async logSlowClose(o){if(!!this.path)try{const i=(0,v.top)(Array.from(this._storage.items.entries()).map(([s,c])=>({key:s,length:c.length})),(s,c)=>c.length-s.length,5).map(s=>`${s.key}:${s.length}`).join(", "),r=(await this.fileService.stat(l.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${o.elapsed()}ms, DB size: ${r}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=I.StorageState.Closed,await this._storage.close()}}C.LOG_SLOW_CLOSE_THRESHOLD=2e3;class w extends C{constructor(o,i,r,s){super(r,s),this.profile=o,this.options=i}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.profile.globalStorageHome.fsPath,w.STORAGE_NAME)}async doCreate(){return new I.Storage(new b.SQLiteStorageDatabase(this.path??b.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}w.STORAGE_NAME="state.vscdb";class p extends w{constructor(o,i,r,s){super(o,i,r,s)}}e.ProfileStorageMain=p;class f extends w{constructor(o,i,r,s){super(i.defaultProfile,o,r,s)}async doInit(o){await super.doInit(o),this.updateTelemetryState(o)}updateTelemetryState(o){o.get(d.firstSessionDateStorageKey,void 0)===void 0&&o.set(d.firstSessionDateStorageKey,new Date().toUTCString());const r=o.get(d.currentSessionDateStorageKey,void 0),s=new Date().toUTCString();o.set(d.lastSessionDateStorageKey,typeof r>"u"?null:r),o.set(d.currentSessionDateStorageKey,s)}}e.ApplicationStorageMain=f;class g extends C{constructor(o,i,r,s,c){super(r,c),this.workspace=o,this.options=i,this.environmentService=s}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,g.WORKSPACE_STORAGE_NAME)}async doCreate(){const{storageFilePath:o,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new I.Storage(new b.SQLiteStorageDatabase(o,{logging:this.createLoggingOptions()}),{hint:i?I.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:b.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const o=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,M.join)(o,g.WORKSPACE_STORAGE_NAME);return await m.Promises.exists(o)?{storageFilePath:i,wasCreated:!1}:(await m.Promises.mkdir(o,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(o),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(o){let i;if((0,S.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,S.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const r=(0,M.join)(o,g.WORKSPACE_META_NAME);await m.Promises.exists(r)||await m.Promises.writeFile(r,JSON.stringify(i,void 0,2))}catch(r){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${r}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json";class a extends C{get path(){}async doCreate(){return new I.Storage(new I.InMemoryStorageDatabase)}}e.InMemoryStorageMain=a}),define(Z[256],ee([0,1,67,35,14,6,226,51,39]),function(q,e,v,t,k,R,M,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let m=class Rt extends l.UserDataProfilesService{constructor(b,y,h,d,S){super(h,d,y,S),this.stateService=b}getStoredProfiles(){return(0,v.revive)(this.stateService.getItem(Rt.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,v.revive)(this.stateService.getItem(Rt.PROFILE_ASSOCIATIONS_KEY,{}))}};m=ve([J(0,M.IStateService),J(1,E.IUriIdentityService),J(2,t.IEnvironmentService),J(3,k.IFileService),J(4,R.ILogService)],m),e.UserDataProfilesService=m}),define(Z[42],ee([0,1,7,35,14,5,6,38,51,39,256]),function(q,e,v,t,k,R,M,E,l,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(m.IUserDataProfilesService);let b=class dt extends I.UserDataProfilesService{constructor(h,d,S,C,w){super(h,d,S,C,w),this.stateMainService=h}setEnablement(h){super.setEnablement(h),this.enabled||(this.saveStoredProfiles([]),this.saveStoredProfileAssociations({}))}isEnabled(){return this.enabled}checkAndCreateProfileFromCli(h){if(!!this.isEnabled()){if(h.profile){const d=this.profiles.find(S=>S.name===h.profile);return d?Promise.resolve(d):this.createProfile(h.profile)}if(h["profile-temp"])return this.createTransientProfile()}}saveStoredProfiles(h){h.length?this.stateMainService.setItem(dt.PROFILES_KEY,h):this.stateMainService.removeItem(dt.PROFILES_KEY)}saveStoredProfileAssociations(h){h.emptyWindow||h.workspaces?this.stateMainService.setItem(dt.PROFILE_ASSOCIATIONS_KEY,h):this.stateMainService.removeItem(dt.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const h="workspaceAndProfileInfo",d=this.stateMainService.getItem(h,void 0);if(d){this.stateMainService.removeItem(h);const S=d.reduce((C,{workspace:w,profile:p})=>(C[v.URI.revive(w).toString()]=v.URI.revive(p).toString(),C),{});this.stateMainService.setItem(dt.PROFILE_ASSOCIATIONS_KEY,{workspaces:S})}return super.getStoredProfileAssociations()}};b=ve([J(0,E.IStateMainService),J(1,l.IUriIdentityService),J(2,t.IEnvironmentService),J(3,k.IFileService),J(4,M.ILogService)],b),e.UserDataProfilesMainService=b}),define(Z[257],ee([0,1,2,16,72,89,14,6,39,42]),function(q,e,v,t,k,R,M,E,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let I=class extends v.Disposable{constructor(y,h,d,S,C){super(),this.userDataProfilesService=y,this.fileService=h,this.extensionsScannerService=d,this.extensionsProfileScannerService=S,y.isEnabled()?(this._register(y.onWillCreateProfile(w=>{y.profiles.length===1&&w.join(this.initialize())})),this._register(y.onDidChangeProfiles(w=>{y.profiles.length===1&&this.uninitialize()}))):this.uninitialize().then(null,w=>C.error(w))}async initialize(){const y=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(y)}catch{}const h=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(h.map(d=>[d,d.metadata]),y)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,t.joinPath)(this.userDataProfilesService.defaultProfile.location,l.EXTENSIONS_RESOURCE_NAME)}};I=ve([J(0,m.IUserDataProfilesMainService),J(1,M.IFileService),J(2,R.IExtensionsScannerService),J(3,k.IExtensionsProfileScannerService),J(4,E.ILogService)],I),e.DefaultExtensionsProfileInitHandler=I}),define(Z[258],ee([0,1,15,24,4,7,23,19,59,5,6,114,32,42]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,m.createDecorator)(e.ID);let d=class{constructor(C,w,p,f,g){this.logService=C,this.windowsMainService=w,this.urlService=p,this.configurationService=f,this.userDataProfilesMainService=g}async start(C,w){this.logService.trace("Received data from other instance: ",C,w),k.isMacintosh&&v.app.focus({steal:!0});const p=this.parseOpenUrl(C);if(p.length){let f=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const g=(0,t.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));g&&(f=g.ready())}f.then(()=>{for(const{uri:g,url:a}of p)this.urlService.open(g,{originalUrl:a})})}else return this.startOpenWindow(C,w)}parseOpenUrl(C){return C["open-url"]&&C._urls&&C._urls.length>0?(0,t.coalesce)(C._urls.map(w=>{try{return{uri:R.URI.parse(w),url:w}}catch{return null}})):[]}async startOpenWindow(C,w){const p=(0,l.isLaunchedFromCli)(w)?0:4;let f=[];const g=C.wait&&C.waitMarkerFilePath?R.URI.file(C.waitMarkerFilePath):void 0,a=C.remote||void 0,n=await this.userDataProfilesMainService.checkAndCreateProfileFromCli(C),o={context:p,cli:C,userEnv:w,waitMarkerFileURI:g,remoteAuthority:a,profile:n};if(C.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(C.extensionDevelopmentPath,o);else if(!C._.length&&!C["folder-uri"]&&!C["file-uri"]){let i=!1;if(C["new-window"]||C["unity-launch"]||n)i=!0;else if(C["reuse-window"])i=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!k.isMacintosh}if(i)f=await this.windowsMainService.open({...o,forceNewWindow:!0,forceEmpty:!0});else{const r=this.windowsMainService.getLastActiveWindow();r?(this.windowsMainService.openExistingWindow(r,o),f=[r]):f=await this.windowsMainService.open({...o,forceEmpty:!0})}}else f=await this.windowsMainService.open({...o,forceNewWindow:C["new-window"],preferNewWindow:!C["reuse-window"]&&!C.wait,forceReuseWindow:C["reuse-window"],diffMode:C.diff,mergeMode:C.merge,addMode:C.add,noRecentEntry:!!C["skip-add-to-recently-opened"],gotoLineMode:C.goto});if(g&&f.length===1&&f[0])return Promise.race([f[0].whenClosedOrLoaded,(0,M.whenDeleted)(g.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};d=ve([J(0,I.ILogService),J(1,y.IWindowsMainService),J(2,b.IURLService),J(3,E.IConfigurationService),J(4,h.IUserDataProfilesMainService)],d),e.LaunchMainService=d}),define(Z[90],ee([0,1,7,49,2,35,14,5,21,6,116,255,39,42,51]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,E.createDecorator)("storageMainService");let S=class extends k.Disposable{constructor(p,f,g,a,n,o){super(),this.logService=p,this.environmentService=f,this.userDataProfilesService=g,this.lifecycleMainService=a,this.fileService=n,this.uriIdentityService=o,this.shutdownReason=void 0,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(p=>{p.window.profile&&this.profileStorage(p.window.profile).init(),p.workspace&&this.workspaceStorage(p.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(p=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=p.reason,p.join(this.applicationStorage.close());for(const[,f]of this.mapProfileToStorage)p.join(f.close());for(const[,f]of this.mapWorkspaceToStorage)p.join(f.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(p=>{p.join((async()=>{await this.fileService.exists(p.profile.globalStorageHome)||await this.fileService.createFolder(p.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(p=>{const f=this.mapProfileToStorage.get(p.profile.id);f&&p.join(f.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const p=new b.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,t.once)(p.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),p}profileStorage(p){if((0,I.isProfileUsingDefaultStorage)(p))return this.applicationStorage;let f=this.mapProfileToStorage.get(p.id);return f||(this.logService.trace(`StorageMainService: creating profile storage (${p.name})`),f=this.createProfileStorage(p),this.mapProfileToStorage.set(p.id,f),(0,t.once)(f.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${p.name})`),this.mapProfileToStorage.delete(p.id)})),f}createProfileStorage(p){return this.shutdownReason===2?new b.InMemoryStorageMain(this.logService,this.fileService):new b.ProfileStorageMain(p,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(p){let f=this.mapWorkspaceToStorage.get(p.id);return f||(this.logService.trace(`StorageMainService: creating workspace storage (${p.id})`),f=this.createWorkspaceStorage(p),this.mapWorkspaceToStorage.set(p.id,f),(0,t.once)(f.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${p.id})`),this.mapWorkspaceToStorage.delete(p.id)})),f}createWorkspaceStorage(p){return this.shutdownReason===2?new b.InMemoryStorageMain(this.logService,this.fileService):new b.WorkspaceStorageMain(p,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(p){const f=v.URI.file(p);for(const g of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(!!g.path&&this.uriIdentityService.extUri.isEqualOrParent(v.URI.file(g.path),f))return!0;return!1}};S=ve([J(0,m.ILogService),J(1,R.IEnvironmentService),J(2,h.IUserDataProfilesMainService),J(3,l.ILifecycleMainService),J(4,M.IFileService),J(5,d.IUriIdentityService)],S),e.StorageMainService=S,e.IApplicationStorageMainService=(0,E.createDecorator)("applicationStorageMainService");let C=class extends I.AbstractStorageService{constructor(p,f){super(),this.userDataProfilesService=p,this.storageMainService=f,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(p){if(p===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(p){if(p===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}};C=ve([J(0,y.IUserDataProfilesService),J(1,e.IStorageMainService)],C),e.ApplicationStorageMainService=C}),define(Z[259],ee([0,1,2,21,42]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let R=class extends v.Disposable{constructor(E,l){super(),this.userDataProfilesService=l,this._register(E.onWillLoadWindow(m=>{m.reason===2&&this.unsetTransientProfileForWorkspace(m.window.openedWorkspace??"empty-window")})),this._register(E.onBeforeCloseWindow(m=>this.unsetTransientProfileForWorkspace(m.openedWorkspace??"empty-window")))}async unsetTransientProfileForWorkspace(E){this.userDataProfilesService.getOrSetProfileForWorkspace(E).isTransient&&(this.userDataProfilesService.unsetWorkspace(E,!0),await this.userDataProfilesService.cleanUpTransientProfiles())}};R=ve([J(0,t.ILifecycleMainService),J(1,k.IUserDataProfilesMainService)],R),e.UserDataTransientProfilesHandler=R}),define(Z[117],ee([0,1,16,7,27]),function(q,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(l,m,I){for(const y of l){const h=y.openedWorkspace;if((0,k.isWorkspaceIdentifier)(h)){const d=await I(h);if(d){if(d.folders.some(S=>v.extUriBiasedIgnorePathCase.isEqualOrParent(m,S.uri)))return y}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(m,h.configPath))return y}}const b=l.filter(y=>(0,k.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(m,y.openedWorkspace.uri));if(b.length)return b.sort((y,h)=>-(y.openedWorkspace.uri.path.length-h.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function M(l,m){for(const I of l)if((0,k.isWorkspaceIdentifier)(I.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(I.openedWorkspace.configPath,m)||(0,k.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(I.openedWorkspace.uri,m))return I}e.findWindowOnWorkspaceOrFolder=M;function E(l,m){const I=b=>m.some(y=>v.extUriBiasedIgnorePathCase.isEqual(t.URI.file(y),t.URI.file(b)));for(const b of l)if(b.config?.extensionDevelopmentPath?.some(y=>I(y)))return b}e.findWindowOnExtensionDevelopmentPath=E}),define(Z[260],ee([0,1,15,2,4,16,7,19,21,6,38,32,115,27]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let d=class Lt extends t.Disposable{constructor(g,a,n,o,i){super(),this.windowsMainService=g,this.stateMainService=a,this.lifecycleMainService=n,this.logService=o,this.configurationService=i,this._state=S(this.stateMainService.getItem(Lt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(g=>this.onBeforeCloseWindow(g)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(g=>{g.newCount-g.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(g=>this.onBeforeCloseWindow(g))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const g=new Set,a={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!a.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),i&&(a.lastActiveWindow=this.toWindowState(i),a.lastActiveWindow.uiState.mode===3&&g.add(a.lastActiveWindow.uiState.display))}const n=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);n&&(a.lastPluginDevelopmentHostWindow=this.toWindowState(n),a.lastPluginDevelopmentHostWindow.uiState.mode===3&&(g.has(a.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!n.win?.isSimpleFullScreen()&&(a.lastPluginDevelopmentHostWindow.uiState.mode=1):g.add(a.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(a.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const r=this.toWindowState(i);return r.uiState.mode===3&&(g.has(r.uiState.display)?k.isMacintosh&&r.windowId!==a.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(r.uiState.mode=1):g.add(r.uiState.display)),r}));const o=w(a);this.stateMainService.setItem(Lt.windowsStateStorageKey,o),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",o)}onBeforeCloseWindow(g){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(g);g.isExtensionDevelopmentHost&&!g.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!g.isExtensionDevelopmentHost&&g.openedWorkspace&&this._state.openedWindows.forEach(n=>{const o=(0,h.isWorkspaceIdentifier)(g.openedWorkspace)&&n.workspace?.id===g.openedWorkspace.id,i=(0,h.isSingleFolderWorkspaceIdentifier)(g.openedWorkspace)&&n.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(n.folderUri,g.openedWorkspace.uri);(o||i)&&(n.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(g){return{windowId:g.id,workspace:(0,h.isWorkspaceIdentifier)(g.openedWorkspace)?g.openedWorkspace:void 0,folderUri:(0,h.isSingleFolderWorkspaceIdentifier)(g.openedWorkspace)?g.openedWorkspace.uri:void 0,backupPath:g.backupPath,remoteAuthority:g.remoteAuthority,uiState:g.serializeWindowState()}}getNewWindowState(g){const a=this.doGetNewWindowState(g),n=this.configurationService.getValue("window");if(a.mode===3){let o;a.hasDefaultState?o=!!(n?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(n.newWindowDimensions)>=0):o=!!(this.lifecycleMainService.wasRestarted||n?.restoreFullscreen),o||(a.mode=1)}return a}doGetNewWindowState(g){const a=this.windowsMainService.getLastActiveWindow();if(!g.extensionTestsPath){if(!!g.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=g.workspace;if((0,h.isWorkspaceIdentifier)(c)){const P=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===c.id).map(D=>D.uiState);if(P.length)return P[0]}if((0,h.isSingleFolderWorkspaceIdentifier)(c)){const P=this.state.openedWindows.filter(D=>D.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(D.folderUri,c.uri)).map(D=>D.uiState);if(P.length)return P[0]}else if(g.backupPath){const P=this.state.openedWindows.filter(D=>D.backupPath===g.backupPath).map(D=>D.uiState);if(P.length)return P[0]}const u=this.lastClosedState||this.state.lastActiveWindow;if(!a&&u)return u.uiState}let n;const o=v.screen.getAllDisplays();if(o.length===1)n=o[0];else{if(k.isMacintosh){const c=v.screen.getCursorScreenPoint();n=v.screen.getDisplayNearestPoint(c)}!n&&a&&(n=v.screen.getDisplayMatching(a.getBounds())),n||(n=v.screen.getPrimaryDisplay()||o[0])}let i=(0,y.defaultWindowState)();i.x=Math.round(n.bounds.x+n.bounds.width/2-i.width/2),i.y=Math.round(n.bounds.y+n.bounds.height/2-i.height/2);const r=this.configurationService.getValue("window");let s=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")i.mode=0,s=!1;else if(r.newWindowDimensions==="fullscreen")i.mode=3,s=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&a){const c=a.serializeWindowState();c.mode===3?i.mode=3:i=c,s=i.mode!==3&&r.newWindowDimensions==="offset"}}return s&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(g){if(this.windowsMainService.getWindows().length===0)return g;g.x=typeof g.x=="number"?g.x:0,g.y=typeof g.y=="number"?g.y:0;const a=this.windowsMainService.getWindows().map(n=>n.getBounds());for(;a.some(n=>n.x===g.x||n.y===g.y);)g.x+=30,g.y+=30;return g}};d.windowsStateStorageKey="windowsState",d=ve([J(0,b.IWindowsMainService),J(1,I.IStateMainService),J(2,l.ILifecycleMainService),J(3,m.ILogService),J(4,E.IConfigurationService)],d),e.WindowsStateHandler=d;function S(f){const g={openedWindows:[]},a=f||{openedWindows:[]};return a.lastActiveWindow&&(g.lastActiveWindow=C(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(g.lastPluginDevelopmentHostWindow=C(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(g.openedWindows=a.openedWindows.map(n=>C(n))),g}e.restoreWindowsState=S;function C(f){const g={uiState:f.uiState};return f.backupPath&&(g.backupPath=f.backupPath),f.remoteAuthority&&(g.remoteAuthority=f.remoteAuthority),f.folder&&(g.folderUri=M.URI.parse(f.folder)),f.workspaceIdentifier&&(g.workspace={id:f.workspaceIdentifier.id,configPath:M.URI.parse(f.workspaceIdentifier.configURIPath)}),g}function w(f){return{lastActiveWindow:f.lastActiveWindow&&p(f.lastActiveWindow),lastPluginDevelopmentHostWindow:f.lastPluginDevelopmentHostWindow&&p(f.lastPluginDevelopmentHostWindow),openedWindows:f.openedWindows.map(g=>p(g))}}e.getWindowsStateStoreData=w;function p(f){return{workspaceIdentifier:f.workspace&&{id:f.workspace.id,configURIPath:f.workspace.configPath.toString()},folder:f.folderUri&&f.folderUri.toString(),backupPath:f.backupPath,remoteAuthority:f.remoteAuthority,uiState:f.uiState}}}),define(Z[91],ee([0,1,30,43,123,34,13,9,4,16,7,5,63,27]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function d(D){return D.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function S(D){return D.hasOwnProperty("folderUri")}e.isRecentFolder=S;function C(D){return D.hasOwnProperty("fileUri")}e.isRecentFile=C;function w(D){return p(D)||f(D)}e.isStoredWorkspaceFolder=w;function p(D){const T=D;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function f(D){const T=D;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function g(D,T,N,U,$){if(D.scheme!==U.scheme)return{name:N,uri:D.toString(!0)};let Y=T?void 0:$.relativePath(U,D);if(Y!==void 0)Y.length===0?Y=".":l.isWindows&&(Y=a(Y));else if(D.scheme===M.Schemas.file)Y=D.fsPath,l.isWindows&&(Y=a(Y));else if($.isEqualAuthority(D.authority,U.authority))Y=D.path;else return{name:N,uri:D.toString(!0)};return{name:N,path:Y}}e.getStoredWorkspaceFolder=g;function a(D){return D=(0,R.normalizeDriveLetter)(D),(0,v.isUNC)(D)||(D=(0,v.toSlashes)(D)),D}function n(D,T,N){const U=[],$=new Set,Y=N.dirname(T);for(const oe of D){let ue;if(p(oe))oe.path&&(ue=N.resolvePath(Y,oe.path));else if(f(oe))try{ue=I.URI.parse(oe.uri),ue.path[0]!==E.posix.sep&&(ue=ue.with({path:E.posix.sep+ue.path}))}catch(se){console.warn(se)}if(ue){const se=N.getComparisonKey(ue);if(!$.has(se)){$.add(se);const de=oe.name||N.basenameOrAuthority(ue);U.push(new h.WorkspaceFolder({uri:ue,name:de,index:U.length},oe))}}}return U}e.toWorkspaceFolders=n;function o(D,T,N,U,$){const Y=i(T,D),oe=$.dirname(T),ue=$.dirname(U),se=[];for(const F of Y.folders){const A=p(F)?$.resolvePath(oe,F.path):I.URI.parse(F.uri);let W;N?W=!1:W=!p(F)||(0,E.isAbsolute)(F.path),se.push(g(A,W,F.name,ue,$))}const de={insertSpaces:!1,tabSize:4,eol:l.isLinux||l.isMacintosh?`
`:`\r
`},G=k.setProperty(D,["folders"],se,de);let K=k.applyEdits(D,G);return(0,m.isEqualAuthority)(Y.remoteAuthority,(0,y.getRemoteAuthority)(U))&&(K=k.applyEdits(K,k.removeProperty(K,["remoteAuthority"],de))),K}e.rewriteWorkspaceFileForNewLocation=o;function i(D,T){const N=t.parse(T);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(U=>w(U));else throw new Error(`${D} looks like an invalid workspace file.`);return N}function r(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function s(D){return typeof D.folderUri=="string"}function c(D){return typeof D.fileUri=="string"}function u(D,T){const N={workspaces:[],files:[]};if(D){const U=function(Y,oe){for(let ue=0;ue<Y.length;ue++)try{oe(Y[ue],ue)}catch(se){T.warn(`Error restoring recent entry ${JSON.stringify(Y[ue])}: ${se.toString()}. Skip entry.`)}},$=D;Array.isArray($.entries)&&U($.entries,Y=>{const oe=Y.label,ue=Y.remoteAuthority;r(Y)?N.workspaces.push({label:oe,remoteAuthority:ue,workspace:{id:Y.workspace.id,configPath:I.URI.parse(Y.workspace.configPath)}}):s(Y)?N.workspaces.push({label:oe,remoteAuthority:ue,folderUri:I.URI.parse(Y.folderUri)}):c(Y)&&N.files.push({label:oe,remoteAuthority:ue,fileUri:I.URI.parse(Y.fileUri)})})}return N}e.restoreRecentlyOpened=u;function P(D){const T={entries:[]};for(const N of D.workspaces)S(N)?T.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):T.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of D.files)T.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return T}e.toStoreData=P}),define(Z[92],ee([0,1,76,13,4,16]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function M(m){function I(){let b=m.scheme===t.Schemas.file?(0,R.originalFSPath)(m):m.toString();return k.isLinux||(b=b.toLowerCase()),(0,v.createHash)("md5").update(b).digest("hex")}return{id:I(),configPath:m}}e.getWorkspaceIdentifier=M;function E(m,I){function b(){if(m.scheme!==t.Schemas.file)return(0,v.createHash)("md5").update(m.toString()).digest("hex");if(!I)return;let h;return k.isLinux?h=I.ino:k.isMacintosh?h=I.birthtime.getTime():k.isWindows&&(typeof I.birthtimeMs=="number"?h=Math.floor(I.birthtimeMs):h=I.birthtime.getTime()),(0,v.createHash)("md5").update(m.fsPath).update(h?String(h):"").digest("hex")}const y=b();if(typeof y=="string")return{id:y,uri:m}}e.getSingleFolderWorkspaceIdentifier=E;function l(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=l}),define(Z[261],ee([0,1,76,30,13,9,4,16,23,177,19,26,38,14,6,176,27,92]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let p=class At{constructor(g,a,n,o){this.environmentMainService=g,this.configurationService=a,this.logService=n,this.stateMainService=o,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=E.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,r)=>(0,t.isEqual)(i,r,!M.isLinux)}}async initialize(){const g=await this.initializeAndMigrateBackupWorkspacesMetadata();this.emptyWindows=await this.validateEmptyWorkspaces(g.emptyWindows),this.workspaces=await this.validateWorkspaces((0,m.deserializeWorkspaceInfos)(g)),this.folders=await this.validateFolders((0,m.deserializeFolderInfos)(g)),this.storeWorkspacesMetadata()}async initializeAndMigrateBackupWorkspacesMetadata(){let g=this.stateMainService.getItem(At.backupWorkspacesMetadataStorageKey);if(!g)try{const a=(0,R.join)(this.backupHome,"workspaces.json"),n=await l.Promises.readFile(a,"utf8");try{await l.Promises.unlink(a)}catch{}const o=JSON.parse(n);g={workspaces:Array.isArray(o.rootURIWorkspaces)?o.rootURIWorkspaces:[],folders:Array.isArray(o.folderWorkspaceInfos)?o.folderWorkspaceInfos:[],emptyWindows:Array.isArray(o.emptyWorkspaceInfos)?o.emptyWorkspaceInfos:[]}}catch(a){a.code!=="ENOENT"&&this.logService.error(`Backup: Could not migrate legacy backup workspaces metadata: ${a.toString()}`)}return g??{workspaces:[],folders:[],emptyWindows:[]}}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==h.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===h.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||h.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(g,a){this.workspaces.some(o=>g.workspace.id===o.workspace.id)||(this.workspaces.push(g),this.storeWorkspacesMetadata());const n=(0,R.join)(this.backupHome,g.workspace.id);return a?this.moveBackupFolder(n,a).then(()=>n):n}async moveBackupFolder(g,a){if(await l.Promises.exists(g)&&await this.convertToEmptyWindowBackup(g),await l.Promises.exists(a))try{await l.Promises.rename(a,g)}catch(n){this.logService.error(`Backup: Could not move backup folder to new location: ${n.toString()}`)}}registerFolderBackup(g){return this.folders.some(a=>this.backupUriComparer.isEqual(g.folderUri,a.folderUri))||(this.folders.push(g),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,this.getFolderHash(g))}registerEmptyWindowBackup(g){return this.emptyWindows.some(a=>!!a.backupFolder&&this.backupPathComparer.isEqual(a.backupFolder,g.backupFolder))||(this.emptyWindows.push(g),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,g.backupFolder)}async validateWorkspaces(g){if(!Array.isArray(g))return[];const a=new Set,n=[];for(const o of g){const i=o.workspace;if(!(0,C.isWorkspaceIdentifier)(i))return[];if(!a.has(i.id)){a.add(i.id);const r=(0,R.join)(this.backupHome,i.id);await this.doHasBackups(r)?i.configPath.scheme!==k.Schemas.file||await l.Promises.exists(i.configPath.fsPath)?n.push(o):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return n}async validateFolders(g){if(!Array.isArray(g))return[];const a=[],n=new Set;for(const o of g){const i=o.folderUri,r=this.backupUriComparer.getComparisonKey(i);if(!n.has(r)){n.add(r);const s=(0,R.join)(this.backupHome,this.getFolderHash(o));await this.doHasBackups(s)?i.scheme!==k.Schemas.file||await l.Promises.exists(i.fsPath)?a.push(o):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return a}async validateEmptyWorkspaces(g){if(!Array.isArray(g))return[];const a=[],n=new Set;for(const o of g){const i=o.backupFolder;if(typeof i!="string")return[];if(!n.has(i)){n.add(i);const r=(0,R.join)(this.backupHome,i);await this.doHasBackups(r)?a.push(o):await this.deleteStaleBackup(r)}}return a}async deleteStaleBackup(g){try{await l.Promises.rm(g,l.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}prepareNewEmptyWindowBackup(){let g=(0,w.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(a=>!!a.backupFolder&&this.backupPathComparer.isEqual(a.backupFolder,g.id));)g=(0,w.createEmptyWorkspaceIdentifier)();return{backupFolder:g.id}}async convertToEmptyWindowBackup(g){const a=this.prepareNewEmptyWindowBackup(),n=(0,R.join)(this.backupHome,a.backupFolder);try{await l.Promises.rename(g,n)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push(a),!0}async getDirtyWorkspaces(){const g=[];for(const a of this.workspaces)await this.hasBackups(a)&&g.push(a);for(const a of this.folders)await this.hasBackups(a)&&g.push(a);return g}hasBackups(g){let a;return(0,m.isEmptyWindowBackupInfo)(g)?a=(0,R.join)(this.backupHome,g.backupFolder):(0,S.isFolderBackupInfo)(g)?a=(0,R.join)(this.backupHome,this.getFolderHash(g)):a=(0,R.join)(this.backupHome,g.workspace.id),this.doHasBackups(a)}async doHasBackups(g){try{const a=await l.Promises.readdir(g);for(const n of a)try{if((await l.Promises.readdir((0,R.join)(g,n))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const g={workspaces:this.workspaces.map(({workspace:a,remoteAuthority:n})=>{const o={id:a.id,configURIPath:a.configPath.toString()};return n&&(o.remoteAuthority=n),o}),folders:this.folders.map(({folderUri:a,remoteAuthority:n})=>{const o={folderUri:a.toString()};return n&&(o.remoteAuthority=n),o}),emptyWindows:this.emptyWindows.map(({backupFolder:a,remoteAuthority:n})=>{const o={backupFolder:a};return n&&(o.remoteAuthority=n),o})};this.stateMainService.setItem(At.backupWorkspacesMetadataStorageKey,g)}getFolderHash(g){const a=g.folderUri;let n;return a.scheme===k.Schemas.file?n=M.isLinux?a.fsPath:a.fsPath.toLowerCase():n=a.toString().toLowerCase(),(0,v.createHash)("md5").update(n).digest("hex")}};p.backupWorkspacesMetadataStorageKey="backupWorkspaces",p=ve([J(0,b.IEnvironmentMainService),J(1,I.IConfigurationService),J(2,d.ILogService),J(3,y.IStateMainService)],p),e.BackupMainService=p}),define(Z[52],ee([0,1,15,3,43,34,2,13,9,16,12,23,175,60,56,26,5,6,20,42,117,27,91,92]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S,C,w,p,f,g,a,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,C.createDecorator)("workspacesManagementMainService");let i=class extends M.Disposable{constructor(s,c,u,P,D,T){super(),this.environmentMainService=s,this.logService=c,this.userDataProfilesMainService=u,this.backupMainService=P,this.dialogMainService=D,this.productService=T,this._onDidDeleteUntitledWorkspace=this._register(new t.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new t.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const s=(await b.Promises.readdir(this.untitledWorkspacesHome.fsPath)).map(c=>(0,m.joinPath)(this.untitledWorkspacesHome,c,a.UNTITLED_WORKSPACE_NAME));for(const c of s){const u=(0,o.getWorkspaceIdentifier)(c),P=await this.resolveLocalWorkspace(c);P?this.untitledWorkspaces.push({workspace:u,remoteAuthority:P.remoteAuthority}):await this.deleteUntitledWorkspace(u)}}catch(s){s.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${s}).`)}}resolveLocalWorkspace(s){return this.doResolveLocalWorkspace(s,c=>b.Promises.readFile(c,"utf8"))}doResolveLocalWorkspace(s,c){if(!!this.isWorkspacePath(s)&&s.scheme===E.Schemas.file)try{const u=c(s.fsPath);return u instanceof Promise?u.then(P=>this.doResolveWorkspace(s,P),P=>{}):this.doResolveWorkspace(s,u)}catch{return}}isWorkspacePath(s){return(0,a.isUntitledWorkspace)(s,this.environmentMainService)||(0,a.hasWorkspaceFileExtension)(s)}doResolveWorkspace(s,c){try{const u=this.doParseStoredWorkspace(s,c),P=(0,o.getWorkspaceIdentifier)(s);return{id:P.id,configPath:P.configPath,folders:(0,n.toWorkspaceFolders)(u.folders,P.configPath,m.extUriBiasedIgnorePathCase),remoteAuthority:u.remoteAuthority,transient:u.transient}}catch(u){this.logService.warn(u.toString())}}doParseStoredWorkspace(s,c){const u=(0,k.parse)(c);if(u&&Array.isArray(u.folders))u.folders=u.folders.filter(P=>(0,n.isStoredWorkspaceFolder)(P));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return u}async createUntitledWorkspace(s,c){const{workspace:u,storedWorkspace:P}=this.newUntitledWorkspace(s,c),D=u.configPath.fsPath;return await b.Promises.mkdir((0,l.dirname)(D),{recursive:!0}),await b.Promises.writeFile(D,JSON.stringify(P,null,"	")),this.untitledWorkspaces.push({workspace:u,remoteAuthority:c}),u}newUntitledWorkspace(s=[],c){const u=(Date.now()+Math.round(Math.random()*1e3)).toString(),P=(0,m.joinPath)(this.untitledWorkspacesHome,u),D=(0,m.joinPath)(P,a.UNTITLED_WORKSPACE_NAME),T=[];for(const N of s)T.push((0,n.getStoredWorkspaceFolder)(N.uri,!0,N.name,P,m.extUriBiasedIgnorePathCase));return{workspace:(0,o.getWorkspaceIdentifier)(D),storedWorkspace:{folders:T,remoteAuthority:c}}}async getWorkspaceIdentifier(s){return(0,o.getWorkspaceIdentifier)(s)}isUntitledWorkspace(s){return(0,a.isUntitledWorkspace)(s.configPath,this.environmentMainService)}async deleteUntitledWorkspace(s){!this.isUntitledWorkspace(s)||(await this.doDeleteUntitledWorkspace(s),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(s),this._onDidDeleteUntitledWorkspace.fire(s))}async doDeleteUntitledWorkspace(s){const c=(0,m.originalFSPath)(s.configPath);try{await b.Promises.rm((0,l.dirname)(c));const u=(0,l.join)(this.environmentMainService.workspaceStorageHome.fsPath,s.id);await b.Promises.exists(u)&&await b.Promises.writeFile((0,l.join)(u,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(P=>P.workspace.id!==s.id)}catch(u){this.logService.warn(`Unable to delete untitled workspace ${c} (${u}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(s,c,u){if(!s||!s.win||!s.isReady||!await this.isValidTargetWorkspacePath(s,c,u))return;const D=await this.doEnterWorkspace(s,(0,o.getWorkspaceIdentifier)(u));if(!!D)return this._onDidEnterWorkspace.fire({window:s,workspace:D.workspace}),D}async isValidTargetWorkspacePath(s,c,u){if(!u)return!0;if((0,a.isWorkspaceIdentifier)(s.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(s.openedWorkspace.configPath,u))return!1;if((0,g.findWindowOnWorkspaceOrFolder)(c,u)){const P={title:this.productService.nameLong,type:"info",buttons:[(0,R.mnemonicButtonLabel)((0,y.localize)(0,null))],message:(0,y.localize)(1,null,(0,m.basename)(u)),detail:(0,y.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(P,(0,I.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}async doEnterWorkspace(s,c){if(!s.config)return;s.focus();let u;return s.config.extensionDevelopmentPath||(s.config.backupPath?u=await this.backupMainService.registerWorkspaceBackup({workspace:c,remoteAuthority:s.remoteAuthority},s.config.backupPath):u=this.backupMainService.registerWorkspaceBackup({workspace:c,remoteAuthority:s.remoteAuthority})),(0,a.isWorkspaceIdentifier)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&await this.deleteUntitledWorkspace(s.openedWorkspace),s.config.workspace=c,s.config.backupPath=u,{workspace:c,backupPath:u}}};i=ve([J(0,S.IEnvironmentMainService),J(1,w.ILogService),J(2,f.IUserDataProfilesMainService),J(3,h.IBackupMainService),J(4,d.IDialogMainService),J(5,p.IProductService)],i),e.WorkspacesManagementMainService=i}),define(Z[118],ee([0,1,15,41,22,5,32,27,52,12,6]),function(q,e,v,t,k,R,M,E,l,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let b=class{constructor(h,d,S){this.windowsMainService=h,this.workspacesManagementMainService=d,this.logService=S}async getRemoteDiagnostics(h){const d=this.windowsMainService.getWindows();return(await Promise.all(d.map(async C=>{const w=C.remoteAuthority;if(!w)return;const p=`vscode:getDiagnosticInfoResponse${C.id}`,f={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?await this.getFolderURIs(C):void 0};return new Promise(g=>{C.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:p,args:f}),t.validatedIpcMain.once(p,(a,n)=>{n||g({hostName:w,errorMessage:`Unable to resolve connection to '${w}'.`}),g(n)}),setTimeout(()=>{g({hostName:w,errorMessage:`Connection to '${w}' could not be established`})},5e3)})}))).filter(C=>!!C)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const h=[];for(const d of v.BrowserWindow.getAllWindows()){const S=this.windowsMainService.getWindowById(d.id);S?h.push(await this.codeWindowToInfo(S)):h.push(this.browserWindowToInfo(d))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}async codeWindowToInfo(h){const d=await this.getFolderURIs(h),S=(0,m.assertIsDefined)(h.win);return this.browserWindowToInfo(S,d,h.remoteAuthority)}browserWindowToInfo(h,d=[],S){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:d,remoteAuthority:S}}async getFolderURIs(h){const d=[],S=h.openedWorkspace;if((0,E.isSingleFolderWorkspaceIdentifier)(S))d.push(S.uri);else if((0,E.isWorkspaceIdentifier)(S)){const C=await this.workspacesManagementMainService.resolveLocalWorkspace(S.configPath);C&&C.folders.forEach(p=>{d.push(p.uri)})}return d}};b=ve([J(0,M.IWindowsMainService),J(1,l.IWorkspacesManagementMainService),J(2,I.ILogService)],b),e.DiagnosticsMainService=b}),define(Z[65],ee([0,1,45,15,28,141,53,3,34,2,13,9,4,7,97,81,23,93,165,56,26,5,21,6,20,64,32,27,52,18,220]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S,C,w,p,f,g,a,n,o,i,r,s,c,u,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let T=class extends m.Disposable{constructor(U,$,Y,oe,ue,se,de,G,K){super(),this.sharedProcess=U,this.windowsMainService=$,this.dialogMainService=Y,this.lifecycleMainService=oe,this.environmentMainService=ue,this.logService=se,this.productService=de,this.themeMainService=G,this.workspacesManagementMainService=K,this.onDidOpenWindow=E.Event.map(this.windowsMainService.onDidOpenWindow,F=>F.id),this.onDidTriggerSystemContextMenu=E.Event.filter(E.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:F,x:A,y:W})=>({windowId:F.id,x:A,y:W})),({windowId:F})=>!!this.windowsMainService.getWindowById(F)),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(F,A)=>A.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(F,A)=>A.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(F,A)=>A.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),F=>!!F),F=>F.id),E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(F,A)=>A.id),F=>!!this.windowsMainService.getWindowById(F))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new E.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(F,A,W)=>W),F=>!(Array.isArray(F)&&F.length===1&&F[0]==="workArea")),E.Event.fromNodeEventEmitter(t.screen,"display-added"),E.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map($=>({id:$.id,workspace:$.openedWorkspace??(0,c.toWorkspaceIdentifier)($.backupPath,$.isExtensionDevelopmentHost),title:$.win?.getTitle()??"",filename:$.getRepresentedFilename(),dirty:$.isDocumentEdited()}))}async getWindowCount(U){return this.windowsMainService.getWindowCount()}async getActiveWindowId(U){const $=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if($)return $.id}openWindow(U,$,Y){return Array.isArray($)?this.doOpenWindow(U,$,Y):this.doOpenEmptyWindow(U,$)}async doOpenWindow(U,$,Y=Object.create(null)){$.length>0&&await this.windowsMainService.open({context:5,contextWindowId:U,urisToOpen:$,cli:this.environmentMainService.args,forceNewWindow:Y.forceNewWindow,forceReuseWindow:Y.forceReuseWindow,preferNewWindow:Y.preferNewWindow,diffMode:Y.diffMode,mergeMode:Y.mergeMode,addMode:Y.addMode,gotoLineMode:Y.gotoLineMode,noRecentEntry:Y.noRecentEntry,waitMarkerFileURI:Y.waitMarkerFileURI,remoteAuthority:Y.remoteAuthority||void 0})}async doOpenEmptyWindow(U,$){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:U},$)}async toggleFullScreen(U){this.windowById(U)?.toggleFullScreen()}async handleTitleDoubleClick(U){this.windowById(U)?.handleTitleDoubleClick()}async isMaximized(U){const $=this.windowById(U);return $?.win?$.win.isMaximized():!1}async maximizeWindow(U){const $=this.windowById(U);$?.win&&$.win.maximize()}async unmaximizeWindow(U){const $=this.windowById(U);$?.win&&$.win.unmaximize()}async minimizeWindow(U){const $=this.windowById(U);$?.win&&$.win.minimize()}async updateWindowControls(U,$){const Y=this.windowById(U);Y&&Y.updateWindowControls($)}async focusWindow(U,$){$&&typeof $.windowId=="number"&&(U=$.windowId),this.windowById(U)?.focus({force:$?.force??!1})}async setMinimumSize(U,$,Y){const oe=this.windowById(U);if(oe?.win){const[ue,se]=oe.win.getSize(),[de,G]=oe.win.getMinimumSize(),[K,F]=[$??de,Y??G],[A,W]=[Math.max(ue,K),Math.max(se,F)];(de!==K||G!==F)&&oe.win.setMinimumSize(K,F),(ue!==A||se!==W)&&oe.win.setSize(A,W)}}async saveWindowSplash(U,$){this.themeMainService.saveWindowSplash(U,$)}async installShellCommand(U){const{source:$,target:Y}=await this.getShellCommandLink();try{const{symbolicLink:oe}=await C.SymlinkSupport.stat($);if(oe&&!oe.dangling){const ue=await(0,d.realpath)($);if(Y===ue)return}await C.Promises.unlink($)}catch(oe){if(oe.code!=="ENOENT")throw oe}try{await C.Promises.symlink(Y,$)}catch(oe){if(oe.code!=="EACCES"&&oe.code!=="ENOENT")throw oe;const{response:ue}=await this.showMessageBox(U,{title:this.productService.nameLong,type:"info",message:(0,p.localize)(0,null,this.productService.nameShort),buttons:[(0,l.mnemonicButtonLabel)((0,p.localize)(1,null)),(0,l.mnemonicButtonLabel)((0,p.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ue===0)try{const se=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${Y}' '${$}'\\" with administrator privileges"`;await(0,R.promisify)(v.exec)(se)}catch{throw new Error((0,p.localize)(3,null,$))}}}async uninstallShellCommand(U){const{source:$}=await this.getShellCommandLink();try{await C.Promises.unlink($)}catch(Y){switch(Y.code){case"EACCES":{const{response:oe}=await this.showMessageBox(U,{title:this.productService.nameLong,type:"info",message:(0,p.localize)(4,null,this.productService.nameShort),buttons:[(0,l.mnemonicButtonLabel)((0,p.localize)(5,null)),(0,l.mnemonicButtonLabel)((0,p.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(oe===0)try{const ue=`osascript -e "do shell script \\"rm '${$}'\\" with administrator privileges"`;await(0,R.promisify)(v.exec)(ue)}catch{throw new Error((0,p.localize)(7,null,$))}break}case"ENOENT":break;default:throw Y}}}async getShellCommandLink(){const U=(0,b.resolve)(this.environmentMainService.appRoot,"bin","code"),$=`/usr/local/bin/${this.productService.applicationName}`;if(!await C.Promises.exists(U))throw new Error((0,p.localize)(8,null,U));return{source:$,target:U}}async showMessageBox(U,$){return this.dialogMainService.showMessageBox($,this.toBrowserWindow(U))}async showSaveDialog(U,$){return this.dialogMainService.showSaveDialog($,this.toBrowserWindow(U))}async showOpenDialog(U,$){return this.dialogMainService.showOpenDialog($,this.toBrowserWindow(U))}toBrowserWindow(U){const $=this.windowById(U);if($?.win)return $.win}async pickFileFolderAndOpen(U,$){const Y=await this.dialogMainService.pickFileFolder($);Y&&await this.doOpenPicked(await Promise.all(Y.map(async oe=>await C.SymlinkSupport.existsDirectory(oe)?{folderUri:h.URI.file(oe)}:{fileUri:h.URI.file(oe)})),$,U)}async pickFolderAndOpen(U,$){const Y=await this.dialogMainService.pickFolder($);Y&&await this.doOpenPicked(Y.map(oe=>({folderUri:h.URI.file(oe)})),$,U)}async pickFileAndOpen(U,$){const Y=await this.dialogMainService.pickFile($);Y&&await this.doOpenPicked(Y.map(oe=>({fileUri:h.URI.file(oe)})),$,U)}async pickWorkspaceAndOpen(U,$){const Y=await this.dialogMainService.pickWorkspace($);Y&&await this.doOpenPicked(Y.map(oe=>({workspaceUri:h.URI.file(oe)})),$,U)}async doOpenPicked(U,$,Y){await this.windowsMainService.open({context:3,contextWindowId:Y,cli:this.environmentMainService.args,urisToOpen:U,forceNewWindow:$.forceNewWindow})}async showItemInFolder(U,$){t.shell.showItemInFolder($)}async setRepresentedFilename(U,$){this.windowById(U)?.setRepresentedFilename($)}async setDocumentEdited(U,$){this.windowById(U)?.setDocumentEdited($)}async openExternal(U,$){return y.isLinuxSnap?this.safeSnapOpenExternal($):t.shell.openExternal($),!0}safeSnapOpenExternal(U){const $=process.env.GDK_PIXBUF_MODULE_FILE,Y=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(U),process.env.GDK_PIXBUF_MODULE_FILE=$,process.env.GDK_PIXBUF_MODULEDIR=Y}moveItemToTrash(U,$){return t.shell.trashItem($)}async isAdmin(){let U;return y.isWindows?U=(await new Promise(($,Y)=>{q(["native-is-elevated"],$,Y)}))():U=process.getuid()===0,U}async writeElevated(U,$,Y,oe){const ue=await new Promise((se,de)=>{q(["@vscode/sudo-prompt"],se,de)});return new Promise((se,de)=>{const G=[`"${this.cliPath}"`];oe?.unlock&&G.push("--file-chmod"),G.push("--file-write",`"${$.fsPath}"`,`"${Y.fsPath}"`);const K={name:this.productService.nameLong.replace("-",""),icns:y.isMacintosh&&this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ue.exec(G.join(" "),K,(F,A,W)=>{A&&this.logService.trace(`[sudo-prompt] received stdout: ${A}`),W&&this.logService.trace(`[sudo-prompt] received stderr: ${W}`),F?de(F):se(void 0)})})}get cliPath(){return y.isWindows?this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):y.isLinux?this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,b.join)(this.environmentMainService.appRoot,"bin","code"):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return S.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return y.isWindows&&(0,D.hasWSLFeatureInstalled)()}async killProcess(U,$,Y){process.kill($,Y)}async readClipboardText(U,$){return t.clipboard.readText($)}async writeClipboardText(U,$,Y){return t.clipboard.writeText($,Y)}async readClipboardFindText(U){return t.clipboard.readFindText()}async writeClipboardFindText(U,$){return t.clipboard.writeFindText($)}async writeClipboardBuffer(U,$,Y,oe){return t.clipboard.writeBuffer($,Buffer.from(Y.buffer),oe)}async readClipboardBuffer(U,$){return P.VSBuffer.wrap(t.clipboard.readBuffer($))}async hasClipboard(U,$,Y){return t.clipboard.has($,Y)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(U,$){this.windowById(U)?.updateTouchBar($)}async notifyReady(U){this.windowById(U)?.setReady()}async relaunch(U,$){return this.lifecycleMainService.relaunch($)}async reload(U,$){const Y=this.windowById(U);if(Y){if((0,c.isWorkspaceIdentifier)(Y.openedWorkspace)){const oe=Y.openedWorkspace.configPath;if(oe.scheme===I.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(oe))?.transient)return this.openWindow(Y.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(Y,$?.disableExtensions!==void 0?{_:[],"disable-extensions":$.disableExtensions}:void 0)}}async closeWindow(U){this.closeWindowById(U,U)}async closeWindowById(U,$){const Y=this.windowById($);if(Y?.win)return Y.win.close()}async quit(U){const $=this.windowsMainService.getLastActiveWindow();$?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&$.win?$.win.close():this.lifecycleMainService.quit()}async exit(U,$){await this.lifecycleMainService.kill($)}async resolveProxy(U,$){const oe=this.windowById(U)?.win?.webContents?.session;if(oe)return oe.resolveProxy($)}findFreePort(U,$,Y,oe,ue=1){return(0,w.findFreePort)($,Y,oe,ue)}async openDevTools(U,$){const Y=this.windowById(U);Y?.win&&Y.win.webContents.openDevTools($)}async toggleDevTools(U){const $=this.windowById(U);$?.win&&$.win.webContents.toggleDevTools()}async sendInputEvent(U,$){const Y=this.windowById(U);Y?.win&&($.type==="mouseDown"||$.type==="mouseUp")&&Y.win.webContents.sendInputEvent($)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(U,$,Y,oe){if(!y.isWindows)return;const ue=await new Promise((se,de)=>{q(["@vscode/windows-registry"],se,de)});try{return ue.GetStringRegKey($,Y,oe)}catch{return}}windowById(U){if(typeof U=="number")return this.windowsMainService.getWindowById(U)}};ve([M.memoize],T.prototype,"cliPath",null),T=ve([J(1,s.IWindowsMainService),J(2,f.IDialogMainService),J(3,n.ILifecycleMainService),J(4,g.IEnvironmentMainService),J(5,o.ILogService),J(6,i.IProductService),J(7,r.IThemeMainService),J(8,u.IWorkspacesManagementMainService)],T),e.NativeHostMainService=T}),define(Z[262],ee([0,1,15,41,28,34,2,13,4,98,163,84,118,56,26,5,6,65,54,20,61,74,30,12]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S,C,w,p,f,g,a,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,S.createDecorator)("issueMainService");let i=class _t{constructor(s,c,u,P,D,T,N,U,$){this.userEnv=s,this.environmentMainService=c,this.logService=u,this.diagnosticsService=P,this.diagnosticsMainService=D,this.dialogMainService=T,this.nativeHostMainService=N,this.protocolMainService=U,this.productService=$,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async s=>{const[c,u]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),P=await this.diagnosticsService.getSystemInfo(c,u);this.safeSend(s,"vscode:issueSystemInfoResponse",P)}),t.validatedIpcMain.on("vscode:listProcesses",async s=>{const c=[];try{c.push({name:(0,I.localize)(0,null),rootProcess:await(0,m.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(P=>{(0,b.isRemoteDiagnosticError)(P)?c.push({name:P.hostName,rootProcess:P}):P.processes&&c.push({name:P.hostName,rootProcess:P.processes})})}catch(u){this.logService.error(`Listing processes failed: ${u}`)}this.safeSend(s,"vscode:listProcessesResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async s=>{const c={title:this.productService.nameLong,message:(0,I.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,I.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const u=await this.dialogMainService.showMessageBox(c,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",u.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const c=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,I.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,I.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(s,c)=>{const{id:u,from:P,args:D}=c;let T;switch(P){case"issueReporter":T=this.issueReporterParentWindow;break;case"processExplorer":T=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${P}`)}T?.webContents.send("vscode:runAction",{id:u,from:P,args:D})}),t.validatedIpcMain.on("vscode:openExternal",(s,c)=>{this.nativeHostMainService.openExternal(void 0,c)}),t.validatedIpcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async s=>{const c=await this.diagnosticsMainService.getMainDiagnostics();this.safeSend(s,"vscode:windowsInfoResponse",c.windows)})}safeSend(s,c,...u){s.sender.isDestroyed()||s.sender.send(c,...u)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const c=new M.DisposableStore,u=c.add(this.protocolMainService.createIPCObjectUrl()),P=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(P,u,{backgroundColor:s.styles.backgroundColor,title:(0,I.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),u.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:p.default}),this.issueReporterWindow.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",q).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,c.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,c.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const c=new M.DisposableStore,u=c.add(this.protocolMainService.createIPCObjectUrl()),P=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(P,u,{backgroundColor:s.styles.backgroundColor,title:(0,I.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),u.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:p.default}),this.processExplorerWindow.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",q).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,c.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,c.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,c,u,P){const D=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:u.title,backgroundColor:u.backgroundColor||_t.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,`--vscode-window-kind=${P}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,a.zoomLevelToZoomFactor)(u.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:u.alwaysOnTop,experimentalDarkMode:!0});return D.setMenuBarVisibility(!1),D}async getSystemStatus(){const[s,c]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,c)}getWindowPosition(s,c,u){let P;const D=v.screen.getAllDisplays();if(D.length===1)P=D[0];else{if(l.isMacintosh){const U=v.screen.getCursorScreenPoint();P=v.screen.getDisplayNearestPoint(U)}!P&&s&&(P=v.screen.getDisplayMatching(s.getBounds())),P||(P=v.screen.getPrimaryDisplay()||D[0])}const T={width:c,height:u},N=P.bounds;return T.x=N.x+N.width/2-T.width/2,T.y=N.y+N.height/2-T.height/2,N.width>0&&N.height>0&&(T.x<N.x&&(T.x=N.x),T.y<N.y&&(T.y=N.y),T.x>N.x+N.width&&(T.x=N.x),T.y>N.y+N.height&&(T.y=N.y),T.width>N.width&&(T.width=N.width),T.height>N.height&&(T.height=N.height)),T}async getPerformanceInfo(){try{const[s,c]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,c)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}async stopTracing(){if(!this.environmentMainService.args.trace)return;const s=await v.contentTracing.stopRecording(`${(0,n.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,I.localize)(9,null),detail:(0,I.localize)(10,null,s),buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(11,null))],defaultId:0,noLink:!0},(0,o.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),this.nativeHostMainService.showItemInFolder(void 0,s)}};i.DEFAULT_BACKGROUND_COLOR="#1E1E1E",i=ve([J(1,d.IEnvironmentMainService),J(2,C.ILogService),J(3,b.IDiagnosticsService),J(4,y.IDiagnosticsMainService),J(5,h.IDialogMainService),J(6,w.INativeHostMainService),J(7,g.IProtocolMainService),J(8,f.IProductService)],i),e.IssueMainService=i}),define(Z[263],ee([0,1,22,19,26,21,6,65,20,55,36,48,88]),function(q,e,v,t,k,R,M,E,l,m,I,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let h=class extends y.AbstractUpdateService{constructor(S,C,w,p,f,g,a,n){super(S,C,p,f,g,n),this.telemetryService=w,this.nativeHostMainService=a}buildUpdateFeedUrl(S){return(0,y.createUpdateURL)(`linux-${process.arch}`,S,this.productService)}doCheckForUpdates(S){!this.url||(this.setState(b.State.CheckingForUpdates(S)),this.requestService.request({url:this.url},v.CancellationToken.None).then(m.asJson).then(C=>{!C||!C.url||!C.version||!C.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S}),this.setState(b.State.Idle(1))):this.setState(b.State.AvailableForDownload(C))}).then(void 0,C=>{this.logService.error(C),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S});const w=S?C.message||C:void 0;this.setState(b.State.Idle(1,w))}))}async doDownloadUpdate(S){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):S.update.url&&this.nativeHostMainService.openExternal(void 0,S.update.url),this.setState(b.State.Idle(1))}};h=ve([J(0,R.ILifecycleMainService),J(1,t.IConfigurationService),J(2,I.ITelemetryService),J(3,k.IEnvironmentMainService),J(4,m.IRequestService),J(5,M.ILogService),J(6,E.INativeHostMainService),J(7,l.IProductService)],h),e.LinuxUpdateService=h}),define(Z[264],ee([0,1,45,40,28,8,22,53,9,7,127,23,19,26,14,21,6,65,20,55,36,48,88]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S,C,w,p,f,g,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function o(c,u=1e3){for(;!c();)await(0,R.timeout)(u)}let i;function r(){return typeof i>"u"&&(i=t.existsSync(l.join(l.dirname(process.execPath),"unins000.exe"))?0:1),i}let s=class extends n.AbstractUpdateService{constructor(u,P,D,T,N,U,$,Y,oe){super(u,P,T,N,U,oe),this.telemetryService=D,this.fileService=$,this.nativeHostMainService=Y}get cachePath(){const u=l.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return b.Promises.mkdir(u,{recursive:!0}).then(()=>u)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(u){let P="win32";return process.arch!=="ia32"&&(P+=`-${process.arch}`),r()===1?P+="-archive":this.productService.target==="user"&&(P+="-user"),(0,n.createUpdateURL)(P,u,this.productService)}doCheckForUpdates(u){!this.url||(this.setState(a.State.CheckingForUpdates(u)),this.requestService.request({url:this.url},M.CancellationToken.None).then(f.asJson).then(P=>{const D=r();return!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!u}),this.setState(a.State.Idle(D)),Promise.resolve(null)):D===1?(this.setState(a.State.AvailableForDownload(P)),Promise.resolve(null)):(this.setState(a.State.Downloading(P)),this.cleanup(P.version).then(()=>this.getUpdatePackagePath(P.version).then(T=>b.Promises.exists(T).then(N=>{if(N)return Promise.resolve(T);const U=P.url,$=P.hash,Y=`${T}.tmp`;return this.requestService.request({url:U},M.CancellationToken.None).then(oe=>this.fileService.writeFile(m.URI.file(Y),oe.stream)).then($?()=>(0,I.checksum)(Y,P.hash):()=>{}).then(()=>b.Promises.rename(Y,T)).then(()=>T)})).then(T=>{const N=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},N&&P.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(a.State.Downloaded(P)):this.setState(a.State.Ready(P))})))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!u});const D=u?P.message||P:void 0;this.setState(a.State.Idle(r(),D))}))}async doDownloadUpdate(u){u.update.url&&this.nativeHostMainService.openExternal(void 0,u.update.url),this.setState(a.State.Idle(r()))}async getUpdatePackagePath(u){const P=await this.cachePath;return l.join(P,`CodeSetup-${this.productService.quality}-${u}.exe`)}async cleanup(u=null){const P=u?U=>!new RegExp(`${this.productService.quality}-${u}\\.exe$`).test(U):()=>!0,D=await this.cachePath,N=(await b.Promises.readdir(D)).filter(P).map(async U=>{try{await b.Promises.unlink(l.join(D,U))}catch{}});await Promise.all(N)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const u=this.state.update;this.setState(a.State.Updating(u));const P=await this.cachePath;this.availableUpdate.updateFilePath=l.join(P,`CodeSetup-${this.productService.quality}-${u.version}.flag`),await b.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(a.State.Idle(r()))});const T=`${this.productService.win32MutexName}-ready`,N=await new Promise((U,$)=>{q(["windows-mutex"],U,$)});o(()=>N.isActive(T)).then(()=>this.setState(a.State.Ready(u)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return r()}async _applySpecificUpdate(u){if(this.state.type!=="idle")return;const P=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!P};this.setState(a.State.Downloading(D)),this.availableUpdate={packagePath:u},P?this.productService.target==="user"?this.doApplyUpdate():this.setState(a.State.Downloaded(D)):this.setState(a.State.Ready(D))}};ve([E.memoize],s.prototype,"cachePath",null),s=ve([J(0,S.ILifecycleMainService),J(1,y.IConfigurationService),J(2,g.ITelemetryService),J(3,h.IEnvironmentMainService),J(4,f.IRequestService),J(5,C.ILogService),J(6,d.IFileService),J(7,w.INativeHostMainService),J(8,p.IProductService)],s),e.Win32UpdateService=s}),define(Z[265],ee([0,1,15,8,22,44,3,34,2,13,9,71,4,7,171,60,19,56,26,59,14,21,6,20,61,231,90,36,234,64,74,32,27,52,115,120,37,38,54,42]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S,C,w,p,f,g,a,n,o,i,r,s,c,u,P,D,T,N,U,$,Y,oe,ue,se,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var G;(function(F){F[F.NONE=0]="NONE",F[F.NAVIGATING=1]="NAVIGATING",F[F.READY=2]="READY"})(G||(G={}));let K=class Tt extends l.Disposable{constructor(A,W,z,te,B,H,L,O,_,V,x,re,j,ie,ne,ae,fe,De,Le){super(),this.logService=W,this.environmentMainService=z,this.policyService=te,this.userDataProfilesService=B,this.fileService=H,this.applicationStorageMainService=L,this.storageMainService=O,this.configurationService=_,this.themeMainService=V,this.workspacesManagementMainService=x,this.backupMainService=re,this.telemetryService=j,this.dialogMainService=ie,this.lifecycleMainService=ne,this.productService=ae,this.protocolMainService=fe,this.windowsMainService=De,this.stateMainService=Le,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new M.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[ke,Ae]=this.restoreWindowState(A.state);this.windowState=ke,this.logService.trace("window#ctor: using window state",ke);const He=this.windowState.mode===0||this.windowState.mode===3,ge=this.configurationService.getValue("window");let we=!1;typeof ge?.experimental?.useSandbox=="boolean"?we=ge.experimental.useSandbox:we=typeof se.default.quality=="string"&&se.default.quality!=="stable";const Ce={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!He,title:this.productService.nameLong,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,D.zoomLevelToZoomFactor)(ge?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...we?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};y.isLinux?Ce.icon=(0,I.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):y.isWindows&&!this.environmentMainService.isBuilt&&(Ce.icon=(0,I.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),y.isMacintosh&&!this.useNativeFullScreen()&&(Ce.fullscreenable=!1),y.isMacintosh&&(Ce.acceptFirstMouse=!0,ge?.clickThroughInactive===!1&&(Ce.acceptFirstMouse=!1));const X=y.isMacintosh&&ge?.nativeTabs===!0;X&&(Ce.tabbingIdentifier=this.productService.nameShort);const ce=(0,D.getTitleBarStyle)(this.configurationService)==="custom";if(ce&&(Ce.titleBarStyle="hidden",y.isMacintosh||(Ce.frame=!1),(0,D.useWindowControlsOverlay)(this.configurationService,this.environmentMainService))){const he=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),ye=Y.Color.fromHex(he).isDarker()?"#FFFFFF":"#000000";Ce.titleBarOverlay={height:29,color:he,symbolColor:ye},this.hasWindowControlOverlay=!0}if((0,b.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(Ce),(0,b.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,y.isMacintosh&&ce&&this._win.setSheetOffset(22),ce&&(y.isWindows&&(0,D.useWindowControlsOverlay)(this.configurationService,this.environmentMainService)||y.isMacintosh)){const he=this.stateMainService.getItem(Tt.windowControlHeightStateStorageKey);he&&this.updateWindowControls({height:he})}y.isWindows&&ce&&this._win.hookWindowMessage(278,()=>{const[ye,Ee]=this._win.getPosition(),We=v.screen.getCursorScreenPoint(),Te=We.x-ye,Ne=We.y-Ee;return(()=>!(Te>30&&Ne>=0&&Ne<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Te,y:Ne})),0}),(y.isMacintosh||y.isWindows)&&Ae&&(!X||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(he=>typeof he=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),He&&((0,b.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,b.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",this.userDataProfilesService.profiles.find(A=>A.id===this.config?.profiles.profile.id)??this.userDataProfilesService.defaultProfile):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}setRepresentedFilename(A){y.isMacintosh?this._win.setRepresentedFilename(A):this.representedFilename=A}getRepresentedFilename(){return y.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(A){y.isMacintosh&&this._win.setDocumentEdited(A),this.documentEdited=A}isDocumentEdited(){return y.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(A){y.isMacintosh&&A?.force&&v.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.whenReadyCallbacks.push(A)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(A=>{function W(){z.dispose(),te.dispose(),A()}const z=this.onDidClose(()=>W()),te=this.onWillLoad(()=>W())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(W,z)=>this.onWindowError(2,z)),this._win.webContents.on("did-fail-load",(W,z,te)=>this.onWindowError(3,{reason:te,exitCode:z})),this._win.webContents.on("will-prevent-unload",W=>{W.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",W=>{this._config&&(this._config.maximized=!0),v.app.emit("browser-window-maximize",W,this._win)}),this._win.on("unmaximize",W=>{this._config&&(this._config.maximized=!1),v.app.emit("browser-window-unmaximize",W,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(W=>this.onConfigurationUpdated(W))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(W=>this.onDidDeleteUntitledWorkspace(W)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(W,z)=>{const te=await this.getMarketplaceHeaders();z({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,te)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,r.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(A,W){switch(A){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:A,reason:W?.reason,code:W?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,d.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,d.localize)(1,null)),(0,E.mnemonicButtonLabel)((0,d.localize)(2,null))],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,d.localize)(5,null):void 0},this._win);if(z.response!==1){const te=z.response===0;await this.destroyWindow(te,z.checkboxChecked)}}else if(A===2){let z;W?z=(0,d.localize)(7,null,W.reason,W.exitCode??"<unknown>"):z=(0,d.localize)(6,null);const te=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,d.localize)(8,null)),(0,E.mnemonicButtonLabel)((0,d.localize)(9,null))],message:z,detail:(0,d.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,d.localize)(11,null):void 0},this._win),B=te.response===0;await this.destroyWindow(B,te.checkboxChecked)}break}}async destroyWindow(A,W){const z=this._config?.workspace;if(W&&z)try{const te=this.storageMainService.workspaceStorage(z);await te.init(),te.delete("memento/workbench.parts.editor"),await te.close()}catch(te){this.logService.error(te)}if(this._onDidDestroy.fire(),this._win?.destroy(),A&&this._config){let te,B;(0,N.isSingleFolderWorkspaceIdentifier)(z)?te={folderUri:z.uri}:(0,N.isWorkspaceIdentifier)(z)?te={workspaceUri:z.configPath}:B=!0;const[H]=await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:te?[te]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});H.focus()}}onDidDeleteUntitledWorkspace(A){this._config?.workspace?.id===A.id&&(this._config.workspace=void 0)}onConfigurationUpdated(A){const W=this.getMenuBarVisibility();W!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=W,this.setMenuBarVisibility(W));let z=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;z?.endsWith("/")&&(z=z.substr(0,z.length-1));const te=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((z||"").indexOf("@")===-1&&(z!==this.currentHttpProxy||te!==this.currentNoProxy)){this.currentHttpProxy=z,this.currentNoProxy=te;const B=z||"",H=te?`${te},<local>`:"<local>";this.logService.trace(`Setting proxy to '${B}', bypassing '${H}'`),this._win.webContents.session.setProxy({proxyRules:B,proxyBypassRules:H,pacScript:""})}}addTabbedWindow(A){y.isMacintosh&&A.win&&this._win.addTabbedWindow(A.win)}load(A,W=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!W.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),W.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(A,W),this.readyState===0?this._config=A:this.pendingLoadConfig=A,this.readyState=1,this._win.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/workbench/workbench.html",q).toString(!0));const z=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:A.workspace,reason:W.isReload?3:z?2:1})}updateConfiguration(A,W){const z=(this._config??this.pendingLoadConfig)?.userEnv;if(z){const te=(0,f.isLaunchedFromCli)(z)&&!(0,f.isLaunchedFromCli)(A.userEnv),B=this.isExtensionDevelopmentHost;(te||B)&&(A.userEnv={...z,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),W.disableExtensions!==void 0&&(A["disable-extensions"]=W.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this._win.isMaximized(),A.partsSplash=this.themeMainService.getWindowSplash(),(0,b.mark)("code/willOpenNewWindow"),A.perfMarks=(0,b.getMarks)(),this.configObjectUrl.update(A)}async reload(A){const W=Object.assign({},this._config);W.workspace=await this.validateWorkspaceBeforeReload(W),delete W.filesToOpenOrCreate,delete W.filesToDiff,delete W.filesToMerge,delete W.filesToWait,this.isExtensionDevelopmentHost&&A&&(W.verbose=A.verbose,W.debugId=A.debugId,W.extensionEnvironment=A.extensionEnvironment,W["inspect-extensions"]=A["inspect-extensions"],W["inspect-brk-extensions"]=A["inspect-brk-extensions"],W["extensions-dir"]=A["extensions-dir"]),W.isInitialStartup=!1,W.policiesData=this.policyService.serialize(),W.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile},this.load(W,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async validateWorkspaceBeforeReload(A){if((0,N.isWorkspaceIdentifier)(A.workspace)){const W=A.workspace.configPath;if(W.scheme===m.Schemas.file&&!await this.fileService.exists(W))return}else if((0,N.isSingleFolderWorkspaceIdentifier)(A.workspace)){const W=A.workspace.uri;if(W.scheme===m.Schemas.file&&!await this.fileService.exists(W))return}return A.workspace}serializeWindowState(){if(!this._win)return(0,$.defaultWindowState)();if(this.isFullScreen){let z;try{z=v.screen.getDisplayMatching(this.getBounds())}catch{}const te=(0,$.defaultWindowState)();return{mode:3,display:z?z.id:void 0,width:this.windowState.width||te.width,height:this.windowState.height||te.height,x:this.windowState.x||0,y:this.windowState.y||0}}const A=Object.create(null);let W;if(!y.isMacintosh&&this._win.isMaximized()?W=0:W=1,W===0?A.mode=0:A.mode=1,W===1||W===0){let z;W===1?z=this.getBounds():z=this._win.getNormalBounds(),A.x=z.x,A.y=z.y,A.width=z.width,A.height=z.height}return A}updateWindowControls(A){A.height&&this.stateMainService.setItem(Tt.windowControlHeightStateStorageKey,A.height),y.isWindows&&this.hasWindowControlOverlay?this._win.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0}):y.isMacintosh&&A.height!==void 0&&this._win.setTrafficLightPosition({x:7,y:(A.height-15)/2})}restoreWindowState(A){(0,b.mark)("code/willRestoreCodeWindowState");let W=!1;if(A)try{const z=v.screen.getAllDisplays();W=z.length>1,A=this.validateWindowState(A,z)}catch(z){this.logService.warn(`Unexpected error validating window state: ${z}
${z.stack}`)}return(0,b.mark)("code/didRestoreCodeWindowState"),[A||(0,$.defaultWindowState)(),W]}validateWindowState(A,W){if(this.logService.trace(`window#validateWindowState: validating window state on ${W.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(W.length===1){const B=this.getWorkingArea(W[0]);if(B){let H=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!B||(A.x<B.x&&(A.x=B.x),A.y<B.y&&(A.y=B.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",B),H(),A.width>B.width&&(A.width=B.width),A.height>B.height&&(A.height=B.height),A.x>B.x+B.width-128&&(A.x=B.x+B.width-A.width),A.y>B.y+B.height-128&&(A.y=B.y+B.height-A.height),H()}return A}if(A.display&&A.mode===3){const B=W.find(H=>H.id===A.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const H=(0,$.defaultWindowState)(3);return H.x=B.bounds.x,H.y=B.bounds.y,H}}let z,te;try{z=v.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),te=this.getWorkingArea(z)}catch{}if(z&&te&&A.x+A.width>te.x&&A.y+A.height>te.y&&A.x<te.x+te.width&&A.y<te.y+te.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",te),A}getWorkingArea(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,W]=this._win.getPosition(),[z,te]=this._win.getSize();return{x:A,y:W,width:z,height:te}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(A){this.useNativeFullScreen()?this.setNativeFullScreen(A):this.setSimpleFullScreen(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return y.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(A){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(A)}doSetNativeFullScreen(A){y.isMacintosh&&(this.transientIsNativeFullScreen=A,this.joinNativeFullScreenTransition=new t.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,t.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(A)}setSimpleFullScreen(A){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(A),this._win.webContents.focus()}useNativeFullScreen(){const A=this.configurationService.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let A=(0,D.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}setMenuBarVisibility(A,W=!0){y.isMacintosh||(A==="toggle"&&W&&this.send("vscode:showInfoMessage",(0,d.localize)(12,null)),A==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(A)}):this.doSetMenuBarVisibility(A))}doSetMenuBarVisibility(A){const W=this.isFullScreen;switch(A){case"classic":this._win.setMenuBarVisibility(!W),this._win.autoHideMenuBar=W;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(y.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(A,W,...z){this.isReady?this.send(A,...z):this.ready().then(()=>{W.isCancellationRequested||this.send(A,...z)})}send(A,...W){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this._win.webContents.send(A,...W)}catch(z){this.logService.warn(`Error sending IPC message to channel '${A}' of window ${this._id}: ${(0,R.toErrorMessage)(z)}`)}}}updateTouchBar(A){!y.isMacintosh||this.touchBarGroups.forEach((W,z)=>{const te=A[z];W.segments=this.createTouchBarGroupSegments(te)})}createTouchBar(){if(!!y.isMacintosh){for(let A=0;A<10;A++){const W=this.createTouchBarGroup();this.touchBarGroups.push(W)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(A=[]){const W=this.createTouchBarGroupSegments(A),z=new v.TouchBar.TouchBarSegmentedControl({segments:W,mode:"buttons",segmentStyle:"automatic",change:te=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:z.segments[te].id,from:"touchbar"})}});return z}createTouchBarGroupSegments(A=[]){return A.map(z=>{let te;z.icon&&!u.ThemeIcon.isThemeIcon(z.icon)&&z.icon?.dark?.scheme===m.Schemas.file&&(te=v.nativeImage.createFromPath(h.URI.revive(z.icon.dark).fsPath),te.isEmpty()&&(te=void 0));let B;return typeof z.title=="string"?B=z.title:B=z.title.value,{id:z.id,label:te?void 0:B,icon:te}})}dispose(){super.dispose(),this._win=null}};K.windowControlHeightStateStorageKey="windowControlHeight",K=ve([J(1,n.ILogService),J(2,p.IEnvironmentMainService),J(3,oe.IPolicyService),J(4,de.IUserDataProfilesMainService),J(5,g.IFileService),J(6,s.IApplicationStorageMainService),J(7,s.IStorageMainService),J(8,C.IConfigurationService),J(9,P.IThemeMainService),J(10,U.IWorkspacesManagementMainService),J(11,S.IBackupMainService),J(12,c.ITelemetryService),J(13,w.IDialogMainService),J(14,a.ILifecycleMainService),J(15,o.IProductService),J(16,i.IProtocolMainService),J(17,T.IWindowsMainService),J(18,ue.IStateMainService)],K),e.CodeWindow=K}),define(Z[75],ee([0,1,15,24,8,3,34,2,13,4,16,7,23,174,5,21,6,90,91,27,52]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S,C,w,p,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let a=class nt extends E.Disposable{constructor(o,i,r,s){super(),this.logService=o,this.workspacesManagementMainService=i,this.lifecycleMainService=r,this.applicationStorageMainService=s,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(o=>this.addRecentlyOpened([{workspace:o.workspace,remoteAuthority:o.window.remoteAuthority}])))}async addRecentlyOpened(o){const i=[],r=[];for(const s of o)if((0,p.isRecentWorkspace)(s))!this.workspacesManagementMainService.isUntitledWorkspace(s.workspace)&&this.indexOfWorkspace(i,s.workspace)===-1&&i.push(s);else if((0,p.isRecentFolder)(s))this.indexOfFolder(i,s.folderUri)===-1&&i.push(s);else{const c=this.indexOfFile(r,s.fileUri)>=0,u=s.fileUri.scheme===l.Schemas.file&&nt.COMMON_FILES_FILTER.indexOf((0,I.basename)(s.fileUri))>=0;!c&&!u&&(r.push(s),m.isWindows&&s.fileUri.scheme===l.Schemas.file&&v.app.addRecentDocument(s.fileUri.fsPath))}await this.addEntriesFromStorage(i,r),i.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(i.length=nt.MAX_TOTAL_RECENT_ENTRIES),r.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(r.length=nt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:r}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(o){const i=u=>{const P=this.location(u);for(const D of o)if(I.extUriBiasedIgnorePathCase.isEqual(D,P))return!1;return!0},r=await this.getRecentlyOpened(),s=r.workspaces.filter(i),c=r.files.filter(i);(s.length!==r.workspaces.length||c.length!==r.files.length)&&(await this.saveRecentlyOpened({files:c,workspaces:s}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){const o=[],i=[];return await this.addEntriesFromStorage(o,i),{workspaces:o,files:i}}async addEntriesFromStorage(o,i){const r=await this.getRecentlyOpenedFromStorage();for(const s of r.workspaces){const c=(0,p.isRecentFolder)(s)?this.indexOfFolder(o,s.folderUri):this.indexOfWorkspace(o,s.workspace);c>=0?o[c].label=o[c].label||s.label:o.push(s)}for(const s of r.files){const c=this.indexOfFile(i,s.fileUri);c>=0?i[c].label=i[c].label||s.label:i.push(s)}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let o;const i=this.applicationStorageMainService.get(nt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof i=="string")try{o=JSON.parse(i)}catch(r){this.logService.error("Unexpected error parsing opened paths list",r)}return(0,p.restoreRecentlyOpened)(o,this.logService)}async saveRecentlyOpened(o){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(nt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,p.toStoreData)(o)),-1,1)}location(o){return(0,p.isRecentFolder)(o)?o.folderUri:(0,p.isRecentFile)(o)?o.fileUri:o.workspace.configPath}indexOfWorkspace(o,i){return o.findIndex(r=>(0,p.isRecentWorkspace)(r)&&r.workspace.id===i.id)}indexOfFolder(o,i){return o.findIndex(r=>(0,p.isRecentFolder)(r)&&I.extUriBiasedIgnorePathCase.isEqual(r.folderUri,i))}indexOfFile(o,i){return o.findIndex(r=>I.extUriBiasedIgnorePathCase.isEqual(r.fileUri,i))}async handleWindowsJumpList(){!m.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!m.isWindows)return;const o=[];if(o.push({type:"tasks",items:[{type:"task",title:(0,h.localize)(0,null),description:(0,h.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const i=[];for(const c of v.app.getJumpListSettings().removedItems){const u=c.args;if(u){const P=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(u);P&&i.push(b.URI.parse(P[2]))}}await this.removeRecentlyOpened(i);let r=!1;const s=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,nt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(c=>{const u=(0,p.isRecentWorkspace)(c)?c.workspace:c.folderUri,{title:P,description:D}=this.getWindowsJumpListLabel(u,c.label);let T;return b.URI.isUri(u)?T=`--folder-uri "${u.toString()}"`:(r=!0,T=`--file-uri "${u.configPath.toString()}"`),{type:"task",title:P.substr(0,255),description:D.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));s.length>0&&o.push({type:"custom",name:r?(0,h.localize)(2,null):(0,h.localize)(3,null),items:s})}o.push({type:"recent"});try{const i=v.app.setJumpList(o);i&&i!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${i}`)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(o,i){if(i)return{title:(0,M.splitName)(i).name,description:i};if(b.URI.isUri(o))return{title:(0,I.basename)(o),description:this.renderJumpListPathDescription(o)};if(this.workspacesManagementMainService.isUntitledWorkspace(o))return{title:(0,h.localize)(4,null),description:""};let r=(0,I.basename)(o.configPath);return r.endsWith(f.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-f.WORKSPACE_EXTENSION.length-1)),{title:(0,h.localize)(5,null,r),description:this.renderJumpListPathDescription(o.configPath)}}renderJumpListPathDescription(o){return o.scheme==="file"?(0,M.normalizeDriveLetter)(o.fsPath):o.toString()}async updateMacOSRecentDocuments(){if(!m.isMacintosh)return;v.app.clearRecentDocuments();const o=await this.getRecentlyOpened(),i=[];let r=0;for(let c=0;c<o.workspaces.length&&r<nt.MAX_MACOS_DOCK_RECENT_WORKSPACES;c++){const u=this.location(o.workspaces[c]);if(u.scheme===l.Schemas.file){const P=(0,I.originalFSPath)(u);await y.Promises.exists(P)&&(i.push(P),r++)}}const s=[];for(let c=0;c<o.files.length&&r<nt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;c++){const u=this.location(o.files[c]);if(u.scheme===l.Schemas.file){const P=(0,I.originalFSPath)(u);if(nt.COMMON_FILES_FILTER.includes((0,I.basename)(u))||i.includes(P))continue;await y.Promises.exists(P)&&(s.push(P),r++)}}s.reverse().forEach(c=>v.app.addRecentDocument(c)),i.reverse().forEach(c=>v.app.addRecentDocument(c))}};a.MAX_TOTAL_RECENT_ENTRIES=500,a.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a=ve([J(0,C.ILogService),J(1,g.IWorkspacesManagementMainService),J(2,S.ILifecycleMainService),J(3,w.IApplicationStorageMainService)],a),e.WorkspacesHistoryMainService=a}),define(Z[266],ee([0,1,15,8,22,34,4,7,164,19,26,21,6,210,65,20,38,36,48,74,32,75]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S,C,w,p,f,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const n="menu";let o=class Ot{constructor(s,c,u,P,D,T,N,U,$,Y,oe){this.updateService=s,this.configurationService=c,this.windowsMainService=u,this.environmentMainService=P,this.telemetryService=D,this.workspacesHistoryMainService=T,this.stateMainService=N,this.lifecycleMainService=U,this.logService=$,this.nativeHostMainService=Y,this.productService=oe,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,f.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(Ot.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,N,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:N?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,N,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:N?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,N,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(T,N,U)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,N,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const c=this.productService.requestFeatureUrl;c&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(c,"openUserVoiceUrl"));const u=this.productService.reportIssueUrl;u&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(u,"openReportIssues"));const P=this.productService.licenseUrl;P&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const T=P.indexOf("?")>0?"&":"?";this.openUrl(`${P}${T}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(P,"openLicenseUrl")});const D=this.productService.privacyStatementUrl;D&&P&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(D,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;const s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,c){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(Ot.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!M.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!M.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=v.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(M.isMacintosh?new v.Menu:null);return}const c=new v.Menu;let u;if(M.isMacintosh){const D=new v.Menu;u=new v.MenuItem({label:this.productService.nameShort,submenu:D}),this.setMacApplicationMenu(D),c.append(u)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const D=new v.Menu;D.append(new v.MenuItem({label:this.mnemonicLabel(l.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(D)}if(this.shouldDrawMenu("File")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(1,null)),submenu:D});this.setMenuById(D,"File"),c.append(T)}if(this.shouldDrawMenu("Edit")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(2,null)),submenu:D});this.setMenuById(D,"Edit"),c.append(T)}if(this.shouldDrawMenu("Selection")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(3,null)),submenu:D});this.setMenuById(D,"Selection"),c.append(T)}if(this.shouldDrawMenu("View")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(4,null)),submenu:D});this.setMenuById(D,"View"),c.append(T)}if(this.shouldDrawMenu("Go")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(5,null)),submenu:D});this.setMenuById(D,"Go"),c.append(T)}if(this.shouldDrawMenu("Run")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(6,null)),submenu:D});this.setMenuById(D,"Run"),c.append(T)}if(this.shouldDrawMenu("Terminal")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(7,null)),submenu:D});this.setMenuById(D,"Terminal"),c.append(T)}let P;if(this.shouldDrawMenu("Window")){const D=new v.Menu;P=new v.MenuItem({label:this.mnemonicLabel(l.localize(8,null)),submenu:D,role:"window"}),this.setMacWindowMenu(D)}if(P&&c.append(P),this.shouldDrawMenu("Help")){const D=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(l.localize(9,null)),submenu:D,role:"help"});this.setMenuById(D,"Help"),c.append(T)}c.items&&c.items.length>0?v.Menu.setApplicationMenu(c):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const c=this.createMenuItem(l.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),u=this.getUpdateMenuItems();let P;if(this.shouldDrawMenu("Preferences")){const ue=new v.Menu;this.setMenuById(ue,"Preferences"),P=new v.MenuItem({label:this.mnemonicLabel(l.localize(11,null)),submenu:ue})}const D=new v.Menu,T=new v.MenuItem({label:l.localize(12,null),role:"services",submenu:D}),N=new v.MenuItem({label:l.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new v.MenuItem({label:l.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),$=new v.MenuItem({label:l.localize(15,null),role:"unhide"}),Y=new v.MenuItem(this.likeAction("workbench.action.quit",{label:l.localize(16,null,this.productService.nameLong),click:async(ue,se,de)=>{const G=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||G?.isMinimized())&&await this.confirmBeforeQuit(de)&&this.nativeHostMainService.quit(void 0)}})),oe=[c];oe.push(...u),P&&oe.push(i(),P),oe.push(i(),T,i(),N,U,$,i(),Y),oe.forEach(ue=>s.append(ue))}async confirmBeforeQuit(s){if(this.windowsMainService.getWindowCount()===0)return!0;const c=this.configurationService.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.isKeyboardEvent(s)){const u={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(l.localize(17,null)),(0,R.mnemonicButtonLabel)(l.localize(18,null))],message:l.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:P}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,u);return P===0}return!0}shouldDrawMenu(s){if(!M.isMacintosh&&(0,f.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,c){c.forEach(u=>{if((0,h.isMenubarMenuItemSeparator)(u))s.append(i());else if((0,h.isMenubarMenuItemSubmenu)(u)){const P=new v.Menu,D=new v.MenuItem({label:this.mnemonicLabel(u.label),submenu:P});this.setMenu(P,u.submenu.items),s.append(D)}else(0,h.isMenubarMenuItemRecentAction)(u)?s.append(this.createOpenRecentMenuItem(u)):(0,h.isMenubarMenuItemAction)(u)&&(u.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[u.id]?s.append(new v.MenuItem(this.likeAction(u.id,{label:this.mnemonicLabel(u.label),click:this.fallbackMenuHandlers[u.id]}))):s.append(this.createMenuItem(u.label,u.id,!1,u.checked)):s.append(this.createMenuItem(u.label,u.id,u.enabled!==!1,!!u.checked)):s.append(this.createMenuItem(u.label,u.id,u.enabled!==!1,!!u.checked)))})}setMenuById(s,c){this.menubarMenus&&this.menubarMenus[c]&&this.setMenu(s,this.menubarMenus[c].items)}insertCheckForUpdatesItems(s){const c=this.getUpdateMenuItems();c.length&&(c.forEach(u=>s.append(u)),s.append(i()))}createOpenRecentMenuItem(s){const c=E.URI.revive(s.uri),u=s.id,P=u==="openRecentFile"?{fileUri:c}:u==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new v.MenuItem(this.likeAction(u,{label:s.label,click:async(D,T,N)=>{const U=this.isOptionClick(N);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[P],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:s.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([c])}},!1))}isOptionClick(s){return!!(s&&(!M.isMacintosh&&(s.ctrlKey||s.shiftKey)||M.isMacintosh&&(s.metaKey||s.altKey)))}isKeyboardEvent(s){return!!(s.triggeredByAccelerator||s.altKey||s.ctrlKey||s.metaKey||s.shiftKey)}createRoleMenuItem(s,c,u){const P={label:this.mnemonicLabel(s),role:u,enabled:!0};return new v.MenuItem(this.withKeybinding(c,P))}setMacWindowMenu(s){const c=new v.MenuItem({label:l.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),u=new v.MenuItem({label:l.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),P=new v.MenuItem({label:l.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),D=this.createMenuItem(l.localize(23,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(i()),T.push(this.createMenuItem(l.localize(24,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(l.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(l.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(l.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(l.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,u,i(),D,...T,i(),P].forEach(N=>s.append(N))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(l.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:l.localize(30,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(l.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:l.localize(32,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(l.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:l.localize(34,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(l.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,c,u,P){const D=this.mnemonicLabel(s),T=typeof c=="function"?c:(oe,ue,se)=>{const de=oe?oe.userSettingsLabel:null;let G=c;Array.isArray(c)&&(G=this.isOptionClick(se)?c[1]:c[0]),de&&se.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:de}):this.runActionInRenderer({type:"commandId",commandId:G})},N=typeof u=="boolean"?u:this.windowsMainService.getWindowCount()>0,U=typeof P=="boolean"?P:!1,$={label:D,click:T,enabled:N};U&&($.type="checkbox",$.checked=U);let Y;return typeof c=="string"?Y=c:Array.isArray(c)&&(Y=c[0]),M.isMacintosh&&(Y==="editor.action.clipboardCutAction"?$.role="cut":Y==="editor.action.clipboardCopyAction"?$.role="copy":Y==="editor.action.clipboardPasteAction"&&($.role="paste"),Y==="undo"?$.click=this.makeContextAwareClickHandler(T,{inDevTools:oe=>oe.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):Y==="redo"?$.click=this.makeContextAwareClickHandler(T,{inDevTools:oe=>oe.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):Y==="editor.action.selectAll"&&($.click=this.makeContextAwareClickHandler(T,{inDevTools:oe=>oe.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(Y,$))}makeContextAwareClickHandler(s,c){return(u,P,D)=>{const T=v.BrowserWindow.getFocusedWindow();if(!T)return c.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return c.inDevTools(T.webContents.devToolsWebContents);s(u,P||T,D)}}runActionInRenderer(s){let c=v.BrowserWindow.getFocusedWindow();if(!c){const P=this.windowsMainService.getLastActiveWindow();P?.isMinimized()&&(c=P.win)}const u=c?this.windowsMainService.getWindowById(c.id):void 0;if(u){if(this.logService.trace("menubar#runActionInRenderer",s),M.isMacintosh&&!this.environmentMainService.isBuilt&&!u.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const P={id:s.commandId,from:"menu"};u.sendWhenReady("vscode:runAction",k.CancellationToken.None,P)}else{const P={userSettingsLabel:s.userSettingsLabel};u.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,P)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,c){const u=typeof s=="string"?this.keybindings[s]:void 0;if(u?.label){if(u.isNative!==!1)c.accelerator=u.label,c.userSettingsLabel=u.userSettingsLabel;else if(typeof c.label=="string"){const P=c.label.indexOf("[");P>=0?c.label=`${c.label.substr(0,P)} [${u.label}]`:c.label=`${c.label} [${u.label}]`}}else c.accelerator=void 0;return c}likeAction(s,c,u=!c.accelerator){u&&(c=this.withKeybinding(s,c));const P=c.click;return c.click=(D,T,N)=>{this.reportMenuActionTelemetry(s),P?.(D,T,N)},c}openUrl(s,c){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(c)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:n})}mnemonicLabel(s){return(0,R.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};o.lastKnownMenubarStorageKey="lastKnownMenubarData",o=ve([J(0,p.IUpdateService),J(1,m.IConfigurationService),J(2,g.IWindowsMainService),J(3,I.IEnvironmentMainService),J(4,w.ITelemetryService),J(5,a.IWorkspacesHistoryMainService),J(6,C.IStateMainService),J(7,b.ILifecycleMainService),J(8,y.ILogService),J(9,d.INativeHostMainService),J(10,S.IProductService)],o),e.Menubar=o;function i(){return new v.MenuItem({type:"separator"})}}),define(Z[267],ee([0,1,5,21,6,266]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let M=class{constructor(l,m,I){this.instantiationService=l,this.lifecycleMainService=m,this.logService=I,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(l,m){this.logService.trace("menubarService#updateMenubar",l),(await this.menubar).updateMenu(m,l)}};M=ve([J(0,v.IInstantiationService),J(1,t.ILifecycleMainService),J(2,k.ILogService)],M),e.MenubarMainService=M}),define(Z[268],ee([0,1,15,23,28,24,22,3,30,49,34,2,13,9,71,4,33,16,12,7,172,60,19,56,26,14,5,21,6,54,20,61,63,38,74,265,117,260,27,92,75,52,64,37,42]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S,C,w,p,f,g,a,n,o,i,r,s,c,u,P,D,T,N,U,$,Y,oe,ue,se,de,G,K,F,A,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function z(H){return(0,se.isWorkspaceIdentifier)(H?.workspace)}function te(H){return(0,se.isSingleFolderWorkspaceIdentifier)(H?.workspace)}let B=class ht extends b.Disposable{constructor(L,O,_,V,x,re,j,ie,ne,ae,fe,De,Le,ke,Ae,He,ge,we){super(),this.machineId=L,this.initialUserEnv=O,this.logService=_,this.stateMainService=V,this.policyService=x,this.environmentMainService=re,this.userDataProfilesMainService=j,this.lifecycleMainService=ie,this.backupMainService=ne,this.configurationService=ae,this.workspacesHistoryMainService=fe,this.workspacesManagementMainService=De,this.instantiationService=Le,this.dialogMainService=ke,this.fileService=Ae,this.productService=He,this.protocolMainService=ge,this.themeMainService=we,this._onDidOpenWindow=this._register(new E.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new E.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new E.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new E.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new E.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ue.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const O=new b.DisposableStore;if(O.add(E.Event.any(L.onDidClose,L.onDidDestroy)(()=>O.dispose())),L.config.extensionDevelopmentPath)for(const _ of L.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(_));L.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,O){const _=this.environmentMainService.args,V=O?.remoteAuthority||void 0,x=!0,re=O?.forceReuseWindow,j=!re;return this.open({...L,cli:_,forceEmpty:x,forceNewWindow:j,forceReuseWindow:re,remoteAuthority:V})}openExistingWindow(L,O){L.focus(),this.handleWaitMarkerFile(O,[L])}async open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const O=[],_=[],V=[],x=[],re=[];let j,ie=0;const ne=await this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",ne);for(const ke of ne)te(ke)?L.addMode?O.push(ke):_.push(ke):z(ke)?V.push(ke):ke.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ke.remoteAuthority}),j.filesToOpenOrCreate.push(ke)):ke.backupPath?re.push({backupFolder:(0,h.basename)(ke.backupPath),remoteAuthority:ke.remoteAuthority}):ie++;L.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),L.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&L.waitMarkerFileURI&&(j.filesToWait={paths:(0,R.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(x.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),V.push(...x),re.push(...this.backupMainService.getEmptyWindowBackups())):re.length=0;const{windows:ae,filesOpenedInWindow:fe}=await this.doOpen(L,V,_,re,ie,j,O);if(this.logService.trace(`windowsManager#open used window count ${ae.length} (workspacesToOpen: ${V.length}, foldersToOpen: ${_.length}, emptyToRestore: ${re.length}, emptyToOpen: ${ie})`),ae.length>1)if(fe)fe.focus();else{const ke=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Ae=!0,He=!0;if(ke){const ge=ae.filter(we=>this.windowsStateHandler.state.lastActiveWindow&&we.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ge.length&&(ge[0].focus(),Ae=!1,He=!1)}if(Ae)for(let ge=ae.length-1;ge>=0;ge--){const we=ae[ge];if(!(we.openedWorkspace&&x.some(Ce=>we.openedWorkspace&&Ce.workspace.id===we.openedWorkspace.id)||we.backupPath&&re.some(Ce=>we.backupPath&&Ce.backupFolder===(0,h.basename)(we.backupPath)))){we.focus(),He=!1;break}}He&&ae[ae.length-1].focus()}const De=j&&j.filesToDiff.length>0,Le=j&&j.filesToMerge.length>0;if(!ae.some(ke=>ke.isExtensionDevelopmentHost)&&!De&&!Le&&!L.noRecentEntry){const ke=[];for(const Ae of ne)z(Ae)&&!Ae.transient?ke.push({label:Ae.label,workspace:Ae.workspace,remoteAuthority:Ae.remoteAuthority}):te(Ae)?ke.push({label:Ae.label,folderUri:Ae.workspace.uri,remoteAuthority:Ae.remoteAuthority}):Ae.fileUri&&ke.push({label:Ae.label,fileUri:Ae.fileUri,remoteAuthority:Ae.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ke)}return this.handleWaitMarkerFile(L,ae),ae}handleWaitMarkerFile(L,O){const _=L.waitMarkerFileURI;L.context===0&&_&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(_)}catch{}})()}async doOpen(L,O,_,V,x,re,j){const ie=[];let ne;function ae(ge,we){ie.push(ge),we&&(ne=ge,re=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:De}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&j.length>0){const ge=j[0].remoteAuthority,we=this.getLastActiveWindowForAuthority(ge);we&&ae(this.doAddFoldersToExistingWindow(we,j.map(Ce=>Ce.workspace.uri)))}const Le=_.length+O.length+V.length;if(re&&Le===0){const ge=re.filesToOpenOrCreate[0]||re.filesToDiff[0]||re.filesToMerge[3],we=this.getWindows().filter(X=>re&&(0,w.isEqualAuthority)(X.remoteAuthority,re.remoteAuthority));let Ce;ge?.fileUri&&!De&&((L.context===4||L.context===0||L.context===1)&&(Ce=await(0,oe.findWindowOnFile)(we,ge.fileUri,async X=>X.configPath.scheme===y.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(X.configPath):void 0)),Ce||(Ce=this.doGetLastActiveWindow(we))),Ce?(0,se.isWorkspaceIdentifier)(Ce.openedWorkspace)?O.push({workspace:Ce.openedWorkspace,remoteAuthority:Ce.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(Ce.openedWorkspace)?_.push({workspace:Ce.openedWorkspace,remoteAuthority:Ce.remoteAuthority}):ae(this.doOpenFilesInExistingWindow(L,Ce,re),!0):ae(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:re,forceNewWindow:!0,remoteAuthority:re.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,profile:L.profile}),!0)}const ke=(0,R.distinct)(O,ge=>ge.workspace.id);if(ke.length>0){const ge=(0,R.coalesce)(ke.map(we=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.configPath)));if(ge.length>0){const we=ge[0],Ce=(0,w.isEqualAuthority)(re?.remoteAuthority,we.remoteAuthority)?re:void 0;ae(this.doOpenFilesInExistingWindow(L,we,Ce),!!Ce),fe=!0}for(const we of ke){if(ge.some(ce=>ce.openedWorkspace&&ce.openedWorkspace.id===we.workspace.id))continue;const Ce=we.remoteAuthority,X=(0,w.isEqualAuthority)(re?.remoteAuthority,Ce)?re:void 0;ae(this.doOpenFolderOrWorkspace(L,we,fe,X),!!X),fe=!0}}const Ae=(0,R.distinct)(_,ge=>w.extUriBiasedIgnorePathCase.getComparisonKey(ge.workspace.uri));if(Ae.length>0){const ge=(0,R.coalesce)(Ae.map(we=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.uri)));if(ge.length>0){const we=ge[0],Ce=(0,w.isEqualAuthority)(re?.remoteAuthority,we.remoteAuthority)?re:void 0;ae(this.doOpenFilesInExistingWindow(L,we,Ce),!!Ce),fe=!0}for(const we of Ae){if(ge.some(ce=>(0,se.isSingleFolderWorkspaceIdentifier)(ce.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(ce.openedWorkspace.uri,we.workspace.uri)))continue;const Ce=we.remoteAuthority,X=(0,w.isEqualAuthority)(re?.remoteAuthority,Ce)?re:void 0;ae(this.doOpenFolderOrWorkspace(L,we,fe,X),!!X),fe=!0}}const He=(0,R.distinct)(V,ge=>ge.backupFolder);if(He.length>0)for(const ge of He){const we=ge.remoteAuthority,Ce=(0,w.isEqualAuthority)(re?.remoteAuthority,we)?re:void 0;ae(this.doOpenEmpty(L,!0,we,Ce,ge),!!Ce),fe=!0}if(ie.length===0||re){re&&!x&&x++;const ge=re?re.remoteAuthority:L.remoteAuthority;for(let we=0;we<x;we++)ae(this.doOpenEmpty(L,fe,ge,re),!!re),fe=!0}return{windows:(0,R.distinct)(ie),filesOpenedInWindow:ne}}doOpenFilesInExistingWindow(L,O,_){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),O.focus();const V={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",M.CancellationToken.None,V),O}doAddFoldersToExistingWindow(L,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),L.focus();const _={foldersToAdd:O};return L.sendWhenReady("vscode:addFolders",M.CancellationToken.None,_),L}doOpenEmpty(L,O,_,V,x){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!x,remoteAuthority:_,filesToOpen:V,forceNewWindow:O});let re;return!O&&typeof L.contextWindowId=="number"&&(re=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:_,forceNewWindow:O,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:re,emptyWindowBackupInfo:x,profile:L.profile})}doOpenFolderOrWorkspace(L,O,_,V,x){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:V}),!_&&!x&&typeof L.contextWindowId=="number"&&(x=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:x,profile:L.profile})}async getPathsToOpen(L){let O,_=!1,V=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(O=await this.doExtractPathsFromAPI(L),_=!0):L.forceEmpty?O=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(O=await this.doExtractPathsFromCLI(L.cli),O.length===0&&O.push(Object.create(null)),_=!0):(O=await this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),V=!0),!L.addMode&&_){const x=O.filter(re=>te(re));if(x.length>1){const re=x[0].remoteAuthority;if(x.every(j=>(0,w.isEqualAuthority)(j.remoteAuthority,re))){const j=await this.workspacesManagementMainService.createUntitledWorkspace(x.map(ie=>({uri:ie.workspace.uri})));O.push({workspace:j,remoteAuthority:re}),O=O.filter(ie=>!te(ie))}}}if(L.initialStartup&&!V&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const x=await this.doGetPathsFromLastSession();O.unshift(...x.filter(re=>z(re)||te(re)||re.backupPath))}return O}async doExtractPathsFromAPI(L){const O={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},_=await Promise.all((0,R.coalesce)(L.urisToOpen||[]).map(async V=>{const x=await this.resolveOpenable(V,O);if(x)return x.label=V.label,x;const re=this.resourceFromOpenable(V),j={title:this.productService.nameLong,type:"info",buttons:[(0,I.mnemonicButtonLabel)((0,g.localize)(0,null))],defaultId:0,message:re.scheme===y.Schemas.file?(0,g.localize)(1,null):(0,g.localize)(2,null),detail:re.scheme===y.Schemas.file?(0,g.localize)(3,null,(0,I.getPathLabel)(re,{os:S.OS,tildify:this.environmentMainService})):(0,g.localize)(4,null,re.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(j,(0,p.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(_)}async doExtractPathsFromCLI(L){const O=[],_={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},V=L["folder-uri"];if(V){const j=await Promise.all(V.map(ie=>{const ne=this.cliArgToUri(ie);if(!!ne)return this.resolveOpenable({folderUri:ne},_)}));O.push(...(0,R.coalesce)(j))}const x=L["file-uri"];if(x){const j=await Promise.all(x.map(ie=>{const ne=this.cliArgToUri(ie);if(!!ne)return this.resolveOpenable((0,se.hasWorkspaceFileExtension)(ie)?{workspaceUri:ne}:{fileUri:ne},_)}));O.push(...(0,R.coalesce)(j))}const re=await Promise.all(L._.map(j=>_.remoteAuthority?this.doResolveRemotePath(j,_):this.doResolveFilePath(j,_)));return O.push(...(0,R.coalesce)(re)),O}cliArgToUri(L){try{const O=f.URI.parse(L);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${L}, ${O.message}`)}}async doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];L!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const _=await Promise.all(O.map(async V=>{if(V.workspace){const x=await this.resolveOpenable({workspaceUri:V.workspace.configPath},{remoteAuthority:V.remoteAuthority,rejectTransientWorkspaces:!0});if(z(x))return x}else if(V.folderUri){const x=await this.resolveOpenable({folderUri:V.folderUri},{remoteAuthority:V.remoteAuthority});if(te(x))return x}else if(L!=="folders"&&V.backupPath)return{backupPath:V.backupPath,remoteAuthority:V.remoteAuthority}}));return(0,R.coalesce)(_)}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async resolveOpenable(L,O=Object.create(null)){const _=this.resourceFromOpenable(L);return _.scheme===y.Schemas.file?((0,$.isFileToOpen)(L)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(_.fsPath,O)):this.doResolveRemoteOpenable(L,O)}doResolveRemoteOpenable(L,O){let _=this.resourceFromOpenable(L);const V=(0,N.getRemoteAuthority)(_)||O.remoteAuthority;if(_=(0,w.removeTrailingPathSeparator)((0,w.normalizePath)(_)),(0,$.isFileToOpen)(L)){if(O.gotoLineMode){const{path:x,line:re,column:j}=(0,l.parseLineAndColumnAware)(_.path);return{fileUri:_.with({path:x}),options:{selection:re?{startLineNumber:re,startColumn:j||1}:void 0},remoteAuthority:V}}return{fileUri:_,remoteAuthority:V}}else if((0,$.isWorkspaceToOpen)(L))return{workspace:(0,de.getWorkspaceIdentifier)(_),remoteAuthority:V};return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:V}}resourceFromOpenable(L){return(0,$.isWorkspaceToOpen)(L)?L.workspaceUri:(0,$.isFolderToOpen)(L)?L.folderUri:L.fileUri}async doResolveFilePath(L,O){let _,V;O.gotoLineMode&&({path:L,line:_,column:V}=(0,l.parseLineAndColumnAware)(L)),L=(0,l.sanitizeFilePath)((0,h.normalize)(L),(0,C.cwd)());try{const x=await t.Promises.stat(L);if(x.isFile()){if(!O.forceOpenWorkspaceAsFile){const re=await this.workspacesManagementMainService.resolveLocalWorkspace(f.URI.file(L));if(re)return re.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:re.id,configPath:re.configPath},type:r.FileType.File,exists:!0,remoteAuthority:re.remoteAuthority,transient:re.transient}}return{fileUri:f.URI.file(L),type:r.FileType.File,exists:!0,options:{selection:_?{startLineNumber:_,startColumn:V||1}:void 0}}}else{if(x.isDirectory())return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(f.URI.file(L),x),type:r.FileType.Directory,exists:!0};if(!S.isWindows&&L==="/dev/null")return{fileUri:f.URI.file(L),type:r.FileType.File,exists:!0}}}catch{const re=f.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([re]),O.ignoreFileNotFound)return{fileUri:re,type:r.FileType.File,exists:!1}}}doResolveRemotePath(L,O){const _=L.charCodeAt(0),V=O.remoteAuthority;let x,re;O.gotoLineMode&&({path:L,line:x,column:re}=(0,l.parseLineAndColumnAware)(L)),_!==47&&((0,l.isWindowsDriveLetter)(_)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,l.toSlashes)(L)),L=`/${L}`);const j=f.URI.from({scheme:y.Schemas.vscodeRemote,authority:V,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return O.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:x?{startLineNumber:x,startColumn:re||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,de.getWorkspaceIdentifier)(j),remoteAuthority:V};if(O.gotoLineMode||h.posix.basename(L).indexOf(".")!==-1)return{fileUri:j,options:{selection:x?{startLineNumber:x,startColumn:re||1}:void 0},remoteAuthority:V}}return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:V}}shouldOpenNewWindow(L){const O=this.configurationService.getValue("window"),_=O?.openFoldersInNewWindow||"default",V=O?.openFilesInNewWindow||"off";let x=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(_==="on"||_==="off")&&(x=_==="on");let re=!1;return L.forceNewWindow||L.forceReuseWindow?re=!!L.forceNewWindow&&!L.forceReuseWindow:(S.isMacintosh?L.context===1&&(re=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(re=!0),!L.cli.extensionDevelopmentPath&&(V==="on"||V==="off")&&(re=V==="on")),{openFolderInNewWindow:!!x,openFilesInNewWindow:re}}async openExtensionDevelopmentHostWindow(L,O){const _=(0,oe.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(_)return this.lifecycleMainService.reload(_,O.cli),_.focus(),[_];let V=O.cli["folder-uri"]||[],x=O.cli["file-uri"]||[],re=O.cli._;if(!re.length&&!V.length&&!x.length&&!O.cli.extensionTestsPath){const ne=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ae=ne?.workspace??ne?.folderUri;ae&&(f.URI.isUri(ae)?ae.scheme===y.Schemas.file?re=[ae.fsPath]:V=[ae.toString()]:ae.configPath.scheme===y.Schemas.file?re=[(0,w.originalFSPath)(ae.configPath)]:x=[ae.configPath.toString()])}let j=O.remoteAuthority;for(const ne of L)if(ne.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ae=f.URI.parse(ne),fe=(0,N.getRemoteAuthority)(ae);fe&&(j?(0,w.isEqualAuthority)(fe,j)||this.logService.error("more than one extension development path authority"):j=fe)}re=re.filter(ne=>{const ae=f.URI.file(ne);return(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:(0,w.isEqualAuthority)((0,N.getRemoteAuthority)(ae),j)}),V=V.filter(ne=>{const ae=this.cliArgToUri(ne);return ae&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,w.isEqualAuthority)((0,N.getRemoteAuthority)(ae),j):!1}),x=x.filter(ne=>{const ae=this.cliArgToUri(ne);return ae&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,w.isEqualAuthority)((0,N.getRemoteAuthority)(ae),j):!1}),O.cli._=re,O.cli["folder-uri"]=V,O.cli["file-uri"]=x;const ie={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!re.length&&!V.length&&!x.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:j,profile:O.profile};return this.open(ie)}openInBrowserWindow(L){const O=this.configurationService.getValue("window"),_={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,h.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesMainService.profiles,profile:this.resolveProfileForBrowserWindow(L)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:P.default,isInitialStartup:L.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize()};let V;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(V=L.windowToUse||this.getLastActiveWindow(),V&&V.focus()),V){const x=V.config;!_.extensionDevelopmentPath&&x?.extensionDevelopmentPath&&(_.extensionDevelopmentPath=x.extensionDevelopmentPath,_.extensionDevelopmentKind=x.extensionDevelopmentKind,_["enable-proposed-api"]=x["enable-proposed-api"],_.verbose=x.verbose,_["inspect-extensions"]=x["inspect-extensions"],_["inspect-brk-extensions"]=x["inspect-brk-extensions"],_.debugId=x.debugId,_.extensionEnvironment=x.extensionEnvironment,_["extensions-dir"]=x["extensions-dir"],_["disable-extensions"]=x["disable-extensions"])}else{const x=this.windowsStateHandler.getNewWindowState(_);(0,d.mark)("code/willCreateCodeWindow");const re=V=this.instantiationService.createInstance(Y.CodeWindow,{state:x,extensionDevelopmentPath:_.extensionDevelopmentPath,isExtensionTestHost:!!_.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(re),ht.WINDOWS.push(re),this._onDidOpenWindow.fire(re),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(re.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(re)),(0,m.once)(re.onDidClose)(()=>this.onWindowClosed(re)),(0,m.once)(re.onDidDestroy)(()=>this._onDidDestroyWindow.fire(re)),re.onDidTriggerSystemContextMenu(({x:ie,y:ne})=>this._onDidTriggerSystemContextMenu.fire({window:re,x:ie,y:ne}));const j=(0,p.assertIsDefined)(re.win?.webContents);j.removeAllListeners("devtools-reload-page"),j.on("devtools-reload-page",()=>this.lifecycleMainService.reload(re)),this.lifecycleMainService.registerWindow(re)}return _.windowId=V.id,V.isReady?this.lifecycleMainService.unload(V,4).then(x=>{x||this.doOpenInBrowserWindow(V,_,L)}):this.doOpenInBrowserWindow(V,_,L),V}doOpenInBrowserWindow(L,O,_){O.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,de.createEmptyWorkspaceIdentifier)().id,remoteAuthority:O.remoteAuthority})),L.load(O)}resolveProfileForBrowserWindow(L){let O=L.profile;return O&&this.userDataProfilesMainService.setProfileForWorkspaceSync(L.workspace??"empty-window",O),O||(O=this.userDataProfilesMainService.getOrSetProfileForWorkspace(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesMainService.defaultProfile)),O}onWindowClosed(L){const O=ht.WINDOWS.indexOf(L);ht.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=v.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,w.isEqualAuthority)(O.remoteAuthority,L)))}doGetLastActiveWindow(L){const O=Math.max.apply(Math,L.map(_=>_.lastFocusTime));return L.find(_=>_.lastFocusTime===O)}sendToFocused(L,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,M.CancellationToken.None,...O)}sendToAll(L,O,_){for(const V of this.getWindows())_&&_.indexOf(V.id)>=0||V.sendWhenReady(L,M.CancellationToken.None,O)}getWindows(){return ht.WINDOWS}getWindowCount(){return ht.WINDOWS.length}getWindowById(L){const O=this.getWindows().filter(_=>_.id===L);return(0,R.firstOrDefault)(O)}getWindowByWebContents(L){const O=v.BrowserWindow.fromWebContents(L);if(!!O)return this.getWindowById(O.id)}};B.WINDOWS=[],B=ve([J(2,u.ILogService),J(3,U.IStateMainService),J(4,A.IPolicyService),J(5,i.IEnvironmentMainService),J(6,W.IUserDataProfilesMainService),J(7,c.ILifecycleMainService),J(8,a.IBackupMainService),J(9,n.IConfigurationService),J(10,G.IWorkspacesHistoryMainService),J(11,K.IWorkspacesManagementMainService),J(12,s.IInstantiationService),J(13,o.IDialogMainService),J(14,r.IFileService),J(15,D.IProductService),J(16,T.IProtocolMainService),J(17,F.IThemeMainService)],B),e.WindowsMainService=B}),define(Z[269],ee([0,1,60,32,75,52]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(l,m,I,b){this.workspacesManagementMainService=l,this.windowsMainService=m,this.workspacesHistoryMainService=I,this.backupMainService=b,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(l,m){const I=this.windowsMainService.getWindowById(l);if(I)return this.workspacesManagementMainService.enterWorkspace(I,this.windowsMainService.getWindows(),m)}createUntitledWorkspace(l,m,I){return this.workspacesManagementMainService.createUntitledWorkspace(m,I)}deleteUntitledWorkspace(l,m){return this.workspacesManagementMainService.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(l,m){return this.workspacesManagementMainService.getWorkspaceIdentifier(m)}getRecentlyOpened(l){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(l,m){return this.workspacesHistoryMainService.addRecentlyOpened(m)}removeRecentlyOpened(l,m){return this.workspacesHistoryMainService.removeRecentlyOpened(m)}clearRecentlyOpened(l){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=ve([J(0,R.IWorkspacesManagementMainService),J(1,t.IWindowsMainService),J(2,k.IWorkspacesHistoryMainService),J(3,v.IBackupMainService)],M),e.WorkspacesMainService=M}),define(Z[270],ee([0,1,15,41,28,18,44,17,30,49,43,34,2,13,9,4,12,7,29,81,131,46,145,100,246,148,60,261,19,69,181,84,118,56,103,179,26,59,111,193,213,194,248,104,195,196,14,206,86,68,5,85,262,225,258,21,6,208,267,65,20,63,254,87,38,251,90,112,36,230,232,73,48,237,238,263,239,264,114,241,242,243,244,249,32,268,250,27,91,75,269,52,247,37,212,42,257,221,55,72,89,252,259,8]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S,C,w,p,f,g,a,n,o,i,r,s,c,u,P,D,T,N,U,$,Y,oe,ue,se,de,G,K,F,A,W,z,te,B,H,L,O,_,V,x,re,j,ie,ne,ae,fe,De,Le,ke,Ae,He,ge,we,Ce,X,ce,he,ye,Ee,We,Te,Ne,Be,ze,Ue,qe,Q,le,pe,me,Se,Re,Fe,Ve,et,je,xe,it,at,ft,Ut,bt,Nt,Bt,zt,Wt,$t,qt,Ht,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ct=class extends y.Disposable{constructor(be,Pe,Me,Ie,Oe,$e,Ze,tt,_e,Ke,Qe){super(),this.mainProcessNodeIpcServer=be,this.userEnv=Pe,this.mainInstantiationService=Me,this.logService=Ie,this.environmentMainService=Oe,this.lifecycleMainService=$e,this.configurationService=Ze,this.stateMainService=tt,this.fileService=_e,this.productService=Ke,this.userDataProfilesMainService=Qe,this.configureSession(),this.registerListeners()}configureSession(){const be=_e=>_e?.startsWith(`${h.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((_e,Ke,Qe,Ye)=>be(Ye.requestingUrl)?Qe(Pe.has(Ke)):Qe(!1)),v.session.defaultSession.setPermissionCheckHandler((_e,Ke,Qe,Ye)=>be(Ye.requestingUrl)?Pe.has(Ke):!1);const Me=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,"devtools"]),Ie=_e=>{for(let Ke=_e;Ke;Ke=Ke.parent)if(Ke.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},Oe=_e=>_e.resourceType==="xhr"||Ie(_e.frame),$e=_e=>{const Ke=_e.frame;if(!Ke||!this.windowsMainService)return!1;const Qe=v.BrowserWindow.getAllWindows();for(const Ye of Qe)if(Ke.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Ze=(_e,Ke)=>{if(_e.path!=="/index.html")return!0;const Qe=Ke.frame;if(!Qe||!this.windowsMainService)return!1;for(const Ye of this.windowsMainService.getWindows())if(Ye.win&&Qe.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};v.session.defaultSession.webRequest.onBeforeRequest((_e,Ke)=>{const Qe=w.URI.parse(_e.url);return Qe.scheme===h.Schemas.vscodeWebview&&!Ze(Qe,_e)?(this.logService.error("Blocked vscode-webview request",_e.url),Ke({cancel:!0})):Qe.scheme===h.Schemas.vscodeFileResource&&!$e(_e)?(this.logService.error("Blocked vscode-file request",_e.url),Ke({cancel:!0})):Qe.path.endsWith(".svg")&&!Me.has(Qe.scheme)?Ke({cancel:!Oe(_e)}):Ke({cancel:!1})}),v.session.defaultSession.webRequest.onHeadersReceived((_e,Ke)=>{const Qe=_e.responseHeaders,Ye=Qe["content-type"]||Qe["Content-Type"];if(Ye&&Array.isArray(Ye)){const rt=w.URI.parse(_e.url);if(rt.path.endsWith(".svg")&&Me.has(rt.scheme))return Qe["Content-Type"]=["image/svg+xml"],Ke({cancel:!1,responseHeaders:Qe});if(!rt.path.endsWith(h.Schemas.vscodeRemoteResource)&&Ye.some(ot=>ot.toLowerCase().includes("image/svg")))return Ke({cancel:!Oe(_e)})}return Ke({cancel:!1})});const tt=v.session.defaultSession;typeof tt.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&tt.setCodeCachePath((0,d.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,E.setUnexpectedErrorHandler)(Me=>this.onUnexpectedError(Me)),process.on("uncaughtException",Me=>(0,E.onUnexpectedError)(Me)),process.on("unhandledRejection",Me=>(0,E.onUnexpectedError)(Me)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,g.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(Me,Ie)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),v.app.on("activate",async(Me,Ie)=>{this.logService.trace("app#activate"),Ie||await this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(Me,Ie)=>{Ie.on("will-navigate",Oe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Oe.preventDefault()}),Ie.setWindowOpenHandler(({url:Oe})=>(this.nativeHostMainService?.openExternal(void 0,Oe),{action:"deny"}))});let be=[],Pe;v.app.on("open-file",(Me,Ie)=>{this.logService.trace("app#open-file: ",Ie),Me.preventDefault(),be.push((0,Ve.hasWorkspaceFileExtension)(Ie)?{workspaceUri:w.URI.file(Ie)}:{fileUri:w.URI.file(Ie)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:be,gotoLineMode:!1,preferNewWindow:!0}),be=[],Pe=void 0},100)}),v.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Me=>{const Ie=this.windowsMainService?.getWindowByWebContents(Me.sender);let Oe,$e;return Ie?.config?(Oe=Ie.config,$e={...process.env,...Ie.config.userEnv}):(Oe=this.environmentMainService.args,$e=process.env),this.resolveShellEnvironment(Oe,$e,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Me,Ie,Oe)=>{const $e=this.validateNlsPath([Ie]);if(!$e||typeof Oe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile($e,R.VSBuffer.fromString(Oe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Me,...Ie)=>{const Oe=this.validateNlsPath(Ie);if(!Oe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Oe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Me=>Me.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Me=>Me.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Me=>Me.sender.reload())}validateNlsPath(be){let Pe;for(const Me of be)typeof Me=="string"&&(typeof Pe!="string"?Pe=Me:Pe=(0,d.join)(Pe,Me));if(!(typeof Pe!="string"||!(0,d.isAbsolute)(Pe)||!(0,l.isEqualOrParent)(Pe,this.environmentMainService.cachedLanguagesPath,!S.isLinux)))return w.URI.file(Pe)}onUnexpectedError(be){if(be){const Pe={message:`[uncaught exception in main]: ${be.message}`,stack:be.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.logService.error(`[uncaught exception in main]: ${be}`),be.stack&&this.logService.error(be.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const be=this.productService.win32AppUserModelId;S.isWindows&&be&&v.app.setAppUserModelId(be);try{S.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(_e){this.logService.error(_e)}const Pe=new n.Server;this.lifecycleMainService.onWillShutdown(_e=>{_e.reason===2&&Pe.dispose()}),this.logService.trace("Resolving machine identifier...");const Me=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Me}`);const{sharedProcess:Ie,sharedProcessReady:Oe,sharedProcessClient:$e}=this.setupSharedProcess(Me),Ze=await this.initServices(Me,Ie,Oe);this.setUpHandlers(Ze),Ze.invokeFunction(_e=>this.initChannels(_e,Pe,$e)),await Ze.invokeFunction(_e=>this.openFirstWindow(_e,Pe)),Ze.invokeFunction(_e=>this.afterWindowOpen(_e,Ie)),this._register(new Et.RunOnceScheduler(()=>{this._register((0,Et.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setUpHandlers(be){this._register(be.createInstance(i.ProxyAuthHandler)),this._register(be.createInstance(Nt.DefaultExtensionsProfileInitHandler)),this._register(be.createInstance(Ht.UserDataTransientProfilesHandler))}async resolveMachineId(){let be=this.stateMainService.getItem(X.machineIdKey);return(!be||S.isMacintosh&&be==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(be=await(0,f.getMachineId)(),this.stateMainService.setItem(X.machineIdKey,be)),be}setupSharedProcess(be){const Pe=this._register(this.mainInstantiationService.createInstance(ke.SharedProcess,be,this.userEnv)),Me=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Oe=await Pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new o.Client(Oe,"main")})(),Ie=(async()=>(await Pe.whenReady(),Me))();return{sharedProcess:Pe,sharedProcessReady:Ie,sharedProcessClient:Me}}async initServices(be,Pe,Me){const Ie=new _.ServiceCollection;switch(process.platform){case"win32":Ie.set(Ee.IUpdateService,new L.SyncDescriptor(ze.Win32UpdateService));break;case"linux":S.isLinuxSnap?Ie.set(Ee.IUpdateService,new L.SyncDescriptor(Be.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(Ee.IUpdateService,new L.SyncDescriptor(Ne.LinuxUpdateService));break;case"darwin":Ie.set(Ee.IUpdateService,new L.SyncDescriptor(Te.DarwinUpdateService));break}Ie.set(Se.IWindowsMainService,new L.SyncDescriptor(Re.WindowsMainService,[be,this.userEnv],!1));const Oe=new U.DialogMainService(this.logService);Ie.set(U.IDialogMainService,Oe),Ie.set(re.ILaunchMainService,new L.SyncDescriptor(re.LaunchMainService,void 0,!1)),Ie.set(N.IDiagnosticsMainService,new L.SyncDescriptor(N.DiagnosticsMainService,void 0,!1)),Ie.set(T.IDiagnosticsService,a.ProxyChannel.toService((0,a.getDelayedChannel)(Me.then(tt=>tt.getChannel("diagnostics"))))),Ie.set(V.IIssueMainService,new L.SyncDescriptor(V.IssueMainService,[this.userEnv])),Ie.set($.IEncryptionMainService,new L.SyncDescriptor(Y.EncryptionMainService,[be])),Ie.set(x.IKeyboardLayoutMainService,new L.SyncDescriptor(x.KeyboardLayoutMainService)),Ie.set(fe.INativeHostMainService,new L.SyncDescriptor(fe.NativeHostMainService,[Pe],!1)),Ie.set(P.ICredentialsMainService,new L.SyncDescriptor(at.CredentialsNativeMainService)),Ie.set(pe.IWebviewManagerService,new L.SyncDescriptor(me.WebviewMainService)),Ie.set(ae.IMenubarMainService,new L.SyncDescriptor(ae.MenubarMainService)),Ie.set(de.IExtensionUrlTrustService,new L.SyncDescriptor(G.ExtensionUrlTrustService)),Ie.set(K.IExtensionHostStarter,new L.SyncDescriptor(F.ExtensionHostStarter)),Ie.set(we.IStorageMainService,new L.SyncDescriptor(we.StorageMainService)),Ie.set(we.IApplicationStorageMainService,new L.SyncDescriptor(we.ApplicationStorageMainService)),S.isWindows?Ie.set(A.IExternalTerminalMainService,new L.SyncDescriptor(W.WindowsExternalTerminalService)):S.isMacintosh?Ie.set(A.IExternalTerminalMainService,new L.SyncDescriptor(W.MacExternalTerminalService)):S.isLinux&&Ie.set(A.IExternalTerminalMainService,new L.SyncDescriptor(W.LinuxExternalTerminalService));const $e=new c.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateMainService);Ie.set(s.IBackupMainService,$e);const Ze=new it.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,$e,Oe,this.productService);if(Ie.set(it.IWorkspacesManagementMainService,Ze),Ie.set(et.IWorkspacesService,new L.SyncDescriptor(xe.WorkspacesMainService,void 0,!1)),Ie.set(je.IWorkspacesHistoryMainService,new L.SyncDescriptor(je.WorkspacesHistoryMainService,void 0,!1)),Ie.set(Ue.IURLService,new L.SyncDescriptor(Q.NativeURLService,void 0,!1)),(0,ye.supportsTelemetry)(this.productService,this.environmentMainService)){const tt=(0,ye.isInternalTelemetry)(this.productService,this.configurationService),_e=(0,a.getDelayedChannel)(Me.then(ot=>ot.getChannel("telemetryAppender"))),Ke=new ce.TelemetryAppenderClient(_e),Qe=(0,Ce.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,be,tt,this.environmentMainService.installSourcePath),Ye=(0,ye.getPiiPathsFromEnvironment)(this.environmentMainService),rt={appenders:[Ke],commonProperties:Qe,piiPaths:Ye,sendErrorTelemetry:!0};Ie.set(X.ITelemetryService,new L.SyncDescriptor(he.TelemetryService,[rt],!1))}else Ie.set(X.ITelemetryService,ye.NullTelemetryService);return Ie.set(Wt.IExtensionsProfileScannerService,new L.SyncDescriptor(Wt.ExtensionsProfileScannerService,void 0,!0)),Ie.set($t.IExtensionsScannerService,new L.SyncDescriptor(qt.ExtensionsScannerService,void 0,!0)),await Et.Promises.settled([$e.initialize(),Ze.initialize()]),this.mainInstantiationService.createChild(Ie)}initChannels(be,Pe,Me){const Ie=a.ProxyChannel.fromService(be.get(re.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Ie);const Oe=a.ProxyChannel.fromService(be.get(N.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Oe);const $e=new Ut.PolicyChannel(be.get(ft.IPolicyService));Pe.registerChannel("policy",$e),Me.then(Je=>Je.registerChannel("policy",$e));const Ze=this.fileService.getProvider(h.Schemas.file);(0,C.assertType)(Ze instanceof H.DiskFileSystemProvider);const tt=new B.DiskFileSystemProviderChannel(Ze,this.logService,this.environmentMainService);Pe.registerChannel(z.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt),Me.then(Je=>Je.registerChannel(z.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt));const _e=a.ProxyChannel.fromService(be.get(bt.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",_e),Me.then(Je=>Je.registerChannel("userDataProfiles",_e));const Ke=new Bt.RequestChannel(be.get(zt.IRequestService));Me.then(Je=>Je.registerChannel("request",Ke));const Qe=new We.UpdateChannel(be.get(Ee.IUpdateService));Pe.registerChannel("update",Qe);const Ye=a.ProxyChannel.fromService(be.get(V.IIssueMainService));Pe.registerChannel("issue",Ye);const rt=a.ProxyChannel.fromService(be.get($.IEncryptionMainService));Pe.registerChannel("encryption",rt);const ot=a.ProxyChannel.fromService(be.get(P.ICredentialsMainService));Pe.registerChannel("credentials",ot);const It=a.ProxyChannel.fromService(be.get(Ae.ISignService));Pe.registerChannel("sign",It);const Xe=a.ProxyChannel.fromService(be.get(x.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",Xe),this.nativeHostMainService=be.get(fe.INativeHostMainService);const gt=a.ProxyChannel.fromService(this.nativeHostMainService);Pe.registerChannel("nativeHost",gt),Me.then(Je=>Je.registerChannel("nativeHost",gt));const mt=a.ProxyChannel.fromService(be.get(et.IWorkspacesService));Pe.registerChannel("workspaces",mt);const wt=a.ProxyChannel.fromService(be.get(ae.IMenubarMainService));Pe.registerChannel("menubar",wt);const Pt=a.ProxyChannel.fromService(be.get(Ue.IURLService));Pe.registerChannel("url",Pt);const kt=a.ProxyChannel.fromService(be.get(de.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",kt);const pt=a.ProxyChannel.fromService(be.get(pe.IWebviewManagerService));Pe.registerChannel("webview",pt);const ct=this._register(new ge.StorageDatabaseChannel(this.logService,be.get(we.IStorageMainService)));Pe.registerChannel("storage",ct),Me.then(Je=>Je.registerChannel("storage",ct));const vt=a.ProxyChannel.fromService(be.get(A.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",vt);const lt=new ne.LogLevelChannel(be.get(ie.ILogService));Pe.registerChannel("logLevel",lt),Me.then(Je=>Je.registerChannel("logLevel",lt));const Ge=new ne.LoggerChannel(be.get(ie.ILoggerService));Pe.registerChannel("logger",Ge),Me.then(Je=>Je.registerChannel("logger",Ge));const st=new D.ElectronExtensionHostDebugBroadcastChannel(be.get(Se.IWindowsMainService),be.get(bt.IUserDataProfilesMainService));Pe.registerChannel("extensionhostdebugservice",st);const ut=a.ProxyChannel.fromService(be.get(K.IExtensionHostStarter));Pe.registerChannel(K.ipcExtensionHostStarterChannelName,ut)}async openFirstWindow(be,Pe){const Me=this.windowsMainService=be.get(Se.IWindowsMainService),Ie=be.get(Ue.IURLService),Oe=be.get(fe.INativeHostMainService);this.lifecycleMainService.phase=2;const $e=[],Ze=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ge=>{try{return{uri:w.URI.parse(Ge),url:Ge}}catch{return}}).filter(Ge=>{if(!Ge||this.shouldBlockURI(Ge.uri))return!1;const st=this.getWindowOpenableFromProtocolLink(Ge.uri);return st?($e.push(st),!1):!0}),tt=this,_e=this.environmentMainService,Ke=this.productService,Qe=this.logService;Ie.registerHandler({async handleURL(Ge,st){if(Qe.trace("app#handleURL: ",Ge.toString(!0),st),Ge.scheme===Ke.urlProtocol&&Ge.path==="workspace"&&(Ge=Ge.with({authority:"file",path:w.URI.parse(Ge.query).path,query:""})),tt.shouldBlockURI(Ge))return!0;let ut=!1;const Je=new URLSearchParams(Ge.query);Je.get("windowId")==="_blank"&&(Je.delete("windowId"),Ge=Ge.with({query:Je.toString()}),ut=!0),ut||=S.isMacintosh&&Me.getWindowCount()===0;const Mt=tt.getWindowOpenableFromProtocolLink(Ge);if(Qe.trace("app#handleURL: windowOpenableFromProtocolLink = ",Mt),Mt){const[Dt]=await Me.open({context:5,cli:{..._e.args},urisToOpen:[Mt],forceNewWindow:ut,gotoLineMode:!0});return Dt.focus(),!0}if(ut){const[Dt]=await Me.open({context:5,cli:{..._e.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Le.getRemoteAuthority)(Ge)});return await Dt.ready(),Ie.open(Ge,st)}return!1}});const Ye=this._register(new Fe.ActiveWindowManager({onDidOpenWindow:Oe.onDidOpenWindow,onDidFocusWindow:Oe.onDidFocusWindow,getActiveWindowId:()=>Oe.getActiveWindowId(-1)})),rt=new a.StaticRouter(Ge=>Ye.getActiveClientId().then(st=>Ge===st)),ot=new qe.URLHandlerRouter(rt),It=Pe.getChannel("urlHandler",ot);Ie.registerHandler(new qe.URLHandlerChannelClient(It)),this._register(new le.ElectronURLListener(Ze,Ie,Me,this.environmentMainService,this.productService));const Xe=this.environmentMainService.args,gt=global.macOpenFiles,mt=(0,ue.isLaunchedFromCli)(process.env)?0:4,wt=Xe._.length,Pt=!!Xe["folder-uri"],kt=!!Xe["file-uri"],pt=Xe["skip-add-to-recently-opened"]===!0,ct=Xe.wait&&Xe.waitMarkerFilePath?w.URI.file(Xe.waitMarkerFilePath):void 0,vt=Xe.remote||void 0;if($e.length>0)return Me.open({context:mt,cli:Xe,urisToOpen:$e,gotoLineMode:!0,initialStartup:!0});const lt=await this.userDataProfilesMainService.checkAndCreateProfileFromCli(this.environmentMainService.args);if(!wt&&!Pt&&!kt){if(Xe["new-window"]||lt)return Me.open({context:mt,cli:Xe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:pt,waitMarkerFileURI:ct,initialStartup:!0,remoteAuthority:vt,profile:lt});if(gt.length)return Me.open({context:1,cli:Xe,urisToOpen:gt.map(Ge=>(0,Ve.hasWorkspaceFileExtension)(Ge)?{workspaceUri:w.URI.file(Ge)}:{fileUri:w.URI.file(Ge)}),noRecentEntry:pt,waitMarkerFileURI:ct,initialStartup:!0})}return Me.open({context:mt,cli:Xe,forceNewWindow:Xe["new-window"]||!wt&&Xe["unity-launch"],diffMode:Xe.diff,mergeMode:Xe.merge,noRecentEntry:pt,waitMarkerFileURI:ct,gotoLineMode:Xe.goto,initialStartup:!0,remoteAuthority:vt,profile:lt})}shouldBlockURI(be){return!!(be.authority===h.Schemas.file&&S.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,b.mnemonicButtonLabel)((0,r.localize)(0,null)),(0,b.mnemonicButtonLabel)((0,r.localize)(1,null))],defaultId:0,cancelId:1,message:(0,r.localize)(2,null,(0,b.getPathLabel)(be,{os:S.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,r.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(be){if(!!be.path){if(be.authority===h.Schemas.file){const Pe=w.URI.file(be.fsPath);return(0,Ve.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(be.authority===h.Schemas.vscodeRemote){const Pe=be.path.indexOf(d.posix.sep,1);if(Pe!==-1){const Me=be.path.substring(1,Pe),Ie=be.path.substring(Pe),Oe=w.URI.from({scheme:h.Schemas.vscodeRemote,authority:Me,path:Ie,query:be.query,fragment:be.fragment});return(0,Ve.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Oe}:/:[\d]+$/.test(Ie)?{fileUri:Oe}:{folderUri:Oe}}}}}afterWindowOpen(be,Pe){const Me=be.get(X.ITelemetryService),Ie=be.get(Ee.IUpdateService);this.lifecycleMainService.phase=3,this.handleSharedProcessErrors(Me,Pe),this.installMutex(),v.protocol.registerHttpProtocol(h.Schemas.vscodeRemoteResource,(Oe,$e)=>{$e({url:Oe.url.replace(/^vscode-remote-resource:/,"http:"),method:Oe.method})}),(Ie instanceof ze.Win32UpdateService||Ie instanceof Ne.LinuxUpdateService||Ie instanceof Te.DarwinUpdateService)&&Ie.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement()}async installMutex(){const be=this.productService.win32MutexName;if(S.isWindows&&be)try{const Pe=await new Promise((Ie,Oe)=>{q(["windows-mutex"],Ie,Oe)}),Me=new Pe.Mutex(be);(0,m.once)(this.lifecycleMainService.onWillShutdown)(()=>Me.release())}catch(Pe){this.logService.error(Pe)}}handleSharedProcessErrors(be,Pe){let Me=!1;(0,m.once)(this.lifecycleMainService.onWillShutdown)(()=>Me=!0),this._register(Pe.onDidError(({type:Ie,details:Oe})=>{let $e;switch(Ie){case 1:$e="SharedProcess: detected unresponsive window";break;case 2:$e=`SharedProcess: renderer process gone (detail: ${Oe?.reason??"<unknown>"}, code: ${Oe?.exitCode??"<unknown>"})`;break;case 3:$e=`SharedProcess: failed to load (detail: ${Oe?.reason??"<unknown>"}, code: ${Oe?.exitCode??"<unknown>"})`;break}(0,E.onUnexpectedError)(new Error($e)),be.publicLog2("sharedprocesserror",{type:Ie,reason:Oe?.reason,code:Oe?.exitCode,visible:Pe.isVisible(),shuttingdown:Me})}))}async resolveShellEnvironment(be,Pe,Me){try{return await(0,se.getResolvedShellEnv)(this.logService,be,Pe)}catch(Ie){const Oe=(0,M.toErrorMessage)(Ie);Me?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Oe):this.logService.error(Oe)}return{}}async updateCrashReporterEnablement(){try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Me=JSON.parse((0,I.stripComments)(Pe)),Oe=(0,ye.getTelemetryLevel)(this.configurationService)>=1;if(Me["enable-crash-reporter"]===void 0){const $e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Oe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,p.generateUuid)()}"`,"}"],Ze=Pe.substring(0,Pe.length-2).concat(`,
`,$e.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(Ze))}else{const $e=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Oe},`);$e!==Pe&&await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString($e))}}catch(be){this.logService.error(be)}}};Ct=ve([J(2,O.IInstantiationService),J(3,ie.ILogService),J(4,oe.IEnvironmentMainService),J(5,j.ILifecycleMainService),J(6,u.IConfigurationService),J(7,He.IStateMainService),J(8,te.IFileService),J(9,De.IProductService),J(10,bt.IUserDataProfilesMainService)],Ct),e.CodeApplication=Ct}),define(Z[271],ee([0,1,37,8,278,2]),function(q,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class M extends v.AbstractPolicyService{constructor(l){super(),this.productName=l,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(l){await this.throttler.queue(()=>new Promise((m,I)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,l,b=>{for(const y in b){const h=b[y];h===void 0?this.policies.delete(y):this.policies.set(y,h)}this._onDidChange.fire(Object.keys(b)),m()})}catch(b){I(b)}}))}}e.NativePolicyService=M}),define(Z[272],ee([0,1,223,8,18,17,2,12,19,35,111,6,222,279]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends M.Disposable{constructor(C,w,p){super(),this.environmentService=w,this.logService=p,this.configure(C.getValue()),this._register(C.onDidChangeConfiguration(()=>this.configure(C.getValue()),this))}configure(C){this.proxyUrl=C.http&&C.http.proxy,this.strictSSL=!!(C.http&&C.http.proxyStrictSSL),this.authorization=C.http&&C.http.proxyAuthorization}async request(C,w){this.logService.trace("RequestService#request (node) - begin",C.url);const{proxyUrl:p,strictSSL:f}=this;let g;try{g=await(0,I.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",o))}const a={...process.env,...g},n=C.agent?C.agent:await(0,y.getProxyAgent)(C.url||"",a,{proxyUrl:p,strictSSL:f});C.agent=n,C.strictSSL=f,this.authorization&&(C.headers={...C.headers||{},"Proxy-Authorization":this.authorization});try{const o=await this._request(C,w);return this.logService.trace("RequestService#request (node) - success",C.url),o}catch(o){throw this.logService.trace("RequestService#request (node) - error",C.url,o),o}}async getNodeRequest(C){return((0,v.parse)(C.url).protocol==="https:"?await new Promise((f,g)=>{q(["https"],f,g)}):await new Promise((f,g)=>{q(["http"],f,g)})).request}_request(C,w){return t.Promises.withAsyncBody(async(p,f)=>{const g=(0,v.parse)(C.url),a=C.getRawRequest?C.getRawRequest(C):await this.getNodeRequest(C),n={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:C.type||"GET",headers:C.headers,agent:C.agent,rejectUnauthorized:(0,E.isBoolean)(C.strictSSL)?C.strictSSL:!0};C.user&&C.password&&(n.auth=C.user+":"+C.password);const o=a(n,i=>{const r=(0,E.isNumber)(C.followRedirects)?C.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)this._request({...C,url:i.headers.location,followRedirects:r-1},w).then(p,f);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,h.createGunzip)())),p({res:i,stream:(0,k.streamToBufferReadableStream)(s)})}});o.on("error",f),C.timeout&&o.setTimeout(C.timeout),C.data&&typeof C.data=="string"&&o.write(C.data),o.end(),w.onCancellationRequested(()=>{o.abort(),f(new R.CancellationError)})})}async resolveProxy(C){}};d=ve([J(0,l.IConfigurationService),J(1,m.INativeEnvironmentService),J(2,b.ILogService)],d),e.RequestService=d}),define(Z[273],ee([0,1,15,272]),function(q,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(M){return v.net.request}class R extends t.RequestService{request(E,l){return super.request({...E||{},getRawRequest:k},l)}}e.RequestMainService=R}),define(Z[280],ee([0,1,15,40,7,24,8,44,17,30,49,34,13,9,71,4,33,25,23,46,83,270,10,19,216,229,26,59,185,14,204,86,68,201,85,21,106,6,209,107,54,20,61,253,113,235,55,273,87,224,38,228,73,64,42,37,271,211,2,51,240,39,236]),function(q,e,v,t,k,R,M,E,l,m,I,b,y,h,d,S,C,w,p,f,g,a,n,o,i,r,s,c,u,P,D,T,N,U,$,Y,oe,ue,se,de,G,K,F,A,W,z,te,B,H,L,O,_,V,x,re,j,ie,ne,ae,fe,De,Le){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ke{main(){try{this.startup()}catch(ge){console.error(ge.message),v.app.exit(1)}}async startup(){(0,l.setUnexpectedErrorHandler)(We=>console.error(We));const[ge,we,Ce,X,ce,he,ye,Ee]=this.createServices();try{try{await this.initServices(Ce,Ee,X,ce,ye)}catch(We){throw this.handleStartupDataDirError(Ce,ye.nameLong,We),We}await ge.invokeFunction(async We=>{const Te=We.get(ue.ILogService),Ne=We.get(Y.ILifecycleMainService),Be=We.get(P.IFileService),ze=await this.claimInstance(Te,Ce,Ne,ge,ye,!0);return p.Promises.writeFile(Ce.mainLockfile,String(process.pid)).catch(Ue=>{Te.warn(`Error writing main lockfile: ${Ue.stack}`)}),he.logger=new de.SpdLogLogger("main",(0,h.join)(Ce.logsPath,"main.log"),!0,!1,he.getLevel()),(0,I.once)(Ne.onWillShutdown)(Ue=>{Be.dispose(),X.dispose(),Ue.join(p.Promises.unlink(Ce.mainLockfile).catch(()=>{}))}),ge.createInstance(a.CodeApplication,ze,we).startup()})}catch(We){ge.invokeFunction(this.quit,We)}}createServices(){const ge=new $.ServiceCollection,we=new ae.DisposableStore;process.once("exit",()=>we.dispose());const Ce={_serviceBrand:void 0,...G.default};ge.set(K.IProductService,Ce);const X=new s.EnvironmentMainService(this.resolveArgs(),Ce),ce=this.patchEnvironment(X);ge.set(s.IEnvironmentMainService,X);const he=new oe.BufferLogService,ye=we.add(new ue.MultiplexLogService([new ue.ConsoleMainLogger((0,ue.getLogLevel)(X)),he]));ge.set(ue.ILogService,ye);const Ee=new D.FileService(ye);ge.set(P.IFileService,Ee);const We=new T.DiskFileSystemProvider(ye);Ee.registerProvider(y.Schemas.file,We);const Te=new De.UriIdentityService(Ee);ge.set(fe.IUriIdentityService,Te),ge.set(ue.ILoggerService,new se.LoggerService(ye,Ee));const Ne=new _.StateMainService(X,ye,Ee);ge.set(O.IStateMainService,Ne);const Be=new re.UserDataProfilesMainService(Ne,Te,X,Ee,ye);ge.set(re.IUserDataProfilesMainService,Be);const ze=S.isWindows&&Ce.win32RegValueName?we.add(new ie.NativePolicyService(Ce.win32RegValueName)):X.policyFile?we.add(new ne.FilePolicyService(X.policyFile,Ee,ye)):new j.NullPolicyService;ge.set(j.IPolicyService,ze);const Ue=new i.ConfigurationService(Be.defaultProfile.settingsResource,Ee,ze,ye);return ge.set(o.IConfigurationService,Ue),ge.set(Y.ILifecycleMainService,new N.SyncDescriptor(Y.LifecycleMainService,void 0,!1)),ge.set(te.IRequestService,new N.SyncDescriptor(B.RequestMainService,void 0,!0)),ge.set(x.IThemeMainService,new N.SyncDescriptor(x.ThemeMainService)),ge.set(H.ISignService,new N.SyncDescriptor(L.SignService,void 0,!1)),ge.set(W.ITunnelService,new N.SyncDescriptor(z.TunnelService)),ge.set(F.IProtocolMainService,new A.ProtocolMainService(X,Be,ye)),[new U.InstantiationService(ge,!0),ce,X,Ue,Ne,he,Ce,Be]}patchEnvironment(ge){const we={VSCODE_IPC_HOOK:ge.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ce=>{const X=process.env[Ce];typeof X=="string"&&(we[Ce]=X)}),Object.assign(process.env,we),we}async initServices(ge,we,Ce,X,ce){await M.Promises.settled([Promise.all([ge.extensionsPath,ge.codeCachePath,ge.logsPath,we.defaultProfile.globalStorageHome.fsPath,ge.workspaceStorageHome.fsPath,ge.localHistoryHome.fsPath,ge.backupHome].map(he=>he?p.Promises.mkdir(he,{recursive:!0}):void 0)),X.init(),Ce.initialize()]),we.setEnablement(ce.quality!=="stable"||Ce.getValue(Le.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(ge,we,Ce,X,ce,he){let ye;try{(0,d.mark)("code/willStartMainServer"),ye=await(0,g.serve)(we.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),(0,I.once)(Ce.onWillShutdown)(()=>ye.dispose())}catch(Ee){if(Ee.code!=="EADDRINUSE")throw this.handleStartupDataDirError(we,ce.nameLong,Ee),Ee;let We;try{We=await(0,g.connect)(we.mainIPCHandle,"main")}catch(ze){if(!he||S.isWindows||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.showStartupWarningDialog((0,n.localize)(0,null,ce.nameShort),(0,n.localize)(1,null),ce.nameLong),ze;try{(0,t.unlinkSync)(we.mainIPCHandle)}catch(Ue){throw ge.warn("Could not delete obsolete instance handle",Ue),Ue}return this.claimInstance(ge,we,Ce,X,ce,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const ze="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ge.error(ze),We.dispose(),new Error(ze)}let Te;!we.args.wait&&!we.args.status&&(Te=setTimeout(()=>{this.showStartupWarningDialog((0,n.localize)(2,null,ce.nameShort),(0,n.localize)(3,null),ce.nameLong)},1e4));const Ne=f.ProxyChannel.toService(We.getChannel("launch"),{disableMarshalling:!0}),Be=f.ProxyChannel.toService(We.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return X.invokeFunction(async()=>{const ze=new r.DiagnosticsService(V.NullTelemetryService,ce),Ue=await Be.getMainDiagnostics(),qe=await Be.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Q=await ze.getDiagnostics(Ue,qe);throw console.log(Q),new l.ExpectedError});throw S.isWindows&&await this.windowsAllowSetForegroundWindow(Ne,ge),ge.trace("Sending env to running instance..."),await Ne.start(we.args,process.env),We.dispose(),Te&&clearTimeout(Te),new l.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw ge.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new l.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ye}handleStartupDataDirError(ge,we,Ce){if(Ce.code==="EACCES"||Ce.code==="EPERM"){const X=(0,R.coalesce)([ge.userDataPath,ge.extensionsPath,g.XDG_RUNTIME_DIR]).map(ce=>(0,b.getPathLabel)(k.URI.file(ce),{os:S.OS,tildify:ge}));this.showStartupWarningDialog((0,n.localize)(4,null),(0,n.localize)(5,null,(0,E.toErrorMessage)(Ce),X.join(`
`)),we)}}showStartupWarningDialog(ge,we,Ce){v.dialog.showMessageBoxSync({title:Ce,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,n.localize)(6,null))],message:ge,detail:we,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ge,we){if(S.isWindows){const Ce=await ge.getMainProcessId();we.trace("Sending some foreground love to the running instance:",Ce);try{(await new Promise((X,ce)=>{q(["windows-foreground-love"],X,ce)})).allowSetForegroundWindow(Ce)}catch(X){we.error(X)}}}quit(ge,we){const Ce=ge.get(ue.ILogService),X=ge.get(Y.ILifecycleMainService);let ce=0;we&&(we.isExpected?we.message&&Ce.trace(we.message):(ce=1,we.stack?Ce.error(we.stack):Ce.error(`Startup error: ${we.toString()}`))),X.kill(ce)}resolveArgs(){const ge=this.validatePaths((0,c.parseMainProcessArgv)(process.argv));if(ge.wait&&!ge.waitMarkerFilePath){const we=(0,u.createWaitMarkerFileSync)(ge.verbose);we&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",we),ge.waitMarkerFilePath=we)}return ge}validatePaths(ge){if(ge["open-url"]&&(ge._urls=ge._,ge._=[]),!ge.remote){const we=this.doValidatePaths(ge._,ge.goto);ge._=we}return ge}doValidatePaths(ge,we){const Ce=(0,C.cwd)(),X=ge.map(ye=>{let Ee=String(ye),We;we&&(We=(0,m.parseLineAndColumnAware)(Ee),Ee=We.path),Ee&&(Ee=this.preparePath(Ce,Ee));const Te=(0,m.sanitizeFilePath)(Ee,Ce),Ne=(0,h.basename)(Te);return Ne&&!(0,m.isValidBasename)(Ne)?null:we&&We?(We.path=Te,this.toPath(We)):Te}),ce=S.isWindows||S.isMacintosh,he=(0,R.distinct)(X,ye=>ye&&ce?ye.toLowerCase():ye||"");return(0,R.coalesce)(he)}preparePath(ge,we){return S.isWindows&&(we=(0,w.rtrim)(we,'"')),we=(0,w.trim)((0,w.trim)(we," "),"	"),S.isWindows&&(we=(0,h.resolve)(ge,we),we=(0,w.rtrim)(we,".")),we}toPath(ge){const we=[ge.path];return typeof ge.line=="number"&&we.push(String(ge.line)),typeof ge.column=="number"&&we.push(String(ge.column)),we.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/2a74e7d5a806e537438158dc8b426b313329f1d1/core/vs/code/electron-main/main.js.map
